-- $Id: all.lua 2924 2017-06-02 03:02:26Z dsb $
-- ToME - Tales of Middle-Earth
-- Copyright © 2012-2017 Scott Bigham
--
-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
-- Scott Bigham "Zizzo"
-- dsb-tome@killerbunnies.org

-- -----------------------------------------------------------------------
-- WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING
-- -----------------------------------------------------------------------
-- This file was generated automatically by the 'gen_feat' Perl script.
-- DO NOT MODIFY THIS FILE DIRECTLY, as any changes will be lost the next
-- time the file is generated (with the possible exception of lines between
-- 'BEGIN VERBATIM' and 'END VERBATIM' markers, if supported by the script).
-- -----------------------------------------------------------------------
-- WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING
-- -----------------------------------------------------------------------

-- Grid entities generated from T2's f_info.txt.

newEntity {
  define_as = 'NOTHING',
  name = 'nothing',
  display = ' ',
  color = colors.C_w,
  image = 'terrain/nothing.png',
  floor = true,
  flags = {
    FLOOR = true,
  },
  change_for_dmgtype = spell.floor_damage,
}

newEntity {
  define_as = 'FLOOR',
  name = 'open floor',
  display = '.',
  color = colors.C_w,
  image = 'terrain/floor.png',
  floor = true,
  flags = {
    CAN_RUN = true,
    DONT_NOTICE_RUNNING = true,
    FLOOR = true,
    SUPPORT_GROWTH = true,
    SUPPORT_LIGHT = true,
  },
  -- BEGIN VERBATIM
  change_for_dmgtype = function(grid, x, y, dt, dam)
    if spell.grid_damage(dt, 'water', dam) then
      local grid_type = spell.grid_prob { SHALLOW_WATER = 35, DEEP_WATER = 5 }
      if grid_type then return grid_type end
    end
    return spell.floor_damage(grid, x, y, dt, dam)
  end,
  -- END VERBATIM
}

newEntity {
  define_as = 'FOUNTAIN',
  name = 'fountain',
  display = '_',
  color = colors.C_w,
  image = 'terrain/fountain.png',
  floor = true,
  flags = {
    CAN_RUN = true,
    FLOOR = true,
    NOTICE = true,
    REMEMBER = true,
  },
  always_remember = true,
  enter_msg = [[The liquid here seems magical.]],
}

newEntity {
  define_as = 'GLYPH_OF_WARDING',
  name = 'glyph of warding',
  display = ';',
  color = colors.C_y,
  image = 'terrain/glyph_of_warding.png',
  floor = true,
  flags = {
    CAN_RUN = true,
    FLOOR = true,
    NOTICE = true,
    REMEMBER = true,
    SUPPORT_LIGHT = true,
  },
  always_remember = true,
  enter_msg = [[There is a mighty spell of protection here.]],
  -- BEGIN VERBATIM
  no_teleport = true,
  -- END VERBATIM
}

newEntity {
  define_as = 'OPEN_DOOR',
  name = 'open door',
  display = "'",
  color = colors.C_U,
  image = 'terrain/open_door.png',
  floor = true,
  flags = {
    CAN_RUN = true,
    DOOR = true,
    FLOOR = true,
    NOTICE = true,
    REMEMBER = true,
  },
  always_remember = true,
  door_closed = 'DOOR',
  -- BEGIN VERBATIM
  change_for_dmgtype = function(grid, x, y, dt, dam)
    local DamageType = require 'engine.DamageType'
    if dt == DamageType.KILL_DOOR then
      game.logSeenXY(x, y, 'There is a bright flash of light!')
      return spell.floor_grid()
    end
    return nil
  end,
  -- END VERBATIM
}

newEntity {
  define_as = 'BROKEN_DOOR',
  name = 'broken door',
  display = "'",
  color = colors.C_U,
  image = 'terrain/broken_door.png',
  floor = true,
  flags = {
    CAN_RUN = true,
    DOOR = true,
    FLOOR = true,
    NOTICE = true,
    REMEMBER = true,
  },
  always_remember = true,
  -- BEGIN VERBATIM
  change_for_dmgtype = function(grid, x, y, dt, dam)
    local DamageType = require 'engine.DamageType'
    if dt == DamageType.KILL_DOOR then
      game.logSeenXY(x, y, 'There is a bright flash of light!')
      return spell.floor_grid()
    end
    return nil
  end,
  -- END VERBATIM
}

newEntity {
  define_as = 'UP',
  name = 'up staircase',
  display = '<',
  color = colors.C_w,
  image = 'terrain/up.png',
  floor = true,
  permanent = true,
  flags = {
    CAN_RUN = true,
    FLOOR = true,
    NOTICE = true,
    PERMANENT = true,
    REMEMBER = true,
    SUPPORT_LIGHT = true,
  },
  always_remember = true,
  -- BEGIN VERBATIM
  change_level = -1,
  -- END VERBATIM
}

-- BEGIN VERBATIM INTRA
-- Zone exit to the wilderness, defined here so we can re-use it
-- everywhere.
newEntity {
  base = 'UP',
  define_as = 'UP_TO_WILDERNESS',
  name = 'stairs back to the outside',
  looks_like = 'UP',
  change_level = 1,
  change_zone = 'wilderness',
}
-- END VERBATIM

newEntity {
  define_as = 'DOWN',
  name = 'down staircase',
  display = '>',
  color = colors.C_w,
  image = 'terrain/down.png',
  floor = true,
  permanent = true,
  flags = {
    CAN_RUN = true,
    FLOOR = true,
    NOTICE = true,
    PERMANENT = true,
    REMEMBER = true,
    SUPPORT_LIGHT = true,
  },
  always_remember = true,
  -- BEGIN VERBATIM
  change_level = 1,
  -- END VERBATIM
}

newEntity {
  define_as = 'QUEST_ENTRANCE',
  name = 'quest entrance',
  display = '>',
  color = colors.C_y,
  image = 'terrain/quest_entrance.png',
  floor = true,
  permanent = true,
  flags = {
    CAN_RUN = true,
    FLOOR = true,
    NOTICE = true,
    PERMANENT = true,
    REMEMBER = true,
  },
  always_remember = true,
}

newEntity {
  define_as = 'QUEST_EXIT',
  name = 'quest exit',
  display = '<',
  color = colors.C_y,
  image = 'terrain/quest_exit.png',
  floor = true,
  permanent = true,
  flags = {
    CAN_RUN = true,
    FLOOR = true,
    NOTICE = true,
    PERMANENT = true,
    REMEMBER = true,
  },
  always_remember = true,
}

newEntity {
  define_as = 'QUEST_DOWN_LEVEL',
  name = 'quest down level',
  display = '>',
  color = colors.C_r,
  image = 'terrain/quest_down_level.png',
  floor = true,
  permanent = true,
  flags = {
    CAN_RUN = true,
    FLOOR = true,
    NOTICE = true,
    PERMANENT = true,
    REMEMBER = true,
  },
  always_remember = true,
  -- BEGIN VERBATIM
  change_level = 1,
  -- END VERBATIM
}

newEntity {
  define_as = 'QUEST_UP_LEVEL',
  name = 'quest up level',
  display = '<',
  color = colors.C_r,
  image = 'terrain/quest_up_level.png',
  floor = true,
  permanent = true,
  flags = {
    CAN_RUN = true,
    FLOOR = true,
    NOTICE = true,
    PERMANENT = true,
    REMEMBER = true,
  },
  always_remember = true,
  -- BEGIN VERBATIM
  change_level = -1,
  -- END VERBATIM
}

newEntity {
  define_as = 'TOWN_EXIT',
  name = 'town exit',
  display = '>',
  color = colors.C_g,
  image = 'terrain/town_exit.png',
  floor = true,
  permanent = true,
  flags = {
    CAN_RUN = true,
    FLOOR = true,
    NOTICE = true,
    PERMANENT = true,
    REMEMBER = true,
  },
  always_remember = true,
}

newEntity {
  define_as = 'SHAFT_DOWN',
  name = 'shaft down',
  display = '>',
  color = colors.C_U,
  image = 'terrain/shaft_down.png',
  floor = true,
  permanent = true,
  flags = {
    CAN_RUN = true,
    FLOOR = true,
    NOTICE = true,
    PERMANENT = true,
    REMEMBER = true,
  },
  always_remember = true,
  enter_msg = [[There is a shaft down here.]],
}

newEntity {
  define_as = 'SHAFT_UP',
  name = 'shaft up',
  display = '<',
  color = colors.C_U,
  image = 'terrain/shaft_up.png',
  floor = true,
  permanent = true,
  flags = {
    CAN_RUN = true,
    FLOOR = true,
    NOTICE = true,
    PERMANENT = true,
    REMEMBER = true,
  },
  always_remember = true,
  enter_msg = [[There is a shaft up here.]],
}

newEntity {
  define_as = 'EMPTY_FOUNTAIN',
  name = 'fountain',
  display = '_',
  color = colors.C_D,
  image = 'terrain/empty_fountain.png',
  floor = true,
  flags = {
    CAN_RUN = true,
    FLOOR = true,
    NOTICE = true,
    REMEMBER = true,
  },
  always_remember = true,
  enter_msg = [[The fountain seems empty.]],
}

newEntity {
  define_as = 'WEB',
  name = 'web',
  display = '+',
  color = colors.C_y,
  image = 'terrain/web.png',
  flags = {
    CAN_PASS = true,
    NOTICE = true,
    TUNNELABLE = true,
    WEB = true,
  },
  always_remember = true,
  -- BEGIN VERBATIM
  dig = {
    -- cf. dig_tunnel_aux() in src/cmd2.c
    skill_req = 30,
    skill_req_1pct = 42,
    hardness = 1200,
    finish = 'You have finished the tunnel.',
  },
  -- END VERBATIM
}

newEntity {
  define_as = 'TRAP',
  name = 'trap',
  display = '^',
  color = colors.C_w,
  image = 'terrain/trap.png',
  floor = true,
  flags = {
    FLOOR = true,
    NOTICE = true,
    REMEMBER = true,
  },
  always_remember = true,
}

newEntity {
  define_as = 'DOOR',
  name = 'door',
  display = '+',
  color = colors.C_U,
  image = 'terrain/door.png',
  block_sight = true,
  wall = true,
  flags = {
    CAN_PASS = true,
    DOOR = true,
    NOTICE = true,
    NO_VISION = true,
    NO_WALK = true,
    REMEMBER = true,
    TUNNELABLE = true,
    WALL = true,
  },
  always_remember = true,
  door_opened = 'OPEN_DOOR',
  is_openable = true,
  -- BEGIN VERBATIM
  dig = {
    -- cf. dig_tunnel_aux() in src/cmd2.c
    skill_req = 30,
    skill_req_1pct = 42,
    hardness = 1200,
    finish = 'You have finished the tunnel.',
  },
  not_map_wall = true,
  change_for_dmgtype = function(grid, x, y, dt, dam)
    local DamageType = require 'engine.DamageType'
    if dt == DamageType.KILL_DOOR then
      game.logSeenXY(x, y, 'There is a bright flash of light!')
      return spell.floor_grid()
    end
    if dt == DamageType.JAM_DOOR then
      return util.jam_door(grid, x, y)
    end
    if dt == DamageType.KILL_WALL then
      game.logSeenXY(x, y, 'The door turns to mud!')
      return spell.floor_grid()
    end
    if dt == DamageType.DIG then
      return spell.floor_grid()
    end
    return nil
  end,
  -- END VERBATIM
}

newEntity {
  base = 'DOOR',
  define_as = 'LOCKED_DOOR',
  name = 'locked door',
  looks_like = 'DOOR',
  -- BEGIN VERBATIM
  force_clone = true,
  -- In case on_added() isn't called.
  door_lock_power = resolvers.rngrange(1, 7),
  on_added = function(self, level, x, y)
    door_lock_power = spell.door_lock_power or rng.range(1, 7)
  end,
  try_open_door = function(self, e)
    if not e.player and e:has('OPEN_DOOR') then
      -- cf. src/melee2.c lines 6882-6889.
      return rng.range(1, math.floor(e.life/10)) > self.door_lock_power
    end
    if not e.skill_disarm then return false, false end
    local chance = math.max(e:getDisarmPower() - self.door_lock_power * 4, 2)
    if rng.percent(chance) then
      game.logPlayer(e, 'You have picked the lock.')
      e:gainExp(1)
      return true, false
    else
      game.logPlayer(e, 'You failed to pick the lock.')
      return false, true
    end
  end,
  change_for_dmgtype = function(grid, x, y, dt, dam)
    -- We duplicate DOOR's handling for KILL_DOOR, JAM_DOOR, KILL_WALL and
    -- DIG and add handling of KILL_TRAP.
    local DamageType = require 'engine.DamageType'
    if dt == DamageType.KILL_DOOR then
      game.logSeenXY(x, y, 'There is a bright flash of light!')
      return spell.floor_grid()
    end
    if dt == DamageType.JAM_DOOR then
      return util.jam_door(grid, x, y)
    end
    if dt == DamageType.KILL_WALL then
      game.logSeenXY(x, y, 'The door turns to mud!')
      return spell.floor_grid()
    end
    if dt == DamageType.DIG then
      return spell.floor_grid()
    end
    if dt == DamageType.KILL_TRAP then
      -- Unlock us by turning us into an unlocked door.
      game.logSeenXY(x, y, 'Click!')
      return game.zone.grid_list.DOOR
    end
    return nil
  end,
  -- END VERBATIM
}

newEntity {
  base = 'DOOR',
  define_as = 'JAMMED_DOOR',
  name = 'jammed door',
  looks_like = 'DOOR',
  -- BEGIN VERBATIM
  force_clone = true,
  -- In case on_added() isn't called.
  door_jam_power = resolvers.rngrange(0, 7),
  on_added = function(self, level, x, y)
    door_jam_power = spell.door_jam_power or rng.range(0, 7)
  end,
  try_open_door = function(self, e)
    game.logPlayer(e, 'The door appears to be stuck.')
    return false, false
  end,
  -- END VERBATIM
}

newEntity {
  define_as = 'SECRET_DOOR',
  name = 'secret door',
  display = '#',
  color = colors.C_w,
  image = 'terrain/secret_door.png',
  looks_like = 'WALL',
  block_sight = true,
  wall = true,
  flags = {
    CAN_PASS = true,
    DONT_NOTICE_RUNNING = true,
    DOOR = true,
    NO_VISION = true,
    NO_WALK = true,
    TUNNELABLE = true,
    WALL = true,
  },
  always_remember = true,
  -- BEGIN VERBATIM
  dig = {
    -- cf. dig_tunnel_aux() in src/cmd2.c
    skill_req = 30,
    skill_req_1pct = 42,
    hardness = 1200,
    finish = 'You have finished the tunnel.',
    -- TODO search or set off trap
  },
  change_for_dmgtype = function(grid, x, y, dt, dam)
    local DamageType = require 'engine.DamageType'
    if dt == DamageType.KILL_TRAP then
      -- Turns us into an ordinary door.
      game.logSeenXY(x, y, 'Click!')
      return game.zone.grid_list.DOOR
    end
    if dt == DamageType.KILL_WALL then
      game.logSeenXY(x, y, 'The door turns to mud!')
      return spell.floor_grid()
    end
    if dt == DamageType.DIG then
      return spell.floor_grid()
    end
    return nil
  end,
  -- cf. T2DungeonLevel:place_secret_door() and Static:generate().
  -- Dodgy Hack(TM):  We count on both of the above callers [qq.v] to set up
  -- spell.use_wall_grid or spell.map_generator for us to be used in our
  -- on_added() via spell.wall_grid().
  force_clone = true,
  on_added = function(self, level, x, y)
    self.replace_display = spell.wall_grid()
  end,
  -- END VERBATIM
}

newEntity {
  define_as = 'RUBBLE',
  name = 'pile of rubble',
  display = ':',
  color = colors.C_w,
  image = 'terrain/rubble.png',
  block_sight = true,
  wall = true,
  flags = {
    CAN_FLY = true,
    CAN_PASS = true,
    NOTICE = true,
    NO_VISION = true,
    NO_WALK = true,
    SUPPORT_LIGHT = true,
    TUNNELABLE = true,
    WALL = true,
  },
  always_remember = true,
  -- BEGIN VERBATIM
  dig = {
    -- cf. dig_tunnel_aux() in src/cmd2.c
    skill_req = 0,
    skill_req_1pct = 2,
    hardness = 200,
    finish = 'You have removed the rubble.',
  },
  change_for_dmgtype = function(grid, x, y, dt, dam)
    local DamageType = require 'engine.DamageType'
    if dt == DamageType.KILL_WALL then
      game.logSeenXY(x, y, 'The rubble turns into mud!')
      return spell.floor_grid(), util.place_obj_under_rubble
    end
    if dt == DamageType.DIG then
      return spell.floor_grid(), util.place_obj_under_rubble
    end
    return nil
  end,
  -- END VERBATIM
}

newEntity {
  define_as = 'MAGMA_VEIN',
  name = 'magma vein',
  display = '%',
  color = colors.C_s,
  image = 'terrain/magma_vein.png',
  block_sight = true,
  wall = true,
  flags = {
    CAN_PASS = true,
    DONT_NOTICE_RUNNING = true,
    NOTICE = true,
    NO_VISION = true,
    NO_WALK = true,
    SUPPORT_LIGHT = true,
    TUNNELABLE = true,
    WALL = true,
  },
  always_remember = true,
  -- BEGIN VERBATIM
  dig = {
    -- cf. dig_tunnel_aux() in src/cmd2.c
    skill_req = 5,
    skill_req_1pct = 8,
    hardness = 250,
    finish = 'You have finished the tunnel.',
  },
  change_for_dmgtype = function(grid, x, y, dt, dam)
    if spell.grid_damage(dt, 'water', dam) and rng.percent(15) then
      return spell.floor_grid()
    end
    local DamageType = require 'engine.DamageType'
    if dt == DamageType.KILL_WALL then
      game.logSeenXY(x, y, 'The vein turns into mud!')
      return spell.floor_grid()
    end
    if dt == DamageType.DIG then
      return spell.floor_grid()
    end
    return nil
  end,
  -- END VERBATIM
}

newEntity {
  define_as = 'QUARTZ_VEIN',
  name = 'quartz vein',
  display = '%',
  color = colors.C_w,
  image = 'terrain/quartz_vein.png',
  block_sight = true,
  wall = true,
  flags = {
    CAN_PASS = true,
    DONT_NOTICE_RUNNING = true,
    NOTICE = true,
    NO_VISION = true,
    NO_WALK = true,
    SUPPORT_LIGHT = true,
    TUNNELABLE = true,
    WALL = true,
  },
  always_remember = true,
  -- BEGIN VERBATIM
  dig = {
    -- cf. dig_tunnel_aux() in src/cmd2.c
    skill_req = 20,
    skill_req_1pct = 28,
    hardness = 800,
    finish = 'You have finished the tunnel.',
  },
  change_for_dmgtype = function(grid, x, y, dt, dam)
    local DamageType = require 'engine.DamageType'
    if dt == DamageType.KILL_WALL then
      game.logSeenXY(x, y, 'The vein turns into mud!')
      return spell.floor_grid()
    end
    if dt == DamageType.DIG then
      return spell.floor_grid()
    end
    return nil
  end,
  -- END VERBATIM
}

newEntity {
  define_as = 'MAGMA_VEIN_WITH_TREASURE',
  name = 'magma vein with treasure',
  display = '*',
  color = colors.C_o,
  image = 'terrain/magma_vein_with_treasure.png',
  block_sight = true,
  wall = true,
  flags = {
    CAN_PASS = true,
    DONT_NOTICE_RUNNING = true,
    NOTICE = true,
    NO_VISION = true,
    NO_WALK = true,
    SUPPORT_LIGHT = true,
    TUNNELABLE = true,
    WALL = true,
  },
  always_remember = true,
  -- BEGIN VERBATIM
  dig = {
    -- cf. dig_tunnel_aux() in src/cmd2.c
    skill_req = 5,
    skill_req_1pct = 8,
    hardness = 250,
    finish = 'You have finished the tunnel.',
  },
  change_for_dmgtype = function(grid, x, y, dt, dam)
    if spell.grid_damage(dt, 'water', dam) and rng.percent(15) then
      return spell.floor_grid(), util.place_gold_in_grid
    end
    local DamageType = require 'engine.DamageType'
    if dt == DamageType.KILL_WALL then
      game.logSeenXY(x, y, 'The vein turns into mud!')
      return spell.floor_grid(), util.place_gold_in_grid
    end
    if dt == DamageType.DIG then
      return spell.floor_grid(), util.place_gold_in_grid
    end
    return nil
  end,
  -- END VERBATIM
}

newEntity {
  define_as = 'QUARTZ_VEIN_WITH_TREASURE',
  name = 'quartz vein with treasure',
  display = '*',
  color = colors.C_o,
  image = 'terrain/quartz_vein_with_treasure.png',
  block_sight = true,
  wall = true,
  flags = {
    CAN_PASS = true,
    DONT_NOTICE_RUNNING = true,
    NOTICE = true,
    NO_VISION = true,
    NO_WALK = true,
    SUPPORT_LIGHT = true,
    TUNNELABLE = true,
    WALL = true,
  },
  always_remember = true,
  -- BEGIN VERBATIM
  dig = {
    -- cf. dig_tunnel_aux() in src/cmd2.c
    skill_req = 20,
    skill_req_1pct = 28,
    hardness = 800,
    finish = 'You have finished the tunnel.',
  },
  change_for_dmgtype = function(grid, x, y, dt, dam)
    local DamageType = require 'engine.DamageType'
    if dt == DamageType.KILL_WALL then
      game.logSeenXY(x, y, 'The vein turns into mud!')
      return spell.floor_grid(), util.place_gold_in_grid
    end
    if dt == DamageType.DIG then
      return spell.floor_grid(), util.place_gold_in_grid
    end
    return nil
  end,
  -- END VERBATIM
}

newEntity {
  define_as = 'WALL',
  name = 'granite wall',
  display = '#',
  color = colors.C_w,
  image = 'terrain/wall.png',
  block_sight = true,
  wall = true,
  flags = {
    CAN_PASS = true,
    DONT_NOTICE_RUNNING = true,
    NO_VISION = true,
    NO_WALK = true,
    SUPPORT_LIGHT = true,
    TUNNELABLE = true,
    WALL = true,
  },
  always_remember = true,
  -- BEGIN VERBATIM
  dig = {
    -- cf. dig_tunnel_aux() in src/cmd2.c
    skill_req = 40,
    skill_req_1pct = 56,
    hardness = 1600,
    finish = 'You have finished the tunnel.',
  },
  change_for_dmgtype = function(grid, x, y, dt, dam)
    local DamageType = require 'engine.DamageType'
    if dt == DamageType.KILL_WALL then
      game.logSeenXY(x, y, 'The wall turns into mud!')
      return spell.floor_grid()
    end
    if dt == DamageType.DIG then
      return spell.floor_grid()
    end
  end,
  -- END VERBATIM
}

-- BEGIN VERBATIM INTRA
-- Dodgy Hack(TM):  Used in some places where T2's FEAT_WALL_EXTRA is used
-- as a "marker" wall distinct from ordinary walls.
-- [cf. mod.class.generator.map.T2DungeonLevel:add_outer_wall()]
newEntity {
  base = 'WALL',
  define_as = 'WALL_XTRA',
  xtra_hack = true,
}
-- END VERBATIM

newEntity {
  define_as = 'PERMA_WALL',
  name = 'permanent wall',
  display = '#',
  color = colors.C_w,
  image = 'terrain/perma_wall.png',
  block_sight = true,
  permanent = true,
  wall = true,
  flags = {
    DONT_NOTICE_RUNNING = true,
    NO_VISION = true,
    NO_WALK = true,
    PERMANENT = true,
    SUPPORT_LIGHT = true,
    WALL = true,
  },
  always_remember = true,
}

newEntity {
  define_as = 'EXPLOSIVE_RUNE',
  name = 'explosive rune',
  display = '*',
  color = colors.C_R,
  image = 'terrain/explosive_rune.png',
  floor = true,
  flags = {
    CAN_FLY = true,
    CAN_LEVITATE = true,
    FLOOR = true,
    NOTICE = true,
    SUPPORT_LIGHT = true,
  },
  change_for_dmgtype = spell.floor_damage,
  enter_msg = [[This rune seems unstable.]],
  -- BEGIN VERBATIM
  no_teleport = true,
  -- END VERBATIM
}

newEntity {
  define_as = 'STRAIGHT_ROAD_STARTPOINT',
  name = 'Straight Road startpoint',
  display = '*',
  color = colors.C_w,
  image = 'terrain/straight_road_startpoint.png',
  floor = true,
  flags = {
    FLOOR = true,
    NOTICE = true,
    REMEMBER = true,
  },
  always_remember = true,
}

newEntity {
  define_as = 'SECTION_OF_THE_STRAIGHT_ROAD',
  name = 'section of the Straight Road',
  display = '*',
  color = colors.C_B,
  image = 'terrain/section_of_the_straight_road.png',
  floor = true,
  flags = {
    FLOOR = true,
    NOTICE = true,
    REMEMBER = true,
  },
  always_remember = true,
}

newEntity {
  define_as = 'SECTION_OF_THE_STRAIGHT_ROAD_2',
  name = 'section of the Straight Road',
  display = '*',
  color = colors.C_b,
  image = 'terrain/section_of_the_straight_road.png',
  floor = true,
  flags = {
    FLOOR = true,
    NOTICE = true,
    REMEMBER = true,
  },
  always_remember = true,
}

newEntity {
  define_as = 'SECTION_OF_THE_STRAIGHT_ROAD_3',
  name = 'section of the Straight Road',
  display = '*',
  color = colors.C_B,
  image = 'terrain/section_of_the_straight_road.png',
  floor = true,
  flags = {
    FLOOR = true,
    NOTICE = true,
    REMEMBER = true,
  },
  always_remember = true,
}

newEntity {
  define_as = 'SECTION_OF_THE_STRAIGHT_ROAD_4',
  name = 'section of the Straight Road',
  display = '*',
  color = colors.C_b,
  image = 'terrain/section_of_the_straight_road.png',
  floor = true,
  flags = {
    FLOOR = true,
    NOTICE = true,
    REMEMBER = true,
  },
  always_remember = true,
}

newEntity {
  define_as = 'SECTION_OF_THE_STRAIGHT_ROAD_5',
  name = 'section of the Straight Road',
  display = '*',
  color = colors.C_W,
  image = 'terrain/section_of_the_straight_road.png',
  floor = true,
  flags = {
    FLOOR = true,
    NOTICE = true,
    REMEMBER = true,
  },
  always_remember = true,
}

newEntity {
  define_as = 'SECTION_OF_THE_STRAIGHT_ROAD__DISCHARGED_',
  name = 'section of the Straight Road (discharged)',
  display = '*',
  color = colors.C_W,
  image = 'terrain/section_of_the_straight_road__discharged_.png',
  floor = true,
  flags = {
    FLOOR = true,
    NOTICE = true,
    REMEMBER = true,
  },
  always_remember = true,
}

newEntity {
  define_as = 'STRAIGHT_ROAD_EXIT',
  name = 'Straight Road exit',
  display = '*',
  color = colors.C_w,
  image = 'terrain/straight_road_exit.png',
  floor = true,
  flags = {
    FLOOR = true,
    NOTICE = true,
    REMEMBER = true,
  },
  always_remember = true,
}

newEntity {
  define_as = 'CORRUPTED_SECTION_OF_THE_STRAIGHT_ROAD',
  name = 'corrupted section of the Straight Road',
  display = '*',
  color = colors.C_D,
  image = 'terrain/corrupted_section_of_the_straight_road.png',
  floor = true,
  flags = {
    FLOOR = true,
    NOTICE = true,
    REMEMBER = true,
  },
  always_remember = true,
}

newEntity {
  define_as = 'BUILDING',
  name = 'Building',
  display = '1',
  color = colors.C_U,
  image = 'terrain/building.png',
  floor = true,
  permanent = true,
  flags = {
    CAN_RUN = true,
    FLOOR = true,
    NOTICE = true,
    PERMANENT = true,
    REMEMBER = true,
  },
  always_remember = true,
}

newEntity {
  define_as = 'SHALLOW_WATER',
  name = 'stream of shallow water',
  display = '~',
  color = colors.C_B,
  image = 'terrain/shallow_water.png',
  floor = true,
  flags = {
    ATTR_MULTI = true,
    CAN_FLY = true,
    CAN_LEVITATE = true,
    CAN_RUN = true,
    DONT_NOTICE_RUNNING = true,
    FLOOR = true,
    REMEMBER = true,
    SUPPORT_GROWTH = true,
    SUPPORT_LIGHT = true,
  },
  always_remember = true,
  -- BEGIN VERBATIM
  change_for_dmgtype = function(grid, x, y, dt, dam)
    if spell.grid_damage(dt, 'water', dam) and rng.percent(10) then return game.zone.grid_list.DEEP_WATER end
    return nil
  end,
  block_move_for = function(grid, e)
    -- Block anything with a fire aura
    local DamageType = require 'engine.DamageType'
    return e and not e.player and e.melee_retal and e.melee_retal[DamageType.FIRE]
  end,
  -- END VERBATIM
}

newEntity {
  define_as = 'DEEP_LAVA',
  name = 'pool of deep lava',
  display = '.',
  color = colors.C_R,
  image = 'terrain/deep_lava.png',
  floor = true,
  flags = {
    CAN_FLY = true,
    CAN_LEVITATE = true,
    FLOOR = true,
    REMEMBER = true,
    SUPPORT_LIGHT = true,
  },
  always_remember = true,
  enter_msg = [[You move across the deep lava.]],
  effect = 'ON_DEEP_LAVA', -- cf. Player:terrainEffects()
  -- BEGIN VERBATIM
  change_for_dmgtype = function(grid, x, y, dt, dam)
    if spell.grid_damage(dt, 'water', dam) then
      local g = spell.floor_grid()
      local grid_type = spell.grid_prob { SHALLOW_LAVA = 10, [g.define_as] = 5 }
      if grid_type then return grid_type end
    end
    return nil
  end,
  block_move_for = function(grid, e)
    -- Block anything without resist fire or flight.
    local DamageType = require 'engine.DamageType'
    return e and not e.player and not e:resistDam(DamageType.FIRE) and not e:has('FLY')
  end,
  can_run = function(grid, e)
    -- Require immunity
    local DamageType = require 'engine.DamageType'
    return e:has('INVULNERABILITY') or e:immuneDam(DamageType.FIRE)
  end,
  -- END VERBATIM
}

newEntity {
  define_as = 'SHALLOW_LAVA',
  name = 'stream of shallow lava',
  display = '.',
  color = colors.C_r,
  image = 'terrain/shallow_lava.png',
  floor = true,
  flags = {
    CAN_FLY = true,
    CAN_LEVITATE = true,
    FLOOR = true,
    REMEMBER = true,
    SUPPORT_LIGHT = true,
  },
  always_remember = true,
  enter_msg = [[You move across the shallow lava.]],
  effect = 'ON_SHALLOW_LAVA', -- cf. Player:terrainEffects()
  -- BEGIN VERBATIM
  change_for_dmgtype = function(grid, x, y, dt, dam)
    if spell.grid_damage(dt, 'water', dam) and rng.percent(15) then return spell.floor_grid() end
    return nil
  end,
  block_move_for = function(grid, e)
    -- Block anything without resist fire or flight.
    local DamageType = require 'engine.DamageType'
    return e and not e.player and not e:resistDam(DamageType.FIRE) and not e:has('FLY')
  end,
  can_run = function(grid, e)
    -- Require immunity
    local DamageType = require 'engine.DamageType'
    return e:has('INVULNERABILITY') or e:immuneDam(DamageType.FIRE)
  end,
  -- END VERBATIM
}

newEntity {
  define_as = 'DARK_PIT',
  name = 'dark pit',
  display = '#',
  color = colors.C_D,
  image = 'terrain/dark_pit.png',
  flags = {
    CAN_FLY = true,
    CAN_LEVITATE = true,
    DONT_NOTICE_RUNNING = true,
    NO_WALK = true,
    SUPPORT_LIGHT = true,
  },
  always_remember = true,
  enter_msg = [[Ohhh, it is dark and deep.]],
  -- BEGIN VERBATIM
  change_for_dmgtype = function(grid, x, y, dt, dam)
    if spell.grid_damage(dt, 'water', dam) and rng.percent(10) then return game.zone.grid_list.DEEP_WATER end
    return nil
  end,
  can_run = function(grid, e)
    -- Require levitation
    return e:has('FEATHER') or e:has('FLY')
  end,
  -- END VERBATIM
}

newEntity {
  define_as = 'DIRT',
  name = 'dirt',
  display = '.',
  color = colors.C_U,
  image = 'terrain/dirt.png',
  floor = true,
  flags = {
    CAN_RUN = true,
    DONT_NOTICE_RUNNING = true,
    FLOOR = true,
    SUPPORT_GROWTH = true,
    SUPPORT_LIGHT = true,
  },
  -- BEGIN VERBATIM
  change_for_dmgtype = function(grid, x, y, dt, dam)
    if spell.grid_damage(dt, 'water', dam) then
      local grid_type = spell.grid_prob { SHALLOW_WATER = 35, DEEP_WATER = 5 }
      if grid_type then return grid_type end
    end
    return spell.floor_damage(grid, x, y, dt, dam)
  end,
  -- END VERBATIM
}

newEntity {
  define_as = 'GRASS',
  name = 'patch of grass',
  display = '.',
  color = colors.C_G,
  image = 'terrain/grass.png',
  floor = true,
  flags = {
    CAN_RUN = true,
    DONT_NOTICE_RUNNING = true,
    FLOOR = true,
    SUPPORT_GROWTH = true,
    SUPPORT_LIGHT = true,
  },
  -- BEGIN VERBATIM
  grassy = true,	-- for Yavanna prayer
  change_for_dmgtype = function(grid, x, y, dt, dam)
    if spell.grid_damage(dt, 'water', dam) then
      local grid_type = spell.grid_prob { SHALLOW_WATER = 35, DEEP_WATER = 5 }
      if grid_type then return grid_type end
    end
    return spell.floor_damage(grid, x, y, dt, dam)
  end,
  -- END VERBATIM
}

newEntity {
  define_as = 'ICE',
  name = 'ice',
  display = '.',
  color = colors.C_W,
  image = 'terrain/ice.png',
  floor = true,
  flags = {
    FLOOR = true,
    NOTICE = true,
  },
  effect = 'ON_ICE', -- cf. Player:terrainEffects()
  -- BEGIN VERBATIM
  change_for_dmgtype = function(grid, x, y, dt, dam)
    if spell.grid_damage(dt, 'fire', dam) then
      local grid_type = spell.grid_prob { DIRT = 10, SHALLOW_WATER = 20 }
      if grid_type then return grid_type end
    end
    return spell.floor_damage(grid, x, y, dt, dam)
  end,
  can_run = function(grid, e)
    -- Require levitation
    return e:has('FEATHER') or e:has('FLY')
  end,
  -- END VERBATIM
}

newEntity {
  define_as = 'SAND',
  name = 'sand',
  display = '.',
  color = colors.C_y,
  image = 'terrain/sand.png',
  floor = true,
  flags = {
    CAN_RUN = true,
    DONT_NOTICE_RUNNING = true,
    FLOOR = true,
    SUPPORT_GROWTH = true,
  },
  change_for_dmgtype = spell.floor_damage,
}

newEntity {
  define_as = 'DEAD_TREE',
  name = 'dead tree',
  display = '#',
  color = colors.C_D,
  image = 'terrain/dead_tree.png',
  block_sight = true,
  wall = true,
  flags = {
    CAN_FLY = true,
    CAN_PASS = true,
    DONT_NOTICE_RUNNING = true,
    NOTICE = true,
    NO_VISION = true,
    NO_WALK = true,
    TUNNELABLE = true,
    WALL = true,
  },
  always_remember = true,
  -- BEGIN VERBATIM
  dig = {
    -- cf. dig_tunnel_aux() in src/cmd2.c
    skill_req = 10,
    skill_req_1pct = 14,
    hardness = 400,
    finish = 'You have cleared away the trees.',
  },
  change_for_dmgtype = function(grid, x, y, dt, dam)
    local DamageType = require 'engine.DamageType'
    if dt == DamageType.DIG then
      return spell.floor_grid()
    end
    return nil
  end,
  -- END VERBATIM
}

newEntity {
  define_as = 'ASH',
  name = 'ash',
  display = '.',
  color = colors.C_s,
  image = 'terrain/ash.png',
  floor = true,
  flags = {
    CAN_RUN = true,
    DONT_NOTICE_RUNNING = true,
    FLOOR = true,
    SUPPORT_GROWTH = true,
  },
  change_for_dmgtype = spell.floor_damage,
}

newEntity {
  define_as = 'MUD',
  name = 'mud',
  display = '.',
  color = colors.C_u,
  image = 'terrain/mud.png',
  floor = true,
  flags = {
    CAN_RUN = true,
    DONT_NOTICE_RUNNING = true,
    FLOOR = true,
    SUPPORT_GROWTH = true,
  },
  change_for_dmgtype = spell.floor_damage,
}

newEntity {
  define_as = 'ICE_WALL',
  name = 'ice wall',
  display = '#',
  color = colors.C_W,
  image = 'terrain/ice_wall.png',
  block_sight = true,
  wall = true,
  flags = {
    CAN_PASS = true,
    DONT_NOTICE_RUNNING = true,
    NO_VISION = true,
    NO_WALK = true,
    SUPPORT_LIGHT = true,
    TUNNELABLE = true,
    WALL = true,
  },
  always_remember = true,
  -- BEGIN VERBATIM
  dig = {
    -- cf. dig_tunnel_aux() in src/cmd2.c
    skill_req = 30,
    skill_req_1pct = 42,
    hardness = 1200,
    finish = 'You have finished the tunnel.',
  },
  -- END VERBATIM
}

newEntity {
  define_as = 'TREE',
  name = 'tree',
  display = '#',
  color = colors.C_G,
  image = 'terrain/tree.png',
  block_sight = true,
  wall = true,
  flags = {
    CAN_FLY = true,
    CAN_PASS = true,
    DONT_NOTICE_RUNNING = true,
    NO_VISION = true,
    NO_WALK = true,
    SUPPORT_LIGHT = true,
    TUNNELABLE = true,
    WALL = true,
  },
  always_remember = true,
  -- BEGIN VERBATIM
  dig = {
    -- cf. dig_tunnel_aux() in src/cmd2.c
    skill_req = 10,
    skill_req_1pct = 14,
    hardness = 400,
    finish = 'You have cleared away the trees.',
  },
  change_for_dmgtype = function(grid, x, y, dt, dam)
    if spell.grid_damage(dt, 'tree', dam) then
      game.player:incPietyFor('Yavanna', -50)
      return game.zone.grid_list.DEAD_TREE
    end
    local DamageType = require 'engine.DamageType'
    if dt == DamageType.DIG then
      return spell.floor_grid()
    end
    return nil
  end,
  -- END VERBATIM
}

newEntity {
  define_as = 'MOUNTAIN_CHAIN',
  name = 'mountain chain',
  display = '^',
  color = colors.C_U,
  image = 'terrain/mountain_chain.png',
  block_sight = true,
  permanent = true,
  wall = true,
  flags = {
    CAN_CLIMB = true,
    CAN_PASS = true,
    DONT_NOTICE_RUNNING = true,
    NO_VISION = true,
    NO_WALK = true,
    PERMANENT = true,
    SUPPORT_LIGHT = true,
    WALL = true,
  },
  always_remember = true,
}

-- BEGIN VERBATIM INTRA
-- Questionable Hack(TM):  For use as a 'diggable_inner_wall' for vaults on
-- levels whose 'inner_wall' is the non-tunnelable MOUNTAIN_CHAIN.
-- [cf. Zone:onLoadZoneFile()]
newEntity {
  base = 'MOUNTAIN_CHAIN',
  define_as = 'DIGGABLE_MOUNTAIN_CHAIN',
  looks_like = 'MOUNTAIN_CHAIN',
  permanent = table.NIL_MERGE,
  flags = {
    PERMANENT = table.NIL_MERGE,
    TUNNELABLE = true,
  }
}
-- END VERBATIM

newEntity {
  define_as = 'SANDWALL',
  name = 'sandwall',
  display = '#',
  color = colors.C_y,
  image = 'terrain/sandwall.png',
  block_sight = true,
  wall = true,
  flags = {
    CAN_PASS = true,
    DONT_NOTICE_RUNNING = true,
    NOTICE = true,
    NO_VISION = true,
    NO_WALK = true,
    TUNNELABLE = true,
    WALL = true,
  },
  always_remember = true,
  -- BEGIN VERBATIM
  dig = {
    -- cf. dig_tunnel_aux() in src/cmd2.c
    skill_req = 5,
    skill_req_1pct = 8,
    hardness = 250,
    finish = 'You have cleared away the trees.',
  },
  change_for_dmgtype = function(grid, x, y, dt, dam)
    if spell.grid_damage(dt, 'fire', dam) and rng.percent(30) then
      return game.zone.grid_list.GLASS_WALL
    end
    local DamageType = require 'engine.DamageType'
    if dt == DamageType.KILL_WALL then
      game.logSeenXY(x, y, 'The sandwall turns into mud!')
      return spell.floor_grid()
    end
    if dt == DamageType.DIG then
      return spell.floor_grid()
    end
    return nil
  end,
  -- END VERBATIM
}

newEntity {
  define_as = 'SANDWALL_WITH_TREASURE',
  name = 'sandwall with treasure',
  display = '*',
  color = colors.C_o,
  image = 'terrain/sandwall_with_treasure.png',
  block_sight = true,
  wall = true,
  flags = {
    CAN_PASS = true,
    DONT_NOTICE_RUNNING = true,
    NOTICE = true,
    NO_VISION = true,
    NO_WALK = true,
    TUNNELABLE = true,
    WALL = true,
  },
  always_remember = true,
  -- BEGIN VERBATIM
  dig = {
    -- cf. dig_tunnel_aux() in src/cmd2.c
    skill_req = 5,
    skill_req_1pct = 8,
    hardness = 250,
    finish = 'You have finished the tunnel.',
  },
  change_for_dmgtype = function(grid, x, y, dt, dam)
    if spell.grid_damage(dt, 'fire', dam) and rng.percent(30) then
      return game.zone.grid_list.GLASS_WALL
    end
    local DamageType = require 'engine.DamageType'
    if dt == DamageType.KILL_WALL then
      game.logSeenXY(x, y, 'The sandwall turns into mud!')
      return spell.floor_grid(), util.place_gold_in_grid
    end
    if dt == DamageType.DIG then
      return spell.floor_grid(), util.place_gold_in_grid
    end
    return nil
  end,
  -- END VERBATIM
}

newEntity {
  define_as = 'HIGH_MOUNTAIN_CHAIN',
  name = 'high mountain chain',
  display = '^',
  color = colors.C_W,
  image = 'terrain/high_mountain_chain.png',
  block_sight = true,
  permanent = true,
  wall = true,
  flags = {
    DONT_NOTICE_RUNNING = true,
    NO_VISION = true,
    NO_WALK = true,
    PERMANENT = true,
    WALL = true,
  },
  always_remember = true,
}

newEntity {
  define_as = 'NETHER_MIST',
  name = 'nether mist',
  display = '.',
  color = colors.C_v,
  image = 'terrain/nether_mist.png',
  floor = true,
  flags = {
    ATTR_MULTI = true,
    CAN_RUN = true,
    DONT_NOTICE_RUNNING = true,
    FLOOR = true,
  },
  change_for_dmgtype = spell.floor_damage,
  effect = 'ON_NETHER_MIST', -- cf. Player:terrainEffects()
}

newEntity {
  define_as = 'MOLTEN_GLASS_WALL',
  name = 'molten glass wall',
  display = '.',
  color = colors.C_B,
  image = 'terrain/molten_glass_wall.png',
  wall = true,
  flags = {
    CAN_PASS = true,
    DONT_NOTICE_RUNNING = true,
    NOTICE = true,
    NO_WALK = true,
    TUNNELABLE = true,
    WALL = true,
  },
  always_remember = true,
  -- BEGIN VERBATIM
  not_map_wall = true,
  dig = {
    -- cf. dig_tunnel_aux() in src/cmd2.c
    skill_req = 30,
    skill_req_1pct = 42,
    hardness = 1200,
    finish = 'You have finished the tunnel.',
  },
  -- END VERBATIM
}

newEntity {
  define_as = 'VOID_JUMPGATE',
  name = 'Void Jumpgate',
  display = '+',
  color = colors.C_v,
  image = 'terrain/void_jumpgate.png',
  floor = true,
  permanent = true,
  flags = {
    CAN_RUN = true,
    FLOOR = true,
    NOTICE = true,
    PERMANENT = true,
    REMEMBER = true,
  },
  always_remember = true,
  enter_msg = [[A dark rift opens to the void here.]],
  -- BEGIN VERBATIM
  use_jumpgate = function(self, who)
    if not who:enoughEnergy() then return end
    -- There are two ways to define jump gate pairs:  setting 'pair_gate'
    -- attrs with each other's x/y coordinates (as used by T2LevelGenerator),
    -- or setting a 'gate_id' attr and searching for level spots with
    -- type='jumpgate' and subtype=<gate_id> (as used by Static via our
    -- various special levels with jumpgates).
    local dest = game.level.map.attrs(who.x, who.y, 'pair_gate')
    if not dest then
      local gate_id = game.level.map.attrs(who.x, who.y, 'gate_id')
      if gate_id then
	for _, spot in ipairs(game.level.spots) do
	  if spot.type == 'jumpgate' and spot.subtype == gate_id and (spot.x ~= who.x or spot.y ~= who.y) then
	    dest = spot
	    break
	  end
	end
      end
    end
    if not dest or not dest.x or not dest.y then
      game.logPlayer(who, 'This jumpgate appears to be non-functional.')
      return
    end
    local Map = require 'mod.class.Map'
    local sx, sy = who.x, who.y
    -- If another Actor is standing on the destination gate...
    local target = game.level.map(dest.x, dest.y, Map.ACTOR)
    game.logPlayer(who, 'You fall into the void.')
    game.logPlayer(who, "Brrrr!  It's deadly cold.")
    -- ...then move it out of the way of the arriving Actor...
    if target then game.level.map:remove(dest.x, dest.y, Map.ACTOR) end
    who:move(dest.x, dest.y, true)
    -- ...and deposit it on the source gate.
    if target then target:move(sx, sy, true) end
    who:useEnergy()
  end,
  -- END VERBATIM
}

newEntity {
  define_as = 'ALTAR_OF_BEING',
  name = 'Altar of Being',
  display = '0',
  color = colors.C_W,
  image = 'terrain/altar_of_being.png',
  floor = true,
  flags = {
    CAN_RUN = true,
    FLOOR = true,
    NOTICE = true,
    REMEMBER = true,
  },
  always_remember = true,
  enter_msg = [[You feel at peace.]],
}

newEntity {
  define_as = 'ALTAR_OF_WINDS',
  name = 'Altar of Winds',
  display = '0',
  color = colors.C_B,
  image = 'terrain/altar_of_winds.png',
  floor = true,
  flags = {
    CAN_RUN = true,
    FLOOR = true,
    NOTICE = true,
    REMEMBER = true,
  },
  always_remember = true,
  enter_msg = [[You grow a desire to become a bird.]],
}

newEntity {
  define_as = 'ALTAR_OF_FORCE',
  name = 'Altar of Force',
  display = '0',
  color = colors.C_R,
  image = 'terrain/altar_of_force.png',
  floor = true,
  flags = {
    CAN_RUN = true,
    FLOOR = true,
    NOTICE = true,
    REMEMBER = true,
  },
  always_remember = true,
  enter_msg = [[You grow a desire to fight evil.]],
}

newEntity {
  define_as = 'ALTAR_OF_DARKNESS',
  name = 'Altar of Darkness',
  display = '0',
  color = colors.C_D,
  image = 'terrain/altar_of_darkness.png',
  floor = true,
  flags = {
    CAN_RUN = true,
    FLOOR = true,
    NOTICE = true,
    REMEMBER = true,
  },
  always_remember = true,
  enter_msg = [[Images of pain and death fill your mind.]],
}

newEntity {
  define_as = 'ALTAR_OF_NATURE',
  name = 'Altar of Nature',
  display = '0',
  color = colors.C_g,
  image = 'terrain/altar_of_nature.png',
  floor = true,
  flags = {
    CAN_RUN = true,
    FLOOR = true,
    NOTICE = true,
    REMEMBER = true,
  },
  always_remember = true,
  enter_msg = [[You feel the desire to walk in a great forest.]],
}

newEntity {
  define_as = 'QUEST_FLOOR',
  name = 'open floor',
  display = '.',
  color = colors.C_w,
  image = 'terrain/quest_floor.png',
  floor = true,
  flags = {
    CAN_RUN = true,
    DONT_NOTICE_RUNNING = true,
    FLOOR = true,
    SUPPORT_GROWTH = true,
  },
  change_for_dmgtype = spell.floor_damage,
}

newEntity {
  define_as = 'UNDERGROUND_TUNNEL',
  name = 'Underground Tunnel',
  display = '#',
  color = colors.C_s,
  image = 'terrain/underground_tunnel.png',
  floor = true,
  flags = {
    CAN_RUN = true,
    DONT_NOTICE_RUNNING = true,
    FLOOR = true,
    REMEMBER = true,
    SUPPORT_LIGHT = true,
  },
  always_remember = true,
  enter_msg = [[Oh, an underground tunnel!]],
}

newEntity {
  define_as = 'TAINTED_WATER',
  name = 'stream of tainted water',
  display = '~',
  color = colors.C_u,
  image = 'terrain/tainted_water.png',
  floor = true,
  flags = {
    CAN_FLY = true,
    CAN_LEVITATE = true,
    DONT_NOTICE_RUNNING = true,
    FLOOR = true,
    REMEMBER = true,
    SUPPORT_LIGHT = true,
  },
  always_remember = true,
}

newEntity {
  define_as = 'MONSTER_TRAP',
  name = 'monster trap',
  display = ';',
  color = colors.C_v,
  image = 'terrain/monster_trap.png',
  floor = true,
  flags = {
    FLOOR = true,
  },
  change_for_dmgtype = spell.floor_damage,
}

newEntity {
  define_as = 'LAVA_WALL',
  name = 'lava wall',
  display = '#',
  color = colors.C_R,
  image = 'terrain/lava_wall.png',
  block_sight = true,
  permanent = true,
  wall = true,
  flags = {
    ATTR_MULTI = true,
    DONT_NOTICE_RUNNING = true,
    NO_VISION = true,
    NO_WALK = true,
    PERMANENT = true,
    WALL = true,
  },
  always_remember = true,
}

newEntity {
  define_as = 'GREAT_FIRE',
  name = 'Great Fire',
  display = '%',
  color = colors.C_v,
  image = 'terrain/great_fire.png',
  floor = true,
  permanent = true,
  flags = {
    ATTR_MULTI = true,
    FLOOR = true,
    NOTICE = true,
    PERMANENT = true,
    REMEMBER = true,
  },
  always_remember = true,
  enter_msg = [[This fire is so powerful it could destroy even the most powerful artifacts.]],
  effect = 'ON_GREAT_FIRE', -- cf. Player:terrainEffects()
  -- BEGIN VERBATIM
  one_ring_drop = true,
  -- END VERBATIM
}

newEntity {
  define_as = 'PATH_TO_THE_NEXT_AREA',
  name = 'path to the next area',
  display = '>',
  color = colors.C_w,
  image = 'terrain/path_to_the_next_area.png',
  floor = true,
  permanent = true,
  flags = {
    CAN_RUN = true,
    FLOOR = true,
    NOTICE = true,
    PERMANENT = true,
    REMEMBER = true,
  },
  always_remember = true,
  -- BEGIN VERBATIM
  change_level = 1,
  -- END VERBATIM
}

newEntity {
  define_as = 'PATH_TO_THE_PREVIOUS_AREA',
  name = 'path to the previous area',
  display = '<',
  color = colors.C_w,
  image = 'terrain/path_to_the_previous_area.png',
  floor = true,
  permanent = true,
  flags = {
    CAN_RUN = true,
    FLOOR = true,
    NOTICE = true,
    PERMANENT = true,
    REMEMBER = true,
  },
  always_remember = true,
  -- BEGIN VERBATIM
  change_level = -1,
  -- END VERBATIM
}

-- BEGIN VERBATIM INTRA
-- Zone exit to the wilderness for "flat" levels, defined here so we can
-- re-use it everywhere.
newEntity {
  base = 'PATH_TO_THE_PREVIOUS_AREA',
  define_as = 'PATH_TO_WILDERNESS',
  name = 'path back to the wilderness',
  looks_like = 'PATH_TO_THE_PREVIOUS_AREA',
  change_level = 1,
  change_zone = 'wilderness',
}
-- END VERBATIM

newEntity {
  define_as = 'FIELD',
  name = 'field',
  display = ':',
  color = colors.C_g,
  image = 'terrain/field.png',
  floor = true,
  permanent = true,
  flags = {
    DONT_NOTICE_RUNNING = true,
    FLOOR = true,
    NOTICE = true,
    PERMANENT = true,
    REMEMBER = true,
  },
  always_remember = true,
}

newEntity {
  define_as = 'EKKAIA__THE_ENCIRCLING_SEA',
  name = 'Ekkaia, the Encircling Sea',
  display = '*',
  color = colors.C_b,
  image = 'terrain/ekkaia__the_encircling_sea.png',
  block_sight = true,
  permanent = true,
  wall = true,
  flags = {
    ATTR_MULTI = true,
    DONT_NOTICE_RUNNING = true,
    NO_VISION = true,
    NO_WALK = true,
    PERMANENT = true,
    SUPPORT_LIGHT = true,
    WALL = true,
  },
  always_remember = true,
}

newEntity {
  define_as = 'VOID',
  name = 'void',
  display = ' ',
  color = colors.C_d,
  image = 'terrain/void.png',
  floor = true,
  flags = {
    FLOOR = true,
  },
  change_for_dmgtype = spell.floor_damage,
}

newEntity {
  define_as = 'DEEP_WATER',
  name = 'pool of deep water',
  display = '~',
  color = colors.C_b,
  image = 'terrain/deep_water.png',
  floor = true,
  flags = {
    ATTR_MULTI = true,
    CAN_FLY = true,
    CAN_LEVITATE = true,
    FLOOR = true,
    REMEMBER = true,
    SUPPORT_LIGHT = true,
  },
  always_remember = true,
  -- BEGIN VERBATIM
  block_move_for = function(grid, e)
    -- Block anything that can't swim or fly.
    return e and not e.player and not (e:has('AQUATIC') or e:has('FLY') or e:has('CAN_SWIM'))
  end,
  can_run = function(grid, e)
    -- Require levitation
    return e:has('FEATHER') or e:has('FLY')
  end,
  -- END VERBATIM
}

newEntity {
  define_as = 'GLASS_WALL',
  name = 'glass wall',
  display = '.',
  color = colors.C_B,
  image = 'terrain/glass_wall.png',
  permanent = true,
  wall = true,
  flags = {
    DONT_NOTICE_RUNNING = true,
    NOTICE = true,
    NO_WALK = true,
    PERMANENT = true,
    WALL = true,
  },
  always_remember = true,
}

newEntity {
  define_as = 'ILLUSION_WALL',
  name = 'illusion wall',
  display = '#',
  color = colors.C_w,
  image = 'terrain/illusion_wall.png',
  floor = true,
  block_sight = true,
  flags = {
    DONT_NOTICE_RUNNING = true,
    FLOOR = true,
    NO_VISION = true,
    REMEMBER = true,
    SUPPORT_LIGHT = true,
  },
  always_remember = true,
  enter_msg = [[Looks like this wall is not so real.]],
  -- BEGIN VERBATIM
  map_wall = true,
  -- END VERBATIM
}

newEntity {
  define_as = 'GRASS_ROOF',
  name = 'Grass roof',
  display = '#',
  color = colors.C_y,
  image = 'terrain/grass_roof.png',
  block_sight = true,
  permanent = true,
  wall = true,
  flags = {
    DONT_NOTICE_RUNNING = true,
    NO_VISION = true,
    NO_WALK = true,
    PERMANENT = true,
    WALL = true,
  },
  always_remember = true,
}

newEntity {
  define_as = 'GRASS_ROOF_TOP',
  name = 'grass roof top',
  display = '#',
  color = colors.C_y,
  image = 'terrain/grass_roof_top.png',
  block_sight = true,
  permanent = true,
  wall = true,
  flags = {
    DONT_NOTICE_RUNNING = true,
    NO_VISION = true,
    NO_WALK = true,
    PERMANENT = true,
    WALL = true,
  },
  always_remember = true,
}

newEntity {
  define_as = 'GRASS_ROOF_CHIMNEY',
  name = 'grass roof chimney',
  display = '#',
  color = colors.C_y,
  image = 'terrain/grass_roof_chimney.png',
  block_sight = true,
  permanent = true,
  wall = true,
  flags = {
    DONT_NOTICE_RUNNING = true,
    NO_VISION = true,
    NO_WALK = true,
    PERMANENT = true,
    WALL = true,
  },
  always_remember = true,
}

newEntity {
  define_as = 'BRICK_ROOF',
  name = 'brick roof',
  display = '#',
  color = colors.C_r,
  image = 'terrain/brick_roof.png',
  block_sight = true,
  permanent = true,
  wall = true,
  flags = {
    DONT_NOTICE_RUNNING = true,
    NO_VISION = true,
    NO_WALK = true,
    PERMANENT = true,
    WALL = true,
  },
  always_remember = true,
}

newEntity {
  define_as = 'BRICK_ROOF_TOP',
  name = 'brick roof top',
  display = '#',
  color = colors.C_r,
  image = 'terrain/brick_roof_top.png',
  block_sight = true,
  permanent = true,
  wall = true,
  flags = {
    DONT_NOTICE_RUNNING = true,
    NO_VISION = true,
    NO_WALK = true,
    PERMANENT = true,
    WALL = true,
  },
  always_remember = true,
}

newEntity {
  define_as = 'BRICK_ROOF_CHIMNEY',
  name = 'brick roof chimney',
  display = '#',
  color = colors.C_r,
  image = 'terrain/brick_roof_chimney.png',
  block_sight = true,
  permanent = true,
  wall = true,
  flags = {
    DONT_NOTICE_RUNNING = true,
    NO_VISION = true,
    NO_WALK = true,
    PERMANENT = true,
    WALL = true,
  },
  always_remember = true,
}

newEntity {
  define_as = 'WINDOW',
  name = 'window',
  display = '#',
  color = colors.C_w,
  image = 'terrain/window.png',
  block_sight = true,
  permanent = true,
  wall = true,
  flags = {
    DONT_NOTICE_RUNNING = true,
    NO_VISION = true,
    NO_WALK = true,
    PERMANENT = true,
    WALL = true,
  },
  always_remember = true,
}

newEntity {
  define_as = 'SMALL_WINDOW',
  name = 'small window',
  display = '#',
  color = colors.C_w,
  image = 'terrain/small_window.png',
  block_sight = true,
  permanent = true,
  wall = true,
  flags = {
    DONT_NOTICE_RUNNING = true,
    NO_VISION = true,
    NO_WALK = true,
    PERMANENT = true,
    WALL = true,
  },
  always_remember = true,
}

newEntity {
  define_as = 'RAIN_BARREL',
  name = 'rain barrel',
  display = '#',
  color = colors.C_w,
  image = 'terrain/rain_barrel.png',
  block_sight = true,
  permanent = true,
  wall = true,
  flags = {
    DONT_NOTICE_RUNNING = true,
    NO_VISION = true,
    NO_WALK = true,
    PERMANENT = true,
    WALL = true,
  },
  always_remember = true,
}

newEntity {
  define_as = 'GRASS_WITH_FLOWERS',
  name = 'grass with flowers',
  display = ';',
  color = colors.C_G,
  image = 'terrain/grass_with_flowers.png',
  floor = true,
  flags = {
    CAN_RUN = true,
    DONT_NOTICE_RUNNING = true,
    FLOOR = true,
    SUPPORT_GROWTH = true,
  },
  change_for_dmgtype = spell.floor_damage,
  -- BEGIN VERBATIM
  grassy = true,	-- for Yavanna prayer
  -- END VERBATIM
}

newEntity {
  define_as = 'COBBLESTONE_ROAD',
  name = 'cobblestone road',
  display = '.',
  color = colors.C_w,
  image = 'terrain/cobblestone_road.png',
  floor = true,
  flags = {
    CAN_RUN = true,
    DONT_NOTICE_RUNNING = true,
    FLOOR = true,
  },
  change_for_dmgtype = spell.floor_damage,
}

newEntity {
  define_as = 'COBBLESTONE_WITH_OUTLET',
  name = 'cobblestone with outlet',
  display = '.',
  color = colors.C_w,
  image = 'terrain/cobblestone_with_outlet.png',
  floor = true,
  flags = {
    CAN_RUN = true,
    DONT_NOTICE_RUNNING = true,
    FLOOR = true,
  },
  change_for_dmgtype = spell.floor_damage,
}

newEntity {
  define_as = 'SMALL_TREE',
  name = 'small tree',
  display = '#',
  color = colors.C_g,
  image = 'terrain/small_tree.png',
  floor = true,
  block_sight = true,
  flags = {
    CAN_RUN = true,
    DONT_NOTICE_RUNNING = true,
    FLOOR = true,
    NO_VISION = true,
    REMEMBER = true,
    SUPPORT_LIGHT = true,
  },
  always_remember = true,
  -- BEGIN VERBATIM
  map_wall = true,
  change_for_dmgtype = function(grid, x, y, dt, dam)
    if spell.grid_damage(dt, 'tree', dam) then
      -- Slight Hack(TM):  Destroying small trees with fire specifically
      -- (well, with one of a handful of fire-related types) reduces
      -- Yavanna piety by 60; I don't think it's worth the effort to single
      -- those out.
      game.player:incPietyFor('Yavanna', -50)
      return game.zone.grid_list.DEAD_SMALL_TREE
    end
    return nil
  end,
  -- END VERBATIM
}

newEntity {
  define_as = 'TOWN',
  name = 'town',
  display = '*',
  color = colors.C_w,
  image = 'terrain/town.png',
  floor = true,
  flags = {
    FLOOR = true,
    NOTICE = true,
  },
  change_for_dmgtype = spell.floor_damage,
}

newEntity {
  define_as = 'UNDERGROUND_TUNNEL_END',
  name = 'Underground Tunnel',
  display = '^',
  color = colors.C_U,
  image = 'terrain/underground_tunnel.png',
  floor = true,
  flags = {
    CAN_RUN = true,
    DONT_NOTICE_RUNNING = true,
    FLOOR = true,
    REMEMBER = true,
    SUPPORT_LIGHT = true,
  },
  always_remember = true,
  enter_msg = [[Oh, an underground tunnel!]],
}

newEntity {
  define_as = 'A_BLAZING_FIRE',
  name = 'a blazing fire',
  display = '%',
  color = colors.C_y,
  image = 'terrain/a_blazing_fire.png',
  floor = true,
  flags = {
    ATTR_MULTI = true,
    CAN_FLY = true,
    DONT_NOTICE_RUNNING = true,
    FLOOR = true,
    REMEMBER = true,
    SUPPORT_LIGHT = true,
  },
  always_remember = true,
  enter_msg = [[The blazing fire burns you!]],
  effect = 'ON_A_BLAZING_FIRE', -- cf. Player:terrainEffects()
}

newEntity {
  define_as = 'PERMA_RUBBLE',
  name = 'pile of rubble',
  display = ':',
  color = colors.C_w,
  image = 'terrain/perma_rubble.png',
  block_sight = true,
  permanent = true,
  wall = true,
  flags = {
    CAN_FLY = true,
    CAN_PASS = true,
    NOTICE = true,
    NO_VISION = true,
    NO_WALK = true,
    PERMANENT = true,
    SUPPORT_LIGHT = true,
    WALL = true,
  },
  always_remember = true,
}

newEntity {
  define_as = 'ROCKY_GROUND',
  name = 'rocky ground',
  display = '.',
  color = colors.C_s,
  image = 'terrain/rocky_ground.png',
  floor = true,
  flags = {
    CAN_RUN = true,
    DONT_NOTICE_RUNNING = true,
    FLOOR = true,
    SUPPORT_LIGHT = true,
  },
  change_for_dmgtype = spell.floor_damage,
}

newEntity {
  define_as = 'CLOUD_LIKE_VAPOUR',
  name = 'cloud-like vapour',
  display = '.',
  color = colors.C_W,
  image = 'terrain/cloud_like_vapour.png',
  floor = true,
  flags = {
    ATTR_MULTI = true,
    CAN_FLY = true,
    CAN_LEVITATE = true,
    CAN_RUN = true,
    DONT_NOTICE_RUNNING = true,
    FLOOR = true,
    SUPPORT_LIGHT  = true,
  },
  change_for_dmgtype = spell.floor_damage,
}

newEntity {
  define_as = 'CONDENSING_WATER',
  name = 'condensing water',
  display = '~',
  color = colors.C_B,
  image = 'terrain/condensing_water.png',
  floor = true,
  flags = {
    ATTR_MULTI = true,
    CAN_FLY = true,
    CAN_LEVITATE = true,
    CAN_RUN = true,
    DONT_NOTICE_RUNNING = true,
    FLOOR = true,
    REMEMBER = true,
    SUPPORT_LIGHT = true,
  },
  always_remember = true,
}

newEntity {
  define_as = 'DENSE_MIST',
  name = 'dense mist',
  display = '#',
  color = colors.C_w,
  image = 'terrain/dense_mist.png',
  floor = true,
  block_sight = true,
  flags = {
    ATTR_MULTI = true,
    DONT_NOTICE_RUNNING = true,
    FLOOR = true,
    NO_VISION = true,
    REMEMBER = true,
    SUPPORT_LIGHT = true,
  },
  always_remember = true,
  enter_msg = [[You wander through the mist.]],
}

newEntity {
  define_as = 'HAIL_STONE_WALL',
  name = 'hail-stone wall',
  display = '#',
  color = colors.C_W,
  image = 'terrain/hail_stone_wall.png',
  block_sight = true,
  wall = true,
  flags = {
    CAN_PASS = true,
    DONT_NOTICE_RUNNING = true,
    NOTICE = true,
    NO_VISION = true,
    NO_WALK = true,
    SUPPORT_LIGHT = true,
    TUNNELABLE = true,
    WALL = true,
  },
  always_remember = true,
  -- BEGIN VERBATIM
  dig = {
    -- cf. dig_tunnel_aux() in src/cmd2.c
    skill_req = 30,
    skill_req_1pct = 42,
    hardness = 1200,
    finish = 'You have finished the tunnel.',
  },
  -- END VERBATIM
}

newEntity {
  define_as = 'DEAD_SMALL_TREE',
  name = 'dead small tree',
  display = '#',
  color = colors.C_D,
  image = 'terrain/dead_small_tree.png',
  floor = true,
  block_sight = true,
  flags = {
    CAN_RUN = true,
    DONT_NOTICE_RUNNING = true,
    FLOOR = true,
    NO_VISION = true,
    REMEMBER = true,
    SUPPORT_LIGHT = true,
  },
  always_remember = true,
}

newEntity {
  define_as = 'COPPER_PILLAR',
  name = 'copper pillar',
  display = '#',
  color = colors.C_u,
  image = 'terrain/copper_pillar.png',
  block_sight = true,
  wall = true,
  flags = {
    ATTR_MULTI = true,
    CAN_PASS = true,
    DONT_NOTICE_RUNNING = true,
    NOTICE = true,
    NO_VISION = true,
    NO_WALK = true,
    SUPPORT_LIGHT = true,
    WALL = true,
  },
  always_remember = true,
}

newEntity {
  define_as = 'ETHEREAL_WALL',
  name = 'ethereal wall',
  display = '.',
  color = colors.C_w,
  image = 'terrain/ethereal_wall.png',
  permanent = true,
  wall = true,
  flags = {
    DONT_NOTICE_RUNNING = true,
    NOTICE = true,
    NO_WALK = true,
    PERMANENT = true,
    WALL = true,
  },
  always_remember = true,
}

newEntity {
  define_as = 'GLACIAL_WALL',
  name = 'glacial wall',
  display = '#',
  color = colors.C_B,
  image = 'terrain/glacial_wall.png',
  block_sight = true,
  wall = true,
  flags = {
    CAN_PASS = true,
    DONT_NOTICE_RUNNING = true,
    NO_VISION = true,
    NO_WALK = true,
    SUPPORT_LIGHT = true,
    TUNNELABLE = true,
    WALL = true,
  },
  always_remember = true,
  -- BEGIN VERBATIM
  dig = {
    -- cf. dig_tunnel_aux() in src/cmd2.c
    skill_req = 30,
    skill_req_1pct = 42,
    hardness = 1200,
    finish = 'You have finished the tunnel.',
  },
  -- END VERBATIM
}

newEntity {
  define_as = 'BATTLEMENT',
  name = 'battlement',
  display = '#',
  color = colors.C_w,
  image = 'terrain/battlement.png',
  flags = {
    CAN_PASS = true,
    DONT_NOTICE_RUNNING = true,
    NOTICE = true,
    NO_WALK = true,
    SUPPORT_LIGHT = true,
    TUNNELABLE = true,
  },
  always_remember = true,
  -- BEGIN VERBATIM
  dig = {
    -- cf. dig_tunnel_aux() in src/cmd2.c
    skill_req = 30,
    skill_req_1pct = 42,
    hardness = 1200,
    finish = 'You have finished the tunnel.',
  },
  -- END VERBATIM
}
