-- $Id$
-- ToME - Tales of Middle-Earth
-- Copyright © 2012-2017 Scott Bigham
--
-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
-- Scott Bigham "Zizzo"
-- dsb-tome@killerbunnies.org

-- -----------------------------------------------------------------------
-- WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING
-- -----------------------------------------------------------------------
-- This file was generated automatically by the 'gen_obj' Perl script.
-- DO NOT MODIFY THIS FILE DIRECTLY, as any changes will be lost the next
-- time the file is generated (with the possible exception of lines between
-- 'BEGIN VERBATIM' and 'END VERBATIM' markers, if supported by the script).
-- -----------------------------------------------------------------------
-- WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING
-- -----------------------------------------------------------------------

-- Object entities generated from T2's k_info.txt

newEntity {
  base = 'MUSHROOM_BASE',
  define_as = 'SHROOM_BLINDNESS',
  name = 'SHROOM_BLINDNESS',
  display_name = 'Blindness',
  desc = [['E'ating this mushrooms will blind you. You cannot cast magic  or see monsters when you are blinded. You can still use magic items or quaff potions.]],
  sval = 1,
  color = colors.C_d,
  image = 'object/shroom_placeholder.png',
  level = 5,
  extra = 0,
  weight = 0.1,
  encumber = 0.1,
  cost = 0,
  allocation = { { level=5, rarity=1 } },
  -- BEGIN VERBATIM
  food = {
    add = 500,
    on_eat = function(self, who)
      if not who:resist(DamageType.BLIND) then
	who:setEffect(who.EFF_BLIND, 200 + rng.range(1, 20), {merge='combine'})
	return true
      end
    end,
    on_eat_desc = 'blind yourself',
  },
  -- END VERBATIM
}

newEntity {
  base = 'MUSHROOM_BASE',
  define_as = 'SHROOM_PARANOIA',
  name = 'SHROOM_PARANOIA',
  display_name = 'Paranoia',
  desc = [['E'ating this mushroom will make you scared. You will not be able to hit your enemies in combat if you're scared.]],
  sval = 2,
  color = colors.C_d,
  image = 'object/shroom_placeholder.png',
  level = 5,
  extra = 0,
  weight = 0.1,
  encumber = 0.1,
  cost = 0,
  allocation = { { level=5, rarity=1 } },
  -- BEGIN VERBATIM
  food = {
    add = 500,
    on_eat = function(self, who)
      if not who:resistDam(DamageType.FEAR) then
	who:setEffect(who.EFF_AFRAID, rng.range(11, 20), {merge='combine'})
	return true
      end
    end,
    on_eat_desc = 'frighten yourself',
  },
  -- END VERBATIM
}

newEntity {
  base = 'MUSHROOM_BASE',
  define_as = 'SHROOM_CONFUSION',
  name = 'SHROOM_CONFUSION',
  display_name = 'Confusion',
  desc = [['E'ating this mushroom will confuse you. You will not be able to cast spells, use wands, staves or scrolls. You can still quaff potions, though.]],
  sval = 3,
  color = colors.C_d,
  image = 'object/shroom_placeholder.png',
  level = 5,
  extra = 0,
  weight = 0.1,
  encumber = 0.1,
  cost = 0,
  allocation = { { level=5, rarity=1 } },
  -- BEGIN VERBATIM
  food = {
    add = 500,
    on_eat = function(self, who)
      if not who:resistDam(DamageType.CONFUSION) then
	who:setEffect(who.EFF_CONFUSED, rng.range(11, 20), {merge='combine'})
	return true
      end
    end,
    on_eat_desc = 'confuse yourself',
  },
  -- END VERBATIM
}

newEntity {
  base = 'MUSHROOM_BASE',
  define_as = 'SHROOM_HALLUCINATION',
  name = 'SHROOM_HALLUCINATION',
  display_name = 'Hallucination',
  desc = [['E'ating this mushroom will make you hallucinate. You will not be able to recognise any monster or item.]],
  sval = 4,
  color = colors.C_d,
  image = 'object/shroom_placeholder.png',
  level = 10,
  extra = 0,
  weight = 0.1,
  encumber = 0.1,
  cost = 0,
  allocation = { { level=10, rarity=1 } },
  -- BEGIN VERBATIM
  food = {
    add = 500,
    on_eat = function(self, who)
      if not who:resistDam(DamageType.CHAOS) then
	who:setEffect(who.EFF_HALLUCINATION, 250 + rng.range(1, 250), {merge='combine'})
	return true
      end
    end,
    on_eat_desc = 'induce hallucinations',
  },
  -- END VERBATIM
}

newEntity {
  base = 'MUSHROOM_BASE',
  define_as = 'SHROOM_CURE_POISON',
  name = 'SHROOM_CURE_POISON',
  display_name = 'Cure Poison',
  desc = [['E'ating this mushroom will cure you from poison.]],
  sval = 12,
  color = colors.C_d,
  image = 'object/shroom_placeholder.png',
  level = 10,
  extra = 0,
  weight = 0.1,
  encumber = 0.1,
  cost = 60,
  allocation = { { level=10, rarity=1 } },
  -- BEGIN VERBATIM
  food = {
    add = 500,
    on_eat = function(self, who)
      local learn = who:hasEffect(who.EFF_POISON) and true or false
      who:removeEffect(who.EFF_POISON)
      return learn
    end,
    on_eat_desc = 'cure poison',
  },
  -- END VERBATIM
}

newEntity {
  base = 'MUSHROOM_BASE',
  define_as = 'SHROOM_CURE_BLINDNESS',
  name = 'SHROOM_CURE_BLINDNESS',
  display_name = 'Cure Blindness',
  desc = [['E'ating this mushroom will cure you from blindness.]],
  sval = 13,
  color = colors.C_d,
  image = 'object/shroom_placeholder.png',
  level = 10,
  extra = 0,
  weight = 0.1,
  encumber = 0.1,
  cost = 50,
  allocation = { { level=10, rarity=1 } },
  -- BEGIN VERBATIM
  food = {
    add = 500,
    on_eat = function(self, who)
      local learn = who:hasEffect(who.EFF_BLIND) and true or false
      who:removeEffect(who.EFF_BLIND)
      return learn
    end,
    on_eat_desc = 'cure blindness',
  },
  -- END VERBATIM
}

newEntity {
  base = 'MUSHROOM_BASE',
  define_as = 'SHROOM_CURE_PARANOIA',
  name = 'SHROOM_CURE_PARANOIA',
  display_name = 'Cure Paranoia',
  desc = [['E'ating this mushroom will cure your paranoia.  Paranoia is the state when you are too afraid to attack monsters.]],
  sval = 14,
  color = colors.C_d,
  image = 'object/shroom_placeholder.png',
  level = 10,
  extra = 0,
  weight = 0.1,
  encumber = 0.1,
  cost = 25,
  allocation = { { level=10, rarity=1 } },
  -- BEGIN VERBATIM
  food = {
    add = 500,
    on_eat = function(self, who)
      local learn = who:hasEffect(who.EFF_AFRAID) and true or false
      who:removeEffect(who.EFF_AFRAID)
      return learn
    end,
    on_eat_desc = 'free yourself of fear',
  },
  -- END VERBATIM
}

newEntity {
  base = 'MUSHROOM_BASE',
  define_as = 'SHROOM_CURE_CONFUSION',
  name = 'SHROOM_CURE_CONFUSION',
  display_name = 'Cure Confusion',
  desc = [['E'ating this mushroom will cure your confusion.  Confusion is when you are too confused to cast spells, zap staves, aim wands or read scrolls.]],
  sval = 15,
  color = colors.C_d,
  image = 'object/shroom_placeholder.png',
  level = 10,
  extra = 0,
  weight = 0.1,
  encumber = 0.1,
  cost = 50,
  allocation = { { level=10, rarity=1 } },
  -- BEGIN VERBATIM
  food = {
    add = 500,
    on_eat = function(self, who)
      local learn = who:hasEffect(who.EFF_CONFUSED) and true or false
      who:removeEffect(who.EFF_CONFUSED)
      return learn
    end,
    on_eat_desc = 'cure confusion',
  },
  -- END VERBATIM
}

newEntity {
  base = 'MUSHROOM_BASE',
  define_as = 'SHROOM_WEAKNESS',
  name = 'SHROOM_WEAKNESS',
  display_name = 'Weakness',
  desc = [['E'ating this mushroom will reduce your strength by one point.]],
  sval = 6,
  color = colors.C_d,
  image = 'object/shroom_placeholder.png',
  level = 10,
  extra = 0,
  weight = 0.1,
  encumber = 0.1,
  cost = 0,
  combat = { 5, 5 },
  allocation = { { level=10, rarity=1 } },
  -- BEGIN VERBATIM
  food = {
    add = 500,
    on_eat = function(self, who)
      who:takeHit(rng.dice(6, 6), self, 'poisonous food')
      local drain, sust = who:bumpStatDown('STR')
      return drain or sust
    end,
    on_eat_desc = 'take 6d6 damage and reduce your Strengh',
  },
  -- END VERBATIM
}

newEntity {
  base = 'MUSHROOM_BASE',
  define_as = 'SHROOM_UNHEALTH',
  name = 'SHROOM_UNHEALTH',
  display_name = 'Unhealth',
  desc = [['E'ating this mushroom will reduce your constitution by one point.]],
  sval = 10,
  color = colors.C_d,
  image = 'object/shroom_placeholder.png',
  level = 15,
  extra = 0,
  weight = 0.1,
  encumber = 0.1,
  cost = 50,
  combat = { 10, 10 },
  allocation = { { level=15, rarity=1 } },
  -- BEGIN VERBATIM
  food = {
    add = 500,
    on_eat = function(self, who)
      who:takeHit(rng.dice(10, 10), self, 'poisonous food')
      local drain, sust = who:bumpStatDown('CON')
      return drain or sust
    end,
    on_eat_desc = 'take 10d10 damage and reduce your Constitution',
  },
  -- END VERBATIM
}

newEntity {
  base = 'MUSHROOM_BASE',
  define_as = 'SHROOM_RESTORE_CONSTITUTION',
  name = 'SHROOM_RESTORE_CONSTITUTION',
  display_name = 'Restore Constitution',
  desc = [['E'ating this mushroom will restore your constitution. Your constitution needs restoring when it is displayed in yellow.]],
  sval = 18,
  color = colors.C_d,
  image = 'object/shroom_placeholder.png',
  level = 20,
  extra = 0,
  weight = 0.1,
  encumber = 0.1,
  cost = 350,
  allocation = { { level=20, rarity=1 } },
  -- BEGIN VERBATIM
  food = {
    add = 500,
    on_eat = function(self, who)
      return who:restoreStat('CON') and true or false
    end,
    on_eat_desc = 'restore your Constitution',
  },
  -- END VERBATIM
}

newEntity {
  base = 'MUSHROOM_BASE',
  define_as = 'SHROOM_RESTORING',
  name = 'SHROOM_RESTORING',
  display_name = 'Restoring',
  desc = [['E'ating this mushroom will restore your strength, dexterity, constitution, intelligence, wisdom and charisma. These need restoring when they are displayed in yellow.]],
  sval = 19,
  color = colors.C_d,
  image = 'object/shroom_placeholder.png',
  level = 20,
  extra = 0,
  weight = 0.1,
  encumber = 0.1,
  cost = 1000,
  allocation = {
    { level=20, rarity=8 },
    { level=30, rarity=4 },
    { level=40, rarity=1 },
  },
  -- BEGIN VERBATIM
  food = {
    add = 500,
    on_eat = function(self, who)
      local learn = false
      learn = who:restoreStat('STR') or learn
      learn = who:restoreStat('INT') or learn
      learn = who:restoreStat('WIS') or learn
      learn = who:restoreStat('DEX') or learn
      learn = who:restoreStat('CON') or learn
      learn = who:restoreStat('CHA') or learn
      return learn
    end,
    on_eat_desc = 'restore your stats',
  },
  -- END VERBATIM
}

newEntity {
  base = 'MUSHROOM_BASE',
  define_as = 'SHROOM_STUPIDITY',
  name = 'SHROOM_STUPIDITY',
  display_name = 'Stupidity',
  desc = [['E'ating this mushroom will reduce your intelligence by one point. That's a bad thing.]],
  sval = 8,
  color = colors.C_d,
  image = 'object/shroom_placeholder.png',
  level = 15,
  extra = 0,
  weight = 0.1,
  encumber = 0.1,
  cost = 0,
  allocation = { { level=15, rarity=1 } },
  -- BEGIN VERBATIM
  food = {
    add = 500,
    on_eat = function(self, who)
      who:takeHit(rng.dice(8, 8), self, 'poisonous food')
      local drain, sust = who:bumpStatDown('INT')
      return drain or sust
    end,
    on_eat_desc = 'take 8d8 damage and reduce your Intelligence',
  },
  -- END VERBATIM
}

newEntity {
  base = 'MUSHROOM_BASE',
  define_as = 'SHROOM_NAIVETY',
  name = 'SHROOM_NAIVETY',
  display_name = 'Naivety',
  desc = [['E'ating this mushroom will reduce your wisdom by one point. That's a bad thing.]],
  sval = 9,
  color = colors.C_d,
  image = 'object/shroom_placeholder.png',
  level = 15,
  extra = 0,
  weight = 0.1,
  encumber = 0.1,
  cost = 0,
  allocation = { { level=15, rarity=1 } },
  -- BEGIN VERBATIM
  food = {
    add = 500,
    on_eat = function(self, who)
      who:takeHit(rng.dice(8, 8), self, 'poisonous food')
      local drain, sust = who:bumpStatDown('WIS')
      return drain or sust
    end,
    on_eat_desc = 'take 8d8 damage and reduce your Wisdom',
  },
  -- END VERBATIM
}

newEntity {
  base = 'MUSHROOM_BASE',
  define_as = 'SHROOM_POISON',
  name = 'SHROOM_POISON',
  display_name = 'Poison',
  desc = [['E'ating this mushroom will poison you. Poisoning makes you lose one hitpoint per turn until you magically stop the poison or until your body has fought off the poison. That's a bad thing.]],
  sval = 0,
  color = colors.C_d,
  image = 'object/shroom_placeholder.png',
  level = 5,
  extra = 0,
  weight = 0.1,
  encumber = 0.1,
  cost = 0,
  combat = { 4, 4 },
  allocation = {
    { level=5, rarity=1 },
    { level=5, rarity=1 },
  },
  -- BEGIN VERBATIM
  food = {
    add = 500,
    on_eat = function(self, who)
      if not who:resistDam(DamageType.POISON, {or_immune=true}) then
	who:setEffect(who.EFF_POISON, rng.range(11, 20), {merge='combine', src=self})
	return true
      end
    end,
    on_eat_desc = 'poison yourself',
  },
  -- END VERBATIM
}

newEntity {
  base = 'MUSHROOM_BASE',
  define_as = 'SHROOM_SICKNESS',
  name = 'SHROOM_SICKNESS',
  display_name = 'Sickness',
  desc = [['E'ating this mushroom will reduce your constitution by one point. It will also damage you quite severely in the process. That's a bad thing.]],
  sval = 7,
  color = colors.C_d,
  image = 'object/shroom_placeholder.png',
  level = 10,
  extra = 0,
  weight = 0.1,
  encumber = 0.1,
  cost = 0,
  combat = { 4, 4 },
  allocation = { { level=10, rarity=1 } },
  -- BEGIN VERBATIM
  food = {
    add = 500,
    on_eat = function(self, who)
      who:takeHit(rng.dice(6, 6), self, 'poisonous food')
      local drain, sust = who:bumpStatDown('CON')
      return drain or sust
    end,
    on_eat_desc = 'take 6d6 damage and reduce your Constitution',
  },
  -- END VERBATIM
}

newEntity {
  base = 'MUSHROOM_BASE',
  define_as = 'SHROOM_PARALYSIS',
  name = 'SHROOM_PARALYSIS',
  display_name = 'Paralysis',
  desc = [['E'ating this mushroom will paralyse you for a certain time. Any nearby monsters will take this opportunity to kill you. That's a bad thing.]],
  sval = 5,
  color = colors.C_d,
  image = 'object/shroom_placeholder.png',
  level = 20,
  extra = 0,
  weight = 0.1,
  encumber = 0.1,
  cost = 0,
  allocation = { { level=20, rarity=1 } },
  -- BEGIN VERBATIM
  food = {
    add = 500,
    on_eat = function(self, who)
      if not who:has('FREE_ACT') then
	who:setEffect(who.EFF_PARALYZED, rng.range(11, 20), {merge='combine'})
	return true
      end
    end,
    on_eat_desc = 'temporarily paralyze yourself',
  },
  -- END VERBATIM
}

newEntity {
  base = 'MUSHROOM_BASE',
  define_as = 'SHROOM_RESTORE_STRENGTH',
  name = 'SHROOM_RESTORE_STRENGTH',
  display_name = 'Restore Strength',
  desc = [['E'ating this mushroom will restore your strength. Your strength needs restoring when it is displayed in yellow.]],
  sval = 17,
  color = colors.C_d,
  image = 'object/shroom_placeholder.png',
  level = 20,
  extra = 0,
  weight = 0.1,
  encumber = 0.1,
  cost = 350,
  allocation = { { level=20, rarity=1 } },
  -- BEGIN VERBATIM
  food = {
    add = 500,
    on_eat = function(self, who)
      return who:restoreStat('STR') and true or false
    end,
    on_eat_desc = 'restore your Strength',
  },
  -- END VERBATIM
}

newEntity {
  base = 'MUSHROOM_BASE',
  define_as = 'SHROOM_DISEASE',
  name = 'SHROOM_DISEASE',
  display_name = 'Disease',
  desc = [['E'ating this mushroom will reduce your strength by one point. It will also damage you quite severely in the process. That's a bad thing.]],
  sval = 11,
  color = colors.C_d,
  image = 'object/shroom_placeholder.png',
  level = 20,
  extra = 0,
  weight = 0.1,
  encumber = 0.1,
  cost = 50,
  combat = { 10, 10 },
  allocation = { { level=20, rarity=1 } },
  -- BEGIN VERBATIM
  food = {
    add = 500,
    on_eat = function(self, who)
      who:takeHit(rng.dice(10, 10), self, 'poisonous food')
      local drain, sust = who:bumpStatDown('STR')
      return drain or sust
    end,
    on_eat_desc = 'take 10d10 damage and reduce your Strengh',
  },
  -- END VERBATIM
}

newEntity {
  base = 'MUSHROOM_BASE',
  define_as = 'SHROOM_CURE_SERIOUS_WOUNDS',
  name = 'SHROOM_CURE_SERIOUS_WOUNDS',
  display_name = 'Cure Serious Wounds',
  desc = [['E'ating this mushroom will heal several hit points. Your hit points need healing when they are displayed in yellow or red.]],
  sval = 16,
  color = colors.C_d,
  image = 'object/shroom_placeholder.png',
  level = 15,
  extra = 0,
  weight = 0.1,
  encumber = 0.1,
  cost = 75,
  allocation = { { level=15, rarity=1 } },
  -- BEGIN VERBATIM
  food = {
    add = 500,
    on_eat = function(self, who)
      local learn = who.life < who.max_life
      who:heal(rng.dice(4, 8))
      return learn
    end,
    on_eat_desc = 'heal 4d8 hit points',
  },
  -- END VERBATIM
}

newEntity {
  base = 'FOOD_BASE',
  define_as = 'RATION_OF_FOOD',
  name = 'RATION_OF_FOOD',
  display_name = '& Ration~ of Food',
  desc = [[Lightweight and filling. Not an incredible taste experience, but that'd be asking a bit much. You can 'E'at it.]],
  sval = 35,
  color = colors.C_U,
  image = 'object/ration_of_food.png',
  level = 0,
  extra = 0,
  weight = 1,
  encumber = 1,
  cost = 3,
  allocation = {
    { level=0, rarity=1 },
    { level=5, rarity=1 },
    { level=10, rarity=1 },
  },
  -- BEGIN VERBATIM
  food = {
    add = 5000,
    message = 'That tasted good.',
  },
  -- END VERBATIM
}

newEntity {
  base = 'FOOD_BASE',
  define_as = 'HARD_BISCUIT',
  name = 'HARD_BISCUIT',
  display_name = '& Hard Biscuit~',
  desc = [[It doesn't look great, and 'E'ating it will only fill your stomach a bit, for a short time.]],
  sval = 32,
  color = colors.C_U,
  image = 'object/hard_biscuit.png',
  level = 0,
  extra = 0,
  weight = 0.2,
  encumber = 0.2,
  cost = 1,
  -- BEGIN VERBATIM
  food = {
    add = 500,
    message = 'That tasted good.',
  },
  -- END VERBATIM
}

newEntity {
  base = 'FOOD_BASE',
  define_as = 'STRIP_OF_VENISON',
  name = 'STRIP_OF_VENISON',
  display_name = '& Strip~ of Venison',
  desc = [[It looks great, and 'E'ating it will fill your stomach well.]],
  sval = 33,
  color = colors.C_u,
  image = 'object/strip_of_venison.png',
  level = 0,
  extra = 0,
  weight = 0.2,
  encumber = 0.2,
  cost = 2,
  -- BEGIN VERBATIM
  food = {
    add = 1500,
    message = 'That tasted good.',
  },
  -- END VERBATIM
}

newEntity {
  base = 'FOOD_BASE',
  define_as = 'SLIME_MOLD',
  name = 'SLIME_MOLD',
  display_name = '& Slime Mold~',
  desc = [[It looks disgusting, but if you really want to you can 'E'at it. Not an incredible taste experience, but that'd be asking a bit much.]],
  sval = 36,
  color = colors.C_g,
  image = 'object/slime_mold.png',
  level = 1,
  extra = 0,
  weight = 0.5,
  encumber = 0.5,
  cost = 2,
  allocation = { { level=1, rarity=1 } },
  -- BEGIN VERBATIM
  food = {
    add = 3000,
    message = 'That tasted good.',
    on_eat = function(self, who)
      if rng.percent(2) then
	who:setEffect(who.EFF_MOLD_AFFINITY, 1, {})
      end
      return true
    end,
  },
  -- END VERBATIM
}

newEntity {
  base = 'FOOD_BASE',
  define_as = 'LEMBAS',
  name = 'LEMBAS',
  display_name = '& Lembas~',
  desc = [[A sort of cake, tasty and sustaining. It even helps to overcome weariness. Its fabrication is a secret of the elves. If you 'E'at it, you will be full.]],
  sval = 37,
  color = colors.C_B,
  image = 'object/lembas.png',
  level = 5,
  extra = 0,
  weight = 0.3,
  encumber = 0.3,
  cost = 10,
  allocation = {
    { level=5, rarity=1 },
    { level=10, rarity=1 },
    { level=20, rarity=1 },
  },
  -- BEGIN VERBATIM
  food = {
    set = util.FOOD.max - 1,
    message = 'That tasted very good.',
    on_eat = function(self, who)
      who:removeEffect(who.EFF_POISON)
      who:heal(rng.dice(4, 8))
      return true
    end,
    on_eat_desc = 'heal 4d8 hit points and cure poison',
  },
  -- END VERBATIM
}

newEntity {
  base = 'FOOD_BASE',
  define_as = 'PINT_OF_FINE_ALE',
  name = 'PINT_OF_FINE_ALE',
  display_name = '& Pint~ of Fine Ale',
  desc = [[A bottle of a dark beer-like beverage. You can drink it by pressing 'E'.]],
  sval = 38,
  color = colors.C_y,
  image = 'object/pint_of_fine_ale.png',
  level = 0,
  extra = 0,
  weight = 0.5,
  encumber = 0.5,
  cost = 1,
  -- BEGIN VERBATIM
  food = {
    add = 500,
    message = 'That tasted good.',
    bottle = true,
  },
  -- END VERBATIM
}

newEntity {
  base = 'FOOD_BASE',
  define_as = 'PINT_OF_FINE_WINE',
  name = 'PINT_OF_FINE_WINE',
  display_name = '& Pint~ of Fine Wine',
  desc = [[A bottle of fine wine. You can drink it by pressing 'E'.]],
  sval = 39,
  color = colors.C_r,
  image = 'object/pint_of_fine_wine.png',
  level = 0,
  extra = 0,
  weight = 1,
  encumber = 1,
  cost = 2,
  -- BEGIN VERBATIM
  food = {
    add = 1000,
    message = 'That tasted good.',
    bottle = true,
  },
  -- END VERBATIM
}

newEntity {
  base = 'FOOD_BASE',
  define_as = 'SPRIG_OF_ATHELAS',
  name = 'SPRIG_OF_ATHELAS',
  display_name = '& Sprig~ of Athelas',
  desc = [['When the black breath blows / And death's shadow grows / And all lights pass / Come Athelas! Come Athelas! / Life to the dying / In the King's hands lying.']],
  sval = 40,
  color = colors.C_g,
  image = 'object/sprig_of_athelas.png',
  level = 25,
  extra = 5,
  weight = 0.2,
  encumber = 0.2,
  cost = 450,
  allocation = {
    { level=25, rarity=2 },
    { level=55, rarity=1 },
    { level=85, rarity=1 },
  },
  -- BEGIN VERBATIM
  food = {
    add = 0,
    message = 'A fresh, clean essence rises, driving away wounds and poison.',
    on_eat = function(self, who)
      who:removeEffect(who.EFF_POISON)
      who:removeEffect(who.EFF_STUN)
      who:removeEffect(who.EFF_CUT)
      who:removeEffect(who.EFF_BLACK_BREATH)
      return true
    end,
    on_eat_desc = 'cure poison, stun and cuts and remove Black Breath',
  },
  -- END VERBATIM
}

newEntity {
  base = 'FOOD_BASE',
  define_as = 'GREATER_RATION_OF_HEALTH',
  name = 'GREATER_RATION_OF_HEALTH',
  display_name = '& Greater Ration~ of Health',
  desc = 'This food will, once eaten, permanently add 70 HP.',
  sval = 41,
  color = colors.C_g,
  image = 'object/greater_ration_of_health.png',
  level = 90,
  extra = 5,
  weight = 0.2,
  encumber = 0.2,
  cost = 60000,
  norm_art = true,
  unique = 'GREATER_RATION_OF_HEALTH',
  flags = { FULL_NAME=true, EASY_KNOW=table.NIL_MERGE },
  allocation = { { level=90, rarity=50 } },
  artifact_info = '80:40',
  -- BEGIN VERBATIM
  food = {
    add = 0,
    on_eat = function(self, who)
      game.logPlayer(who, 'As you eat %s, you begin to feel your life flow getting stronger.', self:getName())
      who.hp_mod = (who.hp_mod or 0) + 70
      return true
    end,
    on_eat_desc = 'permanently increase your hit points by 70',
  },
  -- END VERBATIM
}

newEntity {
  base = 'FOOD_BASE',
  define_as = 'FORTUNE_COOKIE',
  name = 'FORTUNE_COOKIE',
  display_name = '& Fortune cookie~',
  desc = 'A small, sweet bakery product, with a scrap of paper inside.',
  sval = 42,
  color = colors.C_U,
  image = 'object/fortune_cookie.png',
  level = 0,
  extra = 0,
  weight = 0.2,
  encumber = 0.2,
  cost = 10,
  allocation = {
    { level=0, rarity=1 },
    { level=5, rarity=1 },
    { level=10, rarity=1 },
  },
  -- BEGIN VERBATIM
  food = {
    add = 500,
    message = 'That tasted good.',
    on_eat = function(self, who)
      game.logPlayer(who, 'There is a message in the cookie.  It reads:')
      -- TODO T2 also gets fortune lines from other files.
      -- [cf. src/cmd6.c lines 1202-1229]
      local f, err = loadfile('/data/rumors.lua')
      if f then
	local rumor = f()
	game.logPlayer(who, rumor)
      else
	game.logPlayer(who, '[Error generating fortune.  We Apologize for the Inconvenience.]')
      end
      return true
    end,
  },
  -- END VERBATIM
}
-- 30 total items
-- color:  colors.C_B=1; colors.C_U=3; colors.C_d=20; colors.C_g=3; colors.C_r=1; colors.C_u=1; colors.C_y=1
-- level:  0=6; 1=1; 10=7; 15=4; 20=5; 25=1; 5=5; 90=1
-- extra:  0=28; 5=2
-- weight:  1=20; 10=2; 2=5; 3=1; 5=2
-- cost:  0=10; 1=2; 10=2; 1000=1; 2=3; 25=1; 3=1; 350=2; 450=1; 50=4; 60=1; 60000=1; 75=1
-- foodval:  1000=1; 1500=1; 3000=1; 500=23; 5000=1
-- artifact_info:  80:40=1
