-- $Id: scrolls.lua 3032 2017-08-19 04:03:52Z dsb $
-- ToME - Tales of Middle-Earth
-- Copyright © 2012-2017 Scott Bigham
--
-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
-- Scott Bigham "Zizzo"
-- dsb-tome@killerbunnies.org

-- -----------------------------------------------------------------------
-- WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING
-- -----------------------------------------------------------------------
-- This file was generated automatically by the 'gen_obj' Perl script.
-- DO NOT MODIFY THIS FILE DIRECTLY, as any changes will be lost the next
-- time the file is generated (with the possible exception of lines between
-- 'BEGIN VERBATIM' and 'END VERBATIM' markers, if supported by the script).
-- -----------------------------------------------------------------------
-- WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING
-- -----------------------------------------------------------------------

-- Object entities generated from T2's k_info.txt

newEntity {
  base = 'SCROLL_BASE',
  define_as = 'SCRL_ENCHANT_WEAPON_TO_HIT',
  name = 'SCRL_ENCHANT_WEAPON_TO_HIT',
  display_name = 'Enchant Weapon To-Hit',
  desc = 'This magical scroll will allow you to improve the accuracy of a weapon in your possession. However, weapons which are already very highly enchanted are more difficult to improve further.',
  sval = 17,
  image = 'object/scroll_placeholder.png',
  level = 15,
  cost = 125,
  allocation = { { level=15, rarity=1 } },
  -- BEGIN VERBATIM
  use_simple = {
    name_base = [[increase a weapon's to-hit bonus]],
    use = function(self, who)
      local function filter(o) return o.type == 'weapon' end
      local ret = spell.enchant_item(who, 'Enchant Weapon To-Hit', filter, {to_h=1})
      return ret and { id=true, used=true, destroy=true } or { id=true }
    end,
  },
  -- END VERBATIM
}

newEntity {
  base = 'SCROLL_BASE',
  define_as = 'SCRL_ENCHANT_WEAPON_TO_DAM',
  name = 'SCRL_ENCHANT_WEAPON_TO_DAM',
  display_name = 'Enchant Weapon To-Dam',
  desc = 'Upon reading this scroll, a magical enchantment will be placed on a weapon in your possession, increasing the pain it inflicts when hitting. On very highly enchanted weapons this enchantment may fail, wasting the scroll.',
  sval = 18,
  image = 'object/scroll_placeholder.png',
  level = 15,
  cost = 125,
  allocation = { { level=15, rarity=1 } },
  -- BEGIN VERBATIM
  use_simple = {
    name_base = [[increase a weapon's damage bonus]],
    use = function(self, who)
      local function filter(o) return o.type == 'weapon' end
      local ret = spell.enchant_item(who, 'Enchant Weapon To-Dam', filter, {to_d=1})
      return ret and { id=true, used=true, destroy=true } or { id=true }
    end,
  },
  -- END VERBATIM
}

newEntity {
  base = 'SCROLL_BASE',
  define_as = 'SCRL_ENCHANT_ARMOUR',
  name = 'SCRL_ENCHANT_ARMOUR',
  display_name = 'Enchant Armour',
  desc = 'This scroll will try to enchant a piece of armour in your possession, making it more effective in protecting you. Highly enchanted armour is likely not to accept this enchantment, however.',
  sval = 16,
  image = 'object/scroll_placeholder.png',
  level = 15,
  cost = 125,
  allocation = { { level=15, rarity=1 } },
  -- BEGIN VERBATIM
  use_simple = {
    name_base = [[increase an armor piece's armor bonus]],
    use = function(self, who)
      local function filter(o) return o.type == 'armor' end
      local ret = spell.enchant_item(who, 'Enchant Armor', filter, {to_a=true})
      return ret and { id=true, used=true, destroy=true } or { id=true }
    end,
  },
  -- END VERBATIM
}

newEntity {
  base = 'SCROLL_BASE',
  define_as = 'SCRL_IDENTIFY',
  name = 'SCRL_IDENTIFY',
  display_name = 'Identify',
  desc = 'If you read this scroll, the identity of an item you specify will be laid open to you.',
  sval = 12,
  image = 'object/scroll_placeholder.png',
  level = 1,
  cost = 50,
  allocation = {
    { level=1, rarity=1 },
    { level=5, rarity=1 },
    { level=10, rarity=1 },
    { level=30, rarity=1 },
  },
  -- BEGIN VERBATIM
  use_simple = {
    name_base = 'identify an object',
    use = function(self, who)
      local ret = spell.identify_dialog(who, true, 'Select item to identify')
      return ret and { id=true, used=true, destroy=true } or { id=true }
    end,
  },
  -- END VERBATIM
}

newEntity {
  base = 'SCROLL_BASE',
  define_as = 'SCRL_XTRA_IDENTIFY',
  name = 'SCRL_XTRA_IDENTIFY',
  display_name = '*Identify*',
  desc = [[This scroll will allow you to gain insight into an object's special properties. Only the highly magical objects, like rare rings and amulets or very unusual weapons and armour possess abilities which warrant the use of this magic.]],
  sval = 13,
  image = 'object/scroll_placeholder.png',
  level = 30,
  cost = 1000,
  allocation = {
    { level=30, rarity=1 },
    { level=50, rarity=2 },
    { level=80, rarity=1 },
    { level=100, rarity=1 },
  },
  -- BEGIN VERBATIM
  use_simple = {
    name_base = 'learn everything about an object',
    use = function(self, who)
      local ret = spell.identify_dialog(who, 'full', 'Select item to fully identify')
      return ret and { id=true, used=true, destroy=true } or { id=true }
    end,
  },
  -- END VERBATIM
}

newEntity {
  base = 'SCROLL_BASE',
  define_as = 'SCRL_RUMOUR',
  name = 'SCRL_RUMOUR',
  display_name = 'Rumour',
  desc = 'A piece of paper inscribed with a little text. You may meditate over it or ignore it at your leisure.',
  sval = 51,
  image = 'object/scroll_placeholder.png',
  level = 1,
  cost = 10,
  allocation = { { level=1, rarity=1 } },
  -- BEGIN VERBATIM
  use_simple = {
    name_base = 'gain some questionable insight',
    use = function(self, who)
      game.logPlayer(who, 'There is a message on the scroll.  It says:')
      -- TODO T2 also gets fortune lines from other files.
      -- [cf. src/cmd6.c lines 3569-3601]
      local f, err = loadfile('/data/rumors.lua')
      local rumor = f and f() or '[Error generating rumor.  We Apologize for the Inconvenience.]'
      game.logPlayer(who, rumor)
      game.logPlayer(who, 'The scroll disappears in a puff of smoke!')
      return { id=true, used=true, destroy=true }
    end,
  },
  -- END VERBATIM
}

newEntity {
  base = 'SCROLL_BASE',
  define_as = 'SCRL_CHAOS',
  name = 'SCRL_CHAOS',
  display_name = 'Chaos',
  desc = 'A piece of paper inscribed with strange shifting runes. Upon reading them, they will release a blast of chaotic forces.',
  sval = 50,
  image = 'object/scroll_placeholder.png',
  level = 100,
  cost = 10000,
  ignore_dam = { [DamageType.FIRE]=true, [DamageType.ACID]=true, [DamageType.COLD]=true, [DamageType.ELEC]=true },
  allocation = { { level=100, rarity=8 } },
  -- BEGIN VERBATIM
  use_simple = {
    name_base = 'release a blast of chaos doing 222 chaos damage to yourself and everything in radius 4',
    use = function(self, who)
      spell.ball_spell(who, nil, DamageType.CHAOS, 222, 4, who.x, who.y, 0)
      -- T2 describes this as '"Double" damage since it is centered on the
      -- player'.
      if not who:resistDam(DamageType.CHAOS, {or_immune=true}) then
	who:takeHit(rng.range(112, 222), self)
      end
      return { used=true, destroy=true, id=true }
    end,
  },
  -- END VERBATIM
}

newEntity {
  base = 'SCROLL_BASE',
  define_as = 'SCRL_REMOVE_CURSE',
  name = 'SCRL_REMOVE_CURSE',
  display_name = 'Remove Curse',
  desc = 'A scroll inscribed with a beneficial formula. Upon reading it, evil magics will be removed from your possessions.',
  sval = 14,
  image = 'object/scroll_placeholder.png',
  level = 10,
  cost = 100,
  allocation = {
    { level=10, rarity=1 },
    { level=20, rarity=2 },
    { level=40, rarity=2 },
  },
  -- BEGIN VERBATIM
  use_simple = {
    name_base = 'uncurse items you are carrying or wearing',
    use = function(self, who)
      local any = spell.uncurse_inven(who)
      if any then
	game.logPlayer(who, 'You feel someone is watching over you.')
      end
      return { used=true, destroy=true, id=any }
    end,
  },
  -- END VERBATIM
}

newEntity {
  base = 'SCROLL_BASE',
  define_as = 'SCRL_LIGHT',
  name = 'SCRL_LIGHT',
  display_name = 'Light',
  desc = 'A scroll which will create a permanent magical light, illuminating the surroundings.',
  sval = 24,
  image = 'object/scroll_placeholder.png',
  level = 0,
  cost = 15,
  allocation = {
    { level=0, rarity=1 },
    { level=3, rarity=1 },
    { level=10, rarity=1 },
  },
  -- BEGIN VERBATIM
  use_simple = {
    name_base = 'permanently illuminate your immediate surroundings and do 2d8 damage to light-sensitive creatures in radius 2',
    use = function(self, who)
      spell.lite_room(who.x, who.y)
      spell.ball_spell(who, nil, DamageType.LITE_WEAK, rng.dice(2, 8), 2, who.x, who.y, 0)
      return { used=true, destroy=true, id=true }
    end,
  },
  in_trap = {
    damtype=DamageType.LITE_WEAK, dam={2,8}, r=2,
    side_effect = function(self, _, x, y, _) spell.lite_room(x, y) end,
    side_effect_desc = 'illuminates the room',
  }
  -- END VERBATIM
}

newEntity {
  base = 'SCROLL_BASE',
  define_as = 'SCRL_FIRE',
  name = 'SCRL_FIRE',
  display_name = 'Fire',
  desc = 'A piece of paper inscribed with runes glowing brightly red. Upon reading them, a large blast of fire will be released.',
  sval = 48,
  image = 'object/scroll_placeholder.png',
  level = 50,
  cost = 1000,
  ignore_dam = { [DamageType.FIRE]=true },
  allocation = { { level=50, rarity=4 } },
  -- BEGIN VERBATIM
  use_simple = {
    name_base = 'release a blast of fire doing 150 fire damage to yourself and everything in radius 4',
    use = function(self, who)
      spell.ball_spell(who, nil, DamageType.FIRE, 150, 4, who.x, who.y, 0)
      -- T2 describes this as '"Double" damage since it is centered on the
      -- player'.
      if not who:resistDam(DamageType.FIRE, {or_immune=true}) then
	local dam = rng.range(51, 100) + (who:vulnDam(DamageType.FIRE) and 20 or 0)
	who:takeHit(dam, self)
      end
      return { used=true, destroy=true, id=true }
    end,
  },
  -- END VERBATIM
}

newEntity {
  base = 'SCROLL_BASE',
  define_as = 'SCRL_ICE',
  name = 'SCRL_ICE',
  display_name = 'Ice',
  desc = 'A piece of paper inscribed with light-blue runes that radiate a strange cold. Upon reading them, a large icy blast will be released.',
  sval = 49,
  image = 'object/scroll_placeholder.png',
  level = 75,
  cost = 5000,
  ignore_dam = { [DamageType.COLD]=true },
  allocation = { { level=75, rarity=6 } },
  -- BEGIN VERBATIM
  use_simple = {
    name_base = 'release a blast of ice doing 175 ice damage to yourself and everything in radius 4',
    use = function(self, who)
      spell.ball_spell(who, nil, DamageType.ICE, 175, 4, who.x, who.y, 0)
      -- T2 describes this as '"Double" damage since it is centered on the
      -- player'.
      if not who:resistDam(DamageType.COLD, {or_immune=true}) then
	who:takeHit(rng.range(101, 200), self)
      end
      return { used=true, destroy=true, id=true }
    end,
  },
  -- END VERBATIM
}

newEntity {
  base = 'SCROLL_BASE',
  define_as = 'SCRL_SUMMON_MONSTERS',
  name = 'SCRL_SUMMON_MONSTERS',
  display_name = 'Summon Monsters',
  desc = 'This scroll was made by mischievous sorcerers. If it is read, a few creatures will appear to fight you.',
  sval = 4,
  image = 'object/scroll_placeholder.png',
  level = 1,
  cost = 0,
  allocation = { { level=1, rarity=1 } },
  -- BEGIN VERBATIM
  use_simple = {
    name_base = 'summon 1-3 hostile monsters',
    use = function(self, who)
      local ret = spell.summon(self, who.x, who.y, nil, rng.range(1, 3))
      return { used=true, destroy=true, id=(#ret > 0) }
    end,
  },
  in_trap = {
    side_effect = function(self, _, x, y, who)
      spell.summon(self, who.x, who.y, nil, rng.range(1, 3))
    end,
    side_effect_desc = 'summons 1-3 monsters hostile to the target',
  },
  -- END VERBATIM
}

newEntity {
  base = 'SCROLL_BASE',
  define_as = 'SCRL_PHASE_DOOR',
  name = 'SCRL_PHASE_DOOR',
  display_name = 'Phase Door',
  desc = 'Upon reading this scroll, you will be translocated over a short distance.',
  sval = 8,
  image = 'object/scroll_placeholder.png',
  level = 1,
  cost = 15,
  allocation = { { level=1, rarity=1 } },
  -- BEGIN VERBATIM
  use_simple = {
    name_base = 'teleport randomly in range 10',
    use = function(self, who)
      spell.teleport(who, 10)
      return { used=true, destroy=true, id=true }
    end,
  },
  in_trap = { damtype=DamageType.TELEPORT, dam=10, r=0 },
  -- END VERBATIM
}

newEntity {
  base = 'SCROLL_BASE',
  define_as = 'SCRL_TELEPORTATION',
  name = 'SCRL_TELEPORTATION',
  display_name = 'Teleportation',
  desc = 'If you read this scroll, you will immediately be transported to another place on the level.',
  sval = 9,
  image = 'object/scroll_placeholder.png',
  level = 10,
  cost = 40,
  allocation = { { level=10, rarity=1 } },
  -- BEGIN VERBATIM
  use_simple = {
    name_base = 'teleport randomly in range 100',
    use = function(self, who)
      spell.teleport(who, 100)
      return { used=true, destroy=true, id=true }
    end,
  },
  in_trap = { damtype=DamageType.TELEPORT, dam=100, r=0 },
  -- END VERBATIM
}

newEntity {
  base = 'SCROLL_BASE',
  define_as = 'SCRL_TELEPORT_LEVEL',
  name = 'SCRL_TELEPORT_LEVEL',
  display_name = 'Teleport Level',
  desc = 'This scroll will magically transport you to the level directly above or below, when read.',
  sval = 10,
  image = 'object/scroll_placeholder.png',
  level = 20,
  cost = 50,
  allocation = { { level=20, rarity=1 } },
  -- BEGIN VERBATIM
  use_simple = {
    name_base = 'randomly teleport up or down one dungeon level',
    use = function(self, who)
      spell.player_teleport_level(who, 100)
      return { used=true, destroy=true, id=true }
    end,
  },
  in_trap = {
    side_effect = function(self, _, x, y, who)
      -- TODO remove monster from level
    end,
    side_effect_desc = 'teleports target off level',
  },
  -- END VERBATIM
}

newEntity {
  base = 'SCROLL_BASE',
  define_as = 'SCRL_MONSTER_CONFUSION',
  name = 'SCRL_MONSTER_CONFUSION',
  display_name = 'Monster Confusion',
  desc = 'Reading this scroll will cause your hands to glow with a strange mesmerising light that will attempt to confuse the next creature you hit with a hand or weapon attack.',
  sval = 36,
  image = 'object/scroll_placeholder.png',
  level = 5,
  cost = 30,
  allocation = { { level=5, rarity=1 } },
  -- BEGIN VERBATIM
  use_simple = {
    name_base = 'give yourself a temporary monster-confusing effect',
    use = function(self, who)
      who:setEffect(who.EFF_CONFUSE_MONSTER, 1, {})
      return { used=true, destroy=true, id=true }
    end,
  },
  in_trap = { damtype=DamageType.OLD_CONF, dam={5,10}, r=0 },
  -- END VERBATIM
}

newEntity {
  base = 'SCROLL_BASE',
  define_as = 'SCRL_MAGIC_MAPPING',
  name = 'SCRL_MAGIC_MAPPING',
  display_name = 'Magic Mapping',
  desc = 'Reading this scroll will reveal the layout of your immediate surroundings to you.',
  sval = 25,
  image = 'object/scroll_placeholder.png',
  level = 5,
  cost = 40,
  allocation = { { level=5, rarity=1 } },
  -- BEGIN VERBATIM
  use_simple = {
    name_base = 'map the surrounding area',
    use = function(self, who)
      who:computeFOV(40, 'block_sense', spell.map_area_callback, true, true, true)
      return { used=true, destroy=true, id=true }
    end,
  },
  -- END VERBATIM
}

newEntity {
  base = 'SCROLL_BASE',
  define_as = 'SCRL_RUNE_OF_PROTECTION',
  name = 'SCRL_RUNE_OF_PROTECTION',
  display_name = 'Rune of Protection',
  desc = 'This scroll is inscribed with a powerful protective incantation. When read, this will erect a strong magical ward around the location you currently stand on. Be aware that this magic is easily disturbed by already present structures and thus cannot work where an object is lying, or on a trap.',
  sval = 38,
  image = 'object/scroll_placeholder.png',
  level = 50,
  cost = 500,
  allocation = {
    { level=50, rarity=2 },
    { level=90, rarity=4 },
  },
}

newEntity {
  base = 'SCROLL_BASE',
  define_as = 'SCRL_XTRA_REMOVE_CURSE',
  name = 'SCRL_XTRA_REMOVE_CURSE',
  display_name = '*Remove Curse*',
  desc = 'This valuable scroll is inscribed with a powerful blessing capable of dispelling all but the mightiest curses which may have been laid on your possessions.',
  sval = 15,
  image = 'object/scroll_placeholder.png',
  level = 50,
  cost = 8000,
  allocation = {
    { level=50, rarity=2 },
    { level=75, rarity=2 },
    { level=85, rarity=2 },
    { level=95, rarity=1 },
  },
  -- BEGIN VERBATIM
  use_simple = {
    name_base = 'strongly uncurse items you are carrying or wearing',
    use = function(self, who)
      local any = spell.uncurse_inven(who, true)
      if any then
	game.logPlayer(who, 'You feel someone is watching over you.')
      end
      return { used=true, destroy=true, id=any }
    end,
  },
  -- END VERBATIM
}

newEntity {
  base = 'SCROLL_BASE',
  define_as = 'SCRL_TREASURE_DETECTION',
  name = 'SCRL_TREASURE_DETECTION',
  display_name = 'Treasure Detection',
  desc = 'This scroll magically reveals the locations of nearby loose change to you.',
  sval = 26,
  image = 'object/scroll_placeholder.png',
  level = 0,
  cost = 15,
  allocation = { { level=0, rarity=1 } },
  -- BEGIN VERBATIM
  use_simple = {
    name_base = 'detect nearby treasure',
    use = function(self, who)
      local det1 = spell.detect_buried_treasure(25, who)
      local det2 = spell.detect_gold(25, who)
      return { used=true, destroy=true, id=det1 or det2 }
    end,
  },
  -- END VERBATIM
}

newEntity {
  base = 'SCROLL_BASE',
  define_as = 'SCRL_OBJECT_DETECTION',
  name = 'SCRL_OBJECT_DETECTION',
  display_name = 'Object Detection',
  desc = 'This scroll shows nearby objects to you. It only makes you aware of items on the floor, however, not those carried by creatures.',
  sval = 27,
  image = 'object/scroll_placeholder.png',
  level = 0,
  cost = 15,
  allocation = { { level=0, rarity=1 } },
  -- BEGIN VERBATIM
  use_simple = {
    name_base = 'detect nearby objects',
    use = function(self, who)
      local det = spell.detect_objects(25, who)
      return { used=true, destroy=true, id=det }
    end,
  },
  -- END VERBATIM
}

newEntity {
  base = 'SCROLL_BASE',
  define_as = 'SCRL_TRAP_DETECTION',
  name = 'SCRL_TRAP_DETECTION',
  display_name = 'Trap Detection',
  desc = 'This scroll is very helpful, because it reveals the locations of nearby snares and traps which you might otherwise blunder into.',
  sval = 28,
  image = 'object/scroll_placeholder.png',
  level = 5,
  cost = 35,
  allocation = {
    { level=5, rarity=1 },
    { level=10, rarity=1 },
  },
  -- BEGIN VERBATIM
  use_simple = {
    name_base = 'detect nearby traps',
    use = function(self, who)
      local det = spell.detect_traps(25, who)
      return { used=true, destroy=true, id=det }
    end,
  },
  -- END VERBATIM
}

newEntity {
  base = 'SCROLL_BASE',
  define_as = 'SCRL_DOOR_STAIR_LOCATION',
  name = 'SCRL_DOOR_STAIR_LOCATION',
  display_name = 'Door/Stair Location',
  desc = 'This scroll will reveal nearby passages.',
  sval = 29,
  image = 'object/scroll_placeholder.png',
  level = 5,
  cost = 35,
  allocation = {
    { level=5, rarity=1 },
    { level=10, rarity=1 },
    { level=15, rarity=1 },
  },
  -- BEGIN VERBATIM
  use_simple = {
    name_base = 'detect nearby doors and stairs',
    use = function(self, who)
      local det = spell.detect_doors_stairs(25, who)
      return { used=true, destroy=true, id=det }
    end,
  },
  -- END VERBATIM
}

newEntity {
  base = 'SCROLL_BASE',
  define_as = 'SCRL_ACQUIREMENT',
  name = 'SCRL_ACQUIREMENT',
  display_name = 'Acquirement',
  desc = 'A great treasure is magically stored within the shimmering runes of this scroll. Reading the words will release it.',
  sval = 46,
  image = 'object/scroll_placeholder.png',
  level = 20,
  cost = 100000,
  allocation = { { level=20, rarity=8 } },
  -- BEGIN VERBATIM
  use_simple = {
    name_base = 'create a powerful magical object',
    use = function(self, who)
      obj_util.acquirement(who.x, who.y, 1, true, false, self)
      return { used=true, destroy=true, id=true }
    end,
  },
  in_trap = {
    side_effect = function(self, trap, x, y, who)
      local name = self:name{no_mods=true, no_pval=true, no_inscr=true, force_id=true}
      local tr_name = trap:getName()
      local found = {
	type = 'custom_with_level',
	custom = ('You created %%s using %s (via %s)'):format(name, tr_name),
      }
      obj_util.acquirement(who.x, who.y, 1, true, false, found)
    end,
    side_effect_desc = 'creates a powerful magic object',
  }
  -- END VERBATIM
}

newEntity {
  base = 'SCROLL_BASE',
  define_as = 'SCRL_XTRA_ACQUIREMENT',
  name = 'SCRL_XTRA_ACQUIREMENT',
  display_name = '*Acquirement*',
  desc = 'Several great treasures have been hidden in a magical compartment. This scroll serves as the key and will release them when read.',
  sval = 47,
  image = 'object/scroll_placeholder.png',
  level = 60,
  cost = 200000,
  allocation = { { level=60, rarity=16 } },
  -- BEGIN VERBATIM
  use_simple = {
    name_base = 'create a few powerful magical objects',
    use = function(self, who)
      obj_util.acquirement(who.x, who.y, rng.range(2, 3), true, false, self)
      return { used=true, destroy=true, id=true }
    end,
  },
  in_trap = {
    side_effect = function(self, _, x, y, who)
      local name = self:name{no_mods=true, no_pval=true, no_inscr=true, force_id=true}
      local tr_name = trap:getName()
      local found = {
	type = 'custom_with_level',
	custom = ('You created %%s using %s (via %s)'):format(name, tr_name),
      }
      obj_util.acquirement(who.x, who.y, rng.range(2, 3), true, false, found)
    end,
    side_effect_desc = 'creates a few powerful magic objects',
  }
  -- END VERBATIM
}

newEntity {
  base = 'SCROLL_BASE',
  define_as = 'SCRL_MASS_GENOCIDE',
  name = 'SCRL_MASS_GENOCIDE',
  display_name = 'Mass Genocide',
  desc = 'An astoundingly powerful death spell is stored in the runes of this spell.  Reading it will annihilate all nearby creatures. Only a few beings of legendary stature can withstand it.',
  sval = 45,
  image = 'object/scroll_placeholder.png',
  level = 50,
  cost = 1000,
  allocation = {
    { level=50, rarity=4 },
    { level=100, rarity=4 },
  },
  -- BEGIN VERBATIM
  use_simple = {
    name_base = 'remove all non-unique monsters in radius 20, taking 1d3 damage for each monster removed',
    use = function(self, who)
      local ret = spell.genocide(who, nil, 20, 3)
      return { used=true, destroy=true, id=ret }
    end,
  },
  in_trap = {
    side_effect = function(self, _, x, y, who)
      spell.genocide({x=x,y=y}, nil, 1)
    end,
    side_effect_desc = 'removes all non-unique monsters within radius 1 of the trap',
  },
  -- END VERBATIM
}

newEntity {
  base = 'SCROLL_BASE',
  define_as = 'SCRL_DETECT_INVISIBLE',
  name = 'SCRL_DETECT_INVISIBLE',
  display_name = 'Detect Invisible',
  desc = 'A minor detection spell is stored in this scroll, showing you the locations of otherwise unseen beings for a brief moment.',
  sval = 30,
  image = 'object/scroll_placeholder.png',
  level = 1,
  cost = 15,
  allocation = { { level=1, rarity=1 } },
  -- BEGIN VERBATIM
  use_simple = {
    name_base = 'detect nearby objects',
    use = function(self, who)
      local det = spell.detect_invisible_monsters(25, who)
      return { used=true, destroy=true, id=det }
    end,
  },
  -- END VERBATIM
}

newEntity {
  base = 'SCROLL_BASE',
  define_as = 'SCRL_AGGRAVATE_MONSTER',
  name = 'SCRL_AGGRAVATE_MONSTER',
  display_name = 'Aggravate Monster',
  desc = 'This nasty scroll will make a loud noise, waking up foes in your vicinity.',
  sval = 1,
  image = 'object/scroll_placeholder.png',
  level = 5,
  cost = 0,
  allocation = { { level=5, rarity=1 } },
  -- BEGIN VERBATIM
  use_simple = {
    name_base = 'aggravate nearby monsters',
    use = function(self, who)
      spell.aggravate_near(who)
      return { used=true, destroy=true, id=true }
    end,
  },
  in_trap = {
    side_effect = function(self, _, x, y, who) spell.aggravate_near(who) end,
    side_effect_desc = 'aggravates nearby monsters',
  },
  -- END VERBATIM
}

newEntity {
  base = 'SCROLL_BASE',
  define_as = 'SCRL_TRAP_CREATION',
  name = 'SCRL_TRAP_CREATION',
  display_name = 'Trap Creation',
  desc = 'If you read this rather annoying scroll, snares and pitfalls will magically be planted all around you, ready to do nasty things to you once you walk onto them.',
  sval = 7,
  image = 'object/scroll_placeholder.png',
  level = 10,
  cost = 0,
  allocation = { { level=10, rarity=1 } },
  -- BEGIN VERBATIM
  use_simple = {
    name_base = 'create traps around you',
    use = function(self, who)
      spell.ball_spell(who, nil, DamageType.MAKE_TRAP, 1, 1, who.x, who.y)
      return { used=true, destroy=true, id=false }
    end,
  },
  -- END VERBATIM
}

newEntity {
  base = 'SCROLL_BASE',
  define_as = 'SCRL_TRAP_DOOR_DESTRUCTION',
  name = 'SCRL_TRAP_DOOR_DESTRUCTION',
  display_name = 'Trap/Door Destruction',
  desc = 'A very specifically destructive spell is written on this scroll. It will smash all traps and all doors immediately next to you.',
  sval = 39,
  image = 'object/scroll_placeholder.png',
  level = 10,
  cost = 50,
  allocation = { { level=10, rarity=1 } },
  -- BEGIN VERBATIM
  use_simple = {
    name_base = 'destroy adjacent traps and doors',
    use = function(self, who)
      spell.ball_spell(who, nil, DamageType.KILL_DOOR, 1, 1, who.x, who.y)
      spell.ball_spell(who, nil, DamageType.KILL_TRAP, 1, 1, who.x, who.y)
      return { used=true, destroy=true, id=true }
    end,
  },
  -- END VERBATIM
}

newEntity {
  base = 'SCROLL_BASE',
  define_as = 'SCRL_ARTIFACT_CREATION',
  name = 'SCRL_ARTIFACT_CREATION',
  display_name = 'Artifact Creation',
  desc = 'The mighty magic on this scroll will imbue a mundane item you possess with supernatural powers, also rendering the object indestructible.',
  sval = 52,
  image = 'object/scroll_placeholder.png',
  level = 70,
  cost = 200000,
  allocation = { { level=70, rarity=16 } },
  -- BEGIN VERBATIM
  use_simple = {
    name_base = 'transform a non-ego, non-artifact item into an artifact',
    use = function(self, who)
      local function filter_cb(o)
	return not o:isEgo() and not o:isArtifact() and o:getNumber() == 1
      end
      local function action_cb(o, _, _, _, _, _)
	if not o then
	  who:talentDialogReturn({ id=true })
	  return false
	end
	obj_util.convert_to_randart(o, true)
	who:sortInven()
	if who.recalcEverything then who:recalcEverything() end
	who:talentDialogReturn({ id=true, used=true, destroy=true, art=o })
	return false
      end
      local ShowEquipInvenFloor = require 'mod.dialogs.ShowEquipInvenFloor'
      local ret = who:talentDialog(ShowEquipInvenFloor.new('Create Artifact', who, filter_cb, action_cb))
      if ret and ret.art then
	local function name_cb(text) who:talentDialogReturn(text) end
	local text = who:talentDialog(ui_util.get_text('Artifact Name', 'Choose a name for your new artifact', 2, 25, name_cb))
	if text then ret.art.artifact_name = util.alchemy.cleanup_artifact_name(text, who) end
	ret.art = nil
      end
      return ret or { id=true }
    end,
  },
  -- END VERBATIM
}

newEntity {
  base = 'SCROLL_BASE',
  define_as = 'SCRL_RECHARGING',
  name = 'SCRL_RECHARGING',
  display_name = 'Recharging',
  desc = 'This scroll is inscribed with a spell releasing the enchantments used to give wands and staves their power, allowing you to replenish their spent charges.',
  sval = 22,
  image = 'object/scroll_placeholder.png',
  level = 40,
  cost = 200,
  allocation = { { level=40, rarity=1 } },
  -- BEGIN VERBATIM
  use_simple = {
    name_base = 'recharge a wand/staff/rod (power 60)',
    use = function(self, who)
      local ret = obj_util.recharge(who, 60)
      return { used=ret, destroy=ret, id=true }
    end,
  },
  -- END VERBATIM
}

newEntity {
  base = 'SCROLL_BASE',
  define_as = 'SCRL_GENOCIDE',
  name = 'SCRL_GENOCIDE',
  display_name = 'Genocide',
  desc = 'This rare and powerful scroll will annihilate all members of a specified race of monsters in your current location, but this will also exact a price of pain from you.',
  sval = 44,
  image = 'object/scroll_placeholder.png',
  level = 40,
  cost = 750,
  allocation = {
    { level=40, rarity=4 },
    { level=80, rarity=4 },
  },
  -- BEGIN VERBATIM
  use_simple = {
    name_base = 'remove all non-unique monsters of a selected type from the level, taking 1d4 damage for each monster removed',
    use = function(self, who)
      local ret = spell.genocide(who, 'target', nil, 4)
      return { used=ret, destroy=ret, id=true }
    end,
  },
  in_trap = {
    side_effect = function(self, _, x, y, who)
      if who.display then spell.genocide({x=x,y=y}, who.display) end
    end,
    side_effect_desc = 'removes all non-unique monsters of the type of the target from the level',
  },
  -- END VERBATIM
}

newEntity {
  base = 'SCROLL_BASE',
  define_as = 'SCRL_DARKNESS',
  name = 'SCRL_DARKNESS',
  display_name = 'Darkness',
  desc = 'This scroll will create a blast of utter darkness, which then fades to leave the immediate surroundings in a lasting gloom. The extreme darkness can blind those who are not used to it.',
  sval = 0,
  image = 'object/scroll_placeholder.png',
  level = 1,
  cost = 0,
  allocation = { { level=1, rarity=1 } },
  -- BEGIN VERBATIM
  use_simple = {
    name_base = 'permanently darken your immediate surroundings and induce temporary blindness',
    use = function(self, who)
      if not who:resistDam(DamageType.BLIND) and not who:resistDam(DamageType.DARK) then
	who:setEffect(who.EFF_BLIND, 3 + rng.range(1, 5), {merge='combine'})
      end
      return { used=true, destroy=true, id=true }
    end,
  },
  in_trap = {
    damtype=DamageType.DARK_WEAK, dam=10, r=3,
    side_effect = function(self, _, x, y, _) spell.unlite_room(x, y) end,
    side_effect_desc = 'darkens the room',
  },
  -- END VERBATIM
}

newEntity {
  base = 'SCROLL_BASE',
  define_as = 'SCRL_PROTECTION_FROM_EVIL',
  name = 'SCRL_PROTECTION_FROM_EVIL',
  display_name = 'Protection from Evil',
  desc = 'Upon reading the runes on this piece of paper, a faint aura of holiness will spring into existence around you, protecting you from blows of evil creatures, unless they are more powerful than you.',
  sval = 37,
  image = 'object/scroll_placeholder.png',
  level = 30,
  cost = 250,
  allocation = { { level=30, rarity=1 } },
  -- BEGIN VERBATIM
  use_simple = {
    name_base = 'confer protection from evil',
    use = function(self, who)
      who:setEffect(who.EFF_PROTECT_EVIL, rng.range(1, 25) + 3*who.level, {merge='combine'})
      return { used=true, destroy=true, id=true }
    end,
  },
  -- END VERBATIM
}

newEntity {
  base = 'SCROLL_BASE',
  define_as = 'SCRL_SATISFY_HUNGER',
  name = 'SCRL_SATISFY_HUNGER',
  display_name = 'Satisfy Hunger',
  desc = 'Reading this scroll will transport a good portion of nourishing gruel directly into your stomach. Some people say that this is a ploy of a food producer whose food nobody wants to eat.',
  sval = 32,
  image = 'object/scroll_placeholder.png',
  level = 5,
  cost = 10,
  allocation = {
    { level=5, rarity=1 },
    { level=20, rarity=1 },
    { level=50, rarity=1 },
    { level=75, rarity=1 },
  },
  -- BEGIN VERBATIM
  use_simple = {
    name_base = 'satiate yourself',
    use = function(self, who)
      local learn = who:setFood(util.FOOD.max - 1)
      return { used=true, destroy=true, id=learn }
    end,
  },
  -- END VERBATIM
}

newEntity {
  base = 'SCROLL_BASE',
  define_as = 'SCRL_DISPEL_UNDEAD',
  name = 'SCRL_DISPEL_UNDEAD',
  display_name = 'Dispel Undead',
  desc = 'A powerful exorcism is inscribed on this scroll. When read it will hurt undead abominations nearby, possibly even destroying them.',
  sval = 42,
  image = 'object/scroll_placeholder.png',
  level = 40,
  cost = 200,
  allocation = { { level=40, rarity=1 } },
  -- BEGIN VERBATIM
  use_simple = {
    name_base = 'do 60 damage to all undead creatures in line of sight',
    use = function(self, who)
      local ret, seen = spell.los_spell(who, nil, DamageType.DISP_UNDEAD, 60)
      return { used=true, destroy=true, id=seen }
    end,
  },
  in_trap = { damtype=DamageType.DISP_UNDEAD, dam=60, r=5 },
  -- END VERBATIM
}

newEntity {
  base = 'SCROLL_BASE',
  define_as = 'SCRL_XTRA_ENCHANT_WEAPON',
  name = 'SCRL_XTRA_ENCHANT_WEAPON',
  display_name = '*Enchant Weapon*',
  desc = 'Reading this scroll will magically infuse a weapon of your choice, making it more effective in combat.',
  sval = 21,
  image = 'object/scroll_placeholder.png',
  level = 50,
  cost = 500,
  allocation = { { level=50, rarity=1 } },
  -- BEGIN VERBATIM
  use_simple = {
    name_base = [[increase a weapon's to-hit and damage bonuses]],
    use = function(self, who)
      local function filter(o) return o.type == 'weapon' end
      local ret = spell.enchant_item(who, 'Enchant Weapon', filter, {to_h=rng.range{1,3}, to_d=rng.range(1,3)})
      return ret and { id=true, used=true, destroy=true } or { id=true }
    end,
  },
  -- END VERBATIM
}

newEntity {
  base = 'SCROLL_BASE',
  define_as = 'SCRL_CURSE_WEAPON',
  name = 'SCRL_CURSE_WEAPON',
  display_name = 'Curse Weapon',
  desc = 'This scroll will ruin your weapon beyond repair. Only weapons of legend have a hope of escaping destruction, but even they will often be shattered.',
  sval = 3,
  image = 'object/scroll_placeholder.png',
  level = 50,
  cost = 0,
  allocation = { { level=50, rarity=1 } },
}

newEntity {
  base = 'SCROLL_BASE',
  define_as = 'SCRL_XTRA_ENCHANT_ARMOUR',
  name = 'SCRL_XTRA_ENCHANT_ARMOUR',
  display_name = '*Enchant Armour*',
  desc = 'This scroll will place a great enchantment on a piece of armour of your choice, making it much better at protecting you. Mark that improving armours which are already highly enchanted is very difficult and will often fail.',
  sval = 20,
  image = 'object/scroll_placeholder.png',
  level = 50,
  cost = 500,
  allocation = {
    { level=50, rarity=1 },
    { level=50, rarity=1 },
  },
  -- BEGIN VERBATIM
  use_simple = {
    name_base = [[increase an armor piece's armor bonus]],
    use = function(self, who)
      local function filter(o) return o.type == 'armor' end
      local ret = spell.enchant_item(who, 'Enchant Armor', filter, {to_a=rng.range(3,5)})
      return ret and { id=true, used=true, destroy=true } or { id=true }
    end,
  },
  -- END VERBATIM
}

newEntity {
  base = 'SCROLL_BASE',
  define_as = 'SCRL_CURSE_ARMOUR',
  name = 'SCRL_CURSE_ARMOUR',
  display_name = 'Curse Armour',
  desc = [[This scroll bears a curse that will tear your armour to shreds. Don't read it!]],
  sval = 2,
  image = 'object/scroll_placeholder.png',
  level = 50,
  cost = 0,
  allocation = { { level=50, rarity=1 } },
}

newEntity {
  base = 'SCROLL_BASE',
  define_as = 'SCRL_SUMMON_UNDEAD',
  name = 'SCRL_SUMMON_UNDEAD',
  display_name = 'Summon Undead',
  desc = 'These spells scribed by ancient necromancers will call their horrible creatures to haunt you.',
  sval = 5,
  image = 'object/scroll_placeholder.png',
  level = 15,
  cost = 0,
  allocation = { { level=15, rarity=1 } },
  -- BEGIN VERBATIM
  use_simple = {
    name_base = 'summon 1-3 hostile undead creatures',
    use = function(self, who)
      local f = { not_properties={'unique'}, deep_flags={flags={UNDEAD=true}} }
      local ret = spell.summon(self, who.x, who.y, f, rng.range(1, 3))
      return { used=true, destroy=true, id=(#ret > 0) }
    end,
  },
  in_trap = {
    side_effect = function(self, _, x, y, who)
      local f = { not_properties={'unique'}, deep_flags={flags={UNDEAD=true}} }
      spell.summon(self, who.x, who.y, f, rng.range(1, 3))
    end,
    side_effect_desc = 'summons 1-3 undead creatures hostile to the target',
  },
  -- END VERBATIM
}

newEntity {
  base = 'SCROLL_BASE',
  define_as = 'SCRL_BLESSING',
  name = 'SCRL_BLESSING',
  display_name = 'Blessing',
  desc = 'The recitation of this scroll will grant you a blessing of the Valar, making you more confident in attack and defence for a few moments.',
  sval = 33,
  image = 'object/scroll_placeholder.png',
  level = 1,
  cost = 15,
  allocation = { { level=1, rarity=1 } },
  -- BEGIN VERBATIM
  use_simple = {
    name_base = 'temporarly gain +5 AC and +1 to-hit',
    use = function(self, who)
      who:setEffect(who.EFF_BLESSED, rng.range(7, 18), {merge='combine'})
      return { used=true, destroy=true, id=true }
    end,
  },
  in_trap = { damtype=DamageType.HOLY_FIRE, dam={1,4}, r=0 },
  -- END VERBATIM
}

newEntity {
  base = 'SCROLL_BASE',
  define_as = 'SCRL_HOLY_CHANT',
  name = 'SCRL_HOLY_CHANT',
  display_name = 'Holy Chant',
  desc = [[This blessing will give you a holy warrior's prowess in battle for a while.]],
  sval = 34,
  image = 'object/scroll_placeholder.png',
  level = 10,
  cost = 40,
  allocation = { { level=10, rarity=1 } },
  -- BEGIN VERBATIM
  use_simple = {
    name_base = 'temporarly gain +5 AC and +1 to-hit',
    use = function(self, who)
      who:setEffect(who.EFF_BLESSED, rng.range(13, 36), {merge='combine'})
      return { used=true, destroy=true, id=true }
    end,
  },
  in_trap = { damtype=DamageType.HOLY_FIRE, dam={2,4}, r=0 },
  -- END VERBATIM
}

newEntity {
  base = 'SCROLL_BASE',
  define_as = 'SCRL_HOLY_PRAYER',
  name = 'SCRL_HOLY_PRAYER',
  display_name = 'Holy Prayer',
  desc = 'This incantation lets you fight as a warrior of Valinor for quite a while, supreme in attack and defence.',
  sval = 35,
  image = 'object/scroll_placeholder.png',
  level = 25,
  cost = 80,
  allocation = { { level=25, rarity=1 } },
  -- BEGIN VERBATIM
  use_simple = {
    name_base = 'temporarly gain +5 AC and +1 to-hit',
    use = function(self, who)
      who:setEffect(who.EFF_BLESSED, rng.range(25, 72), {merge='combine'})
      return { used=true, destroy=true, id=true }
    end,
  },
  in_trap = { damtype=DamageType.HOLY_FIRE, dam={4,4}, r=0 },
  -- END VERBATIM
}

newEntity {
  base = 'SCROLL_BASE',
  define_as = 'SCRL_WORD_OF_RECALL',
  name = 'SCRL_WORD_OF_RECALL',
  display_name = 'Word of Recall',
  desc = 'The spell on this scroll will slowly build an ethereal conduit to the town for you if you are in a dungeon, and into the dungeon if you are above ground. Upon completion, which takes a while, you will suddenly be translocated to the other place.',
  sval = 11,
  image = 'object/scroll_placeholder.png',
  level = 5,
  cost = 150,
  allocation = { { level=5, rarity=1 } },
  -- BEGIN VERBATIM
  use_simple = {
    name_base = 'recall to the last dungeon level or town you visited',
    use = function(self, who)
      if spell.set_recall(who, 21, 15) then
	return { used=true, destroy=true, id=true }
      else
	return { id=true }
      end
    end,
  },
  -- END VERBATIM
}

newEntity {
  base = 'SCROLL_BASE',
  define_as = 'SCRL_XTRA_DESTRUCTION',
  name = 'SCRL_XTRA_DESTRUCTION',
  display_name = '*Destruction*',
  desc = 'This scroll is inscribed with a mighty conjuration which wrecks the dungeon all around you. Monsters and objects will be annihilated by this blast; only completely indestructible things can withstand it.',
  sval = 41,
  image = 'object/scroll_placeholder.png',
  level = 40,
  cost = 250,
  allocation = { { level=40, rarity=1 } },
  -- BEGIN VERBATIM
  use_simple = {
    name_base = 'destroy the area around you',
    use = function(self, who)
      spell.destroy_area(who.x, who.y, 15, true, false)
      return { used=true, destroy=true, id=true }
    end,
  },
  in_trap = {
    side_effect = function(self, _, x, y, who)
      spell.destroy_area(x, y, 15, true, false)
    end,
    side_effect_desc = 'destroy the area around the trap',
  },
  -- END VERBATIM
}

newEntity {
  base = 'SCROLL_BASE',
  define_as = 'SCRL_NOTHING',
  name = 'SCRL_NOTHING',
  display_name = 'Nothing',
  sval = 53,
  image = 'object/scroll_placeholder.png',
  level = 1,
  cost = 2,
  allocation = { { level=1, rarity=1 } },
  -- BEGIN VERBATIM
  -- This should make Scrolls of Nothing unactivatable.
  use_simple = table.NIL_MERGE,
  -- END VERBATIM
}

newEntity {
  base = 'SCROLL_BASE',
  define_as = 'SCRL_SUMMON_NEVER_MOVING_PET',
  name = 'SCRL_SUMMON_NEVER_MOVING_PET',
  display_name = 'Summon Never-Moving Pet',
  desc = 'A piece of paper, inscribed with runes which will summon an immobile creature to your aid.',
  sval = 6,
  image = 'object/scroll_placeholder.png',
  level = 5,
  cost = 125,
  allocation = {
    { level=5, rarity=1 },
    { level=15, rarity=1 },
    { level=25, rarity=1 },
    { level=35, rarity=1 },
    { level=65, rarity=1 },
    { level=85, rarity=1 },
    { level=95, rarity=1 },
  },
  -- BEGIN VERBATIM
  use_simple = {
    name_base = 'summon a friendly never-moving creature',
    use = function(self, who)
      local f = { not_properties={'unique'}, deep_flags={flags={NEVER_MOVE=true}} }
      local mons = spell.summon(who, who.x, who.y, f)
      return { used=true, destroy=true, id=(mons and #mons > 0) }
    end,
  },
  -- END VERBATIM
}

newEntity {
  base = 'SCROLL_BASE',
  define_as = 'SCRL_CRAFTSMANSHIP',
  name = 'SCRL_CRAFTSMANSHIP',
  display_name = 'Craftsmanship',
  desc = 'A powerful scroll, desired by many, as it can magically improve the special powers of magical weaponry.',
  sval = 19,
  image = 'object/scroll_placeholder.png',
  level = 80,
  cost = 200000,
  allocation = { { level=80, rarity=16 } },
  -- BEGIN VERBATIM
  use_simple = {
    name_base = [[increase a weapon's pval bonus]],
    use = function(self, who)
      local function filter(o) return o.type == 'weapon' end
      local ret = spell.enchant_item(who, 'Craftsmanship', filter, {pval=1})
      return ret and { id=true, used=true, destroy=true } or { id=true }
    end,
  },
  -- END VERBATIM
}

newEntity {
  base = 'SCROLL_BASE',
  define_as = 'SCRL_RESET_RECALL',
  name = 'SCRL_RESET_RECALL',
  display_name = 'Reset Recall',
  desc = 'A strange formula is inscribed on this scroll, which allows you to define another place as the location to which recalls shall move you.',
  sval = 23,
  image = 'object/scroll_placeholder.png',
  level = 20,
  cost = 125,
  allocation = {
    { level=20, rarity=1 },
    { level=25, rarity=1 },
    { level=35, rarity=1 },
  },
}

newEntity {
  base = 'SCROLL_BASE',
  define_as = 'SCRL_DIVINATION',
  name = 'SCRL_DIVINATION',
  display_name = 'Divination',
  desc = 'This scroll is inscribed with a ritual which allows you to discern what fate holds in store for you.',
  sval = 31,
  image = 'object/scroll_placeholder.png',
  level = 20,
  cost = 600,
  allocation = {
    { level=30, rarity=1 },
    { level=45, rarity=1 },
    { level=55, rarity=1 },
  },
  -- BEGIN VERBATIM
  use_simple = {
    name_base = 'reveal some of your unknown fate',
    use = function(self, who)
      local fate_desc = who:learnUnknownFate()
      if fate_desc then
	game.log('A message appears on the scroll.  It reads:')
	game.log(fate_desc)
      end
      local id = fate_desc and true or false
      return { id=id, used=true, destroy=true }
    end,
  },
  -- END VERBATIM
}

newEntity {
  base = 'SCROLL_BASE',
  define_as = 'SCRL_OLD_SCROLL_OF_DEINCARNATION',
  name = 'SCRL_OLD_SCROLL_OF_DEINCARNATION',
  display_name = '& Old Scroll~ of Deincarnation',
  desc = 'It allows you to leave your body to reincarnate into another one. However, your current body is lost in the process.',
  sval = 40,
  image = 'object/scroll_placeholder.png',
  level = 90,
  cost = 160000,
  norm_art = true,
  unique = 'SCRL_OLD_SCROLL_OF_DEINCARNATION',
  flags = { FULL_NAME=true, EASY_KNOW=table.NIL_MERGE },
  ignore_dam = { [DamageType.ACID]=true, [DamageType.ELEC]=true, [DamageType.FIRE]=true, [DamageType.COLD]=true },
  allocation = { { level=90, rarity=140 } },
  artifact_info = '70:51',
}

newEntity {
  base = 'SCROLL_BASE',
  define_as = 'SCRL_CRUMPLED_SCROLL_OF_MASS_RESURRECTION',
  name = 'SCRL_CRUMPLED_SCROLL_OF_MASS_RESURRECTION',
  display_name = '& Crumpled Scroll~ of Mass Resurrection',
  desc = 'This magical scroll sends a call to the halls of Mandos, issuing forth all those who have been slain by the reader.',
  sval = 43,
  image = 'object/scroll_placeholder.png',
  level = 55,
  cost = 0,
  norm_art = true,
  unique = 'SCRL_CRUMPLED_SCROLL_OF_MASS_RESURRECTION',
  flags = { FULL_NAME=true, EASY_KNOW=table.NIL_MERGE },
  ignore_dam = { [DamageType.FIRE]=true, [DamageType.ACID]=true, [DamageType.COLD]=true, [DamageType.ELEC]=true },
  allocation = { { level=55, rarity=1 } },
  artifact_info = '70:1',
}
-- 54 total items
-- level:  0=3; 1=8; 10=5; 100=1; 15=4; 20=4; 25=1; 30=2; 40=4; 5=8; 50=8; 55=1; 60=1; 70=1; 75=1; 80=1; 90=1
-- cost:  0=8; 10=2; 100=1; 1000=3; 10000=1; 100000=1; 125=5; 15=6; 150=1; 160000=1; 2=1; 200=2; 200000=3; 250=2; 30=1; 35=2; 40=3; 50=3; 500=3; 5000=1; 600=1; 750=1; 80=1; 8000=1
-- artifact_info:  70:1=1; 70:51=1
