-- $Id: tome2.lua 2835 2017-04-11 00:13:59Z dsb $
-- ToME - Tales of Middle-Earth
-- Copyright © 2012-2017 Scott Bigham
--
-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
-- Scott Bigham "Zizzo"
-- dsb-tome@killerbunnies.org

defineAction {
  default = { 'sym:=o:false:false:false:false' },
  type = 'OPEN',
  group = 'actions',
  name = 'Open door or chest',
}

defineAction {
  default = { 'sym:_r:false:true:false:false' },
  type = 'REST_TIMED',
  group = 'debug',
  name = 'Rest for a specific number of turns',
}

defineAction {
  default = { 'sym:_s:false:true:false:false' },
  type = 'SEARCH',
  group = 'actions',
  name = 'Search for traps or secret doors in adjacent grids',
}

defineAction {
  default = { 'sym:_d:false:true:false:false' },
  type = 'DISARM',
  group = 'actions',
  name = 'Disarm traps in an adjacent grid',
}

defineAction {
  default = { 'sym:_d:true:true:false:false' },
  type = 'FORCE_TRIGGER',
  group = 'actions',
  name = 'Deliberately trigger a trap in an adjacent grid',
}

defineAction {
  default = { 'sym:_t:true:false:false:false' },
  type = 'USE_THAUMATURGY',
  group = 'actions',
  name = 'Use Thaumaturgy spells',
}

defineAction {
  default = { "sym:_LEFT:true:false:false:false", "sym:_KP_4:true:false:false:false" },
  type = "TUNNEL_LEFT",
  group = "actions",
  name = "Tunnel left",
}
defineAction {
  default = { "sym:_RIGHT:true:false:false:false", "sym:_KP_6:true:false:false:false" },
  type = "TUNNEL_RIGHT",
  group = "actions",
  name = "Tunnel right",
}
defineAction {
  default = { "sym:_UP:true:false:false:false", "sym:_KP_8:true:false:false:false" },
  type = "TUNNEL_UP",
  group = "actions",
  name = "Tunnel up",
}
defineAction {
  default = { "sym:_DOWN:true:false:false:false", "sym:_KP_2:true:false:false:false" },
  type = "TUNNEL_DOWN",
  group = "actions",
  name = "Tunnel down",
}
defineAction {
  default = { "sym:_KP_7:true:false:false:false" },
  type = "TUNNEL_LEFT_UP",
  group = "actions",
  name = "Tunnel diagonally left and up",
}
defineAction {
  default = { "sym:_KP_9:true:false:false:false" },
  type = "TUNNEL_RIGHT_UP",
  group = "actions",
  name = "Tunnel diagonally right and up",
}
defineAction {
  default = { "sym:_KP_1:true:false:false:false" },
  type = "TUNNEL_LEFT_DOWN",
  group = "actions",
  name = "Tunnel diagonally left and down",
}
defineAction {
  default = { "sym:_KP_3:true:false:false:false" },
  type = "TUNNEL_RIGHT_DOWN",
  group = "actions",
  name = "Tunnel diagonally right and down",
}

-- We subsume the contents of the engine's keybinds/debug.lua below, so
-- that we can install a default for DEBUG_MODE.

defineAction {
  default = { 'sym:_l:true:false:false:false' },
  type = "LUA_CONSOLE",
  group = "debug",
  name = "Show Lua console",
  only_on_cheat = true,
}

defineAction {
  default = { 'sym:_d:true:true:true:false' },
  type = "DEBUG_MODE",
  group = "debug",
  name = "Debug Mode",
  only_on_cheat = true,
}
