-- $Id: possession.lua 2835 2017-04-11 00:13:59Z dsb $
-- ToME - Tales of Middle-Earth
-- Copyright © 2012-2017 Scott Bigham
--
-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
-- Scott Bigham "Zizzo"
-- dsb-tome@killerbunnies.org

local Entity = require 'engine.Entity'

newTalentType {
  name = 'Possession powers',
  type = 'skill/possession',
  description = 'Talents conferred by the Possession skill',
}

newTalent {
  name = [[Deincarnate]],
  short_name = 'POSS_DEINCARNATE',
  display_entity = Entity.new { image='talents/deincarnate.png' },
  type = 'skill/possession',
  mode = 'activated',
  is_spell = true,
  points = 0,
  action = function(self, t)
    game.log('Sorry, not implemented (POSS_DEINCARNATE)')
  end,
  info = [[Watch this space]],
}

newTalent {
  name = [[Possess]],
  short_name = 'POSS_INCARNATE',
  display_entity = Entity.new { image='talents/possess.png' },
  type = 'skill/possession',
  mode = 'activated',
  is_spell = true,
  points = 0,
  action = function(self, t)
    game.log('Sorry, not implemented (POSS_INCARNATE)')
  end,
  info = [[Watch this space]],
}
