-- $Id: demonology.lua 2837 2017-04-11 23:37:30Z dsb $
-- ToME - Tales of Middle-Earth
-- Copyright © 2012-2017 Scott Bigham
--
-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
-- Scott Bigham "Zizzo"
-- dsb-tome@killerbunnies.org

-- -----------------------------------------------------------------------
-- WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING
-- -----------------------------------------------------------------------
-- This file was generated automatically by the 'gen_spells' Perl script.
-- DO NOT MODIFY THIS FILE DIRECTLY, as any changes will be lost the next
-- time the file is generated (with the possible exception of lines between
-- 'BEGIN VERBATIM' and 'END VERBATIM' markers, if supported by the script).
-- -----------------------------------------------------------------------
-- WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING
-- -----------------------------------------------------------------------

-- Spell talents generated from T2's s_demon.lua

local Entity = require 'engine.Entity'

newTalentType {
  name = 'Demonology spells',
  type = 'spell/demonology',
  description = 'Spells from the Demonology school',
}

newTalent {
  name = [[Doom Shield]],
  short_name = 'DOOM_SHIELD',
  display_entity = Entity.new { image='talents/doom_shield.png' },
  type = 'spell/demonology',
  mode = 'activated',
  is_spell = true,
  skill = 'DEMONOLOGY',
  skill_level = 1,
  mana = spell.mana_cost,
  min_mana = 2,
  max_mana = 30,
  base_fail = 10,
  stat = 'INT',
  points = 0,
  range = 18,
  direct_hit = true,
  action = function(self, t)
    local base_dur = 20 + spell.get_spell_level(self, t, 100)
    local ac = -300 + spell.get_spell_level(self, t, 100)
    local dd, ds = t.dmg_dice(self, t)
    local p = {
      power = ac,
      on_melee_hit = { type=DamageType.PHYSICAL, dice={dd,ds} },
      shield_name = 'Doom Shield',
    }
    self:setEffect(self.EFF_SHIELD, base_dur+rng.range(1,10), p)
    return true
  end,
  info = function(self, t)
    local base_dur = 20 + spell.get_spell_level(self, t, 100)
    local ac = -300 + spell.get_spell_level(self, t, 100)
    local dd, ds = t.dmg_dice(self, t)
    local pf = util.colorize_damtype(DamageType.PHYSICAL)
    local sfx = spell.spell_skill_desc(self, t)
    local ret = [[Raises a mirror of pain around you for %d+1d10 turns, doing %dd%d %s damage to your foes that dare hit you, but reducing your AC by %d.  Damage and duration will increase, and AC reduction will decrease,%s]]
    return ret:format(base_dur, dd, ds, pf, -ac, sfx)
  end,
  -- BEGIN VERBATIM
  dmg_dice = function(self, t)
    local dd = 1 + spell.get_spell_level(self, t, 14)
    local ds = 10 + spell.get_spell_level(self, t, 15)
    return dd, ds
  end,
  -- END VERBATIM
}

newTalent {
  name = [[Demon Blade]],
  short_name = 'DEMON_BLADE',
  display_entity = Entity.new { image='talents/demon_blade.png' },
  type = 'spell/demonology',
  mode = 'activated',
  is_spell = true,
  skill = 'DEMONOLOGY',
  skill_level = 1,
  mana = spell.mana_cost,
  min_mana = 4,
  max_mana = 44,
  base_fail = 10,
  stat = 'INT',
  stick = {
    type = 'utility/wand',
    charge = { 3, 7 },
    rarity = 75,
    base_level = { 1, 17 },
    max_level = { 20, 40 },
  },
  points = 0,
  range = 18,
  direct_hit = true,
  action = function(self, t)
    local lev = spell.get_spell_level(self, t)
    local dur = rng.range(1, 20) + spell.get_spell_level(self, t, 80)
    local dt = lev >= 30 and DamageType.HELL_FIRE or DamageType.FIRE
    local dam = 4 + spell.get_spell_level(self, t, 40)
    local r = lev >= 45 and 1 or 0
    local p = { dt=dt, damage=dam, radius=r }
    self:setEffect(self.EFF_WEAPON_PROJECT, dur, p)
    return true
  end,
  info = function(self, t)
    local base_dur = spell.get_spell_level(self, t, 80)
    local dam = 4 + spell.get_spell_level(self, t, 40)
    local ff = util.colorize_damtype(DamageType.FIRE)
    local hff = util.colorize_damtype(DamageType.HELL_FIRE)
    local sfx = spell.spell_skill_desc(self, t)
    local ret = [[Imbues your blade with fire.  Your weapon will deal %d additional %s damage per hit for %d+1d20 turns.  At level 30 the damage will become %s.  At level 45, the damage will burst over a radius-1 area around the monster hit.  Damage will increase%s]]
    return ret:format(dam, ff, base_dur, hff, sfx)
  end,
}

newTalent {
  name = [[Summon Demon]],
  short_name = 'SUMMON_DEMON',
  display_entity = Entity.new { image='talents/summon_demon.png' },
  type = 'spell/demonology',
  mode = 'activated',
  is_spell = true,
  skill = 'DEMONOLOGY',
  skill_level = 5,
  mana = spell.mana_cost,
  min_mana = 10,
  max_mana = 50,
  base_fail = 30,
  stat = 'INT',
  points = 0,
  range = 18,
  direct_hit = true,
  action = function(self, t)
    local lev = spell.get_spell_level(self, t)
    local m_lev = 5 + spell.get_spell_level(self, t, 100)
    local d_lev = math.max(game.zone:level_adjust_level(game.level), 4)
    local f = { not_properties={'unique'}, deep_flags={flags={DEMON=true}} }
    if lev >= 35 then f.display = 'U' end
    local mons = spell.summon(self, self.x, self.y, f, 1, dlev)
    if mons then
      for _, m in ipairs(mons) do m:forceLevelup(m_lev) end
    else
      game.logPlayer(self, 'Something blocks your summoning!')
    end
  end,
  info = function(self, t)
    local m_lev = 5 + spell.get_spell_level(self, t, 100)
    local sfx = spell.spell_skill_desc(self, t)
    local ret = [[Summons a demon to your side, leveled to level %d.  At level 35, it summons a high demon.  Leveling will increase%s]]
    return ret:format(m_lev, sfx)
  end,
}

newTalent {
  name = [[Discharge Minion]],
  short_name = 'DISCHARGE_MINION',
  display_entity = Entity.new { image='talents/discharge_minion.png' },
  type = 'spell/demonology',
  mode = 'activated',
  is_spell = true,
  skill = 'DEMONOLOGY',
  skill_level = 10,
  mana = spell.mana_cost,
  min_mana = 20,
  max_mana = 50,
  base_fail = 30,
  stat = 'INT',
  points = 0,
  range = 18,
  direct_hit = true,
  action = function(self, t)
			local ret, x, y, c_ptr
			ret, x, y = tgt_pt()
			if ret == FALSE then return end
			c_ptr = cave(y, x)

			-- ok that is a monster
			if c_ptr.m_idx > 0 then
				local m_ptr = monster(c_ptr.m_idx)
				if m_ptr.status ~= MSTATUS_PET then
					msg_print("You can only target a pet.")
					return
				end

				local dam = m_ptr.hp
				delete_monster_idx(c_ptr.m_idx)
				dam = (dam * (20 + get_level(DISCHARGE_MINION, 60, 0))) / 100
				if dam > 100 + get_level(DISCHARGE_MINION, 500, 0) then
					dam = 100 + get_level(DISCHARGE_MINION, 500, 0)
				end

				-- We use project instead of fire_ball because we must tell it exactly where to land
				return project(0, 2,
					y, x,
					dam,
					GF_GRAVITY, bor(PROJECT_STOP, PROJECT_GRID, PROJECT_ITEM, PROJECT_KILL))
			end
	end,
  info = [[The targeted pet will explode in a burst of gravity]],
  info_aux = function(self, t)
			return "dam "..(20 + get_level(DISCHARGE_MINION, 60, 0)).."% max "..(100 + get_level(DISCHARGE_MINION, 500, 0))
	end,
}

newTalent {
  name = [[Demon Madness]],
  short_name = 'DEMON_MADNESS',
  display_entity = Entity.new { image='talents/demon_madness.png' },
  type = 'spell/demonology',
  mode = 'activated',
  is_spell = true,
  skill = 'DEMONOLOGY',
  skill_level = 10,
  mana = spell.mana_cost,
  min_mana = 5,
  max_mana = 20,
  base_fail = 25,
  stat = 'INT',
  requires_target = true,
  points = 0,
  range = 18,
  direct_hit = true,
  action = function(self, t)
    local lev = spell.get_spell_level(self, t)
    local dt = rng.table({ DamageType.CHAOS, DamageType.CONFUSION, DamageType.CHARM })
    local dam = 20 + spell.get_spell_level(self, t, 200)
    local r = 1 + spell.get_spell_level(self, t, 4, 0)
    local tg = { type='ball', range=self:getTalentRange(t), radius=r, talent=t, selffire=false }
    local x1, y1 = self:getTarget(tg)
    if not x1 or not y1 then return nil end
    local x2, y2 = self.x - (x1 - self.x), self.y - (y1 - self.y)
    self:project(tg, x1, y1, dt, dam)
    self:project(tg, x2, y2, dt, dam)
    return true
  end,
  info = function(self, t)
    local dam = 20 + spell.get_spell_level(self, t, 200)
    local r = 1 + spell.get_spell_level(self, t, 4, 0)
    local ccf = util.colorize_damtype(DamageType.CHAOS)
    local cff = util.colorize_damtype(DamageType.CONFUSION)
    local chf = util.colorize_damtype(DamageType.CHARM)
    local sfx = spell.spell_skill_desc(self, t)
    local ret = [[Fire two radius-%d balls in opposite directions, doing %d damage in %s, %s or %s with equal probability.  Radius and damage will increase%s]]
    return ret:format(r, dam, ccf, cff, chf, sfx)
  end,
}

newTalent {
  name = [[Demon Cloak]],
  short_name = 'DEMON_CLOAK',
  display_entity = Entity.new { image='talents/demon_cloak.png' },
  type = 'spell/demonology',
  mode = 'activated',
  is_spell = true,
  skill = 'DEMONOLOGY',
  skill_level = 20,
  mana = spell.mana_cost,
  min_mana = 10,
  max_mana = 40,
  base_fail = 70,
  stat = 'INT',
  points = 0,
  range = 18,
  direct_hit = true,
  action = function(self, t)
    local base_dur = 5 + spell.get_spell_level(self, t, 15, 0)
    self:setEffect(self.EFF_REFLECTION, base_dur+rng.range(1,5), {})
    return true
  end,
  info = function(self, t)
    local base_dur = 5 + spell.get_spell_level(self, t, 15, 0)
    local sfx = spell.spell_skill_desc(self, t)
    local ret = [[Raises a mirror that can reflect bolts and arrows for %d+1d5 turns.  Duration will increase%s]]
    return ret:format(base_dur, sfx)
  end,
}

newTalent {
  name = [[Demon Field]],
  short_name = 'DEMON_FIELD',
  display_entity = Entity.new { image='talents/demon_field.png' },
  type = 'spell/demonology',
  mode = 'activated',
  is_spell = true,
  skill = 'DEMONOLOGY',
  skill_level = 20,
  mana = spell.mana_cost,
  min_mana = 20,
  max_mana = 60,
  base_fail = 60,
  stat = 'INT',
  requires_target = true,
  points = 0,
  range = 18,
  direct_hit = true,
  action = function(self, t)
    local dam = 20 + spell.get_spell_level(self, t, 70)
    local dur = 30 + spell.get_spell_level(self, t, 100)
    return spell.cloud_spell(self, t, DamageType.NEXUS, dam, 7, dur)
  end,
  info = function(self, t)
    local dam = 20 + spell.get_spell_level(self, t, 70)
    local dur = 30 + spell.get_spell_level(self, t, 100)
    local sfx = spell.spell_skill_desc(self, t)
    local ret = [[Fires a deadly cloud of radius 7, doing %d damage per turn for %d turns.  Damage and duration will increase%s]]
    return ret:format(dam, dur, sfx)
  end,
}

newTalent {
  name = [[Control Demon]],
  short_name = 'CONTROL_DEMON',
  display_entity = Entity.new { image='talents/control_demon.png' },
  type = 'spell/demonology',
  mode = 'activated',
  is_spell = true,
  skill = 'DEMONOLOGY',
  skill_level = 25,
  mana = spell.mana_cost,
  min_mana = 30,
  max_mana = 70,
  base_fail = 55,
  stat = 'INT',
  requires_target = true,
  points = 0,
  range = 18,
  direct_hit = true,
  action = function(self, t)
    local pow = 50 + spell.get_spell_level(self, t, 250)
    return spell.hit_spell(self, t. DamageType.CONTROL_DEMON, pow)
  end,
  info = function(self, t)
    local pow = 50 + spell.get_spell_level(self, t, 250)
    local sfx = spell.spell_skill_desc(self, t)
    local ret = [[Attempts to control a demon (power %d).  Power will increase%s]]
    return ret:format(pow, sfx)
  end,
}

newTalent {
  name = [[Unholy Word]],
  short_name = 'UNHOLY_WORD',
  display_entity = Entity.new { image='talents/unholy_word.png' },
  type = 'spell/demonology',
  mode = 'activated',
  is_spell = true,
  skill = 'DEMONOLOGY',
  skill_level = 25,
  mana = spell.mana_cost,
  min_mana = 15,
  max_mana = 45,
  base_fail = 55,
  stat = 'INT',
  points = 0,
  range = 18,
  direct_hit = true,
  action = function(self, t)
			local ret, x, y, c_ptr
			ret, x, y = tgt_pt()
			if ret == FALSE then return end
			c_ptr = cave(y, x)

			-- ok that is a monster
			if c_ptr.m_idx > 0 then
				local m_ptr = monster(c_ptr.m_idx)
				if m_ptr.status ~= MSTATUS_PET then
					msg_print("You can only target a pet.")
					return
				end

				-- Oups he is angry now
				if magik(30 - get_level(UNHOLY_WORD, 25, 0)) == TRUE then
					local m_name = monster_desc(m_ptr, 0).." turns against you."
					msg_print(strupper(strsub(m_name, 0, 1))..strsub(m_name, 2))
				else
					local m_name = monster_desc(m_ptr, 0)
					msg_print("You consume "..m_name..".")

					local heal = (m_ptr.hp * 100) / m_ptr.maxhp
					heal = ((30 + get_level(UNHOLY_WORD, 50, 0)) * heal) / 100

					hp_player(heal)

					delete_monster_idx(c_ptr.m_idx)
				end
				return TRUE
			end
	end,
  info = [[Kills a pet to heal you There is a chance that the pet won't die but will turn against you it will decrease with higher level]],
  info_aux = function(self, t)
			return "heal mhp% of "..(30 + get_level(UNHOLY_WORD, 50, 0)).."%"
	end,
}
