-- $Id: divination.lua 2941 2017-06-20 02:16:32Z dsb $
-- ToME - Tales of Middle-Earth
-- Copyright © 2012-2017 Scott Bigham
--
-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
-- Scott Bigham "Zizzo"
-- dsb-tome@killerbunnies.org

-- -----------------------------------------------------------------------
-- WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING
-- -----------------------------------------------------------------------
-- This file was generated automatically by the 'gen_spells' Perl script.
-- DO NOT MODIFY THIS FILE DIRECTLY, as any changes will be lost the next
-- time the file is generated (with the possible exception of lines between
-- 'BEGIN VERBATIM' and 'END VERBATIM' markers, if supported by the script).
-- -----------------------------------------------------------------------
-- WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING
-- -----------------------------------------------------------------------

-- Spell talents generated from T2's s_divin.lua

local Entity = require 'engine.Entity'

newTalentType {
  name = 'Divination spells',
  type = 'spell/divination',
  description = 'Spells from the Divination school',
}

newTalent {
  name = [[Sense Monsters]],
  short_name = 'SENSE_MONSTERS',
  display_entity = Entity.new { image='talents/sense_monsters.png' },
  type = 'spell/divination',
  mode = 'activated',
  is_spell = true,
  skill = 'DIVINATION',
  skill_level = 1,
  mana = spell.mana_cost,
  min_mana = 1,
  max_mana = 20,
  base_fail = 10,
  stat = 'INT',
  random_book = 'MAGIC',
  inertia = { 1, 10 },
  stick = {
    type = 'utility/staff',
    charge = { 5, 10 },
    rarity = 37,
    base_level = { 1, 10 },
    max_level = { 15, 40 },
  },
  points = 0,
  range = 18,
  direct_hit = true,
  action = function(self, t)
    local r = 10 + spell.get_spell_level(self, t, 40, 0),
    spell.detect_monsters(r, self)
    if spell.get_spell_level(self, t) >= 30 then
      local dur = rng.range(11, 20) + spell.get_spell_level(self, t, 20)
      self:setEffect(self.EFF_SENSE_MONSTER, dur, {})
    end
    return true
  end,
  info = function(self, t)
    local r = 10 + spell.get_spell_level(self, t, 40, 0)
    local dur_base = 10 + spell.get_spell_level(self, t, 20)
    local sfx = spell.spell_skill_desc(self, t)
    local ret = [[Detects all monsters in a radius of %d around you.  At level 30 it also confers temporary ESP for %d+d10 turns.  Radius and duration will increase%s]]
    return ret:format(r, dur_base, sfx)
  end,
}

newTalent {
  name = [[Sense Hidden]],
  short_name = 'SENSE_HIDDEN',
  display_entity = Entity.new { image='talents/sense_hidden.png' },
  type = 'spell/divination',
  mode = 'activated',
  is_spell = true,
  skill = 'DIVINATION',
  skill_level = 5,
  mana = spell.mana_cost,
  min_mana = 2,
  max_mana = 10,
  base_fail = 25,
  stat = 'INT',
  random_book = 'MAGIC',
  inertia = { 1, 10 },
  stick = {
    type = 'utility/staff',
    charge = { 1, 15 },
    rarity = 20,
    base_level = { 1, 15 },
    max_level = { 10, 50 },
  },
  points = 0,
  range = 18,
  direct_hit = true,
  action = function(self, t)
    local r = 15 + spell.get_spell_level(self, t, 40, 0)
    spell.detect_traps(r, self)
    -- Optionally apply temporary see invisible.
    if spell.get_spell_level(self, t) >= 15 then
      local dur = rng.range(11, 30) + spell.get_spell_level(self, t, 40)
      self:setEffect(self.EFF_SEE_INVIS, dur, {})
    end
    return true
  end,
  info = function(self, t)
    local r = 15 + spell.get_spell_level(self, t, 40, 0)
    local dur = rng.range(11, 30) + spell.get_spell_level(self, t, 40)
    local sfx = spell.spell_skill_desc(self, t)
    local ret = [[Detects traps in a radius of %d around you.  At level 15, also confers temporary see invisible for %d+d20 turns.  Range and duration will increase%s]]
    return ret:format(r, dur, sfx)
  end,
}

newTalent {
  name = [[Identify]],
  short_name = 'IDENTIFY',
  display_entity = Entity.new { image='talents/identify.png' },
  type = 'spell/divination',
  mode = 'activated',
  is_spell = true,
  skill = 'DIVINATION',
  skill_level = 8,
  mana = spell.mana_cost,
  min_mana = 10,
  max_mana = 50,
  base_fail = 40,
  stat = 'INT',
  random_book = 'MAGIC',
  stick = {
    type = 'utility/staff',
    charge = { 7, 10 },
    rarity = 45,
    base_level = { 1, 15 },
    max_level = { 15, 40 },
  },
  points = 0,
  range = 18,
  direct_hit = true,
  action = function(self, t)
    local lev = spell.get_spell_level(self, t, 50)
    local r = lev < 27 and 0 or spell.get_spell_level(self, t, 3)
    if lev >= 17 then
      self:inventoryApplyAll(function(_, _, o) o:identify(true, self) end)
      spell.ball_spell(self, t, DamageType.IDENTIFY, 1, r, self.x, self.y)
      return true
    else
      return spell.identify_dialog(self, true, 'Select item to identify')
    end
  end,
  info = function(self, t)
    local r = spell.get_spell_level(self, t, 3)
    local sfx = spell.spell_skill_desc(self, t)
    local ret = [[Identifies a selected item in your inventory or equipment or on the floor.  At level 17, identifies all worn and carried items and all items on the floor beneath you.  At level 27, also identifies items on the floor at radius %d around you; radius will increase %s]]
    return ret:format(r, sfx)
  end,
}

newTalent {
  name = [[Reveal Ways]],
  short_name = 'REVEAL_WAYS',
  display_entity = Entity.new { image='talents/reveal_ways.png' },
  type = 'spell/divination',
  mode = 'activated',
  is_spell = true,
  skill = 'DIVINATION',
  skill_level = 9,
  mana = spell.mana_cost,
  min_mana = 3,
  max_mana = 15,
  base_fail = 20,
  stat = 'INT',
  random_book = 'MAGIC',
  inertia = { 1, 10 },
  stick = {
    type = 'utility/staff',
    charge = { 6, 6 },
    rarity = 35,
    base_level = { 1, 15 },
    max_level = { 25, 50 },
  },
  points = 0,
  range = 18,
  direct_hit = true,
  action = function(self, t)
    local r = 10 + spell.get_spell_level(self, t, 40, 0)
    spell.detect_doors_stairs(r, self)
    return true
  end,
  info = function(self, t)
    local r = 10 + spell.get_spell_level(self, t, 40, 0)
    local sfx = spell.spell_skill_desc(self, t)
    local ret = [[Detects doors, stairs and other level entrances and exits in a radius of %d around you.  Radius increases%s]]
    return ret:format(r, sfx)
  end,
}

newTalent {
  name = [[Vision]],
  short_name = 'VISION',
  display_entity = Entity.new { image='talents/vision.png' },
  type = 'spell/divination',
  mode = 'activated',
  is_spell = true,
  skill = 'DIVINATION',
  skill_level = 15,
  mana = spell.mana_cost,
  min_mana = 7,
  max_mana = 55,
  base_fail = 45,
  stat = 'INT',
  random_book = 'MAGIC',
  inertia = { 2, 200 },
  stick = {
    type = 'utility/staff',
    charge = { 4, 6 },
    rarity = 60,
    base_level = { 1, 5 },
    max_level = { 10, 30 },
  },
  points = 0,
  range = 18,
  direct_hit = true,
  action = function(self, t)
    if spell.get_spell_level(self, t) < 25 then
      self:computeFOV(40, 'block_sense', spell.map_area_callback, true, true, true)
    else
      local map = game.level.map
      map:liteAll(0, 0, map.w, map.h)
      map:rememberAll(0, 0, map.w, map.h)
    end
    return true
  end,
  info = function(self, t)
    return [[Reveals the layout of the surrounding area in a radius of 40.  At level 25, it maps and lights the entire level.]]
  end,
}

newTalent {
  name = [[Greater Identify]],
  short_name = 'FULL_IDENTIFY',
  display_entity = Entity.new { image='talents/greater_identify.png' },
  type = 'spell/divination',
  mode = 'activated',
  is_spell = true,
  skill = 'DIVINATION',
  skill_level = 35,
  mana = spell.mana_cost,
  min_mana = 30,
  max_mana = 30,
  base_fail = 80,
  stat = 'INT',
  random_book = 'MAGIC',
  points = 0,
  range = 18,
  direct_hit = true,
  action = function(self, t)
    local function yn_cb(ok) self:talentDialogReturn(ok) end
    local do_self = self:talentDialog(ui_util.yesnoPopup('Greater Identify', 'Cast spell on yourself?', yn_cb))
    if do_self then
      game.logPlayer(self, 'You begin to know yourself a little better...')
      spell.self_knowledge_dialog(who)
      return true
    else
      return spell.identify_dialog(self, 'full', 'Select item to fully identify')
    end
  end,
  info = function(self, t)
    return [[Reveals all information about a selected item in your inventory or equipment or on the floor.  Alternately, the spell can be cast directly on the caster, revealing the caster's powers.]]
  end,
}
