-- $Id: earth.lua 2835 2017-04-11 00:13:59Z dsb $
-- ToME - Tales of Middle-Earth
-- Copyright © 2012-2017 Scott Bigham
--
-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
-- Scott Bigham "Zizzo"
-- dsb-tome@killerbunnies.org

-- -----------------------------------------------------------------------
-- WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING
-- -----------------------------------------------------------------------
-- This file was generated automatically by the 'gen_spells' Perl script.
-- DO NOT MODIFY THIS FILE DIRECTLY, as any changes will be lost the next
-- time the file is generated (with the possible exception of lines between
-- 'BEGIN VERBATIM' and 'END VERBATIM' markers, if supported by the script).
-- -----------------------------------------------------------------------
-- WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING
-- -----------------------------------------------------------------------

-- Spell talents generated from T2's s_earth.lua

local Entity = require 'engine.Entity'

newTalentType {
  name = 'Earth spells',
  type = 'spell/earth',
  description = 'Spells from the Earth school',
}

newTalent {
  name = [[Stone Skin]],
  short_name = 'STONE_SKIN',
  display_entity = Entity.new { image='talents/stone_skin.png' },
  type = 'spell/earth',
  mode = 'activated',
  is_spell = true,
  skill = 'EARTH',
  skill_level = 1,
  mana = spell.mana_cost,
  min_mana = 1,
  max_mana = 50,
  base_fail = 10,
  stat = 'INT',
  random_book = 'MAGIC',
  inertia = { 2, 50 },
  points = 0,
  range = 18,
  direct_hit = true,
  action = function(self, t)
    local lev = spell.get_spell_level(self, t)
    local base_dur = 10 + spell.get_spell_level(self, t, 100)
    local ac = 10 + spell.get_spell_level(self, t, 50)
    local p = { power=ac }
    if lev >= 25 then
      local dd, ds = t.dmg_dice(self, t)
      p.on_melee_hit = { type=DamageType.PHYSICAL, dice={dd,ds} }
      p.shield_name = 'Stone Skin'
    end
    self:setEffect(self.EFF_SHIELD, base_dur+rng.range(1,10), p)
    return true
  end,
  info = function(self, t)
    local base_dur = 10 + spell.get_spell_level(self, t, 100)
    local ac = 10 + spell.get_spell_level(self, t, 50)
    local dd, ds = t.dmg_dice(self, t)
    local pf = util.colorize_damtype(DamageType.PHYSICAL)
    local sfx = spell.spell_skill_desc(self, t)
    local ret = [[Creates a shield of earth around you to protect you, increasing your AC by %d for %d+1d10 turns.  At level 25, it also deals %dd%d %s damage to attackers.  AC bonus, duration and damage will increase%s]]
    return ret:format(ac, base_dur, dd, ds, pf, sfx)
  end,
  -- BEGIN VERBATIM
  dmg_dice = function(self, t)
    local dd = 2 + spell.get_spell_level(self, t, 5)
    local ds = 3 + spell.get_spell_level(self, t, 5)
    return dd, ds
  end,
  -- END VERBATIM
}

newTalent {
  name = [[Dig]],
  short_name = 'DIG',
  display_entity = Entity.new { image='talents/dig.png' },
  type = 'spell/earth',
  mode = 'activated',
  is_spell = true,
  skill = 'EARTH',
  skill_level = 12,
  mana = spell.mana_cost,
  min_mana = 14,
  max_mana = 14,
  base_fail = 20,
  stat = 'INT',
  random_book = 'MAGIC',
  stick = {
    type = 'utility/wand',
    charge = { 15, 5 },
    rarity = 25,
    base_level = { 1, 1 },
    max_level = { 1, 1 },
  },
  requires_target = true,
  points = 0,
  range = 18,
  direct_hit = true,
  action = function(self, t)
    return spell.beam_spell(self, t, DamageType.KILL_WALL, 20 + rng.range(1, 30))
  end,
  info = function(self, t)
    return [[Digs a hole in a wall much faster than any shovels.]]
  end,
}

newTalent {
  name = [[Stone Prison]],
  short_name = 'STONE_PRISON',
  display_entity = Entity.new { image='talents/stone_prison.png' },
  type = 'spell/earth',
  mode = 'activated',
  is_spell = true,
  skill = 'EARTH',
  skill_level = 25,
  mana = spell.mana_cost,
  min_mana = 30,
  max_mana = 50,
  base_fail = 65,
  stat = 'INT',
  random_book = 'MAGIC',
  stick = {
    type = 'utility/wand',
    charge = { 5, 3 },
    rarity = 57,
    base_level = { 1, 3 },
    max_level = { 5, 20 },
  },
  points = 0,
  range = 18,
  direct_hit = true,
  action = function(self, t)
    local lev = spell.get_spell_level(self, t)
    local x, y = nil, nil
    if lev < 10 then x, y = self.x, self.y end
    local ret = spell.ball_spell(self, t, DamageType.STONE_WALL,
				 { 0, silent_0dam=true }, 1, x, y)
    if ret then spell.clobber_FOVs(x, y) end
    return ret
  end,
  info = function(self, t)
    return [[Creates a prison of stone walls surrounding the caster.  At level 10, the prison can be targeted at any location.  Note that any objects on the floor or ground will disrupt the creation of walls on that grid.]]
  end,
}

newTalent {
  name = [[Shake]],
  short_name = 'SHAKE',
  display_entity = Entity.new { image='talents/shake.png' },
  type = 'spell/earth',
  mode = 'activated',
  is_spell = true,
  skill = 'EARTH',
  skill_level = 27,
  mana = spell.mana_cost,
  min_mana = 25,
  max_mana = 30,
  base_fail = 60,
  stat = 'INT',
  random_book = 'MAGIC',
  inertia = { 2, 50 },
  stick = {
    type = 'utility/staff',
    charge = { 5, 10 },
    rarity = 75,
    base_level = { 1, 3 },
    max_level = { 9, 20 },
  },
  points = 0,
  range = 18,
  action = function(self, t)
    local lev = spell.get_spell_level(self, t, 50)
    local r = 4 + spell.get_spell_level(self, t, 10)
    local x, y = nil, nil
    if lev >= 10 then
      local tg = { type='ball', range=18, radius=r, talent=t }
      x, y = self:getTarget(tg)
    else
      x, y = self.x, self.y
    end
    if not x or not y then return false end
    spell.earthquake(x, y, r)
    return true
  end,
  info = function(self, t)
    local r = 4 + spell.get_spell_level(self, t, 10)
    local ret = [[Triggers a localized earthquake of radius %d around the player.  At level 10 the center of the quake can be targeted at any location.]]
    return ret:format(r)
  end,
}

newTalent {
  name = [[Strike]],
  short_name = 'STRIKE',
  display_entity = Entity.new { image='talents/strike.png' },
  type = 'spell/earth',
  mode = 'activated',
  is_spell = true,
  skill = 'EARTH',
  skill_level = 30,
  mana = spell.mana_cost,
  min_mana = 30,
  max_mana = 50,
  base_fail = 60,
  stat = 'INT',
  random_book = 'MAGIC',
  stick = {
    type = 'utility/wand',
    charge = { 2, 6 },
    rarity = 635,
    base_level = { 1, 5 },
    max_level = { 10, 50 },
  },
  requires_target = true,
  points = 0,
  range = 18,
  direct_hit = true,
  action = function(self, t)
    local lev = spell.get_spell_level(self, t)
    local dam = 50 + spell.get_spell_level(self, t, 50)
    if lev >= 12 then
      return spell.ball_spell(self, t, DamageType.FORCE, dam, 1)
    else
      return spell.hit_spell(self, t, DamageType.FORCE, dam)
    end
  end,
  info = function(self, t)
    local dam = 50 + spell.get_spell_level(self, t, 50)
    local ff = util.colorize_damtype(DamageType.FORCE)
    local sfx = spell.spell_skill_desc(self, t)
    local ret = [[Creates a micro-ball of force, doing %d %s damage and pushing affected monsters backwards.  If the monster is caught near a wall, it'll be crushed against it.  At level 12 it turns into a ball of radius 1.  Damage will increase%s]]
    return ret:format(dam, ff, sfx)
  end,
}
