-- $Id: mind.lua 2835 2017-04-11 00:13:59Z dsb $
-- ToME - Tales of Middle-Earth
-- Copyright © 2012-2017 Scott Bigham
--
-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
-- Scott Bigham "Zizzo"
-- dsb-tome@killerbunnies.org

-- -----------------------------------------------------------------------
-- WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING
-- -----------------------------------------------------------------------
-- This file was generated automatically by the 'gen_spells' Perl script.
-- DO NOT MODIFY THIS FILE DIRECTLY, as any changes will be lost the next
-- time the file is generated (with the possible exception of lines between
-- 'BEGIN VERBATIM' and 'END VERBATIM' markers, if supported by the script).
-- -----------------------------------------------------------------------
-- WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING
-- -----------------------------------------------------------------------

-- Spell talents generated from T2's s_mind.lua

local Entity = require 'engine.Entity'

newTalentType {
  name = 'Mind spells',
  type = 'spell/mind',
  description = 'Spells from the Mind school',
}

newTalent {
  name = [[Charm]],
  short_name = 'CHARM',
  display_entity = Entity.new { image='talents/charm.png' },
  type = 'spell/mind',
  mode = 'activated',
  is_spell = true,
  skill = 'MIND',
  skill_level = 1,
  mana = spell.mana_cost,
  min_mana = 1,
  max_mana = 20,
  base_fail = 10,
  stat = 'INT',
  random_book = 'MAGIC',
  stick = {
    type = 'utility/wand',
    charge = { 7, 5 },
    rarity = 35,
    base_level = { 1, 15 },
    max_level = { 20, 40 },
  },
  requires_target = true,
  points = 0,
  range = 18,
  direct_hit = true,
  action = function(self, t)
    local lev = spell.get_spell_level(self, t)
    local pow = 10 + spell.get_spell_level(self, t, 150)
    if lev >= 35 then
      spell.los_spell(self, t, DamageType.CHARM, pow)
      return true
    elseif lev >= 15 then
      return spell.ball_spell(self, t, DamageType.CHARM, pow, 3)
    else
      return spell.bolt_spell(self, t, DamageType.CHARM, pow)
    end
  end,
  info = function(self, t)
    local pow = 10 + spell.get_spell_level(self, t, 150)
    local sfx = spell.spell_skill_desc(self, t)
    local ret = [[Tries to manipulate the mind of a monster to make it friendly (with charm power %d).  At level 15, the spell will affect an area of radius 3 around the targeted monster; at level 35, all monsters in line of sight will be affected.  Power will increase%s]]
    return ret:format(pow, sfx)
  end,
}

newTalent {
  name = [[Confuse]],
  short_name = 'CONFUSE',
  display_entity = Entity.new { image='talents/confuse.png' },
  type = 'spell/mind',
  mode = 'activated',
  is_spell = true,
  skill = 'MIND',
  skill_level = 5,
  mana = spell.mana_cost,
  min_mana = 5,
  max_mana = 30,
  base_fail = 20,
  stat = 'INT',
  random_book = 'MAGIC',
  stick = {
    type = 'utility/wand',
    charge = { 3, 4 },
    rarity = 45,
    base_level = { 1, 5 },
    max_level = { 20, 40 },
  },
  requires_target = true,
  points = 0,
  range = 18,
  direct_hit = true,
  action = function(self, t)
    local lev = spell.get_spell_level(self, t)
    local pow = 10 + spell.get_spell_level(self, t, 150)
    if lev >= 35 then
      spell.los_spell(self, t, DamageType.OLD_CONF, pow)
      return true
    elseif lev >= 15 then
      return spell.ball_spell(self, t, DamageType.OLD_CONF, pow, 3)
    else
      return spell.bolt_spell(self, t, DamageType.OLD_CONF, pow)
    end
  end,
  info = function(self, t)
    local pow = 10 + spell.get_spell_level(self, t, 150)
    local sfx = spell.spell_skill_desc(self, t)
    local ret = [[Tries to manipulate the mind of a monster to confuse it (with power %d).  At level 15, the spell will affect an area of radius 3 around the targeted monster; at level 35, all monsters in line of sight will be affected.  Power will increase%s]]
    return ret:format(pow, sfx)
  end,
}

newTalent {
  name = [[Armor of Fear]],
  short_name = 'ARMOR_FEAR',
  display_entity = Entity.new { image='talents/armor_of_fear.png' },
  type = 'spell/mind',
  mode = 'activated',
  is_spell = true,
  skill = 'MIND',
  skill_level = 10,
  mana = spell.mana_cost,
  min_mana = 10,
  max_mana = 50,
  base_fail = 35,
  stat = 'INT',
  random_book = 'MAGIC',
  inertia = { 2, 20 },
  points = 0,
  range = 18,
  direct_hit = true,
  action = function(self, t)
    local dur = rng.range(1, 10) + 10 + spell.get_spell_level(self, t, 100)
    local dd = 1 + spell.get_spell_level(self, t, 7)
    local ds = 5 + spell.get_spell_level(self, t, 20)
    local p = {
      power = 10,
      on_melee_hit = { type=DamageType.FEAR, dice={dd,ds} },
      shield_name = 'Armor of Fear',
    }
    self:setEffect(self.EFF_SHIELD, rng.range(1, 10) + 10 + l100, p)
  end,
  info = function(self, t)
    local dur = 10 + spell.get_spell_level(self, t, 100)
    local dd = 1 + spell.get_spell_level(self, t, 7)
    local ds = 5 + spell.get_spell_level(self, t, 20)
    local sfx = spell.spell_skill_desc(self, t)
    local ret = [[Surrounds you with a shield of pure fear for %d+1d10 turns, increasing your AC by 10.  Any monster that hits you in melee must save against a %dd%d-power fear effect or flee.  Duration and damage will increase%s]]
    return ret:format(dur, dd, ds, sfx)
  end,
}

newTalent {
  name = [[Stun]],
  short_name = 'STUN',
  display_entity = Entity.new { image='talents/stun.png' },
  type = 'spell/mind',
  mode = 'activated',
  is_spell = true,
  skill = 'MIND',
  skill_level = 15,
  mana = spell.mana_cost,
  min_mana = 10,
  max_mana = 90,
  base_fail = 45,
  stat = 'INT',
  random_book = 'MAGIC',
  requires_target = true,
  points = 0,
  range = 18,
  direct_hit = true,
  action = function(self, t)
    local lev = spell.get_spell_level(self, t)
    local pow = 10 + spell.get_spell_level(self, t, 150)
    if lev >= 20 then
      return spell.ball_spell(self, t, DamageType.STUN, pow, 3)
    else
      return spell.bolt_spell(self, t, DamageType.STUN, pow)
    end
  end,
  info = function(self, t)
    local pow = 10 + spell.get_spell_level(self, t, 150)
    local sfx = spell.spell_skill_desc(self, t)
    local ret = [[Tries to manipulate the mind of a monster to stun it (with power %d).  At level 20, the spell will affect an area of radius 3 around the targeted monster.  Power will increase%s]]
    return ret:format(pow, sfx)
  end,
}
