-- $Id: temporal.lua 3025 2017-08-08 01:45:02Z dsb $
-- ToME - Tales of Middle-Earth
-- Copyright © 2012-2017 Scott Bigham
--
-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
-- Scott Bigham "Zizzo"
-- dsb-tome@killerbunnies.org

-- -----------------------------------------------------------------------
-- WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING
-- -----------------------------------------------------------------------
-- This file was generated automatically by the 'gen_spells' Perl script.
-- DO NOT MODIFY THIS FILE DIRECTLY, as any changes will be lost the next
-- time the file is generated (with the possible exception of lines between
-- 'BEGIN VERBATIM' and 'END VERBATIM' markers, if supported by the script).
-- -----------------------------------------------------------------------
-- WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING
-- -----------------------------------------------------------------------

-- Spell talents generated from T2's s_tempo.lua

local Entity = require 'engine.Entity'

newTalentType {
  name = 'Temporal spells',
  type = 'spell/temporal',
  description = 'Spells from the Temporal school',
}

newTalent {
  name = [[Magelock]],
  short_name = 'MAGELOCK',
  display_entity = Entity.new { image='talents/magelock.png' },
  type = 'spell/temporal',
  mode = 'activated',
  is_spell = true,
  skill = 'TEMPORAL',
  skill_level = 1,
  mana = spell.mana_cost,
  min_mana = 1,
  max_mana = 35,
  base_fail = 10,
  stat = 'INT',
  random_book = 'MAGIC',
  stick = {
    type = 'utility/wand',
    charge = { 7, 5 },
    rarity = 30,
    base_level = { 1, 5 },
    max_level = { 15, 45 },
  },
  requires_target = true,
  points = 0,
  range = 18,
  direct_hit = true,
  action = function(self, t)
    local lev = spell.get_spell_level(self, t)
    local function ok_glyph(x, y)
      local map = game.level.map
      return map:checkEntity(x, y, Map.TERRAIN, 'floor') and not map:checkEntity(x, y, Map.TERRAIN, 'permanent')
    end
    if lev >= 30 then
      local tx, ty = self.x, self.y
      if lev >= 40 then
	local tg = {
	  type = 'hit',
	  default_target = self,
	  range = self:getTalentRange(t),
	  nolock = true,
	}
	tx, ty, _ = self:getTarget(tg)
	if not tx or not ty then return end
      end
      local map = game.level.map
      if not map:checkEntity(tx, ty, Map.TERRAIN, 'floor') or map:checkEntity(tx, ty, Map.TERRAIN, 'permanent') or not self:hasLOS(tx, ty) then
	game.logPlayer(self, 'You cannot place a glyph of warding there.')
	return true
      end
      game:onTickEnd(function()
	game.level.map(tx, ty, Map.TERRAIN, game.zone.grid_list.GLYPH_OF_WARDING)
      end)
      return true
    else
      local function match(x, y)
	return game.level.map:checkEntity(x, y, Map.TERRAIN, 'hasFlags', 'DOOR')
      end
      local tx, ty = util.select_adjacent(self, match, 'There are no doors nearby.', 'That is not a door.')
      if not tx or not ty then return end
      local dam = { 20 + rng.range(1, 30), grid=true, object=true }
      spell.beam_spell(self, t, DamageType.JAM_DOOR, dam, tx, ty)
      return true
    end
  end,
  info = function(self, t)
    return [[Magically locks an adjacent door.
At level 30, instead places a glyph of warding on the floor at your feet.
At level 40, the glyph can be placed at any targeted location you can see.]]
  end,
}

newTalent {
  name = [[Slow Monster]],
  short_name = 'SLOW_MONSTER',
  display_entity = Entity.new { image='talents/slow_monster.png' },
  type = 'spell/temporal',
  mode = 'activated',
  is_spell = true,
  skill = 'TEMPORAL',
  skill_level = 10,
  mana = spell.mana_cost,
  min_mana = 10,
  max_mana = 15,
  base_fail = 35,
  stat = 'INT',
  random_book = 'MAGIC',
  stick = {
    type = 'utility/wand',
    charge = { 5, 5 },
    rarity = 23,
    base_level = { 1, 15 },
    max_level = { 20, 50 },
  },
  requires_target = true,
  points = 0,
  range = 18,
  direct_hit = true,
  action = function(self, t)
    local lev = spell.get_spell_level(self, t)
    if lev >= 20 then
      return spell.ball_spell(self, t, DamageType.OLD_SLOW, 40 + lev, 1)
    else
      return spell.bolt_spell(self, t, DamageType.OLD_SLOW, 40 + lev)
    end
  end,
  info = function(self, t)
    local lev = spell.get_spell_level(self, t)
    local sfx = spell.spell_skill_desc(self, t)
    local ret = [[Magically slows down the passing of time around a monster (with power %d).  At level 20 it affects a radius-1 area around the targeted monster.  Power will increase%s]]
    return ret:format(40+lev, sfx)
  end,
}

newTalent {
  name = [[Essence of Speed]],
  short_name = 'ESS_SPEED',
  display_entity = Entity.new { image='talents/essence_of_speed.png' },
  type = 'spell/temporal',
  mode = 'activated',
  is_spell = true,
  skill = 'TEMPORAL',
  skill_level = 15,
  mana = spell.mana_cost,
  min_mana = 20,
  max_mana = 40,
  base_fail = 50,
  stat = 'INT',
  random_book = 'MAGIC',
  inertia = { 5, 20 },
  stick = {
    type = 'utility/wand',
    charge = { 3, 3 },
    rarity = 80,
    base_level = { 1, 1 },
    max_level = { 10, 39 },
  },
  points = 0,
  range = 18,
  direct_hit = true,
  action = function(self, t)
    local dur = 10 + rng.range(1, 10) + spell.get_spell_level(self, t)
    local speed = 5 + spell.get_spell_level(self, t, 20)
    self:setEffect(self.EFF_SPEED, dur, { speed=speed, merge='no_replace' })
  end,
  info = function(self, t)
    local dur = 10 + rng.range(1, 10) + spell.get_spell_level(self, t)
    local speed = 5 + spell.get_spell_level(self, t, 20)
    local sfx = spell.spell_skill_desc(self, t)
    local ret = [[Magically decreases the passing of time around you, making you move faster with respect to the rest of the universe.  Your speed will be increased by %d for %d (normal-speed) turns.  Duration and speed boost will increase%s
    
#{bold}#NOTE:#{normal}#  This spell will have no effect if you currently have any active temporary speed-changing effect, including from a prior casting of this spell.]]
    return ret:format(speed, dur, sfx)
  end,
}

newTalent {
  name = [[Banishment]],
  short_name = 'BANISHMENT',
  display_entity = Entity.new { image='talents/banishment.png' },
  type = 'spell/temporal',
  mode = 'activated',
  is_spell = true,
  skill = { 'TEMPORAL', 'CONVEYANCE' },
  skill_level = 30,
  mana = spell.mana_cost,
  min_mana = 30,
  max_mana = 40,
  base_fail = 95,
  stat = 'INT',
  random_book = 'MAGIC',
  inertia = { 5, 50 },
  stick = {
    type = 'utility/wand',
    charge = { 1, 3 },
    rarity = 98,
    base_level = { 1, 15 },
    max_level = { 10, 36 },
  },
  points = 0,
  range = 18,
  direct_hit = true,
  action = function(self, t)
    local lev = spell.get_spell_level(self, t)
    local tele_pow = 40 + spell.get_spell_level(self, t, 160)
    spell.los_spell(self, t, DamageType.TELEPORT, tele_pow)
    if lev >= 15 then
      local statis_pow = 20 + spell.get_spell_level(self, t, 120)
      spell.los_spell(self, t, DamageType.STASIS, statis_pow)
    end
    return true
  end,
  info = function(self, t)
    local tele_pow = 40 + spell.get_spell_level(self, t, 160)
    local statis_pow = 20 + spell.get_spell_level(self, t, 120)
    local sfx = spell.spell_skill_desc(self, t)
    local ret = [[Disrupts the space/time continuum in your area and teleports all monsters away (with power %d).  At level 15, if any monsters resisted being teleported away, the spell will further attempt to lock them in a time bubble for a while (with power %d).  Power will increase%s]]
    return ret:format(tele_pow, statis_pow, sfx)
  end,
}
