-- $Id: water.lua 2835 2017-04-11 00:13:59Z dsb $
-- ToME - Tales of Middle-Earth
-- Copyright © 2012-2017 Scott Bigham
--
-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
-- Scott Bigham "Zizzo"
-- dsb-tome@killerbunnies.org

-- -----------------------------------------------------------------------
-- WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING
-- -----------------------------------------------------------------------
-- This file was generated automatically by the 'gen_spells' Perl script.
-- DO NOT MODIFY THIS FILE DIRECTLY, as any changes will be lost the next
-- time the file is generated (with the possible exception of lines between
-- 'BEGIN VERBATIM' and 'END VERBATIM' markers, if supported by the script).
-- -----------------------------------------------------------------------
-- WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING
-- -----------------------------------------------------------------------

-- Spell talents generated from T2's s_water.lua

local Entity = require 'engine.Entity'

newTalentType {
  name = 'Water spells',
  type = 'spell/water',
  description = 'Spells from the Water school',
}

newTalent {
  name = [[Geyser]],
  short_name = 'GEYSER',
  display_entity = Entity.new { image='talents/geyser.png' },
  type = 'spell/water',
  mode = 'activated',
  is_spell = true,
  skill = 'WATER',
  skill_level = 1,
  mana = spell.mana_cost,
  min_mana = 1,
  max_mana = 35,
  base_fail = 5,
  stat = 'INT',
  random_book = 'MAGIC',
  requires_target = true,
  points = 0,
  range = 18,
  direct_hit = true,
  action = function(self, t)
    local prob = 2 * spell.get_spell_level(self, t, 85)
    return spell.bolt_or_beam_spell(self, t, prob, DamageType.WATER,
				    rng.dice(t.dmg_dice(self, t)))
  end,
  info = function(self, t)
    local prob = 2 * spell.get_spell_level(self, t, 85)
    local dd, ds = t.dmg_dice(self, t)
    local sfx = spell.spell_skill_desc(self, t)
    local ret = [[Shoots a geyser of water from your fingertips, doing %dd%d %s damage.]]
    ret = ret:format(dd, ds, util.colorize_damtype(DamageType.WATER))
    if prob < 100 then
      local rr = [[  There is a %d%% chance the blast will pass through the first monster it strikes and continue to the location you target.]]
      ret = ret .. rr:format(prob)
    end
    ret = ret .. '  Damage' .. (prob < 100 and ' and beam chance' or '')
	      .. ' will increase' .. sfx
    return ret
  end,
  -- BEGIN VERBATIM
  dmg_dice = function(self, t)
    local dd = spell.get_spell_level(self, t, 10)
    local ds = 3 + spell.get_spell_level(self, t, 35)
    return dd, ds
  end,
  -- END VERBATIM
}

newTalent {
  name = [[Vapor]],
  short_name = 'VAPOR',
  display_entity = Entity.new { image='talents/vapor.png' },
  type = 'spell/water',
  mode = 'activated',
  is_spell = true,
  skill = 'WATER',
  skill_level = 2,
  mana = spell.mana_cost,
  min_mana = 2,
  max_mana = 12,
  base_fail = 20,
  stat = 'INT',
  random_book = 'MAGIC',
  inertia = { 1, 30 },
  points = 0,
  range = 18,
  direct_hit = true,
  action = function(self, t)
    local dam = 3 + spell.get_spell_level(self, t, 20)
    local r = 3 + spell.get_spell_level(self, t, 9, 0)
    return spell.cloud_spell(self, t, DamageType.WATER, dam, r, 5, nil, nil, self.x, self.y)
  end,
  info = function(self, t)
    local dam = 3 + spell.get_spell_level(self, t, 20)
    local r = 3 + spell.get_spell_level(self, t, 9, 0)
    local wf = util.colorize_damtype(DamageType.WATER)
    local sfx = spell.spell_skill_desc(self, t)
    local ret = [[Fills the air with toxic moisture in a radius of %d to eradicate annoying critters.  Does %d %s damage per turn for 5 turns.  Damage and range will increase%s]]
    return ret:format(r, dam, wf, sfx)
  end,
}

newTalent {
  name = [[Ent's Potion]],
  short_name = 'ENT_POTION',
  display_entity = Entity.new { image='talents/ent_s_potion.png' },
  type = 'spell/water',
  mode = 'activated',
  is_spell = true,
  skill = 'WATER',
  skill_level = 6,
  mana = spell.mana_cost,
  min_mana = 7,
  max_mana = 15,
  base_fail = 35,
  stat = 'INT',
  random_book = 'MAGIC',
  inertia = { 1, 30 },
  points = 0,
  range = 18,
  direct_hit = true,
  action = function(self, t)
    local lev = spell.get_spell_level(self, t, 50)
    self:setFood(util.FOOD.max - 1)
    game.logPlayer(self, "The Ent's Potion filles your stomach.")
    if lev >= 5 then self:removeEffect(self.EFF_AFRAID) end
    if lev >= 12 then
      local dur = 25 + spell.get_spell_level(self, t, 40)
      self:setEffect(self.EFF_HEROISM, rng.range(1, 25) + dur, {merge='combine'})
    end
    return true
  end,
  info = function(self, t)
    local dur = 25 + spell.get_spell_level(self, t, 40)
    local sfx = spell.spell_skill_desc(self, t)
    local ret = [[Fills your stomach.  At level 5, also removes fear.  At level 12, also makes you heroic for %d+1d25 turns; the duration will increase%s]]
    return ret:format(dur, sfx)
  end,
}

newTalent {
  name = [[Tidal Wave]],
  short_name = 'TIDAL_WAVE',
  display_entity = Entity.new { image='talents/tidal_wave.png' },
  type = 'spell/water',
  mode = 'activated',
  is_spell = true,
  skill = 'WATER',
  skill_level = 16,
  mana = spell.mana_cost,
  min_mana = 16,
  max_mana = 40,
  base_fail = 65,
  stat = 'INT',
  random_book = 'MAGIC',
  inertia = { 4, 100 },
  stick = {
    type = 'utility/wand',
    charge = { 6, 5 },
    rarity = 54,
    base_level = { 1, 10 },
    max_level = { 20, 50 },
  },
  points = 0,
  range = 18,
  direct_hit = true,
  action = function(self, t)
    local dam = 40 + spell.get_spell_level(self, t, 200)
    local r = 6 + spell.get_spell_level(self, t, 10)
    local e = game.level.map:addEffect(self, self.x, self.y, r,
				       DamageType.WAVE,
				       { dam, x=self.x, y=self.y },
				       0, 5, nil, 
				       spell.cloud_overlay(DamageType.WAVE),
				       t.wave_expand, true, false)
    e.name = t.name
    return true
  end,
  info = function(self, t)
    local dam = 40 + spell.get_spell_level(self, t, 200)
    local r = 6 + spell.get_spell_level(self, t, 10)
    local wff = util.colorize_damtype(DamageType.WATER)
    local sfx = spell.spell_skill_desc(self, t)
    local ret = [[Summons a monstrous tidal wave around you, expanding 1 radius per turn to a maximum radius of %d and knocking back monsters caught in the wave, doing %d %s damage in the process.  Damage and maximum radius will increase%s]]
    return ret:format(r, dam, wff, sfx)
  end,
  -- BEGIN VERBATIM
  wave_expand = function(e, update_shape_only)
    if not update_shape_only then
      e.radius = e.radius + 1
      local outer = core.fov.circle_grids(e.x, e.y, e.radius, true)
      if e.radius >= 2 then
	local inner = core.fov.circle_grids(e.x, e.y, e.radius-2, true)
	for lx, ys in pairs(inner) do
	  if outer[lx] then
	    for ly, _ in pairs(ys) do outer[lx][ly] = nil end
	    local empty = true
	    for _, _ in pairs(outer[lx]) do empty = false end
	    if empty then outer[lx] = nil end
	  end
	end
      end
      e.grids = outer
      e.computed_grids = true
    end
    return true
  end,
  -- END VERBATIM
}

newTalent {
  name = [[Ice Storm]],
  short_name = 'ICE_STORM',
  display_entity = Entity.new { image='talents/ice_storm.png' },
  type = 'spell/water',
  mode = 'activated',
  is_spell = true,
  skill = 'WATER',
  skill_level = 22,
  mana = spell.mana_cost,
  min_mana = 30,
  max_mana = 60,
  base_fail = 80,
  stat = 'INT',
  random_book = 'MAGIC',
  inertia = { 3, 40 },
  stick = {
    type = 'utility/wand',
    charge = { 3, 7 },
    rarity = 65,
    base_level = { 1, 5 },
    max_level = { 25, 45 },
  },
  points = 0,
  range = 18,
  direct_hit = true,
  action = function(self, t)
    local type = spell.get_spell_level(self, t, 50) >= 10 and DamageType.ICE or DamageType.COLD
    local dam = 80 + spell.get_spell_level(self, t, 200)
    local r = 1 + spell.get_spell_level(self, t, 3, 0)
    local dur = 20 + spell.get_spell_level(self, t, 50)
    local function move_cb(e, update_shape_only)
      -- I think we want to move the storm even if update_shape_only is true.
      e.x = e.src.x
      e.y = e.src.y
      return true
    end
    local e = game.level.map:addEffect(self, self.x, self.y, dur, type, dam,
				       r, 5, nil, spell.cloud_overlay(type),
				       move_cb, true, false)
    e.name = t.name
    return true
  end,
  info = function(self, t)
    local dam = 80 + spell.get_spell_level(self, t, 200)
    local r = 1 + spell.get_spell_level(self, t, 3, 0)
    local dur = 20 + spell.get_spell_level(self, t, 50)
    local cdf = util.colorize_damtype(DamageType.COLD)
    local idf = util.colorize_damtype(DamageType.ICE)
    local sfx = spell.spell_skill_desc(self, t)
    local ret = [[Engulfs the caster in a storm of roaring cold that moves with the caster, doing %d %s damage in a radius of %d around the caster for %d turns.  At level 10 the storms begins doing %s damage instead.  Damage, radius and duration will increase%s]]
    return ret:format(dam, cdf, r, dur, idf, sfx)
  end,
}
