-- $Id: zone.lua 2835 2017-04-11 00:13:59Z dsb $
-- ToME - Tales of Middle-Earth
-- Copyright © 2012-2017 Scott Bigham
--
-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
-- Scott Bigham "Zizzo"
-- dsb-tome@killerbunnies.org

return {
  name = 'Minas Anor',
  level_scheme = 'fixed',
  max_level = 1,
  width = 198,
  height = 66,
  no_level_connectivity = true,
  all_remembered = true,
  all_lited = true,
  day_night = true,
  town = true,

  generator = {
    map = {
      class = 'mod.class.generator.map.PlasmaWilderness',
      map = 'towns/minas-anor'
    },
    actor = {
      class = 'mod.class.generator.actor.T2LevelFilteredActors',
      init_npc = 10,
      filters = {
	{ prob=100, mode='any' },
      },
    },
  },

  entry_point = util.town_wild_entry_point,

  on_enter = util.close_quest_entrances,

  on_leave = util.on_leave_town_wild,
}
