-- $Id: zone.lua 2835 2017-04-11 00:13:59Z dsb $
-- ToME - Tales of Middle-Earth
-- Copyright © 2012-2017 Scott Bigham
--
-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
-- Scott Bigham "Zizzo"
-- dsb-tome@killerbunnies.org

-- Zone file for Wilderness.

return {
  name = 'Wilderness',
  display_abbr = 'Wil',
  level_scheme = 'fixed',
  max_level = 1,
  level_range = { 0, 0 },
  width = 198,
  height = 66,
  no_level_connectivity = true,
  wilderness = true,
  -- TODO Handle day/night.
  all_remembered = true,
  all_lited = true,

  generator = {
    map = {
      class = 'mod.class.generator.map.PlasmaWilderness',
      floor = { weighted = { GRASS=80, GRASS_WITH_FLOWERS=20 } },
      fill = { 'TREE' },
      outer_wall = 'WALL',
      inner_wall = 'WALL',
      flags = {
	FLAT = true,
	NO_RECALL = true,
      },
    },
    actor = {
      class = 'mod.class.generator.actor.T2LevelFilteredActors',
      init_npc = 14,
      respawn_in = 500,
      filters = {
	{ prob=100, mode='any' },
      },
    },
  },
  entry_point = util.town_wild_entry_point,

  on_leave = util.on_leave_town_wild,
}
