-- $Id: zone.lua 2835 2017-04-11 00:13:59Z dsb $
-- ToME - Tales of Middle-Earth
-- Copyright © 2012-2017 Scott Bigham
--
-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
-- Scott Bigham "Zizzo"
-- dsb-tome@killerbunnies.org

return {
  name = 'Arda',
  level_scheme = 'fixed',
  max_level = 1,
  width = 101,
  height = 66,
  persistent = 'zone',
  day_night = true,
  worldmap = true,
  no_level_connectivity = true,

  generator = {
    map = {
      class = 'mod.class.generator.map.Static',
      map = 'world'
    },
  },

  entry_point = function(_, _, _)
    -- We should only be entering the world map from a "wilderness" zone
    -- (including non-dungeon towns), which we can assume will have set
    -- game.player.wild_[xy] for us.
    return { x=game.player.wild_x, y=game.player.wild_y }
  end,

  on_leave = function(from_, to_lev, from_lev, to_zone, params)
    -- Remember our wilderness position.
    game.player.wild_x, game.player.wild_y = game.player.x, game.player.y

    if util.zone_is(to_zone, 'dungeon') then
      -- Questionable Hack(TM):  If we're entering a dungeon zone from the
      -- worldmap, set town recall target to the wilderness level around
      -- the zone entrance.
      game.state:setRecallDest(to_zone)
    end
  end,
}
