-- $Id: all.lua 2835 2017-04-11 00:13:59Z dsb $
-- ToME - Tales of Middle-Earth
-- Copyright © 2012-2017 Scott Bigham
--
-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
-- Scott Bigham "Zizzo"
-- dsb-tome@killerbunnies.org

-- -----------------------------------------------------------------------
-- WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING
-- -----------------------------------------------------------------------
-- This file was generated automatically by the 'gen_mon' Perl script.
-- DO NOT MODIFY THIS FILE DIRECTLY, as any changes will be lost the next
-- time the file is generated (with the possible exception of lines between
-- 'BEGIN VERBATIM' and 'END VERBATIM' markers, if supported by the script).
-- -----------------------------------------------------------------------
-- WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING
-- -----------------------------------------------------------------------

-- Monster entities generated from T2's r_info.txt

local AttackType = require 'mod.class.AttackType'
local Talents = require 'engine.interface.ActorTalents'

local bodies = {
  dragon = { MAIN_HAND=0, OFF_HAND=0, BODY=1, CLOAK=1, LAUNCHER=0, QUIVER=1, GLOVES=0, BOOTS=0, HELM=1, RING=6, AMULET=1, LITE=1, TOOL=0, SYMBIOTE=1, INVEN=23 },
  humanoid = { MAIN_HAND=1, OFF_HAND=1, BODY=1, CLOAK=1, LAUNCHER=1, QUIVER=1, GLOVES=1, BOOTS=1, HELM=1, RING=2, AMULET=1, LITE=1, TOOL=1, SYMBIOTE=1, INVEN=23 },
  quadruped = { MAIN_HAND=0, OFF_HAND=0, BODY=1, CLOAK=1, LAUNCHER=0, QUIVER=1, GLOVES=0, BOOTS=0, HELM=1, RING=2, AMULET=1, LITE=1, TOOL=0, SYMBIOTE=1, INVEN=23 },
  snake = { MAIN_HAND=0, OFF_HAND=0, BODY=0, CLOAK=0, LAUNCHER=0, QUIVER=0, GLOVES=0, BOOTS=0, HELM=1, RING=0, AMULET=1, LITE=0, TOOL=0, SYMBIOTE=0, INVEN=23 },
  hydra = { MAIN_HAND=0, OFF_HAND=0, BODY=1, CLOAK=1, LAUNCHER=0, QUIVER=1, GLOVES=0, BOOTS=0, HELM=2, RING=2, AMULET=2, LITE=1, TOOL=0, SYMBIOTE=1, INVEN=23 },
  none = { MAIN_HAND=0, OFF_HAND=0, BODY=0, CLOAK=0, LAUNCHER=0, QUIVER=0, GLOVES=0, BOOTS=0, HELM=0, RING=0, AMULET=0, LITE=0, TOOL=0, SYMBIOTE=0, INVEN=23 },
  winged = { MAIN_HAND=0, OFF_HAND=1, BODY=1, CLOAK=1, LAUNCHER=0, QUIVER=1, GLOVES=1, BOOTS=0, HELM=1, RING=0, AMULET=1, LITE=1, TOOL=1, SYMBIOTE=1, INVEN=23 },
}

newEntity {
  define_as = 'PLAYER',
  name = [[Player]],
  display = '@',
  color = colors.C_w,
  image = 'npc/player.png',
  desc = [[You, under the hood.]],
  corpse_weight = 0,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 1, 1 },
  ac = 0,
  max_life = resolvers.dice(1, 1),
  flags = {
    SPECIAL_GENE = true,
  },
  placement_flags = {},
  body = bodies.humanoid,
  speed = 0,
  vision = 0,
  alertness = 0,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'FILTHY_STREET_URCHIN',
  name = [[Filthy street urchin]],
  display = 't',
  color = colors.C_D,
  image = 'npc/filthy_street_urchin.png',
  desc = [[He looks squalid and thoroughly revolting.]],
  corpse_weight = 120,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=25,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 1, 4 },
  ac = 1,
  max_life = resolvers.dice(1, 4),
  rarity = 2,
  level = 0,
  start_level = 0,
  exp_worth = 0,
  flags = {
    BASEANGBAND = true,
    EVIL = true,
    FRIENDS = true,
    HAS_LITE = true,
    MALE = true,
    MORTAL = true,
    OPEN_DOOR = true,
    TAKE_ITEM = true,
  },
  placement_flags = { WILD_ONLY=true, WILD_TOWN=true },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { method=AttackType.BEG },
    { type=DamageType.EAT_GOLD, method=AttackType.TOUCH },
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 4,
  alertness = 40,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'SCRAWNY_CAT',
  name = [[Scrawny cat]],
  display = 'f',
  color = colors.C_U,
  image = 'npc/scrawny_cat.png',
  desc = [[A skinny little furball with sharp claws and a menacing look.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=25,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 1, 2 },
  ac = 1,
  max_life = resolvers.dice(1, 2),
  rarity = 3,
  level = 0,
  start_level = 0,
  exp_worth = 0,
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    MORTAL = true,
  },
  placement_flags = { WILD_GRASS=true, WILD_ONLY=true, WILD_TOO=true, WILD_TOWN=true },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={1,1} },
  },
  body = bodies.quadruped,
  speed = 0,
  vision = 30,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'SPARROW',
  name = [[Sparrow]],
  display = 'B',
  color = colors.C_U,
  image = 'npc/sparrow.png',
  desc = [[Utterly harmless, except when angry.]],
  corpse_weight = 9,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=25,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 1, 1 },
  ac = 1,
  max_life = resolvers.dice(1, 1),
  rarity = 3,
  level = 0,
  start_level = 0,
  exp_worth = 0,
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    FLY = true,
    HAS_EGG = true,
    IMPRESED = true,
    MORTAL = true,
  },
  placement_flags = { WILD_ONLY=true, WILD_TOWN=true },
  drop_corpse = { skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={1,1} },
  },
  body = bodies.winged,
  speed = 0,
  vision = 30,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'CHAFFINCH',
  name = [[Chaffinch]],
  display = 'B',
  color = colors.C_r,
  image = 'npc/chaffinch.png',
  desc = [[Utterly harmless, except when angry.]],
  corpse_weight = 8,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=25,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 1, 1 },
  ac = 1,
  max_life = resolvers.dice(1, 1),
  rarity = 3,
  level = 0,
  start_level = 0,
  exp_worth = 0,
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    FLY = true,
    HAS_EGG = true,
    IMPRESED = true,
    MORTAL = true,
  },
  placement_flags = { WILD_GRASS=true, WILD_ONLY=true, WILD_WOOD=true },
  drop_corpse = { skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={1,1} },
  },
  body = bodies.winged,
  speed = 0,
  vision = 30,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'WILD_RABBIT',
  name = [[Wild rabbit]],
  display = 'r',
  color = colors.C_U,
  image = 'npc/wild_rabbit.png',
  desc = [[It is not a carnivore, but will defend itself if you stray too close.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=50,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 1, 2 },
  ac = 1,
  max_life = resolvers.dice(1, 2),
  rarity = 3,
  level = 0,
  start_level = 0,
  exp_worth = 0,
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    MORTAL = true,
  },
  placement_flags = { WILD_GRASS=true, WILD_ONLY=true, WILD_WOOD=true },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={1,1} },
  },
  body = bodies.quadruped,
  speed = 0,
  vision = 30,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'WOODSMAN',
  name = [[Woodsman]],
  plural_name = [[Woodsmen]],
  display = 't',
  color = colors.C_g,
  image = 'npc/woodsman.png',
  desc = [[He has a strong axe with a sharp edge.]],
  corpse_weight = 100,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=25,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 3, 3 },
  ac = 1,
  max_life = resolvers.dice(3, 3),
  rarity = 1,
  level = 0,
  start_level = 0,
  exp_worth = 0,
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    HAS_LITE = true,
    MALE = true,
    MORTAL = true,
    OPEN_DOOR = true,
    TAKE_ITEM = true,
  },
  placement_flags = { WILD_ONLY=true, WILD_WOOD=true },
  resolvers.mon_inven{ only_gold=true, '60%' },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,6} },
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 10,
  alertness = 255,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'SCRUFFY_LITTLE_DOG',
  name = [[Scruffy little dog]],
  display = 'C',
  color = colors.C_U,
  image = 'npc/scruffy_little_dog.png',
  desc = [[A thin flea-ridden mutt, growling as you get close.]],
  corpse_weight = 30,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=25,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 1, 3 },
  ac = 1,
  max_life = resolvers.dice(1, 3),
  rarity = 3,
  level = 0,
  start_level = 0,
  exp_worth = 0,
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    MORTAL = true,
  },
  placement_flags = { WILD_ONLY=true, WILD_TOWN=true },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={1,1} },
  },
  body = bodies.quadruped,
  speed = 0,
  vision = 20,
  alertness = 5,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'FARMER_MAGGOT',
  name = [[Farmer Maggot]],
  display = 'h',
  color = colors.C_w,
  image = 'npc/farmer_maggot.png',
  desc = [[He's lost his dogs. He's had his mushrooms stolen. He's not a happy hobbit!]],
  corpse_weight = 73,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 35, 10 },
  ac = 10,
  faction = 'quest_givers',
  max_life = 350,
  level = 0,
  start_level = 0,
  exp_worth = 0,
  unique = 'FARMER_MAGGOT',
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    CAN_SPEAK = true,
    FORCE_MAXHP = true,
    HAS_LITE = true,
    MALE = true,
    MORTAL = true,
    NEUTRAL = true,
    NEVER_MOVE = true,
    NO_DEATH = true,
    NO_TARGET = true,
    OPEN_DOOR = true,
    SPECIAL_GENE = true,
    UNIQUE = true,
  },
  placement_flags = { WILD_ONLY=true, WILD_TOWN=true },
  drop_corpse = { corpse=true },
  body = { MAIN_HAND=0, OFF_HAND=1, BODY=1, CLOAK=1, LAUNCHER=0, QUIVER=1, GLOVES=1, BOOTS=1, HELM=1, RING=2, AMULET=1, LITE=1, TOOL=1, SYMBIOTE=1, INVEN=23 },
  speed = 0,
  vision = 40,
  alertness = 3,
  resolvers.mon_global_speed(),
  -- BEGIN VERBATIM
  can_talk = 'farmer-maggot',
  -- END VERBATIM
}

newEntity {
  define_as = 'BLUBBERING_IDIOT',
  name = [[Blubbering idiot]],
  display = 't',
  color = colors.C_W,
  image = 'npc/blubbering_idiot.png',
  desc = [[He tends to blubber a lot.]],
  corpse_weight = 150,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=25,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 1, 2 },
  ac = 1,
  max_life = resolvers.dice(1, 2),
  rarity = 1,
  level = 0,
  start_level = 0,
  exp_worth = 0,
  flags = {
    BASEANGBAND = true,
    HAS_LITE = true,
    MALE = true,
    MORTAL = true,
    TAKE_ITEM = true,
  },
  placement_flags = { WILD_ONLY=true, WILD_TOWN=true },
  resolvers.mon_inven{ '1d2' },
  drop = { treasure=0, combat=0, magic=0, tools=0, junk=100 },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { method=AttackType.DROOL },
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 6,
  alertness = 0,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'BOIL_COVERED_WRETCH',
  name = [[Boil-covered wretch]],
  display = 't',
  color = colors.C_g,
  image = 'npc/boil_covered_wretch.png',
  desc = [[Ugly doesn't begin to describe him.]],
  corpse_weight = 140,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=25,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 1, 2 },
  ac = 1,
  max_life = resolvers.dice(1, 2),
  rarity = 1,
  level = 0,
  start_level = 0,
  exp_worth = 0,
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    HAS_LITE = true,
    MALE = true,
    MORTAL = true,
    OPEN_DOOR = true,
    TAKE_ITEM = true,
  },
  placement_flags = { WILD_ONLY=true, WILD_TOWN=true },
  resolvers.mon_inven{ '1d2' },
  drop = { treasure=0, combat=0, magic=0, tools=0, junk=100 },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { method=AttackType.DROOL },
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 6,
  alertness = 0,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'VILLAGE_IDIOT',
  name = [[Village idiot]],
  display = 't',
  color = colors.C_G,
  image = 'npc/village_idiot.png',
  desc = [[Drooling and comical, but then, what do you expect?]],
  corpse_weight = 140,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=25,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 4, 4 },
  ac = 1,
  max_life = resolvers.dice(4, 4),
  rarity = 1,
  level = 0,
  start_level = 0,
  exp_worth = 0,
  flags = {
    BASEANGBAND = true,
    HAS_LITE = true,
    MALE = true,
    MORTAL = true,
    TAKE_ITEM = true,
  },
  placement_flags = { WILD_ONLY=true, WILD_TOWN=true },
  resolvers.mon_inven{ '1d2' },
  drop = { treasure=0, combat=0, magic=0, tools=0, junk=100 },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { method=AttackType.DROOL },
  },
  body = bodies.humanoid,
  speed = 10,
  vision = 6,
  alertness = 0,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'PITIFUL_LOOKING_BEGGAR',
  name = [[Pitiful-looking beggar]],
  display = 't',
  color = colors.C_U,
  image = 'npc/pitiful_looking_beggar.png',
  desc = [[You just can't help feeling sorry for him.]],
  corpse_weight = 130,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=25,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 1, 4 },
  ac = 1,
  max_life = resolvers.dice(1, 4),
  rarity = 1,
  level = 0,
  start_level = 0,
  exp_worth = 0,
  flags = {
    BASEANGBAND = true,
    HAS_LITE = true,
    MALE = true,
    MORTAL = true,
    OPEN_DOOR = true,
    TAKE_ITEM = true,
  },
  placement_flags = { WILD_ONLY=true, WILD_TOWN=true },
  resolvers.mon_inven{ '1d2' },
  drop = { treasure=0, combat=0, magic=0, tools=0, junk=100 },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { method=AttackType.BEG },
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 10,
  alertness = 40,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'MANGY_LOOKING_LEPER',
  name = [[Mangy-looking leper]],
  display = 't',
  color = colors.C_u,
  image = 'npc/mangy_looking_leper.png',
  desc = [[You feel it isn't safe to touch him.]],
  corpse_weight = 130,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=25,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 1, 1 },
  ac = 1,
  max_life = resolvers.dice(1, 1),
  rarity = 1,
  level = 0,
  start_level = 0,
  exp_worth = 0,
  flags = {
    BASEANGBAND = true,
    HAS_LITE = true,
    MALE = true,
    MORTAL = true,
    OPEN_DOOR = true,
    TAKE_ITEM = true,
  },
  placement_flags = { WILD_ONLY=true, WILD_TOWN=true },
  resolvers.mon_inven{ '1d2' },
  drop = { treasure=0, combat=0, magic=0, tools=0, junk=100 },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { method=AttackType.BEG },
    { type=DamageType.DISEASE, method=AttackType.TOUCH },
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 10,
  alertness = 50,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'AGENT_OF_THE_BLACK_MARKET',
  name = [[Agent of the black market]],
  display = 't',
  color = colors.C_b,
  image = 'npc/agent_of_the_black_market.png',
  desc = [[He 'finds' new wares for the Black Market. From unwary adventurers...]],
  corpse_weight = 120,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 2, 8 },
  ac = 8,
  max_life = resolvers.dice(2, 8),
  rarity = 1,
  level = 0,
  start_level = 0,
  exp_worth = 0,
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    EVIL = true,
    HAS_LITE = true,
    MALE = true,
    MORTAL = true,
    OPEN_DOOR = true,
    TAKE_ITEM = true,
  },
  placement_flags = { WILD_GRASS=true, WILD_MOUNTAIN=true, WILD_ONLY=true, WILD_SWAMP=true, WILD_TOWN=true, WILD_WOOD=true },
  resolvers.mon_inven{ '60%' },
  drop = { treasure=25, combat=50, magic=20, tools=5, junk=0 },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,6} },
    { type=DamageType.EAT_ITEM, method=AttackType.TOUCH },
    { method=AttackType.INSULT },
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 10,
  alertness = 99,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'SINGING_HAPPY_DRUNK',
  name = [[Singing, happy drunk]],
  display = 't',
  color = colors.C_y,
  image = 'npc/singing_happy_drunk.png',
  desc = [[He makes you glad to be sober.]],
  corpse_weight = 110,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=50,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 2, 3 },
  ac = 1,
  max_life = resolvers.dice(2, 3),
  rarity = 1,
  level = 0,
  start_level = 0,
  exp_worth = 0,
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    HAS_LITE = true,
    MALE = true,
    MORTAL = true,
    OPEN_DOOR = true,
    TAKE_ITEM = true,
  },
  placement_flags = { WILD_ONLY=true, WILD_TOWN=true },
  resolvers.mon_inven{ only_gold=true, '60%' },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { method=AttackType.BEG },
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 10,
  alertness = 0,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'AIMLESS_LOOKING_MERCHANT',
  name = [[Aimless-looking merchant]],
  display = 't',
  color = colors.C_o,
  image = 'npc/aimless_looking_merchant.png',
  desc = [[The typical ponce around town, with purse jingling, and looking for more amulets of adornment to buy.]],
  corpse_weight = 150,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=50,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 3, 3 },
  ac = 1,
  max_life = resolvers.dice(3, 3),
  rarity = 1,
  level = 0,
  start_level = 0,
  exp_worth = 0,
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    HAS_LITE = true,
    MALE = true,
    MORTAL = true,
    OPEN_DOOR = true,
    TAKE_ITEM = true,
  },
  placement_flags = { WILD_ONLY=true, WILD_TOWN=true },
  resolvers.mon_inven{ only_gold=true, '60%' },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,3} },
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 10,
  alertness = 255,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'MEAN_LOOKING_MERCENARY',
  name = [[Mean-looking mercenary]],
  display = 't',
  color = colors.C_r,
  image = 'npc/mean_looking_mercenary.png',
  desc = [[No job is too low for him.]],
  corpse_weight = 170,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=50,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 5, 8 },
  ac = 20,
  max_life = resolvers.dice(5, 8),
  rarity = 1,
  level = 0,
  start_level = 0,
  exp_worth = 0,
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    EVIL = true,
    HAS_LITE = true,
    MALE = true,
    MORTAL = true,
    OPEN_DOOR = true,
    TAKE_ITEM = true,
  },
  placement_flags = { WILD_GRASS=true, WILD_ONLY=true, WILD_TOWN=true, WILD_WOOD=true },
  resolvers.mon_inven{ '90%' },
  drop = { treasure=0, combat=100, magic=0, tools=0, junk=0 },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,10} },
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 10,
  alertness = 250,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'BATTLE_SCARRED_VETERAN',
  name = [[Battle-scarred veteran]],
  display = 't',
  color = colors.C_B,
  image = 'npc/battle_scarred_veteran.png',
  desc = [[He doesn't take to strangers kindly.]],
  corpse_weight = 165,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=50,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 7, 8 },
  ac = 30,
  max_life = resolvers.dice(7, 8),
  rarity = 1,
  level = 0,
  start_level = 0,
  exp_worth = 0,
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    HAS_LITE = true,
    MALE = true,
    MORTAL = true,
    OPEN_DOOR = true,
    TAKE_ITEM = true,
  },
  placement_flags = { WILD_ONLY=true, WILD_TOWN=true },
  resolvers.mon_inven{ '90%' },
  drop = { treasure=25, combat=50, magic=25, tools=0, junk=0 },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={2,6} },
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 10,
  alertness = 250,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'GREY_MOLD',
  name = [[Grey mold]],
  display = 'm',
  color = colors.C_s,
  image = 'npc/grey_mold.png',
  desc = [[A small strange growth.]],
  corpse_weight = 2,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 1, 2 },
  ac = 1,
  max_life = resolvers.dice(1, 2),
  rarity = 1,
  level = 1,
  start_level = 1,
  exp_worth = 3,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.FEAR] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    EMPTY_MIND = true,
    MORTAL = true,
    NEVER_MOVE = true,
    NO_CUT = true,
    STUPID = true,
  },
  placement_flags = {},
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.SPORE, dam={1,4} },
    { type=DamageType.PHYSICAL, method=AttackType.SPORE, dam={1,4} },
  },
  body = bodies.none,
  speed = 0,
  vision = 2,
  alertness = 0,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'LARGE_WHITE_SNAKE',
  name = [[Large white snake]],
  display = 'J',
  color = colors.C_w,
  image = 'npc/large_white_snake.png',
  desc = [[It is about eight feet long.]],
  corpse_weight = 60,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=50,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 3, 6 },
  ac = 30,
  max_life = resolvers.dice(3, 6),
  rarity = 1,
  level = 1,
  start_level = 1,
  exp_worth = 2,
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    HAS_EGG = true,
    MORTAL = true,
  },
  placement_flags = { WILD_TOO=true },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={1,1} },
    { type=DamageType.PHYSICAL, method=AttackType.CRUSH, dam={1,1} },
  },
  body = bodies.snake,
  speed = -10,
  vision = 4,
  alertness = 99,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'GREY_MUSHROOM_PATCH',
  name = [[Grey mushroom patch]],
  display = ',',
  color = colors.C_s,
  image = 'npc/grey_mushroom_patch.png',
  desc = [[Yum! It looks quite tasty.]],
  corpse_weight = 1,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 1, 2 },
  ac = 1,
  max_life = resolvers.dice(1, 2),
  rarity = 1,
  level = 1,
  start_level = 1,
  exp_worth = 1,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.FEAR] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    EMPTY_MIND = true,
    NEVER_MOVE = true,
    NO_CUT = true,
    STUPID = true,
  },
  placement_flags = {},
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.CONFUSION, method=AttackType.SPORE, dam={1,4} },
  },
  body = bodies.none,
  speed = 0,
  vision = 2,
  alertness = 0,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'NEWT',
  name = [[Newt]],
  display = 'R',
  color = colors.C_y,
  image = 'npc/newt.png',
  desc = [[A small, harmless lizard.]],
  corpse_weight = 1,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 2, 6 },
  ac = 12,
  max_life = resolvers.dice(2, 6),
  rarity = 1,
  level = 1,
  start_level = 1,
  exp_worth = 2,
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    CAN_SWIM = true,
    HAS_EGG = true,
    MORTAL = true,
    WEIRD_MIND = true,
  },
  placement_flags = { WILD_GRASS=true, WILD_MOUNTAIN=true, WILD_SHORE=true, WILD_SWAMP=true, WILD_TOO=true, WILD_WASTE=true },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={1,3} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={1,3} },
  },
  body = bodies.quadruped,
  speed = 0,
  vision = 8,
  alertness = 30,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'GIANT_WHITE_CENTIPEDE',
  name = [[Giant white centipede]],
  display = 'c',
  color = colors.C_w,
  image = 'npc/giant_white_centipede.png',
  desc = [[It is about four feet long and carnivorous.]],
  corpse_weight = 50,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=50,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 3, 5 },
  ac = 10,
  max_life = resolvers.dice(3, 5),
  rarity = 1,
  level = 1,
  start_level = 1,
  exp_worth = 2,
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    MORTAL = true,
    WEIRD_MIND = true,
  },
  placement_flags = { WILD_TOO=true },
  drop_corpse = { skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={1,2} },
    { type=DamageType.PHYSICAL, method=AttackType.STING, dam={1,2} },
  },
  body = bodies.snake,
  speed = 0,
  vision = 7,
  alertness = 40,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'WHITE_ICKY_THING',
  name = [[White icky thing]],
  display = 'i',
  color = colors.C_w,
  image = 'npc/white_icky_thing.png',
  desc = [[It is a smallish, slimy, icky creature.]],
  corpse_weight = 50,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=75,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 2, 5 },
  ac = 7,
  max_life = resolvers.dice(2, 5),
  rarity = 1,
  level = 1,
  start_level = 1,
  exp_worth = 1,
  flags = {
    BASEANGBAND = true,
    CAN_SWIM = true,
    EMPTY_MIND = true,
  },
  placement_flags = {},
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.TOUCH, dam={1,2} },
  },
  body = bodies.none,
  speed = 0,
  vision = 12,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'CLEAR_ICKY_THING',
  name = [[Clear icky thing]],
  display = 'i',
  color = colors.C_B,
  image = 'npc/clear_icky_thing.png',
  desc = [[It is a smallish, slimy, icky, blobby creature.]],
  corpse_weight = 50,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=75,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 2, 5 },
  ac = 6,
  max_life = resolvers.dice(2, 5),
  rarity = 1,
  level = 1,
  start_level = 1,
  exp_worth = 2,
  flags = {
    ATTR_CLEAR = true,
    BASEANGBAND = true,
    CAN_SWIM = true,
    EMPTY_MIND = true,
    INVISIBLE = true,
  },
  placement_flags = {},
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.TOUCH, dam={1,2} },
  },
  body = bodies.none,
  speed = 0,
  vision = 12,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'GIANT_WHITE_MOUSE',
  name = [[Giant white mouse]],
  plural_name = [[Giant white mice]],
  display = 'r',
  color = colors.C_w,
  image = 'npc/giant_white_mouse.png',
  desc = [[It is about three feet long with large teeth.]],
  corpse_weight = 60,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=50,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 1, 3 },
  ac = 4,
  max_life = resolvers.dice(1, 3),
  rarity = 1,
  level = 1,
  start_level = 1,
  exp_worth = 1,
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    CAN_SWIM = true,
    MORTAL = true,
    MULTIPLY = true,
  },
  placement_flags = { WILD_GRASS=true, WILD_TOO=true },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={1,2} },
  },
  body = bodies.quadruped,
  speed = 0,
  vision = 8,
  alertness = 20,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'LARGE_BROWN_SNAKE',
  name = [[Large brown snake]],
  display = 'J',
  color = colors.C_u,
  image = 'npc/large_brown_snake.png',
  desc = [[It is about eight feet long.]],
  corpse_weight = 80,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=25,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 4, 6 },
  ac = 35,
  max_life = resolvers.dice(4, 6),
  rarity = 1,
  level = 1,
  start_level = 1,
  exp_worth = 3,
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    CAN_SWIM = true,
    HAS_EGG = true,
    MORTAL = true,
  },
  placement_flags = {},
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={1,3} },
    { type=DamageType.PHYSICAL, method=AttackType.CRUSH, dam={1,4} },
  },
  body = bodies.snake,
  speed = -10,
  vision = 4,
  alertness = 99,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'SMALL_KOBOLD',
  name = [[Small kobold]],
  display = 'k',
  color = colors.C_y,
  image = 'npc/small_kobold.png',
  desc = [[It is a small, dog-headed humanoid figure.]],
  corpse_weight = 80,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 2, 7 },
  ac = 16,
  max_life = resolvers.dice(2, 7),
  rarity = 1,
  level = 1,
  start_level = 1,
  exp_worth = 5,
  resist_dam = {
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    EVIL = true,
    HAS_LITE = true,
    MORTAL = true,
    OPEN_DOOR = true,
  },
  placement_flags = { WILD_TOO=true },
  resolvers.mon_inven{ '60%' },
  drop = { treasure=0, combat=50, magic=0, tools=30, junk=20 },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,5} },
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 20,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'KOBOLD',
  name = [[Kobold]],
  display = 'k',
  color = colors.C_G,
  image = 'npc/kobold.png',
  desc = [[It is a squat and ugly dog-headed humanoid.]],
  corpse_weight = 90,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 3, 7 },
  ac = 16,
  max_life = resolvers.dice(3, 7),
  rarity = 1,
  level = 2,
  start_level = 2,
  exp_worth = 5,
  resist_dam = {
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    EVIL = true,
    HAS_LITE = true,
    MORTAL = true,
    OPEN_DOOR = true,
  },
  placement_flags = { WILD_TOO=true },
  resolvers.mon_inven{ '60%' },
  drop = { treasure=0, combat=50, magic=0, tools=30, junk=20 },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,8} },
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 20,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'WHITE_WORM_MASS',
  name = [[White worm mass]],
  display = 'w',
  color = colors.C_w,
  image = 'npc/white_worm_mass.png',
  desc = [[It is a large slimy mass of worms.]],
  corpse_weight = 3,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=75,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 4, 4 },
  ac = 1,
  max_life = resolvers.dice(4, 4),
  rarity = 1,
  level = 1,
  start_level = 1,
  exp_worth = 2,
  resist_dam = {
    [DamageType.DARK] = true,
    [DamageType.FEAR] = true,
    [DamageType.POISON] = true,
  },
  vuln_dam = {
    [DamageType.LITE] = true,
    [DamageType.LITE_WEAK] = true,
  },
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    CAN_SWIM = true,
    MORTAL = true,
    MULTIPLY = true,
    NO_CUT = true,
    STUPID = true,
    WEIRD_MIND = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.POISON, method=AttackType.CRAWL, dam={1,2} },
  },
  body = bodies.none,
  speed = -10,
  vision = 7,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'FLOATING_EYE',
  name = [[Floating eye]],
  display = 'e',
  color = colors.C_o,
  image = 'npc/floating_eye.png',
  desc = [[A disembodied eye, floating a few feet above the ground.]],
  corpse_weight = 50,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 3, 6 },
  ac = 6,
  max_life = resolvers.dice(3, 6),
  rarity = 1,
  level = 1,
  start_level = 1,
  exp_worth = 1,
  resist_dam = {
    [DamageType.DARK] = true,
    [DamageType.FEAR] = true,
  },
  vuln_dam = {
    [DamageType.LITE] = true,
    [DamageType.LITE_WEAK] = true,
  },
  flags = {
    BASEANGBAND = true,
    FLY = true,
    NEVER_MOVE = true,
  },
  placement_flags = {},
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PARALYZE, method=AttackType.GAZE },
  },
  body = bodies.none,
  speed = 0,
  vision = 2,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'ROCK_LIZARD',
  name = [[Rock lizard]],
  display = 'R',
  color = colors.C_U,
  image = 'npc/rock_lizard.png',
  desc = [[It is a small lizard with a hardened hide.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 3, 4 },
  ac = 4,
  max_life = resolvers.dice(3, 4),
  rarity = 1,
  level = 1,
  start_level = 1,
  exp_worth = 2,
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    CAN_SWIM = true,
    HAS_EGG = true,
    MORTAL = true,
  },
  placement_flags = { WILD_MOUNTAIN=true, WILD_TOO=true },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={1,1} },
  },
  body = bodies.quadruped,
  speed = 0,
  vision = 20,
  alertness = 15,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'JACKAL',
  name = [[Jackal]],
  display = 'C',
  color = colors.C_U,
  image = 'npc/jackal.png',
  desc = [[It is a yapping snarling dog, dangerous when in a pack.]],
  corpse_weight = 40,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 1, 4 },
  ac = 3,
  max_life = resolvers.dice(1, 4),
  rarity = 1,
  level = 1,
  start_level = 1,
  exp_worth = 1,
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    FRIENDS = true,
    MORTAL = true,
  },
  placement_flags = { WILD_GRASS=true, WILD_TOO=true, WILD_WOOD=true },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={1,1} },
  },
  body = bodies.quadruped,
  speed = 0,
  vision = 10,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'SOLDIER_ANT',
  name = [[Soldier ant]],
  display = 'a',
  color = colors.C_u,
  image = 'npc/soldier_ant.png',
  desc = [[A large ant with powerful mandibles.]],
  corpse_weight = 30,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 2, 5 },
  ac = 3,
  max_life = resolvers.dice(2, 5),
  rarity = 1,
  level = 1,
  start_level = 1,
  exp_worth = 3,
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    MORTAL = true,
    WEIRD_MIND = true,
  },
  placement_flags = { WILD_GRASS=true, WILD_TOO=true },
  drop_corpse = { skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={1,2} },
  },
  body = bodies.quadruped,
  speed = 0,
  vision = 10,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'FRUIT_BAT',
  name = [[Fruit bat]],
  display = 'b',
  color = colors.C_o,
  image = 'npc/fruit_bat.png',
  desc = [[A fast-moving pest.]],
  corpse_weight = 2,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 1, 6 },
  ac = 3,
  max_life = resolvers.dice(1, 6),
  rarity = 1,
  level = 1,
  start_level = 1,
  exp_worth = 1,
  flags = {
    AI_ANNOY = true,
    ANIMAL = true,
    BASEANGBAND = true,
    FLY = true,
    MORTAL = true,
  },
  placement_flags = { WILD_SWAMP=true, WILD_TOO=true, WILD_WOOD=true },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={1,1} },
  },
  body = bodies.winged,
  speed = 10,
  vision = 20,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'INSECT_SWARM',
  name = [[Insect swarm]],
  display = 'I',
  color = colors.C_u,
  image = 'npc/insect_swarm.png',
  desc = [[A lone insect may be harmless, but there's a whole swarm of them here!]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=25,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 1, 5 },
  ac = 4,
  max_life = resolvers.dice(1, 5),
  rarity = 1,
  level = 1,
  start_level = 1,
  exp_worth = 1,
  vuln_dam = {
    [DamageType.FIRE] = true,
  },
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    FLY = true,
    MORTAL = true,
    NO_CUT = true,
    WEIRD_MIND = true,
  },
  placement_flags = { WILD_GRASS=true, WILD_SWAMP=true, WILD_TOO=true, WILD_WOOD=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={1,1} },
    { type=DamageType.PHYSICAL, method=AttackType.STING, dam={1,1} },
  },
  body = bodies.none,
  speed = 10,
  vision = 20,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'SHRIEKER_MUSHROOM_PATCH',
  name = [[Shrieker mushroom patch]],
  display = ',',
  color = colors.C_R,
  image = 'npc/shrieker_mushroom_patch.png',
  desc = [[Yum!  It looks quite tasty.  It doesn't sound so nice, though...]],
  corpse_weight = 4,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 4,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 1, 1 },
  ac = 1,
  max_life = resolvers.dice(1, 1),
  rarity = 1,
  level = 2,
  start_level = 2,
  exp_worth = 1,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.FEAR] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    EMPTY_MIND = true,
    FORCE_SLEEP = true,
    NEVER_BLOW = true,
    NEVER_MOVE = true,
    NO_CUT = true,
    STUPID = true,
  },
  placement_flags = { WILD_SWAMP=true, WILD_TOO=true },
  drop_corpse = { corpse=true },
  resolvers.talents {
    [Talents.T_NPC_SHRIEK] = 1,
  },
  body = bodies.none,
  speed = 0,
  vision = 4,
  alertness = 0,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'BLUBBERING_ICKY_THING',
  name = [[Blubbering icky thing]],
  display = 'i',
  color = colors.C_W,
  image = 'npc/blubbering_icky_thing.png',
  desc = [[It is a smallish, slimy, icky, hungry creature.]],
  corpse_weight = 40,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=50,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 5, 6 },
  ac = 4,
  max_life = resolvers.dice(5, 6),
  rarity = 1,
  level = 2,
  start_level = 2,
  exp_worth = 8,
  resist_dam = {
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    CAN_SWIM = true,
    EMPTY_MIND = true,
    KILL_BODY = true,
    TAKE_ITEM = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ '90%' },
  drop = { treasure=20, combat=20, magic=20, tools=20, junk=20 },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.POISON, method=AttackType.CRAWL, dam={1,4} },
    { type=DamageType.EAT_FOOD, method=AttackType.CRAWL },
    { method=AttackType.DROOL },
    { method=AttackType.DROOL },
  },
  body = bodies.none,
  speed = 0,
  vision = 14,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'METALLIC_GREEN_CENTIPEDE',
  name = [[Metallic green centipede]],
  display = 'c',
  color = colors.C_g,
  image = 'npc/metallic_green_centipede.png',
  desc = [[It is about four feet long and carnivorous.]],
  corpse_weight = 50,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=50,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 4, 4 },
  ac = 4,
  max_life = resolvers.dice(4, 4),
  rarity = 1,
  level = 3,
  start_level = 3,
  exp_worth = 5,
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    MORTAL = true,
    WEIRD_MIND = true,
  },
  placement_flags = { WILD_TOO=true },
  drop_corpse = { skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CRAWL, dam={1,2} },
  },
  body = bodies.snake,
  speed = 10,
  vision = 5,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'NOVICE_WARRIOR',
  name = [[Novice warrior]],
  display = 'p',
  color = colors.C_u,
  image = 'npc/novice_warrior.png',
  desc = [[He looks inexperienced but tough.]],
  corpse_weight = 160,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 9, 4 },
  ac = 16,
  max_life = resolvers.dice(9, 4),
  rarity = 1,
  level = 2,
  start_level = 2,
  exp_worth = 6,
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    HAS_LITE = true,
    MALE = true,
    MORTAL = true,
    OPEN_DOOR = true,
  },
  placement_flags = { WILD_TOO=true },
  resolvers.mon_inven{ '60%' },
  drop = { treasure=25, combat=50, magic=0, tools=20, junk=5 },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,7} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,6} },
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 20,
  alertness = 5,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'NOVICE_ROGUE',
  name = [[Novice rogue]],
  display = 'p',
  color = colors.C_b,
  image = 'npc/novice_rogue.png',
  desc = [[A rather shifty individual.]],
  corpse_weight = 140,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 8, 4 },
  ac = 12,
  max_life = resolvers.dice(8, 4),
  rarity = 1,
  level = 2,
  start_level = 2,
  exp_worth = 6,
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    EVIL = true,
    MALE = true,
    MORTAL = true,
    OPEN_DOOR = true,
    TAKE_ITEM = true,
  },
  placement_flags = { WILD_TOO=true },
  resolvers.mon_inven{ '60%' },
  drop = { treasure=50, combat=25, magic=0, tools=20, junk=5 },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,6} },
    { type=DamageType.EAT_GOLD, method=AttackType.TOUCH },
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 20,
  alertness = 5,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'NOVICE_PRIEST',
  name = [[Novice priest]],
  display = 'p',
  color = colors.C_g,
  image = 'npc/novice_priest.png',
  desc = [[He is tripping over his priestly robes.]],
  corpse_weight = 150,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 12,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 7, 4 },
  ac = 10,
  faction = 'eru_manwe',
  max_life = resolvers.dice(7, 4),
  rarity = 1,
  level = 2,
  start_level = 2,
  exp_worth = 6,
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    FORCE_SLEEP = true,
    GOOD = true,
    HAS_LITE = true,
    MALE = true,
    MORTAL = true,
    OPEN_DOOR = true,
  },
  placement_flags = { WILD_TOO=true },
  resolvers.mon_inven{ '60%' },
  drop = { treasure=25, combat=0, magic=50, tools=20, junk=5 },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,5} },
  },
  resolvers.talents {
    [Talents.T_NPC_HEAL] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_CAUSE_1] = 1,
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 20,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'NOVICE_MAGE',
  name = [[Novice mage]],
  display = 'p',
  color = colors.C_r,
  image = 'npc/novice_mage.png',
  desc = [[He is leaving behind a trail of dropped spell components.]],
  corpse_weight = 140,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 12,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 6, 4 },
  ac = 6,
  max_life = resolvers.dice(6, 4),
  rarity = 1,
  level = 2,
  start_level = 2,
  exp_worth = 6,
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    FORCE_SLEEP = true,
    HAS_LITE = true,
    MALE = true,
    MORTAL = true,
    OPEN_DOOR = true,
  },
  placement_flags = { WILD_TOO=true },
  resolvers.mon_inven{ '60%' },
  drop = { treasure=25, combat=0, magic=70, tools=0, junk=5 },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,4} },
  },
  resolvers.talents {
    [Talents.T_NPC_BLINK] = 1,
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_MISSILE] = 1,
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 20,
  alertness = 5,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'YELLOW_MUSHROOM_PATCH',
  name = [[Yellow mushroom patch]],
  display = ',',
  color = colors.C_y,
  image = 'npc/yellow_mushroom_patch.png',
  desc = [[Yum!  It looks quite tasty.]],
  corpse_weight = 3,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 1, 1 },
  ac = 1,
  max_life = resolvers.dice(1, 1),
  rarity = 1,
  level = 2,
  start_level = 2,
  exp_worth = 2,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.FEAR] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    EMPTY_MIND = true,
    MORTAL = true,
    NEVER_MOVE = true,
    NO_CUT = true,
    STUPID = true,
  },
  placement_flags = { WILD_SWAMP=true, WILD_TOO=true },
  attacks = {
    { type=DamageType.FEAR, method=AttackType.SPORE, dam={1,6} },
  },
  body = bodies.none,
  speed = 0,
  vision = 2,
  alertness = 0,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'WHITE_JELLY',
  name = [[White jelly]],
  display = 'j',
  color = colors.C_w,
  image = 'npc/white_jelly.png',
  desc = [[It's a large pile of white flesh.]],
  corpse_weight = 200,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 8, 8 },
  ac = 1,
  max_life = resolvers.dice(8, 8),
  rarity = 1,
  level = 2,
  start_level = 2,
  exp_worth = 10,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.DARK] = true,
    [DamageType.FEAR] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  vuln_dam = {
    [DamageType.LITE] = true,
    [DamageType.LITE_WEAK] = true,
  },
  flags = {
    BASEANGBAND = true,
    CAN_SWIM = true,
    EMPTY_MIND = true,
    NEVER_MOVE = true,
    NO_CUT = true,
    STUPID = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.POISON, method=AttackType.TOUCH, dam={1,2} },
  },
  body = bodies.none,
  speed = 10,
  vision = 2,
  alertness = 99,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'GIANT_BLACK_ANT',
  name = [[Giant black ant]],
  display = 'a',
  color = colors.C_D,
  image = 'npc/giant_black_ant.png',
  desc = [[It is about three feet long.]],
  corpse_weight = 50,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=25,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 3, 6 },
  ac = 20,
  max_life = resolvers.dice(3, 6),
  rarity = 1,
  level = 2,
  start_level = 2,
  exp_worth = 8,
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    MORTAL = true,
    WEIRD_MIND = true,
  },
  placement_flags = { WILD_GRASS=true, WILD_TOO=true, WILD_WOOD=true },
  drop_corpse = { skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={1,4} },
  },
  body = bodies.quadruped,
  speed = 0,
  vision = 8,
  alertness = 80,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'SALAMANDER',
  name = [[Salamander]],
  display = 'R',
  color = colors.C_o,
  image = 'npc/salamander.png',
  desc = [[A small black and orange lizard.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=25,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 4, 6 },
  ac = 20,
  max_life = resolvers.dice(4, 6),
  rarity = 1,
  level = 2,
  start_level = 2,
  exp_worth = 10,
  resist_dam = {
    [DamageType.FIRE] = true,
  },
  vuln_dam = {
    [DamageType.COLD] = true,
  },
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    CAN_SWIM = true,
    MORTAL = true,
  },
  placement_flags = { WILD_TOO=true, WILD_VOLCANO=true },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.FIRE, method=AttackType.BITE, dam={1,3} },
  },
  body = bodies.quadruped,
  speed = 0,
  vision = 8,
  alertness = 80,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'WHITE_HARPY',
  name = [[White harpy]],
  display = 'H',
  color = colors.C_w,
  image = 'npc/white_harpy.png',
  desc = [[A flying, screeching bird with a woman's face.]],
  corpse_weight = 50,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=50,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 2, 5 },
  ac = 17,
  max_life = resolvers.dice(2, 5),
  rarity = 1,
  level = 2,
  start_level = 2,
  exp_worth = 5,
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    EVIL = true,
    FEMALE = true,
    FLY = true,
    MORTAL = true,
  },
  placement_flags = { WILD_MOUNTAIN=true, WILD_TOO=true },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={1,1} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={1,1} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={1,2} },
  },
  body = bodies.winged,
  speed = 0,
  vision = 16,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'BLUE_YEEK',
  name = [[Blue yeek]],
  display = 'y',
  color = colors.C_b,
  image = 'npc/blue_yeek.png',
  desc = [[A small humanoid figure.]],
  corpse_weight = 70,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 2, 6 },
  ac = 14,
  max_life = resolvers.dice(2, 6),
  rarity = 1,
  level = 2,
  start_level = 2,
  exp_worth = 4,
  resist_dam = {
    [DamageType.ACID] = true,
  },
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    MORTAL = true,
    OPEN_DOOR = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ '60%' },
  drop = { treasure=25, combat=0, magic=0, tools=55, junk=20 },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,5} },
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 18,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'GRIP_FARMER_MAGGOT_S_DOG',
  name = [[Grip, Farmer Maggot's dog]],
  display = 'C',
  color = colors.C_w,
  image = 'npc/grip_farmer_maggot_s_dog.png',
  desc = [[A rather vicious dog belonging to Farmer Maggot. It thinks you are stealing mushrooms.]],
  corpse_weight = 60,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=25,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 7, 5 },
  ac = 30,
  max_life = 35,
  level = 2,
  start_level = 2,
  exp_worth = 30,
  unique = 'GRIP_FARMER_MAGGOT_S_DOG',
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    FORCE_MAXHP = true,
    MORTAL = true,
    SPECIAL_GENE = true,
    UNIQUE = true,
  },
  placement_flags = {},
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={1,6} },
  },
  body = bodies.quadruped,
  speed = 10,
  vision = 30,
  alertness = 0,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'WOLF_FARMER_MAGGOT_S_DOG',
  name = [[Wolf, Farmer Maggot's dog]],
  display = 'C',
  color = colors.C_w,
  image = 'npc/wolf_farmer_maggot_s_dog.png',
  desc = [[A rather vicious dog belonging to Farmer Maggot. It thinks you are stealing mushrooms.]],
  corpse_weight = 65,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=25,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 7, 5 },
  ac = 30,
  max_life = 35,
  level = 2,
  start_level = 2,
  exp_worth = 30,
  unique = 'WOLF_FARMER_MAGGOT_S_DOG',
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    FORCE_MAXHP = true,
    MORTAL = true,
    SPECIAL_GENE = true,
    UNIQUE = true,
  },
  placement_flags = {},
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={1,6} },
  },
  body = bodies.quadruped,
  speed = 10,
  vision = 30,
  alertness = 0,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'FANG_FARMER_MAGGOT_S_DOG',
  name = [[Fang, Farmer Maggot's dog]],
  display = 'C',
  color = colors.C_w,
  image = 'npc/fang_farmer_maggot_s_dog.png',
  desc = [[A rather vicious dog belonging to Farmer Maggot. It thinks you are stealing mushrooms.]],
  corpse_weight = 70,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=25,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 7, 5 },
  ac = 30,
  max_life = 35,
  level = 2,
  start_level = 2,
  exp_worth = 30,
  unique = 'FANG_FARMER_MAGGOT_S_DOG',
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    FORCE_MAXHP = true,
    MORTAL = true,
    SPECIAL_GENE = true,
    UNIQUE = true,
  },
  placement_flags = {},
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={1,6} },
  },
  body = bodies.quadruped,
  speed = 10,
  vision = 30,
  alertness = 0,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'GIANT_GREEN_FROG',
  name = [[Giant green frog]],
  display = 'R',
  color = colors.C_g,
  image = 'npc/giant_green_frog.png',
  desc = [[It is as big as a wolf.]],
  corpse_weight = 20,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=25,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 2, 8 },
  ac = 8,
  max_life = resolvers.dice(2, 8),
  rarity = 1,
  level = 2,
  start_level = 2,
  exp_worth = 6,
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    MORTAL = true,
  },
  placement_flags = { WILD_ONLY=true, WILD_SHORE=true, WILD_SWAMP=true },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={1,3} },
  },
  body = bodies.quadruped,
  speed = 0,
  vision = 12,
  alertness = 30,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'GREEN_WORM_MASS',
  name = [[Green worm mass]],
  display = 'w',
  color = colors.C_g,
  image = 'npc/green_worm_mass.png',
  desc = [[It is a large slimy mass of worms.]],
  corpse_weight = 4,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=75,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 6, 4 },
  ac = 3,
  max_life = resolvers.dice(6, 4),
  rarity = 1,
  level = 2,
  start_level = 2,
  exp_worth = 3,
  resist_dam = {
    [DamageType.ACID] = true,
    [DamageType.DARK] = true,
    [DamageType.FEAR] = true,
  },
  vuln_dam = {
    [DamageType.LITE] = true,
    [DamageType.LITE_WEAK] = true,
  },
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    CAN_SWIM = true,
    MORTAL = true,
    MULTIPLY = true,
    NO_CUT = true,
    STUPID = true,
    WEIRD_MIND = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.ACID, method=AttackType.CRAWL, dam={1,3} },
  },
  body = bodies.none,
  speed = -10,
  vision = 7,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'LARGE_YELLOW_SNAKE',
  name = [[Large yellow snake]],
  display = 'J',
  color = colors.C_y,
  image = 'npc/large_yellow_snake.png',
  desc = [[It is about ten feet long.]],
  corpse_weight = 100,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=25,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 4, 8 },
  ac = 38,
  max_life = resolvers.dice(4, 8),
  rarity = 1,
  level = 2,
  start_level = 2,
  exp_worth = 9,
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    CAN_SWIM = true,
    HAS_EGG = true,
    MORTAL = true,
  },
  placement_flags = { WILD_TOO=true },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={1,4} },
    { type=DamageType.PHYSICAL, method=AttackType.CRUSH, dam={1,6} },
  },
  body = bodies.snake,
  speed = -10,
  vision = 5,
  alertness = 75,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'CAVE_SPIDER',
  name = [[Cave spider]],
  display = 'S',
  color = colors.C_D,
  image = 'npc/cave_spider.png',
  desc = [[It is a black spider that moves in fits and starts.]],
  corpse_weight = 40,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 2, 6 },
  ac = 16,
  max_life = resolvers.dice(2, 6),
  rarity = 1,
  level = 2,
  start_level = 2,
  exp_worth = 7,
  resist_dam = {
    [DamageType.DARK] = true,
  },
  vuln_dam = {
    [DamageType.LITE] = true,
    [DamageType.LITE_WEAK] = true,
  },
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    FRIENDS = true,
    MORTAL = true,
    SPIDER = true,
    WEIRD_MIND = true,
  },
  placement_flags = {},
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={1,4} },
  },
  body = bodies.quadruped,
  speed = 10,
  vision = 8,
  alertness = 80,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'CROW',
  name = [[Crow]],
  display = 'B',
  color = colors.C_s,
  image = 'npc/crow.png',
  desc = [[It is a hooded crow, gray except for the black wings and head.]],
  corpse_weight = 30,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 3, 5 },
  ac = 12,
  max_life = resolvers.dice(3, 5),
  rarity = 2,
  level = 2,
  start_level = 2,
  exp_worth = 8,
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    FLY = true,
    HAS_EGG = true,
    MORTAL = true,
  },
  placement_flags = { WILD_TOO=true, WILD_WOOD=true },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={1,3} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={1,3} },
  },
  body = bodies.winged,
  speed = 10,
  vision = 40,
  alertness = 0,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'WILD_CAT',
  name = [[Wild cat]],
  display = 'f',
  color = colors.C_U,
  image = 'npc/wild_cat.png',
  desc = [[A larger than normal feline, hissing loudly. Its velvet claws conceal a fistful of needles.]],
  corpse_weight = 20,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 3, 5 },
  ac = 12,
  max_life = resolvers.dice(3, 5),
  rarity = 2,
  level = 2,
  start_level = 2,
  exp_worth = 8,
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    MORTAL = true,
  },
  placement_flags = { WILD_TOO=true },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={1,3} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={1,3} },
  },
  body = bodies.quadruped,
  speed = 10,
  vision = 40,
  alertness = 0,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'SMEAGOL',
  name = [[Sméagol]],
  display = 'h',
  color = colors.C_B,
  image = 'npc/smeagol.png',
  desc = [[Usually known as Gollum.  He's been sneaking, and he wants his 'precious.']],
  corpse_weight = 67,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=75,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 20, 20 },
  ac = 12,
  max_life = 400,
  rarity = 2,
  level = 3,
  start_level = 3,
  exp_worth = 16,
  unique = 'SMEAGOL',
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    CAN_SPEAK = true,
    CAN_SWIM = true,
    EVIL = true,
    FORCE_MAXHP = true,
    INVISIBLE = true,
    MALE = true,
    OPEN_DOOR = true,
    SMART = true,
    TAKE_ITEM = true,
    UNIQUE = true,
  },
  placement_flags = { WILD_TOO=true },
  resolvers.mon_inven{ good=true, great=true, only_item=true, '90%' },
  drop = { treasure=50, combat=50, magic=0, tools=0, junk=0 },
  drop_corpse = { corpse=true, skeleton=true },
  drop_special = function(self) return game.zone:makeEntityByName(game.level, 'object', 'RING_INVISIBILITY', false) end,
  attacks = {
    { type=DamageType.EAT_GOLD, method=AttackType.TOUCH },
  },
  body = bodies.humanoid,
  speed = 20,
  vision = 20,
  alertness = 5,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'GREEN_OOZE',
  name = [[Green ooze]],
  display = 'j',
  color = colors.C_g,
  image = 'npc/green_ooze.png',
  desc = [[It's green and it's oozing.]],
  corpse_weight = 30,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=75,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 3, 4 },
  ac = 16,
  max_life = resolvers.dice(3, 4),
  rarity = 2,
  level = 3,
  start_level = 3,
  exp_worth = 4,
  resist_dam = {
    [DamageType.ACID] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.FEAR] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    CAN_SWIM = true,
    EMPTY_MIND = true,
    NO_CUT = true,
    STUPID = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ '90%' },
  drop = { treasure=50, combat=0, magic=25, tools=20, junk=5 },
  attacks = {
    { type=DamageType.ACID, method=AttackType.CRAWL, dam={1,3} },
  },
  body = bodies.none,
  speed = 10,
  vision = 8,
  alertness = 80,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'POLTERGEIST',
  name = [[Poltergeist]],
  display = 'G',
  color = colors.C_s,
  image = 'npc/poltergeist.png',
  desc = [[It is a ghastly, ghostly form.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=75,
    talent_in = 15,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 2, 5 },
  ac = 15,
  max_life = resolvers.dice(2, 5),
  rarity = 1,
  level = 3,
  start_level = 3,
  exp_worth = 8,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.DARK] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  vuln_dam = {
    [DamageType.LITE] = true,
    [DamageType.LITE_WEAK] = true,
  },
  flags = {
    BASEANGBAND = true,
    COLD_BLOOD = true,
    EVIL = true,
    FLY = true,
    INVISIBLE = true,
    NO_CUT = true,
    PASS_WALL = true,
    TAKE_ITEM = true,
    UNDEAD = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ '60%', '90%' },
  drop = { treasure=50, combat=5, magic=30, tools=10, junk=5 },
  attacks = {
    { type=DamageType.FEAR, method=AttackType.TOUCH },
  },
  resolvers.talents {
    [Talents.T_NPC_BLINK] = 1,
  },
  body = bodies.none,
  speed = 20,
  vision = 8,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'YELLOW_JELLY',
  name = [[Yellow jelly]],
  display = 'j',
  color = colors.C_y,
  image = 'npc/yellow_jelly.png',
  desc = [[It's a large pile of yellow flesh.]],
  corpse_weight = 200,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 15,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 10, 8 },
  ac = 1,
  max_life = resolvers.dice(10, 8),
  rarity = 1,
  level = 3,
  start_level = 3,
  exp_worth = 12,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.DARK] = true,
    [DamageType.FEAR] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  vuln_dam = {
    [DamageType.LITE] = true,
    [DamageType.LITE_WEAK] = true,
  },
  flags = {
    BASEANGBAND = true,
    CAN_SWIM = true,
    EMPTY_MIND = true,
    NEVER_MOVE = true,
    NO_CUT = true,
    STUPID = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.POISON, method=AttackType.TOUCH, dam={1,3} },
  },
  resolvers.talents {
    [Talents.T_NPC_DRAIN_MANA] = 1,
  },
  body = bodies.none,
  speed = 10,
  vision = 2,
  alertness = 99,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'METALLIC_BLUE_CENTIPEDE',
  name = [[Metallic blue centipede]],
  display = 'c',
  color = colors.C_b,
  image = 'npc/metallic_blue_centipede.png',
  desc = [[It is about four feet long and carnivorous.]],
  corpse_weight = 77,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=50,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 4, 5 },
  ac = 6,
  max_life = resolvers.dice(4, 5),
  rarity = 1,
  level = 4,
  start_level = 4,
  exp_worth = 6,
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    MORTAL = true,
    WEIRD_MIND = true,
  },
  placement_flags = { WILD_TOO=true },
  drop_corpse = { skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CRAWL, dam={1,3} },
  },
  body = bodies.snake,
  speed = 10,
  vision = 6,
  alertness = 15,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'RAVEN',
  name = [[Raven]],
  display = 'B',
  color = colors.C_D,
  image = 'npc/raven.png',
  desc = [[Larger than a crow, and pitch black.]],
  corpse_weight = 50,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 4, 5 },
  ac = 12,
  max_life = resolvers.dice(4, 5),
  rarity = 2,
  level = 4,
  start_level = 4,
  exp_worth = 8,
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    FLY = true,
    HAS_EGG = true,
    MORTAL = true,
  },
  placement_flags = { WILD_TOO=true, WILD_WOOD=true },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={1,4} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={1,4} },
  },
  body = bodies.winged,
  speed = 10,
  vision = 40,
  alertness = 0,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'GIANT_WHITE_LOUSE',
  name = [[Giant white louse]],
  plural_name = [[Giant white lice]],
  display = 'I',
  color = colors.C_w,
  image = 'npc/giant_white_louse.png',
  desc = [[It is six inches long.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=75,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 1, 1 },
  ac = 5,
  max_life = resolvers.dice(1, 1),
  rarity = 1,
  level = 3,
  start_level = 3,
  exp_worth = 1,
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    FLY = true,
    MORTAL = true,
    MULTIPLY = true,
    WEIRD_MIND = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={1,1} },
  },
  body = bodies.none,
  speed = 10,
  vision = 6,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'GIANT_YELLOW_CENTIPEDE',
  name = [[Giant yellow centipede]],
  display = 'c',
  color = colors.C_y,
  image = 'npc/giant_yellow_centipede.png',
  desc = [[It is about four feet long and carnivorous.]],
  corpse_weight = 50,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=50,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 3, 6 },
  ac = 12,
  max_life = resolvers.dice(3, 6),
  rarity = 1,
  level = 2,
  start_level = 2,
  exp_worth = 3,
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    MORTAL = true,
    WEIRD_MIND = true,
  },
  placement_flags = { WILD_TOO=true },
  drop_corpse = { skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={1,3} },
    { type=DamageType.PHYSICAL, method=AttackType.STING, dam={1,3} },
  },
  body = bodies.snake,
  speed = 0,
  vision = 8,
  alertness = 30,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'BLACK_NAGA',
  name = [[Black naga]],
  display = 'n',
  color = colors.C_D,
  image = 'npc/black_naga.png',
  desc = [[A large black serpent's body with a female torso.]],
  corpse_weight = 170,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=25,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 6, 8 },
  ac = 40,
  max_life = resolvers.dice(6, 8),
  rarity = 1,
  level = 3,
  start_level = 3,
  exp_worth = 20,
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    CAN_SWIM = true,
    EVIL = true,
    FEMALE = true,
    MORTAL = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ '60%' },
  drop = { treasure=0, combat=75, magic=20, tools=5, junk=0 },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CRUSH, dam={1,8} },
  },
  body = bodies.snake,
  speed = 0,
  vision = 16,
  alertness = 120,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'SPOTTED_MUSHROOM_PATCH',
  name = [[Spotted mushroom patch]],
  display = ',',
  color = colors.C_o,
  image = 'npc/spotted_mushroom_patch.png',
  desc = [[Yum!  It looks quite tasty.]],
  corpse_weight = 3,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 1, 1 },
  ac = 1,
  max_life = resolvers.dice(1, 1),
  rarity = 1,
  level = 3,
  start_level = 3,
  exp_worth = 3,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.FEAR] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    EMPTY_MIND = true,
    NEVER_MOVE = true,
    NO_CUT = true,
    STUPID = true,
  },
  placement_flags = { WILD_SWAMP=true, WILD_TOO=true },
  attacks = {
    { type=DamageType.POISON, method=AttackType.SPORE, dam={2,4} },
  },
  body = bodies.none,
  speed = 0,
  vision = 2,
  alertness = 0,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'SILVER_JELLY',
  name = [[Silver jelly]],
  display = 'j',
  color = colors.C_W,
  image = 'npc/silver_jelly.png',
  desc = [[It is a large pile of silver flesh that sucks all light from its surroundings.]],
  corpse_weight = 200,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 15,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 10, 8 },
  ac = 1,
  max_life = resolvers.dice(10, 8),
  rarity = 2,
  level = 3,
  start_level = 3,
  exp_worth = 12,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.DARK] = true,
    [DamageType.FEAR] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  vuln_dam = {
    [DamageType.LITE] = true,
    [DamageType.LITE_WEAK] = true,
  },
  flags = {
    BASEANGBAND = true,
    CAN_SWIM = true,
    EMPTY_MIND = true,
    NEVER_MOVE = true,
    NO_CUT = true,
    STUPID = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.EAT_LITE, method=AttackType.TOUCH, dam={1,3} },
    { type=DamageType.EAT_LITE, method=AttackType.TOUCH, dam={1,3} },
  },
  resolvers.talents {
    [Talents.T_NPC_DRAIN_MANA] = 1,
  },
  body = bodies.none,
  speed = 10,
  vision = 2,
  alertness = 99,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'SCRUFFY_LOOKING_HOBBIT',
  name = [[Scruffy-looking hobbit]],
  display = 'h',
  color = colors.C_s,
  image = 'npc/scruffy_looking_hobbit.png',
  desc = [[A short little guy, in bedraggled clothes. He appears to be looking for a good tavern.]],
  corpse_weight = 100,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 3, 5 },
  ac = 8,
  max_life = resolvers.dice(3, 5),
  rarity = 1,
  level = 3,
  start_level = 3,
  exp_worth = 4,
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    EVIL = true,
    MALE = true,
    MORTAL = true,
    OPEN_DOOR = true,
    TAKE_ITEM = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ '60%' },
  drop = { treasure=0, combat=50, magic=0, tools=40, junk=10 },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,4} },
    { type=DamageType.EAT_GOLD, method=AttackType.TOUCH },
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 16,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'GIANT_WHITE_ANT',
  name = [[Giant white ant]],
  display = 'a',
  color = colors.C_w,
  image = 'npc/giant_white_ant.png',
  desc = [[It is about two feet long and has sharp pincers.]],
  corpse_weight = 80,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 3, 6 },
  ac = 16,
  max_life = resolvers.dice(3, 6),
  rarity = 1,
  level = 3,
  start_level = 3,
  exp_worth = 7,
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    MORTAL = true,
    WEIRD_MIND = true,
  },
  placement_flags = { WILD_GRASS=true, WILD_TOO=true },
  drop_corpse = { skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={1,4} },
  },
  body = bodies.quadruped,
  speed = 0,
  vision = 8,
  alertness = 80,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'YELLOW_MOLD',
  name = [[Yellow mold]],
  display = 'm',
  color = colors.C_y,
  image = 'npc/yellow_mold.png',
  desc = [[It is a strange growth on the dungeon floor.]],
  corpse_weight = 3,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 8, 8 },
  ac = 10,
  max_life = resolvers.dice(8, 8),
  rarity = 1,
  level = 3,
  start_level = 3,
  exp_worth = 9,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.FEAR] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    EMPTY_MIND = true,
    NEVER_MOVE = true,
    NO_CUT = true,
    STUPID = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.SPORE, dam={1,4} },
  },
  body = bodies.none,
  speed = 0,
  vision = 2,
  alertness = 99,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'METALLIC_RED_CENTIPEDE',
  name = [[Metallic red centipede]],
  display = 'c',
  color = colors.C_r,
  image = 'npc/metallic_red_centipede.png',
  desc = [[It is about four feet long and carnivorous.]],
  corpse_weight = 80,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=25,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 4, 8 },
  ac = 9,
  max_life = resolvers.dice(4, 8),
  rarity = 1,
  level = 5,
  start_level = 5,
  exp_worth = 10,
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    MORTAL = true,
    WEIRD_MIND = true,
  },
  placement_flags = { WILD_TOO=true },
  drop_corpse = { skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CRAWL, dam={2,3} },
  },
  body = bodies.snake,
  speed = 10,
  vision = 8,
  alertness = 20,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'YELLOW_WORM_MASS',
  name = [[Yellow worm mass]],
  display = 'w',
  color = colors.C_y,
  image = 'npc/yellow_worm_mass.png',
  desc = [[It is a large slimy mass of worms.]],
  corpse_weight = 20,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=75,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 4, 8 },
  ac = 4,
  max_life = resolvers.dice(4, 8),
  rarity = 2,
  level = 3,
  start_level = 3,
  exp_worth = 4,
  resist_dam = {
    [DamageType.DARK] = true,
    [DamageType.FEAR] = true,
  },
  vuln_dam = {
    [DamageType.LITE] = true,
    [DamageType.LITE_WEAK] = true,
  },
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    CAN_SWIM = true,
    MORTAL = true,
    MULTIPLY = true,
    NO_CUT = true,
    STUPID = true,
    WEIRD_MIND = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.LOSE_DEX, method=AttackType.CRAWL, dam={1,3} },
  },
  body = bodies.none,
  speed = -10,
  vision = 7,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'CLEAR_WORM_MASS',
  name = [[Clear worm mass]],
  display = 'w',
  color = colors.C_B,
  image = 'npc/clear_worm_mass.png',
  desc = [[It is a disgusting mass of poisonous worms.]],
  corpse_weight = 20,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=75,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 4, 4 },
  ac = 1,
  max_life = resolvers.dice(4, 4),
  rarity = 2,
  level = 3,
  start_level = 3,
  exp_worth = 4,
  resist_dam = {
    [DamageType.DARK] = true,
    [DamageType.FEAR] = true,
    [DamageType.POISON] = true,
  },
  vuln_dam = {
    [DamageType.LITE] = true,
    [DamageType.LITE_WEAK] = true,
  },
  flags = {
    ANIMAL = true,
    ATTR_CLEAR = true,
    BASEANGBAND = true,
    CAN_SWIM = true,
    INVISIBLE = true,
    MORTAL = true,
    MULTIPLY = true,
    NO_CUT = true,
    STUPID = true,
    WEIRD_MIND = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.POISON, method=AttackType.CRAWL, dam={1,2} },
  },
  body = bodies.none,
  speed = -10,
  vision = 7,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'RADIATION_EYE',
  name = [[Radiation eye]],
  display = 'e',
  color = colors.C_R,
  image = 'npc/radiation_eye.png',
  desc = [[A disembodied eye, crackling with energy.]],
  corpse_weight = 50,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 11,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 3, 6 },
  ac = 6,
  max_life = resolvers.dice(3, 6),
  rarity = 1,
  level = 3,
  start_level = 3,
  exp_worth = 6,
  resist_dam = {
    [DamageType.DARK] = true,
    [DamageType.FEAR] = true,
  },
  vuln_dam = {
    [DamageType.LITE] = true,
    [DamageType.LITE_WEAK] = true,
  },
  flags = {
    BASEANGBAND = true,
    FLY = true,
    HAS_LITE = true,
    NEVER_MOVE = true,
  },
  placement_flags = {},
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.LOSE_STR, method=AttackType.GAZE, dam={1,6} },
  },
  resolvers.talents {
    [Talents.T_NPC_DRAIN_MANA] = 1,
  },
  body = bodies.none,
  speed = 0,
  vision = 2,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'YELLOW_LIGHT',
  name = [[Yellow light]],
  display = '*',
  color = colors.C_y,
  image = 'npc/yellow_light.png',
  desc = [[A fast-moving bright light, apparently totally random in its movement.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=75,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 2, 6 },
  ac = 12,
  max_life = resolvers.dice(2, 6),
  rarity = 1,
  level = 4,
  start_level = 4,
  exp_worth = 4,
  vuln_dam = {
    [DamageType.ELEC] = true,
  },
  flags = {
    BASEANGBAND = true,
    EMPTY_MIND = true,
    FLY = true,
    HAS_LITE = true,
    NONLIVING = true,
    NO_CUT = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.BLIND, method=AttackType.EXPLODE },
  },
  body = bodies.none,
  speed = 10,
  vision = 8,
  alertness = 30,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'CAVE_LIZARD',
  name = [[Cave lizard]],
  display = 'R',
  color = colors.C_u,
  image = 'npc/cave_lizard.png',
  desc = [[It is an armoured lizard with a powerful bite.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 3, 6 },
  ac = 16,
  max_life = resolvers.dice(3, 6),
  rarity = 1,
  level = 4,
  start_level = 4,
  exp_worth = 8,
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    CAN_SWIM = true,
    HAS_EGG = true,
    MORTAL = true,
  },
  placement_flags = {},
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={1,5} },
  },
  body = bodies.quadruped,
  speed = 0,
  vision = 8,
  alertness = 80,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'NOVICE_RANGER',
  name = [[Novice ranger]],
  display = 'p',
  color = colors.C_W,
  image = 'npc/novice_ranger.png',
  desc = [[An agile hunter, ready and relaxed.]],
  corpse_weight = 140,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 9,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 6, 8 },
  ac = 8,
  max_life = resolvers.dice(6, 8),
  rarity = 1,
  level = 4,
  start_level = 4,
  exp_worth = 18,
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    FORCE_SLEEP = true,
    HAS_LITE = true,
    MALE = true,
    MORTAL = true,
    OPEN_DOOR = true,
  },
  placement_flags = { WILD_TOO=true, WILD_WOOD=true },
  resolvers.mon_inven{ '60%' },
  drop = { treasure=25, combat=45, magic=25, tools=0, junk=5 },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,5} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,5} },
  },
  resolvers.talents {
    [Talents.T_NPC_ARROW_2] = 1,
    [Talents.T_NPC_MISSILE] = 1,
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 20,
  alertness = 5,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'BLUE_JELLY',
  name = [[Blue jelly]],
  display = 'j',
  color = colors.C_b,
  image = 'npc/blue_jelly.png',
  desc = [[It's a large pile of pulsing blue flesh.]],
  corpse_weight = 200,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 12, 8 },
  ac = 1,
  max_life = resolvers.dice(12, 8),
  rarity = 1,
  level = 4,
  start_level = 4,
  exp_worth = 14,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.DARK] = true,
    [DamageType.FEAR] = true,
    [DamageType.OLD_SLEEP] = true,
  },
  vuln_dam = {
    [DamageType.FIRE] = true,
    [DamageType.LITE] = true,
    [DamageType.LITE_WEAK] = true,
  },
  flags = {
    BASEANGBAND = true,
    CAN_SWIM = true,
    COLD_BLOOD = true,
    EMPTY_MIND = true,
    NEVER_MOVE = true,
    NO_CUT = true,
    STUPID = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.COLD, method=AttackType.TOUCH, dam={1,6} },
  },
  body = bodies.none,
  speed = 0,
  vision = 2,
  alertness = 99,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'CREEPING_COPPER_COINS',
  name = [[Creeping copper coins]],
  self_plural = true,
  display = '$',
  color = colors.C_u,
  image = 'npc/creeping_copper_coins.png',
  desc = [[It appears to be a pile of copper coins, until it starts crawling towards you on tiny legs.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 7, 8 },
  ac = 24,
  max_life = resolvers.dice(7, 8),
  rarity = 3,
  level = 4,
  start_level = 4,
  exp_worth = 9,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.ELEC] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  vuln_dam = {
    [DamageType.ACID] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    CHAR_MULTI = true,
    COLD_BLOOD = true,
    NO_CUT = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ coin_type='COPPER_2', only_gold=true, '1d2' },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,4} },
    { type=DamageType.POISON, method=AttackType.TOUCH, dam={2,4} },
  },
  body = bodies.none,
  speed = -10,
  vision = 3,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'GIANT_WHITE_RAT',
  name = [[Giant white rat]],
  display = 'r',
  color = colors.C_W,
  image = 'npc/giant_white_rat.png',
  desc = [[It is a very vicious rodent.]],
  corpse_weight = 20,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=25,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 2, 2 },
  ac = 7,
  max_life = resolvers.dice(2, 2),
  rarity = 1,
  level = 4,
  start_level = 4,
  exp_worth = 1,
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    MORTAL = true,
    MULTIPLY = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.POISON, method=AttackType.BITE, dam={1,3} },
  },
  body = bodies.quadruped,
  speed = 0,
  vision = 8,
  alertness = 30,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'SNOTLING',
  name = [[Snotling]],
  display = 'o',
  color = colors.C_U,
  image = 'npc/snotling.png',
  desc = [[Immature Orclings, running wild and screaming all the time.]],
  corpse_weight = 90,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=50,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 5, 5 },
  ac = 32,
  max_life = resolvers.dice(5, 5),
  rarity = 1,
  level = 4,
  start_level = 4,
  exp_worth = 15,
  resist_dam = {
    [DamageType.DARK] = true,
  },
  vuln_dam = {
    [DamageType.LITE] = true,
    [DamageType.LITE_WEAK] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    EVIL = true,
    FRIENDS = true,
    HAS_LITE = true,
    MALE = true,
    MORTAL = true,
    OPEN_DOOR = true,
    ORC = true,
  },
  placement_flags = { WILD_TOO=true, WILD_WOOD=true },
  resolvers.mon_inven{ '60%' },
  drop = { treasure=25, combat=50, magic=0, tools=20, junk=5 },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,6} },
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 20,
  alertness = 30,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'SWORDFISH',
  name = [[Swordfish]],
  self_plural = true,
  display = '~',
  color = colors.C_W,
  image = 'npc/swordfish.png',
  desc = [[A fish with a swordlike "beak".]],
  corpse_weight = 80,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 4, 7 },
  ac = 10,
  max_life = resolvers.dice(4, 7),
  rarity = 2,
  level = 4,
  start_level = 4,
  exp_worth = 15,
  flags = {
    ANIMAL = true,
    AQUATIC = true,
    BASEANGBAND = true,
    COLD_BLOOD = true,
    MORTAL = true,
  },
  placement_flags = { WILD_TOO=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,5} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,5} },
  },
  body = bodies.snake,
  speed = 10,
  vision = 14,
  alertness = 20,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'BLUE_WORM_MASS',
  name = [[Blue worm mass]],
  display = 'w',
  color = colors.C_b,
  image = 'npc/blue_worm_mass.png',
  desc = [[It is a large slimy mass of worms.]],
  corpse_weight = 4,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=75,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 5, 8 },
  ac = 12,
  max_life = resolvers.dice(5, 8),
  rarity = 1,
  level = 4,
  start_level = 4,
  exp_worth = 5,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.DARK] = true,
    [DamageType.FEAR] = true,
  },
  vuln_dam = {
    [DamageType.FIRE] = true,
    [DamageType.LITE] = true,
    [DamageType.LITE_WEAK] = true,
  },
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    CAN_SWIM = true,
    COLD_BLOOD = true,
    MORTAL = true,
    MULTIPLY = true,
    NO_CUT = true,
    STUPID = true,
    WEIRD_MIND = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.COLD, method=AttackType.CRAWL, dam={1,4} },
  },
  body = bodies.none,
  speed = -10,
  vision = 7,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'LARGE_GREY_SNAKE',
  name = [[Large grey snake]],
  display = 'J',
  color = colors.C_s,
  image = 'npc/large_grey_snake.png',
  desc = [[It is about ten feet long.]],
  corpse_weight = 130,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=25,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 6, 8 },
  ac = 41,
  max_life = resolvers.dice(6, 8),
  rarity = 1,
  level = 4,
  start_level = 4,
  exp_worth = 14,
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    CAN_SWIM = true,
    HAS_EGG = true,
    MORTAL = true,
  },
  placement_flags = { WILD_TOO=true },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={1,5} },
    { type=DamageType.PHYSICAL, method=AttackType.CRUSH, dam={1,8} },
  },
  body = bodies.snake,
  speed = -10,
  vision = 6,
  alertness = 50,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'SKELETON_KOBOLD',
  name = [[Skeleton kobold]],
  display = 's',
  color = colors.C_W,
  image = 'npc/skeleton_kobold.png',
  desc = [[It is a small animated kobold skeleton.]],
  corpse_weight = 80,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 5, 8 },
  ac = 26,
  max_life = resolvers.dice(5, 8),
  rarity = 1,
  level = 5,
  start_level = 5,
  exp_worth = 12,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.FEAR] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    COLD_BLOOD = true,
    EMPTY_MIND = true,
    EVIL = true,
    NO_CUT = true,
    OPEN_DOOR = true,
    UNDEAD = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,6} },
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 20,
  alertness = 40,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'NOVICE_MAGE_GRP',
  name = [[Novice mage]],
  display = 'p',
  color = colors.C_r,
  image = 'npc/novice_mage_grp.png',
  desc = [[He is leaving behind a trail of dropped spell components.]],
  corpse_weight = 140,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 12,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 6, 4 },
  ac = 6,
  max_life = resolvers.dice(6, 4),
  rarity = 2,
  level = 6,
  start_level = 6,
  exp_worth = 6,
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    FORCE_SLEEP = true,
    FRIENDS = true,
    HAS_LITE = true,
    MALE = true,
    MORTAL = true,
    OPEN_DOOR = true,
  },
  placement_flags = { WILD_TOO=true },
  resolvers.mon_inven{ '60%' },
  drop = { treasure=25, combat=0, magic=70, tools=0, junk=5 },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,4} },
  },
  resolvers.talents {
    [Talents.T_NPC_BLINK] = 1,
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_MISSILE] = 1,
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 20,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'GREEN_NAGA',
  name = [[Green naga]],
  display = 'n',
  color = colors.C_g,
  image = 'npc/green_naga.png',
  desc = [[A large green serpent with a female torso. Her green skin glistens with acid.]],
  corpse_weight = 170,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=25,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 9, 8 },
  ac = 40,
  max_life = resolvers.dice(9, 8),
  rarity = 1,
  level = 5,
  start_level = 5,
  exp_worth = 30,
  resist_dam = {
    [DamageType.ACID] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    CAN_SWIM = true,
    EVIL = true,
    FEMALE = true,
    MORTAL = true,
    TAKE_ITEM = true,
  },
  placement_flags = { WILD_SHORE=true, WILD_TOO=true },
  resolvers.mon_inven{ '60%' },
  drop = { treasure=0, combat=25, magic=0, tools=65, junk=10 },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CRUSH, dam={1,8} },
    { type=DamageType.ACID, method=AttackType.SPIT, dam={2,6} },
  },
  body = bodies.snake,
  speed = 0,
  vision = 18,
  alertness = 120,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'GIANT_LEECH',
  name = [[Giant leech]],
  display = 'w',
  color = colors.C_u,
  image = 'npc/giant_leech.png',
  desc = [[Yech! The disgusting thing only wants your blood!]],
  corpse_weight = 3,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=25,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 6, 8 },
  ac = 20,
  max_life = resolvers.dice(6, 8),
  rarity = 1,
  level = 5,
  start_level = 5,
  exp_worth = 20,
  flags = {
    ANIMAL = true,
    AQUATIC = true,
    BASEANGBAND = true,
    WEIRD_MIND = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={3,1} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={3,1} },
  },
  body = bodies.snake,
  speed = 10,
  vision = 10,
  alertness = 50,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'BARRACUDA',
  name = [[Barracuda]],
  display = '~',
  color = colors.C_G,
  image = 'npc/barracuda.png',
  desc = [[A predatory fish with razor-sharp teeth.]],
  corpse_weight = 15,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 6, 8 },
  ac = 45,
  max_life = resolvers.dice(6, 8),
  rarity = 2,
  level = 5,
  start_level = 5,
  exp_worth = 30,
  flags = {
    ANIMAL = true,
    AQUATIC = true,
    BASEANGBAND = true,
    COLD_BLOOD = true,
    MORTAL = true,
  },
  placement_flags = { WILD_TOO=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={1,10} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={1,10} },
  },
  body = bodies.snake,
  speed = 10,
  vision = 20,
  alertness = 20,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'NOVICE_PALADIN',
  name = [[Novice paladin]],
  display = 'p',
  color = colors.C_w,
  image = 'npc/novice_paladin.png',
  desc = [[An adventurer both devoutly religious and skilful in combat. He seems to consider you an agent of the devil.]],
  corpse_weight = 170,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 9,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 6, 8 },
  ac = 16,
  faction = 'eru_manwe',
  max_life = resolvers.dice(6, 8),
  rarity = 1,
  level = 4,
  start_level = 4,
  exp_worth = 18,
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    FORCE_SLEEP = true,
    GOOD = true,
    HAS_LITE = true,
    MALE = true,
    MORTAL = true,
    OPEN_DOOR = true,
  },
  placement_flags = { WILD_TOO=true },
  resolvers.mon_inven{ '60%' },
  drop = { treasure=0, combat=70, magic=25, tools=0, junk=5 },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,7} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,7} },
  },
  resolvers.talents {
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_CAUSE_1] = 1,
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 20,
  alertness = 5,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'BLUE_OOZE',
  name = [[Blue ooze]],
  display = 'j',
  color = colors.C_b,
  image = 'npc/blue_ooze.png',
  desc = [[It's blue and it's oozing.]],
  corpse_weight = 30,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=75,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 3, 4 },
  ac = 16,
  max_life = resolvers.dice(3, 4),
  rarity = 1,
  level = 5,
  start_level = 5,
  exp_worth = 7,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.FEAR] = true,
    [DamageType.OLD_SLEEP] = true,
  },
  vuln_dam = {
    [DamageType.FIRE] = true,
  },
  flags = {
    BASEANGBAND = true,
    CAN_SWIM = true,
    EMPTY_MIND = true,
    NO_CUT = true,
    STUPID = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ '60%' },
  drop = { treasure=45, combat=20, magic=20, tools=0, junk=15 },
  attacks = {
    { type=DamageType.COLD, method=AttackType.CRAWL, dam={1,4} },
  },
  body = bodies.none,
  speed = 0,
  vision = 8,
  alertness = 80,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'GREEN_GLUTTON_GHOST',
  name = [[Green glutton ghost]],
  display = 'G',
  color = colors.C_g,
  image = 'npc/green_glutton_ghost.png',
  desc = [[It is a very ugly green ghost with a voracious appetite.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=75,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 3, 4 },
  ac = 20,
  max_life = resolvers.dice(3, 4),
  rarity = 1,
  level = 5,
  start_level = 5,
  exp_worth = 15,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.OLD_SLEEP] = true,
  },
  flags = {
    BASEANGBAND = true,
    COLD_BLOOD = true,
    EVIL = true,
    FLY = true,
    INVISIBLE = true,
    NO_CUT = true,
    PASS_WALL = true,
    UNDEAD = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ '60%', '90%' },
  drop = { treasure=30, combat=30, magic=30, tools=5, junk=5 },
  attacks = {
    { type=DamageType.EAT_FOOD, method=AttackType.TOUCH, dam={1,1} },
  },
  body = bodies.none,
  speed = 20,
  vision = 10,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'GREEN_JELLY',
  name = [[Green jelly]],
  display = 'j',
  color = colors.C_g,
  image = 'npc/green_jelly.png',
  desc = [[It is a large pile of pulsing green flesh.]],
  corpse_weight = 250,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 22, 8 },
  ac = 1,
  max_life = resolvers.dice(22, 8),
  rarity = 1,
  level = 5,
  start_level = 5,
  exp_worth = 18,
  resist_dam = {
    [DamageType.ACID] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.DARK] = true,
    [DamageType.FEAR] = true,
    [DamageType.OLD_SLEEP] = true,
  },
  vuln_dam = {
    [DamageType.LITE] = true,
    [DamageType.LITE_WEAK] = true,
  },
  flags = {
    BASEANGBAND = true,
    CAN_SWIM = true,
    EMPTY_MIND = true,
    NEVER_MOVE = true,
    NO_CUT = true,
    STUPID = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.ACID, method=AttackType.TOUCH, dam={1,2} },
  },
  body = bodies.none,
  speed = 10,
  vision = 2,
  alertness = 99,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'LARGE_KOBOLD',
  name = [[Large kobold]],
  display = 'k',
  color = colors.C_b,
  image = 'npc/large_kobold.png',
  desc = [[It a man-sized figure with the all too recognisable face of a kobold.]],
  corpse_weight = 100,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 13, 9 },
  ac = 32,
  max_life = resolvers.dice(13, 9),
  rarity = 1,
  level = 5,
  start_level = 5,
  exp_worth = 25,
  resist_dam = {
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    EVIL = true,
    HAS_LITE = true,
    MORTAL = true,
    OPEN_DOOR = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ '90%' },
  drop = { treasure=0, combat=90, magic=0, tools=5, junk=5 },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,10} },
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 20,
  alertness = 30,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'GREY_ICKY_THING',
  name = [[Grey icky thing]],
  display = 'i',
  color = colors.C_s,
  image = 'npc/grey_icky_thing.png',
  desc = [[It is a smallish, slimy, icky, nasty creature.]],
  corpse_weight = 50,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=50,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 4, 8 },
  ac = 12,
  max_life = resolvers.dice(4, 8),
  rarity = 1,
  level = 5,
  start_level = 5,
  exp_worth = 10,
  flags = {
    BASEANGBAND = true,
    CAN_SWIM = true,
    EMPTY_MIND = true,
  },
  placement_flags = {},
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.TOUCH, dam={1,5} },
  },
  body = bodies.none,
  speed = 0,
  vision = 14,
  alertness = 15,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'DISENCHANTER_EYE',
  name = [[Disenchanter eye]],
  display = 'e',
  color = colors.C_v,
  image = 'npc/disenchanter_eye.png',
  desc = [[A disembodied eye, crackling with magic.]],
  corpse_weight = 50,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 9,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 7, 8 },
  ac = 10,
  max_life = resolvers.dice(7, 8),
  rarity = 2,
  level = 5,
  start_level = 5,
  exp_worth = 20,
  resist_dam = {
    [DamageType.DARK] = true,
    [DamageType.DISEASE] = true,
    [DamageType.FEAR] = true,
  },
  vuln_dam = {
    [DamageType.LITE] = true,
    [DamageType.LITE_WEAK] = true,
  },
  flags = {
    ATTR_ANY = true,
    ATTR_MULTI = true,
    BASEANGBAND = true,
    FLY = true,
    NEVER_MOVE = true,
  },
  placement_flags = {},
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.DISENCHANT, method=AttackType.GAZE },
  },
  resolvers.talents {
    [Talents.T_NPC_DRAIN_MANA] = 1,
  },
  body = bodies.none,
  speed = -10,
  vision = 2,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'RED_WORM_MASS',
  name = [[Red worm mass]],
  display = 'w',
  color = colors.C_r,
  image = 'npc/red_worm_mass.png',
  desc = [[It is a large slimy mass of worms.]],
  corpse_weight = 4,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=75,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 5, 8 },
  ac = 12,
  max_life = resolvers.dice(5, 8),
  rarity = 1,
  level = 5,
  start_level = 5,
  exp_worth = 6,
  resist_dam = {
    [DamageType.DARK] = true,
    [DamageType.FEAR] = true,
    [DamageType.FIRE] = true,
  },
  vuln_dam = {
    [DamageType.COLD] = true,
    [DamageType.LITE] = true,
    [DamageType.LITE_WEAK] = true,
  },
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    CAN_SWIM = true,
    EMPTY_MIND = true,
    MORTAL = true,
    MULTIPLY = true,
    NO_CUT = true,
    STUPID = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.FIRE, method=AttackType.CRAWL, dam={1,6} },
  },
  body = bodies.none,
  speed = -10,
  vision = 7,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'COPPERHEAD_SNAKE',
  name = [[Copperhead snake]],
  display = 'J',
  color = colors.C_o,
  image = 'npc/copperhead_snake.png',
  desc = [[It has a copper head and sharp venomous fangs.]],
  corpse_weight = 20,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=50,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 4, 6 },
  ac = 20,
  max_life = resolvers.dice(4, 6),
  rarity = 1,
  level = 5,
  start_level = 5,
  exp_worth = 15,
  resist_dam = {
    [DamageType.POISON] = true,
  },
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    CAN_SWIM = true,
    HAS_EGG = true,
    MORTAL = true,
  },
  placement_flags = { WILD_TOO=true },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.POISON, method=AttackType.BITE, dam={2,4} },
  },
  body = bodies.snake,
  speed = 0,
  vision = 6,
  alertness = 1,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'DEATH_SWORD',
  name = [[Death sword]],
  display = '|',
  color = colors.C_W,
  image = 'npc/death_sword.png',
  desc = [[A bloodthirsty blade lurking for prey. Beware!]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 6, 6 },
  ac = 40,
  max_life = 36,
  rarity = 5,
  level = 6,
  start_level = 6,
  exp_worth = 30,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.ELEC] = true,
    [DamageType.FEAR] = true,
    [DamageType.FIRE] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  vuln_dam = {
    [DamageType.ACID] = true,
  },
  flags = {
    BASEANGBAND = true,
    CHAR_MULTI = true,
    COLD_BLOOD = true,
    EMPTY_MIND = true,
    EVIL = true,
    FORCE_MAXHP = true,
    HAS_LITE = true,
    NEVER_MOVE = true,
    NONLIVING = true,
    NO_CUT = true,
    STUPID = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ '90%' },
  drop = { treasure=50, combat=0, magic=50, tools=0, junk=0 },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={5,5} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={5,5} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={5,5} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={5,5} },
  },
  body = bodies.none,
  speed = 20,
  vision = 20,
  alertness = 0,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'PURPLE_MUSHROOM_PATCH',
  name = [[Purple mushroom patch]],
  display = ',',
  color = colors.C_v,
  image = 'npc/purple_mushroom_patch.png',
  desc = [[Yuk!  It doesn't look so tasty.]],
  corpse_weight = 4,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 1, 1 },
  ac = 1,
  max_life = resolvers.dice(1, 1),
  rarity = 2,
  level = 6,
  start_level = 6,
  exp_worth = 15,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.FEAR] = true,
    [DamageType.OLD_SLEEP] = true,
  },
  flags = {
    BASEANGBAND = true,
    CAN_SWIM = true,
    EMPTY_MIND = true,
    NEVER_MOVE = true,
    NO_CUT = true,
    STUPID = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.LOSE_CON, method=AttackType.SPORE, dam={1,2} },
    { type=DamageType.LOSE_CON, method=AttackType.SPORE, dam={1,2} },
    { type=DamageType.LOSE_CON, method=AttackType.SPORE, dam={1,2} },
  },
  body = bodies.none,
  speed = 0,
  vision = 2,
  alertness = 0,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'NOVICE_PRIEST_GRP',
  name = [[Novice priest]],
  display = 'p',
  color = colors.C_g,
  image = 'npc/novice_priest_grp.png',
  desc = [[He is tripping over his priestly robes.]],
  corpse_weight = 150,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 12,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 7, 4 },
  ac = 10,
  faction = 'eru_manwe',
  max_life = resolvers.dice(7, 4),
  rarity = 2,
  level = 6,
  start_level = 6,
  exp_worth = 6,
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    FORCE_SLEEP = true,
    FRIENDS = true,
    GOOD = true,
    HAS_LITE = true,
    MALE = true,
    MORTAL = true,
    OPEN_DOOR = true,
  },
  placement_flags = { WILD_TOO=true },
  resolvers.mon_inven{ '60%' },
  drop = { treasure=20, combat=50, magic=20, tools=5, junk=5 },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,5} },
  },
  resolvers.talents {
    [Talents.T_NPC_HEAL] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_CAUSE_1] = 1,
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 20,
  alertness = 5,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'NOVICE_WARRIOR_GRP',
  name = [[Novice warrior]],
  display = 'p',
  color = colors.C_u,
  image = 'npc/novice_warrior_grp.png',
  desc = [[He looks inexperienced but tough.]],
  corpse_weight = 160,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 9, 4 },
  ac = 16,
  max_life = resolvers.dice(9, 4),
  rarity = 2,
  level = 6,
  start_level = 6,
  exp_worth = 6,
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    FRIENDS = true,
    HAS_LITE = true,
    MALE = true,
    MORTAL = true,
    OPEN_DOOR = true,
  },
  placement_flags = { WILD_TOO=true },
  resolvers.mon_inven{ '60%' },
  drop = { treasure=0, combat=95, magic=0, tools=0, junk=5 },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,7} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,6} },
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 20,
  alertness = 5,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'BROWN_MOLD',
  name = [[Brown mold]],
  display = 'm',
  color = colors.C_u,
  image = 'npc/brown_mold.png',
  desc = [[A strange brown growth on the dungeon floor.]],
  corpse_weight = 5,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 15, 8 },
  ac = 12,
  max_life = resolvers.dice(15, 8),
  rarity = 1,
  level = 6,
  start_level = 6,
  exp_worth = 20,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.FEAR] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    CAN_SWIM = true,
    EMPTY_MIND = true,
    NEVER_MOVE = true,
    NO_CUT = true,
    STUPID = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.CONFUSION, method=AttackType.SPORE, dam={1,4} },
  },
  body = bodies.none,
  speed = 0,
  vision = 2,
  alertness = 99,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'GIANT_BROWN_BAT',
  name = [[Giant brown bat]],
  display = 'b',
  color = colors.C_u,
  image = 'npc/giant_brown_bat.png',
  desc = [[It screeches as it attacks.]],
  corpse_weight = 60,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=50,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 3, 8 },
  ac = 15,
  max_life = resolvers.dice(3, 8),
  rarity = 1,
  level = 6,
  start_level = 6,
  exp_worth = 10,
  flags = {
    AI_ANNOY = true,
    ANIMAL = true,
    BASEANGBAND = true,
    FLY = true,
    MORTAL = true,
  },
  placement_flags = { WILD_MOUNTAIN=true, WILD_TOO=true, WILD_WOOD=true },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={1,3} },
  },
  body = bodies.winged,
  speed = 20,
  vision = 10,
  alertness = 30,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'NOVICE_ROGUE_GRP',
  name = [[Novice rogue]],
  display = 'p',
  color = colors.C_b,
  image = 'npc/novice_rogue_grp.png',
  desc = [[A rather shifty individual.]],
  corpse_weight = 140,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 8, 4 },
  ac = 12,
  max_life = resolvers.dice(8, 4),
  rarity = 2,
  level = 6,
  start_level = 6,
  exp_worth = 6,
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    EVIL = true,
    FRIENDS = true,
    MALE = true,
    MORTAL = true,
    OPEN_DOOR = true,
    TAKE_ITEM = true,
  },
  placement_flags = { WILD_TOO=true },
  resolvers.mon_inven{ '60%' },
  drop = { treasure=50, combat=25, magic=0, tools=20, junk=5 },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,6} },
    { type=DamageType.EAT_GOLD, method=AttackType.TOUCH },
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 20,
  alertness = 5,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'CREEPING_SILVER_COINS',
  name = [[Creeping silver coins]],
  self_plural = true,
  display = '$',
  color = colors.C_s,
  image = 'npc/creeping_silver_coins.png',
  desc = [[It appears to be a pile of silver coins, until it starts crawling towards you on tiny legs.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 12, 8 },
  ac = 30,
  max_life = resolvers.dice(12, 8),
  rarity = 3,
  level = 6,
  start_level = 6,
  exp_worth = 18,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.ELEC] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  vuln_dam = {
    [DamageType.ACID] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    CHAR_MULTI = true,
    COLD_BLOOD = true,
    NO_CUT = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ coin_type='SILVER_2', only_gold=true, '1d2', '60%' },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,6} },
    { type=DamageType.POISON, method=AttackType.TOUCH, dam={2,6} },
  },
  body = bodies.none,
  speed = -10,
  vision = 4,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'SNAGA',
  name = [[Snaga]],
  display = 'o',
  color = colors.C_U,
  image = 'npc/snaga.png',
  desc = [[He is one of the many weaker 'slave' orcs, often mistakenly known as a goblin.]],
  corpse_weight = 160,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 8, 8 },
  ac = 32,
  max_life = resolvers.dice(8, 8),
  rarity = 1,
  level = 6,
  start_level = 6,
  exp_worth = 15,
  resist_dam = {
    [DamageType.DARK] = true,
  },
  vuln_dam = {
    [DamageType.LITE] = true,
    [DamageType.LITE_WEAK] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    EVIL = true,
    FRIENDS = true,
    HAS_LITE = true,
    MALE = true,
    MORTAL = true,
    OPEN_DOOR = true,
    ORC = true,
  },
  placement_flags = { WILD_TOO=true },
  resolvers.mon_inven{ '60%' },
  drop = { treasure=20, combat=50, magic=5, tools=15, junk=10 },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,8} },
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 20,
  alertness = 30,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'RATTLESNAKE',
  name = [[Rattlesnake]],
  display = 'J',
  color = colors.C_r,
  image = 'npc/rattlesnake.png',
  desc = [[It is recognised by the hard-scaled end of its body that is often rattled to frighten its prey.]],
  corpse_weight = 20,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=50,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 6, 7 },
  ac = 24,
  max_life = resolvers.dice(6, 7),
  rarity = 1,
  level = 6,
  start_level = 6,
  exp_worth = 20,
  resist_dam = {
    [DamageType.POISON] = true,
  },
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    CAN_SWIM = true,
    HAS_EGG = true,
    MORTAL = true,
  },
  placement_flags = { WILD_TOO=true },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.POISON, method=AttackType.BITE, dam={2,5} },
  },
  body = bodies.snake,
  speed = 0,
  vision = 6,
  alertness = 1,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'GIANT_SLUG',
  name = [[Giant slug]],
  display = 'w',
  color = colors.C_U,
  image = 'npc/giant_slug.png',
  desc = [[It is slowly making its way towards you, eating everything in its path...]],
  corpse_weight = 60,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 10,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 12, 9 },
  ac = 25,
  max_life = resolvers.dice(12, 9),
  rarity = 1,
  level = 6,
  start_level = 6,
  exp_worth = 25,
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    CAN_SWIM = true,
    EMPTY_MIND = true,
    KILL_BODY = true,
    KILL_ITEM = true,
    MORTAL = true,
  },
  placement_flags = { WILD_TOO=true },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.ACID, method=AttackType.BITE, dam={2,4} },
    { type=DamageType.ACID, method=AttackType.BITE, dam={2,6} },
  },
  resolvers.talents {
    [Talents.T_NPC_BR_ACID] = 1,
  },
  body = bodies.snake,
  speed = -10,
  vision = 10,
  alertness = 25,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'GIANT_PINK_FROG',
  name = [[Giant pink frog]],
  display = 'R',
  color = colors.C_r,
  image = 'npc/giant_pink_frog.png',
  desc = [[It looks poisonous.]],
  corpse_weight = 20,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=50,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 5, 8 },
  ac = 16,
  max_life = resolvers.dice(5, 8),
  rarity = 1,
  level = 7,
  start_level = 7,
  exp_worth = 16,
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    MORTAL = true,
  },
  placement_flags = { WILD_ONLY=true, WILD_SHORE=true, WILD_SWAMP=true },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.LOSE_STR, method=AttackType.BITE, dam={2,4} },
  },
  body = bodies.quadruped,
  speed = 0,
  vision = 12,
  alertness = 50,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'DARK_ELF',
  name = [[Dark elf]],
  plural_name = [[Dark elves]],
  display = 'h',
  color = colors.C_D,
  image = 'npc/dark_elf.png',
  desc = [[An elven figure with jet black skin and white hair, his eyes are large and twisted with evil.]],
  corpse_weight = 120,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 10,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 7, 10 },
  ac = 16,
  max_life = resolvers.dice(7, 10),
  rarity = 2,
  level = 7,
  start_level = 7,
  exp_worth = 25,
  resist_dam = {
    [DamageType.DARK] = true,
  },
  vuln_dam = {
    [DamageType.LITE] = true,
    [DamageType.LITE_WEAK] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    EVIL = true,
    FORCE_SLEEP = true,
    HAS_LITE = true,
    MALE = true,
    OPEN_DOOR = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ '90%' },
  drop = { treasure=20, combat=20, magic=50, tools=10, junk=0 },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,6} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,6} },
  },
  resolvers.talents {
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_DARKNESS] = 1,
    [Talents.T_NPC_MISSILE] = 1,
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 20,
  alertness = 20,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'ZOMBIFIED_KOBOLD',
  name = [[Zombified kobold]],
  display = 'z',
  color = colors.C_s,
  image = 'npc/zombified_kobold.png',
  desc = [[It is an animated kobold corpse. Flesh falls off in large chunks as it shambles forward.]],
  corpse_weight = 75,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 6, 8 },
  ac = 14,
  max_life = resolvers.dice(6, 8),
  rarity = 1,
  level = 7,
  start_level = 7,
  exp_worth = 14,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.FEAR] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    COLD_BLOOD = true,
    EMPTY_MIND = true,
    EVIL = true,
    NO_CUT = true,
    OPEN_DOOR = true,
    UNDEAD = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,2} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,2} },
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 20,
  alertness = 30,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'CRYPT_CREEP',
  name = [[Crypt creep]],
  display = 's',
  color = colors.C_D,
  image = 'npc/crypt_creep.png',
  desc = [[A frightening skeletal figure in a black robe.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=25,
    talent_in = 10,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 6, 8 },
  ac = 12,
  max_life = resolvers.dice(6, 8),
  rarity = 2,
  level = 7,
  start_level = 7,
  exp_worth = 25,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.DARK] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  vuln_dam = {
    [DamageType.LITE] = true,
    [DamageType.LITE_WEAK] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    COLD_BLOOD = true,
    EVIL = true,
    FRIENDS = true,
    NO_CUT = true,
    OPEN_DOOR = true,
    UNDEAD = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={1,2} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={1,2} },
    { type=DamageType.POISON, method=AttackType.BITE },
  },
  resolvers.talents {
    [Talents.T_NPC_CAUSE_1] = 1,
    [Talents.T_NPC_S_UNDEAD] = 1,
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 20,
  alertness = 14,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'ROTTING_CORPSE',
  name = [[Rotting corpse]],
  display = 'z',
  color = colors.C_R,
  image = 'npc/rotting_corpse.png',
  desc = [[Corpses awakened from their sleep by dark sorcery.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 8, 8 },
  ac = 20,
  max_life = resolvers.dice(8, 8),
  rarity = 1,
  level = 8,
  start_level = 8,
  exp_worth = 15,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.FEAR] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    COLD_BLOOD = true,
    EMPTY_MIND = true,
    EVIL = true,
    FRIENDS = true,
    NO_CUT = true,
    OPEN_DOOR = true,
    UNDEAD = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.POISON, method=AttackType.CLAW, dam={1,3} },
    { type=DamageType.POISON, method=AttackType.CLAW, dam={1,3} },
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 20,
  alertness = 20,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'CAVE_ORC',
  name = [[Cave orc]],
  display = 'o',
  color = colors.C_G,
  image = 'npc/cave_orc.png',
  desc = [[He is often found in huge numbers in deep caves.]],
  corpse_weight = 190,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 11, 9 },
  ac = 32,
  max_life = resolvers.dice(11, 9),
  rarity = 1,
  level = 7,
  start_level = 7,
  exp_worth = 20,
  resist_dam = {
    [DamageType.DARK] = true,
  },
  vuln_dam = {
    [DamageType.LITE] = true,
    [DamageType.LITE_WEAK] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    EVIL = true,
    FRIENDS = true,
    HAS_LITE = true,
    MALE = true,
    MORTAL = true,
    OPEN_DOOR = true,
    ORC = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ '60%' },
  drop = { treasure=20, combat=70, magic=0, tools=0, junk=10 },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,8} },
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 20,
  alertness = 30,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'WOOD_SPIDER',
  name = [[Wood spider]],
  display = 'S',
  color = colors.C_U,
  image = 'npc/wood_spider.png',
  desc = [[It scuttles towards you.]],
  corpse_weight = 60,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 3, 6 },
  ac = 16,
  max_life = resolvers.dice(3, 6),
  rarity = 3,
  level = 7,
  start_level = 7,
  exp_worth = 15,
  resist_dam = {
    [DamageType.POISON] = true,
  },
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    FRIENDS = true,
    MORTAL = true,
    SPIDER = true,
    WEIRD_MIND = true,
  },
  placement_flags = { WILD_TOO=true, WILD_WOOD=true },
  drop_corpse = { skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={1,3} },
    { type=DamageType.POISON, method=AttackType.STING, dam={1,4} },
  },
  body = bodies.quadruped,
  speed = 10,
  vision = 8,
  alertness = 80,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'MANES',
  name = [[Manes]],
  self_plural = true,
  display = 'u',
  color = colors.C_r,
  image = 'npc/manes.png',
  desc = [[It is a minor but aggressive demon.]],
  corpse_weight = 30,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 8, 8 },
  ac = 32,
  max_life = resolvers.dice(8, 8),
  rarity = 2,
  level = 7,
  start_level = 7,
  exp_worth = 16,
  resist_dam = {
    [DamageType.FEAR] = true,
    [DamageType.FIRE] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    DEMON = true,
    EVIL = true,
    FRIENDS = true,
    OPEN_DOOR = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,8} },
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 20,
  alertness = 30,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'BLOODSHOT_EYE',
  name = [[Bloodshot eye]],
  display = 'e',
  color = colors.C_r,
  image = 'npc/bloodshot_eye.png',
  desc = [[A disembodied eye, bloodshot and nasty.]],
  corpse_weight = 55,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 7,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 10, 8 },
  ac = 6,
  max_life = resolvers.dice(10, 8),
  rarity = 3,
  level = 7,
  start_level = 7,
  exp_worth = 30,
  resist_dam = {
    [DamageType.DARK] = true,
    [DamageType.FEAR] = true,
  },
  vuln_dam = {
    [DamageType.LITE] = true,
    [DamageType.LITE_WEAK] = true,
  },
  flags = {
    BASEANGBAND = true,
    FLY = true,
    NEVER_MOVE = true,
    NO_CUT = true,
  },
  placement_flags = {},
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.BLIND, method=AttackType.GAZE, dam={2,6} },
  },
  resolvers.talents {
    [Talents.T_NPC_DRAIN_MANA] = 1,
  },
  body = bodies.none,
  speed = 0,
  vision = 2,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'RED_NAGA',
  name = [[Red naga]],
  display = 'n',
  color = colors.C_r,
  image = 'npc/red_naga.png',
  desc = [[A large red snake with a woman's torso.]],
  corpse_weight = 180,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=25,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 11, 8 },
  ac = 40,
  max_life = resolvers.dice(11, 8),
  rarity = 2,
  level = 7,
  start_level = 7,
  exp_worth = 40,
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    CAN_SWIM = true,
    EVIL = true,
    FEMALE = true,
    MORTAL = true,
    TAKE_ITEM = true,
  },
  placement_flags = { WILD_SHORE=true, WILD_TOO=true },
  resolvers.mon_inven{ '60%' },
  drop = { treasure=50, combat=0, magic=50, tools=0, junk=0 },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CRUSH, dam={1,10} },
    { type=DamageType.LOSE_STR, method=AttackType.BITE, dam={1,4} },
  },
  body = bodies.snake,
  speed = 0,
  vision = 20,
  alertness = 120,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'RED_JELLY',
  name = [[Red jelly]],
  display = 'j',
  color = colors.C_r,
  image = 'npc/red_jelly.png',
  desc = [[It is a large pulsating mound of red flesh.]],
  corpse_weight = 250,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 26, 8 },
  ac = 1,
  max_life = resolvers.dice(26, 8),
  rarity = 1,
  level = 7,
  start_level = 7,
  exp_worth = 26,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.DARK] = true,
    [DamageType.FEAR] = true,
    [DamageType.OLD_SLEEP] = true,
  },
  vuln_dam = {
    [DamageType.LITE] = true,
    [DamageType.LITE_WEAK] = true,
  },
  flags = {
    BASEANGBAND = true,
    CAN_SWIM = true,
    EMPTY_MIND = true,
    NEVER_MOVE = true,
    NO_CUT = true,
    STUPID = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.LOSE_STR, method=AttackType.TOUCH, dam={1,5} },
  },
  body = bodies.none,
  speed = 0,
  vision = 2,
  alertness = 99,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'GREEN_ICKY_THING',
  name = [[Green icky thing]],
  display = 'i',
  color = colors.C_g,
  image = 'npc/green_icky_thing.png',
  desc = [[It is a smallish, slimy, icky, acidic creature.]],
  corpse_weight = 50,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=50,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 5, 8 },
  ac = 12,
  max_life = resolvers.dice(5, 8),
  rarity = 2,
  level = 7,
  start_level = 7,
  exp_worth = 18,
  resist_dam = {
    [DamageType.ACID] = true,
  },
  flags = {
    BASEANGBAND = true,
    CAN_SWIM = true,
    EMPTY_MIND = true,
  },
  placement_flags = {},
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.ACID, method=AttackType.TOUCH, dam={2,5} },
  },
  body = bodies.none,
  speed = 0,
  vision = 14,
  alertness = 20,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'LOST_SOUL',
  name = [[Lost soul]],
  display = 'G',
  color = colors.C_W,
  image = 'npc/lost_soul.png',
  desc = [[It is almost insubstantial.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=50,
    talent_in = 15,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 2, 8 },
  ac = 10,
  max_life = resolvers.dice(2, 8),
  rarity = 2,
  level = 7,
  start_level = 7,
  exp_worth = 18,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.OLD_SLEEP] = true,
  },
  flags = {
    BASEANGBAND = true,
    COLD_BLOOD = true,
    EVIL = true,
    FLY = true,
    INVISIBLE = true,
    NO_CUT = true,
    PASS_WALL = true,
    TAKE_ITEM = true,
    UNDEAD = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ '60%', '90%' },
  drop = { treasure=60, combat=0, magic=25, tools=0, junk=15 },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={2,2} },
    { type=DamageType.LOSE_WIS, method=AttackType.TOUCH },
  },
  resolvers.talents {
    [Talents.T_NPC_TPORT] = 1,
    [Talents.T_NPC_DRAIN_MANA] = 1,
  },
  body = bodies.none,
  speed = 0,
  vision = 12,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'NIGHT_LIZARD',
  name = [[Night lizard]],
  display = 'R',
  color = colors.C_b,
  image = 'npc/night_lizard.png',
  desc = [[It is a black lizard with overlapping scales and a powerful jaw.]],
  corpse_weight = 40,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 4, 8 },
  ac = 16,
  max_life = resolvers.dice(4, 8),
  rarity = 2,
  level = 7,
  start_level = 7,
  exp_worth = 35,
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    CAN_SWIM = true,
    HAS_EGG = true,
    MORTAL = true,
  },
  placement_flags = { WILD_TOO=true },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={1,6} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={1,6} },
  },
  body = bodies.quadruped,
  speed = 0,
  vision = 20,
  alertness = 30,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'MUGHASH_THE_KOBOLD_LORD',
  name = [[Mughash, the Kobold Lord]],
  display = 'k',
  color = colors.C_v,
  image = 'npc/mughash_the_kobold_lord.png',
  desc = [[Strong and powerful, for a kobold.]],
  corpse_weight = 110,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 17, 10 },
  ac = 20,
  max_life = 170,
  rarity = 3,
  level = 7,
  start_level = 7,
  exp_worth = 100,
  unique = 'MUGHASH_THE_KOBOLD_LORD',
  resist_dam = {
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    CAN_SPEAK = true,
    ESCORT = true,
    ESCORTS = true,
    EVIL = true,
    FORCE_MAXHP = true,
    HAS_LITE = true,
    MALE = true,
    MORTAL = true,
    OPEN_DOOR = true,
    UNIQUE = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, only_item=true, '1d2' },
  drop = { treasure=0, combat=100, magic=0, tools=0, junk=0 },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,12} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,12} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,12} },
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 20,
  alertness = 20,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'SKELETON_ORC',
  name = [[Skeleton orc]],
  display = 's',
  color = colors.C_W,
  image = 'npc/skeleton_orc.png',
  desc = [[It is an animated orc skeleton.]],
  corpse_weight = 170,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 10, 8 },
  ac = 36,
  max_life = resolvers.dice(10, 8),
  rarity = 1,
  level = 8,
  start_level = 8,
  exp_worth = 26,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.DARK] = true,
    [DamageType.FEAR] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    COLD_BLOOD = true,
    EMPTY_MIND = true,
    EVIL = true,
    NO_CUT = true,
    OPEN_DOOR = true,
    ORC = true,
    UNDEAD = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={2,5} },
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 20,
  alertness = 40,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'WORMTONGUE_AGENT_OF_SARUMAN',
  name = [[Wormtongue, Agent of Saruman]],
  display = 'p',
  color = colors.C_B,
  image = 'npc/wormtongue_agent_of_saruman.png',
  desc = [[He's been spying for Saruman. He is a snivelling wretch with no morals.]],
  corpse_weight = 150,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 5,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 28, 10 },
  ac = 30,
  max_life = 280,
  rarity = 2,
  level = 9,
  start_level = 9,
  exp_worth = 150,
  unique = 'WORMTONGUE_AGENT_OF_SARUMAN',
  resist_dam = {
    [DamageType.TELEPORT] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    CAN_SPEAK = true,
    EVIL = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    HAS_LITE = true,
    MALE = true,
    MORTAL = true,
    OPEN_DOOR = true,
    TAKE_ITEM = true,
    UNIQUE = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, great=true, only_item=true, '1d2' },
  drop = { treasure=10, combat=50, magic=35, tools=0, junk=5 },
  drop_corpse = { skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,7} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,7} },
    { type=DamageType.EAT_GOLD, method=AttackType.TOUCH },
    { method=AttackType.INSULT },
  },
  resolvers.talents {
    [Talents.T_NPC_HEAL] = 1,
    [Talents.T_NPC_SLOW] = 1,
    [Talents.T_NPC_TRAPS] = 1,
    [Talents.T_NPC_BO_COLD] = 1,
    [Talents.T_NPC_BA_POIS] = 1,
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 20,
  alertness = 20,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'LAGDUF_THE_SNAGA',
  name = [[Lagduf, the Snaga]],
  display = 'o',
  color = colors.C_y,
  image = 'npc/lagduf_the_snaga.png',
  desc = [[A captain of a regiment of weaker orcs, Lagduf keeps his troop in order with displays of excessive violence.]],
  corpse_weight = 170,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 22, 10 },
  ac = 32,
  max_life = 220,
  level = 8,
  start_level = 8,
  exp_worth = 80,
  unique = 'LAGDUF_THE_SNAGA',
  resist_dam = {
    [DamageType.DARK] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    CAN_SPEAK = true,
    ESCORT = true,
    EVIL = true,
    FORCE_MAXHP = true,
    HAS_LITE = true,
    MALE = true,
    MORTAL = true,
    OPEN_DOOR = true,
    ORC = true,
    SPECIAL_GENE = true,
    UNIQUE = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, only_item=true, '1d2' },
  drop = { treasure=10, combat=80, magic=0, tools=0, junk=10 },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,11} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,11} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,10} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,10} },
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 20,
  alertness = 30,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'BROWN_YEEK',
  name = [[Brown yeek]],
  display = 'y',
  color = colors.C_u,
  image = 'npc/brown_yeek.png',
  desc = [[It is a strange small humanoid.]],
  corpse_weight = 80,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 4, 8 },
  ac = 18,
  max_life = resolvers.dice(4, 8),
  rarity = 1,
  level = 8,
  start_level = 8,
  exp_worth = 11,
  resist_dam = {
    [DamageType.ACID] = true,
  },
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    MORTAL = true,
    OPEN_DOOR = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ '60%' },
  drop = { treasure=0, combat=50, magic=0, tools=30, junk=20 },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,6} },
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 18,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'NOVICE_RANGER_GRP',
  name = [[Novice ranger]],
  display = 'p',
  color = colors.C_W,
  image = 'npc/novice_ranger_grp.png',
  desc = [[An agile hunter, ready and relaxed.]],
  corpse_weight = 150,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 9,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 6, 8 },
  ac = 8,
  max_life = resolvers.dice(6, 8),
  rarity = 2,
  level = 8,
  start_level = 8,
  exp_worth = 18,
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    FORCE_SLEEP = true,
    FRIENDS = true,
    HAS_LITE = true,
    MALE = true,
    MORTAL = true,
    OPEN_DOOR = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ '60%' },
  drop = { treasure=0, combat=80, magic=0, tools=15, junk=5 },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,5} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,5} },
  },
  resolvers.talents {
    [Talents.T_NPC_ARROW_2] = 1,
    [Talents.T_NPC_MISSILE] = 1,
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 20,
  alertness = 5,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'GIANT_SALAMANDER',
  name = [[Giant salamander]],
  display = 'R',
  color = colors.C_R,
  image = 'npc/giant_salamander.png',
  desc = [[A large black and yellow lizard. You'd better run away!]],
  corpse_weight = 60,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=25,
    talent_in = 9,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 6, 7 },
  ac = 40,
  max_life = resolvers.dice(6, 7),
  rarity = 1,
  level = 8,
  start_level = 8,
  exp_worth = 50,
  resist_dam = {
    [DamageType.FIRE] = true,
  },
  vuln_dam = {
    [DamageType.COLD] = true,
  },
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    CAN_SWIM = true,
    FORCE_SLEEP = true,
    MORTAL = true,
  },
  placement_flags = {},
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.FIRE, method=AttackType.BITE, dam={3,6} },
  },
  resolvers.talents {
    [Talents.T_NPC_BR_FIRE] = 1,
  },
  body = bodies.quadruped,
  speed = 0,
  vision = 6,
  alertness = 1,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'GREEN_MOLD',
  name = [[Green mold]],
  display = 'm',
  color = colors.C_g,
  image = 'npc/green_mold.png',
  desc = [[It is a strange growth on the dungeon floor.]],
  corpse_weight = 4,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 21, 8 },
  ac = 14,
  max_life = resolvers.dice(21, 8),
  rarity = 1,
  level = 8,
  start_level = 8,
  exp_worth = 28,
  resist_dam = {
    [DamageType.ACID] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.FEAR] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    CAN_SWIM = true,
    EMPTY_MIND = true,
    NEVER_MOVE = true,
    NO_CUT = true,
    STUPID = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.FEAR, method=AttackType.SPORE, dam={1,4} },
  },
  body = bodies.none,
  speed = 0,
  vision = 2,
  alertness = 75,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'NOVICE_PALADIN_GRP',
  name = [[Novice paladin]],
  display = 'p',
  color = colors.C_w,
  image = 'npc/novice_paladin_grp.png',
  desc = [[He thinks you are an agent of the devil.]],
  corpse_weight = 150,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 9,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 6, 8 },
  ac = 16,
  faction = 'eru_manwe',
  max_life = resolvers.dice(6, 8),
  rarity = 2,
  level = 8,
  start_level = 8,
  exp_worth = 18,
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    FORCE_SLEEP = true,
    FRIENDS = true,
    GOOD = true,
    HAS_LITE = true,
    MALE = true,
    MORTAL = true,
    OPEN_DOOR = true,
  },
  placement_flags = { WILD_TOO=true },
  resolvers.mon_inven{ '60%' },
  drop = { treasure=30, combat=55, magic=10, tools=0, junk=5 },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,7} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,7} },
  },
  resolvers.talents {
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_CAUSE_1] = 1,
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 20,
  alertness = 5,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'LEMURE',
  name = [[Lemure]],
  display = 'u',
  color = colors.C_U,
  image = 'npc/lemure.png',
  desc = [[It is the larval form of a major demon.]],
  corpse_weight = 100,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 13, 9 },
  ac = 32,
  max_life = resolvers.dice(13, 9),
  rarity = 3,
  level = 8,
  start_level = 8,
  exp_worth = 16,
  resist_dam = {
    [DamageType.FEAR] = true,
    [DamageType.FIRE] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    DEMON = true,
    EVIL = true,
    FRIENDS = true,
    OPEN_DOOR = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,8} },
  },
  body = bodies.snake,
  speed = 0,
  vision = 20,
  alertness = 30,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'HILL_ORC',
  name = [[Hill orc]],
  display = 'o',
  color = colors.C_u,
  image = 'npc/hill_orc.png',
  desc = [[He is a hardy well-weathered survivor.]],
  corpse_weight = 200,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 13, 9 },
  ac = 32,
  max_life = resolvers.dice(13, 9),
  rarity = 1,
  level = 8,
  start_level = 8,
  exp_worth = 25,
  resist_dam = {
    [DamageType.DARK] = true,
  },
  vuln_dam = {
    [DamageType.LITE] = true,
    [DamageType.LITE_WEAK] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    EVIL = true,
    FRIENDS = true,
    HAS_LITE = true,
    MALE = true,
    MORTAL = true,
    OPEN_DOOR = true,
    ORC = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ '60%' },
  drop = { treasure=10, combat=70, magic=10, tools=0, junk=10 },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,10} },
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 20,
  alertness = 30,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'BANDIT',
  name = [[Bandit]],
  display = 'p',
  color = colors.C_b,
  image = 'npc/bandit.png',
  desc = [[He is after your possessions!]],
  corpse_weight = 150,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 8, 8 },
  ac = 24,
  max_life = resolvers.dice(8, 8),
  rarity = 2,
  level = 10,
  start_level = 10,
  exp_worth = 26,
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    EVIL = true,
    HAS_LITE = true,
    MALE = true,
    MORTAL = true,
    OPEN_DOOR = true,
    TAKE_ITEM = true,
  },
  placement_flags = { WILD_TOO=true, WILD_WOOD=true },
  resolvers.mon_inven{ '1d2' },
  drop = { treasure=25, combat=60, magic=0, tools=0, junk=15 },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={2,4} },
    { type=DamageType.EAT_GOLD, method=AttackType.TOUCH },
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 20,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'HUNTING_HAWK',
  name = [[Hunting hawk]],
  display = 'B',
  color = colors.C_u,
  image = 'npc/hunting_hawk.png',
  desc = [[Trained to hunt and kill without fear.]],
  corpse_weight = 80,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 8, 8 },
  ac = 25,
  max_life = resolvers.dice(8, 8),
  rarity = 2,
  level = 8,
  start_level = 8,
  exp_worth = 22,
  resist_dam = {
    [DamageType.FEAR] = true,
  },
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    FLY = true,
    HAS_EGG = true,
    MORTAL = true,
  },
  placement_flags = { WILD_TOO=true, WILD_WOOD=true },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={1,3} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={1,3} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={1,4} },
  },
  body = bodies.winged,
  speed = 10,
  vision = 30,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'PHANTOM_WARRIOR',
  name = [[Phantom warrior]],
  display = 'G',
  color = colors.C_B,
  image = 'npc/phantom_warrior.png',
  desc = [[Spectral creatures that are half real, half illusion.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 5, 5 },
  ac = 10,
  max_life = resolvers.dice(5, 5),
  rarity = 1,
  level = 8,
  start_level = 8,
  exp_worth = 15,
  resist_dam = {
    [DamageType.FEAR] = true,
    [DamageType.OLD_SLEEP] = true,
  },
  flags = {
    BASEANGBAND = true,
    COLD_BLOOD = true,
    EMPTY_MIND = true,
    FLY = true,
    FRIENDS = true,
    NONLIVING = true,
    NO_CUT = true,
    PASS_WALL = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,11} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,11} },
  },
  body = bodies.none,
  speed = 0,
  vision = 20,
  alertness = 40,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'YETI',
  name = [[Yeti]],
  self_plural = true,
  display = 'Y',
  color = colors.C_w,
  image = 'npc/yeti.png',
  desc = [[A large white figure covered in shaggy fur.]],
  corpse_weight = 350,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 11, 9 },
  ac = 24,
  max_life = resolvers.dice(11, 9),
  rarity = 3,
  level = 9,
  start_level = 9,
  exp_worth = 30,
  resist_dam = {
    [DamageType.COLD] = true,
  },
  vuln_dam = {
    [DamageType.FIRE] = true,
  },
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    MORTAL = true,
    OPEN_DOOR = true,
  },
  placement_flags = { WILD_MOUNTAIN=true, WILD_TOO=true },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={1,3} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={1,3} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={1,4} },
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 20,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'BLOODSHOT_ICKY_THING',
  name = [[Bloodshot icky thing]],
  display = 'i',
  color = colors.C_r,
  image = 'npc/bloodshot_icky_thing.png',
  desc = [[It is a strange, slimy, icky creature.]],
  corpse_weight = 6,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=50,
    talent_in = 11,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 7, 8 },
  ac = 18,
  max_life = resolvers.dice(7, 8),
  rarity = 3,
  level = 9,
  start_level = 9,
  exp_worth = 24,
  resist_dam = {
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    CAN_SWIM = true,
    EMPTY_MIND = true,
  },
  placement_flags = {},
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.TOUCH, dam={1,4} },
    { type=DamageType.ACID, method=AttackType.CRAWL, dam={2,4} },
  },
  resolvers.talents {
    [Talents.T_NPC_DRAIN_MANA] = 1,
  },
  body = bodies.none,
  speed = 0,
  vision = 14,
  alertness = 20,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'GIANT_GREY_RAT',
  name = [[Giant grey rat]],
  display = 'r',
  color = colors.C_s,
  image = 'npc/giant_grey_rat.png',
  desc = [[It is a rodent of unusual size.]],
  corpse_weight = 25,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=25,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 2, 3 },
  ac = 12,
  max_life = resolvers.dice(2, 3),
  rarity = 1,
  level = 9,
  start_level = 9,
  exp_worth = 2,
  resist_dam = {
    [DamageType.POISON] = true,
  },
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    MORTAL = true,
    MULTIPLY = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.POISON, method=AttackType.BITE, dam={1,4} },
  },
  body = bodies.quadruped,
  speed = 0,
  vision = 8,
  alertness = 20,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'BLACK_HARPY',
  name = [[Black harpy]],
  display = 'H',
  color = colors.C_D,
  image = 'npc/black_harpy.png',
  desc = [[A woman's face on the body of a vicious black bird.]],
  corpse_weight = 60,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=25,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 3, 8 },
  ac = 22,
  max_life = resolvers.dice(3, 8),
  rarity = 1,
  level = 9,
  start_level = 9,
  exp_worth = 19,
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    EVIL = true,
    FEMALE = true,
    FLY = true,
    MORTAL = true,
  },
  placement_flags = { WILD_MOUNTAIN=true, WILD_TOO=true },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={1,2} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={1,2} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={1,3} },
  },
  body = bodies.winged,
  speed = 10,
  vision = 16,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'THE_WOUNDED_BEAR',
  name = [[The wounded bear]],
  display = 'q',
  color = colors.C_r,
  image = 'npc/the_wounded_bear.png',
  desc = [[A wounded bear, who has occasionally attacked humans.]],
  corpse_weight = 300,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 11, 10 },
  ac = 35,
  max_life = 110,
  rarity = 1,
  level = 12,
  start_level = 12,
  exp_worth = 30,
  unique = 'THE_WOUNDED_BEAR',
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    MORTAL = true,
    UNIQUE = true,
  },
  placement_flags = { WILD_GRASS=true, WILD_MOUNTAIN=true, WILD_ONLY=true, WILD_WOOD=true },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={1,10} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={1,10} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={1,11} },
  },
  body = bodies.quadruped,
  speed = 0,
  vision = 10,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'CAVE_BEAR',
  name = [[Cave bear]],
  display = 'q',
  color = colors.C_u,
  image = 'npc/cave_bear.png',
  desc = [[A large bear appears to have made its home in this cave.  It is hungry, and you are trespassing in its territory.]],
  corpse_weight = 300,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 8, 8 },
  ac = 35,
  max_life = 64,
  rarity = 1,
  level = 9,
  start_level = 9,
  exp_worth = 25,
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    MORTAL = true,
  },
  placement_flags = { WILD_MOUNTAIN=true, WILD_TOO=true, WILD_WOOD=true },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={1,6} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={1,6} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={1,8} },
  },
  body = bodies.quadruped,
  speed = 0,
  vision = 10,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'ROCK_MOLE',
  name = [[Rock mole]],
  display = 'r',
  color = colors.C_s,
  image = 'npc/rock_mole.png',
  desc = [[Despite its unimpressive size, this mole creature has fangs powerful enough to bore through solid rock.]],
  corpse_weight = 6,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 10, 10 },
  ac = 30,
  max_life = resolvers.dice(10, 10),
  rarity = 2,
  level = 9,
  start_level = 9,
  exp_worth = 25,
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    KILL_ITEM = true,
    KILL_WALL = true,
    MORTAL = true,
    WEIRD_MIND = true,
  },
  placement_flags = {},
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={1,10} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={1,10} },
  },
  body = bodies.quadruped,
  speed = 0,
  vision = 20,
  alertness = 75,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'MINDCRAFTER',
  name = [[Mindcrafter]],
  display = 'p',
  color = colors.C_y,
  image = 'npc/mindcrafter.png',
  desc = [[A master of the mental arts, able to damage or dominate the minds of others.]],
  corpse_weight = 170,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 3,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 9, 8 },
  ac = 15,
  max_life = resolvers.dice(9, 8),
  rarity = 2,
  level = 16,
  start_level = 16,
  exp_worth = 50,
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    EVIL = true,
    FORCE_SLEEP = true,
    HAS_LITE = true,
    MALE = true,
    MORTAL = true,
    OPEN_DOOR = true,
  },
  placement_flags = { WILD_TOO=true },
  resolvers.mon_inven{ '90%' },
  drop = { treasure=30, combat=40, magic=30, tools=0, junk=0 },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={2,4} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={2,4} },
  },
  resolvers.talents {
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_HOLD] = 1,
    [Talents.T_NPC_SLOW] = 1,
    [Talents.T_NPC_MIND_BLAST] = 1,
    [Talents.T_NPC_S_MONSTER] = 1,
    [Talents.T_NPC_BLINK] = 1,
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 20,
  alertness = 20,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'BABY_BLUE_DRAGON',
  name = [[Baby blue dragon]],
  display = 'd',
  color = colors.C_b,
  multi_colors = { colors.C_b, colors.C_B },
  image = 'npc/baby_blue_dragon.png',
  desc = [[This hatchling dragon is still soft, its eyes unaccustomed to light and its scales a pale blue.]],
  corpse_weight = 400,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 12,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 10, 10 },
  ac = 30,
  max_life = 100,
  rarity = 2,
  level = 9,
  start_level = 9,
  exp_worth = 35,
  resist_dam = {
    [DamageType.ELEC] = true,
  },
  flags = {
    ATTR_MULTI = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    DRAGON = true,
    EVIL = true,
    FLY = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    HAS_EGG = true,
    IMPRESED = true,
    OPEN_DOOR = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ only_gold=true, '1d2', '60%' },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={1,3} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={1,3} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={1,5} },
  },
  resolvers.talents {
    [Talents.T_NPC_BR_ELEC] = 1,
  },
  body = bodies.dragon,
  speed = 0,
  vision = 20,
  alertness = 70,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'BABY_WHITE_DRAGON',
  name = [[Baby white dragon]],
  display = 'd',
  color = colors.C_w,
  multi_colors = { colors.C_w, colors.C_W },
  image = 'npc/baby_white_dragon.png',
  desc = [[This hatchling dragon is still soft, its eyes unaccustomed to light and its scales a pale white.]],
  corpse_weight = 400,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 12,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 10, 10 },
  ac = 30,
  max_life = 100,
  rarity = 2,
  level = 9,
  start_level = 9,
  exp_worth = 35,
  resist_dam = {
    [DamageType.COLD] = true,
  },
  vuln_dam = {
    [DamageType.FIRE] = true,
  },
  flags = {
    ATTR_MULTI = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    DRAGON = true,
    EVIL = true,
    FLY = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    HAS_EGG = true,
    IMPRESED = true,
    OPEN_DOOR = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ only_gold=true, '1d2', '60%' },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={1,3} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={1,3} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={1,5} },
  },
  resolvers.talents {
    [Talents.T_NPC_BR_COLD] = 1,
  },
  body = bodies.dragon,
  speed = 0,
  vision = 20,
  alertness = 70,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'BABY_GREEN_DRAGON',
  name = [[Baby green dragon]],
  display = 'd',
  color = colors.C_g,
  multi_colors = { colors.C_g, colors.C_G },
  image = 'npc/baby_green_dragon.png',
  desc = [[This hatchling dragon is still soft, its eyes unaccustomed to light and its scales a sickly green.]],
  corpse_weight = 400,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 12,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 10, 10 },
  ac = 30,
  max_life = 100,
  rarity = 2,
  level = 9,
  start_level = 9,
  exp_worth = 35,
  resist_dam = {
    [DamageType.POISON] = true,
  },
  flags = {
    ATTR_MULTI = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    DRAGON = true,
    EVIL = true,
    FLY = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    HAS_EGG = true,
    IMPRESED = true,
    OPEN_DOOR = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ only_gold=true, '1d2', '60%' },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={1,3} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={1,3} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={1,5} },
  },
  resolvers.talents {
    [Talents.T_NPC_BR_POIS] = 1,
  },
  body = bodies.dragon,
  speed = 0,
  vision = 20,
  alertness = 70,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'BABY_BLACK_DRAGON',
  name = [[Baby black dragon]],
  display = 'd',
  color = colors.C_s,
  multi_colors = { colors.C_d, colors.C_D },
  image = 'npc/baby_black_dragon.png',
  desc = [[This hatchling dragon is still soft, its eyes unaccustomed to light and its scales a dull black.]],
  corpse_weight = 400,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 12,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 10, 10 },
  ac = 30,
  max_life = 100,
  rarity = 2,
  level = 9,
  start_level = 9,
  exp_worth = 35,
  resist_dam = {
    [DamageType.ACID] = true,
  },
  flags = {
    ATTR_MULTI = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    DRAGON = true,
    EVIL = true,
    FLY = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    HAS_EGG = true,
    IMPRESED = true,
    OPEN_DOOR = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ only_gold=true, '1d2', '60%' },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={1,3} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={1,3} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={1,5} },
  },
  resolvers.talents {
    [Talents.T_NPC_BR_ACID] = 1,
  },
  body = bodies.dragon,
  speed = 0,
  vision = 20,
  alertness = 70,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'BABY_RED_DRAGON',
  name = [[Baby red dragon]],
  display = 'd',
  color = colors.C_r,
  multi_colors = { colors.C_r, colors.C_R },
  image = 'npc/baby_red_dragon.png',
  desc = [[This hatchling dragon is still soft, its eyes unaccustomed to light and its scales a pale red.]],
  corpse_weight = 400,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 11,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 10, 10 },
  ac = 30,
  max_life = 100,
  rarity = 2,
  level = 9,
  start_level = 9,
  exp_worth = 35,
  resist_dam = {
    [DamageType.FIRE] = true,
  },
  vuln_dam = {
    [DamageType.COLD] = true,
  },
  flags = {
    ATTR_MULTI = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    DRAGON = true,
    EVIL = true,
    FLY = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    HAS_EGG = true,
    HAS_LITE = true,
    IMPRESED = true,
    OPEN_DOOR = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ only_gold=true, '1d2', '60%' },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={1,3} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={1,3} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={1,5} },
  },
  resolvers.talents {
    [Talents.T_NPC_BR_FIRE] = 1,
  },
  body = bodies.dragon,
  speed = 0,
  vision = 20,
  alertness = 70,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'GIANT_RED_ANT',
  name = [[Giant red ant]],
  display = 'a',
  color = colors.C_r,
  image = 'npc/giant_red_ant.png',
  desc = [[It is large and has venomous mandibles.]],
  corpse_weight = 60,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 4, 8 },
  ac = 34,
  max_life = resolvers.dice(4, 8),
  rarity = 2,
  level = 9,
  start_level = 9,
  exp_worth = 22,
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    HAS_LITE = true,
    MORTAL = true,
    WEIRD_MIND = true,
  },
  placement_flags = { WILD_TOO=true },
  drop_corpse = { skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={1,4} },
    { type=DamageType.LOSE_STR, method=AttackType.STING, dam={1,4} },
  },
  body = bodies.quadruped,
  speed = 0,
  vision = 12,
  alertness = 60,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'BRODDA_THE_EASTERLING',
  name = [[Brodda, the Easterling]],
  display = 'p',
  color = colors.C_U,
  image = 'npc/brodda_the_easterling.png',
  desc = [[A nasty piece of work, Brodda picks on defenceless women and children.]],
  corpse_weight = 220,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 24, 10 },
  ac = 25,
  max_life = 240,
  rarity = 2,
  level = 9,
  start_level = 9,
  exp_worth = 100,
  unique = 'BRODDA_THE_EASTERLING',
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    CAN_SPEAK = true,
    EVIL = true,
    FORCE_MAXHP = true,
    HAS_LITE = true,
    MALE = true,
    MORTAL = true,
    OPEN_DOOR = true,
    UNIQUE = true,
  },
  placement_flags = { WILD_TOO=true },
  resolvers.mon_inven{ good=true, only_item=true, '1d2' },
  drop = { treasure=10, combat=90, magic=0, tools=0, junk=0 },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,13} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,13} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,13} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,13} },
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 20,
  alertness = 20,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'BLOODFANG_THE_WOLF',
  name = [[Bloodfang, the Wolf]],
  display = 'C',
  color = colors.C_R,
  image = 'npc/bloodfang_the_wolf.png',
  desc = [[It has been terrorising the nearby villages.]],
  corpse_weight = 160,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 8, 6 },
  ac = 30,
  max_life = 48,
  rarity = 1,
  level = 9,
  start_level = 9,
  exp_worth = 30,
  unique = 'BLOODFANG_THE_WOLF',
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    FORCE_MAXHP = true,
    MORTAL = true,
    UNIQUE = true,
  },
  placement_flags = { WILD_GRASS=true, WILD_ONLY=true, WILD_WOOD=true },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={1,12} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={1,12} },
  },
  body = bodies.quadruped,
  speed = 10,
  vision = 30,
  alertness = 20,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'KING_COBRA',
  name = [[King cobra]],
  display = 'J',
  color = colors.C_g,
  image = 'npc/king_cobra.png',
  desc = [[It is a large snake with a hooded face.]],
  corpse_weight = 30,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=50,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 8, 10 },
  ac = 30,
  max_life = resolvers.dice(8, 10),
  rarity = 2,
  level = 9,
  start_level = 9,
  exp_worth = 28,
  resist_dam = {
    [DamageType.POISON] = true,
  },
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    CAN_SWIM = true,
    HAS_EGG = true,
    MORTAL = true,
  },
  placement_flags = { WILD_SWAMP=true, WILD_TOO=true, WILD_WOOD=true },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.BLIND, method=AttackType.SPIT, dam={1,2} },
    { type=DamageType.POISON, method=AttackType.BITE, dam={3,4} },
  },
  body = bodies.snake,
  speed = 0,
  vision = 8,
  alertness = 1,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'EAGLE',
  name = [[Eagle]],
  display = 'B',
  color = colors.C_u,
  image = 'npc/eagle.png',
  desc = [[A magnificent huge predatory bird.]],
  corpse_weight = 60,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 9, 9 },
  ac = 25,
  max_life = resolvers.dice(9, 9),
  rarity = 2,
  level = 12,
  start_level = 12,
  exp_worth = 22,
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    FLY = true,
    HAS_EGG = true,
    MORTAL = true,
  },
  placement_flags = { WILD_MOUNTAIN=true, WILD_ONLY=true, WILD_WASTE=true, WILD_WOOD=true },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={1,3} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={1,3} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={1,6} },
  },
  body = bodies.winged,
  speed = 10,
  vision = 30,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'WAR_BEAR',
  name = [[War bear]],
  display = 'q',
  color = colors.C_u,
  image = 'npc/war_bear.png',
  desc = [[Bears with tusks, trained to kill.]],
  corpse_weight = 200,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 10, 10 },
  ac = 35,
  max_life = resolvers.dice(10, 10),
  rarity = 1,
  level = 9,
  start_level = 9,
  exp_worth = 25,
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    FRIENDS = true,
    MORTAL = true,
    WEIRD_MIND = true,
  },
  placement_flags = {},
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={1,4} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={1,4} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={1,6} },
  },
  body = bodies.quadruped,
  speed = 0,
  vision = 10,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'KILLER_BEE',
  name = [[Killer bee]],
  display = 'I',
  color = colors.C_y,
  image = 'npc/killer_bee.png',
  desc = [[It is poisonous and aggressive.]],
  corpse_weight = 5,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 2, 4 },
  ac = 34,
  max_life = resolvers.dice(2, 4),
  rarity = 2,
  level = 9,
  start_level = 9,
  exp_worth = 22,
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    FLY = true,
    FRIENDS = true,
    MORTAL = true,
    WEIRD_MIND = true,
  },
  placement_flags = { WILD_TOO=true },
  attacks = {
    { type=DamageType.POISON, method=AttackType.STING, dam={1,4} },
    { type=DamageType.LOSE_STR, method=AttackType.STING, dam={1,4} },
  },
  body = bodies.none,
  speed = 10,
  vision = 12,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'GIANT_SPIDER',
  name = [[Giant spider]],
  display = 'S',
  color = colors.C_v,
  image = 'npc/giant_spider.png',
  desc = [[It is a vast spider whose bulbous body is bloated with poison.]],
  corpse_weight = 70,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 10, 10 },
  ac = 16,
  max_life = resolvers.dice(10, 10),
  rarity = 2,
  level = 10,
  start_level = 10,
  exp_worth = 35,
  resist_dam = {
    [DamageType.POISON] = true,
  },
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    MORTAL = true,
    SPIDER = true,
    WEIRD_MIND = true,
  },
  placement_flags = { WILD_TOO=true },
  drop_corpse = { skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={1,10} },
    { type=DamageType.POISON, method=AttackType.BITE, dam={1,6} },
    { type=DamageType.POISON, method=AttackType.BITE, dam={1,6} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={1,10} },
  },
  body = bodies.quadruped,
  speed = 0,
  vision = 8,
  alertness = 80,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'GIANT_WHITE_TICK',
  name = [[Giant white tick]],
  display = 'S',
  color = colors.C_w,
  image = 'npc/giant_white_tick.png',
  desc = [[It is moving slowly towards you.]],
  corpse_weight = 20,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 12, 8 },
  ac = 40,
  max_life = resolvers.dice(12, 8),
  rarity = 2,
  level = 10,
  start_level = 10,
  exp_worth = 27,
  resist_dam = {
    [DamageType.POISON] = true,
  },
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    FLY = true,
    MORTAL = true,
    WEIRD_MIND = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.POISON, method=AttackType.BITE, dam={2,6} },
  },
  body = bodies.quadruped,
  speed = -10,
  vision = 12,
  alertness = 20,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'DARK_ELVEN_MAGE',
  name = [[Dark elven mage]],
  display = 'h',
  color = colors.C_r,
  image = 'npc/dark_elven_mage.png',
  desc = [[A dark elven figure, dressed all in black, hurling spells at you.]],
  corpse_weight = 120,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 5,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 7, 10 },
  ac = 16,
  max_life = resolvers.dice(7, 10),
  rarity = 1,
  level = 10,
  start_level = 10,
  exp_worth = 50,
  resist_dam = {
    [DamageType.DARK] = true,
    [DamageType.POISON] = true,
  },
  vuln_dam = {
    [DamageType.LITE] = true,
    [DamageType.LITE_WEAK] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    EVIL = true,
    FORCE_SLEEP = true,
    HAS_LITE = true,
    MALE = true,
    OPEN_DOOR = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ only_item=true, '1d2' },
  drop = { treasure=0, combat=0, magic=100, tools=0, junk=0 },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,6} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,6} },
  },
  resolvers.talents {
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_MISSILE] = 1,
    [Talents.T_NPC_DARKNESS] = 1,
    [Talents.T_NPC_BA_POIS] = 1,
  },
  body = bodies.humanoid,
  speed = 10,
  vision = 20,
  alertness = 20,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'ORFAX_SON_OF_BOLDOR',
  name = [[Orfax, Son of Boldor]],
  display = 'y',
  color = colors.C_B,
  image = 'npc/orfax_son_of_boldor.png',
  desc = [[He's just like his daddy!  He knows mighty spells, but fortunately he is a yeek.]],
  corpse_weight = 60,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 4,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 14, 10 },
  ac = 20,
  max_life = 140,
  rarity = 3,
  level = 11,
  start_level = 11,
  exp_worth = 80,
  unique = 'ORFAX_SON_OF_BOLDOR',
  resist_dam = {
    [DamageType.ACID] = true,
  },
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    CAN_SPEAK = true,
    ESCORT = true,
    ESCORTS = true,
    EVIL = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    MALE = true,
    MORTAL = true,
    OPEN_DOOR = true,
    SMART = true,
    UNIQUE = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, only_item=true, '90%' },
  drop = { treasure=0, combat=50, magic=50, tools=0, junk=0 },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,10} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,9} },
    { method=AttackType.INSULT },
    { method=AttackType.INSULT },
  },
  resolvers.talents {
    [Talents.T_NPC_HEAL] = 1,
    [Talents.T_NPC_BLINK] = 1,
    [Talents.T_NPC_TELE_TO] = 1,
    [Talents.T_NPC_SLOW] = 1,
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_S_MONSTER] = 1,
  },
  body = bodies.humanoid,
  speed = 10,
  vision = 18,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'DARK_ELVEN_WARRIOR',
  name = [[Dark elven warrior]],
  display = 'h',
  color = colors.C_u,
  image = 'npc/dark_elven_warrior.png',
  desc = [[A dark elven figure in armour, ready with his sword.]],
  corpse_weight = 140,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 12,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 10, 11 },
  ac = 16,
  max_life = resolvers.dice(10, 11),
  rarity = 1,
  level = 10,
  start_level = 10,
  exp_worth = 50,
  resist_dam = {
    [DamageType.DARK] = true,
  },
  vuln_dam = {
    [DamageType.LITE] = true,
    [DamageType.LITE_WEAK] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    EVIL = true,
    HAS_LITE = true,
    MALE = true,
    OPEN_DOOR = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ '1d2' },
  drop = { treasure=10, combat=90, magic=0, tools=0, junk=0 },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,8} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,8} },
  },
  resolvers.talents {
    [Talents.T_NPC_MISSILE] = 1,
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 20,
  alertness = 20,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'CLEAR_MUSHROOM_PATCH',
  name = [[Clear mushroom patch]],
  display = ',',
  color = colors.C_B,
  image = 'npc/clear_mushroom_patch.png',
  desc = [[Yum! It smells quite tasty.  If you could only see it...]],
  corpse_weight = 3,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 1, 1 },
  ac = 1,
  max_life = resolvers.dice(1, 1),
  rarity = 2,
  level = 10,
  start_level = 10,
  exp_worth = 3,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.FEAR] = true,
    [DamageType.OLD_SLEEP] = true,
  },
  flags = {
    ATTR_CLEAR = true,
    BASEANGBAND = true,
    CAN_SWIM = true,
    COLD_BLOOD = true,
    EMPTY_MIND = true,
    INVISIBLE = true,
    MULTIPLY = true,
    NEVER_MOVE = true,
    NO_CUT = true,
    STUPID = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.SPORE, dam={1,1} },
  },
  body = bodies.none,
  speed = 10,
  vision = 4,
  alertness = 0,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'GRISHNAKH_THE_HILL_ORC',
  name = [[Grishnakh, the Hill Orc]],
  display = 'o',
  color = colors.C_y,
  image = 'npc/grishnakh_the_hill_orc.png',
  desc = [[He is a cunning and devious orc with a chaotic nature.]],
  corpse_weight = 230,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 25, 10 },
  ac = 20,
  max_life = 250,
  level = 10,
  start_level = 10,
  exp_worth = 160,
  unique = 'GRISHNAKH_THE_HILL_ORC',
  resist_dam = {
    [DamageType.DARK] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    CAN_SPEAK = true,
    ESCORT = true,
    EVIL = true,
    FORCE_MAXHP = true,
    HAS_LITE = true,
    MALE = true,
    MORTAL = true,
    OPEN_DOOR = true,
    ORC = true,
    SPECIAL_GENE = true,
    UNIQUE = true,
  },
  placement_flags = { WILD_TOO=true },
  resolvers.mon_inven{ good=true, only_item=true, '1d2' },
  drop = { treasure=0, combat=100, magic=0, tools=0, junk=0 },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,13} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,11} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,13} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,11} },
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 20,
  alertness = 20,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'GIANT_TAN_BAT',
  name = [[Giant tan bat]],
  display = 'b',
  color = colors.C_U,
  image = 'npc/giant_tan_bat.png',
  desc = [[A giant bat, the beating of whose wings produces a strangely unnerving noise.]],
  corpse_weight = 60,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=50,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 3, 8 },
  ac = 20,
  max_life = resolvers.dice(3, 8),
  rarity = 2,
  level = 10,
  start_level = 10,
  exp_worth = 18,
  flags = {
    AI_ANNOY = true,
    ANIMAL = true,
    BASEANGBAND = true,
    FLY = true,
    FORCE_SLEEP = true,
    MORTAL = true,
  },
  placement_flags = { WILD_MOUNTAIN=true, WILD_TOO=true, WILD_WOOD=true },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.FEAR, method=AttackType.BITE, dam={1,3} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={1,2} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={1,2} },
  },
  body = bodies.winged,
  speed = 20,
  vision = 12,
  alertness = 50,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'OWLBEAR',
  name = [[Owlbear]],
  display = 'H',
  color = colors.C_o,
  image = 'npc/owlbear.png',
  desc = [[A bizarre bear-creature with the claws and the face of an owl.]],
  corpse_weight = 200,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 12, 12 },
  ac = 20,
  max_life = resolvers.dice(12, 12),
  rarity = 1,
  level = 10,
  start_level = 10,
  exp_worth = 35,
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    EVIL = true,
    MORTAL = true,
    OPEN_DOOR = true,
  },
  placement_flags = {},
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={1,3} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={1,3} },
    { type=DamageType.PHYSICAL, method=AttackType.CRUSH, dam={1,10} },
  },
  body = bodies.winged,
  speed = 0,
  vision = 20,
  alertness = 20,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'HAIRY_MOLD',
  name = [[Hairy mold]],
  display = 'm',
  color = colors.C_o,
  image = 'npc/hairy_mold.png',
  desc = [[It is a strange hairy growth on the dungeon floor.]],
  corpse_weight = 5,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 15, 8 },
  ac = 15,
  max_life = resolvers.dice(15, 8),
  rarity = 1,
  level = 10,
  start_level = 10,
  exp_worth = 32,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.FEAR] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    CAN_SWIM = true,
    EMPTY_MIND = true,
    NEVER_MOVE = true,
    NO_CUT = true,
    STUPID = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.POISON, method=AttackType.SPORE, dam={1,3} },
  },
  body = bodies.none,
  speed = 0,
  vision = 2,
  alertness = 70,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'GRIZZLY_BEAR',
  name = [[Grizzly bear]],
  display = 'q',
  color = colors.C_U,
  image = 'npc/grizzly_bear.png',
  desc = [[A huge, beastly bear, more savage than most of its kind.]],
  corpse_weight = 260,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 15, 15 },
  ac = 35,
  max_life = resolvers.dice(15, 15),
  rarity = 2,
  level = 16,
  start_level = 16,
  exp_worth = 55,
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    MORTAL = true,
  },
  placement_flags = { WILD_MOUNTAIN=true, WILD_TOO=true, WILD_WOOD=true },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={1,8} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={1,8} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={1,12} },
    { type=DamageType.PHYSICAL, method=AttackType.CRUSH, dam={1,10} },
  },
  body = bodies.quadruped,
  speed = 0,
  vision = 10,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'DISENCHANTER_MOLD',
  name = [[Disenchanter mold]],
  display = 'm',
  color = colors.C_v,
  image = 'npc/disenchanter_mold.png',
  desc = [[It is a strange glowing growth on the dungeon floor.]],
  corpse_weight = 4,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 11,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 16, 8 },
  ac = 20,
  max_life = resolvers.dice(16, 8),
  rarity = 1,
  level = 10,
  start_level = 10,
  exp_worth = 40,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.DISEASE] = true,
    [DamageType.FEAR] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    ATTR_MULTI = true,
    BASEANGBAND = true,
    CAN_SWIM = true,
    EMPTY_MIND = true,
    NEVER_MOVE = true,
    NO_CUT = true,
    STUPID = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.DISENCHANT, method=AttackType.SPORE, dam={1,6} },
  },
  resolvers.talents {
    [Talents.T_NPC_DRAIN_MANA] = 1,
  },
  body = bodies.none,
  speed = 0,
  vision = 2,
  alertness = 70,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'PSEUDO_DRAGON',
  name = [[Pseudo dragon]],
  display = 'd',
  color = colors.C_o,
  multi_colors = { colors.C_y, colors.C_D },
  image = 'npc/pseudo_dragon.png',
  desc = [[A small relative of the dragon that inhabits dark caves.]],
  corpse_weight = 1000,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 11,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 20, 10 },
  ac = 30,
  max_life = 200,
  rarity = 2,
  level = 10,
  start_level = 10,
  exp_worth = 150,
  flags = {
    ATTR_MULTI = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    DRAGON = true,
    EVIL = true,
    FLY = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    HAS_EGG = true,
    HAS_LITE = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ '60%' },
  drop = { treasure=50, combat=50, magic=0, tools=0, junk=0 },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={1,3} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={1,3} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={1,5} },
  },
  resolvers.talents {
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_BR_LITE] = 1,
    [Talents.T_NPC_BR_DARK] = 1,
  },
  body = bodies.dragon,
  speed = 0,
  vision = 20,
  alertness = 40,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'TENGU',
  name = [[Tengu]],
  self_plural = true,
  display = 'u',
  color = colors.C_b,
  image = 'npc/tengu.png',
  desc = [[It is a fast-moving demon that blinks quickly in and out of existence; no other demon matches its teleporting mastery.]],
  corpse_weight = 60,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 3,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 16, 9 },
  ac = 32,
  max_life = resolvers.dice(16, 9),
  rarity = 1,
  level = 10,
  start_level = 10,
  exp_worth = 40,
  resist_dam = {
    [DamageType.FEAR] = true,
    [DamageType.FIRE] = true,
    [DamageType.TELEPORT] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    DEMON = true,
    EVIL = true,
    FLY = true,
    OPEN_DOOR = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,8} },
  },
  resolvers.talents {
    [Talents.T_NPC_BLINK] = 1,
    [Talents.T_NPC_TELE_TO] = 1,
    [Talents.T_NPC_TELE_AWAY] = 1,
    [Talents.T_NPC_TPORT] = 1,
  },
  body = bodies.humanoid,
  speed = 10,
  vision = 20,
  alertness = 30,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'CREEPING_GOLD_COINS',
  name = [[Creeping gold coins]],
  self_plural = true,
  display = '$',
  color = colors.C_y,
  image = 'npc/creeping_gold_coins.png',
  desc = [[It appears to be a pile of gold coins, until it starts crawling towards you on tiny legs.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 18, 8 },
  ac = 36,
  max_life = resolvers.dice(18, 8),
  rarity = 3,
  level = 10,
  start_level = 10,
  exp_worth = 32,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.ELEC] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    COLD_BLOOD = true,
    NO_CUT = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ coin_type='GOLD_2', only_gold=true, '1d2', '90%' },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={2,5} },
    { type=DamageType.POISON, method=AttackType.TOUCH, dam={3,5} },
  },
  body = bodies.none,
  speed = -10,
  vision = 5,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'WOLF',
  name = [[Wolf]],
  plural_name = [[Wolves]],
  display = 'C',
  color = colors.C_u,
  image = 'npc/wolf.png',
  desc = [[It howls and snaps at you.]],
  corpse_weight = 60,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=25,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 6, 6 },
  ac = 30,
  max_life = resolvers.dice(6, 6),
  rarity = 1,
  level = 10,
  start_level = 10,
  exp_worth = 30,
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    FRIENDS = true,
    MORTAL = true,
  },
  placement_flags = { WILD_MOUNTAIN=true, WILD_TOO=true, WILD_WASTE=true, WILD_WOOD=true },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={1,6} },
  },
  body = bodies.quadruped,
  speed = 10,
  vision = 30,
  alertness = 20,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'GIANT_FRUIT_FLY',
  name = [[Giant fruit fly]],
  display = 'I',
  color = colors.C_G,
  image = 'npc/giant_fruit_fly.png',
  desc = [[A fast-breeding, annoying pest.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=75,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 2, 2 },
  ac = 14,
  max_life = resolvers.dice(2, 2),
  rarity = 3,
  level = 10,
  start_level = 10,
  exp_worth = 4,
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    FLY = true,
    MORTAL = true,
    MULTIPLY = true,
    WEIRD_MIND = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={1,2} },
  },
  body = bodies.none,
  speed = 10,
  vision = 8,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'PANTHER',
  name = [[Panther]],
  display = 'f',
  color = colors.C_D,
  image = 'npc/panther.png',
  desc = [[A large black cat, stalking you with intent. It thinks you're its next meal.]],
  corpse_weight = 130,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 10, 8 },
  ac = 30,
  max_life = resolvers.dice(10, 8),
  rarity = 2,
  level = 10,
  start_level = 10,
  exp_worth = 25,
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    MORTAL = true,
  },
  placement_flags = { WILD_GRASS=true, WILD_TOO=true, WILD_WOOD=true },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={1,8} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={1,8} },
  },
  body = bodies.quadruped,
  speed = 10,
  vision = 40,
  alertness = 0,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'BRIGAND',
  name = [[Brigand]],
  display = 'p',
  color = colors.C_b,
  image = 'npc/brigand.png',
  desc = [[He is eyeing your backpack.]],
  corpse_weight = 170,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 9, 8 },
  ac = 32,
  max_life = resolvers.dice(9, 8),
  rarity = 2,
  level = 10,
  start_level = 10,
  exp_worth = 35,
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    EVIL = true,
    HAS_LITE = true,
    MALE = true,
    MORTAL = true,
    OPEN_DOOR = true,
    TAKE_ITEM = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ '1d2' },
  drop = { treasure=25, combat=60, magic=0, tools=0, junk=15 },
  drop_corpse = { skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={2,4} },
    { type=DamageType.EAT_ITEM, method=AttackType.TOUCH },
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 20,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'UNDEAD_MASS',
  name = [[Undead mass]],
  display = 'j',
  color = colors.C_u,
  image = 'npc/undead_mass.png',
  desc = [[A sickening mound of decaying flesh, bones, hands and so on. It seems to be growing.]],
  corpse_weight = 20,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 8, 8 },
  ac = 12,
  max_life = resolvers.dice(8, 8),
  rarity = 2,
  level = 10,
  start_level = 10,
  exp_worth = 33,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.DARK] = true,
    [DamageType.FEAR] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  vuln_dam = {
    [DamageType.LITE] = true,
    [DamageType.LITE_WEAK] = true,
  },
  flags = {
    BASEANGBAND = true,
    COLD_BLOOD = true,
    EMPTY_MIND = true,
    EVIL = true,
    MULTIPLY = true,
    NEVER_MOVE = true,
    NO_CUT = true,
    UNDEAD = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.DISEASE, method=AttackType.TOUCH, dam={1,6} },
    { type=DamageType.LOSE_CON, method=AttackType.TOUCH, dam={1,6} },
  },
  body = bodies.none,
  speed = 0,
  vision = 70,
  alertness = 5,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'BABY_MULTI_HUED_DRAGON',
  name = [[Baby multi-hued dragon]],
  display = 'd',
  color = colors.C_v,
  multi_colors = { colors.C_d, colors.C_r, colors.C_w, colors.C_b, colors.C_g },
  image = 'npc/baby_multi_hued_dragon.png',
  desc = [[This hatchling dragon is still soft, its eyes unaccustomed to light and its scales shimmering with a hint of colour.]],
  corpse_weight = 500,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 12,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 13, 10 },
  ac = 30,
  max_life = 130,
  rarity = 2,
  level = 11,
  start_level = 11,
  exp_worth = 45,
  resist_dam = {
    [DamageType.ACID] = true,
    [DamageType.COLD] = true,
    [DamageType.ELEC] = true,
    [DamageType.FIRE] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    ATTR_MULTI = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    DRAGON = true,
    EVIL = true,
    FLY = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    HAS_EGG = true,
    HAS_LITE = true,
    IMPRESED = true,
    OPEN_DOOR = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ only_gold=true, '1d2', '60%' },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={1,4} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={1,4} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={1,6} },
  },
  resolvers.talents {
    [Talents.T_NPC_BR_ACID] = 1,
    [Talents.T_NPC_BR_FIRE] = 1,
    [Talents.T_NPC_BR_COLD] = 1,
    [Talents.T_NPC_BR_ELEC] = 1,
    [Talents.T_NPC_BR_POIS] = 1,
  },
  body = bodies.dragon,
  speed = 0,
  vision = 20,
  alertness = 70,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'OLD_MAN_WILLOW',
  name = [[Old Man Willow]],
  display = '#',
  color = colors.C_s,
  image = 'npc/old_man_willow.png',
  desc = [[The ancient grey willow tree, ruler of the Old Forest. He despises trespassers in his territory.  "...a huge willow-tree, old and hoary. Enormous it looked, its sprawling branches going up like racing arms with may long-fingered hands, its knotted and twisted trunk gaping in wide fissures that creaked faintly as the boughs moved."]],
  corpse_weight = 300,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 10,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 32, 30 },
  ac = 20,
  max_life = 960,
  level = 25,
  start_level = 25,
  exp_worth = 150,
  unique = 'OLD_MAN_WILLOW',
  resist_dam = {
    [DamageType.ACID] = true,
    [DamageType.POISON] = true,
    [DamageType.WATER] = true,
  },
  vuln_dam = {
    [DamageType.FIRE] = true,
  },
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    COLD_BLOOD = true,
    EMPTY_MIND = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    NEVER_MOVE = true,
    NO_CUT = true,
    SPECIAL_GENE = true,
    UNIQUE = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, only_item=true, randart=true, '1d2' },
  drop = { treasure=0, combat=50, magic=50, tools=0, junk=0 },
  attacks = {
    { type=DamageType.PARALYZE, method=AttackType.TOUCH, dam={1,14} },
    { type=DamageType.PARALYZE, method=AttackType.TOUCH, dam={1,14} },
    { type=DamageType.PHYSICAL, method=AttackType.CRUSH, dam={2,12} },
  },
  resolvers.talents {
    [Talents.T_NPC_TELE_TO] = 1,
    [Talents.T_NPC_HOLD] = 1,
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 20,
  alertness = 20,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'HIPPOCAMPUS',
  name = [[Hippocampus]],
  plural_name = [[Hippocampi]],
  display = 'H',
  color = colors.C_B,
  image = 'npc/hippocampus.png',
  desc = [[A truly strange hybrid of a horse and a fish.]],
  corpse_weight = 90,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 20, 9 },
  ac = 14,
  max_life = resolvers.dice(20, 9),
  rarity = 1,
  level = 11,
  start_level = 11,
  exp_worth = 30,
  flags = {
    ANIMAL = true,
    AQUATIC = true,
    BASEANGBAND = true,
    MORTAL = true,
  },
  placement_flags = { WILD_TOO=true },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={2,5} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={2,5} },
  },
  body = bodies.snake,
  speed = 0,
  vision = 12,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'ZOMBIFIED_ORC',
  name = [[Zombified orc]],
  display = 'z',
  color = colors.C_s,
  image = 'npc/zombified_orc.png',
  desc = [[It is a shambling orcish corpse leaving behind a trail of flesh.]],
  corpse_weight = 180,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 11, 8 },
  ac = 24,
  max_life = resolvers.dice(11, 8),
  rarity = 1,
  level = 11,
  start_level = 11,
  exp_worth = 30,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.DARK] = true,
    [DamageType.FEAR] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    COLD_BLOOD = true,
    EMPTY_MIND = true,
    EVIL = true,
    NO_CUT = true,
    OPEN_DOOR = true,
    ORC = true,
    UNDEAD = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,4} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,4} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,4} },
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 20,
  alertness = 25,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'HIPPOGRYPH',
  name = [[Hippogryph]],
  display = 'H',
  color = colors.C_U,
  image = 'npc/hippogryph.png',
  desc = [[A strange hybrid of eagle and horse. It looks weird.]],
  corpse_weight = 150,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 20, 9 },
  ac = 14,
  max_life = resolvers.dice(20, 9),
  rarity = 1,
  level = 11,
  start_level = 11,
  exp_worth = 30,
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    FLY = true,
    MORTAL = true,
  },
  placement_flags = { WILD_GRASS=true, WILD_MOUNTAIN=true, WILD_TOO=true },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={2,5} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={2,5} },
  },
  body = bodies.quadruped,
  speed = 0,
  vision = 12,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'BLACK_MAMBA',
  name = [[Black mamba]],
  display = 'J',
  color = colors.C_D,
  image = 'npc/black_mamba.png',
  desc = [[It has glistening black skin, a sleek body, and highly venomous fangs.]],
  corpse_weight = 30,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=50,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 10, 8 },
  ac = 32,
  max_life = resolvers.dice(10, 8),
  rarity = 3,
  level = 12,
  start_level = 12,
  exp_worth = 40,
  resist_dam = {
    [DamageType.POISON] = true,
  },
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    CAN_SWIM = true,
    HAS_EGG = true,
    MORTAL = true,
  },
  placement_flags = { WILD_GRASS=true, WILD_SWAMP=true, WILD_TOO=true, WILD_WOOD=true },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.POISON, method=AttackType.BITE, dam={4,4} },
  },
  body = bodies.snake,
  speed = 10,
  vision = 10,
  alertness = 1,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'WHITE_WOLF',
  name = [[White wolf]],
  plural_name = [[White wolves]],
  display = 'C',
  color = colors.C_w,
  image = 'npc/white_wolf.png',
  desc = [[A large and muscled wolf from the northern wastes. Its breath is cold and icy and its fur coated in frost.]],
  corpse_weight = 70,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=25,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 7, 7 },
  ac = 30,
  max_life = resolvers.dice(7, 7),
  rarity = 1,
  level = 12,
  start_level = 12,
  exp_worth = 30,
  resist_dam = {
    [DamageType.COLD] = true,
  },
  vuln_dam = {
    [DamageType.FIRE] = true,
  },
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    FRIENDS = true,
    MORTAL = true,
  },
  placement_flags = { WILD_TOO=true, WILD_WASTE=true },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={1,3} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={1,4} },
  },
  body = bodies.quadruped,
  speed = 10,
  vision = 30,
  alertness = 20,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'GRAPE_JELLY',
  name = [[Grape jelly]],
  display = 'j',
  color = colors.C_v,
  image = 'npc/grape_jelly.png',
  desc = [[Yum! It looks quite tasty.  It is a pulsing mound of glowing flesh.]],
  corpse_weight = 260,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 11,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 52, 8 },
  ac = 1,
  max_life = resolvers.dice(52, 8),
  rarity = 3,
  level = 12,
  start_level = 12,
  exp_worth = 60,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.DARK] = true,
    [DamageType.FEAR] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  vuln_dam = {
    [DamageType.LITE] = true,
    [DamageType.LITE_WEAK] = true,
  },
  flags = {
    BASEANGBAND = true,
    CAN_SWIM = true,
    EMPTY_MIND = true,
    NEVER_MOVE = true,
    NO_CUT = true,
    STUPID = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.EXP_10, method=AttackType.TOUCH },
  },
  resolvers.talents {
    [Talents.T_NPC_DRAIN_MANA] = 1,
  },
  body = bodies.none,
  speed = 0,
  vision = 2,
  alertness = 99,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'NETHER_WORM_MASS',
  name = [[Nether worm mass]],
  display = 'w',
  color = colors.C_D,
  image = 'npc/nether_worm_mass.png',
  desc = [[It is a disgusting mass of dark worms, eating each other, the floor, the air, you...]],
  corpse_weight = 20,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=75,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 5, 8 },
  ac = 15,
  max_life = resolvers.dice(5, 8),
  rarity = 4,
  level = 12,
  start_level = 12,
  exp_worth = 6,
  resist_dam = {
    [DamageType.DARK] = true,
    [DamageType.FEAR] = true,
  },
  vuln_dam = {
    [DamageType.LITE] = true,
    [DamageType.LITE_WEAK] = true,
  },
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    CAN_SWIM = true,
    MULTIPLY = true,
    NO_CUT = true,
    STUPID = true,
    WEIRD_MIND = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.EXP_10, method=AttackType.TOUCH },
  },
  body = bodies.none,
  speed = -10,
  vision = 10,
  alertness = 3,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'GOLFIMBUL_THE_HILL_ORC_CHIEF',
  name = [[Golfimbul, the Hill Orc Chief]],
  display = 'o',
  color = colors.C_y,
  image = 'npc/golfimbul_the_hill_orc_chief.png',
  desc = [[A leader of a band of raiding orcs, he picks on hobbits.]],
  corpse_weight = 220,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 26, 10 },
  ac = 60,
  max_life = 260,
  level = 12,
  start_level = 12,
  exp_worth = 230,
  unique = 'GOLFIMBUL_THE_HILL_ORC_CHIEF',
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.DARK] = true,
    [DamageType.ELEC] = true,
    [DamageType.FIRE] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    CAN_SPEAK = true,
    ESCORT = true,
    EVIL = true,
    FORCE_MAXHP = true,
    HAS_LITE = true,
    MALE = true,
    MORTAL = true,
    OPEN_DOOR = true,
    ORC = true,
    SPECIAL_GENE = true,
    UNIQUE = true,
  },
  placement_flags = { WILD_TOO=true },
  resolvers.mon_inven{ good=true, only_item=true, '2d2' },
  drop = { treasure=10, combat=90, magic=0, tools=0, junk=0 },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,13} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,13} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,11} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,11} },
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 20,
  alertness = 20,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'SWORDSMAN',
  name = [[Swordsman]],
  plural_name = [[Swordsmen]],
  display = 'p',
  color = colors.C_u,
  image = 'npc/swordsman.png',
  desc = [[A warrior of considerable skill.]],
  corpse_weight = 180,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 12, 8 },
  ac = 34,
  max_life = resolvers.dice(12, 8),
  rarity = 1,
  level = 12,
  start_level = 12,
  exp_worth = 40,
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    HAS_LITE = true,
    MALE = true,
    MORTAL = true,
    OPEN_DOOR = true,
  },
  placement_flags = { WILD_TOO=true },
  resolvers.mon_inven{ '1d2' },
  drop = { treasure=0, combat=100, magic=0, tools=0, junk=0 },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={3,5} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={3,5} },
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 20,
  alertness = 20,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'BABY_BRONZE_DRAGON',
  name = [[Baby bronze dragon]],
  display = 'd',
  color = colors.C_U,
  multi_colors = { colors.C_U, colors.C_u },
  image = 'npc/baby_bronze_dragon.png',
  desc = [[This hatchling dragon is still soft, its eyes unaccustomed to light and its scales a dull bronze.]],
  corpse_weight = 400,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 12,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 10, 10 },
  ac = 30,
  max_life = 100,
  rarity = 2,
  level = 9,
  start_level = 9,
  exp_worth = 35,
  resist_dam = {
    [DamageType.CONFUSION] = true,
  },
  flags = {
    ATTR_MULTI = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    DRAGON = true,
    EVIL = true,
    FLY = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    HAS_EGG = true,
    IMPRESED = true,
    OPEN_DOOR = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ only_gold=true, '1d2', '60%' },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={1,3} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={1,3} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={1,5} },
  },
  resolvers.talents {
    [Talents.T_NPC_BR_CONF] = 1,
  },
  body = bodies.dragon,
  speed = 0,
  vision = 20,
  alertness = 70,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'BABY_GOLD_DRAGON',
  name = [[Baby gold dragon]],
  display = 'd',
  color = colors.C_y,
  multi_colors = { colors.C_y, colors.C_U },
  image = 'npc/baby_gold_dragon.png',
  desc = [[This hatchling dragon is still soft, its eyes unaccustomed to light and its scales a pale gold.]],
  corpse_weight = 400,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 12,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 10, 10 },
  ac = 30,
  max_life = 100,
  rarity = 2,
  level = 9,
  start_level = 9,
  exp_worth = 35,
  resist_dam = {
    [DamageType.SOUND] = true,
  },
  flags = {
    ATTR_MULTI = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    DRAGON = true,
    EVIL = true,
    FLY = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    HAS_EGG = true,
    HAS_LITE = true,
    IMPRESED = true,
    NO_STUN = true,
    OPEN_DOOR = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ only_gold=true, '1d2', '60%' },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={1,3} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={1,3} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={1,5} },
  },
  resolvers.talents {
    [Talents.T_NPC_BR_SOUN] = 1,
  },
  body = bodies.dragon,
  speed = 0,
  vision = 20,
  alertness = 70,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'EVIL_EYE',
  name = [[Evil eye]],
  display = 'e',
  color = colors.C_D,
  image = 'npc/evil_eye.png',
  desc = [[A huge disembodied eye.  As you stare into the black nothingness of its pupil, you feel your will and vitality draining away, and are unable to do anything except approach it in horrified fascination.]],
  corpse_weight = 60,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 7,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 15, 8 },
  ac = 6,
  max_life = resolvers.dice(15, 8),
  rarity = 3,
  level = 18,
  start_level = 18,
  exp_worth = 80,
  resist_dam = {
    [DamageType.DARK] = true,
    [DamageType.FEAR] = true,
  },
  vuln_dam = {
    [DamageType.LITE] = true,
    [DamageType.LITE_WEAK] = true,
  },
  flags = {
    BASEANGBAND = true,
    EVIL = true,
    FLY = true,
    NEVER_MOVE = true,
    NO_CUT = true,
  },
  placement_flags = {},
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.EXP_10, method=AttackType.GAZE },
    { type=DamageType.EXP_10, method=AttackType.GAZE },
  },
  resolvers.talents {
    [Talents.T_NPC_HOLD] = 1,
    [Talents.T_NPC_TELE_TO] = 1,
  },
  body = bodies.none,
  speed = 0,
  vision = 2,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'MASTER_YEEK',
  name = [[Master yeek]],
  display = 'y',
  color = colors.C_g,
  image = 'npc/master_yeek.png',
  desc = [[A small humanoid that radiates some power.]],
  corpse_weight = 60,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 4,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 12, 9 },
  ac = 24,
  max_life = resolvers.dice(12, 9),
  rarity = 2,
  level = 12,
  start_level = 12,
  exp_worth = 28,
  resist_dam = {
    [DamageType.ACID] = true,
  },
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    EVIL = true,
    FORCE_SLEEP = true,
    MORTAL = true,
    OPEN_DOOR = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ '60%' },
  drop = { treasure=0, combat=0, magic=100, tools=0, junk=0 },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,8} },
  },
  resolvers.talents {
    [Talents.T_NPC_BLINK] = 1,
    [Talents.T_NPC_TPORT] = 1,
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_SLOW] = 1,
    [Talents.T_NPC_BA_POIS] = 1,
    [Talents.T_NPC_S_MONSTER] = 1,
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 18,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'PRIEST',
  name = [[Priest]],
  display = 'p',
  color = colors.C_g,
  image = 'npc/priest.png',
  desc = [[A robed man dedicated to his god.]],
  corpse_weight = 150,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 3,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 12, 8 },
  ac = 22,
  faction = 'eru_manwe',
  max_life = resolvers.dice(12, 8),
  rarity = 1,
  level = 12,
  start_level = 12,
  exp_worth = 36,
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    FORCE_SLEEP = true,
    GOOD = true,
    HAS_LITE = true,
    MALE = true,
    MORTAL = true,
    OPEN_DOOR = true,
    SMART = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ '1d2' },
  drop = { treasure=0, combat=20, magic=80, tools=0, junk=0 },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={2,3} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={2,3} },
  },
  resolvers.talents {
    [Talents.T_NPC_HEAL] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_CAUSE_2] = 1,
    [Talents.T_NPC_S_MONSTER] = 1,
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 20,
  alertness = 40,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'DARK_ELVEN_PRIEST',
  name = [[Dark elven priest]],
  display = 'h',
  color = colors.C_g,
  image = 'npc/dark_elven_priest.png',
  desc = [[A dark elven figure, dressed all in black, chanting curses and waiting to deliver your soul to hell.]],
  corpse_weight = 120,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 5,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 7, 10 },
  ac = 30,
  max_life = resolvers.dice(7, 10),
  rarity = 1,
  level = 12,
  start_level = 12,
  exp_worth = 50,
  resist_dam = {
    [DamageType.DARK] = true,
  },
  vuln_dam = {
    [DamageType.LITE] = true,
    [DamageType.LITE_WEAK] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    EVIL = true,
    FORCE_SLEEP = true,
    HAS_LITE = true,
    MALE = true,
    OPEN_DOOR = true,
    SMART = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ only_item=true, '1d2' },
  drop = { treasure=0, combat=10, magic=90, tools=0, junk=0 },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,9} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,10} },
  },
  resolvers.talents {
    [Talents.T_NPC_HEAL] = 1,
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_CAUSE_2] = 1,
    [Talents.T_NPC_DARKNESS] = 1,
    [Talents.T_NPC_MISSILE] = 1,
  },
  body = bodies.humanoid,
  speed = 10,
  vision = 20,
  alertness = 30,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'AIR_SPIRIT',
  name = [[Air spirit]],
  display = 'E',
  color = colors.C_B,
  image = 'npc/air_spirit.png',
  desc = [[A whirlwind of sentient air.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=75,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 8, 8 },
  ac = 40,
  max_life = resolvers.dice(8, 8),
  rarity = 2,
  level = 12,
  start_level = 12,
  exp_worth = 40,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.ELEC] = true,
    [DamageType.FEAR] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    COLD_BLOOD = true,
    EMPTY_MIND = true,
    FLY = true,
    INVISIBLE = true,
    NO_CUT = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,3} },
  },
  body = bodies.none,
  speed = 20,
  vision = 12,
  alertness = 20,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'SKELETON_HUMAN',
  name = [[Skeleton human]],
  display = 's',
  color = colors.C_W,
  image = 'npc/skeleton_human.png',
  desc = [[It is an animated human skeleton.]],
  corpse_weight = 150,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 10, 8 },
  ac = 30,
  max_life = resolvers.dice(10, 8),
  rarity = 1,
  level = 12,
  start_level = 12,
  exp_worth = 38,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.FEAR] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    COLD_BLOOD = true,
    EMPTY_MIND = true,
    EVIL = true,
    NO_CUT = true,
    OPEN_DOOR = true,
    UNDEAD = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,8} },
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 20,
  alertness = 30,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'ZOMBIFIED_HUMAN',
  name = [[Zombified human]],
  display = 'z',
  color = colors.C_s,
  image = 'npc/zombified_human.png',
  desc = [[It is a shambling human corpse dropping chunks of flesh behind it.]],
  corpse_weight = 150,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 12, 8 },
  ac = 24,
  max_life = resolvers.dice(12, 8),
  rarity = 1,
  level = 12,
  start_level = 12,
  exp_worth = 34,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.FEAR] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    COLD_BLOOD = true,
    EMPTY_MIND = true,
    EVIL = true,
    NO_CUT = true,
    OPEN_DOOR = true,
    UNDEAD = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,4} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,4} },
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 20,
  alertness = 20,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'TIGER',
  name = [[Tiger]],
  display = 'f',
  color = colors.C_o,
  image = 'npc/tiger.png',
  desc = [[One of the largest of its species, a sleek orange and black shape creeps towards you, ready to pounce.]],
  corpse_weight = 150,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 12, 10 },
  ac = 40,
  max_life = resolvers.dice(12, 10),
  rarity = 2,
  level = 12,
  start_level = 12,
  exp_worth = 40,
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    MORTAL = true,
  },
  placement_flags = { WILD_GRASS=true, WILD_MOUNTAIN=true, WILD_TOO=true, WILD_WOOD=true },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={1,8} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={1,8} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={1,6} },
  },
  body = bodies.quadruped,
  speed = 10,
  vision = 40,
  alertness = 0,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'MOANING_SPIRIT',
  name = [[Moaning spirit]],
  display = 'G',
  color = colors.C_u,
  image = 'npc/moaning_spirit.png',
  desc = [[A ghostly apparition that shrieks horribly.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=25,
    talent_in = 15,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 5, 8 },
  ac = 20,
  max_life = resolvers.dice(5, 8),
  rarity = 2,
  level = 12,
  start_level = 12,
  exp_worth = 44,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.OLD_SLEEP] = true,
  },
  flags = {
    BASEANGBAND = true,
    COLD_BLOOD = true,
    EVIL = true,
    FLY = true,
    FORCE_SLEEP = true,
    INVISIBLE = true,
    NO_CUT = true,
    PASS_WALL = true,
    UNDEAD = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ '60%', '90%' },
  drop = { treasure=45, combat=15, magic=25, tools=0, junk=15 },
  attacks = {
    { type=DamageType.FEAR, method=AttackType.WAIL },
    { type=DamageType.LOSE_DEX, method=AttackType.TOUCH, dam={1,8} },
  },
  resolvers.talents {
    [Talents.T_NPC_TPORT] = 1,
    [Talents.T_NPC_SCARE] = 1,
  },
  body = bodies.none,
  speed = 10,
  vision = 14,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'STEGOCENTIPEDE',
  name = [[Stegocentipede]],
  display = 'c',
  color = colors.C_u,
  image = 'npc/stegocentipede.png',
  desc = [[It is a vast armoured centipede with massive mandibles and a spiked tail.]],
  corpse_weight = 120,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 13, 8 },
  ac = 30,
  max_life = resolvers.dice(13, 8),
  rarity = 2,
  level = 12,
  start_level = 12,
  exp_worth = 40,
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    MORTAL = true,
    WEIRD_MIND = true,
  },
  placement_flags = {},
  drop_corpse = { skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={2,4} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={2,4} },
    { type=DamageType.PHYSICAL, method=AttackType.STING, dam={2,4} },
  },
  body = bodies.snake,
  speed = 10,
  vision = 12,
  alertness = 30,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'SPOTTED_JELLY',
  name = [[Spotted jelly]],
  display = 'j',
  color = colors.C_o,
  image = 'npc/spotted_jelly.png',
  desc = [[A strange jelly thing, covered in discoloured blotches.]],
  corpse_weight = 250,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 13, 8 },
  ac = 18,
  max_life = resolvers.dice(13, 8),
  rarity = 3,
  level = 12,
  start_level = 12,
  exp_worth = 33,
  resist_dam = {
    [DamageType.ACID] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.DARK] = true,
    [DamageType.FEAR] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  vuln_dam = {
    [DamageType.LITE] = true,
    [DamageType.LITE_WEAK] = true,
  },
  flags = {
    BASEANGBAND = true,
    CAN_SWIM = true,
    COLD_BLOOD = true,
    EMPTY_MIND = true,
    NEVER_MOVE = true,
    NO_CUT = true,
    STUPID = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.ACID, method=AttackType.TOUCH, dam={1,10} },
    { type=DamageType.ACID, method=AttackType.TOUCH, dam={2,6} },
    { type=DamageType.ACID, method=AttackType.TOUCH, dam={2,6} },
  },
  body = bodies.none,
  speed = 10,
  vision = 12,
  alertness = 1,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'DRIDER',
  name = [[Drider]],
  display = 'S',
  color = colors.C_b,
  image = 'npc/drider.png',
  desc = [[A dark elven torso merged with the bloated form of a giant spider.]],
  corpse_weight = 200,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 8,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 10, 13 },
  ac = 30,
  max_life = resolvers.dice(10, 13),
  rarity = 2,
  level = 13,
  start_level = 13,
  exp_worth = 55,
  resist_dam = {
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    EVIL = true,
    FORCE_SLEEP = true,
    HAS_LITE = true,
    MORTAL = true,
  },
  placement_flags = {},
  drop_corpse = { skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,12} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,12} },
    { type=DamageType.POISON, method=AttackType.BITE, dam={1,6} },
  },
  resolvers.talents {
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_CAUSE_1] = 1,
    [Talents.T_NPC_DARKNESS] = 1,
    [Talents.T_NPC_MISSILE] = 1,
    [Talents.T_NPC_ARROW_2] = 1,
  },
  body = { MAIN_HAND=1, OFF_HAND=1, BODY=1, CLOAK=1, LAUNCHER=1, QUIVER=1, GLOVES=1, BOOTS=0, HELM=1, RING=2, AMULET=1, LITE=1, TOOL=1, SYMBIOTE=1, INVEN=23 },
  speed = 0,
  vision = 8,
  alertness = 80,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'MONGBAT',
  name = [[Mongbat]],
  display = 'b',
  color = colors.C_U,
  image = 'npc/mongbat.png',
  desc = [[Devil-bats, notoriously difficult to kill.]],
  corpse_weight = 80,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 10, 10 },
  ac = 80,
  max_life = 100,
  rarity = 2,
  level = 13,
  start_level = 13,
  exp_worth = 65,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.ELEC] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    EVIL = true,
    FLY = true,
    FORCE_MAXHP = true,
    FRIENDS = true,
    MORTAL = true,
    WEIRD_MIND = true,
  },
  placement_flags = {},
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={1,4} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={1,4} },
    { type=DamageType.POISON, method=AttackType.BITE, dam={1,8} },
  },
  body = bodies.winged,
  speed = 0,
  vision = 20,
  alertness = 8,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'KILLER_BROWN_BEETLE',
  name = [[Killer brown beetle]],
  display = 'K',
  color = colors.C_u,
  image = 'npc/killer_brown_beetle.png',
  desc = [[It is a vicious insect with a tough carapace.]],
  corpse_weight = 50,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 13, 8 },
  ac = 40,
  max_life = resolvers.dice(13, 8),
  rarity = 1,
  level = 13,
  start_level = 13,
  exp_worth = 38,
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    FLY = true,
    MORTAL = true,
    WEIRD_MIND = true,
  },
  placement_flags = {},
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={3,4} },
  },
  body = bodies.quadruped,
  speed = 0,
  vision = 10,
  alertness = 30,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'BOLDOR_KING_OF_THE_YEEKS',
  name = [[Boldor, King of the Yeeks]],
  display = 'y',
  color = colors.C_v,
  image = 'npc/boldor_king_of_the_yeeks.png',
  desc = [[A great yeek, powerful in magic and sorcery, but a yeek all the same.]],
  corpse_weight = 65,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 2,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 20, 10 },
  ac = 24,
  max_life = 200,
  rarity = 3,
  level = 13,
  start_level = 13,
  exp_worth = 200,
  unique = 'BOLDOR_KING_OF_THE_YEEKS',
  resist_dam = {
    [DamageType.ACID] = true,
  },
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    CAN_SPEAK = true,
    ESCORT = true,
    ESCORTS = true,
    EVIL = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    MALE = true,
    MORTAL = true,
    OPEN_DOOR = true,
    SMART = true,
    UNIQUE = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, only_item=true, '1d2', '90%' },
  drop = { treasure=0, combat=90, magic=10, tools=0, junk=0 },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,10} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,10} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,9} },
  },
  resolvers.talents {
    [Talents.T_NPC_HEAL] = 1,
    [Talents.T_NPC_BLINK] = 1,
    [Talents.T_NPC_TPORT] = 1,
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_SLOW] = 1,
    [Talents.T_NPC_S_KIN] = 1,
    [Talents.T_NPC_S_MONSTER] = 1,
  },
  body = bodies.humanoid,
  speed = 10,
  vision = 18,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'OGRE',
  name = [[Ogre]],
  display = 'O',
  color = colors.C_U,
  image = 'npc/ogre.png',
  desc = [[A hideous, smallish giant that is often found near or with orcs.]],
  corpse_weight = 210,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 13, 9 },
  ac = 33,
  max_life = resolvers.dice(13, 9),
  rarity = 2,
  level = 13,
  start_level = 13,
  exp_worth = 50,
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    EVIL = true,
    FRIENDS = true,
    GIANT = true,
    HAS_LITE = true,
    MORTAL = true,
    OPEN_DOOR = true,
  },
  placement_flags = { WILD_MOUNTAIN=true, WILD_TOO=true, WILD_WOOD=true },
  resolvers.mon_inven{ '60%' },
  drop = { treasure=10, combat=85, magic=0, tools=0, junk=5 },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={2,8} },
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 20,
  alertness = 30,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'CREEPING_MITHRIL_COINS',
  name = [[Creeping mithril coins]],
  self_plural = true,
  display = '$',
  color = colors.C_B,
  image = 'npc/creeping_mithril_coins.png',
  desc = [[It appears to be a pile of sentient mithril coins that doesn't like being picked up.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 20, 8 },
  ac = 50,
  max_life = resolvers.dice(20, 8),
  rarity = 3,
  level = 13,
  start_level = 13,
  exp_worth = 45,
  resist_dam = {
    [DamageType.ACID] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.ELEC] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    CHAR_MULTI = true,
    COLD_BLOOD = true,
    NO_CUT = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ coin_type='MITHRIL', only_gold=true, '2d2', '90%' },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={2,5} },
    { type=DamageType.POISON, method=AttackType.TOUCH, dam={3,5} },
  },
  body = bodies.none,
  speed = 0,
  vision = 5,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'ILLUSIONIST',
  name = [[Illusionist]],
  display = 'p',
  color = colors.C_R,
  image = 'npc/illusionist.png',
  desc = [[A deceptive spell caster.]],
  corpse_weight = 150,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 3,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 12, 8 },
  ac = 10,
  max_life = resolvers.dice(12, 8),
  rarity = 2,
  level = 13,
  start_level = 13,
  exp_worth = 50,
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    EVIL = true,
    FORCE_SLEEP = true,
    HAS_LITE = true,
    MALE = true,
    MORTAL = true,
    OPEN_DOOR = true,
    SMART = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ '1d2' },
  drop = { treasure=20, combat=0, magic=80, tools=0, junk=0 },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={2,2} },
  },
  resolvers.talents {
    [Talents.T_NPC_HASTE] = 1,
    [Talents.T_NPC_BLINK] = 1,
    [Talents.T_NPC_TPORT] = 1,
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_HOLD] = 1,
    [Talents.T_NPC_SLOW] = 1,
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_DARKNESS] = 1,
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 20,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'DRUID',
  name = [[Druid]],
  display = 'p',
  color = colors.C_G,
  image = 'npc/druid.png',
  desc = [[A priest devoted to Nature.]],
  corpse_weight = 140,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 3,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 12, 12 },
  ac = 10,
  max_life = resolvers.dice(12, 12),
  rarity = 2,
  level = 13,
  start_level = 13,
  exp_worth = 50,
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    EVIL = true,
    FORCE_SLEEP = true,
    HAS_LITE = true,
    MALE = true,
    MORTAL = true,
    OPEN_DOOR = true,
    SMART = true,
  },
  placement_flags = { WILD_TOO=true, WILD_WOOD=true },
  resolvers.mon_inven{ '1d2' },
  drop = { treasure=20, combat=0, magic=80, tools=0, junk=0 },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={2,4} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={2,4} },
  },
  resolvers.talents {
    [Talents.T_NPC_HASTE] = 1,
    [Talents.T_NPC_BLINK] = 1,
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_HOLD] = 1,
    [Talents.T_NPC_SLOW] = 1,
    [Talents.T_NPC_BO_FIRE] = 1,
    [Talents.T_NPC_BO_ELEC] = 1,
    [Talents.T_NPC_S_ANIMAL] = 1,
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 20,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'CLOAKER',
  name = [[Cloaker]],
  display = '(',
  color = colors.C_g,
  image = 'npc/cloaker.png',
  desc = [[It resembles a normal cloak until some poor fool ventures too close!]],
  corpse_weight = 6,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 7, 7 },
  ac = 40,
  max_life = 49,
  rarity = 5,
  level = 13,
  start_level = 13,
  exp_worth = 30,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.ELEC] = true,
    [DamageType.FEAR] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    CHAR_MULTI = true,
    COLD_BLOOD = true,
    EMPTY_MIND = true,
    FORCE_MAXHP = true,
    NEVER_MOVE = true,
    NO_CUT = true,
    STUPID = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ '90%' },
  drop = { treasure=0, combat=0, magic=0, tools=0, junk=100 },
  attacks = {
    { type=DamageType.PARALYZE, method=AttackType.HIT, dam={5,5} },
    { type=DamageType.FEAR, method=AttackType.HIT, dam={5,5} },
  },
  body = bodies.none,
  speed = 20,
  vision = 20,
  alertness = 0,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'BLACK_ORC',
  name = [[Black orc]],
  display = 'o',
  color = colors.C_D,
  image = 'npc/black_orc.png',
  desc = [[He is a large orc with powerful arms and deep black skin.]],
  corpse_weight = 200,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 9,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 12, 10 },
  ac = 36,
  max_life = resolvers.dice(12, 10),
  rarity = 1,
  level = 13,
  start_level = 13,
  exp_worth = 45,
  resist_dam = {
    [DamageType.DARK] = true,
  },
  vuln_dam = {
    [DamageType.LITE] = true,
    [DamageType.LITE_WEAK] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    EVIL = true,
    FRIENDS = true,
    HAS_LITE = true,
    MALE = true,
    MORTAL = true,
    OPEN_DOOR = true,
    ORC = true,
  },
  placement_flags = { WILD_TOO=true },
  resolvers.mon_inven{ '60%' },
  drop = { treasure=10, combat=50, magic=20, tools=15, junk=5 },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={3,4} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={3,4} },
  },
  resolvers.talents {
    [Talents.T_NPC_ARROW_2] = 1,
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 20,
  alertness = 20,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'OCHRE_JELLY',
  name = [[Ochre jelly]],
  display = 'j',
  color = colors.C_U,
  image = 'npc/ochre_jelly.png',
  desc = [[A fast moving highly acidic jelly thing, that is eating away the floor it rests on.]],
  corpse_weight = 230,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 13, 8 },
  ac = 18,
  max_life = resolvers.dice(13, 8),
  rarity = 3,
  level = 13,
  start_level = 13,
  exp_worth = 40,
  resist_dam = {
    [DamageType.ACID] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.FEAR] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    CAN_SWIM = true,
    COLD_BLOOD = true,
    EMPTY_MIND = true,
    NO_CUT = true,
    OPEN_DOOR = true,
    STUPID = true,
    TAKE_ITEM = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.ACID, method=AttackType.TOUCH, dam={1,10} },
    { type=DamageType.ACID, method=AttackType.TOUCH, dam={2,6} },
    { type=DamageType.ACID, method=AttackType.TOUCH, dam={2,6} },
  },
  body = bodies.none,
  speed = 10,
  vision = 12,
  alertness = 1,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'LURKER',
  name = [[Lurker]],
  display = '.',
  color = colors.C_w,
  image = 'npc/lurker.png',
  desc = [[A strange creature that merges with the dungeon floor, trapping its victims by enveloping them within its perfectly disguised form.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 20, 10 },
  ac = 25,
  max_life = 200,
  rarity = 3,
  level = 14,
  start_level = 14,
  exp_worth = 80,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.FEAR] = true,
    [DamageType.OLD_SLEEP] = true,
  },
  flags = {
    ATTR_CLEAR = true,
    BASEANGBAND = true,
    CHAR_CLEAR = true,
    CHAR_MULTI = true,
    COLD_BLOOD = true,
    EMPTY_MIND = true,
    FORCE_MAXHP = true,
    INVISIBLE = true,
    NEVER_MOVE = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,8} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,8} },
  },
  body = bodies.none,
  speed = 0,
  vision = 30,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'TANGLEWEED',
  name = [[Tangleweed]],
  display = '#',
  color = colors.C_g,
  image = 'npc/tangleweed.png',
  desc = [[A mass of vegetation.  As you pass near it, it reaches out tendrils to ensnare you.  You can just make out skeletons of its previous victims deep within the thickets.]],
  corpse_weight = 5,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 5, 5 },
  ac = 5,
  max_life = resolvers.dice(5, 5),
  rarity = 4,
  level = 10,
  start_level = 10,
  exp_worth = 10,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.FEAR] = true,
    [DamageType.OLD_SLEEP] = true,
  },
  vuln_dam = {
    [DamageType.FIRE] = true,
  },
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    COLD_BLOOD = true,
    EMPTY_MIND = true,
    FORCE_SLEEP = true,
    FRIENDS = true,
    KILL_TREES = true,
    MORTAL = true,
    NEVER_MOVE = true,
    NO_CUT = true,
    STUPID = true,
  },
  placement_flags = { WILD_GRASS=true, WILD_ONLY=true, WILD_WOOD=true },
  resolvers.mon_inven{ '60%' },
  drop = { treasure=0, combat=0, magic=0, tools=0, junk=100 },
  attacks = {
    { type=DamageType.PARALYZE, method=AttackType.HIT },
    { type=DamageType.PARALYZE, method=AttackType.HIT },
  },
  body = bodies.none,
  speed = -10,
  vision = 5,
  alertness = 5,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'GIANT_WHITE_DRAGON_FLY',
  name = [[Giant white dragon fly]],
  display = 'F',
  color = colors.C_w,
  image = 'npc/giant_white_dragon_fly.png',
  desc = [[It is a large fly that drips frost.]],
  corpse_weight = 15,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=50,
    talent_in = 10,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 3, 8 },
  ac = 20,
  max_life = resolvers.dice(3, 8),
  rarity = 2,
  level = 14,
  start_level = 14,
  exp_worth = 60,
  resist_dam = {
    [DamageType.COLD] = true,
  },
  vuln_dam = {
    [DamageType.FIRE] = true,
  },
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    FLY = true,
    FORCE_SLEEP = true,
    MORTAL = true,
    WEIRD_MIND = true,
  },
  placement_flags = { WILD_TOO=true, WILD_WASTE=true },
  attacks = {
    { type=DamageType.COLD, method=AttackType.BITE, dam={1,6} },
  },
  resolvers.talents {
    [Talents.T_NPC_BR_COLD] = 1,
  },
  body = bodies.quadruped,
  speed = 0,
  vision = 12,
  alertness = 50,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'BLUE_ICKY_THING',
  name = [[Blue icky thing]],
  display = 'i',
  color = colors.C_b,
  image = 'npc/blue_icky_thing.png',
  desc = [[It is a strange, slimy, icky creature, with rudimentary intelligence, but evil cunning. It hungers for food, and you look tasty.]],
  corpse_weight = 60,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=50,
    talent_in = 8,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 10, 6 },
  ac = 20,
  max_life = resolvers.dice(10, 6),
  rarity = 4,
  level = 14,
  start_level = 14,
  exp_worth = 20,
  resist_dam = {
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    CAN_SWIM = true,
    EVIL = true,
    FORCE_SLEEP = true,
    MULTIPLY = true,
    OPEN_DOOR = true,
  },
  placement_flags = {},
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.POISON, method=AttackType.CRAWL, dam={1,4} },
    { type=DamageType.EAT_FOOD, method=AttackType.CRAWL },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,4} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,4} },
  },
  resolvers.talents {
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_SCARE] = 1,
  },
  body = bodies.none,
  speed = -10,
  vision = 15,
  alertness = 20,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'GIBBERING_MOUTHER',
  name = [[Gibbering mouther]],
  display = 'j',
  color = colors.C_o,
  image = 'npc/gibbering_mouther.png',
  desc = [[A chaotic mass of pulsating flesh, mouths and eyes.]],
  corpse_weight = 260,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 7,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 8, 6 },
  ac = 20,
  max_life = resolvers.dice(8, 6),
  rarity = 4,
  level = 14,
  start_level = 14,
  exp_worth = 20,
  resist_dam = {
    [DamageType.FEAR] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    CAN_SWIM = true,
    EMPTY_MIND = true,
    EVIL = true,
    MULTIPLY = true,
    NEVER_MOVE = true,
    NO_CUT = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.POISON, method=AttackType.CRAWL, dam={1,4} },
  },
  resolvers.talents {
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_BR_LITE] = 1,
  },
  body = bodies.none,
  speed = 0,
  vision = 15,
  alertness = 20,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'HILL_GIANT',
  name = [[Hill giant]],
  display = 'P',
  color = colors.C_U,
  image = 'npc/hill_giant.png',
  desc = [[A ten foot tall humanoid with powerful muscles.]],
  corpse_weight = 350,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 30, 15 },
  ac = 45,
  max_life = resolvers.dice(30, 15),
  rarity = 1,
  level = 25,
  start_level = 25,
  exp_worth = 150,
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    EVIL = true,
    GIANT = true,
    HAS_LITE = true,
    MALE = true,
    MORTAL = true,
    OPEN_DOOR = true,
  },
  placement_flags = { WILD_MOUNTAIN=true, WILD_TOO=true },
  resolvers.mon_inven{ '60%' },
  drop = { treasure=20, combat=50, magic=20, tools=5, junk=5 },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={4,8} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={4,8} },
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 20,
  alertness = 50,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'FLESH_GOLEM',
  name = [[Flesh golem]],
  display = 'g',
  color = colors.C_R,
  image = 'npc/flesh_golem.png',
  desc = [[A shambling humanoid monster with long scars.]],
  corpse_weight = 300,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 12, 8 },
  ac = 30,
  max_life = resolvers.dice(12, 8),
  rarity = 2,
  level = 14,
  start_level = 14,
  exp_worth = 50,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.ELEC] = true,
    [DamageType.FEAR] = true,
    [DamageType.OLD_SLEEP] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    CAN_SWIM = true,
    EMPTY_MIND = true,
    MORTAL = true,
    NONLIVING = true,
    NO_CUT = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,6} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,6} },
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 12,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'WARG',
  name = [[Warg]],
  display = 'C',
  color = colors.C_D,
  image = 'npc/warg.png',
  desc = [[It is a large wolf with eyes full of cunning.]],
  corpse_weight = 70,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=25,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 8, 8 },
  ac = 20,
  max_life = resolvers.dice(8, 8),
  rarity = 2,
  level = 16,
  start_level = 16,
  exp_worth = 40,
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    EVIL = true,
    FRIENDS = true,
    MORTAL = true,
  },
  placement_flags = { WILD_MOUNTAIN=true, WILD_TOO=true, WILD_WOOD=true },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={1,6} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={1,6} },
  },
  body = bodies.quadruped,
  speed = 10,
  vision = 20,
  alertness = 40,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'GIANT_FLEA',
  name = [[Giant flea]],
  display = 'I',
  color = colors.C_s,
  image = 'npc/giant_flea.png',
  desc = [[It makes you itch just to look at it.]],
  corpse_weight = 9,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=50,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 1, 2 },
  ac = 7,
  max_life = resolvers.dice(1, 2),
  rarity = 3,
  level = 14,
  start_level = 14,
  exp_worth = 3,
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    FLY = true,
    MORTAL = true,
    MULTIPLY = true,
    WEIRD_MIND = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={1,2} },
  },
  body = bodies.none,
  speed = 10,
  vision = 6,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'UFTHAK_OF_CIRITH_UNGOL',
  name = [[Ufthak of Cirith Ungol]],
  display = 'o',
  color = colors.C_g,
  image = 'npc/ufthak_of_cirith_ungol.png',
  desc = [[A strong orc guarding the pass of Cirith Ungol. He is mortally afraid of spiders:  he was captured by Shelob once, but escaped when she forgot completely about him.]],
  corpse_weight = 260,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 34, 10 },
  ac = 50,
  max_life = 340,
  rarity = 3,
  level = 14,
  start_level = 14,
  exp_worth = 250,
  unique = 'UFTHAK_OF_CIRITH_UNGOL',
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.DARK] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    CAN_SPEAK = true,
    ESCORT = true,
    EVIL = true,
    FORCE_MAXHP = true,
    HAS_LITE = true,
    MALE = true,
    MORTAL = true,
    OPEN_DOOR = true,
    ORC = true,
    UNIQUE = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, only_item=true, '1d2' },
  drop = { treasure=0, combat=100, magic=0, tools=0, junk=0 },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={3,5} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={3,5} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={3,5} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={3,5} },
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 20,
  alertness = 20,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'CLAY_GOLEM',
  name = [[Clay golem]],
  display = 'g',
  color = colors.C_U,
  image = 'npc/clay_golem.png',
  desc = [[It is a massive animated statue made out of hardened clay.]],
  corpse_weight = 320,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 14, 8 },
  ac = 30,
  max_life = resolvers.dice(14, 8),
  rarity = 2,
  level = 15,
  start_level = 15,
  exp_worth = 60,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.ELEC] = true,
    [DamageType.FEAR] = true,
    [DamageType.FIRE] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  vuln_dam = {
    [DamageType.KILL_WALL] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    COLD_BLOOD = true,
    EMPTY_MIND = true,
    NO_CUT = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,8} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,8} },
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 12,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'BLACK_OGRE',
  name = [[Black ogre]],
  display = 'O',
  color = colors.C_D,
  image = 'npc/black_ogre.png',
  desc = [[A massive orc-like figure with black skin and powerful arms.]],
  corpse_weight = 230,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=25,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 20, 9 },
  ac = 33,
  max_life = resolvers.dice(20, 9),
  rarity = 2,
  level = 15,
  start_level = 15,
  exp_worth = 70,
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    EVIL = true,
    FRIENDS = true,
    GIANT = true,
    HAS_LITE = true,
    MORTAL = true,
    OPEN_DOOR = true,
  },
  placement_flags = { WILD_MOUNTAIN=true, WILD_TOO=true },
  resolvers.mon_inven{ '60%' },
  drop = { treasure=0, combat=70, magic=0, tools=15, junk=15 },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={2,8} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={2,8} },
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 20,
  alertness = 30,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'HALF_ORC',
  name = [[Half-orc]],
  display = 'o',
  color = colors.C_s,
  image = 'npc/half_orc.png',
  desc = [[He is a hideous deformed cross-breed of man and orc, combining man's strength and cunning with orcish evil.  The traitorous wizard Saruman is generally believed to be responsible for this abomination.]],
  corpse_weight = 170,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 16, 10 },
  ac = 40,
  max_life = resolvers.dice(16, 10),
  rarity = 2,
  level = 15,
  start_level = 15,
  exp_worth = 50,
  resist_dam = {
    [DamageType.DARK] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    EVIL = true,
    FRIENDS = true,
    HAS_LITE = true,
    MALE = true,
    MORTAL = true,
    OPEN_DOOR = true,
    ORC = true,
  },
  placement_flags = { WILD_TOO=true },
  resolvers.mon_inven{ '60%' },
  drop = { treasure=30, combat=30, magic=30, tools=5, junk=5 },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={3,4} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={3,4} },
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 20,
  alertness = 20,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'DARK_NAGA',
  name = [[Dark naga]],
  display = 'n',
  color = colors.C_s,
  image = 'npc/dark_naga.png',
  desc = [[A giant snake-like figure with a woman's torso, talented in magic.]],
  corpse_weight = 190,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=25,
    talent_in = 8,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 22, 11 },
  ac = 65,
  max_life = resolvers.dice(22, 11),
  rarity = 2,
  level = 15,
  start_level = 15,
  exp_worth = 90,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.POISON] = true,
    [DamageType.WATER] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    CAN_SWIM = true,
    EMPTY_MIND = true,
    EVIL = true,
    FEMALE = true,
    MORTAL = true,
    OPEN_DOOR = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ '1d2', '60%' },
  drop = { treasure=0, combat=0, magic=80, tools=20, junk=0 },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.STING, dam={1,10} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={1,10} },
  },
  resolvers.talents {
    [Talents.T_NPC_HOLD] = 1,
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_BO_COLD] = 1,
    [Talents.T_NPC_HEAL] = 1,
    [Talents.T_NPC_DARKNESS] = 1,
  },
  body = bodies.snake,
  speed = 0,
  vision = 60,
  alertness = 60,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'POISON_IVY',
  name = [[Poison ivy]],
  display = '#',
  color = colors.C_g,
  image = 'npc/poison_ivy.png',
  desc = [[A mass of vegetation.  It seems to be growing...]],
  corpse_weight = 5,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 5, 5 },
  ac = 5,
  max_life = resolvers.dice(5, 5),
  rarity = 4,
  level = 10,
  start_level = 10,
  exp_worth = 10,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.FEAR] = true,
    [DamageType.OLD_SLEEP] = true,
  },
  vuln_dam = {
    [DamageType.FIRE] = true,
  },
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    COLD_BLOOD = true,
    EMPTY_MIND = true,
    FORCE_SLEEP = true,
    FRIENDS = true,
    KILL_TREES = true,
    MORTAL = true,
    MULTIPLY = true,
    NEVER_MOVE = true,
    NO_CUT = true,
    STUPID = true,
  },
  placement_flags = { WILD_GRASS=true, WILD_ONLY=true, WILD_WOOD=true },
  resolvers.mon_inven{ '60%' },
  drop = { treasure=0, combat=0, magic=0, tools=0, junk=100 },
  attacks = {
    { type=DamageType.POISON, method=AttackType.HIT, dam={2,2} },
    { type=DamageType.POISON, method=AttackType.HIT, dam={2,2} },
  },
  body = bodies.none,
  speed = -10,
  vision = 5,
  alertness = 5,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'MAGIC_MUSHROOM_PATCH',
  name = [[Magic mushroom patch]],
  display = ',',
  color = colors.C_B,
  image = 'npc/magic_mushroom_patch.png',
  desc = [[Yum!  It looks quite tasty. It seems to glow with an unusual light.]],
  corpse_weight = 5,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 2,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 1, 1 },
  ac = 10,
  max_life = resolvers.dice(1, 1),
  rarity = 2,
  level = 15,
  start_level = 15,
  exp_worth = 10,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.FEAR] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.TELEPORT] = true,
  },
  flags = {
    BASEANGBAND = true,
    CAN_SWIM = true,
    FORCE_SLEEP = true,
    NEVER_MOVE = true,
    NO_CUT = true,
    STUPID = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.CONFUSION, method=AttackType.SPORE },
    { type=DamageType.CONFUSION, method=AttackType.SPORE },
    { type=DamageType.HALLUCINATION, method=AttackType.SPORE },
    { type=DamageType.HALLUCINATION, method=AttackType.SPORE },
  },
  resolvers.talents {
    [Talents.T_NPC_BLINK] = 1,
    [Talents.T_NPC_SLOW] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_DARKNESS] = 1,
  },
  body = bodies.none,
  speed = 30,
  vision = 40,
  alertness = 0,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'GUARDIAN_NAGA',
  name = [[Guardian naga]],
  display = 'n',
  color = colors.C_y,
  image = 'npc/guardian_naga.png',
  desc = [[A giant snake-like figure with a woman's torso.]],
  corpse_weight = 190,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=25,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 24, 11 },
  ac = 65,
  max_life = resolvers.dice(24, 11),
  rarity = 2,
  level = 15,
  start_level = 15,
  exp_worth = 80,
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    CAN_SWIM = true,
    EVIL = true,
    FEMALE = true,
    MORTAL = true,
    OPEN_DOOR = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ '1d2', '60%' },
  drop = { treasure=0, combat=0, magic=80, tools=20, junk=0 },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CRUSH, dam={2,8} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={1,8} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={1,8} },
  },
  body = bodies.snake,
  speed = 0,
  vision = 20,
  alertness = 120,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'WERERAT',
  name = [[Wererat]],
  display = 'r',
  color = colors.C_D,
  image = 'npc/wererat.png',
  desc = [[A large rat with glowing red eyes, which can also assume human form. The wererat is a disgusting creature, relishing in filth and disease.]],
  corpse_weight = 3,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 9,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 20, 8 },
  ac = 10,
  max_life = resolvers.dice(20, 8),
  rarity = 2,
  level = 15,
  start_level = 15,
  exp_worth = 55,
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    EVIL = true,
    FORCE_SLEEP = true,
    MORTAL = true,
    OPEN_DOOR = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ only_gold=true, '60%' },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={1,8} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={1,8} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={2,6} },
  },
  resolvers.talents {
    [Talents.T_NPC_BLINK] = 1,
    [Talents.T_NPC_CAUSE_2] = 1,
    [Talents.T_NPC_BO_COLD] = 1,
    [Talents.T_NPC_BA_POIS] = 1,
    [Talents.T_NPC_S_KIN] = 1,
  },
  body = bodies.quadruped,
  speed = 0,
  vision = 10,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'LIGHT_HOUND',
  name = [[Light hound]],
  display = 'Z',
  color = colors.C_o,
  image = 'npc/light_hound.png',
  desc = [[A brilliant canine form whose light hurts your eyes, even at this distance.]],
  corpse_weight = 60,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 5,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 6, 6 },
  ac = 30,
  max_life = resolvers.dice(6, 6),
  rarity = 1,
  level = 15,
  start_level = 15,
  exp_worth = 50,
  resist_dam = {
    [DamageType.LITE] = true,
  },
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    FORCE_SLEEP = true,
    FRIENDS = true,
    HAS_LITE = true,
    MORTAL = true,
  },
  placement_flags = {},
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={1,4} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={1,4} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={1,6} },
  },
  resolvers.talents {
    [Talents.T_NPC_BR_LITE] = 1,
  },
  body = bodies.quadruped,
  speed = 0,
  vision = 30,
  alertness = 0,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'DARK_HOUND',
  name = [[Dark hound]],
  display = 'Z',
  color = colors.C_D,
  image = 'npc/dark_hound.png',
  desc = [[A hole in the air in the shape of a huge hound. No light falls upon its form.]],
  corpse_weight = 60,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 5,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 6, 6 },
  ac = 30,
  max_life = resolvers.dice(6, 6),
  rarity = 1,
  level = 15,
  start_level = 15,
  exp_worth = 50,
  resist_dam = {
    [DamageType.DARK] = true,
  },
  vuln_dam = {
    [DamageType.LITE] = true,
    [DamageType.LITE_WEAK] = true,
  },
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    FORCE_SLEEP = true,
    FRIENDS = true,
    MORTAL = true,
  },
  placement_flags = {},
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={1,4} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={1,4} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={1,6} },
  },
  resolvers.talents {
    [Talents.T_NPC_BR_DARK] = 1,
  },
  body = bodies.quadruped,
  speed = 0,
  vision = 30,
  alertness = 0,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'FLYING_SKULL',
  name = [[Flying skull]],
  display = 's',
  color = colors.C_s,
  image = 'npc/flying_skull.png',
  desc = [[A pack of skulls animated by necromantic spells.]],
  corpse_weight = 50,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 10, 10 },
  ac = 30,
  max_life = resolvers.dice(10, 10),
  rarity = 3,
  level = 15,
  start_level = 15,
  exp_worth = 50,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.FEAR] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    COLD_BLOOD = true,
    EVIL = true,
    FLY = true,
    FRIENDS = true,
    NO_CUT = true,
    UNDEAD = true,
    WEIRD_MIND = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ '60%' },
  drop = { treasure=90, combat=0, magic=10, tools=0, junk=0 },
  attacks = {
    { type=DamageType.POISON, method=AttackType.BITE, dam={1,3} },
    { type=DamageType.LOSE_STR, method=AttackType.BITE, dam={1,4} },
  },
  body = bodies.snake,
  speed = 0,
  vision = 30,
  alertness = 20,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'GIANT_TARANTULA',
  name = [[Giant tarantula]],
  display = 'S',
  color = colors.C_o,
  image = 'npc/giant_tarantula.png',
  desc = [[A giant spider with hairy black and red legs.]],
  corpse_weight = 110,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 10, 15 },
  ac = 32,
  max_life = resolvers.dice(10, 15),
  rarity = 3,
  level = 15,
  start_level = 15,
  exp_worth = 70,
  resist_dam = {
    [DamageType.POISON] = true,
  },
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    MORTAL = true,
    SPIDER = true,
    WEIRD_MIND = true,
  },
  placement_flags = { WILD_TOO=true },
  drop_corpse = { skeleton=true },
  attacks = {
    { type=DamageType.POISON, method=AttackType.BITE, dam={1,6} },
    { type=DamageType.POISON, method=AttackType.BITE, dam={1,6} },
    { type=DamageType.POISON, method=AttackType.BITE, dam={1,6} },
  },
  body = bodies.quadruped,
  speed = 10,
  vision = 8,
  alertness = 80,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'GIANT_CLEAR_CENTIPEDE',
  name = [[Giant clear centipede]],
  display = 'c',
  color = colors.C_B,
  image = 'npc/giant_clear_centipede.png',
  desc = [[It is about four feet long and carnivorous.]],
  corpse_weight = 40,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 5, 8 },
  ac = 30,
  max_life = resolvers.dice(5, 8),
  rarity = 2,
  level = 15,
  start_level = 15,
  exp_worth = 30,
  flags = {
    ANIMAL = true,
    ATTR_CLEAR = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    INVISIBLE = true,
    MORTAL = true,
    WEIRD_MIND = true,
  },
  placement_flags = { WILD_TOO=true },
  drop_corpse = { skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={2,4} },
    { type=DamageType.PHYSICAL, method=AttackType.STING, dam={2,4} },
  },
  body = bodies.snake,
  speed = 0,
  vision = 12,
  alertness = 30,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'MIRKWOOD_SPIDER',
  name = [[Mirkwood spider]],
  display = 'S',
  color = colors.C_G,
  image = 'npc/mirkwood_spider.png',
  desc = [[A strong and powerful spider from Mirkwood forest. Cunning and evil, it seeks to taste your juicy insides.]],
  corpse_weight = 120,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 9, 8 },
  ac = 25,
  max_life = resolvers.dice(9, 8),
  rarity = 2,
  level = 15,
  start_level = 15,
  exp_worth = 25,
  resist_dam = {
    [DamageType.DARK] = true,
    [DamageType.POISON] = true,
  },
  vuln_dam = {
    [DamageType.LITE] = true,
    [DamageType.LITE_WEAK] = true,
  },
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    EVIL = true,
    FRIENDS = true,
    MORTAL = true,
    SPIDER = true,
    WEIRD_MIND = true,
  },
  placement_flags = { WILD_TOO=true, WILD_WOOD=true },
  drop_corpse = { skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={1,8} },
    { type=DamageType.POISON, method=AttackType.BITE, dam={1,6} },
    { type=DamageType.POISON, method=AttackType.BITE, dam={1,6} },
  },
  body = bodies.quadruped,
  speed = 10,
  vision = 15,
  alertness = 80,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'FROST_GIANT',
  name = [[Frost giant]],
  display = 'P',
  color = colors.C_w,
  image = 'npc/frost_giant.png',
  desc = [[A twelve foot tall giant covered in furs.]],
  corpse_weight = 400,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 32, 15 },
  ac = 50,
  max_life = resolvers.dice(32, 15),
  rarity = 1,
  level = 28,
  start_level = 28,
  exp_worth = 180,
  resist_dam = {
    [DamageType.COLD] = true,
  },
  vuln_dam = {
    [DamageType.FIRE] = true,
  },
  melee_retal = {
    [DamageType.COLD] = 'mondam',
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    EVIL = true,
    GIANT = true,
    HAS_LITE = true,
    MALE = true,
    MORTAL = true,
    OPEN_DOOR = true,
  },
  placement_flags = { WILD_MOUNTAIN=true, WILD_TOO=true, WILD_WASTE=true },
  resolvers.mon_inven{ '60%' },
  drop = { treasure=20, combat=80, magic=0, tools=0, junk=0 },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.COLD, method=AttackType.HIT, dam={5,8} },
    { type=DamageType.COLD, method=AttackType.HIT, dam={5,8} },
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 20,
  alertness = 50,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'GRIFFON',
  name = [[Griffon]],
  display = 'H',
  color = colors.C_u,
  image = 'npc/griffon.png',
  desc = [[It is half lion, half eagle. It flies menacingly towards you.]],
  corpse_weight = 250,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 30, 8 },
  ac = 15,
  max_life = resolvers.dice(30, 8),
  rarity = 1,
  level = 15,
  start_level = 15,
  exp_worth = 70,
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    FLY = true,
    MORTAL = true,
  },
  placement_flags = { WILD_GRASS=true, WILD_MOUNTAIN=true, WILD_TOO=true, WILD_WOOD=true },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={3,4} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={2,6} },
  },
  body = bodies.quadruped,
  speed = 0,
  vision = 12,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'HOMUNCULUS',
  name = [[Homunculus]],
  display = 'u',
  color = colors.C_y,
  image = 'npc/homunculus.png',
  desc = [[It is a small demonic spirit full of malevolence.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 8, 8 },
  ac = 32,
  max_life = resolvers.dice(8, 8),
  rarity = 3,
  level = 15,
  start_level = 15,
  exp_worth = 40,
  resist_dam = {
    [DamageType.FEAR] = true,
    [DamageType.FIRE] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    DEMON = true,
    EVIL = true,
    FLY = true,
    HAS_LITE = true,
    NONLIVING = true,
    OPEN_DOOR = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.PARALYZE, method=AttackType.HIT, dam={1,2} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,10} },
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 20,
  alertness = 30,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'GNOME_MAGE',
  name = [[Gnome mage]],
  display = 'h',
  color = colors.C_R,
  image = 'npc/gnome_mage.png',
  desc = [[A mage of short stature.]],
  corpse_weight = 90,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 4,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 7, 8 },
  ac = 20,
  max_life = resolvers.dice(7, 8),
  rarity = 2,
  level = 15,
  start_level = 15,
  exp_worth = 40,
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    EVIL = true,
    FORCE_SLEEP = true,
    FRIENDS = true,
    HAS_LITE = true,
    MALE = true,
    MORTAL = true,
    OPEN_DOOR = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ '60%' },
  drop = { treasure=20, combat=0, magic=80, tools=0, junk=0 },
  drop_corpse = { skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,5} },
  },
  resolvers.talents {
    [Talents.T_NPC_BLINK] = 1,
    [Talents.T_NPC_DARKNESS] = 1,
    [Talents.T_NPC_BO_COLD] = 1,
    [Talents.T_NPC_S_MONSTER] = 1,
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 20,
  alertness = 20,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'CLEAR_HOUND',
  name = [[Clear hound]],
  display = 'Z',
  color = colors.C_B,
  image = 'npc/clear_hound.png',
  desc = [[A faint sense of motion in the air, hound shaped, stands before you.]],
  corpse_weight = 60,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 6, 6 },
  ac = 30,
  max_life = resolvers.dice(6, 6),
  rarity = 1,
  level = 15,
  start_level = 15,
  exp_worth = 50,
  flags = {
    ANIMAL = true,
    ATTR_CLEAR = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    FRIENDS = true,
    INVISIBLE = true,
    MORTAL = true,
  },
  placement_flags = {},
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={1,6} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={1,6} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={1,8} },
  },
  body = bodies.quadruped,
  speed = 0,
  vision = 30,
  alertness = 0,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'UMBER_HULK',
  name = [[Umber hulk]],
  display = 'X',
  color = colors.C_U,
  image = 'npc/umber_hulk.png',
  desc = [[This bizarre creature has glaring eyes and large mandibles capable of slicing through rock.]],
  corpse_weight = 500,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 20, 10 },
  ac = 50,
  max_life = resolvers.dice(20, 10),
  rarity = 1,
  level = 16,
  start_level = 16,
  exp_worth = 75,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  vuln_dam = {
    [DamageType.KILL_WALL] = true,
  },
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    COLD_BLOOD = true,
    EMPTY_MIND = true,
    EVIL = true,
    KILL_WALL = true,
    NO_CUT = true,
  },
  placement_flags = {},
  drop_corpse = { skeleton=true },
  attacks = {
    { type=DamageType.CONFUSION, method=AttackType.GAZE },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,6} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,6} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={2,6} },
  },
  body = bodies.quadruped,
  speed = 0,
  vision = 20,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'RUST_MONSTER',
  name = [[Rust monster]],
  display = 'q',
  color = colors.C_o,
  image = 'npc/rust_monster.png',
  desc = [[It is a weird, small animal with two antennae popping forth from its forehead. It looks hungry.]],
  corpse_weight = 90,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 20, 15 },
  ac = 55,
  max_life = resolvers.dice(20, 15),
  rarity = 2,
  level = 16,
  start_level = 16,
  exp_worth = 50,
  resist_dam = {
    [DamageType.ACID] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    KILL_ITEM = true,
    MORTAL = true,
    STUPID = true,
    WEIRD_MIND = true,
  },
  placement_flags = {},
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.ACID, method=AttackType.TOUCH, dam={1,10} },
    { type=DamageType.ACID, method=AttackType.TOUCH, dam={1,10} },
    { type=DamageType.ACID, method=AttackType.TOUCH, dam={1,10} },
    { type=DamageType.ACID, method=AttackType.TOUCH, dam={1,10} },
  },
  body = bodies.quadruped,
  speed = 0,
  vision = 12,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'OGRILLON',
  name = [[Ogrillon]],
  display = 'O',
  color = colors.C_W,
  image = 'npc/ogrillon.png',
  desc = [[An unholy hybrid of ogre and orc.]],
  corpse_weight = 240,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 22, 9 },
  ac = 33,
  max_life = resolvers.dice(22, 9),
  rarity = 2,
  level = 16,
  start_level = 16,
  exp_worth = 75,
  resist_dam = {
    [DamageType.DARK] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    EVIL = true,
    FRIENDS = true,
    GIANT = true,
    HAS_LITE = true,
    MORTAL = true,
    OPEN_DOOR = true,
    ORC = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ '60%' },
  drop = { treasure=20, combat=70, magic=0, tools=10, junk=0 },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={2,10} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={2,10} },
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 20,
  alertness = 30,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'GELATINOUS_CUBE',
  name = [[Gelatinous cube]],
  display = 'j',
  color = colors.C_G,
  image = 'npc/gelatinous_cube.png',
  desc = [[It is a strange, vast gelatinous structure that assumes cubic proportions as it lines all four walls of the corridors it patrols. Through its transparent jelly structure you can see treasures it has engulfed, and a few corpses as well.]],
  corpse_weight = 4000,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 36, 10 },
  ac = 18,
  max_life = 360,
  rarity = 4,
  level = 16,
  start_level = 16,
  exp_worth = 80,
  resist_dam = {
    [DamageType.ACID] = true,
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.ELEC] = true,
    [DamageType.FEAR] = true,
    [DamageType.FIRE] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    CAN_SWIM = true,
    COLD_BLOOD = true,
    EMPTY_MIND = true,
    FORCE_MAXHP = true,
    NO_CUT = true,
    OPEN_DOOR = true,
    STUPID = true,
    TAKE_ITEM = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ '1d2', '4d2' },
  drop = { treasure=40, combat=30, magic=20, tools=0, junk=10 },
  attacks = {
    { type=DamageType.ACID, method=AttackType.TOUCH, dam={1,10} },
    { type=DamageType.ACID, method=AttackType.TOUCH, dam={1,10} },
    { type=DamageType.ACID, method=AttackType.TOUCH, dam={1,10} },
  },
  body = bodies.none,
  speed = 0,
  vision = 12,
  alertness = 1,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'GIANT_GREEN_DRAGON_FLY',
  name = [[Giant green dragon fly]],
  display = 'F',
  color = colors.C_G,
  image = 'npc/giant_green_dragon_fly.png',
  desc = [[A vast, foul-smelling dragonfly.]],
  corpse_weight = 15,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=75,
    talent_in = 10,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 3, 8 },
  ac = 20,
  max_life = resolvers.dice(3, 8),
  rarity = 2,
  level = 16,
  start_level = 16,
  exp_worth = 65,
  resist_dam = {
    [DamageType.POISON] = true,
  },
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    FLY = true,
    FORCE_SLEEP = true,
    MORTAL = true,
    WEIRD_MIND = true,
  },
  placement_flags = { WILD_SWAMP=true, WILD_TOO=true },
  attacks = {
    { type=DamageType.POISON, method=AttackType.BITE, dam={1,6} },
  },
  resolvers.talents {
    [Talents.T_NPC_BR_POIS] = 1,
  },
  body = bodies.quadruped,
  speed = 0,
  vision = 12,
  alertness = 50,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'FIRE_GIANT',
  name = [[Fire giant]],
  display = 'P',
  color = colors.C_r,
  image = 'npc/fire_giant.png',
  desc = [[A glowing fourteen foot tall giant. Flames drip from its red skin.]],
  corpse_weight = 500,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 34, 16 },
  ac = 60,
  max_life = resolvers.dice(34, 16),
  rarity = 1,
  level = 30,
  start_level = 30,
  exp_worth = 220,
  resist_dam = {
    [DamageType.FIRE] = true,
  },
  vuln_dam = {
    [DamageType.COLD] = true,
  },
  melee_retal = {
    [DamageType.FIRE] = 'mondam',
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    EVIL = true,
    GIANT = true,
    HAS_LITE = true,
    MALE = true,
    MORTAL = true,
    OPEN_DOOR = true,
  },
  placement_flags = { WILD_TOO=true, WILD_VOLCANO=true },
  resolvers.mon_inven{ '60%' },
  drop = { treasure=20, combat=80, magic=0, tools=0, junk=0 },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.FIRE, method=AttackType.HIT, dam={6,8} },
    { type=DamageType.FIRE, method=AttackType.HIT, dam={6,8} },
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 20,
  alertness = 50,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'HUMMERHORN',
  name = [[Hummerhorn]],
  display = 'I',
  color = colors.C_y,
  image = 'npc/hummerhorn.png',
  desc = [[A giant buzzing wasp, its stinger drips venom.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=75,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 2, 2 },
  ac = 14,
  max_life = resolvers.dice(2, 2),
  rarity = 4,
  level = 16,
  start_level = 16,
  exp_worth = 4,
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    FLY = true,
    MULTIPLY = true,
    WEIRD_MIND = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.CONFUSION, method=AttackType.BITE, dam={2,2} },
  },
  body = bodies.quadruped,
  speed = 10,
  vision = 8,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'LIZARD_MAN',
  name = [[Lizard man]],
  plural_name = [[Lizard men]],
  display = 'h',
  color = colors.C_G,
  image = 'npc/lizard_man.png',
  desc = [[Intelligent lizard beings from the depths.]],
  corpse_weight = 130,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 16, 10 },
  ac = 40,
  max_life = resolvers.dice(16, 10),
  rarity = 3,
  level = 16,
  start_level = 16,
  exp_worth = 55,
  resist_dam = {
    [DamageType.ACID] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    CAN_SWIM = true,
    EVIL = true,
    FRIENDS = true,
    HAS_LITE = true,
    MALE = true,
    MORTAL = true,
    OPEN_DOOR = true,
  },
  placement_flags = { WILD_SHORE=true, WILD_TOO=true },
  resolvers.mon_inven{ '60%' },
  drop = { treasure=50, combat=50, magic=0, tools=0, junk=0 },
  drop_corpse = { skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={4,4} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={4,4} },
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 20,
  alertness = 20,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'ULFAST_SON_OF_ULFANG',
  name = [[Ulfast, Son of Ulfang]],
  display = 'p',
  color = colors.C_U,
  image = 'npc/ulfast_son_of_ulfang.png',
  desc = [[A short and swarthy Easterling.]],
  corpse_weight = 170,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 37, 10 },
  ac = 40,
  max_life = 370,
  rarity = 3,
  level = 16,
  start_level = 16,
  exp_worth = 200,
  unique = 'ULFAST_SON_OF_ULFANG',
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    CAN_SPEAK = true,
    EVIL = true,
    FORCE_MAXHP = true,
    HAS_LITE = true,
    MALE = true,
    MORTAL = true,
    OPEN_DOOR = true,
    TAKE_ITEM = true,
    UNIQUE = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, only_item=true, '90%' },
  drop = { treasure=0, combat=100, magic=0, tools=0, junk=0 },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={3,6} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={3,6} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={3,6} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={3,6} },
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 20,
  alertness = 40,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'CREBAIN',
  name = [[Craban]],
  plural_name = [[Crebain]],
  display = 'B',
  color = colors.C_D,
  image = 'npc/crebain.png',
  desc = [[A type of crow, specially bred by the forces of evil as spies; their rudimentary intelligence guided by an evil mind has tracked you down, and now they seek to alert other evil creatures to your presence.]],
  corpse_weight = 50,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 8,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 3, 5 },
  ac = 12,
  max_life = resolvers.dice(3, 5),
  rarity = 4,
  level = 16,
  start_level = 16,
  exp_worth = 20,
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    EVIL = true,
    FLY = true,
    FRIENDS = true,
    HAS_EGG = true,
    MORTAL = true,
  },
  placement_flags = { WILD_GRASS=true, WILD_MOUNTAIN=true, WILD_OCEAN=true, WILD_SHORE=true, WILD_SWAMP=true, WILD_TOO=true, WILD_VOLCANO=true, WILD_WASTE=true, WILD_WOOD=true },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={1,4} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={1,4} },
  },
  resolvers.talents {
    [Talents.T_NPC_SHRIEK] = 1,
  },
  body = bodies.winged,
  speed = 10,
  vision = 40,
  alertness = 0,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'BERSERKER',
  name = [[Berserker]],
  display = 'p',
  color = colors.C_u,
  image = 'npc/berserker.png',
  desc = [[Even the strongest of normal human warriors fears the Berserker - the one who can drive himself into such a terrible battle-frenzy that he can survive blows which should kill him, and still apparently feel no pain.  He tramples weaker creatures underfoot in his eagerness to get to his real enemy, and his battle-cry strikes terror into his foes.]],
  corpse_weight = 230,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 4,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 60, 25 },
  ac = 80,
  max_life = 1500,
  rarity = 2,
  level = 45,
  start_level = 45,
  exp_worth = 2500,
  resist_dam = {
    [DamageType.FEAR] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    FORCE_MAXHP = true,
    HAS_LITE = true,
    KILL_BODY = true,
    MALE = true,
    MORTAL = true,
    NO_STUN = true,
  },
  placement_flags = {},
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={7,7} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={7,7} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={7,7} },
  },
  resolvers.talents {
    [Talents.T_NPC_HASTE] = 1,
    [Talents.T_NPC_SCARE] = 1,
  },
  body = bodies.humanoid,
  speed = 10,
  vision = 20,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'QUASIT',
  name = [[Quasit]],
  display = 'u',
  color = colors.C_o,
  image = 'npc/quasit.png',
  desc = [[The chaotic evil master's favourite pet.]],
  corpse_weight = 50,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=25,
    talent_in = 10,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 6, 8 },
  ac = 30,
  max_life = resolvers.dice(6, 8),
  rarity = 2,
  level = 16,
  start_level = 16,
  exp_worth = 50,
  resist_dam = {
    [DamageType.FIRE] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    DEMON = true,
    EVIL = true,
    FLY = true,
    FORCE_SLEEP = true,
    HAS_LITE = true,
    INVISIBLE = true,
    NONLIVING = true,
    SMART = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ only_item=true, '1d2' },
  drop = { treasure=0, combat=50, magic=30, tools=10, junk=10 },
  attacks = {
    { type=DamageType.LOSE_DEX, method=AttackType.BITE, dam={1,6} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={1,3} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={1,3} },
  },
  resolvers.talents {
    [Talents.T_NPC_BLINK] = 1,
    [Talents.T_NPC_TPORT] = 1,
    [Talents.T_NPC_TELE_TO] = 1,
    [Talents.T_NPC_TELE_LEVEL] = 1,
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_SCARE] = 1,
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 20,
  alertness = 20,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'SPHINX',
  name = [[Sphinx]],
  plural_name = [[Sphinxes]],
  display = 'H',
  color = colors.C_o,
  image = 'npc/sphinx.png',
  desc = [[It will eat you if you cannot answer its riddle.]],
  corpse_weight = 600,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 11,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 60, 5 },
  ac = 60,
  max_life = resolvers.dice(60, 5),
  rarity = 2,
  level = 17,
  start_level = 17,
  exp_worth = 80,
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    FLY = true,
    FORCE_SLEEP = true,
    MORTAL = true,
    OPEN_DOOR = true,
  },
  placement_flags = { WILD_MOUNTAIN=true, WILD_TOO=true },
  resolvers.mon_inven{ only_gold=true, '1d2' },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={2,6} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={2,6} },
  },
  resolvers.talents {
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_CONF] = 1,
  },
  body = bodies.quadruped,
  speed = 0,
  vision = 20,
  alertness = 20,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'IMP',
  name = [[Imp]],
  display = 'u',
  color = colors.C_g,
  image = 'npc/imp.png',
  desc = [[The lawful evil master's favourite pet.]],
  corpse_weight = 40,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=25,
    talent_in = 10,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 6, 8 },
  ac = 30,
  max_life = resolvers.dice(6, 8),
  rarity = 2,
  level = 17,
  start_level = 17,
  exp_worth = 55,
  resist_dam = {
    [DamageType.FIRE] = true,
    [DamageType.TELEPORT] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    COLD_BLOOD = true,
    DEMON = true,
    EVIL = true,
    FLY = true,
    FORCE_SLEEP = true,
    HAS_LITE = true,
    INVISIBLE = true,
    SMART = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ only_item=true, '1d2' },
  drop = { treasure=30, combat=20, magic=50, tools=0, junk=0 },
  attacks = {
    { type=DamageType.POISON, method=AttackType.HIT, dam={3,4} },
    { type=DamageType.POISON, method=AttackType.HIT, dam={3,4} },
  },
  resolvers.talents {
    [Talents.T_NPC_BLINK] = 1,
    [Talents.T_NPC_TPORT] = 1,
    [Talents.T_NPC_TELE_TO] = 1,
    [Talents.T_NPC_TELE_LEVEL] = 1,
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_BO_FIRE] = 1,
  },
  body = bodies.winged,
  speed = 0,
  vision = 20,
  alertness = 20,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'FOREST_TROLL',
  name = [[Forest troll]],
  display = 'T',
  color = colors.C_g,
  image = 'npc/forest_troll.png',
  desc = [[He is green-skinned and ugly.]],
  corpse_weight = 300,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 20, 10 },
  ac = 50,
  max_life = resolvers.dice(20, 10),
  rarity = 1,
  level = 17,
  start_level = 17,
  exp_worth = 70,
  resist_dam = {
    [DamageType.DARK] = true,
  },
  vuln_dam = {
    [DamageType.FIRE] = true,
    [DamageType.LITE] = true,
    [DamageType.LITE_WEAK] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    EVIL = true,
    FRIENDS = true,
    MALE = true,
    OPEN_DOOR = true,
    REGENERATE = true,
    TROLL = true,
  },
  placement_flags = { WILD_TOO=true, WILD_WOOD=true },
  resolvers.mon_inven{ '60%' },
  drop = { treasure=30, combat=70, magic=0, tools=0, junk=0 },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,4} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,4} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={1,6} },
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 20,
  alertness = 40,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'FREEZING_SPHERE',
  name = [[Freezing sphere]],
  display = '*',
  color = colors.C_w,
  image = 'npc/freezing_sphere.png',
  desc = [[A semi-sentient snowball, hurling itself at targets at random.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=75,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 6, 6 },
  ac = 30,
  max_life = resolvers.dice(6, 6),
  rarity = 1,
  level = 17,
  start_level = 17,
  exp_worth = 50,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.FEAR] = true,
    [DamageType.OLD_SLEEP] = true,
  },
  vuln_dam = {
    [DamageType.FIRE] = true,
  },
  melee_retal = {
    [DamageType.COLD] = 'mondam',
  },
  flags = {
    BASEANGBAND = true,
    EMPTY_MIND = true,
    FLY = true,
    FORCE_SLEEP = true,
    HAS_LITE = true,
    NONLIVING = true,
    NO_CUT = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.COLD, method=AttackType.EXPLODE, dam={8,8} },
  },
  body = bodies.none,
  speed = 10,
  vision = 100,
  alertness = 0,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'JUMPING_FIREBALL',
  name = [[Jumping fireball]],
  display = '*',
  color = colors.C_r,
  image = 'npc/jumping_fireball.png',
  desc = [[A semi-sentient fireball that moves around randomly.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=75,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 6, 6 },
  ac = 30,
  max_life = resolvers.dice(6, 6),
  rarity = 1,
  level = 17,
  start_level = 17,
  exp_worth = 50,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.FEAR] = true,
    [DamageType.FIRE] = true,
    [DamageType.OLD_SLEEP] = true,
  },
  vuln_dam = {
    [DamageType.COLD] = true,
  },
  melee_retal = {
    [DamageType.FIRE] = 'mondam',
  },
  flags = {
    BASEANGBAND = true,
    EMPTY_MIND = true,
    FLY = true,
    FORCE_SLEEP = true,
    HAS_LITE = true,
    NONLIVING = true,
    NO_CUT = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.FIRE, method=AttackType.EXPLODE, dam={8,8} },
  },
  body = bodies.none,
  speed = 10,
  vision = 100,
  alertness = 0,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'BALL_LIGHTNING',
  name = [[Ball lightning]],
  display = '*',
  color = colors.C_B,
  image = 'npc/ball_lightning.png',
  desc = [[A crackling ball of energy, zooming about seemingly at random.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=75,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 6, 6 },
  ac = 30,
  max_life = resolvers.dice(6, 6),
  rarity = 1,
  level = 17,
  start_level = 17,
  exp_worth = 50,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.ELEC] = true,
    [DamageType.FEAR] = true,
    [DamageType.OLD_SLEEP] = true,
  },
  melee_retal = {
    [DamageType.ELEC] = 'mondam',
  },
  flags = {
    BASEANGBAND = true,
    EMPTY_MIND = true,
    FLY = true,
    FORCE_SLEEP = true,
    HAS_LITE = true,
    NONLIVING = true,
    NO_CUT = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.ELEC, method=AttackType.EXPLODE, dam={8,8} },
  },
  body = bodies.none,
  speed = 10,
  vision = 100,
  alertness = 0,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = '2_HEADED_HYDRA',
  name = [[2-headed hydra]],
  display = 'M',
  color = colors.C_u,
  image = 'npc/2_headed_hydra.png',
  desc = [[A strange reptilian creature with two heads, guarding its hoard.]],
  corpse_weight = 400,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 11,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 100, 3 },
  ac = 60,
  max_life = resolvers.dice(100, 3),
  rarity = 2,
  level = 17,
  start_level = 17,
  exp_worth = 80,
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    CAN_SWIM = true,
    FORCE_SLEEP = true,
    HAS_EGG = true,
    IMPRESED = true,
    MORTAL = true,
    MOVE_BODY = true,
    OPEN_DOOR = true,
  },
  placement_flags = { WILD_SHORE=true, WILD_SWAMP=true, WILD_TOO=true },
  resolvers.mon_inven{ only_gold=true, '1d2' },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={2,6} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={2,6} },
  },
  resolvers.talents {
    [Talents.T_NPC_SCARE] = 1,
  },
  body = bodies.hydra,
  speed = 0,
  vision = 20,
  alertness = 20,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'SWAMP_THING',
  name = [[Swamp thing]],
  display = 'H',
  color = colors.C_g,
  image = 'npc/swamp_thing.png',
  desc = [[A creature that was once human, but is now as green as moss.]],
  corpse_weight = 200,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 8, 12 },
  ac = 60,
  max_life = resolvers.dice(8, 12),
  rarity = 2,
  level = 17,
  start_level = 17,
  exp_worth = 80,
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    CAN_SWIM = true,
    MORTAL = true,
    OPEN_DOOR = true,
  },
  placement_flags = { WILD_SWAMP=true, WILD_TOO=true },
  attacks = {
    { type=DamageType.FEAR, method=AttackType.CLAW, dam={2,5} },
    { type=DamageType.FEAR, method=AttackType.CLAW, dam={5,2} },
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 20,
  alertness = 30,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'WATER_SPIRIT',
  name = [[Water spirit]],
  display = 'E',
  color = colors.C_b,
  image = 'npc/water_spirit.png',
  desc = [[A whirlpool of sentient liquid.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=25,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 9, 8 },
  ac = 28,
  max_life = resolvers.dice(9, 8),
  rarity = 2,
  level = 17,
  start_level = 17,
  exp_worth = 58,
  resist_dam = {
    [DamageType.ACID] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.FEAR] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    COLD_BLOOD = true,
    EMPTY_MIND = true,
    FLY = true,
    NO_CUT = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={2,4} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={2,4} },
  },
  body = bodies.none,
  speed = 10,
  vision = 12,
  alertness = 40,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'GIANT_RED_SCORPION',
  name = [[Giant red scorpion]],
  display = 'S',
  color = colors.C_r,
  image = 'npc/giant_red_scorpion.png',
  desc = [[It is fast and poisonous.]],
  corpse_weight = 100,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 11, 8 },
  ac = 44,
  max_life = resolvers.dice(11, 8),
  rarity = 1,
  level = 17,
  start_level = 17,
  exp_worth = 62,
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    MORTAL = true,
    WEIRD_MIND = true,
  },
  placement_flags = { WILD_TOO=true },
  drop_corpse = { skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={2,4} },
    { type=DamageType.LOSE_STR, method=AttackType.STING, dam={1,7} },
  },
  body = bodies.quadruped,
  speed = 0,
  vision = 12,
  alertness = 20,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'EARTH_SPIRIT',
  name = [[Earth spirit]],
  display = 'E',
  color = colors.C_u,
  image = 'npc/earth_spirit.png',
  desc = [[A whirling form of sentient rock.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=25,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 13, 8 },
  ac = 40,
  max_life = resolvers.dice(13, 8),
  rarity = 2,
  level = 17,
  start_level = 17,
  exp_worth = 64,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.ELEC] = true,
    [DamageType.FEAR] = true,
    [DamageType.FIRE] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  vuln_dam = {
    [DamageType.KILL_WALL] = true,
  },
  flags = {
    BASEANGBAND = true,
    COLD_BLOOD = true,
    EMPTY_MIND = true,
    FLY = true,
    NO_CUT = true,
    PASS_WALL = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,8} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,8} },
  },
  body = bodies.none,
  speed = 10,
  vision = 10,
  alertness = 50,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'FIRE_SPIRIT',
  name = [[Fire spirit]],
  display = 'E',
  color = colors.C_r,
  image = 'npc/fire_spirit.png',
  desc = [[A whirlwind of sentient flame.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=25,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 10, 9 },
  ac = 30,
  max_life = resolvers.dice(10, 9),
  rarity = 2,
  level = 18,
  start_level = 18,
  exp_worth = 75,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.FEAR] = true,
    [DamageType.FIRE] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  vuln_dam = {
    [DamageType.COLD] = true,
  },
  melee_retal = {
    [DamageType.FIRE] = 'mondam',
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    EMPTY_MIND = true,
    FLY = true,
    HAS_LITE = true,
    NO_CUT = true,
  },
  placement_flags = { WILD_TOO=true, WILD_VOLCANO=true },
  attacks = {
    { type=DamageType.FIRE, method=AttackType.HIT, dam={2,6} },
    { type=DamageType.FIRE, method=AttackType.HIT, dam={2,6} },
  },
  body = bodies.none,
  speed = 10,
  vision = 16,
  alertness = 20,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'FIRE_HOUND',
  name = [[Fire hound]],
  display = 'Z',
  color = colors.C_r,
  image = 'npc/fire_hound.png',
  desc = [[Flames lick at its feet and its tongue is a blade of fire. You can feel a furnace heat radiating from the creature.]],
  corpse_weight = 60,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 10,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 10, 6 },
  ac = 30,
  max_life = resolvers.dice(10, 6),
  rarity = 1,
  level = 18,
  start_level = 18,
  exp_worth = 70,
  resist_dam = {
    [DamageType.FIRE] = true,
  },
  vuln_dam = {
    [DamageType.COLD] = true,
  },
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    FORCE_SLEEP = true,
    FRIENDS = true,
    HAS_LITE = true,
    MORTAL = true,
  },
  placement_flags = {},
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={3,3} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={3,3} },
    { type=DamageType.FIRE, method=AttackType.BITE, dam={2,6} },
  },
  resolvers.talents {
    [Talents.T_NPC_BR_FIRE] = 1,
  },
  body = bodies.quadruped,
  speed = 0,
  vision = 30,
  alertness = 0,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'COLD_HOUND',
  name = [[Cold hound]],
  display = 'Z',
  color = colors.C_w,
  image = 'npc/cold_hound.png',
  desc = [[A hound as tall as a man, this creature appears to be composed of angular planes of ice. Cold radiates from it and freezes your breath in the air.]],
  corpse_weight = 60,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 10,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 10, 6 },
  ac = 30,
  max_life = resolvers.dice(10, 6),
  rarity = 1,
  level = 18,
  start_level = 18,
  exp_worth = 70,
  resist_dam = {
    [DamageType.COLD] = true,
  },
  vuln_dam = {
    [DamageType.FIRE] = true,
  },
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    FORCE_SLEEP = true,
    FRIENDS = true,
    MORTAL = true,
  },
  placement_flags = {},
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={3,3} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={3,3} },
    { type=DamageType.COLD, method=AttackType.BITE, dam={2,6} },
  },
  resolvers.talents {
    [Talents.T_NPC_BR_COLD] = 1,
  },
  body = bodies.quadruped,
  speed = 0,
  vision = 30,
  alertness = 0,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'ENERGY_HOUND',
  name = [[Energy hound]],
  display = 'Z',
  color = colors.C_b,
  image = 'npc/energy_hound.png',
  desc = [[Saint Elmo's Fire forms a ghostly halo around this hound, and sparks sting your fingers as energy builds up in the air around you.]],
  corpse_weight = 60,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 10,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 10, 6 },
  ac = 30,
  max_life = resolvers.dice(10, 6),
  rarity = 1,
  level = 18,
  start_level = 18,
  exp_worth = 70,
  resist_dam = {
    [DamageType.ELEC] = true,
  },
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    FORCE_SLEEP = true,
    FRIENDS = true,
    HAS_LITE = true,
    MORTAL = true,
  },
  placement_flags = {},
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={3,3} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={3,3} },
    { type=DamageType.ELEC, method=AttackType.BITE, dam={2,6} },
  },
  resolvers.talents {
    [Talents.T_NPC_BR_ELEC] = 1,
  },
  body = bodies.quadruped,
  speed = 0,
  vision = 30,
  alertness = 0,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'LESSER_MIMIC',
  name = [[Lesser Mimic]],
  display = 'm',
  color = colors.C_y,
  image = 'npc/lesser_mimic.png',
  desc = [[A strange creature that disguises itself as some object to lure unsuspecting adventurers within reach of its venomous claws.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 6,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 10, 10 },
  ac = 30,
  max_life = resolvers.dice(10, 10),
  rarity = 3,
  level = 18,
  start_level = 18,
  exp_worth = 60,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.FEAR] = true,
    [DamageType.OLD_SLEEP] = true,
  },
  vuln_dam = {
    [DamageType.COLD] = true,
  },
  flags = {
    BASEANGBAND = true,
    COLD_BLOOD = true,
    EMPTY_MIND = true,
    FORCE_SLEEP = true,
    MIMIC = true,
    NEVER_MOVE = true,
    NO_CUT = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.POISON, method=AttackType.HIT, dam={3,4} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={2,3} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={2,3} },
  },
  resolvers.talents {
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_CAUSE_2] = 1,
    [Talents.T_NPC_BO_COLD] = 1,
  },
  body = bodies.none,
  speed = 0,
  vision = 25,
  alertness = 250,
  resolvers.mon_global_speed(),
  resolvers.mon_mimic(),
}

newEntity {
  define_as = 'DOOR_MIMIC',
  name = [[Door mimic]],
  display = '+',
  color = colors.C_U,
  image = 'npc/door_mimic.png',
  desc = [[A strange creature that disguises itself as a door to lure unsuspecting adventurers within reach of its venomous claws.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 6,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 10, 10 },
  ac = 30,
  max_life = resolvers.dice(10, 10),
  rarity = 6,
  level = 18,
  start_level = 18,
  exp_worth = 70,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.FEAR] = true,
    [DamageType.OLD_SLEEP] = true,
  },
  flags = {
    BASEANGBAND = true,
    CHAR_MULTI = true,
    COLD_BLOOD = true,
    EMPTY_MIND = true,
    FORCE_SLEEP = true,
    NEVER_MOVE = true,
    NO_CUT = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.POISON, method=AttackType.HIT, dam={3,4} },
    { type=DamageType.CONFUSION, method=AttackType.HIT, dam={2,3} },
    { type=DamageType.PARALYZE, method=AttackType.HIT, dam={2,3} },
  },
  resolvers.talents {
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_CAUSE_2] = 1,
    [Talents.T_NPC_BO_COLD] = 1,
  },
  body = bodies.none,
  speed = 0,
  vision = 25,
  alertness = 0,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'BLINK_DOG',
  name = [[Blink dog]],
  display = 'C',
  color = colors.C_B,
  image = 'npc/blink_dog.png',
  desc = [[A strange magical member of the canine race, its form seems to shimmer and fade in front of your very eyes.]],
  corpse_weight = 40,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=25,
    talent_in = 4,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 8, 8 },
  ac = 20,
  max_life = resolvers.dice(8, 8),
  rarity = 2,
  level = 18,
  start_level = 18,
  exp_worth = 50,
  resist_dam = {
    [DamageType.TELEPORT] = true,
  },
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    FRIENDS = true,
    MORTAL = true,
  },
  placement_flags = {},
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={1,8} },
  },
  resolvers.talents {
    [Talents.T_NPC_BLINK] = 1,
    [Talents.T_NPC_TELE_TO] = 1,
  },
  body = bodies.quadruped,
  speed = 10,
  vision = 20,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'URUK',
  name = [[Uruk]],
  display = 'o',
  color = colors.C_B,
  image = 'npc/uruk.png',
  desc = [[It is a cunning orc of power, as tall as a man, and stronger. It fears little.]],
  corpse_weight = 230,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 9,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 8, 10 },
  ac = 50,
  max_life = 80,
  rarity = 1,
  level = 16,
  start_level = 16,
  exp_worth = 60,
  resist_dam = {
    [DamageType.DARK] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    EVIL = true,
    FORCE_MAXHP = true,
    FRIENDS = true,
    HAS_LITE = true,
    MALE = true,
    MORTAL = true,
    OPEN_DOOR = true,
    ORC = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ '60%' },
  drop = { treasure=20, combat=80, magic=0, tools=0, junk=0 },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={3,5} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={3,5} },
  },
  resolvers.talents {
    [Talents.T_NPC_ARROW_2] = 1,
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 20,
  alertness = 20,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'SHAGRAT_THE_ORC_CAPTAIN',
  name = [[Shagrat, the Orc Captain]],
  display = 'o',
  color = colors.C_g,
  image = 'npc/shagrat_the_orc_captain.png',
  desc = [[He is an orc of power and great cunning, leader of the garrison at Cirith Ungol.]],
  corpse_weight = 260,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 42, 10 },
  ac = 60,
  max_life = 420,
  level = 19,
  start_level = 19,
  exp_worth = 400,
  unique = 'SHAGRAT_THE_ORC_CAPTAIN',
  resist_dam = {
    [DamageType.DARK] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    CAN_SPEAK = true,
    ESCORT = true,
    EVIL = true,
    FORCE_MAXHP = true,
    HAS_LITE = true,
    MALE = true,
    MORTAL = true,
    OPEN_DOOR = true,
    ORC = true,
    SPECIAL_GENE = true,
    UNIQUE = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, only_item=true, '1d2' },
  drop = { treasure=10, combat=90, magic=0, tools=0, junk=0 },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={3,9} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={3,9} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={3,6} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={3,6} },
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 20,
  alertness = 20,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'GORBAG_THE_ORC_CAPTAIN',
  name = [[Gorbag, the Orc Captain]],
  display = 'o',
  color = colors.C_g,
  image = 'npc/gorbag_the_orc_captain.png',
  desc = [[He is an orc of power and great cunning, leader of the garrison at Minas Morgul.]],
  corpse_weight = 260,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 42, 10 },
  ac = 60,
  max_life = 420,
  rarity = 2,
  level = 19,
  start_level = 19,
  exp_worth = 400,
  unique = 'GORBAG_THE_ORC_CAPTAIN',
  resist_dam = {
    [DamageType.DARK] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    CAN_SPEAK = true,
    ESCORT = true,
    EVIL = true,
    FORCE_MAXHP = true,
    HAS_LITE = true,
    MALE = true,
    MORTAL = true,
    OPEN_DOOR = true,
    ORC = true,
    UNIQUE = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, only_item=true, '1d2' },
  drop = { treasure=10, combat=90, magic=0, tools=0, junk=0 },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={3,9} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={3,9} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={3,6} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={3,6} },
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 20,
  alertness = 20,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'SHAMBLING_MOUND',
  name = [[Shambling mound]],
  display = ',',
  color = colors.C_g,
  image = 'npc/shambling_mound.png',
  desc = [[A pile of rotting vegetation that slides towards you with a disgusting stench, waking all it nears.]],
  corpse_weight = 300,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 4,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 20, 6 },
  ac = 16,
  max_life = resolvers.dice(20, 6),
  rarity = 2,
  level = 18,
  start_level = 18,
  exp_worth = 75,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.FEAR] = true,
    [DamageType.OLD_SLEEP] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    EMPTY_MIND = true,
    EVIL = true,
    NO_CUT = true,
    OPEN_DOOR = true,
    STUPID = true,
  },
  placement_flags = { WILD_SWAMP=true, WILD_TOO=true },
  resolvers.mon_inven{ only_gold=true, '90%' },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,8} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,8} },
  },
  resolvers.talents {
    [Talents.T_NPC_SHRIEK] = 1,
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 20,
  alertness = 40,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'GIANT_VENUS_FLYTRAP',
  name = [[Giant Venus Flytrap]],
  display = '#',
  color = colors.C_g,
  image = 'npc/giant_venus_flytrap.png',
  desc = [[A carnivorous plant that is difficult to detect, until it suddenly snaps shut around its prey and releases paralysing enzymes to stop its struggles.]],
  corpse_weight = 20,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 10, 10 },
  ac = 5,
  max_life = resolvers.dice(10, 10),
  rarity = 5,
  level = 15,
  start_level = 15,
  exp_worth = 30,
  vuln_dam = {
    [DamageType.FIRE] = true,
  },
  flags = {
    ANIMAL = true,
    CHAR_CLEAR = true,
    CHAR_MULTI = true,
    EMPTY_MIND = true,
    NEVER_MOVE = true,
    NO_CUT = true,
    STUPID = true,
  },
  placement_flags = { WILD_ONLY=true, WILD_SWAMP=true, WILD_WOOD=true },
  attacks = {
    { type=DamageType.PARALYZE, method=AttackType.HIT, dam={3,3} },
    { type=DamageType.PARALYZE, method=AttackType.HIT, dam={3,3} },
    { type=DamageType.PARALYZE, method=AttackType.HIT, dam={3,3} },
  },
  body = bodies.none,
  speed = 10,
  vision = 20,
  alertness = 0,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'GIANT_BRONZE_DRAGON_FLY',
  name = [[Giant bronze dragon fly]],
  display = 'F',
  color = colors.C_U,
  image = 'npc/giant_bronze_dragon_fly.png',
  desc = [[This vast gleaming bronze fly has wings which beat mesmerically fast.]],
  corpse_weight = 15,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=75,
    talent_in = 10,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 3, 8 },
  ac = 20,
  max_life = resolvers.dice(3, 8),
  rarity = 2,
  level = 18,
  start_level = 18,
  exp_worth = 80,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.OLD_SLEEP] = true,
  },
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    FLY = true,
    FORCE_SLEEP = true,
    MORTAL = true,
    WEIRD_MIND = true,
  },
  placement_flags = { WILD_MOUNTAIN=true, WILD_TOO=true },
  attacks = {
    { type=DamageType.CONFUSION, method=AttackType.BITE, dam={1,6} },
  },
  resolvers.talents {
    [Talents.T_NPC_BR_CONF] = 1,
  },
  body = bodies.quadruped,
  speed = 10,
  vision = 12,
  alertness = 50,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'STONE_GIANT',
  name = [[Stone giant]],
  display = 'P',
  color = colors.C_W,
  image = 'npc/stone_giant.png',
  desc = [[It is eighteen feet tall and looking at you.]],
  corpse_weight = 700,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 35, 18 },
  ac = 75,
  max_life = resolvers.dice(35, 18),
  rarity = 1,
  level = 33,
  start_level = 33,
  exp_worth = 250,
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    EVIL = true,
    GIANT = true,
    HAS_LITE = true,
    MALE = true,
    OPEN_DOOR = true,
    TAKE_ITEM = true,
  },
  placement_flags = { WILD_MOUNTAIN=true, WILD_TOO=true },
  resolvers.mon_inven{ '60%' },
  drop = { treasure=10, combat=90, magic=0, tools=0, junk=0 },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={3,8} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={3,8} },
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 20,
  alertness = 50,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'GIANT_BLACK_DRAGON_FLY',
  name = [[Giant black dragon fly]],
  display = 'F',
  color = colors.C_s,
  image = 'npc/giant_black_dragon_fly.png',
  desc = [[The size of a large bird, this fly drips caustic acid.]],
  corpse_weight = 15,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=75,
    talent_in = 10,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 3, 8 },
  ac = 20,
  max_life = resolvers.dice(3, 8),
  rarity = 2,
  level = 20,
  start_level = 20,
  exp_worth = 70,
  resist_dam = {
    [DamageType.ACID] = true,
  },
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    FLY = true,
    FORCE_SLEEP = true,
    MORTAL = true,
    WEIRD_MIND = true,
  },
  placement_flags = { WILD_SWAMP=true, WILD_TOO=true },
  attacks = {
    { type=DamageType.ACID, method=AttackType.BITE, dam={1,6} },
  },
  resolvers.talents {
    [Talents.T_NPC_BR_ACID] = 1,
  },
  body = bodies.quadruped,
  speed = 10,
  vision = 12,
  alertness = 50,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'STONE_GOLEM',
  name = [[Stone golem]],
  display = 'g',
  color = colors.C_W,
  image = 'npc/stone_golem.png',
  desc = [[It is a massive animated statue.]],
  corpse_weight = 350,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 28, 8 },
  ac = 75,
  max_life = resolvers.dice(28, 8),
  rarity = 2,
  level = 19,
  start_level = 19,
  exp_worth = 100,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.ELEC] = true,
    [DamageType.FEAR] = true,
    [DamageType.FIRE] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  vuln_dam = {
    [DamageType.KILL_WALL] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    COLD_BLOOD = true,
    EMPTY_MIND = true,
    NONLIVING = true,
    NO_CUT = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,10} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,10} },
  },
  body = bodies.humanoid,
  speed = -10,
  vision = 12,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'RED_MOLD',
  name = [[Red mold]],
  display = 'm',
  color = colors.C_r,
  image = 'npc/red_mold.png',
  desc = [[It is a strange red growth on the dungeon floor; it seems to burn with flame.]],
  corpse_weight = 4,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 17, 8 },
  ac = 16,
  max_life = resolvers.dice(17, 8),
  rarity = 1,
  level = 19,
  start_level = 19,
  exp_worth = 64,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.FEAR] = true,
    [DamageType.FIRE] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  vuln_dam = {
    [DamageType.COLD] = true,
  },
  flags = {
    BASEANGBAND = true,
    CAN_SWIM = true,
    EMPTY_MIND = true,
    NEVER_MOVE = true,
    NO_CUT = true,
    STUPID = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.FIRE, method=AttackType.SPORE, dam={4,4} },
  },
  body = bodies.none,
  speed = 0,
  vision = 2,
  alertness = 70,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'GIANT_GOLD_DRAGON_FLY',
  name = [[Giant gold dragon fly]],
  display = 'F',
  color = colors.C_y,
  image = 'npc/giant_gold_dragon_fly.png',
  desc = [[Large beating wings support this dazzling insect. A loud buzzing noise pervades the air.]],
  corpse_weight = 15,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=75,
    talent_in = 10,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 3, 8 },
  ac = 20,
  max_life = resolvers.dice(3, 8),
  rarity = 2,
  level = 22,
  start_level = 22,
  exp_worth = 75,
  resist_dam = {
    [DamageType.FIRE] = true,
    [DamageType.SOUND] = true,
  },
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    FLY = true,
    FORCE_SLEEP = true,
    MORTAL = true,
    WEIRD_MIND = true,
  },
  placement_flags = { WILD_MOUNTAIN=true, WILD_TOO=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={1,6} },
  },
  resolvers.talents {
    [Talents.T_NPC_BR_SOUN] = 1,
  },
  body = bodies.quadruped,
  speed = 10,
  vision = 12,
  alertness = 50,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'GHAST',
  name = [[Ghast]],
  display = 'z',
  color = colors.C_u,
  image = 'npc/ghast.png',
  desc = [[This vile abomination is a relative of ghouls, and often leads packs of them. It smells foul, and its bite carries a rotting disease.]],
  corpse_weight = 150,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 30, 10 },
  ac = 40,
  max_life = resolvers.dice(30, 10),
  rarity = 1,
  level = 30,
  start_level = 30,
  exp_worth = 130,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.DARK] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  vuln_dam = {
    [DamageType.LITE] = true,
    [DamageType.LITE_WEAK] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    CAN_SWIM = true,
    COLD_BLOOD = true,
    ESCORT = true,
    EVIL = true,
    NO_CUT = true,
    OPEN_DOOR = true,
    UNDEAD = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ '60%' },
  drop = { treasure=20, combat=35, magic=25, tools=10, junk=10 },
  attacks = {
    { type=DamageType.PARALYZE, method=AttackType.CLAW, dam={2,4} },
    { type=DamageType.PARALYZE, method=AttackType.CLAW, dam={2,4} },
    { type=DamageType.LOSE_CON, method=AttackType.BITE, dam={2,4} },
    { type=DamageType.LOSE_CHR, method=AttackType.BITE, dam={2,4} },
  },
  body = bodies.humanoid,
  speed = 10,
  vision = 40,
  alertness = 20,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'NEEKERBREEKER',
  name = [[Neekerbreeker]],
  display = 'I',
  color = colors.C_D,
  image = 'npc/neekerbreeker.png',
  desc = [[Believed to be an evil relative of the cricket, this creature gets its name from its incessant squeaking, which can best be described as "neek-breek, neek-breek".  The noise can drive people frantic, and worse still, can be heard for quite some distance, alerting other monsters to your presence.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=75,
    talent_in = 12,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 3, 2 },
  ac = 18,
  max_life = resolvers.dice(3, 2),
  rarity = 4,
  level = 19,
  start_level = 19,
  exp_worth = 4,
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    EVIL = true,
    FLY = true,
    MULTIPLY = true,
    WEIRD_MIND = true,
  },
  placement_flags = { WILD_SWAMP=true, WILD_TOO=true },
  attacks = {
    { type=DamageType.POISON, method=AttackType.BITE, dam={2,2} },
  },
  resolvers.talents {
    [Talents.T_NPC_SHRIEK] = 1,
  },
  speed = 10,
  vision = 8,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'HUORN',
  name = [[Huorn]],
  display = '#',
  color = colors.C_g,
  image = 'npc/huorn.png',
  desc = [[A very strong near-sentient tree, which has become hostile to other living things.]],
  corpse_weight = 400,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 9,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 50, 10 },
  ac = 45,
  max_life = resolvers.dice(50, 10),
  rarity = 1,
  level = 19,
  start_level = 19,
  exp_worth = 75,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.WATER] = true,
  },
  vuln_dam = {
    [DamageType.FIRE] = true,
  },
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    NEVER_MOVE = true,
    NO_CUT = true,
    WEIRD_MIND = true,
  },
  placement_flags = { WILD_ONLY=true, WILD_WOOD=true },
  resolvers.mon_inven{ '60%' },
  drop = { treasure=30, combat=30, magic=30, tools=5, junk=5 },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CRUSH, dam={3,6} },
    { type=DamageType.PHYSICAL, method=AttackType.CRUSH, dam={3,6} },
    { type=DamageType.PHYSICAL, method=AttackType.CRUSH, dam={3,6} },
    { type=DamageType.PHYSICAL, method=AttackType.CRUSH, dam={3,6} },
  },
  resolvers.talents {
    [Talents.T_NPC_BLINK] = 1,
    [Talents.T_NPC_TELE_TO] = 1,
  },
  body = bodies.none,
  speed = 0,
  vision = 40,
  alertness = 20,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'BOLG_SON_OF_AZOG',
  name = [[Bolg, Son of Azog]],
  display = 'o',
  color = colors.C_v,
  image = 'npc/bolg_son_of_azog.png',
  desc = [[A large and powerful orc, he looks just like his father. He is tall and fast, but fortunately blessed with orcish brains.]],
  corpse_weight = 230,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 52, 10 },
  ac = 50,
  max_life = 520,
  level = 20,
  start_level = 20,
  exp_worth = 800,
  unique = 'BOLG_SON_OF_AZOG',
  resist_dam = {
    [DamageType.DARK] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    CAN_SPEAK = true,
    ESCORT = true,
    EVIL = true,
    FORCE_MAXHP = true,
    HAS_LITE = true,
    MALE = true,
    MORTAL = true,
    OPEN_DOOR = true,
    ORC = true,
    SPECIAL_GENE = true,
    UNIQUE = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, only_item=true, '2d2' },
  drop = { treasure=0, combat=100, magic=0, tools=0, junk=0 },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={3,7} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={3,7} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={3,7} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={3,7} },
  },
  body = bodies.humanoid,
  speed = 10,
  vision = 20,
  alertness = 20,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'PHASE_SPIDER',
  name = [[Phase spider]],
  display = 'S',
  color = colors.C_B,
  image = 'npc/phase_spider.png',
  desc = [[A spider that never seems quite there. Everywhere you look it is just half-seen in the corner of one eye.]],
  corpse_weight = 50,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 5,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 6, 8 },
  ac = 25,
  max_life = resolvers.dice(6, 8),
  rarity = 2,
  level = 20,
  start_level = 20,
  exp_worth = 60,
  resist_dam = {
    [DamageType.POISON] = true,
    [DamageType.TELEPORT] = true,
  },
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    CAN_SWIM = true,
    FRIENDS = true,
    MORTAL = true,
    SPIDER = true,
    WEIRD_MIND = true,
  },
  placement_flags = { WILD_TOO=true, WILD_WOOD=true },
  drop_corpse = { skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={1,8} },
    { type=DamageType.POISON, method=AttackType.BITE, dam={1,6} },
    { type=DamageType.POISON, method=AttackType.BITE, dam={1,6} },
  },
  resolvers.talents {
    [Talents.T_NPC_BLINK] = 1,
    [Talents.T_NPC_TELE_TO] = 1,
  },
  body = bodies.quadruped,
  speed = 10,
  vision = 15,
  alertness = 80,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'LIZARD_KING',
  name = [[Lizard king]],
  display = 'h',
  color = colors.C_g,
  image = 'npc/lizard_king.png',
  desc = [[A lizardman leader.]],
  corpse_weight = 160,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 18, 11 },
  ac = 40,
  max_life = 198,
  rarity = 3,
  level = 20,
  start_level = 20,
  exp_worth = 150,
  resist_dam = {
    [DamageType.ACID] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    CAN_SWIM = true,
    EVIL = true,
    FORCE_MAXHP = true,
    HAS_LITE = true,
    MALE = true,
    MORTAL = true,
    OPEN_DOOR = true,
  },
  placement_flags = { WILD_SHORE=true },
  resolvers.mon_inven{ '1d2', '60%' },
  drop = { treasure=50, combat=50, magic=0, tools=0, junk=0 },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={5,5} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={5,5} },
    { type=DamageType.FEAR, method=AttackType.WAIL },
  },
  body = bodies.humanoid,
  speed = 10,
  vision = 20,
  alertness = 20,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'WYVERN',
  name = [[Wyvern]],
  display = 'd',
  color = colors.C_g,
  image = 'npc/wyvern.png',
  desc = [[A fast-moving and deadly draconian animal. Beware its poisonous sting!]],
  corpse_weight = 450,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 100, 5 },
  ac = 65,
  max_life = resolvers.dice(100, 5),
  rarity = 2,
  level = 22,
  start_level = 22,
  exp_worth = 250,
  resist_dam = {
    [DamageType.POISON] = true,
  },
  flags = {
    ANIMAL = true,
    ATTR_MULTI = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    DRAGON = true,
    EVIL = true,
    FLY = true,
    FORCE_SLEEP = true,
    HAS_EGG = true,
    MOVE_BODY = true,
    OPEN_DOOR = true,
  },
  placement_flags = { WILD_MOUNTAIN=true, WILD_TOO=true, WILD_WOOD=true },
  resolvers.mon_inven{ only_gold=true, '2d2' },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={2,6} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={2,6} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={2,6} },
    { type=DamageType.POISON, method=AttackType.STING, dam={1,6} },
  },
  body = bodies.winged,
  speed = 10,
  vision = 20,
  alertness = 20,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'GREAT_EAGLE',
  name = [[Great eagle]],
  display = 'B',
  color = colors.C_u,
  image = 'npc/great_eagle.png',
  desc = [[Greater and more intelligent than most of its kind, this great eagle is a messenger between the forces of good.]],
  corpse_weight = 100,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 100, 5 },
  ac = 65,
  faction = 'eru_manwe',
  max_life = resolvers.dice(100, 5),
  rarity = 2,
  level = 20,
  start_level = 20,
  exp_worth = 150,
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    FLY = true,
    GOOD = true,
    HAS_EGG = true,
  },
  placement_flags = { WILD_MOUNTAIN=true, WILD_ONLY=true, WILD_VOLCANO=true, WILD_WASTE=true, WILD_WOOD=true },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={6,3} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={6,3} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={3,6} },
  },
  body = bodies.winged,
  speed = 10,
  vision = 20,
  alertness = 20,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'LIVINGSTONE',
  name = [[Livingstone]],
  display = '#',
  color = colors.C_W,
  image = 'npc/livingstone.png',
  desc = [[A sentient section of wall.]],
  corpse_weight = 100,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 6, 8 },
  ac = 28,
  max_life = resolvers.dice(6, 8),
  rarity = 4,
  level = 20,
  start_level = 20,
  exp_worth = 56,
  resist_dam = {
    [DamageType.ACID] = true,
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.ELEC] = true,
    [DamageType.FEAR] = true,
    [DamageType.FIRE] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  vuln_dam = {
    [DamageType.KILL_WALL] = true,
  },
  flags = {
    BASEANGBAND = true,
    CHAR_MULTI = true,
    COLD_BLOOD = true,
    FRIENDS = true,
    MULTIPLY = true,
    NEVER_MOVE = true,
    NO_CUT = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={2,5} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={2,5} },
  },
  body = bodies.none,
  speed = 0,
  vision = 45,
  alertness = 20,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'EARTH_HOUND',
  name = [[Earth hound]],
  display = 'Z',
  color = colors.C_u,
  image = 'npc/earth_hound.png',
  desc = [[A beautiful crystalline shape does not disguise the danger this hound clearly presents. Your flesh tingles as it approaches.]],
  corpse_weight = 60,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 10,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 15, 8 },
  ac = 30,
  max_life = resolvers.dice(15, 8),
  rarity = 1,
  level = 20,
  start_level = 20,
  exp_worth = 200,
  resist_dam = {
    [DamageType.SHARDS] = true,
  },
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    FORCE_SLEEP = true,
    FRIENDS = true,
    MORTAL = true,
    NO_CUT = true,
  },
  placement_flags = {},
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={1,8} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={1,8} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={3,3} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={3,3} },
  },
  resolvers.talents {
    [Talents.T_NPC_BR_SHAR] = 1,
  },
  body = bodies.quadruped,
  speed = 0,
  vision = 30,
  alertness = 0,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'AIR_HOUND',
  name = [[Air hound]],
  display = 'Z',
  color = colors.C_g,
  image = 'npc/air_hound.png',
  desc = [[Swirling vapours surround this beast as it floats towards you, seemingly walking on air. Noxious gases sting your throat.]],
  corpse_weight = 60,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 10,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 15, 8 },
  ac = 30,
  max_life = resolvers.dice(15, 8),
  rarity = 1,
  level = 20,
  start_level = 20,
  exp_worth = 200,
  resist_dam = {
    [DamageType.POISON] = true,
  },
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    FLY = true,
    FORCE_SLEEP = true,
    FRIENDS = true,
    MORTAL = true,
  },
  placement_flags = {},
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.POISON, method=AttackType.BITE, dam={1,8} },
    { type=DamageType.POISON, method=AttackType.BITE, dam={1,8} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={3,3} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={3,3} },
  },
  resolvers.talents {
    [Talents.T_NPC_BR_POIS] = 1,
  },
  body = bodies.quadruped,
  speed = 0,
  vision = 30,
  alertness = 0,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'SABRE_TOOTH_TIGER',
  name = [[Sabre-tooth tiger]],
  display = 'f',
  color = colors.C_y,
  image = 'npc/sabre_tooth_tiger.png',
  desc = [[A fierce and dangerous cat, its huge tusks and sharp claws would lacerate even the strongest armour.]],
  corpse_weight = 180,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 20, 14 },
  ac = 50,
  max_life = resolvers.dice(20, 14),
  rarity = 2,
  level = 20,
  start_level = 20,
  exp_worth = 120,
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    MORTAL = true,
  },
  placement_flags = { WILD_GRASS=true, WILD_TOO=true, WILD_WOOD=true },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={1,10} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={1,10} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={1,10} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={1,10} },
  },
  body = bodies.quadruped,
  speed = 10,
  vision = 40,
  alertness = 0,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'ACID_HOUND',
  name = [[Acid hound]],
  display = 'Z',
  color = colors.C_s,
  image = 'npc/acid_hound.png',
  desc = [[Footprints are burned in the ground behind this hound as it pads around the dungeon. An acrid smell of acid rises from the dog's pelt.]],
  corpse_weight = 60,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 10,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 15, 8 },
  ac = 30,
  max_life = resolvers.dice(15, 8),
  rarity = 1,
  level = 20,
  start_level = 20,
  exp_worth = 200,
  resist_dam = {
    [DamageType.ACID] = true,
  },
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    CAN_SWIM = true,
    FORCE_SLEEP = true,
    FRIENDS = true,
    MORTAL = true,
  },
  placement_flags = {},
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.ACID, method=AttackType.BITE, dam={1,8} },
    { type=DamageType.ACID, method=AttackType.BITE, dam={1,8} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={3,3} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={3,3} },
  },
  resolvers.talents {
    [Talents.T_NPC_BR_ACID] = 1,
  },
  body = bodies.quadruped,
  speed = 0,
  vision = 30,
  alertness = 0,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'CHIMAERA',
  name = [[Chimaera]],
  display = 'H',
  color = colors.C_r,
  image = 'npc/chimaera.png',
  desc = [[It is a strange concoction of goat, lion and dragon, with the heads of all three beasts.]],
  corpse_weight = 160,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 10,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 20, 15 },
  ac = 15,
  max_life = resolvers.dice(20, 15),
  rarity = 2,
  level = 20,
  start_level = 20,
  exp_worth = 200,
  resist_dam = {
    [DamageType.FIRE] = true,
  },
  vuln_dam = {
    [DamageType.COLD] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    FLY = true,
    FORCE_SLEEP = true,
    HAS_LITE = true,
    MORTAL = true,
  },
  placement_flags = { WILD_MOUNTAIN=true, WILD_TOO=true },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.BUTT, dam={2,8} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={2,10} },
    { type=DamageType.FIRE, method=AttackType.BITE, dam={2,6} },
  },
  resolvers.talents {
    [Talents.T_NPC_BR_FIRE] = 1,
  },
  body = bodies.hydra,
  speed = 0,
  vision = 12,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'QUYLTHULG',
  name = [[Quylthulg]],
  display = 'Q',
  color = colors.C_y,
  image = 'npc/quylthulg.png',
  desc = [[It is a strange pulsing mound of flesh.]],
  corpse_weight = 300,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 4,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 6, 8 },
  ac = 1,
  max_life = resolvers.dice(6, 8),
  rarity = 1,
  level = 20,
  start_level = 20,
  exp_worth = 250,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.FEAR] = true,
    [DamageType.OLD_SLEEP] = true,
  },
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    EMPTY_MIND = true,
    FORCE_SLEEP = true,
    INVISIBLE = true,
    NEVER_BLOW = true,
    NEVER_MOVE = true,
  },
  placement_flags = {},
  resolvers.talents {
    [Talents.T_NPC_BLINK] = 1,
    [Talents.T_NPC_S_MONSTER] = 1,
  },
  body = bodies.none,
  speed = 0,
  vision = 10,
  alertness = 0,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'SASQUATCH',
  name = [[Sasquatch]],
  display = 'Y',
  color = colors.C_W,
  image = 'npc/sasquatch.png',
  desc = [[A tall shaggy, furry humanoid, it could call the yeti brother.]],
  corpse_weight = 350,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 20, 19 },
  ac = 40,
  max_life = resolvers.dice(20, 19),
  rarity = 3,
  level = 20,
  start_level = 20,
  exp_worth = 180,
  resist_dam = {
    [DamageType.COLD] = true,
  },
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    MORTAL = true,
    OPEN_DOOR = true,
  },
  placement_flags = { WILD_MOUNTAIN=true, WILD_TOO=true, WILD_WASTE=true, WILD_WOOD=true },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={1,10} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={1,10} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={2,8} },
  },
  body = bodies.humanoid,
  speed = 10,
  vision = 15,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'RANGER',
  name = [[Ranger]],
  display = 'p',
  color = colors.C_W,
  image = 'npc/ranger.png',
  desc = [[A warrior who is at one with nature.  A master of both bow and sword, with minor spellcasting skills.]],
  corpse_weight = 170,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 4,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 15, 11 },
  ac = 40,
  max_life = resolvers.dice(15, 11),
  rarity = 1,
  level = 20,
  start_level = 20,
  exp_worth = 55,
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    HAS_LITE = true,
    MALE = true,
    MORTAL = true,
    OPEN_DOOR = true,
    TAKE_ITEM = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ '1d2' },
  drop = { treasure=20, combat=50, magic=20, tools=0, junk=10 },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={5,4} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={5,4} },
  },
  resolvers.talents {
    [Talents.T_NPC_ARROW_2] = 1,
    [Talents.T_NPC_MISSILE] = 1,
    [Talents.T_NPC_BO_COLD] = 1,
    [Talents.T_NPC_BO_ELEC] = 1,
    [Talents.T_NPC_BLINK] = 1,
    [Talents.T_NPC_S_ANIMAL] = 1,
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 20,
  alertness = 40,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'PALADIN',
  name = [[Paladin]],
  display = 'p',
  color = colors.C_w,
  image = 'npc/paladin.png',
  desc = [[A warrior for a holy cause.  Unfortunately, his god is not yours, and there is rivalry even between the various gods of Good, so he is your enemy.]],
  corpse_weight = 170,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 4,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 15, 11 },
  ac = 40,
  faction = 'eru_manwe',
  max_life = resolvers.dice(15, 11),
  rarity = 1,
  level = 20,
  start_level = 20,
  exp_worth = 55,
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    GOOD = true,
    HAS_LITE = true,
    MALE = true,
    MORTAL = true,
    OPEN_DOOR = true,
    TAKE_ITEM = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ '1d2' },
  drop = { treasure=20, combat=60, magic=0, tools=10, junk=10 },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={4,5} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={4,5} },
  },
  resolvers.talents {
    [Talents.T_NPC_HEAL] = 1,
    [Talents.T_NPC_CAUSE_2] = 1,
    [Talents.T_NPC_SLOW] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_BLIND] = 1,
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 20,
  alertness = 40,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'WEREWOLF',
  name = [[Werewolf]],
  plural_name = [[Werewolves]],
  display = 'C',
  color = colors.C_D,
  image = 'npc/werewolf.png',
  desc = [[It is a huge wolf with eyes that glow with manly intelligence.]],
  corpse_weight = 90,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=25,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 20, 22 },
  ac = 30,
  max_life = resolvers.dice(20, 22),
  rarity = 2,
  level = 20,
  start_level = 20,
  exp_worth = 150,
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    EVIL = true,
    MORTAL = true,
    OPEN_DOOR = true,
    TAKE_ITEM = true,
  },
  placement_flags = {},
  drop_corpse = { skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={2,6} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={2,6} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={2,10} },
  },
  body = bodies.quadruped,
  speed = 0,
  vision = 15,
  alertness = 70,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'DARK_ELVEN_LORD',
  name = [[Dark elven lord]],
  display = 'h',
  color = colors.C_s,
  image = 'npc/dark_elven_lord.png',
  desc = [[A dark elven figure in armour and radiating evil power.]],
  corpse_weight = 140,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 5,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 18, 15 },
  ac = 40,
  max_life = resolvers.dice(18, 15),
  rarity = 2,
  level = 20,
  start_level = 20,
  exp_worth = 500,
  resist_dam = {
    [DamageType.DARK] = true,
  },
  vuln_dam = {
    [DamageType.LITE] = true,
    [DamageType.LITE_WEAK] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    EVIL = true,
    FORCE_SLEEP = true,
    HAS_LITE = true,
    MALE = true,
    OPEN_DOOR = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ only_item=true, '2d2' },
  drop = { treasure=0, combat=80, magic=20, tools=0, junk=0 },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={3,8} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={3,5} },
  },
  resolvers.talents {
    [Talents.T_NPC_HASTE] = 1,
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_DARKNESS] = 1,
    [Talents.T_NPC_BO_FIRE] = 1,
    [Talents.T_NPC_BO_COLD] = 1,
    [Talents.T_NPC_MISSILE] = 1,
  },
  body = bodies.humanoid,
  speed = 10,
  vision = 20,
  alertness = 30,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'CLOUD_GIANT',
  name = [[Cloud giant]],
  display = 'P',
  color = colors.C_b,
  image = 'npc/cloud_giant.png',
  desc = [[It is a twenty foot tall giant wreathed in clouds.]],
  corpse_weight = 900,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 35, 20 },
  ac = 60,
  max_life = resolvers.dice(35, 20),
  rarity = 1,
  level = 36,
  start_level = 36,
  exp_worth = 500,
  resist_dam = {
    [DamageType.ELEC] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    EVIL = true,
    GIANT = true,
    HAS_LITE = true,
    MALE = true,
    OPEN_DOOR = true,
    TAKE_ITEM = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ '90%' },
  drop = { treasure=10, combat=90, magic=0, tools=0, junk=0 },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.ELEC, method=AttackType.HIT, dam={8,8} },
    { type=DamageType.ELEC, method=AttackType.HIT, dam={8,8} },
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 20,
  alertness = 50,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'UGLUK_THE_URUK',
  name = [[Uglúk, the Uruk]],
  display = 'o',
  color = colors.C_v,
  image = 'npc/ugluk_the_uruk.png',
  desc = [[A strong and cunning orc warrior, the commander of Saruman's orcish horde.]],
  corpse_weight = 240,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 72, 10 },
  ac = 95,
  max_life = 720,
  rarity = 3,
  level = 21,
  start_level = 21,
  exp_worth = 600,
  unique = 'UGLUK_THE_URUK',
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.DARK] = true,
    [DamageType.FIRE] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    CAN_SPEAK = true,
    ESCORT = true,
    EVIL = true,
    FORCE_MAXHP = true,
    HAS_LITE = true,
    MALE = true,
    MORTAL = true,
    OPEN_DOOR = true,
    ORC = true,
    UNIQUE = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, only_item=true, '1d2' },
  drop = { treasure=10, combat=90, magic=0, tools=0, junk=0 },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={3,8} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={3,8} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={3,5} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={3,5} },
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 20,
  alertness = 20,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'BLUE_DRAGON_BAT',
  name = [[Blue dragon bat]],
  display = 'b',
  color = colors.C_b,
  image = 'npc/blue_dragon_bat.png',
  desc = [[It is a glowing blue bat with a sharp tail.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=50,
    talent_in = 4,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 4, 4 },
  ac = 26,
  max_life = resolvers.dice(4, 4),
  rarity = 1,
  level = 21,
  start_level = 21,
  exp_worth = 54,
  resist_dam = {
    [DamageType.ELEC] = true,
  },
  flags = {
    AI_ANNOY = true,
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    FLY = true,
    FORCE_SLEEP = true,
    MORTAL = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.ELEC, method=AttackType.BITE, dam={1,3} },
  },
  resolvers.talents {
    [Talents.T_NPC_BR_ELEC] = 1,
  },
  body = bodies.winged,
  speed = 20,
  vision = 12,
  alertness = 50,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'MIMIC',
  name = [[Mimic]],
  display = 'm',
  color = colors.C_y,
  image = 'npc/mimic.png',
  desc = [[A strange creature that disguises itself as an object to lure unsuspecting adventurers within reach of its venomous claws.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 5,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 10, 14 },
  ac = 40,
  max_life = resolvers.dice(10, 14),
  rarity = 3,
  level = 21,
  start_level = 21,
  exp_worth = 70,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.FEAR] = true,
    [DamageType.OLD_SLEEP] = true,
  },
  vuln_dam = {
    [DamageType.FIRE] = true,
  },
  flags = {
    BASEANGBAND = true,
    COLD_BLOOD = true,
    EMPTY_MIND = true,
    FORCE_SLEEP = true,
    MIMIC = true,
    NEVER_MOVE = true,
    NO_CUT = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.POISON, method=AttackType.HIT, dam={3,4} },
    { type=DamageType.POISON, method=AttackType.HIT, dam={3,4} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={2,3} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={2,3} },
  },
  resolvers.talents {
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_CAUSE_2] = 1,
    [Talents.T_NPC_BO_FIRE] = 1,
    [Talents.T_NPC_S_MONSTER] = 1,
  },
  body = bodies.none,
  speed = 0,
  vision = 30,
  alertness = 0,
  resolvers.mon_global_speed(),
  resolvers.mon_mimic(),
}

newEntity {
  define_as = 'ULTIMATE_MIMIC',
  name = [[Ultimate Mimic]],
  display = 'm',
  color = colors.C_y,
  image = 'npc/ultimate_mimic.png',
  desc = [[A strange creature that disguises itself as an object to lure unsuspecting adventurers within reach of its venomous claws.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 5,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 15, 40 },
  ac = 40,
  max_life = resolvers.dice(15, 40),
  rarity = 4,
  level = 35,
  start_level = 35,
  exp_worth = 250,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.FEAR] = true,
    [DamageType.OLD_SLEEP] = true,
  },
  flags = {
    BASEANGBAND = true,
    COLD_BLOOD = true,
    EMPTY_MIND = true,
    FORCE_SLEEP = true,
    MIMIC = true,
    NEVER_MOVE = true,
    NO_CUT = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.POISON, method=AttackType.BITE, dam={4,4} },
    { type=DamageType.POISON, method=AttackType.BITE, dam={4,4} },
    { type=DamageType.CONFUSION, method=AttackType.BUTT, dam={4,4} },
    { type=DamageType.BLIND, method=AttackType.SPIT, dam={4,4} },
  },
  resolvers.talents {
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_CAUSE_2] = 1,
    [Talents.T_NPC_BA_POIS] = 1,
    [Talents.T_NPC_S_MONSTER] = 1,
  },
  body = bodies.none,
  speed = 0,
  vision = 30,
  alertness = 0,
  resolvers.mon_global_speed(),
  resolvers.mon_mimic(),
}

newEntity {
  define_as = 'FIRE_VORTEX',
  name = [[Fire vortex]],
  display = 'v',
  color = colors.C_r,
  image = 'npc/fire_vortex.png',
  desc = [[A whirling maelstrom of fire.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=50,
    talent_in = 6,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 9, 9 },
  ac = 30,
  max_life = resolvers.dice(9, 9),
  rarity = 1,
  level = 21,
  start_level = 21,
  exp_worth = 100,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.FEAR] = true,
    [DamageType.FIRE] = true,
    [DamageType.OLD_SLEEP] = true,
  },
  vuln_dam = {
    [DamageType.COLD] = true,
  },
  melee_retal = {
    [DamageType.FIRE] = 'mondam',
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    EMPTY_MIND = true,
    FLY = true,
    FORCE_SLEEP = true,
    HAS_LITE = true,
    NONLIVING = true,
    NO_CUT = true,
    POWERFUL = true,
  },
  placement_flags = { WILD_TOO=true, WILD_VOLCANO=true },
  attacks = {
    { type=DamageType.FIRE, method=AttackType.ENGULF, dam={3,3} },
  },
  resolvers.talents {
    [Talents.T_NPC_BR_FIRE] = 1,
  },
  body = bodies.none,
  speed = 0,
  vision = 100,
  alertness = 0,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'ACID_VORTEX',
  name = [[Acid vortex]],
  display = 'v',
  color = colors.C_s,
  image = 'npc/acid_vortex.png',
  desc = [[A caustic spinning whirlpool of foaming, steaming water.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=50,
    talent_in = 6,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 9, 9 },
  ac = 30,
  max_life = resolvers.dice(9, 9),
  rarity = 1,
  level = 21,
  start_level = 21,
  exp_worth = 100,
  resist_dam = {
    [DamageType.ACID] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.FEAR] = true,
    [DamageType.OLD_SLEEP] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    EMPTY_MIND = true,
    FLY = true,
    FORCE_SLEEP = true,
    NONLIVING = true,
    NO_CUT = true,
    POWERFUL = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.ACID, method=AttackType.ENGULF, dam={3,3} },
  },
  resolvers.talents {
    [Talents.T_NPC_BR_ACID] = 1,
  },
  body = bodies.none,
  speed = 0,
  vision = 100,
  alertness = 0,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'LUGDUSH_THE_URUK',
  name = [[Lugdush, the Uruk]],
  display = 'o',
  color = colors.C_v,
  image = 'npc/lugdush_the_uruk.png',
  desc = [[A large and powerful orc, captain of one of Saruman's orcish regiments.]],
  corpse_weight = 250,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 66, 10 },
  ac = 90,
  max_life = 660,
  rarity = 4,
  level = 21,
  start_level = 21,
  exp_worth = 550,
  unique = 'LUGDUSH_THE_URUK',
  resist_dam = {
    [DamageType.DARK] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    CAN_SPEAK = true,
    ESCORT = true,
    EVIL = true,
    FORCE_MAXHP = true,
    HAS_LITE = true,
    MALE = true,
    MORTAL = true,
    OPEN_DOOR = true,
    ORC = true,
    UNIQUE = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, only_item=true, '1d2' },
  drop = { treasure=10, combat=90, magic=0, tools=0, junk=0 },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={3,6} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={3,6} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={3,6} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={3,6} },
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 20,
  alertness = 20,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'COLD_VORTEX',
  name = [[Cold vortex]],
  display = 'v',
  color = colors.C_w,
  image = 'npc/cold_vortex.png',
  desc = [[A twisting whirlpool of frost.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=50,
    talent_in = 6,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 9, 9 },
  ac = 30,
  max_life = resolvers.dice(9, 9),
  rarity = 1,
  level = 21,
  start_level = 21,
  exp_worth = 100,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.FEAR] = true,
    [DamageType.OLD_SLEEP] = true,
  },
  vuln_dam = {
    [DamageType.FIRE] = true,
  },
  melee_retal = {
    [DamageType.COLD] = 'mondam',
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    COLD_BLOOD = true,
    EMPTY_MIND = true,
    FLY = true,
    FORCE_SLEEP = true,
    NONLIVING = true,
    NO_CUT = true,
    POWERFUL = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.COLD, method=AttackType.ENGULF, dam={3,3} },
  },
  resolvers.talents {
    [Talents.T_NPC_BR_COLD] = 1,
  },
  body = bodies.none,
  speed = 0,
  vision = 100,
  alertness = 0,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'ENERGY_VORTEX',
  name = [[Energy vortex]],
  display = 'v',
  color = colors.C_b,
  image = 'npc/energy_vortex.png',
  desc = [[A shimmering tornado of air, sparks crackle along its length.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=50,
    talent_in = 6,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 9, 9 },
  ac = 30,
  max_life = resolvers.dice(9, 9),
  rarity = 1,
  level = 21,
  start_level = 21,
  exp_worth = 100,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.ELEC] = true,
    [DamageType.FEAR] = true,
    [DamageType.OLD_SLEEP] = true,
  },
  melee_retal = {
    [DamageType.ELEC] = 'mondam',
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    EMPTY_MIND = true,
    FLY = true,
    FORCE_SLEEP = true,
    HAS_LITE = true,
    NONLIVING = true,
    NO_CUT = true,
    POWERFUL = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.ELEC, method=AttackType.ENGULF, dam={3,3} },
  },
  resolvers.talents {
    [Talents.T_NPC_BR_ELEC] = 1,
  },
  body = bodies.none,
  speed = 0,
  vision = 100,
  alertness = 0,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'GLOBEFISH',
  name = [[Globefish]],
  self_plural = true,
  display = '~',
  color = colors.C_w,
  image = 'npc/globefish.png',
  desc = [[This fish is among the most poisonous creatures there are.]],
  corpse_weight = 60,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 8,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 10, 10 },
  ac = 30,
  max_life = resolvers.dice(10, 10),
  rarity = 1,
  level = 21,
  start_level = 21,
  exp_worth = 111,
  resist_dam = {
    [DamageType.POISON] = true,
  },
  flags = {
    ANIMAL = true,
    AQUATIC = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    COLD_BLOOD = true,
    EMPTY_MIND = true,
    MORTAL = true,
    NO_STUN = true,
    POWERFUL = true,
  },
  placement_flags = { WILD_TOO=true },
  attacks = {
    { type=DamageType.POISON, method=AttackType.BITE, dam={10,5} },
    { type=DamageType.POISON, method=AttackType.BITE, dam={10,5} },
  },
  resolvers.talents {
    [Talents.T_NPC_BR_POIS] = 1,
  },
  body = bodies.snake,
  speed = 0,
  vision = 20,
  alertness = 30,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'GIANT_FIREFLY',
  name = [[Giant firefly]],
  display = 'I',
  color = colors.C_r,
  image = 'npc/giant_firefly.png',
  desc = [[Clouds of these monsters light up the dungeon - so brightly that you can barely see through them.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=75,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 3, 2 },
  ac = 18,
  max_life = resolvers.dice(3, 2),
  rarity = 4,
  level = 24,
  start_level = 24,
  exp_worth = 4,
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    FLY = true,
    MULTIPLY = true,
    WEIRD_MIND = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.BLIND, method=AttackType.BITE, dam={1,2} },
  },
  speed = 10,
  vision = 8,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'MUMMIFIED_ORC',
  name = [[Mummified orc]],
  display = 'z',
  color = colors.C_w,
  image = 'npc/mummified_orc.png',
  desc = [[It is an orcish figure covered in wrappings.]],
  corpse_weight = 170,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 15, 8 },
  ac = 28,
  max_life = resolvers.dice(15, 8),
  rarity = 1,
  level = 21,
  start_level = 21,
  exp_worth = 56,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.DARK] = true,
    [DamageType.FEAR] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    COLD_BLOOD = true,
    EMPTY_MIND = true,
    EVIL = true,
    NO_CUT = true,
    OPEN_DOOR = true,
    ORC = true,
    UNDEAD = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ '90%' },
  drop = { treasure=10, combat=70, magic=0, tools=10, junk=10 },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={2,4} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={2,4} },
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 20,
  alertness = 75,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'WOLF_CHIEFTAIN',
  name = [[Wolf chieftain]],
  display = 'C',
  color = colors.C_D,
  image = 'npc/wolf_chieftain.png',
  desc = [[A great wolf-chieftain whose pack is in the service of the Dark Lord, and whose howls strike fear into even the boldest heart.]],
  corpse_weight = 100,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 8,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 22, 22 },
  ac = 20,
  max_life = 484,
  rarity = 5,
  level = 26,
  start_level = 26,
  exp_worth = 120,
  resist_dam = {
    [DamageType.ACID] = true,
    [DamageType.COLD] = true,
    [DamageType.FEAR] = true,
  },
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    ESCORT = true,
    ESCORTS = true,
    EVIL = true,
    FORCE_MAXHP = true,
    MALE = true,
    MORTAL = true,
    OPEN_DOOR = true,
    SMART = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={2,6} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={2,6} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={2,10} },
    { type=DamageType.FEAR, method=AttackType.WAIL },
  },
  resolvers.talents {
    [Talents.T_NPC_DARKNESS] = 1,
  },
  speed = 10,
  vision = 20,
  alertness = 5,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'VAMPIRIC_MIST',
  name = [[Vampiric mist]],
  display = '#',
  color = colors.C_D,
  image = 'npc/vampiric_mist.png',
  desc = [[A cloud of evil, sentient mist.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=25,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 10, 8 },
  ac = 55,
  max_life = resolvers.dice(10, 8),
  rarity = 1,
  level = 22,
  start_level = 22,
  exp_worth = 40,
  resist_dam = {
    [DamageType.ACID] = true,
    [DamageType.COLD] = true,
    [DamageType.NETHER] = true,
    [DamageType.POISON] = true,
  },
  vuln_dam = {
    [DamageType.ELEC] = true,
  },
  flags = {
    BASEANGBAND = true,
    COLD_BLOOD = true,
    EMPTY_MIND = true,
    EVIL = true,
    FRIENDS = true,
    NO_CUT = true,
    UNDEAD = true,
  },
  placement_flags = { WILD_SWAMP=true, WILD_TOO=true },
  attacks = {
    { type=DamageType.EXP_20, method=AttackType.ENGULF, dam={1,6} },
    { type=DamageType.EXP_20, method=AttackType.ENGULF, dam={1,6} },
  },
  body = bodies.none,
  speed = 0,
  vision = 12,
  alertness = 30,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'KILLER_STAG_BEETLE',
  name = [[Killer stag beetle]],
  display = 'K',
  color = colors.C_g,
  image = 'npc/killer_stag_beetle.png',
  desc = [[It is a giant beetle with vicious claws.]],
  corpse_weight = 50,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=25,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 15, 8 },
  ac = 55,
  max_life = resolvers.dice(15, 8),
  rarity = 1,
  level = 22,
  start_level = 22,
  exp_worth = 80,
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    FLY = true,
    MORTAL = true,
    WEIRD_MIND = true,
  },
  placement_flags = { WILD_TOO=true },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={1,12} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={1,12} },
  },
  body = bodies.quadruped,
  speed = 0,
  vision = 12,
  alertness = 30,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'IRON_GOLEM',
  name = [[Iron golem]],
  display = 'g',
  color = colors.C_s,
  image = 'npc/iron_golem.png',
  desc = [[It is a massive metal statue that moves steadily towards you.]],
  corpse_weight = 380,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 7,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 80, 12 },
  ac = 80,
  max_life = resolvers.dice(80, 12),
  rarity = 2,
  level = 22,
  start_level = 22,
  exp_worth = 160,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.ELEC] = true,
    [DamageType.FEAR] = true,
    [DamageType.FIRE] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  vuln_dam = {
    [DamageType.ACID] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    COLD_BLOOD = true,
    EMPTY_MIND = true,
    FORCE_SLEEP = true,
    NONLIVING = true,
    NO_CUT = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,12} },
  },
  resolvers.talents {
    [Talents.T_NPC_SLOW] = 1,
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 12,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'GIANT_YELLOW_SCORPION',
  name = [[Giant yellow scorpion]],
  display = 'S',
  color = colors.C_y,
  image = 'npc/giant_yellow_scorpion.png',
  desc = [[It is a giant scorpion with a sharp stinger.]],
  corpse_weight = 120,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 12, 8 },
  ac = 38,
  max_life = resolvers.dice(12, 8),
  rarity = 1,
  level = 22,
  start_level = 22,
  exp_worth = 60,
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    MORTAL = true,
    WEIRD_MIND = true,
  },
  placement_flags = { WILD_TOO=true },
  drop_corpse = { skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={1,8} },
    { type=DamageType.POISON, method=AttackType.STING, dam={2,5} },
  },
  body = bodies.quadruped,
  speed = 0,
  vision = 12,
  alertness = 20,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'BLACK_OOZE',
  name = [[Black ooze]],
  display = 'j',
  color = colors.C_D,
  image = 'npc/black_ooze.png',
  desc = [[It is a strangely moving puddle.]],
  corpse_weight = 40,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=50,
    talent_in = 11,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 6, 8 },
  ac = 6,
  max_life = resolvers.dice(6, 8),
  rarity = 1,
  level = 23,
  start_level = 23,
  exp_worth = 7,
  resist_dam = {
    [DamageType.FEAR] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    CAN_SWIM = true,
    EMPTY_MIND = true,
    KILL_BODY = true,
    MORTAL = true,
    MULTIPLY = true,
    NO_CUT = true,
    OPEN_DOOR = true,
    STUPID = true,
    TAKE_ITEM = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ '60%' },
  drop = { treasure=30, combat=0, magic=40, tools=15, junk=15 },
  attacks = {
    { type=DamageType.ACID, method=AttackType.TOUCH, dam={2,6} },
  },
  resolvers.talents {
    [Talents.T_NPC_DRAIN_MANA] = 1,
  },
  body = bodies.none,
  speed = -20,
  vision = 10,
  alertness = 1,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'HARDENED_WARRIOR',
  name = [[Hardened warrior]],
  display = 'p',
  color = colors.C_u,
  image = 'npc/hardened_warrior.png',
  desc = [[A scarred warrior who moves with confidence.]],
  corpse_weight = 190,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 15, 11 },
  ac = 40,
  max_life = resolvers.dice(15, 11),
  rarity = 1,
  level = 23,
  start_level = 23,
  exp_worth = 60,
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    EVIL = true,
    HAS_LITE = true,
    MALE = true,
    MORTAL = true,
    OPEN_DOOR = true,
    TAKE_ITEM = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ '1d2' },
  drop = { treasure=0, combat=100, magic=0, tools=0, junk=0 },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={6,5} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={6,5} },
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 20,
  alertness = 40,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'AZOG_KING_OF_THE_URUK_HAI',
  name = [[Azog, King of the Uruk-Hai]],
  display = 'o',
  color = colors.C_v,
  image = 'npc/azog_king_of_the_uruk_hai.png',
  desc = [[He is also known as the King of Khazad-dûm. His ego is renowned to be bigger than his head.]],
  corpse_weight = 270,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 94, 10 },
  ac = 80,
  max_life = 940,
  level = 23,
  start_level = 23,
  exp_worth = 1111,
  unique = 'AZOG_KING_OF_THE_URUK_HAI',
  resist_dam = {
    [DamageType.DARK] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    CAN_SPEAK = true,
    ESCORT = true,
    ESCORTS = true,
    EVIL = true,
    FORCE_MAXHP = true,
    HAS_LITE = true,
    MALE = true,
    MORTAL = true,
    OPEN_DOOR = true,
    ORC = true,
    SPECIAL_GENE = true,
    UNIQUE = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, only_item=true, '2d2' },
  drop = { treasure=10, combat=90, magic=0, tools=0, junk=0 },
  drop_corpse = { corpse=true, skeleton=true },
  drop_special = function(self) return game.zone:makeEntityByName(game.level, 'object', 'WAND_WAND_OF_DIGGING_OF_THRAIN', false) end,
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={5,6} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={5,5} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={5,5} },
  },
  body = bodies.humanoid,
  speed = 10,
  vision = 20,
  alertness = 20,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'DARK_ELVEN_WARLOCK',
  name = [[Dark elven warlock]],
  display = 'h',
  color = colors.C_v,
  image = 'npc/dark_elven_warlock.png',
  desc = [[A dark elven mage with spells of frightening destructive power.]],
  corpse_weight = 170,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 5,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 7, 10 },
  ac = 16,
  max_life = resolvers.dice(7, 10),
  rarity = 1,
  level = 23,
  start_level = 23,
  exp_worth = 75,
  resist_dam = {
    [DamageType.DARK] = true,
    [DamageType.POISON] = true,
  },
  vuln_dam = {
    [DamageType.LITE] = true,
    [DamageType.LITE_WEAK] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    EVIL = true,
    FORCE_SLEEP = true,
    FRIENDS = true,
    HAS_LITE = true,
    MALE = true,
    OPEN_DOOR = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ only_item=true, '1d2' },
  drop = { treasure=0, combat=0, magic=100, tools=0, junk=0 },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,6} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,6} },
  },
  resolvers.talents {
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_MISSILE] = 1,
    [Talents.T_NPC_DARKNESS] = 1,
    [Talents.T_NPC_BO_MANA] = 1,
  },
  body = bodies.humanoid,
  speed = 10,
  vision = 20,
  alertness = 20,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'MASTER_ROGUE',
  name = [[Master rogue]],
  display = 'p',
  color = colors.C_b,
  image = 'npc/master_rogue.png',
  desc = [[A thief of great power and shifty speed.]],
  corpse_weight = 160,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 15, 9 },
  ac = 30,
  max_life = resolvers.dice(15, 9),
  rarity = 2,
  level = 23,
  start_level = 23,
  exp_worth = 110,
  vuln_dam = {
    [DamageType.ELEC] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    EVIL = true,
    HAS_LITE = true,
    MALE = true,
    MORTAL = true,
    OPEN_DOOR = true,
    TAKE_ITEM = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ '2d2' },
  drop = { treasure=80, combat=10, magic=10, tools=0, junk=0 },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={2,8} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={2,8} },
    { type=DamageType.EAT_GOLD, method=AttackType.HIT, dam={4,4} },
  },
  body = bodies.humanoid,
  speed = 10,
  vision = 20,
  alertness = 40,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'RED_DRAGON_BAT',
  name = [[Red dragon bat]],
  display = 'b',
  color = colors.C_r,
  image = 'npc/red_dragon_bat.png',
  desc = [[It is a sharp-tailed bat, wreathed in fire.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=50,
    talent_in = 4,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 3, 8 },
  ac = 28,
  max_life = resolvers.dice(3, 8),
  rarity = 1,
  level = 23,
  start_level = 23,
  exp_worth = 60,
  resist_dam = {
    [DamageType.FIRE] = true,
  },
  vuln_dam = {
    [DamageType.COLD] = true,
  },
  flags = {
    AI_ANNOY = true,
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    FLY = true,
    FORCE_SLEEP = true,
  },
  placement_flags = {},
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.FIRE, method=AttackType.BITE, dam={1,3} },
  },
  resolvers.talents {
    [Talents.T_NPC_BR_FIRE] = 1,
  },
  body = bodies.winged,
  speed = 20,
  vision = 12,
  alertness = 50,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'KILLER_WHITE_BEETLE',
  name = [[Killer white beetle]],
  display = 'K',
  color = colors.C_w,
  image = 'npc/killer_white_beetle.png',
  desc = [[It is looking for prey.]],
  corpse_weight = 50,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=25,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 18, 8 },
  ac = 55,
  max_life = resolvers.dice(18, 8),
  rarity = 1,
  level = 23,
  start_level = 23,
  exp_worth = 85,
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    FLY = true,
    MORTAL = true,
    WEIRD_MIND = true,
  },
  placement_flags = { WILD_TOO=true },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={4,5} },
  },
  body = bodies.quadruped,
  speed = 0,
  vision = 14,
  alertness = 30,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'ICE_SKELETON',
  name = [[Ice skeleton]],
  display = 's',
  color = colors.C_w,
  image = 'npc/ice_skeleton.png',
  desc = [[It is a skeleton covered in frost.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 16, 9 },
  ac = 34,
  max_life = resolvers.dice(16, 9),
  rarity = 1,
  level = 23,
  start_level = 23,
  exp_worth = 70,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.FEAR] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  vuln_dam = {
    [DamageType.FIRE] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    COLD_BLOOD = true,
    EVIL = true,
    NO_CUT = true,
    OPEN_DOOR = true,
    UNDEAD = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ only_item=true, '90%' },
  drop = { treasure=20, combat=0, magic=80, tools=0, junk=0 },
  attacks = {
    { type=DamageType.COLD, method=AttackType.CLAW, dam={2,3} },
    { type=DamageType.COLD, method=AttackType.CLAW, dam={2,3} },
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 20,
  alertness = 60,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'ANGAMAITE_OF_UMBAR',
  name = [[Angamaitë of Umbar]],
  display = 'p',
  color = colors.C_U,
  image = 'npc/angamaite_of_umbar.png',
  desc = [[A Black Númenórean who hates the men of the west.]],
  corpse_weight = 240,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 4,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 82, 10 },
  ac = 80,
  max_life = 820,
  rarity = 2,
  level = 24,
  start_level = 24,
  exp_worth = 400,
  unique = 'ANGAMAITE_OF_UMBAR',
  resist_dam = {
    [DamageType.ELEC] = true,
    [DamageType.FIRE] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    CAN_SPEAK = true,
    EVIL = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    HAS_LITE = true,
    MALE = true,
    MORTAL = true,
    OPEN_DOOR = true,
    UNIQUE = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, only_item=true, '1d2', '90%' },
  drop = { treasure=0, combat=80, magic=20, tools=0, junk=0 },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={4,7} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={4,7} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={4,6} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={4,6} },
  },
  resolvers.talents {
    [Talents.T_NPC_SLOW] = 1,
    [Talents.T_NPC_FORGET] = 1,
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 25,
  alertness = 25,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'FOREST_WIGHT',
  name = [[Forest wight]],
  display = 'W',
  color = colors.C_g,
  image = 'npc/forest_wight.png',
  desc = [[It is a ghostly apparition with a humanoid form.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=25,
    talent_in = 10,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 12, 8 },
  ac = 30,
  max_life = resolvers.dice(12, 8),
  rarity = 1,
  level = 24,
  start_level = 24,
  exp_worth = 140,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.DARK] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  vuln_dam = {
    [DamageType.LITE] = true,
    [DamageType.LITE_WEAK] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    COLD_BLOOD = true,
    EVIL = true,
    FLY = true,
    FORCE_SLEEP = true,
    NO_CUT = true,
    OPEN_DOOR = true,
    UNDEAD = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ '60%', '90%' },
  drop = { treasure=0, combat=50, magic=50, tools=0, junk=0 },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,6} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,6} },
    { type=DamageType.EXP_20, method=AttackType.TOUCH },
  },
  resolvers.talents {
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_DRAIN_MANA] = 1,
  },
  body = bodies.none,
  speed = 0,
  vision = 20,
  alertness = 30,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'KHIM_SON_OF_MIM',
  name = [[Khîm, Son of Mîm]],
  display = 'h',
  color = colors.C_o,
  image = 'npc/khim_son_of_mim.png',
  desc = [[One of the last of the Petty-Dwarves. Khîm is a tricky sorcerous little being, full of mischief.]],
  corpse_weight = 230,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 8,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 84, 10 },
  ac = 80,
  max_life = 840,
  rarity = 2,
  level = 24,
  start_level = 24,
  exp_worth = 300,
  unique = 'KHIM_SON_OF_MIM',
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.FIRE] = true,
    [DamageType.TELEPORT] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    CAN_SPEAK = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    HAS_LITE = true,
    MALE = true,
    MORTAL = true,
    OPEN_DOOR = true,
    UNIQUE = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, only_item=true, '1d2' },
  drop = { treasure=10, combat=80, magic=0, tools=10, junk=0 },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={3,8} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={3,8} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={3,7} },
    { type=DamageType.DISENCHANT, method=AttackType.HIT },
  },
  resolvers.talents {
    [Talents.T_NPC_HEAL] = 1,
    [Talents.T_NPC_SLOW] = 1,
    [Talents.T_NPC_BO_FIRE] = 1,
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 20,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'IBUN_SON_OF_MIM',
  name = [[Ibun, Son of Mîm]],
  display = 'h',
  color = colors.C_o,
  image = 'npc/ibun_son_of_mim.png',
  desc = [[One of the last of the Petty-Dwarves. Ibun is a tricky sorcerous little being, full of mischief.]],
  corpse_weight = 230,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 8,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 84, 10 },
  ac = 80,
  max_life = 840,
  rarity = 2,
  level = 24,
  start_level = 24,
  exp_worth = 300,
  unique = 'IBUN_SON_OF_MIM',
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.FIRE] = true,
    [DamageType.TELEPORT] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    CAN_SPEAK = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    HAS_LITE = true,
    MALE = true,
    MORTAL = true,
    OPEN_DOOR = true,
    UNIQUE = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, only_item=true, '1d2' },
  drop = { treasure=10, combat=80, magic=0, tools=5, junk=5 },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={3,8} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={3,8} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={3,7} },
    { type=DamageType.DISENCHANT, method=AttackType.HIT },
  },
  resolvers.talents {
    [Talents.T_NPC_HEAL] = 1,
    [Talents.T_NPC_SLOW] = 1,
    [Talents.T_NPC_BO_FIRE] = 1,
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 20,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'MENELDOR_THE_SWIFT',
  name = [[Meneldor the Swift]],
  display = 'B',
  color = colors.C_u,
  image = 'npc/meneldor_the_swift.png',
  desc = [[Among all the eagles of Middle-earth he is the swiftest, and in his time has borne messages between all of the Wise.  It was Meneldor who bore the Ring-bearer away from the destruction of Mount Doom.]],
  corpse_weight = 120,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 80, 10 },
  ac = 65,
  faction = 'friendlies',
  max_life = 800,
  rarity = 6,
  level = 24,
  start_level = 24,
  exp_worth = 360,
  unique = 'MENELDOR_THE_SWIFT',
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    CAN_SPEAK = true,
    FLY = true,
    FORCE_MAXHP = true,
    GOOD = true,
    PET = true,
    UNIQUE = true,
  },
  placement_flags = { WILD_MOUNTAIN=true, WILD_ONLY=true, WILD_VOLCANO=true },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={7,3} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={7,3} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={3,7} },
  },
  body = bodies.winged,
  speed = 30,
  vision = 20,
  alertness = 20,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'PHANTOM_BEAST',
  name = [[Phantom beast]],
  display = 'G',
  color = colors.C_B,
  image = 'npc/phantom_beast.png',
  desc = [[A creature that is half real, half illusion.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 12, 12 },
  ac = 40,
  max_life = 144,
  rarity = 1,
  level = 24,
  start_level = 24,
  exp_worth = 100,
  resist_dam = {
    [DamageType.FEAR] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.TELEPORT] = true,
  },
  flags = {
    BASEANGBAND = true,
    COLD_BLOOD = true,
    EMPTY_MIND = true,
    FLY = true,
    FORCE_MAXHP = true,
    NONLIVING = true,
    NO_CUT = true,
    PASS_WALL = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={2,33} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={2,44} },
  },
  body = bodies.none,
  speed = 0,
  vision = 20,
  alertness = 40,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'GIANT_SILVER_ANT',
  name = [[Giant silver ant]],
  display = 'a',
  color = colors.C_W,
  image = 'npc/giant_silver_ant.png',
  desc = [[A giant silver ant with a caustic bite.]],
  corpse_weight = 80,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=25,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 9, 8 },
  ac = 38,
  max_life = resolvers.dice(9, 8),
  rarity = 1,
  level = 23,
  start_level = 23,
  exp_worth = 45,
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    HAS_LITE = true,
    MORTAL = true,
    WEIRD_MIND = true,
  },
  placement_flags = { WILD_TOO=true },
  drop_corpse = { skeleton=true },
  attacks = {
    { type=DamageType.ACID, method=AttackType.BITE, dam={4,4} },
  },
  body = bodies.quadruped,
  speed = 0,
  vision = 10,
  alertness = 40,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = '4_HEADED_HYDRA',
  name = [[4-headed hydra]],
  display = 'M',
  color = colors.C_y,
  image = 'npc/4_headed_hydra.png',
  desc = [[A strange reptilian creature with four heads, guarding its hoard.]],
  corpse_weight = 500,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 7,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 100, 6 },
  ac = 70,
  max_life = resolvers.dice(100, 6),
  rarity = 2,
  level = 24,
  start_level = 24,
  exp_worth = 450,
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    FORCE_SLEEP = true,
    MORTAL = true,
    MOVE_BODY = true,
    OPEN_DOOR = true,
  },
  placement_flags = { WILD_SHORE=true, WILD_SWAMP=true, WILD_TOO=true },
  resolvers.mon_inven{ only_gold=true, '4d2' },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={2,6} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={2,6} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={2,6} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={2,6} },
  },
  resolvers.talents {
    [Talents.T_NPC_SCARE] = 1,
  },
  body = bodies.hydra,
  speed = 10,
  vision = 20,
  alertness = 20,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'MUMMIFIED_HUMAN',
  name = [[Mummified human]],
  display = 'z',
  color = colors.C_w,
  image = 'npc/mummified_human.png',
  desc = [[It is a human form encased in mouldy wrappings.]],
  corpse_weight = 150,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 17, 9 },
  ac = 34,
  max_life = resolvers.dice(17, 9),
  rarity = 1,
  level = 24,
  start_level = 24,
  exp_worth = 70,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.FEAR] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    COLD_BLOOD = true,
    EMPTY_MIND = true,
    EVIL = true,
    NO_CUT = true,
    OPEN_DOOR = true,
    UNDEAD = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ only_item=true, '90%' },
  drop = { treasure=20, combat=40, magic=20, tools=10, junk=10 },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={2,4} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={2,4} },
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 20,
  alertness = 60,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'VAMPIRE_BAT',
  name = [[Vampire bat]],
  display = 'b',
  color = colors.C_D,
  image = 'npc/vampire_bat.png',
  desc = [[A blood-sucking bat that flies at your neck hungrily.]],
  corpse_weight = 5,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=50,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 9, 10 },
  ac = 40,
  max_life = resolvers.dice(9, 10),
  rarity = 2,
  level = 24,
  start_level = 24,
  exp_worth = 150,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.FEAR] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    COLD_BLOOD = true,
    EVIL = true,
    FLY = true,
    NO_CUT = true,
    REGENERATE = true,
    UNDEAD = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.EXP_40, method=AttackType.BITE, dam={1,4} },
    { type=DamageType.EXP_40, method=AttackType.BITE, dam={1,4} },
  },
  body = bodies.winged,
  speed = 10,
  vision = 12,
  alertness = 50,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'SANGAHYANDO_OF_UMBAR',
  name = [[Sangahyando of Umbar]],
  display = 'p',
  color = colors.C_U,
  image = 'npc/sangahyando_of_umbar.png',
  desc = [[A Black Númenórean with a blacker heart.]],
  corpse_weight = 240,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 4,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 82, 10 },
  ac = 80,
  max_life = 820,
  rarity = 2,
  level = 24,
  start_level = 24,
  exp_worth = 400,
  unique = 'SANGAHYANDO_OF_UMBAR',
  resist_dam = {
    [DamageType.ELEC] = true,
    [DamageType.FIRE] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    CAN_SPEAK = true,
    EVIL = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    HAS_LITE = true,
    MALE = true,
    MORTAL = true,
    OPEN_DOOR = true,
    UNIQUE = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, only_item=true, '1d2', '90%' },
  drop = { treasure=0, combat=90, magic=10, tools=0, junk=0 },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={4,7} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={4,7} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={4,7} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={4,7} },
  },
  resolvers.talents {
    [Talents.T_NPC_SLOW] = 1,
    [Talents.T_NPC_FORGET] = 1,
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 25,
  alertness = 25,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'BANSHEE',
  name = [[Banshee]],
  display = 'G',
  color = colors.C_b,
  image = 'npc/banshee.png',
  desc = [[It is a ghostly woman's form that wails mournfully.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=50,
    talent_in = 15,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 6, 8 },
  ac = 24,
  max_life = resolvers.dice(6, 8),
  rarity = 2,
  level = 24,
  start_level = 24,
  exp_worth = 60,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    COLD_BLOOD = true,
    EVIL = true,
    FEMALE = true,
    FLY = true,
    INVISIBLE = true,
    NO_CUT = true,
    PASS_WALL = true,
    TAKE_ITEM = true,
    UNDEAD = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ '1d2' },
  drop = { treasure=80, combat=0, magic=0, tools=15, junk=5 },
  attacks = {
    { type=DamageType.FEAR, method=AttackType.WAIL },
    { type=DamageType.EXP_20, method=AttackType.TOUCH },
  },
  resolvers.talents {
    [Talents.T_NPC_TPORT] = 1,
    [Talents.T_NPC_DRAIN_MANA] = 1,
  },
  body = bodies.none,
  speed = 10,
  vision = 20,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'CARRION_CRAWLER',
  name = [[Carrion crawler]],
  display = 'c',
  color = colors.C_o,
  image = 'npc/carrion_crawler.png',
  desc = [[A hideous centipede covered in slime and with glowing tentacles around its head.]],
  corpse_weight = 70,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=25,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 20, 12 },
  ac = 40,
  max_life = resolvers.dice(20, 12),
  rarity = 2,
  level = 25,
  start_level = 25,
  exp_worth = 60,
  resist_dam = {
    [DamageType.POISON] = true,
  },
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    MORTAL = true,
    WEIRD_MIND = true,
  },
  placement_flags = {},
  drop_corpse = { skeleton=true },
  attacks = {
    { type=DamageType.PARALYZE, method=AttackType.STING, dam={2,6} },
    { type=DamageType.PARALYZE, method=AttackType.STING, dam={2,6} },
  },
  body = bodies.snake,
  speed = 0,
  vision = 15,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'SILENT_WATCHER',
  name = [[Silent watcher]],
  display = 'g',
  color = colors.C_s,
  image = 'npc/silent_watcher.png',
  desc = [[A figure carved from stone, with three vulture faces whose eyes glow with a malevolent light.  None escape its vigilance.]],
  corpse_weight = 400,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 3,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 80, 25 },
  ac = 80,
  max_life = resolvers.dice(80, 25),
  rarity = 3,
  level = 35,
  start_level = 35,
  exp_worth = 800,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.DARK] = true,
    [DamageType.ELEC] = true,
    [DamageType.FEAR] = true,
    [DamageType.FIRE] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
    [DamageType.TELEPORT] = true,
  },
  vuln_dam = {
    [DamageType.KILL_WALL] = true,
    [DamageType.LITE] = true,
    [DamageType.LITE_WEAK] = true,
  },
  flags = {
    BASEANGBAND = true,
    COLD_BLOOD = true,
    EMPTY_MIND = true,
    EVIL = true,
    NEVER_MOVE = true,
    NONLIVING = true,
    NO_CUT = true,
    NO_STUN = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.FEAR, method=AttackType.GAZE },
    { type=DamageType.PARALYZE, method=AttackType.GAZE },
    { type=DamageType.LOSE_STR, method=AttackType.GAZE },
    { type=DamageType.HALLUCINATION, method=AttackType.GAZE },
  },
  resolvers.talents {
    [Talents.T_NPC_SHRIEK] = 1,
    [Talents.T_NPC_S_MONSTER] = 1,
    [Talents.T_NPC_S_MONSTERS] = 1,
    [Talents.T_NPC_HOLD] = 1,
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_MIND_BLAST] = 1,
    [Talents.T_NPC_DRAIN_MANA] = 1,
  },
  body = { MAIN_HAND=3, OFF_HAND=3, BODY=0, CLOAK=0, LAUNCHER=1, QUIVER=0, GLOVES=3, BOOTS=0, HELM=2, RING=3, AMULET=2, LITE=0, TOOL=1, SYMBIOTE=0, INVEN=23 },
  speed = 0,
  vision = 60,
  alertness = 0,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'PUKELMAN',
  name = [[Pukelman]],
  plural_name = [[Pukelmen]],
  display = 'g',
  color = colors.C_D,
  image = 'npc/pukelman.png',
  desc = [[A stumpy figure carved from stone, with glittering eyes.]],
  corpse_weight = 1000,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 4,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 80, 12 },
  ac = 80,
  max_life = resolvers.dice(80, 12),
  rarity = 3,
  level = 25,
  start_level = 25,
  exp_worth = 600,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.ELEC] = true,
    [DamageType.FEAR] = true,
    [DamageType.FIRE] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  vuln_dam = {
    [DamageType.KILL_WALL] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    COLD_BLOOD = true,
    EMPTY_MIND = true,
    FORCE_SLEEP = true,
    NO_CUT = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,12} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={3,6} },
  },
  resolvers.talents {
    [Talents.T_NPC_SLOW] = 1,
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_BO_ACID] = 1,
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 12,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'DARK_ELVEN_DRUID',
  name = [[Dark elven druid]],
  display = 'h',
  color = colors.C_G,
  image = 'npc/dark_elven_druid.png',
  desc = [[A powerful dark elf, with mighty nature-controlling enchantments.]],
  corpse_weight = 120,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 6,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 20, 20 },
  ac = 75,
  max_life = resolvers.dice(20, 20),
  rarity = 3,
  level = 25,
  start_level = 25,
  exp_worth = 500,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.DARK] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  vuln_dam = {
    [DamageType.LITE] = true,
    [DamageType.LITE_WEAK] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    EVIL = true,
    FORCE_SLEEP = true,
    HAS_LITE = true,
    MALE = true,
    OPEN_DOOR = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ only_item=true, '1d2' },
  drop = { treasure=10, combat=0, magic=80, tools=10, junk=0 },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,7} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,7} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={3,8} },
  },
  resolvers.talents {
    [Talents.T_NPC_HEAL] = 1,
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_DARKNESS] = 1,
    [Talents.T_NPC_S_MONSTER] = 1,
    [Talents.T_NPC_S_SPIDER] = 1,
    [Talents.T_NPC_S_ANIMAL] = 1,
  },
  body = bodies.humanoid,
  speed = 10,
  vision = 15,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'STONE_TROLL',
  name = [[Stone troll]],
  display = 'T',
  color = colors.C_W,
  image = 'npc/stone_troll.png',
  desc = [[He is a giant troll with scabrous black skin.]],
  corpse_weight = 500,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 23, 10 },
  ac = 50,
  max_life = resolvers.dice(23, 10),
  rarity = 1,
  level = 25,
  start_level = 25,
  exp_worth = 85,
  resist_dam = {
    [DamageType.DARK] = true,
  },
  vuln_dam = {
    [DamageType.KILL_WALL] = true,
    [DamageType.LITE] = true,
    [DamageType.LITE_WEAK] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    EVIL = true,
    FRIENDS = true,
    MALE = true,
    NO_CUT = true,
    OPEN_DOOR = true,
    REGENERATE = true,
    TROLL = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ '60%' },
  drop = { treasure=0, combat=100, magic=0, tools=0, junk=0 },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,6} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,6} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={3,4} },
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 20,
  alertness = 50,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'HILL_TROLL',
  name = [[Hill troll]],
  display = 'T',
  color = colors.C_s,
  image = 'npc/hill_troll.png',
  desc = [[A large troll with an extremely tough and warty hide.]],
  corpse_weight = 400,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 21, 10 },
  ac = 65,
  max_life = resolvers.dice(21, 10),
  rarity = 1,
  level = 21,
  start_level = 21,
  exp_worth = 75,
  resist_dam = {
    [DamageType.DARK] = true,
  },
  vuln_dam = {
    [DamageType.FIRE] = true,
    [DamageType.LITE] = true,
    [DamageType.LITE_WEAK] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    EVIL = true,
    FRIENDS = true,
    MALE = true,
    OPEN_DOOR = true,
    REGENERATE = true,
    TROLL = true,
  },
  placement_flags = { WILD_MOUNTAIN=true, WILD_TOO=true, WILD_WASTE=true },
  resolvers.mon_inven{ '60%' },
  drop = { treasure=30, combat=70, magic=0, tools=0, junk=0 },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,5} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,5} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={2,6} },
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 20,
  alertness = 40,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'WEREWORM',
  name = [[Wereworm]],
  display = 'w',
  color = colors.C_u,
  image = 'npc/wereworm.png',
  desc = [[A huge wormlike shape dripping acid, twisted by evil sorcery into a foul monster that breeds on death.]],
  corpse_weight = 600,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 100, 11 },
  ac = 70,
  max_life = resolvers.dice(100, 11),
  rarity = 3,
  level = 25,
  start_level = 25,
  exp_worth = 300,
  resist_dam = {
    [DamageType.ACID] = true,
  },
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    CAN_SWIM = true,
    EVIL = true,
    MORTAL = true,
  },
  placement_flags = { WILD_SWAMP=true, WILD_TOO=true },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.EXP_20, method=AttackType.GAZE },
    { type=DamageType.ACID, method=AttackType.CRAWL, dam={2,4} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={1,10} },
    { type=DamageType.POISON, method=AttackType.BITE, dam={1,6} },
  },
  body = bodies.snake,
  speed = 0,
  vision = 15,
  alertness = 20,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'KILLER_RED_BEETLE',
  name = [[Killer red beetle]],
  display = 'K',
  color = colors.C_r,
  image = 'npc/killer_red_beetle.png',
  desc = [[A giant beetle with poisonous mandibles.]],
  corpse_weight = 60,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=25,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 20, 8 },
  ac = 50,
  max_life = resolvers.dice(20, 8),
  rarity = 1,
  level = 25,
  start_level = 25,
  exp_worth = 90,
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    FLY = true,
    MORTAL = true,
    WEIRD_MIND = true,
  },
  placement_flags = { WILD_TOO=true },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.LOSE_STR, method=AttackType.BITE, dam={4,4} },
  },
  body = bodies.quadruped,
  speed = 0,
  vision = 14,
  alertness = 30,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'DISENCHANTER_BAT',
  name = [[Disenchanter bat]],
  display = 'b',
  color = colors.C_v,
  image = 'npc/disenchanter_bat.png',
  desc = [[A giant bat which feeds on raw magical energy.]],
  corpse_weight = 5,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=50,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 6, 8 },
  ac = 28,
  max_life = resolvers.dice(6, 8),
  rarity = 4,
  level = 26,
  start_level = 26,
  exp_worth = 75,
  flags = {
    AI_ANNOY = true,
    ANIMAL = true,
    ATTR_MULTI = true,
    BASEANGBAND = true,
    FLY = true,
    FORCE_SLEEP = true,
    MORTAL = true,
    WEIRD_MIND = true,
  },
  placement_flags = {},
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.DISENCHANT, method=AttackType.HIT },
    { type=DamageType.DISENCHANT, method=AttackType.HIT },
  },
  body = bodies.winged,
  speed = 20,
  vision = 12,
  alertness = 50,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'GIANT_GREY_ANT',
  name = [[Giant grey ant]],
  display = 'a',
  color = colors.C_s,
  image = 'npc/giant_grey_ant.png',
  desc = [[It is an ant encased in shaggy grey fur.]],
  corpse_weight = 70,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=25,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 19, 8 },
  ac = 40,
  max_life = resolvers.dice(19, 8),
  rarity = 1,
  level = 26,
  start_level = 26,
  exp_worth = 90,
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    KILL_BODY = true,
    WEIRD_MIND = true,
  },
  placement_flags = {},
  drop_corpse = { skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={2,12} },
  },
  body = bodies.quadruped,
  speed = 0,
  vision = 10,
  alertness = 40,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'KHUFU_THE_MUMMIFIED_KING',
  name = [[Khufu, the Mummified King]],
  display = 'z',
  color = colors.C_v,
  image = 'npc/khufu_the_mummified_king.png',
  desc = [[He is out to have revenge on those who have desecrated his tomb.]],
  corpse_weight = 180,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 5,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 85, 11 },
  ac = 40,
  max_life = 935,
  rarity = 4,
  level = 26,
  start_level = 26,
  exp_worth = 500,
  unique = 'KHUFU_THE_MUMMIFIED_KING',
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.FEAR] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
    [DamageType.TELEPORT] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    CAN_SPEAK = true,
    COLD_BLOOD = true,
    ESCORT = true,
    ESCORTS = true,
    EVIL = true,
    FORCE_MAXHP = true,
    MALE = true,
    NO_CUT = true,
    OPEN_DOOR = true,
    UNDEAD = true,
    UNIQUE = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, only_item=true, '90%' },
  drop = { treasure=0, combat=80, magic=20, tools=0, junk=0 },
  attacks = {
    { type=DamageType.FEAR, method=AttackType.GAZE },
    { type=DamageType.DISEASE, method=AttackType.HIT, dam={6,6} },
    { type=DamageType.LOSE_CON, method=AttackType.CLAW, dam={4,4} },
    { type=DamageType.LOSE_CON, method=AttackType.CLAW, dam={4,4} },
  },
  resolvers.talents {
    [Talents.T_NPC_TRAPS] = 1,
    [Talents.T_NPC_CAUSE_3] = 1,
    [Talents.T_NPC_DARKNESS] = 1,
    [Talents.T_NPC_S_UNDEAD] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_SLOW] = 1,
    [Talents.T_NPC_S_KIN] = 1,
    [Talents.T_NPC_ANIM_DEAD] = 1,
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 20,
  alertness = 40,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'GWAIHIR_THE_WINDLORD',
  name = [[Gwaihir the Windlord]],
  display = 'B',
  color = colors.C_u,
  image = 'npc/gwaihir_the_windlord.png',
  desc = [[The greatest of eagles in the Third Age of Middle-earth, Gwaihir rescued Gandalf the Wizard from Orthanc, and has twice brought his flock to the aid of Sauron's enemies in battle - first outside the gates of Erebor in the Battle of Five Armies, and then before the Black Gate of Mordor itself.]],
  corpse_weight = 120,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 85, 10 },
  ac = 65,
  faction = 'friendlies',
  max_life = 850,
  rarity = 6,
  level = 24,
  start_level = 24,
  exp_worth = 360,
  unique = 'GWAIHIR_THE_WINDLORD',
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    CAN_SPEAK = true,
    FLY = true,
    FORCE_MAXHP = true,
    GOOD = true,
    PET = true,
    UNIQUE = true,
  },
  placement_flags = { WILD_MOUNTAIN=true, WILD_ONLY=true, WILD_VOLCANO=true },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={15,2} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={15,2} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={3,10} },
  },
  body = bodies.winged,
  speed = 20,
  vision = 20,
  alertness = 20,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'GIANT_FIRE_TICK',
  name = [[Giant fire tick]],
  display = 'S',
  color = colors.C_R,
  image = 'npc/giant_fire_tick.png',
  desc = [[It is smoking and burning with great heat.]],
  corpse_weight = 20,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=25,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 16, 8 },
  ac = 54,
  max_life = resolvers.dice(16, 8),
  rarity = 2,
  level = 26,
  start_level = 26,
  exp_worth = 90,
  resist_dam = {
    [DamageType.FIRE] = true,
  },
  vuln_dam = {
    [DamageType.COLD] = true,
  },
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    FLY = true,
    HAS_LITE = true,
    MORTAL = true,
    WEIRD_MIND = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.FIRE, method=AttackType.BITE, dam={3,6} },
  },
  body = bodies.quadruped,
  speed = 0,
  vision = 14,
  alertness = 20,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'DISPLACER_BEAST',
  name = [[Displacer beast]],
  display = 'f',
  color = colors.C_b,
  image = 'npc/displacer_beast.png',
  desc = [[It is a huge black panther, clubbed tentacles sprouting from its shoulders.]],
  corpse_weight = 180,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 25, 10 },
  ac = 100,
  max_life = resolvers.dice(25, 10),
  rarity = 2,
  level = 26,
  start_level = 26,
  exp_worth = 100,
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    INVISIBLE = true,
    MORTAL = true,
  },
  placement_flags = {},
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={2,8} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,10} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,10} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,10} },
  },
  body = bodies.quadruped,
  speed = 0,
  vision = 35,
  alertness = 20,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'ULWARTH_SON_OF_ULFANG',
  name = [[Ulwarth, Son of Ulfang]],
  display = 'p',
  color = colors.C_U,
  image = 'npc/ulwarth_son_of_ulfang.png',
  desc = [[A short and swarthy Easterling.]],
  corpse_weight = 180,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 85, 10 },
  ac = 40,
  max_life = 850,
  rarity = 4,
  level = 26,
  start_level = 26,
  exp_worth = 500,
  unique = 'ULWARTH_SON_OF_ULFANG',
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    CAN_SPEAK = true,
    EVIL = true,
    FORCE_MAXHP = true,
    HAS_LITE = true,
    MALE = true,
    MORTAL = true,
    OPEN_DOOR = true,
    TAKE_ITEM = true,
    UNIQUE = true,
  },
  placement_flags = { WILD_TOO=true },
  resolvers.mon_inven{ good=true, only_item=true, '90%' },
  drop = { treasure=40, combat=60, magic=0, tools=0, junk=0 },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={4,6} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={4,6} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={4,6} },
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 20,
  alertness = 40,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'WEREBEAR',
  name = [[Werebear]],
  display = 'q',
  color = colors.C_D,
  image = 'npc/werebear.png',
  desc = [[In the eyes of this bear, there glimmers the faintest light of intelligence. And then its form begins to change... The combination of animal cunning, human intelligence and the great physical strength of the bear makes for a dangerous enemy.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 25, 25 },
  ac = 50,
  max_life = resolvers.dice(25, 25),
  rarity = 2,
  level = 24,
  start_level = 24,
  exp_worth = 200,
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    EVIL = true,
    OPEN_DOOR = true,
  },
  placement_flags = { WILD_MOUNTAIN=true, WILD_TOO=true, WILD_WOOD=true },
  resolvers.mon_inven{ '1d2' },
  drop = { treasure=25, combat=25, magic=25, tools=20, junk=5 },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={1,10} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={1,10} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={2,8} },
    { type=DamageType.PHYSICAL, method=AttackType.CRUSH, dam={2,6} },
  },
  body = bodies.quadruped,
  speed = 0,
  vision = 20,
  alertness = 20,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'CAVE_OGRE',
  name = [[Cave ogre]],
  display = 'O',
  color = colors.C_u,
  image = 'npc/cave_ogre.png',
  desc = [[A giant orc-like figure with an awesomely muscled frame.]],
  corpse_weight = 250,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 30, 9 },
  ac = 33,
  max_life = resolvers.dice(30, 9),
  rarity = 2,
  level = 26,
  start_level = 26,
  exp_worth = 80,
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    EVIL = true,
    FRIENDS = true,
    GIANT = true,
    HAS_LITE = true,
    MORTAL = true,
    OPEN_DOOR = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ '60%' },
  drop = { treasure=20, combat=70, magic=0, tools=10, junk=0 },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={3,8} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={3,8} },
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 20,
  alertness = 30,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'WHITE_WRAITH',
  name = [[White wraith]],
  display = 'W',
  color = colors.C_w,
  image = 'npc/white_wraith.png',
  desc = [[It is a tangible but ghostly form made of white fog.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 8,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 15, 8 },
  ac = 40,
  max_life = resolvers.dice(15, 8),
  rarity = 1,
  level = 26,
  start_level = 26,
  exp_worth = 175,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.DARK] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  vuln_dam = {
    [DamageType.LITE] = true,
    [DamageType.LITE_WEAK] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    COLD_BLOOD = true,
    EVIL = true,
    FLY = true,
    FORCE_SLEEP = true,
    NO_CUT = true,
    OPEN_DOOR = true,
    UNDEAD = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ '1d2' },
  drop = { treasure=0, combat=50, magic=50, tools=0, junk=0 },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,6} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,6} },
    { type=DamageType.EXP_20, method=AttackType.TOUCH },
  },
  resolvers.talents {
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_CAUSE_2] = 1,
    [Talents.T_NPC_DARKNESS] = 1,
  },
  body = bodies.none,
  speed = 0,
  vision = 20,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'ANGEL',
  name = [[Angel]],
  display = 'A',
  color = colors.C_o,
  image = 'npc/angel.png',
  desc = [[Who knows why you are now facing an angel as an enemy? Is it a punishment from your own god for your sins, or a test of your mettle, or has this angel been sent by another god on behalf of someone who wishes to claim the glory for his own god? Perhaps you will never know: but it is here, and you must fight it.]],
  corpse_weight = 260,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 3,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 30, 10 },
  ac = 60,
  faction = 'eru_manwe',
  max_life = 300,
  rarity = 4,
  level = 26,
  start_level = 26,
  exp_worth = 220,
  resist_dam = {
    [DamageType.ACID] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.FEAR] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    FLY = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    GOOD = true,
    HAS_LITE = true,
    OPEN_DOOR = true,
    POWERFUL = true,
    TAKE_ITEM = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ only_item=true, '2d2' },
  drop = { treasure=0, combat=40, magic=60, tools=0, junk=0 },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={3,4} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={3,4} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={3,4} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={3,4} },
  },
  resolvers.talents {
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_FORGET] = 1,
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 30,
  alertness = 255,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'GHOUL',
  name = [[Ghoul]],
  display = 'z',
  color = colors.C_U,
  image = 'npc/ghoul.png',
  desc = [[Flesh is falling off in chunks from this decaying abomination.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 9,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 15, 9 },
  ac = 30,
  max_life = resolvers.dice(15, 9),
  rarity = 1,
  level = 25,
  start_level = 25,
  exp_worth = 95,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.DARK] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  vuln_dam = {
    [DamageType.LITE] = true,
    [DamageType.LITE_WEAK] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    CAN_SWIM = true,
    COLD_BLOOD = true,
    EVIL = true,
    FRIENDS = true,
    NO_CUT = true,
    OPEN_DOOR = true,
    UNDEAD = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ '60%' },
  drop = { treasure=0, combat=45, magic=35, tools=10, junk=10 },
  attacks = {
    { type=DamageType.DISEASE, method=AttackType.CLAW, dam={1,4} },
    { type=DamageType.DISEASE, method=AttackType.CLAW, dam={1,4} },
    { type=DamageType.PARALYZE, method=AttackType.BITE, dam={1,5} },
  },
  resolvers.talents {
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_HOLD] = 1,
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 30,
  alertness = 20,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'MIM_BETRAYER_OF_TURIN',
  name = [[Mîm, Betrayer of Túrin]],
  display = 'h',
  color = colors.C_o,
  image = 'npc/mim_betrayer_of_turin.png',
  desc = [[The last of his race, Mîm is a Petty-Dwarf.  Petty-Dwarves are strange creatures, powerful in sorcery and originating in the East.  They have been hunted nearly to extinction by the High Elves.]],
  corpse_weight = 120,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 6,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 11, 105 },
  ac = 80,
  max_life = 1155,
  rarity = 4,
  level = 27,
  start_level = 27,
  exp_worth = 1000,
  unique = 'MIM_BETRAYER_OF_TURIN',
  resist_dam = {
    [DamageType.ACID] = true,
    [DamageType.COLD] = true,
    [DamageType.DISEASE] = true,
    [DamageType.ELEC] = true,
    [DamageType.FIRE] = true,
    [DamageType.POISON] = true,
    [DamageType.TELEPORT] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    CAN_SPEAK = true,
    EVIL = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    HAS_LITE = true,
    MALE = true,
    MORTAL = true,
    OPEN_DOOR = true,
    UNIQUE = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, only_item=true, '2d2' },
  drop = { treasure=10, combat=80, magic=10, tools=0, junk=0 },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={3,9} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={3,9} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={3,9} },
    { type=DamageType.DISENCHANT, method=AttackType.HIT, dam={3,12} },
  },
  resolvers.talents {
    [Talents.T_NPC_HEAL] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_BO_ACID] = 1,
    [Talents.T_NPC_BA_ACID] = 1,
    [Talents.T_NPC_TPORT] = 1,
    [Talents.T_NPC_S_MONSTER] = 1,
  },
  body = bodies.humanoid,
  speed = 10,
  vision = 20,
  alertness = 20,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'HELLBLADE',
  name = [[Hellblade]],
  display = '|',
  color = colors.C_v,
  image = 'npc/hellblade.png',
  desc = [[A deadly blade of chaos, moving of its own volition.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 13, 13 },
  ac = 40,
  max_life = 169,
  rarity = 2,
  level = 27,
  start_level = 27,
  exp_worth = 130,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.FEAR] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  vuln_dam = {
    [DamageType.ACID] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    CHAR_MULTI = true,
    COLD_BLOOD = true,
    EVIL = true,
    FLY = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    HAS_LITE = true,
    NONLIVING = true,
    NO_CUT = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.EXP_20, method=AttackType.HIT, dam={2,13} },
    { type=DamageType.EXP_20, method=AttackType.HIT, dam={2,13} },
  },
  body = bodies.none,
  speed = 10,
  vision = 20,
  alertness = 20,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'KILLER_FIRE_BEETLE',
  name = [[Killer fire beetle]],
  display = 'K',
  color = colors.C_R,
  image = 'npc/killer_fire_beetle.png',
  desc = [[It is a giant beetle wreathed in flames.]],
  corpse_weight = 60,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 22, 8 },
  ac = 45,
  max_life = resolvers.dice(22, 8),
  rarity = 1,
  level = 27,
  start_level = 27,
  exp_worth = 95,
  resist_dam = {
    [DamageType.FIRE] = true,
  },
  vuln_dam = {
    [DamageType.COLD] = true,
  },
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    FLY = true,
    HAS_LITE = true,
    MORTAL = true,
    WEIRD_MIND = true,
  },
  placement_flags = { WILD_TOO=true, WILD_VOLCANO=true },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={3,4} },
    { type=DamageType.FIRE, method=AttackType.SPIT, dam={4,5} },
  },
  body = bodies.quadruped,
  speed = 0,
  vision = 14,
  alertness = 30,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'CREEPING_ADAMANTITE_COINS',
  name = [[Creeping adamantite coins]],
  self_plural = true,
  display = '$',
  color = colors.C_G,
  image = 'npc/creeping_adamantite_coins.png',
  desc = [[It appears to be a pile of coins made of precious adamant, slithering toward you on lots of tiny legs.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 20, 25 },
  ac = 50,
  max_life = resolvers.dice(20, 25),
  rarity = 3,
  level = 27,
  start_level = 27,
  exp_worth = 60,
  resist_dam = {
    [DamageType.ACID] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.ELEC] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    CHAR_MULTI = true,
    COLD_BLOOD = true,
    NO_CUT = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ coin_type='ADAMANTITE', only_gold=true, '2d2', '90%' },
  attacks = {
    { type=DamageType.POISON, method=AttackType.BITE, dam={3,4} },
    { type=DamageType.POISON, method=AttackType.TOUCH, dam={3,5} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,12} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,12} },
  },
  body = bodies.none,
  speed = 10,
  vision = 5,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'ALGROTH',
  name = [[Algroth]],
  display = 'T',
  color = colors.C_o,
  image = 'npc/algroth.png',
  desc = [[A powerful troll form. Venom drips from its needlelike claws.]],
  corpse_weight = 600,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 21, 12 },
  ac = 60,
  max_life = resolvers.dice(21, 12),
  rarity = 1,
  level = 27,
  start_level = 27,
  exp_worth = 150,
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    EVIL = true,
    FRIENDS = true,
    OPEN_DOOR = true,
    REGENERATE = true,
    TROLL = true,
  },
  placement_flags = { WILD_MOUNTAIN=true, WILD_SWAMP=true, WILD_TOO=true, WILD_WOOD=true },
  resolvers.mon_inven{ '60%' },
  drop = { treasure=10, combat=80, magic=0, tools=10, junk=0 },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.POISON, method=AttackType.CLAW, dam={3,3} },
    { type=DamageType.POISON, method=AttackType.CLAW, dam={3,3} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={1,6} },
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 20,
  alertness = 40,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'ROPER',
  name = [[Roper]],
  display = '#',
  color = colors.C_D,
  image = 'npc/roper.png',
  desc = [[This creature look like a pillar of rock. However, a closer inspection reveals a glaring eye and powerful tentacles, which crush its prey and feed it to the creature's hungry mouth.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 5,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 30, 10 },
  ac = 60,
  max_life = 300,
  rarity = 5,
  level = 27,
  start_level = 27,
  exp_worth = 235,
  resist_dam = {
    [DamageType.ACID] = true,
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.FEAR] = true,
    [DamageType.FIRE] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    EVIL = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    NEVER_MOVE = true,
    NO_CUT = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ only_gold=true, '1d2', '2d2', '60%' },
  attacks = {
    { type=DamageType.PARALYZE, method=AttackType.CRUSH, dam={3,5} },
    { type=DamageType.PARALYZE, method=AttackType.CRUSH, dam={3,5} },
    { type=DamageType.PARALYZE, method=AttackType.CRUSH, dam={3,5} },
    { type=DamageType.PARALYZE, method=AttackType.CRUSH, dam={3,5} },
  },
  resolvers.talents {
    [Talents.T_NPC_BA_FIRE] = 1,
    [Talents.T_NPC_BA_ELEC] = 1,
    [Talents.T_NPC_BA_POIS] = 1,
    [Talents.T_NPC_HASTE] = 1,
    [Talents.T_NPC_TRAPS] = 1,
    [Talents.T_NPC_SHRIEK] = 1,
    [Talents.T_NPC_HOLD] = 1,
    [Talents.T_NPC_CONF] = 1,
  },
  body = { MAIN_HAND=0, OFF_HAND=0, BODY=0, CLOAK=0, LAUNCHER=0, QUIVER=0, GLOVES=0, BOOTS=0, HELM=0, RING=6, AMULET=0, LITE=0, TOOL=0, SYMBIOTE=0, INVEN=23 },
  speed = 5,
  vision = 30,
  alertness = 255,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'VIBRATION_HOUND',
  name = [[Vibration hound]],
  display = 'Z',
  color = colors.C_y,
  image = 'npc/vibration_hound.png',
  desc = [[A blurry canine form which seems to be moving as fast as the eye can follow. You can feel the earth resonating beneath your feet.]],
  corpse_weight = 60,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 5,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 25, 10 },
  ac = 30,
  max_life = resolvers.dice(25, 10),
  rarity = 2,
  level = 27,
  start_level = 27,
  exp_worth = 250,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.SOUND] = true,
  },
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    FORCE_SLEEP = true,
    FRIENDS = true,
    MORTAL = true,
  },
  placement_flags = {},
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={2,8} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={2,8} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={3,3} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={3,3} },
  },
  resolvers.talents {
    [Talents.T_NPC_BR_SOUN] = 1,
  },
  body = bodies.quadruped,
  speed = 0,
  vision = 30,
  alertness = 0,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'NEXUS_HOUND',
  name = [[Nexus hound]],
  display = 'Z',
  color = colors.C_v,
  image = 'npc/nexus_hound.png',
  desc = [[A locus of conflicting points coalesce to form the vague shape of a huge hound. Or is it just your imagination?]],
  corpse_weight = 60,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 5,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 25, 10 },
  ac = 30,
  max_life = resolvers.dice(25, 10),
  rarity = 2,
  level = 27,
  start_level = 27,
  exp_worth = 250,
  resist_dam = {
    [DamageType.NEXUS] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.TELEPORT] = true,
  },
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    FORCE_SLEEP = true,
    FRIENDS = true,
    MORTAL = true,
  },
  placement_flags = {},
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={2,8} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={2,8} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={3,3} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={3,3} },
  },
  resolvers.talents {
    [Talents.T_NPC_BR_NEXU] = 1,
  },
  body = bodies.quadruped,
  speed = 0,
  vision = 30,
  alertness = 0,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'HALF_OGRE',
  name = [[Half-ogre]],
  display = 'O',
  color = colors.C_o,
  image = 'npc/half_ogre.png',
  desc = [[A giant, brutish figure, as ugly as an orc, but with some of the intelligence of his half-human ancestry.]],
  corpse_weight = 270,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 35, 9 },
  ac = 33,
  max_life = resolvers.dice(35, 9),
  rarity = 2,
  level = 27,
  start_level = 27,
  exp_worth = 80,
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    EVIL = true,
    FRIENDS = true,
    GIANT = true,
    HAS_LITE = true,
    MORTAL = true,
    OPEN_DOOR = true,
    SMART = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ '60%' },
  drop = { treasure=20, combat=70, magic=0, tools=10, junk=0 },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={4,8} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={4,8} },
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 20,
  alertness = 30,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'LOKKAK_THE_OGRE_CHIEFTAIN',
  name = [[Lokkak, the Ogre Chieftain]],
  display = 'O',
  color = colors.C_v,
  image = 'npc/lokkak_the_ogre_chieftain.png',
  desc = [[An ogre renowned for acts of surprising cruelty, Lokkak is the leader of a large band of violent ogres.]],
  corpse_weight = 300,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 15, 103 },
  ac = 100,
  max_life = 1545,
  rarity = 2,
  level = 32,
  start_level = 32,
  exp_worth = 1500,
  unique = 'LOKKAK_THE_OGRE_CHIEFTAIN',
  resist_dam = {
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    CAN_SPEAK = true,
    CAN_SWIM = true,
    ESCORT = true,
    EVIL = true,
    FORCE_MAXHP = true,
    GIANT = true,
    HAS_LITE = true,
    MALE = true,
    MORTAL = true,
    OPEN_DOOR = true,
    UNIQUE = true,
  },
  placement_flags = { WILD_SHORE=true, WILD_SWAMP=true, WILD_TOO=true },
  resolvers.mon_inven{ good=true, only_item=true, '2d2' },
  drop = { treasure=5, combat=85, magic=0, tools=5, junk=5 },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={6,7} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={6,7} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={6,7} },
  },
  body = bodies.humanoid,
  speed = 10,
  vision = 20,
  alertness = 20,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'VAMPIRE',
  name = [[Vampire]],
  display = 'V',
  color = colors.C_W,
  image = 'npc/vampire.png',
  desc = [[It is a humanoid with an aura of power. You notice a sharp set of front teeth.]],
  corpse_weight = 170,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 9,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 25, 12 },
  ac = 45,
  max_life = 300,
  rarity = 1,
  level = 27,
  start_level = 27,
  exp_worth = 175,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.DARK] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  vuln_dam = {
    [DamageType.LITE] = true,
    [DamageType.LITE_WEAK] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    COLD_BLOOD = true,
    EVIL = true,
    FLY = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    NO_CUT = true,
    OPEN_DOOR = true,
    REGENERATE = true,
    UNDEAD = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ '1d2', '60%' },
  drop = { treasure=20, combat=40, magic=20, tools=10, junk=10 },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,6} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,6} },
    { type=DamageType.EXP_20, method=AttackType.BITE, dam={2,6} },
    { type=DamageType.EXP_20, method=AttackType.BITE, dam={2,6} },
  },
  resolvers.talents {
    [Talents.T_NPC_TELE_TO] = 1,
    [Talents.T_NPC_HOLD] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_CAUSE_2] = 1,
    [Talents.T_NPC_MIND_BLAST] = 1,
    [Talents.T_NPC_FORGET] = 1,
    [Talents.T_NPC_DARKNESS] = 1,
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 20,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'GORGIMAERA',
  name = [[Gorgimaera]],
  display = 'H',
  color = colors.C_o,
  image = 'npc/gorgimaera.png',
  desc = [[The result of evil experiments, this travesty of nature should never be alive.  It has three heads - goat, dragon and gorgon - all attached to a lion's body.]],
  corpse_weight = 230,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 8,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 25, 20 },
  ac = 55,
  max_life = resolvers.dice(25, 20),
  rarity = 2,
  level = 27,
  start_level = 27,
  exp_worth = 400,
  resist_dam = {
    [DamageType.FIRE] = true,
  },
  vuln_dam = {
    [DamageType.COLD] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    FLY = true,
    FORCE_SLEEP = true,
  },
  placement_flags = {},
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.BUTT, dam={2,10} },
    { type=DamageType.FIRE, method=AttackType.BITE, dam={2,10} },
    { type=DamageType.PARALYZE, method=AttackType.GAZE, dam={2,6} },
  },
  resolvers.talents {
    [Talents.T_NPC_BR_FIRE] = 1,
  },
  body = bodies.hydra,
  speed = 0,
  vision = 12,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'COLBRAN',
  name = [[Colbran]],
  display = 'g',
  color = colors.C_y,
  image = 'npc/colbran.png',
  desc = [[A man-shaped form of living lightning, sparks and shocks crackle all over this madly capering figure, as it leaps and whirls around and about you.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 3,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 80, 12 },
  ac = 80,
  max_life = resolvers.dice(80, 12),
  rarity = 2,
  level = 27,
  start_level = 27,
  exp_worth = 900,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.ELEC] = true,
    [DamageType.FEAR] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  melee_retal = {
    [DamageType.ELEC] = 'mondam',
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    COLD_BLOOD = true,
    EMPTY_MIND = true,
    FLY = true,
    FORCE_SLEEP = true,
    NONLIVING = true,
    NO_CUT = true,
    REFLECTING = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.ELEC, method=AttackType.HIT, dam={3,8} },
    { type=DamageType.ELEC, method=AttackType.HIT, dam={3,8} },
  },
  resolvers.talents {
    [Talents.T_NPC_BO_ELEC] = 1,
  },
  body = bodies.none,
  speed = 10,
  vision = 12,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'SPIRIT_NAGA',
  name = [[Spirit naga]],
  display = 'n',
  color = colors.C_w,
  image = 'npc/spirit_naga.png',
  desc = [[A wraithly snake-like form with the torso of a beautiful woman, it is the most powerful of its kind.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 4,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 30, 15 },
  ac = 75,
  max_life = resolvers.dice(30, 15),
  rarity = 2,
  level = 28,
  start_level = 28,
  exp_worth = 60,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.OLD_SLEEP] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    EVIL = true,
    FEMALE = true,
    FLY = true,
    FORCE_SLEEP = true,
    INVISIBLE = true,
    NO_CUT = true,
    OPEN_DOOR = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ only_item=true, '2d2', '90%' },
  drop = { treasure=20, combat=0, magic=80, tools=0, junk=0 },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CRUSH, dam={2,8} },
    { type=DamageType.PHYSICAL, method=AttackType.CRUSH, dam={2,8} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={1,8} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={1,8} },
  },
  resolvers.talents {
    [Talents.T_NPC_HEAL] = 1,
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_MIND_BLAST] = 1,
    [Talents.T_NPC_DARKNESS] = 1,
  },
  body = bodies.snake,
  speed = 0,
  vision = 20,
  alertness = 120,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = '5_HEADED_HYDRA',
  name = [[5-headed hydra]],
  display = 'M',
  color = colors.C_g,
  image = 'npc/5_headed_hydra.png',
  desc = [[A strange reptilian creature with five heads dripping venom.]],
  corpse_weight = 550,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 5,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 100, 8 },
  ac = 80,
  max_life = resolvers.dice(100, 8),
  rarity = 2,
  level = 28,
  start_level = 28,
  exp_worth = 650,
  resist_dam = {
    [DamageType.POISON] = true,
  },
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    CAN_SWIM = true,
    FORCE_SLEEP = true,
    MORTAL = true,
    MOVE_BODY = true,
  },
  placement_flags = { WILD_SHORE=true, WILD_SWAMP=true, WILD_TOO=true },
  resolvers.mon_inven{ only_gold=true, '1d2', '4d2' },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.POISON, method=AttackType.BITE, dam={4,4} },
    { type=DamageType.POISON, method=AttackType.BITE, dam={4,4} },
    { type=DamageType.POISON, method=AttackType.BITE, dam={4,4} },
    { type=DamageType.POISON, method=AttackType.BITE, dam={4,4} },
  },
  resolvers.talents {
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_BA_POIS] = 1,
  },
  body = bodies.hydra,
  speed = 10,
  vision = 20,
  alertness = 20,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'BLACK_KNIGHT',
  name = [[Black knight]],
  display = 'p',
  color = colors.C_s,
  image = 'npc/black_knight.png',
  desc = [[He is a figure encased in deep black plate armour; he looks at you menacingly.]],
  corpse_weight = 240,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 8,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 30, 10 },
  ac = 70,
  max_life = resolvers.dice(30, 10),
  rarity = 1,
  level = 28,
  start_level = 28,
  exp_worth = 240,
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    EVIL = true,
    FORCE_SLEEP = true,
    HAS_LITE = true,
    MALE = true,
    MORTAL = true,
    OPEN_DOOR = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ '1d2' },
  drop = { treasure=0, combat=90, magic=10, tools=0, junk=0 },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={5,5} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={5,5} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={5,5} },
  },
  resolvers.talents {
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_CAUSE_3] = 1,
    [Talents.T_NPC_DARKNESS] = 1,
  },
  body = bodies.humanoid,
  speed = 10,
  vision = 20,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'SEAHORSE',
  name = [[Seahorse]],
  display = '~',
  color = colors.C_o,
  image = 'npc/seahorse.png',
  desc = [[Your mind is filled with admiration as you view this wondrous, magical seahorse.]],
  corpse_weight = 300,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 5,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 111, 7 },
  ac = 60,
  faction = 'yavanna',
  max_life = resolvers.dice(111, 7),
  rarity = 2,
  level = 28,
  start_level = 28,
  exp_worth = 360,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.ELEC] = true,
    [DamageType.FIRE] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    ANIMAL = true,
    AQUATIC = true,
    BASEANGBAND = true,
    FORCE_SLEEP = true,
    GOOD = true,
    MORTAL = true,
  },
  placement_flags = { WILD_OCEAN=true, WILD_TOO=true },
  attacks = {
    { type=DamageType.PARALYZE, method=AttackType.BITE, dam={4,5} },
    { type=DamageType.LOSE_DEX, method=AttackType.BITE, dam={4,5} },
    { type=DamageType.LOSE_CON, method=AttackType.BITE, dam={4,5} },
  },
  resolvers.talents {
    [Talents.T_NPC_BO_WATE] = 1,
    [Talents.T_NPC_BO_COLD] = 1,
    [Talents.T_NPC_BO_ICEE] = 1,
    [Talents.T_NPC_BO_MANA] = 1,
  },
  body = bodies.snake,
  speed = 10,
  vision = 20,
  alertness = 20,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'CYCLOPS',
  name = [[Cyclops]],
  plural_name = [[Cyclopes]],
  display = 'P',
  color = colors.C_u,
  image = 'npc/cyclops.png',
  desc = [[A gigantic humanoid with but one eye.]],
  corpse_weight = 350,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 8,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 60, 20 },
  ac = 90,
  max_life = resolvers.dice(60, 20),
  rarity = 2,
  level = 45,
  start_level = 45,
  exp_worth = 1500,
  resist_dam = {
    [DamageType.ACID] = true,
    [DamageType.COLD] = true,
    [DamageType.FIRE] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    EVIL = true,
    FORCE_SLEEP = true,
    GIANT = true,
    HAS_LITE = true,
    MORTAL = true,
    MOVE_BODY = true,
    OPEN_DOOR = true,
    TAKE_ITEM = true,
  },
  placement_flags = { WILD_MOUNTAIN=true, WILD_SHORE=true, WILD_TOO=true },
  resolvers.mon_inven{ '1d2' },
  drop = { treasure=0, combat=100, magic=0, tools=0, junk=0 },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={9,9} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={9,9} },
  },
  resolvers.talents {
    [Talents.T_NPC_ARROW_4] = 1,
  },
  body = bodies.humanoid,
  speed = 10,
  vision = 20,
  alertness = 20,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'CLAIRVOYANT',
  name = [[Clairvoyant]],
  display = 'p',
  color = colors.C_y,
  image = 'npc/clairvoyant.png',
  desc = [[He is using his supernatural talents to bring about your destruction.]],
  corpse_weight = 160,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 8,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 25, 10 },
  ac = 50,
  max_life = resolvers.dice(25, 10),
  rarity = 3,
  level = 28,
  start_level = 28,
  exp_worth = 250,
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    EVIL = true,
    FORCE_SLEEP = true,
    HAS_LITE = true,
    MALE = true,
    MORTAL = true,
    OPEN_DOOR = true,
    SMART = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ '1d2' },
  drop = { treasure=0, combat=0, magic=90, tools=10, junk=0 },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.CONFUSION, method=AttackType.HIT, dam={5,5} },
    { type=DamageType.FEAR, method=AttackType.HIT, dam={5,5} },
  },
  resolvers.talents {
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_MIND_BLAST] = 1,
    [Talents.T_NPC_HOLD] = 1,
    [Talents.T_NPC_CAUSE_3] = 1,
    [Talents.T_NPC_FORGET] = 1,
    [Talents.T_NPC_S_MONSTER] = 1,
  },
  body = bodies.humanoid,
  speed = 10,
  vision = 100,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'PURPLE_WORM',
  name = [[Purple worm]],
  display = 'w',
  color = colors.C_v,
  image = 'npc/purple_worm.png',
  desc = [[It is a massive worm form, many feet in length. Its vast maw drips acid and poison.]],
  corpse_weight = 100,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 65, 8 },
  ac = 65,
  max_life = resolvers.dice(65, 8),
  rarity = 4,
  level = 29,
  start_level = 29,
  exp_worth = 400,
  resist_dam = {
    [DamageType.ACID] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    CAN_SWIM = true,
    MORTAL = true,
  },
  placement_flags = {},
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,8} },
    { type=DamageType.ACID, method=AttackType.BITE, dam={2,8} },
    { type=DamageType.POISON, method=AttackType.STING, dam={1,8} },
  },
  body = bodies.snake,
  speed = 0,
  vision = 14,
  alertness = 30,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'CATOBLEPAS',
  name = [[Catoblepas]],
  plural_name = [[Catoblepones]],
  display = 'q',
  color = colors.C_g,
  image = 'npc/catoblepas.png',
  desc = [[A strange ox-like form with a huge head but a thin, weak neck, it looks like the creation of some deranged alchemist.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 30, 10 },
  ac = 55,
  max_life = resolvers.dice(30, 10),
  rarity = 2,
  level = 29,
  start_level = 29,
  exp_worth = 400,
  resist_dam = {
    [DamageType.POISON] = true,
  },
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    CAN_SWIM = true,
    MORTAL = true,
  },
  placement_flags = { WILD_SWAMP=true, WILD_TOO=true },
  resolvers.mon_inven{ only_gold=true, '2d2' },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.FEAR, method=AttackType.GAZE, dam={2,4} },
    { type=DamageType.BLIND, method=AttackType.GAZE, dam={2,4} },
    { type=DamageType.PHYSICAL, method=AttackType.BUTT, dam={2,6} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={2,12} },
  },
  body = bodies.quadruped,
  speed = 0,
  vision = 15,
  alertness = 40,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'LESSER_WALL_MONSTER',
  name = [[Lesser wall monster]],
  display = '#',
  color = colors.C_W,
  image = 'npc/lesser_wall_monster.png',
  desc = [[A sentient, moving section of wall.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=50,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 13, 8 },
  ac = 75,
  max_life = resolvers.dice(13, 8),
  rarity = 4,
  level = 28,
  start_level = 28,
  exp_worth = 600,
  resist_dam = {
    [DamageType.ACID] = true,
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.ELEC] = true,
    [DamageType.FIRE] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  vuln_dam = {
    [DamageType.KILL_WALL] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    CHAR_MULTI = true,
    COLD_BLOOD = true,
    EMPTY_MIND = true,
    FORCE_SLEEP = true,
    KILL_WALL = true,
    MULTIPLY = true,
    NONLIVING = true,
    NO_CUT = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={2,6} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={2,6} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={2,6} },
  },
  body = bodies.none,
  speed = 0,
  vision = 20,
  alertness = 40,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'MAGE',
  name = [[Mage]],
  display = 'p',
  color = colors.C_r,
  image = 'npc/mage.png',
  desc = [[A fat mage with glasses.  And considerable power, too - as you can tell from the size of his hat.]],
  corpse_weight = 150,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 3,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 15, 8 },
  ac = 40,
  max_life = resolvers.dice(15, 8),
  rarity = 1,
  level = 28,
  start_level = 28,
  exp_worth = 150,
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    EVIL = true,
    FORCE_SLEEP = true,
    HAS_LITE = true,
    MALE = true,
    MORTAL = true,
    OPEN_DOOR = true,
    SMART = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ only_item=true, '1d2' },
  drop = { treasure=10, combat=0, magic=90, tools=0, junk=0 },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={2,5} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={2,5} },
  },
  resolvers.talents {
    [Talents.T_NPC_HASTE] = 1,
    [Talents.T_NPC_TPORT] = 1,
    [Talents.T_NPC_TELE_TO] = 1,
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_BO_FIRE] = 1,
    [Talents.T_NPC_BO_COLD] = 1,
    [Talents.T_NPC_BO_ELEC] = 1,
    [Talents.T_NPC_S_MONSTER] = 1,
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 20,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'MIND_FLAYER',
  name = [[Mind flayer]],
  display = 'h',
  color = colors.C_v,
  image = 'npc/mind_flayer.png',
  desc = [[A humanoid form with a gruesome head, tentacular mouth, and piercing eyes. Claws reach out for you and you feel a presence invade your mind.]],
  corpse_weight = 140,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 8,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 15, 10 },
  ac = 60,
  max_life = 150,
  rarity = 1,
  level = 28,
  start_level = 28,
  exp_worth = 200,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.OLD_SLEEP] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    EVIL = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    MORTAL = true,
    OPEN_DOOR = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ only_item=true, '1d2', '60%' },
  drop = { treasure=0, combat=10, magic=90, tools=0, junk=0 },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.LOSE_INT, method=AttackType.CRUSH, dam={2,6} },
    { type=DamageType.INSANITY, method=AttackType.GAZE, dam={2,6} },
  },
  resolvers.talents {
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_HOLD] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_MIND_BLAST] = 1,
    [Talents.T_NPC_BRAIN_SMASH] = 1,
    [Talents.T_NPC_FORGET] = 1,
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 20,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'BASILISK',
  name = [[Basilisk]],
  display = 'R',
  color = colors.C_s,
  image = 'npc/basilisk.png',
  desc = [[An evil reptile that preys on unsuspecting travellers.  Its eyes stare deeply at you and your soul starts to wilt!]],
  corpse_weight = 40,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 8,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 20, 30 },
  ac = 90,
  max_life = resolvers.dice(20, 30),
  rarity = 3,
  level = 28,
  start_level = 28,
  exp_worth = 350,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    CAN_SWIM = true,
    EVIL = true,
    MORTAL = true,
    OPEN_DOOR = true,
  },
  placement_flags = { WILD_MOUNTAIN=true, WILD_TOO=true },
  resolvers.mon_inven{ only_item=true, '1d2' },
  drop = { treasure=50, combat=0, magic=30, tools=20, junk=0 },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PARALYZE, method=AttackType.GAZE },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={2,12} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={2,12} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={2,12} },
  },
  resolvers.talents {
    [Talents.T_NPC_BR_POIS] = 1,
  },
  body = bodies.quadruped,
  speed = 10,
  vision = 15,
  alertness = 30,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'ICE_TROLL',
  name = [[Ice troll]],
  display = 'T',
  color = colors.C_w,
  image = 'npc/ice_troll.png',
  desc = [[He is a white troll with powerful clawed hands.]],
  corpse_weight = 500,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 24, 10 },
  ac = 56,
  max_life = resolvers.dice(24, 10),
  rarity = 1,
  level = 28,
  start_level = 28,
  exp_worth = 200,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.DARK] = true,
  },
  vuln_dam = {
    [DamageType.FIRE] = true,
    [DamageType.LITE] = true,
    [DamageType.LITE_WEAK] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    EVIL = true,
    FRIENDS = true,
    MALE = true,
    OPEN_DOOR = true,
    REGENERATE = true,
    TROLL = true,
  },
  placement_flags = { WILD_TOO=true, WILD_WASTE=true },
  resolvers.mon_inven{ '60%' },
  drop = { treasure=0, combat=100, magic=0, tools=0, junk=0 },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,5} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,5} },
    { type=DamageType.COLD, method=AttackType.BITE, dam={2,6} },
    { type=DamageType.COLD, method=AttackType.BITE, dam={2,6} },
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 20,
  alertness = 50,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'ARCHANGEL',
  name = [[Archangel]],
  display = 'A',
  color = colors.C_B,
  image = 'npc/archangel.png',
  desc = [[A lesser angel protected by an aura of holiness. Its muscular form looks extremely powerful next to your own frail body.]],
  corpse_weight = 400,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 3,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 60, 10 },
  ac = 68,
  faction = 'eru_manwe',
  max_life = 600,
  rarity = 4,
  level = 34,
  start_level = 34,
  exp_worth = 1000,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.FEAR] = true,
    [DamageType.FIRE] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
    [DamageType.TELEPORT] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    FLY = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    GOOD = true,
    HAS_LITE = true,
    OPEN_DOOR = true,
    POWERFUL = true,
    SMART = true,
    TAKE_ITEM = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ only_item=true, '2d2' },
  drop = { treasure=0, combat=40, magic=60, tools=0, junk=0 },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={3,5} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={3,5} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={3,5} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={3,5} },
  },
  resolvers.talents {
    [Talents.T_NPC_HEAL] = 1,
    [Talents.T_NPC_HASTE] = 1,
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_SCARE] = 1,
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 30,
  alertness = 255,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'GREATER_MIMIC',
  name = [[Greater Mimic]],
  display = 'm',
  color = colors.C_y,
  image = 'npc/greater_mimic.png',
  desc = [[A strange creature that disguises itself as an object to lure unsuspecting adventurers within reach of its venomous claws.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 4,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 10, 35 },
  ac = 60,
  max_life = resolvers.dice(10, 35),
  rarity = 3,
  level = 29,
  start_level = 29,
  exp_worth = 200,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.FEAR] = true,
    [DamageType.OLD_SLEEP] = true,
  },
  vuln_dam = {
    [DamageType.ACID] = true,
  },
  flags = {
    BASEANGBAND = true,
    COLD_BLOOD = true,
    EMPTY_MIND = true,
    FORCE_SLEEP = true,
    MIMIC = true,
    NEVER_MOVE = true,
    NO_CUT = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.POISON, method=AttackType.HIT, dam={3,4} },
    { type=DamageType.POISON, method=AttackType.HIT, dam={3,4} },
    { type=DamageType.POISON, method=AttackType.HIT, dam={3,4} },
    { type=DamageType.POISON, method=AttackType.HIT, dam={3,4} },
  },
  resolvers.talents {
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_CAUSE_2] = 1,
    [Talents.T_NPC_FORGET] = 1,
    [Talents.T_NPC_BO_ACID] = 1,
    [Talents.T_NPC_BO_FIRE] = 1,
    [Talents.T_NPC_BO_COLD] = 1,
    [Talents.T_NPC_BO_ELEC] = 1,
    [Talents.T_NPC_S_MONSTER] = 1,
  },
  body = bodies.none,
  speed = 10,
  vision = 30,
  alertness = 100,
  resolvers.mon_global_speed(),
  resolvers.mon_mimic(),
}

newEntity {
  define_as = 'YOUNG_BLUE_DRAGON',
  name = [[Young blue dragon]],
  display = 'd',
  color = colors.C_b,
  multi_colors = { colors.C_b, colors.C_B },
  image = 'npc/young_blue_dragon.png',
  desc = [[It has a form out of legend. Its still-tender scales are a deep blue in hue. Sparks crackle along its length.]],
  corpse_weight = 2000,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 10,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 27, 10 },
  ac = 50,
  max_life = 270,
  rarity = 1,
  level = 29,
  start_level = 29,
  exp_worth = 500,
  resist_dam = {
    [DamageType.ELEC] = true,
  },
  flags = {
    ATTR_MULTI = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    DRAGON = true,
    EVIL = true,
    FLY = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    OPEN_DOOR = true,
  },
  placement_flags = { WILD_MOUNTAIN=true, WILD_TOO=true, WILD_WOOD=true },
  resolvers.mon_inven{ '2d2' },
  drop = { treasure=50, combat=50, magic=0, tools=0, junk=0 },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={2,4} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={2,4} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={2,6} },
  },
  resolvers.talents {
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_BR_ELEC] = 1,
  },
  body = bodies.dragon,
  speed = 0,
  vision = 20,
  alertness = 70,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'YOUNG_WHITE_DRAGON',
  name = [[Young white dragon]],
  display = 'd',
  color = colors.C_w,
  multi_colors = { colors.C_w, colors.C_W },
  image = 'npc/young_white_dragon.png',
  desc = [[It has a form out of legend. Its still-tender scales are a frosty white in hue. Icy blasts of cold air come from it as it breathes.]],
  corpse_weight = 2000,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 10,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 27, 10 },
  ac = 50,
  max_life = 270,
  rarity = 1,
  level = 29,
  start_level = 29,
  exp_worth = 500,
  resist_dam = {
    [DamageType.COLD] = true,
  },
  vuln_dam = {
    [DamageType.FIRE] = true,
  },
  flags = {
    ATTR_MULTI = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    DRAGON = true,
    EVIL = true,
    FLY = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    OPEN_DOOR = true,
  },
  placement_flags = { WILD_MOUNTAIN=true, WILD_TOO=true, WILD_WASTE=true },
  resolvers.mon_inven{ '2d2' },
  drop = { treasure=50, combat=50, magic=0, tools=0, junk=0 },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={2,4} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={2,4} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={2,6} },
  },
  resolvers.talents {
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_BR_COLD] = 1,
  },
  body = bodies.dragon,
  speed = 0,
  vision = 20,
  alertness = 70,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'YOUNG_GREEN_DRAGON',
  name = [[Young green dragon]],
  display = 'd',
  color = colors.C_g,
  multi_colors = { colors.C_g, colors.C_G },
  image = 'npc/young_green_dragon.png',
  desc = [[It has a form out of legend. Its still-tender scales are a deep green in hue. Foul gas seeps through its scales.]],
  corpse_weight = 2000,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 10,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 27, 10 },
  ac = 50,
  max_life = 270,
  rarity = 1,
  level = 29,
  start_level = 29,
  exp_worth = 500,
  resist_dam = {
    [DamageType.POISON] = true,
  },
  flags = {
    ATTR_MULTI = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    DRAGON = true,
    EVIL = true,
    FLY = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    OPEN_DOOR = true,
  },
  placement_flags = { WILD_MOUNTAIN=true, WILD_SWAMP=true, WILD_TOO=true },
  resolvers.mon_inven{ '2d2' },
  drop = { treasure=50, combat=50, magic=0, tools=0, junk=0 },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={2,4} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={2,4} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={2,6} },
  },
  resolvers.talents {
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_BR_POIS] = 1,
  },
  body = bodies.dragon,
  speed = 0,
  vision = 20,
  alertness = 70,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'YOUNG_BRONZE_DRAGON',
  name = [[Young bronze dragon]],
  display = 'd',
  color = colors.C_U,
  multi_colors = { colors.C_U, colors.C_u },
  image = 'npc/young_bronze_dragon.png',
  desc = [[It has a form out of legend. Its still-tender scales are a rich bronze hue, and its shape masks its true form.]],
  corpse_weight = 2000,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 10,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 27, 10 },
  ac = 50,
  max_life = 270,
  rarity = 1,
  level = 29,
  start_level = 29,
  exp_worth = 500,
  resist_dam = {
    [DamageType.CONFUSION] = true,
  },
  flags = {
    ATTR_MULTI = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    DRAGON = true,
    EVIL = true,
    FLY = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    OPEN_DOOR = true,
  },
  placement_flags = { WILD_MOUNTAIN=true, WILD_TOO=true },
  resolvers.mon_inven{ '2d2' },
  drop = { treasure=50, combat=50, magic=0, tools=0, junk=0 },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={2,4} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={2,4} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={2,6} },
  },
  resolvers.talents {
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_BR_CONF] = 1,
  },
  body = bodies.dragon,
  speed = 0,
  vision = 20,
  alertness = 70,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'MITHRIL_GOLEM',
  name = [[Mithril golem]],
  display = 'g',
  color = colors.C_B,
  image = 'npc/mithril_golem.png',
  desc = [[It is a massive statue of purest mithril. It looks expensive!]],
  corpse_weight = 1000,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 80, 15 },
  ac = 100,
  max_life = resolvers.dice(80, 15),
  rarity = 4,
  level = 30,
  start_level = 30,
  exp_worth = 500,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.ELEC] = true,
    [DamageType.FEAR] = true,
    [DamageType.FIRE] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    COLD_BLOOD = true,
    EMPTY_MIND = true,
    NONLIVING = true,
    NO_CUT = true,
    REFLECTING = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ only_gold=true, '2d2' },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={3,8} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={3,8} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={5,5} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={5,5} },
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 12,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'SKELETON_TROLL',
  name = [[Skeleton troll]],
  display = 's',
  color = colors.C_W,
  image = 'npc/skeleton_troll.png',
  desc = [[It is a troll skeleton animated by dark dweomers.]],
  corpse_weight = 500,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 20, 10 },
  ac = 55,
  max_life = resolvers.dice(20, 10),
  rarity = 1,
  level = 30,
  start_level = 30,
  exp_worth = 225,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.FEAR] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    COLD_BLOOD = true,
    EMPTY_MIND = true,
    EVIL = true,
    NO_CUT = true,
    OPEN_DOOR = true,
    TROLL = true,
    UNDEAD = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,6} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,6} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={3,4} },
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 20,
  alertness = 20,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'BEORN_THE_SHAPE_CHANGER',
  name = [[Beorn, the Shape-Changer]],
  display = 'q',
  color = colors.C_D,
  image = 'npc/beorn_the_shape_changer.png',
  desc = [[Beorn is only occasionally seen in human form these days, preferring to appear in the shape of a giant black bear:  he also prefers the company of beasts to that of humans.  He has never taken kindly to strangers, even in human form - and still less when in bear's shape, as he is now.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 6,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 20, 70 },
  ac = 60,
  faction = 'friendlies',
  max_life = 1400,
  rarity = 3,
  level = 28,
  start_level = 28,
  exp_worth = 1000,
  unique = 'BEORN_THE_SHAPE_CHANGER',
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    MALE = true,
    MOVE_BODY = true,
    PET = true,
    SMART = true,
    UNIQUE = true,
  },
  placement_flags = { WILD_MOUNTAIN=true, WILD_TOO=true, WILD_WOOD=true },
  resolvers.mon_inven{ good=true, only_item=true, '2d2' },
  drop = { treasure=20, combat=60, magic=20, tools=0, junk=0 },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={2,10} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={2,10} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={4,8} },
    { type=DamageType.PHYSICAL, method=AttackType.CRUSH, dam={3,6} },
  },
  resolvers.talents {
    [Talents.T_NPC_S_ANIMAL] = 1,
  },
  body = bodies.quadruped,
  speed = 10,
  vision = 25,
  alertness = 25,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'THORONDOR_LORD_OF_EAGLES',
  name = [[Thorondor, Lord of Eagles]],
  display = 'B',
  color = colors.C_u,
  image = 'npc/thorondor_lord_of_eagles.png',
  desc = [[Among the mightiest of birds, Thorondor is the messenger of the Valar, and brings news of Middle-earth to Valinor itself.  Nothing that can be seen from the airs of the world is hidden from him.]],
  corpse_weight = 160,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 85, 12 },
  ac = 65,
  faction = 'friendlies',
  max_life = 1020,
  rarity = 6,
  level = 30,
  start_level = 30,
  exp_worth = 555,
  unique = 'THORONDOR_LORD_OF_EAGLES',
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    CAN_SPEAK = true,
    FLY = true,
    FORCE_MAXHP = true,
    GOOD = true,
    PET = true,
    UNIQUE = true,
  },
  placement_flags = { WILD_MOUNTAIN=true, WILD_ONLY=true, WILD_VOLCANO=true },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={16,2} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={16,2} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={4,10} },
  },
  body = bodies.winged,
  speed = 20,
  vision = 20,
  alertness = 20,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'GIANT_BLUE_ANT',
  name = [[Giant blue ant]],
  display = 'a',
  color = colors.C_b,
  image = 'npc/giant_blue_ant.png',
  desc = [[It is a giant ant that crackles with energy.]],
  corpse_weight = 60,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=25,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 8, 8 },
  ac = 50,
  max_life = resolvers.dice(8, 8),
  rarity = 2,
  level = 30,
  start_level = 30,
  exp_worth = 80,
  resist_dam = {
    [DamageType.ELEC] = true,
  },
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    MORTAL = true,
    WEIRD_MIND = true,
  },
  placement_flags = { WILD_TOO=true },
  drop_corpse = { skeleton=true },
  attacks = {
    { type=DamageType.ELEC, method=AttackType.BITE, dam={5,5} },
  },
  body = bodies.quadruped,
  speed = 0,
  vision = 10,
  alertness = 60,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'GRAVE_WIGHT',
  name = [[Grave wight]],
  display = 'W',
  color = colors.C_b,
  image = 'npc/grave_wight.png',
  desc = [[It is a ghostly form with eyes that haunt you.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=25,
    talent_in = 8,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 12, 10 },
  ac = 50,
  max_life = resolvers.dice(12, 10),
  rarity = 1,
  level = 30,
  start_level = 30,
  exp_worth = 325,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.DARK] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  vuln_dam = {
    [DamageType.LITE] = true,
    [DamageType.LITE_WEAK] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    COLD_BLOOD = true,
    EVIL = true,
    FLY = true,
    FORCE_SLEEP = true,
    NO_CUT = true,
    OPEN_DOOR = true,
    UNDEAD = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ only_item=true, '1d2' },
  drop = { treasure=0, combat=50, magic=50, tools=0, junk=0 },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,7} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,7} },
    { type=DamageType.EXP_20, method=AttackType.TOUCH },
  },
  resolvers.talents {
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_CAUSE_3] = 1,
    [Talents.T_NPC_DARKNESS] = 1,
  },
  body = bodies.none,
  speed = 0,
  vision = 20,
  alertness = 30,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'SHADOW_DRAKE',
  name = [[Shadow drake]],
  display = 'd',
  color = colors.C_G,
  multi_colors = { colors.C_G, colors.C_g },
  image = 'npc/shadow_drake.png',
  desc = [[It is a dragon-like form wrapped in shadow.  Glowing red eyes shine in the dark, and it is surrounded by an aura of unearthly cold that chills the soul rather than the body.]],
  corpse_weight = 1800,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 6,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 30, 10 },
  ac = 70,
  max_life = 300,
  rarity = 3,
  level = 33,
  start_level = 33,
  exp_worth = 1100,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.OLD_SLEEP] = true,
  },
  flags = {
    ATTR_MULTI = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    DRAGON = true,
    EVIL = true,
    FLY = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    INVISIBLE = true,
    OPEN_DOOR = true,
    PASS_WALL = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ only_item=true, '3d2' },
  drop = { treasure=50, combat=50, magic=0, tools=0, junk=0 },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={2,4} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={2,4} },
    { type=DamageType.EXP_10, method=AttackType.BITE, dam={3,6} },
  },
  resolvers.talents {
    [Talents.T_NPC_BR_NETH] = 1,
    [Talents.T_NPC_SLOW] = 1,
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_DARKNESS] = 1,
  },
  body = bodies.dragon,
  speed = 0,
  vision = 20,
  alertness = 70,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'MANTICORE',
  name = [[Manticore]],
  display = 'H',
  color = colors.C_y,
  image = 'npc/manticore.png',
  desc = [[It is a winged lion's body with a human torso and a tail covered in vicious spikes.]],
  corpse_weight = 190,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 5,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 25, 10 },
  ac = 15,
  max_life = 250,
  rarity = 2,
  level = 30,
  start_level = 30,
  exp_worth = 300,
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    EVIL = true,
    FLY = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    MORTAL = true,
  },
  placement_flags = { WILD_TOO=true, WILD_WOOD=true },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={3,4} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={3,4} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={3,4} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={3,4} },
  },
  resolvers.talents {
    [Talents.T_NPC_ARROW_4] = 1,
  },
  body = { MAIN_HAND=1, OFF_HAND=1, BODY=1, CLOAK=1, LAUNCHER=1, QUIVER=1, GLOVES=1, BOOTS=0, HELM=1, RING=2, AMULET=1, LITE=1, TOOL=1, SYMBIOTE=1, INVEN=23 },
  speed = 10,
  vision = 12,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'GIANT_ARMY_ANT',
  name = [[Giant army ant]],
  display = 'a',
  color = colors.C_o,
  image = 'npc/giant_army_ant.png',
  desc = [[An armoured form moving with purpose. Powerful on its own, flee when hordes of them march.]],
  corpse_weight = 60,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=25,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 19, 6 },
  ac = 40,
  max_life = resolvers.dice(19, 6),
  rarity = 3,
  level = 30,
  start_level = 30,
  exp_worth = 90,
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    FRIENDS = true,
    KILL_BODY = true,
    MORTAL = true,
    WEIRD_MIND = true,
  },
  placement_flags = {},
  drop_corpse = { skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={2,12} },
  },
  body = bodies.quadruped,
  speed = 10,
  vision = 10,
  alertness = 40,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'KILLER_SLICER_BEETLE',
  name = [[Killer slicer beetle]],
  display = 'K',
  color = colors.C_y,
  image = 'npc/killer_slicer_beetle.png',
  desc = [[It is a beetle with deadly sharp cutting mandibles and a rock-hard carapace.]],
  corpse_weight = 60,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 25, 10 },
  ac = 60,
  max_life = resolvers.dice(25, 10),
  rarity = 2,
  level = 30,
  start_level = 30,
  exp_worth = 200,
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    FLY = true,
    MORTAL = true,
    WEIRD_MIND = true,
  },
  placement_flags = { WILD_GRASS=true, WILD_TOO=true },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={5,8} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={5,8} },
  },
  body = bodies.quadruped,
  speed = 0,
  vision = 14,
  alertness = 30,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'GORGON',
  name = [[Gorgon]],
  display = 'H',
  color = colors.C_b,
  image = 'npc/gorgon.png',
  desc = [[A bull-like creature whose skin is made of steel plates. Watch out for its deadly breath!]],
  corpse_weight = 300,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 8,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 30, 20 },
  ac = 88,
  max_life = resolvers.dice(30, 20),
  rarity = 2,
  level = 31,
  start_level = 31,
  exp_worth = 275,
  resist_dam = {
    [DamageType.ACID] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    FORCE_SLEEP = true,
    MORTAL = true,
    MOVE_BODY = true,
  },
  placement_flags = { WILD_TOO=true, WILD_WOOD=true },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.BUTT, dam={3,9} },
    { type=DamageType.PHYSICAL, method=AttackType.BUTT, dam={3,9} },
    { type=DamageType.POISON, method=AttackType.BITE, dam={1,10} },
    { type=DamageType.PHYSICAL, method=AttackType.KICK, dam={2,4} },
  },
  resolvers.talents {
    [Talents.T_NPC_BR_POIS] = 1,
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 12,
  alertness = 20,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'GHOST',
  name = [[Ghost]],
  display = 'G',
  color = colors.C_w,
  image = 'npc/ghost.png',
  desc = [[You don't believe in them.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=25,
    talent_in = 15,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 13, 8 },
  ac = 30,
  max_life = resolvers.dice(13, 8),
  rarity = 1,
  level = 31,
  start_level = 31,
  exp_worth = 350,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    COLD_BLOOD = true,
    EVIL = true,
    FLY = true,
    FORCE_SLEEP = true,
    INVISIBLE = true,
    NO_CUT = true,
    PASS_WALL = true,
    TAKE_ITEM = true,
    UNDEAD = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ '1d2', '60%' },
  drop = { treasure=30, combat=40, magic=0, tools=20, junk=10 },
  attacks = {
    { type=DamageType.FEAR, method=AttackType.WAIL },
    { type=DamageType.EXP_20, method=AttackType.TOUCH },
    { type=DamageType.LOSE_INT, method=AttackType.CLAW, dam={1,6} },
    { type=DamageType.LOSE_WIS, method=AttackType.CLAW, dam={1,6} },
  },
  resolvers.talents {
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_HOLD] = 1,
    [Talents.T_NPC_DRAIN_MANA] = 1,
  },
  body = bodies.none,
  speed = 10,
  vision = 20,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'DEATH_WATCH_BEETLE',
  name = [[Death watch beetle]],
  display = 'K',
  color = colors.C_D,
  image = 'npc/death_watch_beetle.png',
  desc = [[It is a giant beetle that produces a chilling sound.]],
  corpse_weight = 80,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 25, 12 },
  ac = 60,
  max_life = resolvers.dice(25, 12),
  rarity = 3,
  level = 31,
  start_level = 31,
  exp_worth = 220,
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    FLY = true,
    MORTAL = true,
    WEIRD_MIND = true,
  },
  placement_flags = { WILD_TOO=true },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={5,4} },
    { type=DamageType.FEAR, method=AttackType.WAIL, dam={5,6} },
  },
  body = bodies.quadruped,
  speed = 0,
  vision = 16,
  alertness = 30,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'MOUNTAIN_OGRE',
  name = [[Mountain ogre]],
  display = 'O',
  color = colors.C_s,
  image = 'npc/mountain_ogre.png',
  desc = [[The largest breed of ogre, he is awesomely strong and awesomely ugly.]],
  corpse_weight = 300,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 40, 9 },
  ac = 33,
  max_life = resolvers.dice(40, 9),
  rarity = 2,
  level = 30,
  start_level = 30,
  exp_worth = 100,
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    EVIL = true,
    FRIENDS = true,
    GIANT = true,
    HAS_LITE = true,
    MORTAL = true,
    OPEN_DOOR = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ '60%' },
  drop = { treasure=20, combat=70, magic=0, tools=10, junk=0 },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={5,8} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={5,8} },
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 20,
  alertness = 30,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'NEXUS_QUYLTHULG',
  name = [[Nexus quylthulg]],
  display = 'Q',
  color = colors.C_v,
  image = 'npc/nexus_quylthulg.png',
  desc = [[It is a very unstable, strange pulsing mound of flesh.]],
  corpse_weight = 300,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 1,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 10, 12 },
  ac = 1,
  max_life = resolvers.dice(10, 12),
  rarity = 1,
  level = 32,
  start_level = 32,
  exp_worth = 300,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.FEAR] = true,
    [DamageType.NEXUS] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.TELEPORT] = true,
  },
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    EMPTY_MIND = true,
    FORCE_SLEEP = true,
    INVISIBLE = true,
    NEVER_BLOW = true,
    NEVER_MOVE = true,
  },
  placement_flags = {},
  resolvers.talents {
    [Talents.T_NPC_BLINK] = 1,
    [Talents.T_NPC_TELE_AWAY] = 1,
  },
  body = bodies.none,
  speed = 0,
  vision = 10,
  alertness = 0,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'SHELOB_SPIDER_OF_DARKNESS',
  name = [[Shelob, Spider of Darkness]],
  display = 'S',
  color = colors.C_D,
  image = 'npc/shelob_spider_of_darkness.png',
  desc = [[Shelob is an enormous bloated spider, the last daughter of Ungoliant the Unlight.  Her poison is legendary, as is her ego.  She normally guards the pass through Cirith Ungol, but occasionally goes out foraging for food to feed her voracious appetite.]],
  corpse_weight = 140,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 4,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 35, 100 },
  ac = 120,
  max_life = 3500,
  level = 55,
  start_level = 55,
  exp_worth = 27000,
  unique = 'SHELOB_SPIDER_OF_DARKNESS',
  resist_dam = {
    [DamageType.ACID] = true,
    [DamageType.DARK] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  vuln_dam = {
    [DamageType.LITE] = true,
    [DamageType.LITE_WEAK] = true,
  },
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    ESCORT = true,
    ESCORTS = true,
    EVIL = true,
    FEMALE = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    SMART = true,
    SPECIAL_GENE = true,
    SPIDER = true,
    UNIQUE = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, only_item=true, randart=true, '1d2', '2d2' },
  drop = { treasure=20, combat=30, magic=40, tools=0, junk=10 },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.POISON, method=AttackType.CLAW, dam={5,6} },
    { type=DamageType.POISON, method=AttackType.CLAW, dam={5,6} },
    { type=DamageType.PARALYZE, method=AttackType.BITE, dam={5,10} },
    { type=DamageType.LOSE_STR, method=AttackType.STING, dam={5,4} },
  },
  resolvers.talents {
    [Talents.T_NPC_HEAL] = 1,
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_SLOW] = 1,
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_CAUSE_3] = 1,
    [Talents.T_NPC_CAUSE_4] = 1,
    [Talents.T_NPC_TRAPS] = 1,
    [Talents.T_NPC_BR_DARK] = 1,
    [Talents.T_NPC_BR_POIS] = 1,
    [Talents.T_NPC_S_SPIDER] = 1,
  },
  body = bodies.quadruped,
  speed = 10,
  vision = 30,
  alertness = 80,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'GIANT_SQUID',
  name = [[Giant squid]],
  self_plural = true,
  display = '~',
  color = colors.C_g,
  image = 'npc/giant_squid.png',
  desc = [[Besides being capable of dragging whole ships underwater, this creature can also harm you with ranged attacks.]],
  corpse_weight = 300,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 8,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 80, 10 },
  ac = 80,
  max_life = 800,
  rarity = 3,
  level = 32,
  start_level = 32,
  exp_worth = 600,
  resist_dam = {
    [DamageType.ACID] = true,
    [DamageType.COLD] = true,
    [DamageType.WATER] = true,
  },
  flags = {
    ANIMAL = true,
    AQUATIC = true,
    BASEANGBAND = true,
    COLD_BLOOD = true,
    FORCE_MAXHP = true,
    MOVE_BODY = true,
  },
  placement_flags = { WILD_OCEAN=true, WILD_TOO=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CRUSH, dam={8,4} },
    { type=DamageType.PHYSICAL, method=AttackType.CRUSH, dam={8,4} },
    { type=DamageType.PHYSICAL, method=AttackType.CRUSH, dam={8,4} },
  },
  resolvers.talents {
    [Talents.T_NPC_BR_ELEC] = 1,
    [Talents.T_NPC_BR_ACID] = 1,
    [Talents.T_NPC_BR_POIS] = 1,
  },
  body = { MAIN_HAND=3, OFF_HAND=3, BODY=0, CLOAK=0, LAUNCHER=1, QUIVER=0, GLOVES=3, BOOTS=0, HELM=1, RING=6, AMULET=1, LITE=0, TOOL=1, SYMBIOTE=0, INVEN=23 },
  speed = 0,
  vision = 8,
  alertness = 80,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'GHOULKING',
  name = [[Ghoulking]],
  display = 'z',
  color = colors.C_D,
  image = 'npc/ghoulking.png',
  desc = [[Flesh is falling off in chunks from this decaying abomination.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 7,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 40, 12 },
  ac = 60,
  max_life = 480,
  rarity = 2,
  level = 32,
  start_level = 32,
  exp_worth = 340,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.DARK] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  vuln_dam = {
    [DamageType.LITE] = true,
    [DamageType.LITE_WEAK] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    CAN_SWIM = true,
    COLD_BLOOD = true,
    ESCORT = true,
    EVIL = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    NO_CUT = true,
    OPEN_DOOR = true,
    UNDEAD = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ '1d2', '60%' },
  drop = { treasure=20, combat=40, magic=30, tools=0, junk=10 },
  attacks = {
    { type=DamageType.LOSE_STR, method=AttackType.CLAW, dam={3,4} },
    { type=DamageType.DISEASE, method=AttackType.CLAW, dam={3,4} },
    { type=DamageType.DISEASE, method=AttackType.CLAW, dam={3,4} },
    { type=DamageType.PARALYZE, method=AttackType.BITE, dam={3,5} },
  },
  resolvers.talents {
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_HOLD] = 1,
    [Talents.T_NPC_DARKNESS] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_S_UNDEAD] = 1,
    [Talents.T_NPC_ANIM_DEAD] = 1,
  },
  body = bodies.humanoid,
  speed = 10,
  vision = 20,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'DOOMBAT',
  name = [[Doombat]],
  display = 'b',
  color = colors.C_R,
  image = 'npc/doombat.png',
  desc = [[It is a fast moving creature of chaos, a gigantic black bat surrounded by flickering bright red flames.]],
  corpse_weight = 15,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 24, 14 },
  ac = 75,
  max_life = resolvers.dice(24, 14),
  rarity = 2,
  level = 32,
  start_level = 32,
  exp_worth = 250,
  resist_dam = {
    [DamageType.FIRE] = true,
  },
  melee_retal = {
    [DamageType.FIRE] = 'mondam',
  },
  flags = {
    AI_ANNOY = true,
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    FLY = true,
    MORTAL = true,
    WEIRD_MIND = true,
  },
  placement_flags = {},
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.FIRE, method=AttackType.BITE, dam={5,4} },
    { type=DamageType.FIRE, method=AttackType.BITE, dam={5,4} },
    { type=DamageType.FIRE, method=AttackType.BITE, dam={5,4} },
  },
  body = bodies.winged,
  speed = 10,
  vision = 16,
  alertness = 30,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'NINJA',
  name = [[Ninja]],
  self_plural = true,
  display = 'p',
  color = colors.C_u,
  image = 'npc/ninja.png',
  desc = [[A humanoid clothed in black who moves with blinding speed.]],
  corpse_weight = 160,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 13, 12 },
  ac = 60,
  max_life = resolvers.dice(13, 12),
  rarity = 2,
  level = 32,
  start_level = 32,
  exp_worth = 300,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.OLD_SLEEP] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    EVIL = true,
    HAS_LITE = true,
    MALE = true,
    MORTAL = true,
    OPEN_DOOR = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ '1d2' },
  drop = { treasure=0, combat=100, magic=0, tools=0, junk=0 },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.POISON, method=AttackType.HIT, dam={3,4} },
    { type=DamageType.LOSE_STR, method=AttackType.HIT, dam={3,4} },
    { type=DamageType.LOSE_STR, method=AttackType.HIT, dam={3,4} },
  },
  body = bodies.humanoid,
  speed = 10,
  vision = 20,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'MEMORY_MOSS',
  name = [[Memory moss]],
  display = ',',
  color = colors.C_b,
  image = 'npc/memory_moss.png',
  desc = [[A mass of vegetation. You don't remember seeing anything like it before.]],
  corpse_weight = 5,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 6,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 1, 2 },
  ac = 1,
  max_life = resolvers.dice(1, 2),
  rarity = 3,
  level = 32,
  start_level = 32,
  exp_worth = 150,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.FEAR] = true,
    [DamageType.OLD_SLEEP] = true,
  },
  flags = {
    BASEANGBAND = true,
    EMPTY_MIND = true,
    FORCE_SLEEP = true,
    MORTAL = true,
    NEVER_MOVE = true,
    NO_CUT = true,
    STUPID = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.CONFUSION, method=AttackType.HIT, dam={1,4} },
    { type=DamageType.CONFUSION, method=AttackType.HIT, dam={1,4} },
  },
  resolvers.talents {
    [Talents.T_NPC_FORGET] = 1,
  },
  body = bodies.none,
  speed = 0,
  vision = 30,
  alertness = 5,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'STORM_GIANT',
  name = [[Storm giant]],
  display = 'P',
  color = colors.C_B,
  image = 'npc/storm_giant.png',
  desc = [[It is a twenty-five foot tall giant wreathed in lightning.]],
  corpse_weight = 1300,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 8,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 40, 20 },
  ac = 60,
  max_life = 800,
  rarity = 1,
  level = 40,
  start_level = 40,
  exp_worth = 1000,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.ELEC] = true,
  },
  melee_retal = {
    [DamageType.ELEC] = 'mondam',
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    EVIL = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    GIANT = true,
    HAS_LITE = true,
    MALE = true,
    OPEN_DOOR = true,
    TAKE_ITEM = true,
  },
  placement_flags = { WILD_MOUNTAIN=true, WILD_TOO=true },
  resolvers.mon_inven{ '1d2' },
  drop = { treasure=10, combat=90, magic=0, tools=0, junk=0 },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.ELEC, method=AttackType.HIT, dam={10,8} },
    { type=DamageType.ELEC, method=AttackType.HIT, dam={10,8} },
  },
  resolvers.talents {
    [Talents.T_NPC_BLINK] = 1,
    [Talents.T_NPC_TELE_TO] = 1,
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_BO_ELEC] = 1,
    [Talents.T_NPC_BA_ELEC] = 1,
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 20,
  alertness = 40,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'SPECTATOR',
  name = [[Spectator]],
  display = 'e',
  color = colors.C_B,
  image = 'npc/spectator.png',
  desc = [[A lesser relative of the beholder: a globular body with a large toothy mouth, a large central eye, and four smaller eyes on stalks protruding from the top of its body.]],
  corpse_weight = 160,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 6,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 15, 13 },
  ac = 1,
  max_life = 195,
  rarity = 2,
  level = 28,
  start_level = 28,
  exp_worth = 150,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.FEAR] = true,
    [DamageType.OLD_SLEEP] = true,
  },
  flags = {
    BASEANGBAND = true,
    EMPTY_MIND = true,
    FLY = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    MORTAL = true,
    STUPID = true,
  },
  placement_flags = {},
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PARALYZE, method=AttackType.GAZE, dam={1,4} },
    { type=DamageType.CONFUSION, method=AttackType.GAZE, dam={1,4} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={1,8} },
  },
  resolvers.talents {
    [Talents.T_NPC_FORGET] = 1,
    [Talents.T_NPC_CAUSE_2] = 1,
    [Talents.T_NPC_HOLD] = 1,
    [Talents.T_NPC_SLOW] = 1,
  },
  body = bodies.none,
  speed = 0,
  vision = 30,
  alertness = 5,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'HALF_TROLL',
  name = [[Half-troll]],
  display = 'T',
  color = colors.C_U,
  image = 'npc/half_troll.png',
  desc = [[A huge, ugly, half-human in search of plunder.]],
  corpse_weight = 300,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 25, 14 },
  ac = 50,
  max_life = resolvers.dice(25, 14),
  rarity = 2,
  level = 34,
  start_level = 34,
  exp_worth = 400,
  resist_dam = {
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    EVIL = true,
    FRIENDS = true,
    MALE = true,
    OPEN_DOOR = true,
    REGENERATE = true,
    TROLL = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ only_item=true, '90%' },
  drop = { treasure=20, combat=80, magic=0, tools=0, junk=0 },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={1,5} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={1,5} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={2,6} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={2,6} },
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 20,
  alertness = 50,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'BERT_THE_STONE_TROLL',
  name = [[Bert the Stone Troll]],
  display = 'T',
  color = colors.C_W,
  image = 'npc/bert_the_stone_troll.png',
  desc = [[Big, brawny, powerful and with a taste for hobbit. He has friends called Bill and Tom.]],
  corpse_weight = 500,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 11, 100 },
  ac = 70,
  max_life = 1100,
  level = 34,
  start_level = 34,
  exp_worth = 2000,
  unique = 'BERT_THE_STONE_TROLL',
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.DARK] = true,
    [DamageType.POISON] = true,
  },
  vuln_dam = {
    [DamageType.KILL_WALL] = true,
    [DamageType.LITE] = true,
    [DamageType.LITE_WEAK] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    ESCORT = true,
    EVIL = true,
    FORCE_MAXHP = true,
    MALE = true,
    MOVE_BODY = true,
    NO_CUT = true,
    OPEN_DOOR = true,
    REGENERATE = true,
    SPECIAL_GENE = true,
    TAKE_ITEM = true,
    TROLL = true,
    UNIQUE = true,
  },
  placement_flags = { WILD_TOO=true, WILD_WOOD=true },
  resolvers.mon_inven{ good=true, only_item=true, '1d2' },
  drop = { treasure=0, combat=100, magic=0, tools=0, junk=0 },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={6,6} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={6,6} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={3,10} },
  },
  body = bodies.humanoid,
  speed = 10,
  vision = 20,
  alertness = 50,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'BILL_THE_STONE_TROLL',
  name = [[Bill the Stone Troll]],
  display = 'T',
  color = colors.C_W,
  image = 'npc/bill_the_stone_troll.png',
  desc = [[Big, brawny, powerful and with a taste for hobbit. He has friends called Bert and Tom.]],
  corpse_weight = 500,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 11, 100 },
  ac = 70,
  max_life = 1100,
  level = 34,
  start_level = 34,
  exp_worth = 2000,
  unique = 'BILL_THE_STONE_TROLL',
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.DARK] = true,
    [DamageType.POISON] = true,
  },
  vuln_dam = {
    [DamageType.KILL_WALL] = true,
    [DamageType.LITE] = true,
    [DamageType.LITE_WEAK] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    ESCORT = true,
    EVIL = true,
    FORCE_MAXHP = true,
    MALE = true,
    MOVE_BODY = true,
    NO_CUT = true,
    OPEN_DOOR = true,
    REGENERATE = true,
    SPECIAL_GENE = true,
    TAKE_ITEM = true,
    TROLL = true,
    UNIQUE = true,
  },
  placement_flags = { WILD_TOO=true, WILD_WOOD=true },
  resolvers.mon_inven{ good=true, only_item=true, '1d2' },
  drop = { treasure=0, combat=100, magic=0, tools=0, junk=0 },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={6,6} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={6,6} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={3,10} },
  },
  body = bodies.humanoid,
  speed = 10,
  vision = 20,
  alertness = 50,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'TOM_THE_STONE_TROLL',
  name = [[Tom the Stone Troll]],
  display = 'T',
  color = colors.C_W,
  image = 'npc/tom_the_stone_troll.png',
  desc = [[Big, brawny, powerful and with a taste for hobbit. He has friends called Bert and Bill.]],
  corpse_weight = 500,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 11, 100 },
  ac = 70,
  max_life = 1100,
  level = 34,
  start_level = 34,
  exp_worth = 2000,
  unique = 'TOM_THE_STONE_TROLL',
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.DARK] = true,
    [DamageType.POISON] = true,
  },
  vuln_dam = {
    [DamageType.KILL_WALL] = true,
    [DamageType.LITE] = true,
    [DamageType.LITE_WEAK] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    ESCORT = true,
    EVIL = true,
    FORCE_MAXHP = true,
    MALE = true,
    MOVE_BODY = true,
    NO_CUT = true,
    OPEN_DOOR = true,
    REGENERATE = true,
    SPECIAL_GENE = true,
    TAKE_ITEM = true,
    TROLL = true,
    UNIQUE = true,
  },
  placement_flags = { WILD_TOO=true, WILD_WOOD=true },
  resolvers.mon_inven{ good=true, only_item=true, '1d2' },
  drop = { treasure=0, combat=100, magic=0, tools=0, junk=0 },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={6,6} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={6,6} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={3,10} },
  },
  body = bodies.humanoid,
  speed = 10,
  vision = 20,
  alertness = 50,
  resolvers.mon_global_speed(),
  -- BEGIN VERBATIM
  drop_special = function(self) return game.zone:makeEntityByName(game.level, 'artifact', 'GLAMDRING', false) end,
  -- END VERBATIM
}

newEntity {
  define_as = 'CAVE_TROLL',
  name = [[Cave troll]],
  display = 'T',
  color = colors.C_u,
  image = 'npc/cave_troll.png',
  desc = [[He is a vicious monster, feared for his ferocity.]],
  corpse_weight = 600,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 24, 12 },
  ac = 50,
  max_life = resolvers.dice(24, 12),
  rarity = 1,
  level = 33,
  start_level = 33,
  exp_worth = 350,
  resist_dam = {
    [DamageType.DARK] = true,
    [DamageType.POISON] = true,
  },
  vuln_dam = {
    [DamageType.FIRE] = true,
    [DamageType.LITE] = true,
    [DamageType.LITE_WEAK] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    EVIL = true,
    FRIENDS = true,
    MALE = true,
    OPEN_DOOR = true,
    REGENERATE = true,
    TROLL = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ '60%' },
  drop = { treasure=20, combat=80, magic=0, tools=0, junk=0 },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={3,5} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={3,5} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={1,8} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={1,8} },
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 20,
  alertness = 50,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'BARROW_WIGHT',
  name = [[Barrow wight]],
  display = 'W',
  color = colors.C_v,
  image = 'npc/barrow_wight.png',
  desc = [[It is a ghostly nightmare of an entity.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 8,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 15, 10 },
  ac = 40,
  max_life = resolvers.dice(15, 10),
  rarity = 3,
  level = 33,
  start_level = 33,
  exp_worth = 375,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.DARK] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  vuln_dam = {
    [DamageType.LITE] = true,
    [DamageType.LITE_WEAK] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    COLD_BLOOD = true,
    EVIL = true,
    FLY = true,
    FORCE_SLEEP = true,
    FRIENDS = true,
    NO_CUT = true,
    OPEN_DOOR = true,
    UNDEAD = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ '60%' },
  drop = { treasure=0, combat=50, magic=50, tools=0, junk=0 },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,8} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,8} },
    { type=DamageType.EXP_40, method=AttackType.TOUCH },
  },
  resolvers.talents {
    [Talents.T_NPC_HOLD] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_CAUSE_2] = 1,
    [Talents.T_NPC_DARKNESS] = 1,
  },
  body = bodies.none,
  speed = 0,
  vision = 20,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'SKELETON_ETTIN',
  name = [[Skeleton ettin]],
  display = 's',
  color = colors.C_W,
  image = 'npc/skeleton_ettin.png',
  desc = [[It is the animated skeleton of a massive two-headed troll.]],
  corpse_weight = 700,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 45, 10 },
  ac = 50,
  max_life = 450,
  rarity = 1,
  level = 33,
  start_level = 33,
  exp_worth = 325,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.FEAR] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    COLD_BLOOD = true,
    EMPTY_MIND = true,
    EVIL = true,
    FORCE_MAXHP = true,
    NO_CUT = true,
    OPEN_DOOR = true,
    TROLL = true,
    UNDEAD = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,9} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,9} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={1,5} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={1,5} },
  },
  body = { MAIN_HAND=1, OFF_HAND=1, BODY=1, CLOAK=1, LAUNCHER=1, QUIVER=1, GLOVES=1, BOOTS=1, HELM=2, RING=2, AMULET=2, LITE=1, TOOL=1, SYMBIOTE=1, INVEN=23 },
  speed = 0,
  vision = 20,
  alertness = 20,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'CHAOS_DRAKE',
  name = [[Chaos drake]],
  display = 'd',
  color = colors.C_v,
  image = 'npc/chaos_drake.png',
  desc = [[A dragon twisted by the forces of chaos. It seems first ugly, then fair, as its form shimmers and changes in front of your eyes.]],
  corpse_weight = 1800,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 6,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 50, 10 },
  ac = 70,
  max_life = 500,
  rarity = 3,
  level = 33,
  start_level = 33,
  exp_worth = 1400,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.DISEASE] = true,
    [DamageType.FIRE] = true,
    [DamageType.OLD_SLEEP] = true,
  },
  flags = {
    ATTR_ANY = true,
    ATTR_MULTI = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    DRAGON = true,
    EVIL = true,
    FLY = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    HAS_LITE = true,
    OPEN_DOOR = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ only_item=true, '3d2' },
  drop = { treasure=50, combat=50, magic=0, tools=0, junk=0 },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={2,4} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={2,4} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={3,6} },
  },
  resolvers.talents {
    [Talents.T_NPC_SLOW] = 1,
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_BR_DISE] = 1,
    [Talents.T_NPC_BR_CHAO] = 1,
  },
  body = bodies.dragon,
  speed = 0,
  vision = 20,
  alertness = 70,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'LAW_DRAKE',
  name = [[Law drake]],
  display = 'd',
  color = colors.C_B,
  multi_colors = { colors.C_y, colors.C_u },
  image = 'npc/law_drake.png',
  desc = [[This dragon is clever and cunning. It laughs at your puny efforts to disturb it.]],
  corpse_weight = 1800,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 6,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 50, 10 },
  ac = 70,
  max_life = 500,
  rarity = 3,
  level = 33,
  start_level = 33,
  exp_worth = 1400,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.OLD_SLEEP] = true,
  },
  flags = {
    ATTR_MULTI = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    DRAGON = true,
    EVIL = true,
    FLY = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    HAS_LITE = true,
    NO_CUT = true,
    OPEN_DOOR = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ only_item=true, '3d2' },
  drop = { treasure=50, combat=50, magic=0, tools=0, junk=0 },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={2,4} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={2,4} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={3,6} },
  },
  resolvers.talents {
    [Talents.T_NPC_SLOW] = 1,
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_BR_SOUN] = 1,
    [Talents.T_NPC_BR_SHAR] = 1,
  },
  body = bodies.dragon,
  speed = 0,
  vision = 20,
  alertness = 70,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'BALANCE_DRAKE',
  name = [[Balance drake]],
  display = 'd',
  color = colors.C_v,
  image = 'npc/balance_drake.png',
  desc = [[A mighty dragon, the balance drake seeks to maintain the Cosmic Balance, and despises your feeble efforts to destroy evil.]],
  corpse_weight = 1800,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 6,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 60, 10 },
  ac = 70,
  max_life = 600,
  rarity = 3,
  level = 33,
  start_level = 33,
  exp_worth = 1600,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.DISEASE] = true,
    [DamageType.FIRE] = true,
    [DamageType.OLD_SLEEP] = true,
  },
  flags = {
    ATTR_MULTI = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    DRAGON = true,
    EVIL = true,
    FLY = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    HAS_LITE = true,
    NO_CUT = true,
    OPEN_DOOR = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ only_item=true, '3d2' },
  drop = { treasure=50, combat=50, magic=0, tools=0, junk=0 },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={2,4} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={2,4} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={3,6} },
  },
  resolvers.talents {
    [Talents.T_NPC_SLOW] = 1,
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_BR_SOUN] = 1,
    [Talents.T_NPC_BR_SHAR] = 1,
    [Talents.T_NPC_BR_DISE] = 1,
    [Talents.T_NPC_BR_CHAO] = 1,
  },
  body = bodies.dragon,
  speed = 0,
  vision = 20,
  alertness = 70,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'ETHEREAL_DRAKE',
  name = [[Ethereal drake]],
  display = 'd',
  color = colors.C_o,
  multi_colors = { colors.C_y, colors.C_D, colors.C_U },
  image = 'npc/ethereal_drake.png',
  desc = [[A dragon of great power with control over light and dark, the ethereal drake's eyes glare with white hatred from the shadows.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 6,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 40, 10 },
  ac = 70,
  max_life = 400,
  rarity = 3,
  level = 33,
  start_level = 33,
  exp_worth = 1200,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.OLD_SLEEP] = true,
  },
  flags = {
    ATTR_MULTI = true,
    BASEANGBAND = true,
    DRAGON = true,
    EVIL = true,
    FLY = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    INVISIBLE = true,
    PASS_WALL = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ only_item=true, '3d2' },
  drop = { treasure=40, combat=50, magic=10, tools=0, junk=0 },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={2,4} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={2,4} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={3,6} },
  },
  resolvers.talents {
    [Talents.T_NPC_SLOW] = 1,
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_BR_LITE] = 1,
    [Talents.T_NPC_BR_DARK] = 1,
    [Talents.T_NPC_BR_CONF] = 1,
  },
  body = bodies.dragon,
  speed = 0,
  vision = 20,
  alertness = 70,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'FASOLT_THE_GIANT',
  name = [[Fasolt the Giant]],
  display = 'P',
  color = colors.C_u,
  image = 'npc/fasolt_the_giant.png',
  desc = [[Big, brawny, powerful and with a greed for gold.]],
  corpse_weight = 1000,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 11, 111 },
  ac = 70,
  max_life = 1221,
  rarity = 4,
  level = 33,
  start_level = 33,
  exp_worth = 2000,
  unique = 'FASOLT_THE_GIANT',
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    CAN_SPEAK = true,
    ESCORT = true,
    EVIL = true,
    FORCE_MAXHP = true,
    GIANT = true,
    HAS_LITE = true,
    MALE = true,
    OPEN_DOOR = true,
    TAKE_ITEM = true,
    UNIQUE = true,
  },
  placement_flags = { WILD_TOO=true },
  resolvers.mon_inven{ good=true, only_item=true, '1d2' },
  drop = { treasure=0, combat=100, magic=0, tools=0, junk=0 },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={7,10} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={7,10} },
    { type=DamageType.EAT_GOLD, method=AttackType.HIT, dam={2,10} },
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 20,
  alertness = 50,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'SHADE',
  name = [[Shade]],
  display = 'G',
  color = colors.C_D,
  image = 'npc/shade.png',
  desc = [[A shadowy form clutches at you from the darkness. A powerful undead with a deadly touch.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=25,
    talent_in = 15,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 14, 20 },
  ac = 30,
  max_life = resolvers.dice(14, 20),
  rarity = 3,
  level = 33,
  start_level = 33,
  exp_worth = 350,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    COLD_BLOOD = true,
    EVIL = true,
    FLY = true,
    FORCE_SLEEP = true,
    INVISIBLE = true,
    NO_CUT = true,
    PASS_WALL = true,
    TAKE_ITEM = true,
    UNDEAD = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ only_item=true, '2d2', '90%' },
  drop = { treasure=0, combat=0, magic=100, tools=0, junk=0 },
  attacks = {
    { type=DamageType.FEAR, method=AttackType.WAIL },
    { type=DamageType.EXP_40, method=AttackType.TOUCH },
    { type=DamageType.LOSE_INT, method=AttackType.CLAW, dam={1,10} },
  },
  resolvers.talents {
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_HOLD] = 1,
    [Talents.T_NPC_DRAIN_MANA] = 1,
    [Talents.T_NPC_FORGET] = 1,
  },
  body = bodies.none,
  speed = 10,
  vision = 20,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'SPECTRE',
  name = [[Spectre]],
  display = 'G',
  color = colors.C_U,
  image = 'npc/spectre.png',
  desc = [[A phantasmal shrieking spirit. Its wail drives the intense cold of pure evil deep within your body.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=25,
    talent_in = 15,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 14, 20 },
  ac = 30,
  max_life = resolvers.dice(14, 20),
  rarity = 3,
  level = 33,
  start_level = 33,
  exp_worth = 350,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    COLD_BLOOD = true,
    EVIL = true,
    FLY = true,
    FORCE_SLEEP = true,
    NO_CUT = true,
    PASS_WALL = true,
    TAKE_ITEM = true,
    UNDEAD = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ only_item=true, '2d2', '90%' },
  drop = { treasure=0, combat=0, magic=100, tools=0, junk=0 },
  attacks = {
    { type=DamageType.FEAR, method=AttackType.WAIL },
    { type=DamageType.EXP_40, method=AttackType.TOUCH },
    { type=DamageType.LOSE_WIS, method=AttackType.CLAW, dam={5,5} },
  },
  resolvers.talents {
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_HOLD] = 1,
    [Talents.T_NPC_DRAIN_MANA] = 1,
    [Talents.T_NPC_FORGET] = 1,
  },
  body = bodies.none,
  speed = 10,
  vision = 20,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'WATER_TROLL',
  name = [[Water troll]],
  display = 'T',
  color = colors.C_B,
  image = 'npc/water_troll.png',
  desc = [[He is a troll that reeks of brackish water and mud.]],
  corpse_weight = 400,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 36, 10 },
  ac = 50,
  max_life = 360,
  rarity = 1,
  level = 35,
  start_level = 35,
  exp_worth = 420,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.DARK] = true,
    [DamageType.POISON] = true,
  },
  vuln_dam = {
    [DamageType.LITE] = true,
    [DamageType.LITE_WEAK] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    CAN_SWIM = true,
    EVIL = true,
    FORCE_MAXHP = true,
    FRIENDS = true,
    MALE = true,
    OPEN_DOOR = true,
    REGENERATE = true,
    TROLL = true,
  },
  placement_flags = { WILD_SHORE=true, WILD_SWAMP=true, WILD_TOO=true },
  resolvers.mon_inven{ '60%' },
  drop = { treasure=0, combat=100, magic=0, tools=0, junk=0 },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,9} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,9} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={2,2} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={2,2} },
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 20,
  alertness = 50,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'FIRE_ELEMENTAL',
  name = [[Fire elemental]],
  display = 'E',
  color = colors.C_r,
  image = 'npc/fire_elemental.png',
  desc = [[It is a towering inferno of flames.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=25,
    talent_in = 6,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 30, 8 },
  ac = 50,
  max_life = resolvers.dice(30, 8),
  rarity = 2,
  level = 33,
  start_level = 33,
  exp_worth = 350,
  resist_dam = {
    [DamageType.ACID] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.ELEC] = true,
    [DamageType.FEAR] = true,
    [DamageType.FIRE] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  melee_retal = {
    [DamageType.FIRE] = 'mondam',
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    EMPTY_MIND = true,
    FLY = true,
    FORCE_SLEEP = true,
    HAS_LITE = true,
    KILL_BODY = true,
    KILL_ITEM = true,
    NO_CUT = true,
    POWERFUL = true,
  },
  placement_flags = { WILD_TOO=true, WILD_VOLCANO=true },
  attacks = {
    { type=DamageType.FIRE, method=AttackType.HIT, dam={4,6} },
    { type=DamageType.FIRE, method=AttackType.HIT, dam={4,6} },
  },
  resolvers.talents {
    [Talents.T_NPC_BO_FIRE] = 1,
  },
  body = bodies.none,
  speed = 0,
  vision = 12,
  alertness = 50,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'CHERUB',
  name = [[Cherub]],
  plural_name = [[Cherubim]],
  display = 'A',
  color = colors.C_G,
  image = 'npc/cherub.png',
  desc = [[It is an angel moving very quickly, wielding a holy war hammer and casting a volley of powerful spells in your direction.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 3,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 100, 10 },
  ac = 68,
  faction = 'eru_manwe',
  max_life = 1000,
  rarity = 4,
  level = 39,
  start_level = 39,
  exp_worth = 2700,
  resist_dam = {
    [DamageType.ACID] = true,
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.ELEC] = true,
    [DamageType.FEAR] = true,
    [DamageType.FIRE] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
    [DamageType.TELEPORT] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    FLY = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    GOOD = true,
    HAS_LITE = true,
    MOVE_BODY = true,
    OPEN_DOOR = true,
    POWERFUL = true,
    REFLECTING = true,
    SMART = true,
    TAKE_ITEM = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ only_item=true, '1d2', '2d2' },
  drop = { treasure=0, combat=90, magic=10, tools=0, junk=0 },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={4,3} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={3,8} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={4,3} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={3,8} },
  },
  resolvers.talents {
    [Talents.T_NPC_HEAL] = 1,
    [Talents.T_NPC_HASTE] = 1,
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_MIND_BLAST] = 1,
    [Talents.T_NPC_BO_FIRE] = 1,
    [Talents.T_NPC_S_MONSTERS] = 1,
  },
  body = bodies.humanoid,
  speed = 10,
  vision = 30,
  alertness = 255,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'WATER_ELEMENTAL',
  name = [[Water elemental]],
  display = 'E',
  color = colors.C_b,
  image = 'npc/water_elemental.png',
  desc = [[It is a towering tempest of water.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=25,
    talent_in = 6,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 25, 8 },
  ac = 40,
  max_life = resolvers.dice(25, 8),
  rarity = 2,
  level = 33,
  start_level = 33,
  exp_worth = 325,
  resist_dam = {
    [DamageType.ACID] = true,
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.FEAR] = true,
    [DamageType.FIRE] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    COLD_BLOOD = true,
    EMPTY_MIND = true,
    FLY = true,
    FORCE_SLEEP = true,
    KILL_BODY = true,
    KILL_ITEM = true,
    NO_CUT = true,
    POWERFUL = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,10} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,10} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,10} },
  },
  resolvers.talents {
    [Talents.T_NPC_BO_COLD] = 1,
  },
  body = bodies.none,
  speed = 0,
  vision = 12,
  alertness = 50,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'MULTI_HUED_HOUND',
  name = [[Multi-hued hound]],
  display = 'Z',
  color = colors.C_v,
  multi_colors = { colors.C_d, colors.C_g, colors.C_w, colors.C_r, colors.C_b },
  image = 'npc/multi_hued_hound.png',
  desc = [[Shimmering in rainbow hues, this hound is beautiful and deadly.]],
  corpse_weight = 60,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 5,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 30, 10 },
  ac = 40,
  max_life = resolvers.dice(30, 10),
  rarity = 3,
  level = 33,
  start_level = 33,
  exp_worth = 600,
  resist_dam = {
    [DamageType.ACID] = true,
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.ELEC] = true,
    [DamageType.FIRE] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    ANIMAL = true,
    ATTR_MULTI = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    FORCE_SLEEP = true,
    FRIENDS = true,
    HAS_LITE = true,
    MORTAL = true,
  },
  placement_flags = {},
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={2,8} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={2,8} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={4,4} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={4,4} },
  },
  resolvers.talents {
    [Talents.T_NPC_BR_ACID] = 1,
    [Talents.T_NPC_BR_POIS] = 1,
    [Talents.T_NPC_BR_COLD] = 1,
    [Talents.T_NPC_BR_FIRE] = 1,
    [Talents.T_NPC_BR_ELEC] = 1,
  },
  body = bodies.quadruped,
  speed = 0,
  vision = 25,
  alertness = 0,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'INVISIBLE_STALKER',
  name = [[Invisible stalker]],
  display = 'E',
  color = colors.C_y,
  image = 'npc/invisible_stalker.png',
  desc = [[It is impossible to define its form but its violence is legendary.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=50,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 19, 12 },
  ac = 46,
  max_life = resolvers.dice(19, 12),
  rarity = 3,
  level = 35,
  start_level = 35,
  exp_worth = 300,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.ELEC] = true,
    [DamageType.FEAR] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
    [DamageType.TELEPORT] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    COLD_BLOOD = true,
    EMPTY_MIND = true,
    EVIL = true,
    INVISIBLE = true,
    NONLIVING = true,
    NO_CUT = true,
    OPEN_DOOR = true,
    POWERFUL = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,6} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,6} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,6} },
  },
  body = bodies.none,
  speed = 20,
  vision = 20,
  alertness = 20,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'CARRION_CRAWLER_GRP',
  name = [[Carrion crawler]],
  display = 'c',
  color = colors.C_o,
  image = 'npc/carrion_crawler_grp.png',
  desc = [[A hideous centipede covered in slime and with glowing tentacles around its head.]],
  corpse_weight = 200,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=25,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 20, 12 },
  ac = 40,
  max_life = resolvers.dice(20, 12),
  rarity = 2,
  level = 34,
  start_level = 34,
  exp_worth = 100,
  resist_dam = {
    [DamageType.POISON] = true,
  },
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    FRIENDS = true,
    MORTAL = true,
    WEIRD_MIND = true,
  },
  placement_flags = {},
  drop_corpse = { skeleton=true },
  attacks = {
    { type=DamageType.PARALYZE, method=AttackType.STING, dam={2,6} },
    { type=DamageType.PARALYZE, method=AttackType.STING, dam={2,6} },
  },
  body = bodies.snake,
  speed = 0,
  vision = 15,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'MASTER_THIEF',
  name = [[Master thief]],
  plural_name = [[Master thieves]],
  display = 'p',
  color = colors.C_b,
  image = 'npc/master_thief.png',
  desc = [[Cool and confident, fast and lithe; protect your possessions quickly!]],
  corpse_weight = 130,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 6,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 18, 10 },
  ac = 30,
  max_life = resolvers.dice(18, 10),
  rarity = 2,
  level = 34,
  start_level = 34,
  exp_worth = 350,
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    EVIL = true,
    HAS_LITE = true,
    MALE = true,
    MORTAL = true,
    OPEN_DOOR = true,
    TAKE_ITEM = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ '2d2', '90%' },
  drop = { treasure=90, combat=10, magic=0, tools=0, junk=0 },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={2,8} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={3,4} },
    { type=DamageType.EAT_GOLD, method=AttackType.HIT, dam={4,4} },
    { type=DamageType.EAT_ITEM, method=AttackType.HIT, dam={4,5} },
  },
  resolvers.talents {
    [Talents.T_NPC_TRAPS] = 1,
    [Talents.T_NPC_ARROW_2] = 1,
    [Talents.T_NPC_BLINK] = 1,
  },
  body = bodies.humanoid,
  speed = 20,
  vision = 20,
  alertness = 40,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'THE_WATCHER_IN_THE_WATER',
  name = [[The Watcher in the Water]],
  display = '~',
  color = colors.C_v,
  image = 'npc/the_watcher_in_the_water.png',
  desc = [[A vile creature which seems to consist mostly of tentacles, it seeks to drag people to their doom in the water.  Few have ever escaped its grasp.]],
  corpse_weight = 700,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 5,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 27, 100 },
  ac = 100,
  max_life = 2700,
  level = 45,
  start_level = 45,
  exp_worth = 12000,
  unique = 'THE_WATCHER_IN_THE_WATER',
  resist_dam = {
    [DamageType.ACID] = true,
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.FEAR] = true,
    [DamageType.POISON] = true,
    [DamageType.TELEPORT] = true,
    [DamageType.WATER] = true,
  },
  flags = {
    ANIMAL = true,
    AQUATIC = true,
    BASEANGBAND = true,
    CAN_SWIM = true,
    COLD_BLOOD = true,
    EVIL = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    SPECIAL_GENE = true,
    UNIQUE = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, only_item=true, randart=true, '1d2', '4d2' },
  drop = { treasure=50, combat=50, magic=0, tools=0, junk=0 },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.ACID, method=AttackType.CRUSH, dam={8,8} },
    { type=DamageType.POISON, method=AttackType.CRUSH, dam={8,8} },
    { type=DamageType.PARALYZE, method=AttackType.CRUSH, dam={8,8} },
  },
  resolvers.talents {
    [Talents.T_NPC_BA_WATE] = 1,
    [Talents.T_NPC_BO_WATE] = 1,
    [Talents.T_NPC_HOLD] = 1,
    [Talents.T_NPC_BR_POIS] = 1,
    [Talents.T_NPC_BO_ICEE] = 1,
    [Talents.T_NPC_TELE_TO] = 1,
  },
  body = { MAIN_HAND=3, OFF_HAND=3, BODY=0, CLOAK=0, LAUNCHER=1, QUIVER=0, GLOVES=3, BOOTS=0, HELM=1, RING=6, AMULET=1, LITE=0, TOOL=1, SYMBIOTE=0, INVEN=23 },
  speed = 10,
  vision = 30,
  alertness = 80,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'LICH',
  name = [[Lich]],
  display = 'L',
  color = colors.C_o,
  image = 'npc/lich.png',
  desc = [[It is a skeletal form dressed in robes. It radiates vastly evil power.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 4,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 30, 10 },
  ac = 60,
  max_life = 300,
  rarity = 2,
  level = 34,
  start_level = 34,
  exp_worth = 1000,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.DARK] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  vuln_dam = {
    [DamageType.LITE] = true,
    [DamageType.LITE_WEAK] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    COLD_BLOOD = true,
    EVIL = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    NO_CUT = true,
    OPEN_DOOR = true,
    SMART = true,
    UNDEAD = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ '1d2' },
  drop = { treasure=0, combat=10, magic=90, tools=0, junk=0 },
  attacks = {
    { type=DamageType.EXP_40, method=AttackType.TOUCH },
    { type=DamageType.UN_POWER, method=AttackType.TOUCH },
    { type=DamageType.LOSE_DEX, method=AttackType.TOUCH, dam={2,8} },
    { type=DamageType.LOSE_DEX, method=AttackType.TOUCH, dam={2,8} },
  },
  resolvers.talents {
    [Talents.T_NPC_BLINK] = 1,
    [Talents.T_NPC_TELE_TO] = 1,
    [Talents.T_NPC_TELE_AWAY] = 1,
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_HOLD] = 1,
    [Talents.T_NPC_SLOW] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_CAUSE_3] = 1,
    [Talents.T_NPC_DRAIN_MANA] = 1,
    [Talents.T_NPC_BRAIN_SMASH] = 1,
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 20,
  alertness = 60,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'GAS_SPORE',
  name = [[Gas spore]],
  display = 'e',
  color = colors.C_g,
  image = 'npc/gas_spore.png',
  desc = [[From a distance, this creature is often mistaken for the much more dangerous beholder.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 25, 10 },
  ac = 1,
  max_life = resolvers.dice(25, 10),
  rarity = 4,
  level = 34,
  start_level = 34,
  exp_worth = 100,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.FEAR] = true,
    [DamageType.OLD_SLEEP] = true,
  },
  flags = {
    BASEANGBAND = true,
    EMPTY_MIND = true,
    FLY = true,
    FORCE_SLEEP = true,
    NO_CUT = true,
    STUPID = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.DISEASE, method=AttackType.EXPLODE, dam={30,2} },
  },
  body = bodies.none,
  speed = 0,
  vision = 30,
  alertness = 5,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'MASTER_VAMPIRE',
  name = [[Master vampire]],
  display = 'V',
  color = colors.C_g,
  image = 'npc/master_vampire.png',
  desc = [[It is a humanoid form dressed in robes. Power emanates from its chilling frame.]],
  corpse_weight = 160,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 6,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 34, 20 },
  ac = 60,
  max_life = 680,
  rarity = 1,
  level = 36,
  start_level = 36,
  exp_worth = 750,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.DARK] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  vuln_dam = {
    [DamageType.LITE] = true,
    [DamageType.LITE_WEAK] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    COLD_BLOOD = true,
    EVIL = true,
    FLY = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    NO_CUT = true,
    OPEN_DOOR = true,
    REGENERATE = true,
    UNDEAD = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ '4d2' },
  drop = { treasure=20, combat=40, magic=30, tools=0, junk=10 },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={2,6} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={2,6} },
    { type=DamageType.EXP_40, method=AttackType.BITE, dam={3,6} },
    { type=DamageType.EXP_40, method=AttackType.BITE, dam={3,6} },
  },
  resolvers.talents {
    [Talents.T_NPC_TELE_TO] = 1,
    [Talents.T_NPC_HOLD] = 1,
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_CAUSE_3] = 1,
    [Talents.T_NPC_MIND_BLAST] = 1,
    [Talents.T_NPC_FORGET] = 1,
    [Talents.T_NPC_DARKNESS] = 1,
    [Talents.T_NPC_BO_NETH] = 1,
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 20,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'ORIENTAL_VAMPIRE',
  name = [[Oriental vampire]],
  display = 'V',
  color = colors.C_s,
  image = 'npc/oriental_vampire.png',
  desc = [[The oriental vampire can transform into a mist at will.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 6,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 30, 30 },
  ac = 60,
  max_life = 900,
  rarity = 3,
  level = 40,
  start_level = 40,
  exp_worth = 750,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.DARK] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
    [DamageType.TELEPORT] = true,
  },
  vuln_dam = {
    [DamageType.LITE] = true,
    [DamageType.LITE_WEAK] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    COLD_BLOOD = true,
    EVIL = true,
    FLY = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    INVISIBLE = true,
    NO_CUT = true,
    OPEN_DOOR = true,
    PASS_WALL = true,
    REGENERATE = true,
    UNDEAD = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ '4d2' },
  drop = { treasure=10, combat=45, magic=35, tools=0, junk=10 },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={3,6} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={3,6} },
    { type=DamageType.EXP_40, method=AttackType.BITE, dam={3,6} },
    { type=DamageType.EXP_40, method=AttackType.BITE, dam={3,6} },
  },
  on_melee_hit = util.black_breath_melee_hit,
  resolvers.talents {
    [Talents.T_NPC_TELE_TO] = 1,
    [Talents.T_NPC_HOLD] = 1,
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_CAUSE_3] = 1,
    [Talents.T_NPC_MIND_BLAST] = 1,
    [Talents.T_NPC_FORGET] = 1,
    [Talents.T_NPC_DARKNESS] = 1,
    [Talents.T_NPC_BO_NETH] = 1,
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 20,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'GREATER_MUMMY',
  name = [[Greater mummy]],
  display = 'z',
  color = colors.C_y,
  image = 'npc/greater_mummy.png',
  desc = [[Once a powerful ruler, now an even more powerful undead menace.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 3,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 34, 10 },
  ac = 68,
  max_life = 340,
  rarity = 3,
  level = 36,
  start_level = 36,
  exp_worth = 800,
  resist_dam = {
    [DamageType.ACID] = true,
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.ELEC] = true,
    [DamageType.FEAR] = true,
    [DamageType.FIRE] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
    [DamageType.TELEPORT] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    COLD_BLOOD = true,
    EVIL = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    MOVE_BODY = true,
    NO_CUT = true,
    OPEN_DOOR = true,
    POWERFUL = true,
    SMART = true,
    TAKE_ITEM = true,
    UNDEAD = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ only_item=true, '1d2', '2d2' },
  drop = { treasure=50, combat=50, magic=0, tools=0, junk=0 },
  attacks = {
    { type=DamageType.LOSE_CON, method=AttackType.CLAW, dam={3,6} },
    { type=DamageType.DISEASE, method=AttackType.CLAW, dam={3,6} },
    { type=DamageType.EXP_40, method=AttackType.GAZE, dam={3,4} },
    { type=DamageType.FEAR, method=AttackType.GAZE, dam={3,4} },
  },
  resolvers.talents {
    [Talents.T_NPC_HEAL] = 1,
    [Talents.T_NPC_HASTE] = 1,
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_S_UNDEAD] = 1,
    [Talents.T_NPC_ANIM_DEAD] = 1,
    [Talents.T_NPC_BA_POIS] = 1,
    [Talents.T_NPC_BA_NETH] = 1,
    [Talents.T_NPC_BA_COLD] = 1,
    [Talents.T_NPC_DRAIN_MANA] = 1,
    [Talents.T_NPC_MIND_BLAST] = 1,
    [Talents.T_NPC_CAUSE_3] = 1,
    [Talents.T_NPC_DARKNESS] = 1,
    [Talents.T_NPC_FORGET] = 1,
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 30,
  alertness = 255,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'GIANT_GREY_SCORPION',
  name = [[Giant grey scorpion]],
  display = 'S',
  color = colors.C_s,
  image = 'npc/giant_grey_scorpion.png',
  desc = [[It is a giant grey scorpion. It looks poisonous.]],
  corpse_weight = 120,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 18, 20 },
  ac = 50,
  max_life = resolvers.dice(18, 20),
  rarity = 4,
  level = 34,
  start_level = 34,
  exp_worth = 275,
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    MORTAL = true,
    WEIRD_MIND = true,
  },
  placement_flags = { WILD_TOO=true },
  drop_corpse = { skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={1,6} },
    { type=DamageType.POISON, method=AttackType.STING, dam={1,4} },
  },
  body = bodies.quadruped,
  speed = 10,
  vision = 12,
  alertness = 40,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'EARTH_ELEMENTAL',
  name = [[Earth elemental]],
  display = 'E',
  color = colors.C_u,
  image = 'npc/earth_elemental.png',
  desc = [[It is a towering form composed of rock with fists of awesome power.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 8,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 30, 10 },
  ac = 60,
  max_life = resolvers.dice(30, 10),
  rarity = 2,
  level = 34,
  start_level = 34,
  exp_worth = 375,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.ELEC] = true,
    [DamageType.FEAR] = true,
    [DamageType.FIRE] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  vuln_dam = {
    [DamageType.KILL_WALL] = true,
  },
  flags = {
    BASEANGBAND = true,
    COLD_BLOOD = true,
    EMPTY_MIND = true,
    FORCE_SLEEP = true,
    KILL_BODY = true,
    KILL_ITEM = true,
    NO_CUT = true,
    PASS_WALL = true,
    POWERFUL = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={4,6} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={4,6} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={4,6} },
  },
  resolvers.talents {
    [Talents.T_NPC_BO_ACID] = 1,
  },
  body = bodies.none,
  speed = -10,
  vision = 10,
  alertness = 90,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'AIR_ELEMENTAL',
  name = [[Air elemental]],
  display = 'E',
  color = colors.C_B,
  image = 'npc/air_elemental.png',
  desc = [[It is a towering tornado of winds.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=25,
    talent_in = 8,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 30, 5 },
  ac = 50,
  max_life = resolvers.dice(30, 5),
  rarity = 2,
  level = 34,
  start_level = 34,
  exp_worth = 390,
  resist_dam = {
    [DamageType.ACID] = true,
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.ELEC] = true,
    [DamageType.FEAR] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    COLD_BLOOD = true,
    EMPTY_MIND = true,
    FLY = true,
    FORCE_SLEEP = true,
    KILL_BODY = true,
    KILL_ITEM = true,
    NO_CUT = true,
    POWERFUL = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,10} },
    { type=DamageType.CONFUSION, method=AttackType.HIT, dam={1,4} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,10} },
  },
  resolvers.talents {
    [Talents.T_NPC_BO_ELEC] = 1,
  },
  body = bodies.none,
  speed = 10,
  vision = 12,
  alertness = 50,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'SHIMMERING_MOLD',
  name = [[Shimmering mold]],
  display = 'm',
  color = colors.C_b,
  image = 'npc/shimmering_mold.png',
  desc = [[It is a strange growth on the dungeon floor, glowing and crackling with sparks.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 32, 8 },
  ac = 24,
  max_life = resolvers.dice(32, 8),
  rarity = 1,
  level = 27,
  start_level = 27,
  exp_worth = 140,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.ELEC] = true,
    [DamageType.FEAR] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    CAN_SWIM = true,
    EMPTY_MIND = true,
    NEVER_MOVE = true,
    NO_CUT = true,
    STUPID = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.ELEC, method=AttackType.SPORE, dam={5,4} },
    { type=DamageType.ELEC, method=AttackType.SPORE, dam={5,4} },
  },
  speed = 0,
  vision = 2,
  alertness = 70,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'GARGOYLE',
  name = [[Gargoyle]],
  display = 'u',
  color = colors.C_s,
  image = 'npc/gargoyle.png',
  desc = [[A weird demon creature with a stone-like skin.]],
  corpse_weight = 300,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 12,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 18, 12 },
  ac = 50,
  max_life = resolvers.dice(18, 12),
  rarity = 2,
  level = 34,
  start_level = 34,
  exp_worth = 110,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.DARK] = true,
    [DamageType.ELEC] = true,
    [DamageType.FIRE] = true,
    [DamageType.POISON] = true,
  },
  vuln_dam = {
    [DamageType.KILL_WALL] = true,
    [DamageType.LITE] = true,
    [DamageType.LITE_WEAK] = true,
  },
  flags = {
    BASEANGBAND = true,
    DEMON = true,
    EVIL = true,
    FRIENDS = true,
    NONLIVING = true,
    NO_CUT = true,
  },
  placement_flags = { WILD_MOUNTAIN=true, WILD_TOO=true, WILD_WASTE=true },
  resolvers.mon_inven{ only_gold=true, '60%' },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={2,6} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={2,6} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={1,6} },
  },
  resolvers.talents {
    [Talents.T_NPC_BR_ELEC] = 1,
    [Talents.T_NPC_BR_FIRE] = 1,
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 10,
  alertness = 15,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'MALICIOUS_LEPRECHAUN',
  name = [[Malicious leprechaun]],
  display = 'h',
  color = colors.C_v,
  image = 'npc/malicious_leprechaun.png',
  desc = [[This little creature has a fiendish gleam in its eyes.]],
  corpse_weight = 120,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=25,
    talent_in = 6,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 4, 5 },
  ac = 13,
  max_life = resolvers.dice(4, 5),
  rarity = 4,
  level = 35,
  start_level = 35,
  exp_worth = 85,
  resist_dam = {
    [DamageType.DARK] = true,
  },
  vuln_dam = {
    [DamageType.LITE] = true,
    [DamageType.LITE_WEAK] = true,
  },
  flags = {
    BASEANGBAND = true,
    COLD_BLOOD = true,
    EVIL = true,
    INVISIBLE = true,
    MALE = true,
    MORTAL = true,
    MULTIPLY = true,
    OPEN_DOOR = true,
    TAKE_ITEM = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.EAT_GOLD, method=AttackType.TOUCH },
    { type=DamageType.EAT_ITEM, method=AttackType.TOUCH },
  },
  resolvers.talents {
    [Talents.T_NPC_BLINK] = 1,
    [Talents.T_NPC_TPORT] = 1,
    [Talents.T_NPC_TELE_TO] = 1,
    [Talents.T_NPC_CAUSE_1] = 1,
  },
  body = bodies.humanoid,
  speed = 10,
  vision = 8,
  alertness = 8,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'EOG_GOLEM',
  name = [[Eog golem]],
  display = 'g',
  color = colors.C_u,
  image = 'npc/eog_golem.png',
  desc = [[It is a massive deep brown statue, striding towards you with an all-too-familiar purpose. Your magic surprisingly feels much less powerful now.]],
  corpse_weight = 1200,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 100, 20 },
  ac = 125,
  max_life = resolvers.dice(100, 20),
  rarity = 4,
  level = 34,
  start_level = 34,
  exp_worth = 1200,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.ELEC] = true,
    [DamageType.FEAR] = true,
    [DamageType.FIRE] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    COLD_BLOOD = true,
    EMPTY_MIND = true,
    NONLIVING = true,
    NO_CUT = true,
    REFLECTING = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ only_gold=true, '2d2' },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={8,6} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={8,6} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={6,6} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={6,6} },
  },
  body = bodies.humanoid,
  speed = -10,
  vision = 12,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'DAGASHI',
  name = [[Dagashi]],
  self_plural = true,
  display = 'p',
  color = colors.C_u,
  image = 'npc/dagashi.png',
  desc = [[A human warrior, moving with lightning speed.]],
  corpse_weight = 160,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 13, 25 },
  ac = 70,
  max_life = resolvers.dice(13, 25),
  rarity = 4,
  level = 35,
  start_level = 35,
  exp_worth = 500,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.OLD_SLEEP] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    EVIL = true,
    HAS_LITE = true,
    MALE = true,
    MORTAL = true,
    OPEN_DOOR = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ '1d2' },
  drop = { treasure=0, combat=100, magic=0, tools=0, junk=0 },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.POISON, method=AttackType.HIT, dam={3,4} },
    { type=DamageType.LOSE_STR, method=AttackType.HIT, dam={3,4} },
    { type=DamageType.LOSE_STR, method=AttackType.HIT, dam={3,4} },
    { type=DamageType.POISON, method=AttackType.HIT, dam={3,4} },
  },
  body = bodies.humanoid,
  speed = 10,
  vision = 20,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'HEADLESS_GHOST',
  name = [[Headless ghost]],
  display = 'G',
  color = colors.C_u,
  image = 'npc/headless_ghost.png',
  desc = [[A phantasmal apparition with no head.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=25,
    talent_in = 15,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 20, 25 },
  ac = 30,
  max_life = resolvers.dice(20, 25),
  rarity = 3,
  level = 35,
  start_level = 35,
  exp_worth = 550,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    COLD_BLOOD = true,
    EVIL = true,
    FLY = true,
    FORCE_SLEEP = true,
    NO_CUT = true,
    PASS_WALL = true,
    TAKE_ITEM = true,
    UNDEAD = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ only_item=true, '2d2', '90%' },
  drop = { treasure=35, combat=25, magic=25, tools=0, junk=15 },
  attacks = {
    { type=DamageType.FEAR, method=AttackType.TOUCH },
    { type=DamageType.EXP_40, method=AttackType.TOUCH },
    { type=DamageType.LOSE_INT, method=AttackType.CLAW, dam={5,5} },
    { type=DamageType.LOSE_WIS, method=AttackType.CLAW, dam={5,5} },
  },
  resolvers.talents {
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_DRAIN_MANA] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_BO_COLD] = 1,
    [Talents.T_NPC_FORGET] = 1,
  },
  body = bodies.none,
  speed = 10,
  vision = 20,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'DREAD',
  name = [[Dread]],
  display = 'G',
  color = colors.C_o,
  image = 'npc/dread.png',
  desc = [[It is a form that screams its presence against the eye. Death incarnate, its hideous black body seems to struggle against reality as the universe itself struggles to banish it.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=25,
    talent_in = 15,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 25, 20 },
  ac = 30,
  max_life = resolvers.dice(25, 20),
  rarity = 2,
  level = 35,
  start_level = 35,
  exp_worth = 600,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    COLD_BLOOD = true,
    EVIL = true,
    FLY = true,
    FORCE_SLEEP = true,
    INVISIBLE = true,
    NO_CUT = true,
    PASS_WALL = true,
    TAKE_ITEM = true,
    UNDEAD = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ only_item=true, '2d2', '60%' },
  drop = { treasure=0, combat=50, magic=50, tools=0, junk=0 },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={6,6} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={6,6} },
    { type=DamageType.LOSE_STR, method=AttackType.HIT, dam={3,4} },
  },
  resolvers.talents {
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_HOLD] = 1,
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_DRAIN_MANA] = 1,
    [Talents.T_NPC_BO_NETH] = 1,
  },
  body = bodies.none,
  speed = 10,
  vision = 20,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'GAUTH',
  name = [[Gauth]],
  display = 'e',
  color = colors.C_s,
  image = 'npc/gauth.png',
  desc = [[Another lesser relative of the beholder, this six-eyed creature feeds on magic.]],
  corpse_weight = 160,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 5,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 15, 20 },
  ac = 50,
  max_life = 300,
  rarity = 2,
  level = 36,
  start_level = 36,
  exp_worth = 600,
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    EVIL = true,
    FLY = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    MORTAL = true,
  },
  placement_flags = {},
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.DISENCHANT, method=AttackType.GAZE, dam={5,2} },
    { type=DamageType.DISENCHANT, method=AttackType.GAZE, dam={5,2} },
    { type=DamageType.UN_POWER, method=AttackType.GAZE, dam={5,2} },
    { type=DamageType.UN_POWER, method=AttackType.GAZE, dam={5,2} },
  },
  resolvers.talents {
    [Talents.T_NPC_CAUSE_2] = 1,
    [Talents.T_NPC_TELE_AWAY] = 1,
    [Talents.T_NPC_BA_COLD] = 1,
    [Talents.T_NPC_BO_ELEC] = 1,
    [Talents.T_NPC_HOLD] = 1,
    [Talents.T_NPC_DRAIN_MANA] = 1,
  },
  body = bodies.none,
  speed = 0,
  vision = 20,
  alertness = 20,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'SMOKE_ELEMENTAL',
  name = [[Smoke elemental]],
  display = 'E',
  color = colors.C_R,
  image = 'npc/smoke_elemental.png',
  desc = [[It is a towering blackened form, crackling with heat.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 5,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 15, 10 },
  ac = 80,
  max_life = resolvers.dice(15, 10),
  rarity = 3,
  level = 36,
  start_level = 36,
  exp_worth = 375,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.ELEC] = true,
    [DamageType.FEAR] = true,
    [DamageType.FIRE] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    EMPTY_MIND = true,
    FLY = true,
    FORCE_SLEEP = true,
    KILL_BODY = true,
    KILL_ITEM = true,
    NO_CUT = true,
    POWERFUL = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.ENGULF, dam={2,6} },
    { type=DamageType.PHYSICAL, method=AttackType.ENGULF, dam={2,6} },
  },
  resolvers.talents {
    [Talents.T_NPC_DARKNESS] = 1,
    [Talents.T_NPC_BO_FIRE] = 1,
  },
  body = bodies.none,
  speed = 10,
  vision = 10,
  alertness = 90,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'OLOG',
  name = [[Olog]],
  display = 'T',
  color = colors.C_y,
  image = 'npc/olog.png',
  desc = [[It is a massive troll, more intelligent than most of its kind, with needle- sharp fangs.]],
  corpse_weight = 600,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 42, 10 },
  ac = 50,
  max_life = 420,
  rarity = 1,
  level = 36,
  start_level = 36,
  exp_worth = 450,
  resist_dam = {
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    EVIL = true,
    FORCE_MAXHP = true,
    FRIENDS = true,
    OPEN_DOOR = true,
    REGENERATE = true,
    SMART = true,
    TROLL = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ '60%' },
  drop = { treasure=10, combat=90, magic=0, tools=0, junk=0 },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,12} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,12} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={2,3} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={2,3} },
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 20,
  alertness = 50,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'HALFLING_SLINGER',
  name = [[Halfling slinger]],
  display = 'h',
  color = colors.C_U,
  image = 'npc/halfling_slinger.png',
  desc = [[A rebel halfling who has rejected the halfling tradition of archery.]],
  corpse_weight = 90,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 3,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 30, 9 },
  ac = 40,
  max_life = 270,
  rarity = 1,
  level = 35,
  start_level = 35,
  exp_worth = 330,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    EVIL = true,
    FORCE_MAXHP = true,
    FRIENDS = true,
    HAS_LITE = true,
    MALE = true,
    MORTAL = true,
    OPEN_DOOR = true,
    SMART = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ '90%' },
  drop = { treasure=100, combat=0, magic=0, tools=0, junk=0 },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={2,6} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={2,6} },
  },
  resolvers.talents {
    [Talents.T_NPC_ARROW_4] = 1,
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 20,
  alertness = 30,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'GRAVITY_HOUND',
  name = [[Gravity hound]],
  display = 'Z',
  color = colors.C_W,
  image = 'npc/gravity_hound.png',
  desc = [[Unfettered by the usual constraints of gravity, these unnatural creatures are walking on the walls and even the ceiling!  The earth suddenly feels rather less solid as you see gravity warp all around these monsters.]],
  corpse_weight = 70,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 5,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 35, 10 },
  ac = 30,
  max_life = resolvers.dice(35, 10),
  rarity = 2,
  level = 35,
  start_level = 35,
  exp_worth = 500,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.GRAVITY] = true,
    [DamageType.OLD_SLEEP] = true,
  },
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    FORCE_SLEEP = true,
    FRIENDS = true,
    MORTAL = true,
  },
  placement_flags = {},
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={2,8} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={2,8} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={2,8} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={2,8} },
  },
  resolvers.talents {
    [Talents.T_NPC_BR_GRAV] = 1,
  },
  body = bodies.quadruped,
  speed = 0,
  vision = 30,
  alertness = 0,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'ACIDIC_CYTOPLASM',
  name = [[Acidic cytoplasm]],
  display = 'j',
  color = colors.C_s,
  image = 'npc/acidic_cytoplasm.png',
  desc = [[A disgusting animated blob of destruction. Flee its gruesome hunger!]],
  corpse_weight = 300,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 40, 10 },
  ac = 18,
  max_life = 400,
  rarity = 5,
  level = 35,
  start_level = 35,
  exp_worth = 180,
  resist_dam = {
    [DamageType.ACID] = true,
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.ELEC] = true,
    [DamageType.FEAR] = true,
    [DamageType.FIRE] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    CAN_SWIM = true,
    COLD_BLOOD = true,
    EMPTY_MIND = true,
    FORCE_MAXHP = true,
    NO_CUT = true,
    OPEN_DOOR = true,
    STUPID = true,
    TAKE_ITEM = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ '1d2', '4d2' },
  drop = { treasure=50, combat=0, magic=50, tools=0, junk=0 },
  attacks = {
    { type=DamageType.ACID, method=AttackType.TOUCH, dam={1,10} },
    { type=DamageType.ACID, method=AttackType.TOUCH, dam={1,10} },
    { type=DamageType.ACID, method=AttackType.TOUCH, dam={1,10} },
    { type=DamageType.ACID, method=AttackType.TOUCH, dam={1,10} },
  },
  body = bodies.none,
  speed = 10,
  vision = 12,
  alertness = 1,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'INERTIA_HOUND',
  name = [[Inertia hound]],
  display = 'Z',
  color = colors.C_W,
  image = 'npc/inertia_hound.png',
  desc = [[Bizarrely, this hound seems to be hardly moving at all, yet it approaches you with deadly menace. It makes you tired just to look at it.]],
  corpse_weight = 70,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 5,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 35, 10 },
  ac = 30,
  max_life = resolvers.dice(35, 10),
  rarity = 2,
  level = 35,
  start_level = 35,
  exp_worth = 500,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.INERTIA] = true,
    [DamageType.OLD_SLEEP] = true,
  },
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    FORCE_SLEEP = true,
    FRIENDS = true,
    MORTAL = true,
  },
  placement_flags = {},
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={2,8} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={2,8} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={2,8} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={2,8} },
  },
  resolvers.talents {
    [Talents.T_NPC_BR_INER] = 1,
  },
  body = bodies.quadruped,
  speed = 0,
  vision = 30,
  alertness = 0,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'IMPACT_HOUND',
  name = [[Impact hound]],
  display = 'Z',
  color = colors.C_u,
  image = 'npc/impact_hound.png',
  desc = [[A deep brown shape is visible before you, its canine form striking you with an almost physical force. The dungeon floor buckles as if struck by a powerful blow as it stalks towards you.]],
  corpse_weight = 70,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 5,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 35, 10 },
  ac = 30,
  max_life = resolvers.dice(35, 10),
  rarity = 2,
  level = 35,
  start_level = 35,
  exp_worth = 500,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.OLD_SLEEP] = true,
  },
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    FORCE_SLEEP = true,
    FRIENDS = true,
    MORTAL = true,
  },
  placement_flags = {},
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={2,8} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={2,8} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={2,8} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={2,8} },
  },
  resolvers.talents {
    [Talents.T_NPC_BR_WALL] = 1,
  },
  body = bodies.quadruped,
  speed = 0,
  vision = 30,
  alertness = 0,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'SHARDSTORM',
  name = [[Shardstorm]],
  display = 'v',
  color = colors.C_u,
  image = 'npc/shardstorm.png',
  desc = [[A howling blast of razor-sharp mountain fragments, kept intact by perilous magics.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=50,
    talent_in = 4,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 32, 10 },
  ac = 12,
  max_life = resolvers.dice(32, 10),
  rarity = 1,
  level = 37,
  start_level = 37,
  exp_worth = 800,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.FEAR] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.SHARDS] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    EMPTY_MIND = true,
    FLY = true,
    FORCE_SLEEP = true,
    NONLIVING = true,
    NO_CUT = true,
    POWERFUL = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.ENGULF, dam={6,6} },
  },
  resolvers.talents {
    [Talents.T_NPC_BR_SHAR] = 1,
  },
  body = bodies.none,
  speed = 10,
  vision = 40,
  alertness = 0,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'OOZE_ELEMENTAL',
  name = [[Ooze elemental]],
  display = 'E',
  color = colors.C_g,
  image = 'npc/ooze_elemental.png',
  desc = [[It is a towering mass of filth, an eyesore of ooze.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 5,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 13, 10 },
  ac = 80,
  max_life = resolvers.dice(13, 10),
  rarity = 3,
  level = 36,
  start_level = 36,
  exp_worth = 300,
  resist_dam = {
    [DamageType.ACID] = true,
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.FEAR] = true,
    [DamageType.FIRE] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    CAN_SWIM = true,
    COLD_BLOOD = true,
    EMPTY_MIND = true,
    FORCE_SLEEP = true,
    KILL_BODY = true,
    KILL_ITEM = true,
    NO_CUT = true,
    POWERFUL = true,
  },
  placement_flags = { WILD_SHORE=true, WILD_SWAMP=true, WILD_TOO=true },
  attacks = {
    { type=DamageType.ACID, method=AttackType.TOUCH, dam={1,10} },
    { type=DamageType.ACID, method=AttackType.TOUCH, dam={1,10} },
    { type=DamageType.ACID, method=AttackType.TOUCH, dam={1,10} },
  },
  resolvers.talents {
    [Talents.T_NPC_BO_ACID] = 1,
    [Talents.T_NPC_BA_ACID] = 1,
  },
  body = bodies.none,
  speed = 0,
  vision = 10,
  alertness = 90,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'YOUNG_BLACK_DRAGON',
  name = [[Young black dragon]],
  display = 'd',
  color = colors.C_s,
  multi_colors = { colors.C_d, colors.C_D },
  image = 'npc/young_black_dragon.png',
  desc = [[It has a form out of legend. Its still-tender scales are a darkest black hue. Acid drips from its body.]],
  corpse_weight = 2000,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 10,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 30, 10 },
  ac = 60,
  max_life = 300,
  rarity = 1,
  level = 31,
  start_level = 31,
  exp_worth = 700,
  resist_dam = {
    [DamageType.ACID] = true,
  },
  flags = {
    ATTR_MULTI = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    DRAGON = true,
    EVIL = true,
    FLY = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    OPEN_DOOR = true,
  },
  placement_flags = { WILD_SWAMP=true, WILD_TOO=true },
  resolvers.mon_inven{ '3d2' },
  drop = { treasure=50, combat=50, magic=0, tools=0, junk=0 },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={2,6} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={2,6} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={2,8} },
  },
  resolvers.talents {
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_BR_ACID] = 1,
  },
  body = bodies.dragon,
  speed = 0,
  vision = 20,
  alertness = 70,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'MUMAK',
  name = [[Mûmak]],
  plural_name = [[Mûmakil]],
  display = 'q',
  color = colors.C_s,
  image = 'npc/mumak.png',
  desc = [[A massive elephantine form with eyes twisted by madness.]],
  corpse_weight = 15000,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 90, 10 },
  ac = 55,
  max_life = resolvers.dice(90, 10),
  rarity = 3,
  level = 35,
  start_level = 35,
  exp_worth = 2100,
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    MORTAL = true,
  },
  placement_flags = {},
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.BUTT, dam={8,6} },
    { type=DamageType.PHYSICAL, method=AttackType.BUTT, dam={8,6} },
    { type=DamageType.PHYSICAL, method=AttackType.CRUSH, dam={8,4} },
  },
  body = bodies.quadruped,
  speed = 0,
  vision = 20,
  alertness = 100,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'GIANT_FIRE_ANT',
  name = [[Giant fire ant]],
  display = 'a',
  color = colors.C_R,
  image = 'npc/giant_fire_ant.png',
  desc = [[A giant ant covered in shaggy fur. Its powerful jaws glow with heat.]],
  corpse_weight = 70,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 20, 10 },
  ac = 49,
  max_life = 200,
  rarity = 1,
  level = 35,
  start_level = 35,
  exp_worth = 350,
  resist_dam = {
    [DamageType.FIRE] = true,
  },
  vuln_dam = {
    [DamageType.COLD] = true,
  },
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    FORCE_MAXHP = true,
    FRIENDS = true,
    KILL_BODY = true,
    MORTAL = true,
    WEIRD_MIND = true,
  },
  placement_flags = {},
  drop_corpse = { skeleton=true },
  attacks = {
    { type=DamageType.FIRE, method=AttackType.BITE, dam={3,12} },
    { type=DamageType.FIRE, method=AttackType.BITE, dam={3,12} },
  },
  body = bodies.quadruped,
  speed = 0,
  vision = 14,
  alertness = 40,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'MATURE_WHITE_DRAGON',
  name = [[Mature white dragon]],
  display = 'd',
  color = colors.C_w,
  multi_colors = { colors.C_w, colors.C_W },
  image = 'npc/mature_white_dragon.png',
  desc = [[A large dragon, scales gleaming bright white.]],
  corpse_weight = 11000,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 9,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 40, 10 },
  ac = 70,
  max_life = 400,
  rarity = 1,
  level = 34,
  start_level = 34,
  exp_worth = 1200,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.OLD_SLEEP] = true,
  },
  vuln_dam = {
    [DamageType.FIRE] = true,
  },
  flags = {
    ATTR_MULTI = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    DRAGON = true,
    EVIL = true,
    FLY = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    HAS_LITE = true,
    OPEN_DOOR = true,
  },
  placement_flags = { WILD_MOUNTAIN=true, WILD_TOO=true, WILD_WASTE=true },
  resolvers.mon_inven{ '4d2' },
  drop = { treasure=50, combat=50, magic=0, tools=0, junk=0 },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={2,8} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={2,8} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={4,8} },
  },
  resolvers.talents {
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_BR_COLD] = 1,
  },
  body = bodies.dragon,
  speed = 0,
  vision = 20,
  alertness = 70,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'XORN',
  name = [[Xorn]],
  self_plural = true,
  display = 'X',
  color = colors.C_u,
  image = 'npc/xorn.png',
  desc = [[A huge creature of the element Earth. Able to merge with its element, it has four huge arms protruding from its enormous torso.]],
  corpse_weight = 3000,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 16, 10 },
  ac = 80,
  max_life = 160,
  rarity = 2,
  level = 36,
  start_level = 36,
  exp_worth = 650,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.ELEC] = true,
    [DamageType.FIRE] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  vuln_dam = {
    [DamageType.KILL_WALL] = true,
  },
  flags = {
    BASEANGBAND = true,
    COLD_BLOOD = true,
    EMPTY_MIND = true,
    FORCE_MAXHP = true,
    KILL_ITEM = true,
    NO_CUT = true,
    PASS_WALL = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,6} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,6} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,6} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,6} },
  },
  body = { MAIN_HAND=0, OFF_HAND=0, BODY=0, CLOAK=0, LAUNCHER=0, QUIVER=0, GLOVES=0, BOOTS=0, HELM=0, RING=3, AMULET=0, LITE=0, TOOL=0, SYMBIOTE=0, INVEN=23 },
  speed = 0,
  vision = 20,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'ROGROG_THE_BLACK_TROLL',
  name = [[Rogrog the Black Troll]],
  display = 'T',
  color = colors.C_D,
  image = 'npc/rogrog_the_black_troll.png',
  desc = [[A massive and cruel troll of great power, drool slides caustically down his muscular frame. Despite his bulk, he strikes with stunning speed.]],
  corpse_weight = 900,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 15, 100 },
  ac = 70,
  max_life = 1500,
  rarity = 5,
  level = 41,
  start_level = 41,
  exp_worth = 5000,
  unique = 'ROGROG_THE_BLACK_TROLL',
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    ESCORT = true,
    EVIL = true,
    FORCE_MAXHP = true,
    MALE = true,
    MOVE_BODY = true,
    OPEN_DOOR = true,
    REGENERATE = true,
    TAKE_ITEM = true,
    TROLL = true,
    UNIQUE = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, only_item=true, '2d2' },
  drop = { treasure=0, combat=100, magic=0, tools=0, junk=0 },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={6,7} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={6,7} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={4,10} },
    { type=DamageType.ACID, method=AttackType.SPIT, dam={4,8} },
  },
  body = bodies.humanoid,
  speed = 10,
  vision = 20,
  alertness = 50,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'PHANTOM',
  name = [[Phantom]],
  display = 'G',
  color = colors.C_v,
  image = 'npc/phantom.png',
  desc = [[An unholy creature of darkness, the aura emanating from this evil being saps your very soul.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 5,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 20, 25 },
  ac = 30,
  max_life = resolvers.dice(20, 25),
  rarity = 3,
  level = 36,
  start_level = 36,
  exp_worth = 400,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    COLD_BLOOD = true,
    EVIL = true,
    FLY = true,
    FORCE_SLEEP = true,
    INVISIBLE = true,
    NO_CUT = true,
    PASS_WALL = true,
    UNDEAD = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ only_item=true, '1d2' },
  drop = { treasure=0, combat=0, magic=100, tools=0, junk=0 },
  attacks = {
    { type=DamageType.EXP_80, method=AttackType.TOUCH },
    { type=DamageType.EXP_40, method=AttackType.TOUCH },
    { type=DamageType.LOSE_INT, method=AttackType.CLAW, dam={1,10} },
    { type=DamageType.LOSE_WIS, method=AttackType.CLAW, dam={1,10} },
  },
  resolvers.talents {
    [Talents.T_NPC_FORGET] = 1,
    [Talents.T_NPC_MIND_BLAST] = 1,
  },
  body = bodies.none,
  speed = 10,
  vision = 30,
  alertness = 20,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'GREY_WRAITH',
  name = [[Grey wraith]],
  display = 'W',
  color = colors.C_s,
  image = 'npc/grey_wraith.png',
  desc = [[A tangible but ghostly form, made of grey fog. The air around it feels deathly cold.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 7,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 19, 10 },
  ac = 50,
  max_life = 190,
  rarity = 1,
  level = 36,
  start_level = 36,
  exp_worth = 700,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.DARK] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  vuln_dam = {
    [DamageType.LITE] = true,
    [DamageType.LITE_WEAK] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    COLD_BLOOD = true,
    EVIL = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    NO_CUT = true,
    OPEN_DOOR = true,
    UNDEAD = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ '60%', '90%' },
  drop = { treasure=0, combat=50, magic=50, tools=0, junk=0 },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,10} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,10} },
    { type=DamageType.EXP_40, method=AttackType.TOUCH },
  },
  resolvers.talents {
    [Talents.T_NPC_HOLD] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_CAUSE_3] = 1,
    [Talents.T_NPC_DARKNESS] = 1,
  },
  body = bodies.none,
  speed = 0,
  vision = 20,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'REVENANT',
  name = [[Revenant]],
  display = 'W',
  color = colors.C_u,
  image = 'npc/revenant.png',
  desc = [[Back from the grave, to wreak vengeance upon the living. A skeletal figure wearing a black robe, with eyes that burn with undying hatred.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 7,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 2, 111 },
  ac = 50,
  max_life = 222,
  rarity = 1,
  level = 36,
  start_level = 36,
  exp_worth = 725,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.DARK] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  vuln_dam = {
    [DamageType.LITE] = true,
    [DamageType.LITE_WEAK] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    COLD_BLOOD = true,
    EVIL = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    MOVE_BODY = true,
    NO_CUT = true,
    OPEN_DOOR = true,
    REGENERATE = true,
    UNDEAD = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ '60%', '90%' },
  drop = { treasure=0, combat=0, magic=100, tools=0, junk=0 },
  attacks = {
    { type=DamageType.PARALYZE, method=AttackType.GAZE },
    { type=DamageType.LOSE_CON, method=AttackType.CLAW, dam={1,10} },
    { type=DamageType.LOSE_CON, method=AttackType.CLAW, dam={1,10} },
    { type=DamageType.EXP_40, method=AttackType.GAZE },
  },
  resolvers.talents {
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_CAUSE_3] = 1,
    [Talents.T_NPC_DARKNESS] = 1,
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 20,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'YOUNG_MULTI_HUED_DRAGON',
  name = [[Young multi-hued dragon]],
  display = 'd',
  color = colors.C_v,
  multi_colors = { colors.C_d, colors.C_r, colors.C_w, colors.C_b, colors.C_g },
  image = 'npc/young_multi_hued_dragon.png',
  desc = [[It has a form out of legend. Beautiful scales of shimmering and magical colours cover it.]],
  corpse_weight = 2000,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 8,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 32, 10 },
  ac = 60,
  max_life = 320,
  rarity = 1,
  level = 32,
  start_level = 32,
  exp_worth = 900,
  resist_dam = {
    [DamageType.ACID] = true,
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.ELEC] = true,
    [DamageType.FIRE] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    ATTR_MULTI = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    DRAGON = true,
    EVIL = true,
    FLY = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    HAS_LITE = true,
    OPEN_DOOR = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ '1d2', '3d2' },
  drop = { treasure=50, combat=50, magic=0, tools=0, junk=0 },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={2,6} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={2,6} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={3,8} },
  },
  resolvers.talents {
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_BR_ACID] = 1,
    [Talents.T_NPC_BR_FIRE] = 1,
    [Talents.T_NPC_BR_COLD] = 1,
    [Talents.T_NPC_BR_ELEC] = 1,
    [Talents.T_NPC_BR_POIS] = 1,
  },
  body = bodies.dragon,
  speed = 0,
  vision = 20,
  alertness = 70,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'COLOSSUS',
  name = [[Colossus]],
  plural_name = [[Colossi]],
  display = 'g',
  color = colors.C_G,
  image = 'npc/colossus.png',
  desc = [[An enormous construct resembling a titan made from stone. It strides purposefully towards you, swinging its slow fists with earth-shattering power.]],
  corpse_weight = 3500,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 8,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 30, 100 },
  ac = 150,
  max_life = 3000,
  rarity = 4,
  level = 36,
  start_level = 36,
  exp_worth = 900,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.ELEC] = true,
    [DamageType.FEAR] = true,
    [DamageType.FIRE] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    COLD_BLOOD = true,
    EMPTY_MIND = true,
    FORCE_MAXHP = true,
    MORTAL = true,
    NONLIVING = true,
    NO_CUT = true,
    REFLECTING = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={10,10} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={10,10} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={6,6} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={6,6} },
  },
  resolvers.talents {
    [Talents.T_NPC_ARROW_4] = 1,
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 15,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'YOUNG_GOLD_DRAGON',
  name = [[Young gold dragon]],
  display = 'd',
  color = colors.C_y,
  multi_colors = { colors.C_y, colors.C_U },
  image = 'npc/young_gold_dragon.png',
  desc = [[It has a form out of legend. Its still-tender scales are a tarnished gold hue, and light is reflected from its form.]],
  corpse_weight = 2000,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 10,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 30, 10 },
  ac = 60,
  max_life = 300,
  rarity = 1,
  level = 31,
  start_level = 31,
  exp_worth = 700,
  flags = {
    ATTR_MULTI = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    DRAGON = true,
    EVIL = true,
    FLY = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    HAS_LITE = true,
    NO_STUN = true,
    OPEN_DOOR = true,
  },
  placement_flags = { WILD_MOUNTAIN=true, WILD_TOO=true },
  resolvers.mon_inven{ '3d2' },
  drop = { treasure=50, combat=50, magic=0, tools=0, junk=0 },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={2,6} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={2,6} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={2,8} },
  },
  resolvers.talents {
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_BR_SOUN] = 1,
  },
  body = bodies.dragon,
  speed = 0,
  vision = 20,
  alertness = 70,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'MATURE_BLUE_DRAGON',
  name = [[Mature blue dragon]],
  display = 'd',
  color = colors.C_b,
  multi_colors = { colors.C_b, colors.C_B },
  image = 'npc/mature_blue_dragon.png',
  desc = [[A large dragon, scales tinted deep blue.]],
  corpse_weight = 11000,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 9,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 40, 10 },
  ac = 70,
  max_life = 400,
  rarity = 1,
  level = 34,
  start_level = 34,
  exp_worth = 1200,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.ELEC] = true,
    [DamageType.OLD_SLEEP] = true,
  },
  flags = {
    ATTR_MULTI = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    DRAGON = true,
    EVIL = true,
    FLY = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    HAS_LITE = true,
  },
  placement_flags = { WILD_MOUNTAIN=true, WILD_TOO=true, WILD_WOOD=true },
  resolvers.mon_inven{ '4d2' },
  drop = { treasure=50, combat=50, magic=0, tools=0, junk=0 },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={2,8} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={2,8} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={4,8} },
  },
  resolvers.talents {
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_BR_ELEC] = 1,
  },
  body = bodies.dragon,
  speed = 0,
  vision = 20,
  alertness = 70,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'MATURE_GREEN_DRAGON',
  name = [[Mature green dragon]],
  display = 'd',
  color = colors.C_g,
  multi_colors = { colors.C_g, colors.C_G },
  image = 'npc/mature_green_dragon.png',
  desc = [[A large dragon, scales tinted deep green.]],
  corpse_weight = 11000,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 9,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 40, 10 },
  ac = 70,
  max_life = 400,
  rarity = 1,
  level = 34,
  start_level = 34,
  exp_worth = 1200,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    ATTR_MULTI = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    DRAGON = true,
    EVIL = true,
    FLY = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    HAS_LITE = true,
  },
  placement_flags = { WILD_MOUNTAIN=true, WILD_TOO=true, WILD_WOOD=true },
  resolvers.mon_inven{ '4d2' },
  drop = { treasure=50, combat=50, magic=0, tools=0, junk=0 },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={2,8} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={2,8} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={4,8} },
  },
  resolvers.talents {
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_BR_POIS] = 1,
  },
  body = bodies.dragon,
  speed = 0,
  vision = 20,
  alertness = 70,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'MATURE_BRONZE_DRAGON',
  name = [[Mature bronze dragon]],
  display = 'd',
  color = colors.C_U,
  multi_colors = { colors.C_U, colors.C_u },
  image = 'npc/mature_bronze_dragon.png',
  desc = [[A large dragon with scales of rich bronze.]],
  corpse_weight = 11000,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 9,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 40, 10 },
  ac = 70,
  max_life = 400,
  rarity = 1,
  level = 34,
  start_level = 34,
  exp_worth = 1200,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.OLD_SLEEP] = true,
  },
  flags = {
    ATTR_MULTI = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    DRAGON = true,
    EVIL = true,
    FLY = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    HAS_LITE = true,
  },
  placement_flags = { WILD_MOUNTAIN=true, WILD_TOO=true },
  resolvers.mon_inven{ '4d2' },
  drop = { treasure=50, combat=50, magic=0, tools=0, junk=0 },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={2,8} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={2,8} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={4,8} },
  },
  resolvers.talents {
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_BR_CONF] = 1,
  },
  body = bodies.dragon,
  speed = 0,
  vision = 20,
  alertness = 70,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'YOUNG_RED_DRAGON',
  name = [[Young red dragon]],
  display = 'd',
  color = colors.C_r,
  multi_colors = { colors.C_r, colors.C_R },
  image = 'npc/young_red_dragon.png',
  desc = [[It has a form out of legend. Its still-tender scales are a deepest red hue. Heat radiates from its form.]],
  corpse_weight = 2000,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 10,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 30, 10 },
  ac = 60,
  max_life = 300,
  rarity = 1,
  level = 31,
  start_level = 31,
  exp_worth = 700,
  resist_dam = {
    [DamageType.FIRE] = true,
  },
  vuln_dam = {
    [DamageType.COLD] = true,
  },
  flags = {
    ATTR_MULTI = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    DRAGON = true,
    EVIL = true,
    FLY = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    HAS_LITE = true,
    OPEN_DOOR = true,
  },
  placement_flags = { WILD_MOUNTAIN=true, WILD_TOO=true, WILD_VOLCANO=true },
  resolvers.mon_inven{ '3d2' },
  drop = { treasure=50, combat=50, magic=0, tools=0, junk=0 },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={2,6} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={2,6} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={2,8} },
  },
  resolvers.talents {
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_BR_FIRE] = 1,
  },
  body = bodies.dragon,
  speed = 0,
  vision = 20,
  alertness = 70,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'TRAPPER',
  name = [[Trapper]],
  display = '.',
  color = colors.C_w,
  image = 'npc/trapper.png',
  desc = [[This creature traps unsuspecting victims and paralyzes them, to be slowly digested later.]],
  corpse_weight = 130,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 60, 10 },
  ac = 75,
  max_life = 600,
  rarity = 3,
  level = 36,
  start_level = 36,
  exp_worth = 580,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.FEAR] = true,
    [DamageType.OLD_SLEEP] = true,
  },
  flags = {
    ATTR_CLEAR = true,
    BASEANGBAND = true,
    CHAR_CLEAR = true,
    CHAR_MULTI = true,
    COLD_BLOOD = true,
    EMPTY_MIND = true,
    FORCE_MAXHP = true,
    INVISIBLE = true,
    MORTAL = true,
    NEVER_MOVE = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={3,8} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={3,8} },
    { type=DamageType.PARALYZE, method=AttackType.HIT, dam={15,1} },
    { type=DamageType.PARALYZE, method=AttackType.HIT, dam={15,1} },
  },
  body = bodies.none,
  speed = 10,
  vision = 30,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'BODAK',
  name = [[Bodak]],
  display = 'u',
  color = colors.C_r,
  image = 'npc/bodak.png',
  desc = [[It is a humanoid form composed of flames and hatred.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 4,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 35, 10 },
  ac = 68,
  max_life = resolvers.dice(35, 10),
  rarity = 2,
  level = 36,
  start_level = 36,
  exp_worth = 750,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.FIRE] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  melee_retal = {
    [DamageType.FIRE] = 'mondam',
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    DEMON = true,
    EVIL = true,
    FORCE_SLEEP = true,
    HAS_LITE = true,
    NONLIVING = true,
    OPEN_DOOR = true,
    TAKE_ITEM = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.FIRE, method=AttackType.HIT, dam={4,6} },
    { type=DamageType.FIRE, method=AttackType.HIT, dam={4,6} },
    { type=DamageType.EXP_20, method=AttackType.GAZE },
  },
  resolvers.talents {
    [Talents.T_NPC_BO_FIRE] = 1,
    [Talents.T_NPC_BA_FIRE] = 1,
    [Talents.T_NPC_S_DEMON] = 1,
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 10,
  alertness = 90,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'MEZZODAEMON',
  name = [[Mezzodaemon]],
  display = 'u',
  color = colors.C_o,
  image = 'npc/mezzodaemon.png',
  desc = [[An ugly demon with insect-like extremities and large bulbous eyes.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 4,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 40, 10 },
  ac = 68,
  max_life = resolvers.dice(40, 10),
  rarity = 2,
  level = 36,
  start_level = 36,
  exp_worth = 750,
  resist_dam = {
    [DamageType.ACID] = true,
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.FIRE] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    DEMON = true,
    EVIL = true,
    FORCE_SLEEP = true,
    INVISIBLE = true,
    NONLIVING = true,
    NO_STUN = true,
    PASS_WALL = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={5,6} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={5,6} },
  },
  resolvers.talents {
    [Talents.T_NPC_BLINK] = 1,
    [Talents.T_NPC_DARKNESS] = 1,
    [Talents.T_NPC_S_DEMON] = 1,
  },
  body = { MAIN_HAND=1, OFF_HAND=1, BODY=1, CLOAK=1, LAUNCHER=1, QUIVER=1, GLOVES=1, BOOTS=1, HELM=1, RING=0, AMULET=1, LITE=1, TOOL=1, SYMBIOTE=1, INVEN=23 },
  speed = 0,
  vision = 10,
  alertness = 90,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'ICE_ELEMENTAL',
  name = [[Ice elemental]],
  display = 'E',
  color = colors.C_w,
  image = 'npc/ice_elemental.png',
  desc = [[It is a towering glacier of ice.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 5,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 35, 10 },
  ac = 60,
  max_life = resolvers.dice(35, 10),
  rarity = 3,
  level = 37,
  start_level = 37,
  exp_worth = 650,
  resist_dam = {
    [DamageType.ACID] = true,
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.ELEC] = true,
    [DamageType.FEAR] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  melee_retal = {
    [DamageType.COLD] = 'mondam',
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    CAN_SWIM = true,
    COLD_BLOOD = true,
    EMPTY_MIND = true,
    FORCE_SLEEP = true,
    KILL_BODY = true,
    KILL_ITEM = true,
    NO_CUT = true,
    POWERFUL = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.COLD, method=AttackType.TOUCH, dam={4,3} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={4,6} },
    { type=DamageType.COLD, method=AttackType.TOUCH, dam={4,3} },
  },
  resolvers.talents {
    [Talents.T_NPC_BO_ICEE] = 1,
    [Talents.T_NPC_BA_COLD] = 1,
  },
  body = bodies.none,
  speed = 0,
  vision = 10,
  alertness = 90,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'NECROMANCER',
  name = [[Necromancer]],
  display = 'p',
  color = colors.C_R,
  image = 'npc/necromancer.png',
  desc = [[A gaunt figure, clothed in black robes.]],
  corpse_weight = 160,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 3,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 28, 10 },
  ac = 50,
  max_life = 280,
  rarity = 2,
  level = 36,
  start_level = 36,
  exp_worth = 666,
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    EVIL = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    HAS_LITE = true,
    MALE = true,
    MORTAL = true,
    OPEN_DOOR = true,
    SMART = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ only_item=true, '1d2' },
  drop = { treasure=10, combat=0, magic=90, tools=0, junk=0 },
  drop_corpse = { skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={2,6} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={2,6} },
  },
  resolvers.talents {
    [Talents.T_NPC_HASTE] = 1,
    [Talents.T_NPC_TPORT] = 1,
    [Talents.T_NPC_TELE_TO] = 1,
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_HOLD] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_CAUSE_3] = 1,
    [Talents.T_NPC_BO_NETH] = 1,
    [Talents.T_NPC_MIND_BLAST] = 1,
    [Talents.T_NPC_FORGET] = 1,
    [Talents.T_NPC_S_UNDEAD] = 1,
    [Talents.T_NPC_ANIM_DEAD] = 1,
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 20,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'LORGAN_CHIEF_OF_THE_EASTERLINGS',
  name = [[Lorgan, Chief of the Easterlings]],
  display = 'p',
  color = colors.C_v,
  image = 'npc/lorgan_chief_of_the_easterlings.png',
  desc = [[A mighty warrior from the east, Lorgan hates everything that he cannot control.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 4,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 18, 100 },
  ac = 100,
  max_life = 1800,
  rarity = 2,
  level = 36,
  start_level = 36,
  exp_worth = 1200,
  unique = 'LORGAN_CHIEF_OF_THE_EASTERLINGS',
  resist_dam = {
    [DamageType.ACID] = true,
    [DamageType.COLD] = true,
    [DamageType.ELEC] = true,
    [DamageType.FIRE] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    EVIL = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    HAS_LITE = true,
    MALE = true,
    OPEN_DOOR = true,
    UNIQUE = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, only_item=true, '2d2' },
  drop = { treasure=0, combat=100, magic=0, tools=0, junk=0 },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={6,6} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={6,6} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={3,8} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={3,8} },
  },
  resolvers.talents {
    [Talents.T_NPC_TELE_TO] = 1,
    [Talents.T_NPC_S_MONSTERS] = 1,
  },
  body = bodies.humanoid,
  speed = 10,
  vision = 25,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'MUMMIFIED_TROLL',
  name = [[Mummified troll]],
  display = 'z',
  color = colors.C_w,
  image = 'npc/mummified_troll.png',
  desc = [[It is a massive figure clothed in wrappings. You are wary of its massive fists.]],
  corpse_weight = 500,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 25, 10 },
  ac = 50,
  max_life = 250,
  rarity = 1,
  level = 34,
  start_level = 34,
  exp_worth = 420,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.FEAR] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    COLD_BLOOD = true,
    EMPTY_MIND = true,
    EVIL = true,
    FORCE_MAXHP = true,
    NO_CUT = true,
    OPEN_DOOR = true,
    REGENERATE = true,
    TROLL = true,
    UNDEAD = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ '60%' },
  drop = { treasure=0, combat=100, magic=0, tools=0, junk=0 },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={4,6} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={4,6} },
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 20,
  alertness = 50,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'STORM_OF_UNMAGIC',
  name = [[Storm of Unmagic]],
  display = 'v',
  color = colors.C_v,
  multi_colors = { colors.C_B, colors.C_v },
  image = 'npc/storm_of_unmagic.png',
  desc = [[Howling through the disintegrating dungeon, this awesome whirlpool of Unmagic rips the enchantments from everything it touches.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=75,
    talent_in = 6,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 32, 20 },
  ac = 40,
  max_life = 640,
  rarity = 3,
  level = 53,
  start_level = 53,
  exp_worth = 4000,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.FEAR] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.TIME] = true,
  },
  flags = {
    ATTR_MULTI = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    EMPTY_MIND = true,
    FLY = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    NONLIVING = true,
    NO_CUT = true,
    POWERFUL = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.EXP_80, method=AttackType.ENGULF, dam={5,5} },
    { type=DamageType.UN_POWER, method=AttackType.ENGULF, dam={5,5} },
    { type=DamageType.DISENCHANT, method=AttackType.ENGULF, dam={5,5} },
    { type=DamageType.LOSE_ALL, method=AttackType.HIT, dam={5,5} },
  },
  resolvers.talents {
    [Talents.T_NPC_BR_TIME] = 1,
    [Talents.T_NPC_BR_DISE] = 1,
  },
  speed = 20,
  vision = 50,
  alertness = 0,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'CRYPT_THING',
  name = [[Crypt thing]],
  display = 'L',
  color = colors.C_G,
  image = 'npc/crypt_thing.png',
  desc = [[It is a skeletal form dressed in robes. It looks evil and devious...]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 3,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 80, 10 },
  ac = 60,
  max_life = 800,
  rarity = 2,
  level = 37,
  start_level = 37,
  exp_worth = 2500,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.DARK] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
    [DamageType.TELEPORT] = true,
  },
  vuln_dam = {
    [DamageType.LITE] = true,
    [DamageType.LITE_WEAK] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    COLD_BLOOD = true,
    EVIL = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    NO_CUT = true,
    OPEN_DOOR = true,
    SMART = true,
    UNDEAD = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ '1d2' },
  drop = { treasure=50, combat=50, magic=0, tools=0, junk=0 },
  attacks = {
    { type=DamageType.EXP_40, method=AttackType.TOUCH },
    { type=DamageType.UN_POWER, method=AttackType.TOUCH },
    { type=DamageType.LOSE_DEX, method=AttackType.TOUCH, dam={2,10} },
    { type=DamageType.LOSE_DEX, method=AttackType.TOUCH, dam={2,10} },
  },
  resolvers.talents {
    [Talents.T_NPC_BLINK] = 1,
    [Talents.T_NPC_TELE_TO] = 1,
    [Talents.T_NPC_TELE_AWAY] = 1,
    [Talents.T_NPC_TELE_LEVEL] = 1,
    [Talents.T_NPC_CAUSE_3] = 1,
    [Talents.T_NPC_DRAIN_MANA] = 1,
    [Talents.T_NPC_BRAIN_SMASH] = 1,
  },
  body = bodies.humanoid,
  speed = 10,
  vision = 20,
  alertness = 60,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'THE_QUEEN_ANT',
  name = [[The Queen Ant]],
  display = 'a',
  color = colors.C_v,
  image = 'npc/the_queen_ant.png',
  desc = [[She's upset because you hurt her children.]],
  corpse_weight = 200,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 2,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 15, 100 },
  ac = 100,
  faction = 'yavanna',
  max_life = 1500,
  rarity = 2,
  level = 37,
  start_level = 37,
  exp_worth = 1000,
  unique = 'THE_QUEEN_ANT',
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    ESCORT = true,
    ESCORTS = true,
    FEMALE = true,
    FLY = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    GOOD = true,
    MORTAL = true,
    OPEN_DOOR = true,
    UNIQUE = true,
    WEIRD_MIND = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, only_item=true, '2d2' },
  drop = { treasure=50, combat=50, magic=0, tools=0, junk=0 },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={2,12} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={2,12} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={2,8} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={2,8} },
  },
  resolvers.talents {
    [Talents.T_NPC_S_KIN] = 1,
  },
  body = bodies.quadruped,
  speed = 10,
  vision = 30,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'WILL_O_THE_WISP',
  name = [[Will o' the wisp]],
  display = 'E',
  color = colors.C_W,
  image = 'npc/will_o_the_wisp.png',
  desc = [[A strange ball of glowing light. It disappears and reappears and seems to draw you to it. You seem somehow compelled to stand still and watch its strange dancing motion.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=50,
    talent_in = 2,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 20, 10 },
  ac = 150,
  max_life = 200,
  rarity = 4,
  level = 38,
  start_level = 38,
  exp_worth = 500,
  resist_dam = {
    [DamageType.ACID] = true,
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.ELEC] = true,
    [DamageType.FEAR] = true,
    [DamageType.FIRE] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    EMPTY_MIND = true,
    FLY = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    HAS_LITE = true,
    INVISIBLE = true,
    NONLIVING = true,
    NO_CUT = true,
    PASS_WALL = true,
    POWERFUL = true,
    SMART = true,
  },
  placement_flags = { WILD_SWAMP=true, WILD_TOO=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,9} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,9} },
    { type=DamageType.HALLUCINATION, method=AttackType.HIT, dam={1,9} },
    { type=DamageType.HALLUCINATION, method=AttackType.HIT, dam={1,9} },
  },
  resolvers.talents {
    [Talents.T_NPC_BLINK] = 1,
    [Talents.T_NPC_TPORT] = 1,
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_CAUSE_2] = 1,
  },
  body = bodies.none,
  speed = 20,
  vision = 30,
  alertness = 0,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'MAGMA_ELEMENTAL',
  name = [[Magma elemental]],
  display = 'E',
  color = colors.C_o,
  image = 'npc/magma_elemental.png',
  desc = [[It is a towering glowing form of molten rock.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 7,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 35, 10 },
  ac = 70,
  max_life = resolvers.dice(35, 10),
  rarity = 3,
  level = 37,
  start_level = 37,
  exp_worth = 950,
  resist_dam = {
    [DamageType.ACID] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.ELEC] = true,
    [DamageType.FEAR] = true,
    [DamageType.FIRE] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  melee_retal = {
    [DamageType.FIRE] = 'mondam',
  },
  flags = {
    BASEANGBAND = true,
    EMPTY_MIND = true,
    FORCE_SLEEP = true,
    HAS_LITE = true,
    KILL_BODY = true,
    KILL_ITEM = true,
    NO_CUT = true,
    PASS_WALL = true,
    POWERFUL = true,
  },
  placement_flags = { WILD_TOO=true, WILD_VOLCANO=true },
  attacks = {
    { type=DamageType.FIRE, method=AttackType.HIT, dam={3,7} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={4,6} },
    { type=DamageType.FIRE, method=AttackType.HIT, dam={3,7} },
  },
  resolvers.talents {
    [Talents.T_NPC_BO_PLAS] = 1,
    [Talents.T_NPC_BA_FIRE] = 1,
  },
  body = bodies.none,
  speed = 0,
  vision = 10,
  alertness = 90,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'BLACK_PUDDING',
  name = [[Black pudding]],
  display = 'j',
  color = colors.C_D,
  image = 'npc/black_pudding.png',
  desc = [[A lump of rotting black flesh that slurrrrrrrps across the dungeon floor.]],
  corpse_weight = 30,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 40, 10 },
  ac = 18,
  max_life = 400,
  rarity = 5,
  level = 37,
  start_level = 37,
  exp_worth = 50,
  resist_dam = {
    [DamageType.ACID] = true,
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.ELEC] = true,
    [DamageType.FEAR] = true,
    [DamageType.FIRE] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    CAN_SWIM = true,
    COLD_BLOOD = true,
    EMPTY_MIND = true,
    FORCE_MAXHP = true,
    FRIENDS = true,
    NO_CUT = true,
    OPEN_DOOR = true,
    STUPID = true,
    TAKE_ITEM = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ '1d2', '60%', '90%' },
  drop = { treasure=90, combat=0, magic=0, tools=0, junk=10 },
  attacks = {
    { type=DamageType.ACID, method=AttackType.TOUCH, dam={1,10} },
    { type=DamageType.ACID, method=AttackType.TOUCH, dam={1,10} },
    { type=DamageType.ACID, method=AttackType.TOUCH, dam={1,10} },
    { type=DamageType.ACID, method=AttackType.TOUCH, dam={1,10} },
  },
  body = bodies.none,
  speed = 0,
  vision = 12,
  alertness = 1,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'KILLER_IRIDESCENT_BEETLE',
  name = [[Killer iridescent beetle]],
  display = 'K',
  color = colors.C_v,
  image = 'npc/killer_iridescent_beetle.png',
  desc = [[It is a giant beetle, whose carapace shimmers with vibrant energies.]],
  corpse_weight = 60,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 25, 15 },
  ac = 60,
  max_life = 375,
  rarity = 2,
  level = 37,
  start_level = 37,
  exp_worth = 850,
  resist_dam = {
    [DamageType.ELEC] = true,
  },
  melee_retal = {
    [DamageType.ELEC] = 'mondam',
  },
  flags = {
    ANIMAL = true,
    ATTR_MULTI = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    FLY = true,
    FORCE_MAXHP = true,
    HAS_LITE = true,
    MORTAL = true,
    WEIRD_MIND = true,
  },
  placement_flags = {},
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.ELEC, method=AttackType.CLAW, dam={1,12} },
    { type=DamageType.ELEC, method=AttackType.CLAW, dam={1,12} },
    { type=DamageType.PARALYZE, method=AttackType.GAZE },
  },
  body = bodies.quadruped,
  speed = 0,
  vision = 16,
  alertness = 30,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'NEXUS_VORTEX',
  name = [[Nexus vortex]],
  display = 'v',
  color = colors.C_v,
  image = 'npc/nexus_vortex.png',
  desc = [[A maelstrom of potent magical energy.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=75,
    talent_in = 6,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 32, 10 },
  ac = 40,
  max_life = resolvers.dice(32, 10),
  rarity = 1,
  level = 37,
  start_level = 37,
  exp_worth = 800,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.FEAR] = true,
    [DamageType.NEXUS] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.TELEPORT] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    EMPTY_MIND = true,
    FLY = true,
    FORCE_SLEEP = true,
    HAS_LITE = true,
    NONLIVING = true,
    NO_CUT = true,
    POWERFUL = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.ENGULF, dam={5,5} },
  },
  resolvers.talents {
    [Talents.T_NPC_BR_NEXU] = 1,
  },
  body = bodies.none,
  speed = 10,
  vision = 100,
  alertness = 0,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'PLASMA_VORTEX',
  name = [[Plasma vortex]],
  display = 'v',
  color = colors.C_R,
  image = 'npc/plasma_vortex.png',
  desc = [[A whirlpool of intense flame, charring the stones at your feet.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=75,
    talent_in = 6,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 32, 10 },
  ac = 40,
  max_life = resolvers.dice(32, 10),
  rarity = 1,
  level = 37,
  start_level = 37,
  exp_worth = 800,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.FEAR] = true,
    [DamageType.FIRE] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.PLASMA] = true,
  },
  vuln_dam = {
    [DamageType.COLD] = true,
  },
  melee_retal = {
    [DamageType.ELEC] = 'mondam',
    [DamageType.FIRE] = 'mondam',
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    EMPTY_MIND = true,
    FLY = true,
    FORCE_SLEEP = true,
    HAS_LITE = true,
    NONLIVING = true,
    NO_CUT = true,
    POWERFUL = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.FIRE, method=AttackType.ENGULF, dam={4,8} },
    { type=DamageType.ELEC, method=AttackType.ENGULF, dam={4,8} },
  },
  resolvers.talents {
    [Talents.T_NPC_BR_PLAS] = 1,
  },
  body = bodies.none,
  speed = 10,
  vision = 100,
  alertness = 0,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'MATURE_RED_DRAGON',
  name = [[Mature red dragon]],
  display = 'd',
  color = colors.C_r,
  multi_colors = { colors.C_r, colors.C_R },
  image = 'npc/mature_red_dragon.png',
  desc = [[A large dragon, scales tinted deep red.]],
  corpse_weight = 11000,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 9,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 50, 10 },
  ac = 80,
  max_life = 500,
  rarity = 1,
  level = 36,
  start_level = 36,
  exp_worth = 1500,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.FIRE] = true,
    [DamageType.OLD_SLEEP] = true,
  },
  vuln_dam = {
    [DamageType.COLD] = true,
  },
  flags = {
    ATTR_MULTI = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    DRAGON = true,
    EVIL = true,
    FLY = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    HAS_LITE = true,
  },
  placement_flags = { WILD_MOUNTAIN=true, WILD_TOO=true, WILD_VOLCANO=true },
  resolvers.mon_inven{ '1d2', '4d2' },
  drop = { treasure=50, combat=50, magic=0, tools=0, junk=0 },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={2,10} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={2,10} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={4,10} },
  },
  resolvers.talents {
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_BR_FIRE] = 1,
  },
  body = bodies.dragon,
  speed = 0,
  vision = 20,
  alertness = 70,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'MATURE_GOLD_DRAGON',
  name = [[Mature gold dragon]],
  display = 'd',
  color = colors.C_y,
  multi_colors = { colors.C_y, colors.C_U },
  image = 'npc/mature_gold_dragon.png',
  desc = [[A large dragon with scales of gleaming gold.]],
  corpse_weight = 11000,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 9,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 50, 10 },
  ac = 80,
  max_life = 500,
  rarity = 1,
  level = 36,
  start_level = 36,
  exp_worth = 1500,
  resist_dam = {
    [DamageType.OLD_SLEEP] = true,
  },
  flags = {
    ATTR_MULTI = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    DRAGON = true,
    EVIL = true,
    FLY = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    HAS_LITE = true,
    NO_STUN = true,
  },
  placement_flags = { WILD_MOUNTAIN=true, WILD_TOO=true },
  resolvers.mon_inven{ '1d2', '4d2' },
  drop = { treasure=50, combat=50, magic=0, tools=0, junk=0 },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={2,10} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={2,10} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={4,10} },
  },
  resolvers.talents {
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_BR_SOUN] = 1,
  },
  body = bodies.dragon,
  speed = 0,
  vision = 20,
  alertness = 70,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'CRYSTAL_DRAKE',
  name = [[Crystal drake]],
  display = 'd',
  color = colors.C_u,
  multi_colors = { colors.C_u, colors.C_U },
  image = 'npc/crystal_drake.png',
  desc = [[A dragon of strange crystalline form. Light shines through it, dazzling your eyes with spectrums of colour.]],
  corpse_weight = 1800,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 6,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 45, 10 },
  ac = 70,
  max_life = 450,
  rarity = 3,
  level = 33,
  start_level = 33,
  exp_worth = 1350,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.OLD_SLEEP] = true,
  },
  flags = {
    ATTR_MULTI = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    DRAGON = true,
    EVIL = true,
    FLY = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    HAS_LITE = true,
    NO_CUT = true,
    OPEN_DOOR = true,
    REFLECTING = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ only_item=true, '3d2' },
  drop = { treasure=50, combat=50, magic=0, tools=0, junk=0 },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={2,4} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={2,4} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={3,6} },
  },
  resolvers.talents {
    [Talents.T_NPC_SLOW] = 1,
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_BR_SHAR] = 1,
  },
  body = bodies.dragon,
  speed = 0,
  vision = 20,
  alertness = 70,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'MATURE_BLACK_DRAGON',
  name = [[Mature black dragon]],
  display = 'd',
  color = colors.C_s,
  multi_colors = { colors.C_d, colors.C_D },
  image = 'npc/mature_black_dragon.png',
  desc = [[A large dragon, with scales of deepest black.]],
  corpse_weight = 11000,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 9,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 50, 10 },
  ac = 80,
  max_life = 500,
  rarity = 1,
  level = 36,
  start_level = 36,
  exp_worth = 1500,
  resist_dam = {
    [DamageType.ACID] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.OLD_SLEEP] = true,
  },
  flags = {
    ATTR_MULTI = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    DRAGON = true,
    EVIL = true,
    FLY = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
  },
  placement_flags = { WILD_MOUNTAIN=true, WILD_SWAMP=true, WILD_TOO=true },
  resolvers.mon_inven{ '1d2', '4d2' },
  drop = { treasure=50, combat=50, magic=0, tools=0, junk=0 },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={2,10} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={2,10} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={4,10} },
  },
  resolvers.talents {
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_BR_ACID] = 1,
  },
  body = bodies.dragon,
  speed = 0,
  vision = 20,
  alertness = 70,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'MATURE_MULTI_HUED_DRAGON',
  name = [[Mature multi-hued dragon]],
  display = 'd',
  color = colors.C_v,
  multi_colors = { colors.C_d, colors.C_r, colors.C_w, colors.C_b, colors.C_g },
  image = 'npc/mature_multi_hued_dragon.png',
  desc = [[A large dragon, scales shimmering many colours.]],
  corpse_weight = 11000,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 7,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 60, 10 },
  ac = 80,
  max_life = 600,
  rarity = 1,
  level = 38,
  start_level = 38,
  exp_worth = 1800,
  resist_dam = {
    [DamageType.ACID] = true,
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.ELEC] = true,
    [DamageType.FIRE] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    ATTR_MULTI = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    DRAGON = true,
    EVIL = true,
    FLY = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    HAS_LITE = true,
    OPEN_DOOR = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ '2d2', '4d2' },
  drop = { treasure=50, combat=50, magic=0, tools=0, junk=0 },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={2,12} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={2,12} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={4,12} },
  },
  resolvers.talents {
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_BR_ACID] = 1,
    [Talents.T_NPC_BR_FIRE] = 1,
    [Talents.T_NPC_BR_COLD] = 1,
    [Talents.T_NPC_BR_ELEC] = 1,
    [Talents.T_NPC_BR_POIS] = 1,
  },
  body = bodies.dragon,
  speed = 0,
  vision = 20,
  alertness = 70,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'DRAEBOR_THE_IMP',
  name = [[Draebor, the Imp]],
  display = 'u',
  color = colors.C_v,
  image = 'npc/draebor_the_imp.png',
  desc = [[An intensely irritating git of a monster.]],
  corpse_weight = 300,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 5,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 19, 99 },
  ac = 80,
  max_life = 1881,
  rarity = 3,
  level = 38,
  start_level = 38,
  exp_worth = 3250,
  unique = 'DRAEBOR_THE_IMP',
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.FIRE] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
    [DamageType.TELEPORT] = true,
    [DamageType.WATER] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    CAN_SPEAK = true,
    CAN_SWIM = true,
    DEMON = true,
    ESCORT = true,
    EVIL = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    HAS_LITE = true,
    MALE = true,
    POWERFUL = true,
    UNIQUE = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, only_item=true, '1d2', '60%', '90%' },
  drop = { treasure=30, combat=20, magic=50, tools=0, junk=0 },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.POISON, method=AttackType.CLAW, dam={8,4} },
    { type=DamageType.POISON, method=AttackType.CLAW, dam={8,4} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={8,8} },
    { method=AttackType.INSULT },
  },
  resolvers.talents {
    [Talents.T_NPC_S_KIN] = 1,
    [Talents.T_NPC_BLINK] = 1,
    [Talents.T_NPC_TPORT] = 1,
    [Talents.T_NPC_TELE_TO] = 1,
    [Talents.T_NPC_TELE_AWAY] = 1,
    [Talents.T_NPC_TELE_LEVEL] = 1,
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_SCARE] = 1,
  },
  body = bodies.winged,
  speed = 10,
  vision = 12,
  alertness = 50,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'DEATH_KNIGHT',
  name = [[Death knight]],
  display = 'p',
  color = colors.C_D,
  image = 'npc/death_knight.png',
  desc = [[It is a humanoid figure dressed in armour of an ancient form. From beneath its helmet, eyes glow a baleful red and seem to pierce you like lances of fire.]],
  corpse_weight = 270,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 5,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 60, 10 },
  ac = 100,
  max_life = 600,
  rarity = 1,
  level = 38,
  start_level = 38,
  exp_worth = 1111,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.NETHER] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    COLD_BLOOD = true,
    EVIL = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    HAS_LITE = true,
    NO_CUT = true,
    OPEN_DOOR = true,
    SMART = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ only_item=true, '1d2', '2d2' },
  drop = { treasure=0, combat=90, magic=0, tools=10, junk=0 },
  attacks = {
    { type=DamageType.EXP_20, method=AttackType.HIT, dam={6,6} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={5,5} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={5,5} },
  },
  resolvers.talents {
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_CAUSE_3] = 1,
    [Talents.T_NPC_BO_NETH] = 1,
    [Talents.T_NPC_S_MONSTERS] = 1,
  },
  body = bodies.humanoid,
  speed = 10,
  vision = 20,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'CASTAMIR_THE_USURPER',
  name = [[Castamir the Usurper]],
  display = 'p',
  color = colors.C_R,
  image = 'npc/castamir_the_usurper.png',
  desc = [[A Black Númenórean who usurped the throne of Gondor, he is treacherous and evil.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 2,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 88, 10 },
  ac = 90,
  max_life = 880,
  rarity = 5,
  level = 38,
  start_level = 38,
  exp_worth = 1600,
  unique = 'CASTAMIR_THE_USURPER',
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    EVIL = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    HAS_LITE = true,
    MALE = true,
    OPEN_DOOR = true,
    SMART = true,
    TAKE_ITEM = true,
    UNIQUE = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, only_item=true, '2d2' },
  drop = { treasure=10, combat=60, magic=10, tools=10, junk=10 },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={5,5} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={5,5} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={5,5} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={5,5} },
  },
  resolvers.talents {
    [Talents.T_NPC_HEAL] = 1,
    [Talents.T_NPC_TRAPS] = 1,
    [Talents.T_NPC_BO_FIRE] = 1,
    [Talents.T_NPC_BO_COLD] = 1,
    [Talents.T_NPC_BO_ELEC] = 1,
    [Talents.T_NPC_BO_ICEE] = 1,
  },
  body = bodies.humanoid,
  speed = 10,
  vision = 20,
  alertness = 40,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'TIME_VORTEX',
  name = [[Time vortex]],
  display = 'v',
  color = colors.C_B,
  image = 'npc/time_vortex.png',
  desc = [[You haven't seen it yet.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=75,
    talent_in = 6,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 32, 10 },
  ac = 40,
  max_life = resolvers.dice(32, 10),
  rarity = 4,
  level = 38,
  start_level = 38,
  exp_worth = 800,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.FEAR] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.TIME] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    EMPTY_MIND = true,
    FLY = true,
    FORCE_SLEEP = true,
    NONLIVING = true,
    NO_CUT = true,
    POWERFUL = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.TIME, method=AttackType.ENGULF, dam={5,5} },
  },
  resolvers.talents {
    [Talents.T_NPC_BR_TIME] = 1,
  },
  body = bodies.none,
  speed = 20,
  vision = 100,
  alertness = 0,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'SHIMMERING_VORTEX',
  name = [[Shimmering vortex]],
  display = 'v',
  color = colors.C_o,
  image = 'npc/shimmering_vortex.png',
  desc = [[A strange pillar of shining light that hurts your eyes. Its shape changes constantly as it cuts through the air towards you. It is like a beacon, waking monsters from their slumber.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=75,
    talent_in = 4,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 32, 10 },
  ac = 40,
  max_life = resolvers.dice(32, 10),
  rarity = 4,
  level = 38,
  start_level = 38,
  exp_worth = 800,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.FEAR] = true,
    [DamageType.LITE] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.TELEPORT] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    EMPTY_MIND = true,
    FLY = true,
    FORCE_SLEEP = true,
    HAS_LITE = true,
    NONLIVING = true,
    NO_CUT = true,
    POWERFUL = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.BLIND, method=AttackType.ENGULF, dam={4,4} },
    { type=DamageType.BLIND, method=AttackType.ENGULF, dam={4,4} },
  },
  resolvers.talents {
    [Talents.T_NPC_BR_LITE] = 1,
    [Talents.T_NPC_SHRIEK] = 1,
  },
  body = bodies.none,
  speed = 30,
  vision = 100,
  alertness = 0,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'ANCIENT_BLUE_DRAGON',
  name = [[Ancient blue dragon]],
  display = 'D',
  color = colors.C_b,
  multi_colors = { colors.C_b, colors.C_B },
  image = 'npc/ancient_blue_dragon.png',
  desc = [[A huge draconic form. Lightning crackles along its length.]],
  corpse_weight = 17000,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 6,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 72, 10 },
  ac = 90,
  max_life = 720,
  rarity = 1,
  level = 40,
  start_level = 40,
  exp_worth = 2000,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.ELEC] = true,
    [DamageType.OLD_SLEEP] = true,
  },
  flags = {
    ATTR_MULTI = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    DRAGON = true,
    EVIL = true,
    FLY = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    HAS_LITE = true,
    MOVE_BODY = true,
    POWERFUL = true,
    SMART = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ '3d2', '4d2' },
  drop = { treasure=50, combat=50, magic=0, tools=0, junk=0 },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={4,8} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={4,8} },
    { type=DamageType.ELEC, method=AttackType.BITE, dam={7,8} },
  },
  resolvers.talents {
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_BR_ELEC] = 1,
  },
  body = bodies.dragon,
  speed = 10,
  vision = 20,
  alertness = 80,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'ANCIENT_BRONZE_DRAGON',
  name = [[Ancient bronze dragon]],
  display = 'D',
  color = colors.C_U,
  multi_colors = { colors.C_U, colors.C_u },
  image = 'npc/ancient_bronze_dragon.png',
  desc = [[A huge draconic form enveloped in a cascade of colour.]],
  corpse_weight = 17000,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 6,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 72, 10 },
  ac = 90,
  max_life = 720,
  rarity = 1,
  level = 40,
  start_level = 40,
  exp_worth = 2000,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.OLD_SLEEP] = true,
  },
  flags = {
    ATTR_MULTI = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    DRAGON = true,
    EVIL = true,
    FLY = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    HAS_LITE = true,
    MOVE_BODY = true,
    POWERFUL = true,
    SMART = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ '3d2', '4d2' },
  drop = { treasure=50, combat=50, magic=0, tools=0, junk=0 },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={4,8} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={4,8} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={7,8} },
  },
  resolvers.talents {
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_BR_CONF] = 1,
  },
  body = bodies.dragon,
  speed = 10,
  vision = 20,
  alertness = 80,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'BEHOLDER',
  name = [[Beholder]],
  display = 'e',
  color = colors.C_U,
  image = 'npc/beholder.png',
  desc = [[A vile creature with one huge central eye, twelve smaller eyes on stalks, and a huge mouth filled with sharp teeth.]],
  corpse_weight = 160,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 2,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 16, 100 },
  ac = 80,
  max_life = 1600,
  rarity = 3,
  level = 40,
  start_level = 40,
  exp_worth = 6000,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
    [DamageType.TELEPORT] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    EVIL = true,
    FLY = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
  },
  placement_flags = {},
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.EXP_20, method=AttackType.GAZE, dam={2,6} },
    { type=DamageType.UN_POWER, method=AttackType.GAZE, dam={2,6} },
    { type=DamageType.INSANITY, method=AttackType.GAZE, dam={2,6} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={6,6} },
  },
  resolvers.talents {
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_SLOW] = 1,
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_DRAIN_MANA] = 1,
    [Talents.T_NPC_MIND_BLAST] = 1,
    [Talents.T_NPC_FORGET] = 1,
    [Talents.T_NPC_DARKNESS] = 1,
    [Talents.T_NPC_BO_ACID] = 1,
    [Talents.T_NPC_BO_FIRE] = 1,
    [Talents.T_NPC_BO_COLD] = 1,
    [Talents.T_NPC_BO_ELEC] = 1,
  },
  body = bodies.none,
  speed = 10,
  vision = 30,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'EMPEROR_WIGHT',
  name = [[Emperor wight]],
  display = 'W',
  color = colors.C_r,
  image = 'npc/emperor_wight.png',
  desc = [[Your life force is torn from your body as this powerful unearthly being approaches.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 6,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 38, 10 },
  ac = 40,
  max_life = 380,
  rarity = 2,
  level = 38,
  start_level = 38,
  exp_worth = 1600,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.DARK] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  vuln_dam = {
    [DamageType.LITE] = true,
    [DamageType.LITE_WEAK] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    COLD_BLOOD = true,
    EVIL = true,
    FLY = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    NO_CUT = true,
    OPEN_DOOR = true,
    UNDEAD = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ only_item=true, '4d2', '90%' },
  drop = { treasure=0, combat=40, magic=60, tools=0, junk=0 },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,12} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,12} },
    { type=DamageType.EXP_80, method=AttackType.TOUCH },
    { type=DamageType.EXP_80, method=AttackType.TOUCH },
  },
  resolvers.talents {
    [Talents.T_NPC_HOLD] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_CAUSE_3] = 1,
    [Talents.T_NPC_BO_NETH] = 1,
  },
  body = bodies.none,
  speed = 10,
  vision = 20,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'SERAPH',
  name = [[Seraph]],
  plural_name = [[Seraphim]],
  display = 'A',
  color = colors.C_r,
  image = 'npc/seraph.png',
  desc = [[It is an angel, fast and strong. You are stunned by its extreme holiness and try to resist all desires to obey it.]],
  corpse_weight = 310,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 11,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 150, 10 },
  ac = 68,
  faction = 'eru_manwe',
  max_life = 1500,
  rarity = 4,
  level = 45,
  start_level = 45,
  exp_worth = 5000,
  resist_dam = {
    [DamageType.ACID] = true,
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.ELEC] = true,
    [DamageType.FEAR] = true,
    [DamageType.FIRE] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
    [DamageType.TELEPORT] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    FLY = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    GOOD = true,
    HAS_LITE = true,
    MOVE_BODY = true,
    OPEN_DOOR = true,
    POWERFUL = true,
    REFLECTING = true,
    SMART = true,
    TAKE_ITEM = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ only_item=true, '1d2', '2d2' },
  drop = { treasure=0, combat=30, magic=70, tools=0, junk=0 },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={4,6} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={5,5} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={5,5} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={4,6} },
  },
  resolvers.talents {
    [Talents.T_NPC_HEAL] = 1,
    [Talents.T_NPC_HASTE] = 1,
    [Talents.T_NPC_TELE_AWAY] = 1,
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_BO_MANA] = 1,
    [Talents.T_NPC_BO_PLAS] = 1,
    [Talents.T_NPC_S_MONSTERS] = 1,
    [Talents.T_NPC_S_ANGEL] = 1,
  },
  body = bodies.humanoid,
  speed = 10,
  vision = 30,
  alertness = 255,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'VARGO_TYRANT_OF_FIRE',
  name = [[Vargo, Tyrant of Fire]],
  display = 'E',
  color = colors.C_r,
  image = 'npc/vargo_tyrant_of_fire.png',
  desc = [[A towering fire elemental, Vargo burns everything beyond recognition.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=25,
    talent_in = 4,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 24, 100 },
  ac = 50,
  max_life = 2400,
  rarity = 3,
  level = 43,
  start_level = 43,
  exp_worth = 4000,
  unique = 'VARGO_TYRANT_OF_FIRE',
  resist_dam = {
    [DamageType.ACID] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.ELEC] = true,
    [DamageType.FIRE] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  vuln_dam = {
    [DamageType.COLD] = true,
  },
  melee_retal = {
    [DamageType.FIRE] = 'mondam',
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    CAN_SPEAK = true,
    EMPTY_MIND = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    HAS_LITE = true,
    KILL_BODY = true,
    KILL_ITEM = true,
    MALE = true,
    NO_CUT = true,
    NO_STUN = true,
    POWERFUL = true,
    UNIQUE = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.FIRE, method=AttackType.HIT, dam={6,6} },
    { type=DamageType.FIRE, method=AttackType.HIT, dam={6,6} },
    { type=DamageType.FIRE, method=AttackType.HIT, dam={6,6} },
    { type=DamageType.FIRE, method=AttackType.HIT, dam={6,6} },
  },
  resolvers.talents {
    [Talents.T_NPC_BO_PLAS] = 1,
    [Talents.T_NPC_BA_FIRE] = 1,
  },
  body = bodies.none,
  speed = 10,
  vision = 12,
  alertness = 50,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'BLACK_WRAITH',
  name = [[Black wraith]],
  display = 'W',
  color = colors.C_D,
  image = 'npc/black_wraith.png',
  desc = [[A figure that seems made of void, its strangely human shape is cloaked in shadow. It reaches out at you.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 7,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 50, 10 },
  ac = 55,
  max_life = 500,
  rarity = 2,
  level = 38,
  start_level = 38,
  exp_worth = 1700,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.DARK] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  vuln_dam = {
    [DamageType.LITE] = true,
    [DamageType.LITE_WEAK] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    COLD_BLOOD = true,
    EVIL = true,
    FLY = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    NO_CUT = true,
    OPEN_DOOR = true,
    UNDEAD = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ only_item=true, '1d2', '2d2' },
  drop = { treasure=50, combat=0, magic=50, tools=0, junk=0 },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,12} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,12} },
    { type=DamageType.EXP_40, method=AttackType.TOUCH },
    { type=DamageType.EXP_40, method=AttackType.TOUCH },
  },
  resolvers.talents {
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_HOLD] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_CAUSE_3] = 1,
    [Talents.T_NPC_BO_NETH] = 1,
  },
  body = bodies.none,
  speed = 10,
  vision = 20,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'MONASTIC_LICH',
  name = [[Monastic lich]],
  display = 'L',
  color = colors.C_u,
  image = 'npc/monastic_lich.png',
  desc = [[A skeletal form wrapped in priestly robes. Before its un-death, it was a monk in an evil order.]],
  corpse_weight = 200,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 3,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 12, 100 },
  ac = 80,
  max_life = 1200,
  rarity = 2,
  level = 39,
  start_level = 39,
  exp_worth = 5000,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
    [DamageType.TELEPORT] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    COLD_BLOOD = true,
    EVIL = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    NO_CUT = true,
    OPEN_DOOR = true,
    SMART = true,
    UNDEAD = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ only_item=true, '2d2', '4d2' },
  drop = { treasure=0, combat=50, magic=50, tools=0, junk=0 },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.KICK, dam={24,1} },
    { type=DamageType.PHYSICAL, method=AttackType.KICK, dam={24,1} },
    { type=DamageType.EXP_80, method=AttackType.CLAW, dam={4,2} },
    { type=DamageType.LOSE_DEX, method=AttackType.CLAW, dam={4,2} },
  },
  resolvers.talents {
    [Talents.T_NPC_BLINK] = 1,
    [Talents.T_NPC_TELE_TO] = 1,
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_HOLD] = 1,
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_CAUSE_3] = 1,
    [Talents.T_NPC_CAUSE_4] = 1,
    [Talents.T_NPC_DRAIN_MANA] = 1,
    [Talents.T_NPC_BRAIN_SMASH] = 1,
    [Talents.T_NPC_ANIM_DEAD] = 1,
  },
  body = bodies.humanoid,
  speed = 10,
  vision = 30,
  alertness = 30,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'NETHER_WRAITH',
  name = [[Nether wraith]],
  display = 'W',
  color = colors.C_G,
  image = 'npc/nether_wraith.png',
  desc = [[A form that hurts the eye, death permeates the air around it. As it nears you, a coldness saps your soul.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 6,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 48, 10 },
  ac = 55,
  max_life = 480,
  rarity = 2,
  level = 39,
  start_level = 39,
  exp_worth = 1700,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.DARK] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  vuln_dam = {
    [DamageType.LITE] = true,
    [DamageType.LITE_WEAK] = true,
  },
  flags = {
    BASEANGBAND = true,
    COLD_BLOOD = true,
    EVIL = true,
    FLY = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    INVISIBLE = true,
    NO_CUT = true,
    PASS_WALL = true,
    UNDEAD = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ only_item=true, '4d2', '90%' },
  drop = { treasure=50, combat=0, magic=50, tools=0, junk=0 },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,12} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,12} },
    { type=DamageType.EXP_80, method=AttackType.TOUCH },
    { type=DamageType.EXP_80, method=AttackType.TOUCH },
  },
  resolvers.talents {
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_CAUSE_3] = 1,
    [Talents.T_NPC_MIND_BLAST] = 1,
    [Talents.T_NPC_DARKNESS] = 1,
    [Talents.T_NPC_BO_NETH] = 1,
  },
  body = bodies.none,
  speed = 10,
  vision = 20,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'HELLHOUND',
  name = [[Hellhound]],
  display = 'C',
  color = colors.C_r,
  image = 'npc/hellhound.png',
  desc = [[It is a giant dog that glows with heat. Flames pour from its nostrils.]],
  corpse_weight = 60,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=25,
    talent_in = 5,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 48, 10 },
  ac = 80,
  max_life = 480,
  rarity = 3,
  level = 35,
  start_level = 35,
  exp_worth = 600,
  resist_dam = {
    [DamageType.FIRE] = true,
  },
  vuln_dam = {
    [DamageType.COLD] = true,
  },
  melee_retal = {
    [DamageType.FIRE] = 'mondam',
  },
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    EVIL = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    FRIENDS = true,
    HAS_LITE = true,
    MOVE_BODY = true,
  },
  placement_flags = {},
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.FIRE, method=AttackType.BITE, dam={3,12} },
    { type=DamageType.FIRE, method=AttackType.BITE, dam={3,12} },
    { type=DamageType.FIRE, method=AttackType.BITE, dam={3,12} },
  },
  resolvers.talents {
    [Talents.T_NPC_BR_FIRE] = 1,
  },
  body = bodies.quadruped,
  speed = 10,
  vision = 25,
  alertness = 30,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = '7_HEADED_HYDRA',
  name = [[7-headed hydra]],
  display = 'M',
  color = colors.C_G,
  image = 'npc/7_headed_hydra.png',
  desc = [[A strange reptilian creature with seven heads dripping venom.]],
  corpse_weight = 700,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 5,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 100, 10 },
  ac = 90,
  max_life = resolvers.dice(100, 10),
  rarity = 2,
  level = 39,
  start_level = 39,
  exp_worth = 2000,
  resist_dam = {
    [DamageType.POISON] = true,
  },
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    CAN_SWIM = true,
    FORCE_SLEEP = true,
    MORTAL = true,
    MOVE_BODY = true,
  },
  placement_flags = { WILD_SHORE=true, WILD_SWAMP=true, WILD_TOO=true },
  resolvers.mon_inven{ only_gold=true, '2d2', '4d2' },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.POISON, method=AttackType.BITE, dam={3,9} },
    { type=DamageType.POISON, method=AttackType.BITE, dam={3,9} },
    { type=DamageType.POISON, method=AttackType.BITE, dam={3,9} },
    { type=DamageType.BLIND, method=AttackType.SPIT, dam={1,2} },
  },
  resolvers.talents {
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_BA_POIS] = 1,
    [Talents.T_NPC_BR_POIS] = 1,
  },
  body = bodies.hydra,
  speed = 10,
  vision = 20,
  alertness = 20,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'WALDERN_KING_OF_WATER',
  name = [[Waldern, King of Water]],
  display = 'E',
  color = colors.C_b,
  image = 'npc/waldern_king_of_water.png',
  desc = [[A towering water elemental, Waldern is master of all things liquid. Wave after wave drowns your frail body.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 3,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 25, 100 },
  ac = 80,
  max_life = 2500,
  rarity = 3,
  level = 43,
  start_level = 43,
  exp_worth = 4250,
  unique = 'WALDERN_KING_OF_WATER',
  resist_dam = {
    [DamageType.ACID] = true,
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.FEAR] = true,
    [DamageType.FIRE] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    COLD_BLOOD = true,
    EMPTY_MIND = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    KILL_BODY = true,
    KILL_ITEM = true,
    NO_CUT = true,
    POWERFUL = true,
    UNIQUE = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={8,5} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={8,5} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={8,5} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={8,5} },
  },
  resolvers.talents {
    [Talents.T_NPC_BO_ICEE] = 1,
    [Talents.T_NPC_BO_WATE] = 1,
    [Talents.T_NPC_BA_COLD] = 1,
    [Talents.T_NPC_BA_WATE] = 1,
  },
  body = bodies.none,
  speed = 20,
  vision = 12,
  alertness = 50,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'KAVLAX_THE_MANY_HEADED',
  name = [[Kavlax the Many-Headed]],
  display = 'd',
  color = colors.C_v,
  image = 'npc/kavlax_the_many_headed.png',
  desc = [[A large dragon with a selection of heads, all shouting and arguing as they look for prey, but each with its own deadly breath weapon.]],
  corpse_weight = 9000,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 4,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 13, 100 },
  ac = 85,
  max_life = 1300,
  rarity = 3,
  level = 39,
  start_level = 39,
  exp_worth = 3000,
  unique = 'KAVLAX_THE_MANY_HEADED',
  resist_dam = {
    [DamageType.ACID] = true,
    [DamageType.COLD] = true,
    [DamageType.ELEC] = true,
    [DamageType.FIRE] = true,
    [DamageType.NEXUS] = true,
  },
  flags = {
    ATTR_ANY = true,
    ATTR_MULTI = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    CAN_SPEAK = true,
    DRAGON = true,
    EVIL = true,
    FLY = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    HAS_LITE = true,
    MALE = true,
    OPEN_DOOR = true,
    POWERFUL = true,
    UNIQUE = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, only_item=true, '4d2' },
  drop = { treasure=50, combat=50, magic=0, tools=0, junk=0 },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={2,12} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={2,12} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={2,12} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={2,12} },
  },
  resolvers.talents {
    [Talents.T_NPC_BR_ACID] = 1,
    [Talents.T_NPC_BR_FIRE] = 1,
    [Talents.T_NPC_BR_COLD] = 1,
    [Talents.T_NPC_BR_ELEC] = 1,
    [Talents.T_NPC_BR_SOUN] = 1,
    [Talents.T_NPC_BR_CONF] = 1,
    [Talents.T_NPC_BR_SHAR] = 1,
    [Talents.T_NPC_BR_GRAV] = 1,
    [Talents.T_NPC_BR_NEXU] = 1,
  },
  body = { MAIN_HAND=0, OFF_HAND=0, BODY=1, CLOAK=1, LAUNCHER=0, QUIVER=1, GLOVES=0, BOOTS=0, HELM=2, RING=6, AMULET=2, LITE=1, TOOL=0, SYMBIOTE=1, INVEN=23 },
  speed = 10,
  vision = 20,
  alertness = 30,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'ANCIENT_WHITE_DRAGON',
  name = [[Ancient white dragon]],
  display = 'D',
  color = colors.C_w,
  multi_colors = { colors.C_w, colors.C_W },
  image = 'npc/ancient_white_dragon.png',
  desc = [[A huge draconic form. Frost covers it from head to tail.]],
  corpse_weight = 17000,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 6,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 72, 10 },
  ac = 90,
  max_life = 720,
  rarity = 1,
  level = 40,
  start_level = 40,
  exp_worth = 2000,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.OLD_SLEEP] = true,
  },
  vuln_dam = {
    [DamageType.FIRE] = true,
  },
  flags = {
    ATTR_MULTI = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    DRAGON = true,
    EVIL = true,
    FLY = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    HAS_LITE = true,
    MOVE_BODY = true,
    POWERFUL = true,
    SMART = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ '3d2', '4d2' },
  drop = { treasure=50, combat=50, magic=0, tools=0, junk=0 },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={4,8} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={4,8} },
    { type=DamageType.COLD, method=AttackType.BITE, dam={7,8} },
  },
  resolvers.talents {
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_BR_COLD] = 1,
  },
  body = bodies.dragon,
  speed = 10,
  vision = 20,
  alertness = 80,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'ANCIENT_GREEN_DRAGON',
  name = [[Ancient green dragon]],
  display = 'D',
  color = colors.C_g,
  multi_colors = { colors.C_g, colors.C_G },
  image = 'npc/ancient_green_dragon.png',
  desc = [[A huge draconic form enveloped in clouds of poisonous vapour.]],
  corpse_weight = 17000,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 6,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 72, 10 },
  ac = 90,
  max_life = 720,
  rarity = 1,
  level = 40,
  start_level = 40,
  exp_worth = 2000,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    ATTR_MULTI = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    DRAGON = true,
    EVIL = true,
    FLY = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    HAS_LITE = true,
    MOVE_BODY = true,
    POWERFUL = true,
    SMART = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ '3d2', '4d2' },
  drop = { treasure=50, combat=50, magic=0, tools=0, junk=0 },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={4,8} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={4,8} },
    { type=DamageType.POISON, method=AttackType.BITE, dam={7,8} },
  },
  resolvers.talents {
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_BR_POIS] = 1,
  },
  body = bodies.dragon,
  speed = 10,
  vision = 20,
  alertness = 80,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'ELDRAK',
  name = [[Eldrak]],
  display = 'T',
  color = colors.C_r,
  image = 'npc/eldrak.png',
  desc = [[A massive troll of huge strength. Eldraks are extremely stupid and extremely violent.]],
  corpse_weight = 700,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 75, 10 },
  ac = 80,
  max_life = 750,
  rarity = 3,
  level = 38,
  start_level = 38,
  exp_worth = 1500,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    EVIL = true,
    FORCE_MAXHP = true,
    MOVE_BODY = true,
    OPEN_DOOR = true,
    REGENERATE = true,
    TAKE_ITEM = true,
    TROLL = true,
  },
  placement_flags = { WILD_SHORE=true, WILD_WOOD=true },
  resolvers.mon_inven{ only_item=true, '2d2' },
  drop = { treasure=0, combat=100, magic=0, tools=0, junk=0 },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={3,6} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={3,6} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={3,4} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={3,4} },
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 20,
  alertness = 50,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'ETTIN',
  name = [[Ettin]],
  display = 'T',
  color = colors.C_b,
  image = 'npc/ettin.png',
  desc = [[A massive two-headed troll, larger and stronger than many men together. Fortunately, ettins are solitary creatures.  They are also living proof that two heads are not necessarily more intelligent than one...]],
  corpse_weight = 800,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 15, 100 },
  ac = 100,
  max_life = 1500,
  rarity = 3,
  level = 39,
  start_level = 39,
  exp_worth = 2000,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    EVIL = true,
    FORCE_MAXHP = true,
    MOVE_BODY = true,
    OPEN_DOOR = true,
    REGENERATE = true,
    TROLL = true,
  },
  placement_flags = { WILD_MOUNTAIN=true, WILD_SWAMP=true, WILD_TOO=true, WILD_WOOD=true },
  resolvers.mon_inven{ only_item=true, '1d2' },
  drop = { treasure=0, combat=100, magic=0, tools=0, junk=0 },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={3,8} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={3,8} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={3,8} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={3,8} },
  },
  body = { MAIN_HAND=1, OFF_HAND=1, BODY=1, CLOAK=1, LAUNCHER=1, QUIVER=1, GLOVES=1, BOOTS=1, HELM=2, RING=2, AMULET=2, LITE=1, TOOL=1, SYMBIOTE=1, INVEN=23 },
  speed = 0,
  vision = 20,
  alertness = 30,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'NIGHT_MARE',
  name = [[Night mare]],
  display = 'q',
  color = colors.C_G,
  image = 'npc/night_mare.png',
  desc = [[A fearsome skeletal horse with glowing eyes that watch you with little more than a hatred of all that lives. Its flying hooves do not touch the ground.]],
  corpse_weight = 600,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 15, 100 },
  ac = 85,
  max_life = 1500,
  rarity = 3,
  level = 39,
  start_level = 39,
  exp_worth = 2900,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    COLD_BLOOD = true,
    EVIL = true,
    FLY = true,
    FORCE_MAXHP = true,
    HAS_LITE = true,
    NO_CUT = true,
    OPEN_DOOR = true,
    UNDEAD = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ only_gold=true, '2d2' },
  attacks = {
    { type=DamageType.EXP_80, method=AttackType.BITE, dam={2,6} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={3,8} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={3,8} },
    { type=DamageType.CONFUSION, method=AttackType.HIT, dam={6,6} },
  },
  body = bodies.quadruped,
  speed = 10,
  vision = 30,
  alertness = 0,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'VAMPIRE_LORD',
  name = [[Vampire lord]],
  display = 'V',
  color = colors.C_b,
  image = 'npc/vampire_lord.png',
  desc = [[A foul wind chills your bones as this ghastly figure approaches.]],
  corpse_weight = 170,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 7,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 20, 100 },
  ac = 70,
  max_life = 2000,
  rarity = 1,
  level = 42,
  start_level = 42,
  exp_worth = 1800,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.DARK] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
    [DamageType.TELEPORT] = true,
  },
  vuln_dam = {
    [DamageType.LITE] = true,
    [DamageType.LITE_WEAK] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    COLD_BLOOD = true,
    EVIL = true,
    FLY = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    NO_CUT = true,
    OPEN_DOOR = true,
    REGENERATE = true,
    UNDEAD = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ '4d2', '60%' },
  drop = { treasure=0, combat=70, magic=30, tools=0, junk=0 },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={3,6} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={3,6} },
    { type=DamageType.EXP_80, method=AttackType.BITE, dam={4,6} },
    { type=DamageType.EXP_80, method=AttackType.BITE, dam={4,6} },
  },
  on_melee_hit = util.black_breath_melee_hit,
  resolvers.talents {
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_HOLD] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_CAUSE_3] = 1,
    [Talents.T_NPC_CAUSE_4] = 1,
    [Talents.T_NPC_DRAIN_MANA] = 1,
    [Talents.T_NPC_BRAIN_SMASH] = 1,
    [Talents.T_NPC_DARKNESS] = 1,
    [Talents.T_NPC_BO_NETH] = 1,
  },
  body = bodies.humanoid,
  speed = 10,
  vision = 20,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'ANCIENT_BLACK_DRAGON',
  name = [[Ancient black dragon]],
  display = 'D',
  color = colors.C_s,
  multi_colors = { colors.C_d, colors.C_D },
  image = 'npc/ancient_black_dragon.png',
  desc = [[A huge draconic form. Pools of acid melt the floor around it.]],
  corpse_weight = 17000,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 6,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 10, 100 },
  ac = 90,
  max_life = 1000,
  rarity = 1,
  level = 41,
  start_level = 41,
  exp_worth = 2500,
  resist_dam = {
    [DamageType.ACID] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.OLD_SLEEP] = true,
  },
  flags = {
    ATTR_MULTI = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    DRAGON = true,
    EVIL = true,
    FLY = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    MOVE_BODY = true,
    POWERFUL = true,
    SMART = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ '3d2', '4d2' },
  drop = { treasure=50, combat=50, magic=0, tools=0, junk=0 },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={4,9} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={4,9} },
    { type=DamageType.ACID, method=AttackType.BITE, dam={7,9} },
  },
  resolvers.talents {
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_BR_ACID] = 1,
  },
  body = bodies.dragon,
  speed = 10,
  vision = 20,
  alertness = 80,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'SHADOWFAX_STEED_OF_GANDALF',
  name = [[Shadowfax, steed of Gandalf]],
  display = 'q',
  color = colors.C_v,
  image = 'npc/shadowfax_steed_of_gandalf.png',
  desc = [[Shadowfax is the chief of the "Mearas", the greatest of all horses that are bred in the fields of Rohan.  Although the Mearas should technically be only ridden by the royal family of Rohan, only Gandalf the Wizard has ever succeeded in taming Shadowfax: and even then, Shadowfax will not be subjected to a bridle or saddle, but must be ridden bareback.]],
  corpse_weight = 260,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 30, 100 },
  ac = 100,
  faction = 'eru_manwe',
  max_life = 3000,
  rarity = 3,
  level = 40,
  start_level = 40,
  exp_worth = 2000,
  unique = 'SHADOWFAX_STEED_OF_GANDALF',
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.ELEC] = true,
    [DamageType.FEAR] = true,
    [DamageType.FIRE] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    FORCE_MAXHP = true,
    GOOD = true,
    MORTAL = true,
    REGENERATE = true,
    UNIQUE = true,
  },
  placement_flags = {},
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.KICK, dam={5,5} },
    { type=DamageType.PHYSICAL, method=AttackType.KICK, dam={5,5} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={6,6} },
  },
  body = bodies.quadruped,
  speed = 20,
  vision = 20,
  alertness = 50,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'SPIRIT_TROLL',
  name = [[Spirit troll]],
  display = 'G',
  color = colors.C_G,
  image = 'npc/spirit_troll.png',
  desc = [[A weird ghostly troll-like being from the ethereal plane.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 10, 100 },
  ac = 90,
  max_life = 1000,
  rarity = 3,
  level = 40,
  start_level = 40,
  exp_worth = 900,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.ELEC] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    EVIL = true,
    FLY = true,
    FORCE_MAXHP = true,
    INVISIBLE = true,
    NO_CUT = true,
    PASS_WALL = true,
    TROLL = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ '90%' },
  drop = { treasure=10, combat=90, magic=0, tools=0, junk=0 },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={3,6} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={3,5} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={3,5} },
  },
  body = bodies.none,
  speed = 0,
  vision = 20,
  alertness = 5,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'WAR_TROLL',
  name = [[War troll]],
  display = 'T',
  color = colors.C_b,
  image = 'npc/war_troll.png',
  desc = [[A massive troll, equipped with a scimitar and heavy armour.]],
  corpse_weight = 650,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 50, 10 },
  ac = 100,
  max_life = 500,
  rarity = 3,
  level = 40,
  start_level = 40,
  exp_worth = 800,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.FEAR] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  vuln_dam = {
    [DamageType.FIRE] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    EVIL = true,
    FORCE_MAXHP = true,
    FRIENDS = true,
    OPEN_DOOR = true,
    REGENERATE = true,
    TROLL = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ '90%' },
  drop = { treasure=0, combat=100, magic=0, tools=0, junk=0 },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={5,5} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={5,5} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={3,5} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={3,5} },
  },
  body = bodies.humanoid,
  speed = 10,
  vision = 20,
  alertness = 50,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'DISENCHANTER_WORM_MASS',
  name = [[Disenchanter worm mass]],
  display = 'w',
  color = colors.C_v,
  image = 'npc/disenchanter_worm_mass.png',
  desc = [[It is a strange mass of squirming worms. Magical energy crackles around its disgusting form.]],
  corpse_weight = 5,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=50,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 10, 8 },
  ac = 5,
  max_life = resolvers.dice(10, 8),
  rarity = 3,
  level = 40,
  start_level = 40,
  exp_worth = 30,
  resist_dam = {
    [DamageType.DARK] = true,
    [DamageType.DISEASE] = true,
    [DamageType.FEAR] = true,
  },
  vuln_dam = {
    [DamageType.LITE] = true,
    [DamageType.LITE_WEAK] = true,
  },
  flags = {
    ANIMAL = true,
    ATTR_MULTI = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    CAN_SWIM = true,
    MULTIPLY = true,
    NO_CUT = true,
    STUPID = true,
    WEIRD_MIND = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.DISENCHANT, method=AttackType.CRAWL, dam={1,4} },
  },
  body = bodies.none,
  speed = -10,
  vision = 7,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'ROTTING_QUYLTHULG',
  name = [[Rotting quylthulg]],
  display = 'Q',
  color = colors.C_u,
  image = 'npc/rotting_quylthulg.png',
  desc = [[It is a pulsing flesh mound that reeks of death and putrefaction.]],
  corpse_weight = 300,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 2,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 48, 10 },
  ac = 1,
  max_life = 480,
  rarity = 1,
  level = 45,
  start_level = 45,
  exp_worth = 3000,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.FEAR] = true,
    [DamageType.OLD_SLEEP] = true,
  },
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    EMPTY_MIND = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    INVISIBLE = true,
    NEVER_BLOW = true,
    NEVER_MOVE = true,
  },
  placement_flags = {},
  resolvers.talents {
    [Talents.T_NPC_BLINK] = 1,
    [Talents.T_NPC_TPORT] = 1,
    [Talents.T_NPC_S_UNDEAD] = 1,
  },
  body = bodies.none,
  speed = 10,
  vision = 20,
  alertness = 0,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'LESSER_TITAN',
  name = [[Lesser titan]],
  display = 'P',
  color = colors.C_y,
  image = 'npc/lesser_titan.png',
  desc = [[It is a humanoid figure thirty feet tall that gives off an aura of power and hate.]],
  corpse_weight = 3000,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 3,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 24, 100 },
  ac = 80,
  max_life = 2400,
  rarity = 3,
  level = 56,
  start_level = 56,
  exp_worth = 6000,
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    EVIL = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    GIANT = true,
    HAS_LITE = true,
    MALE = true,
    OPEN_DOOR = true,
    SMART = true,
    TAKE_ITEM = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, '4d2' },
  drop = { treasure=0, combat=100, magic=0, tools=0, junk=0 },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.CONFUSION, method=AttackType.HIT, dam={9,9} },
    { type=DamageType.CONFUSION, method=AttackType.HIT, dam={9,9} },
    { type=DamageType.CONFUSION, method=AttackType.HIT, dam={9,9} },
    { type=DamageType.CONFUSION, method=AttackType.HIT, dam={9,9} },
  },
  resolvers.talents {
    [Talents.T_NPC_HEAL] = 1,
    [Talents.T_NPC_TELE_TO] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_S_MONSTERS] = 1,
  },
  body = bodies.humanoid,
  speed = 10,
  vision = 30,
  alertness = 15,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = '9_HEADED_HYDRA',
  name = [[9-headed hydra]],
  display = 'M',
  color = colors.C_r,
  image = 'npc/9_headed_hydra.png',
  desc = [[A strange reptilian creature with nine smouldering heads.]],
  corpse_weight = 800,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 4,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 100, 12 },
  ac = 95,
  max_life = resolvers.dice(100, 12),
  rarity = 2,
  level = 40,
  start_level = 40,
  exp_worth = 3000,
  resist_dam = {
    [DamageType.FIRE] = true,
  },
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    CAN_SWIM = true,
    FORCE_SLEEP = true,
    MORTAL = true,
    MOVE_BODY = true,
    OPEN_DOOR = true,
  },
  placement_flags = { WILD_SHORE=true, WILD_SWAMP=true, WILD_TOO=true },
  resolvers.mon_inven{ only_gold=true, '3d2', '4d2' },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.FIRE, method=AttackType.BITE, dam={3,10} },
    { type=DamageType.FIRE, method=AttackType.BITE, dam={3,10} },
    { type=DamageType.FIRE, method=AttackType.BITE, dam={3,10} },
    { type=DamageType.FIRE, method=AttackType.BITE, dam={3,10} },
  },
  resolvers.talents {
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_BO_FIRE] = 1,
    [Talents.T_NPC_BR_FIRE] = 1,
  },
  body = bodies.hydra,
  speed = 10,
  vision = 20,
  alertness = 20,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'ENCHANTRESS',
  name = [[Enchantress]],
  display = 'p',
  color = colors.C_R,
  image = 'npc/enchantress.png',
  desc = [[This elusive female spellcaster has a special affinity for dragons, without whom she rarely fights.]],
  corpse_weight = 170,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 2,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 52, 10 },
  ac = 60,
  max_life = 520,
  rarity = 4,
  level = 40,
  start_level = 40,
  exp_worth = 2100,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.OLD_SLEEP] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    EVIL = true,
    FEMALE = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    HAS_LITE = true,
    MORTAL = true,
    OPEN_DOOR = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, only_item=true, '2d2' },
  drop = { treasure=0, combat=0, magic=100, tools=0, junk=0 },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={2,6} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={2,6} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={2,8} },
  },
  resolvers.talents {
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_S_DRAGON] = 1,
  },
  body = bodies.humanoid,
  speed = 20,
  vision = 20,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'RANGER_CHIEFTAIN',
  name = [[Ranger chieftain]],
  display = 'p',
  color = colors.C_W,
  image = 'npc/ranger_chieftain.png',
  desc = [[A chieftain among the Rangers.  His understanding of nature gives him powerful elemental spells to use against you, in addition to his skills as an archer and a warrior.  Furthermore, he is a master of camouflage, so you will need magically enhanced seeing to spot him.]],
  corpse_weight = 180,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 4,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 50, 20 },
  ac = 60,
  max_life = 1000,
  rarity = 2,
  level = 41,
  start_level = 41,
  exp_worth = 1800,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.ELEC] = true,
    [DamageType.FIRE] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    EVIL = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    HAS_LITE = true,
    INVISIBLE = true,
    MALE = true,
    MORTAL = true,
    OPEN_DOOR = true,
    SMART = true,
    TAKE_ITEM = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ only_item=true, '2d2' },
  drop = { treasure=30, combat=50, magic=20, tools=0, junk=0 },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={5,5} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={5,5} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={5,5} },
  },
  resolvers.talents {
    [Talents.T_NPC_S_MONSTERS] = 1,
    [Talents.T_NPC_ARROW_2] = 1,
    [Talents.T_NPC_ARROW_3] = 1,
    [Talents.T_NPC_ARROW_4] = 1,
    [Talents.T_NPC_MISSILE] = 1,
    [Talents.T_NPC_BO_FIRE] = 1,
    [Talents.T_NPC_BO_ELEC] = 1,
    [Talents.T_NPC_BA_COLD] = 1,
    [Talents.T_NPC_HASTE] = 1,
    [Talents.T_NPC_BLINK] = 1,
    [Talents.T_NPC_S_ANIMALS] = 1,
  },
  body = bodies.humanoid,
  speed = 10,
  vision = 20,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'SORCERER',
  name = [[Sorcerer]],
  display = 'p',
  color = colors.C_R,
  image = 'npc/sorcerer.png',
  desc = [[A human figure in robes, he moves with magically improved speed, and his hands are ablur with spell casting.]],
  corpse_weight = 170,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 2,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 52, 10 },
  ac = 60,
  max_life = 520,
  rarity = 2,
  level = 40,
  start_level = 40,
  exp_worth = 2150,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.OLD_SLEEP] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    EVIL = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    HAS_LITE = true,
    MALE = true,
    MORTAL = true,
    OPEN_DOOR = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ only_item=true, '4d2', '90%' },
  drop = { treasure=0, combat=0, magic=100, tools=0, junk=0 },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={2,8} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={2,8} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={2,8} },
  },
  resolvers.talents {
    [Talents.T_NPC_BLINK] = 1,
    [Talents.T_NPC_TELE_TO] = 1,
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_CAUSE_3] = 1,
    [Talents.T_NPC_TRAPS] = 1,
    [Talents.T_NPC_BO_ACID] = 1,
    [Talents.T_NPC_BA_FIRE] = 1,
    [Talents.T_NPC_BA_COLD] = 1,
    [Talents.T_NPC_S_MONSTER] = 1,
    [Talents.T_NPC_S_UNDEAD] = 1,
    [Talents.T_NPC_S_DRAGON] = 1,
  },
  body = bodies.humanoid,
  speed = 20,
  vision = 20,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'XAREN',
  name = [[Xaren]],
  self_plural = true,
  display = 'X',
  color = colors.C_s,
  image = 'npc/xaren.png',
  desc = [[It is a tougher relative of the Xorn. Its hide glitters with metal ores.]],
  corpse_weight = 50000,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 32, 10 },
  ac = 80,
  max_life = 320,
  rarity = 1,
  level = 40,
  start_level = 40,
  exp_worth = 1200,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.ELEC] = true,
    [DamageType.FIRE] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  vuln_dam = {
    [DamageType.ACID] = true,
    [DamageType.KILL_WALL] = true,
  },
  flags = {
    BASEANGBAND = true,
    COLD_BLOOD = true,
    EMPTY_MIND = true,
    FORCE_MAXHP = true,
    KILL_ITEM = true,
    NO_CUT = true,
    PASS_WALL = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ only_gold=true, '2d2' },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={3,4} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={3,4} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={3,4} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={3,4} },
  },
  body = { MAIN_HAND=0, OFF_HAND=0, BODY=0, CLOAK=0, LAUNCHER=0, QUIVER=0, GLOVES=0, BOOTS=0, HELM=0, RING=3, AMULET=0, LITE=0, TOOL=0, SYMBIOTE=0, INVEN=23 },
  speed = 10,
  vision = 20,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'GIANT_ROC',
  name = [[Giant roc]],
  display = 'B',
  color = colors.C_u,
  image = 'npc/giant_roc.png',
  desc = [[A vast legendary bird, its iron talons rake the most impenetrable of surfaces and its screech echoes through the many winding dungeon corridors.]],
  corpse_weight = 600,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 80, 13 },
  ac = 70,
  max_life = resolvers.dice(80, 13),
  rarity = 3,
  level = 40,
  start_level = 40,
  exp_worth = 1000,
  resist_dam = {
    [DamageType.ELEC] = true,
  },
  vuln_dam = {
    [DamageType.ACID] = true,
  },
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    FLY = true,
    HAS_EGG = true,
    MORTAL = true,
  },
  placement_flags = { WILD_MOUNTAIN=true, WILD_WOOD=true },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CRUSH, dam={8,12} },
    { type=DamageType.PHYSICAL, method=AttackType.CRUSH, dam={8,12} },
    { type=DamageType.ELEC, method=AttackType.HIT, dam={12,12} },
  },
  body = bodies.winged,
  speed = 0,
  vision = 20,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'MINOTAUR',
  name = [[Minotaur]],
  display = 'H',
  color = colors.C_U,
  image = 'npc/minotaur.png',
  desc = [[It is a cross between a human and a bull.]],
  corpse_weight = 1500,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 100, 10 },
  ac = 25,
  max_life = resolvers.dice(100, 10),
  rarity = 2,
  level = 40,
  start_level = 40,
  exp_worth = 2100,
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    EVIL = true,
    MORTAL = true,
  },
  placement_flags = {},
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.BUTT, dam={4,6} },
    { type=DamageType.PHYSICAL, method=AttackType.BUTT, dam={4,6} },
    { type=DamageType.PHYSICAL, method=AttackType.BUTT, dam={2,6} },
    { type=DamageType.PHYSICAL, method=AttackType.BUTT, dam={2,6} },
  },
  body = bodies.humanoid,
  speed = 20,
  vision = 13,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'MEDUSA_THE_GORGON',
  name = [[Medusa, the Gorgon]],
  display = 'n',
  color = colors.C_v,
  image = 'npc/medusa_the_gorgon.png',
  desc = [[One of the original three ugly sisters. Her face could sink a thousand ships. Her scales rattle as she slithers towards you, venom dripping from her ghastly mouth.]],
  corpse_weight = 400,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 2,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 24, 100 },
  ac = 100,
  max_life = 2400,
  rarity = 3,
  level = 40,
  start_level = 40,
  exp_worth = 9000,
  unique = 'MEDUSA_THE_GORGON',
  resist_dam = {
    [DamageType.ACID] = true,
    [DamageType.FIRE] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    EVIL = true,
    FEMALE = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    MORTAL = true,
    OPEN_DOOR = true,
    SMART = true,
    UNIQUE = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, only_item=true, '1d2', '2d2' },
  drop = { treasure=30, combat=35, magic=35, tools=0, junk=0 },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.EXP_80, method=AttackType.GAZE },
    { type=DamageType.PARALYZE, method=AttackType.GAZE },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={8,6} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={8,6} },
  },
  resolvers.talents {
    [Talents.T_NPC_HOLD] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_CAUSE_3] = 1,
    [Talents.T_NPC_BO_FIRE] = 1,
    [Talents.T_NPC_BO_PLAS] = 1,
    [Talents.T_NPC_BA_ACID] = 1,
    [Talents.T_NPC_S_HYDRA] = 1,
    [Talents.T_NPC_S_KIN] = 1,
  },
  body = { MAIN_HAND=1, OFF_HAND=1, BODY=1, CLOAK=1, LAUNCHER=1, QUIVER=1, GLOVES=1, BOOTS=1, HELM=0, RING=2, AMULET=0, LITE=1, TOOL=1, SYMBIOTE=1, INVEN=23 },
  speed = 10,
  vision = 30,
  alertness = 5,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'DEATH_DRAKE',
  name = [[Death drake]],
  display = 'D',
  color = colors.C_G,
  multi_colors = { colors.C_G, colors.C_g },
  image = 'npc/death_drake.png',
  desc = [[It is a dragon-like form wrapped in darkness. You cannot make out its true form but you sense its evil.]],
  corpse_weight = 17000,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 6,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 21, 100 },
  ac = 100,
  max_life = 2100,
  rarity = 2,
  level = 45,
  start_level = 45,
  exp_worth = 10000,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.NETHER] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.TELEPORT] = true,
  },
  flags = {
    ATTR_MULTI = true,
    BASEANGBAND = true,
    DRAGON = true,
    EVIL = true,
    FLY = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    INVISIBLE = true,
    MOVE_BODY = true,
    PASS_WALL = true,
    POWERFUL = true,
    TAKE_ITEM = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ only_item=true, '2d2', '4d2' },
  drop = { treasure=50, combat=50, magic=0, tools=0, junk=0 },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={4,10} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={4,10} },
    { type=DamageType.EXP_80, method=AttackType.BITE, dam={7,10} },
  },
  resolvers.talents {
    [Talents.T_NPC_SLOW] = 1,
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_BR_NETH] = 1,
  },
  body = bodies.dragon,
  speed = 10,
  vision = 25,
  alertness = 80,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'ANCIENT_RED_DRAGON',
  name = [[Ancient red dragon]],
  display = 'D',
  color = colors.C_r,
  multi_colors = { colors.C_r, colors.C_R },
  image = 'npc/ancient_red_dragon.png',
  desc = [[A huge draconic form. Wisps of smoke steam from its nostrils and the extreme heat surrounding it makes you gasp for breath.]],
  corpse_weight = 17000,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 6,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 10, 100 },
  ac = 90,
  max_life = 1000,
  rarity = 1,
  level = 41,
  start_level = 41,
  exp_worth = 2500,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.FIRE] = true,
    [DamageType.OLD_SLEEP] = true,
  },
  vuln_dam = {
    [DamageType.COLD] = true,
  },
  flags = {
    ATTR_MULTI = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    DRAGON = true,
    EVIL = true,
    FLY = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    HAS_LITE = true,
    MOVE_BODY = true,
    POWERFUL = true,
    SMART = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ '3d2', '4d2' },
  drop = { treasure=50, combat=50, magic=0, tools=0, junk=0 },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={4,9} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={4,9} },
    { type=DamageType.FIRE, method=AttackType.BITE, dam={7,9} },
  },
  resolvers.talents {
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_BR_FIRE] = 1,
  },
  body = bodies.dragon,
  speed = 10,
  vision = 20,
  alertness = 80,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'ANCIENT_GOLD_DRAGON',
  name = [[Ancient gold dragon]],
  display = 'D',
  color = colors.C_y,
  multi_colors = { colors.C_y, colors.C_U },
  image = 'npc/ancient_gold_dragon.png',
  desc = [[A huge draconic form wreathed in a nimbus of light. Its roar stuns and deafens you.]],
  corpse_weight = 17000,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 6,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 10, 100 },
  ac = 90,
  max_life = 1000,
  rarity = 1,
  level = 41,
  start_level = 41,
  exp_worth = 2500,
  resist_dam = {
    [DamageType.OLD_SLEEP] = true,
  },
  flags = {
    ATTR_MULTI = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    DRAGON = true,
    EVIL = true,
    FLY = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    HAS_LITE = true,
    MOVE_BODY = true,
    NO_STUN = true,
    POWERFUL = true,
    SMART = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ '3d2', '4d2' },
  drop = { treasure=50, combat=50, magic=0, tools=0, junk=0 },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={4,9} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={4,9} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={7,9} },
  },
  resolvers.talents {
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_BR_SOUN] = 1,
  },
  body = bodies.dragon,
  speed = 10,
  vision = 20,
  alertness = 80,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'GREAT_CRYSTAL_DRAKE',
  name = [[Great crystal drake]],
  display = 'D',
  color = colors.C_U,
  multi_colors = { colors.C_u, colors.C_U },
  image = 'npc/great_crystal_drake.png',
  desc = [[A huge crystalline dragon. Its claws could cut you to shreds and its teeth are razor sharp. Strange colours ripple through it as it moves in the light.]],
  corpse_weight = 17000,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 6,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 21, 100 },
  ac = 100,
  max_life = 2100,
  rarity = 2,
  level = 45,
  start_level = 45,
  exp_worth = 10000,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.OLD_SLEEP] = true,
  },
  flags = {
    ATTR_MULTI = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    DRAGON = true,
    EVIL = true,
    FLY = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    HAS_LITE = true,
    MOVE_BODY = true,
    NO_CUT = true,
    OPEN_DOOR = true,
    POWERFUL = true,
    REFLECTING = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ only_item=true, '2d2', '4d2' },
  drop = { treasure=50, combat=50, magic=0, tools=0, junk=0 },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={4,10} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={4,10} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={7,10} },
  },
  resolvers.talents {
    [Talents.T_NPC_SLOW] = 1,
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_BR_SHAR] = 1,
  },
  body = bodies.dragon,
  speed = 10,
  vision = 25,
  alertness = 80,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'VROCK',
  name = [[Vrock]],
  display = 'U',
  color = colors.C_s,
  image = 'npc/vrock.png',
  desc = [[It is a demon with a long neck and raking claws.]],
  corpse_weight = 270,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 8,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 40, 10 },
  ac = 50,
  max_life = 400,
  rarity = 2,
  level = 40,
  start_level = 40,
  exp_worth = 2000,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.FIRE] = true,
    [DamageType.OLD_SLEEP] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    DEMON = true,
    EVIL = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    FRIENDS = true,
    OPEN_DOOR = true,
    POWERFUL = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ only_item=true, '60%' },
  drop = { treasure=0, combat=50, magic=50, tools=0, junk=0 },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={3,4} },
    { type=DamageType.PHYSICAL, method=AttackType.CRUSH, dam={8,12} },
    { type=DamageType.PHYSICAL, method=AttackType.CRUSH, dam={8,12} },
  },
  resolvers.talents {
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_CONF] = 1,
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 20,
  alertness = 80,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'DEATH_QUASIT',
  name = [[Death quasit]],
  display = 'u',
  color = colors.C_D,
  image = 'npc/death_quasit.png',
  desc = [[It is a demon of small stature, but its armoured frame moves with lightning speed and its powers make it a tornado of death and destruction.]],
  corpse_weight = 60,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 10,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 44, 10 },
  ac = 80,
  max_life = 440,
  rarity = 3,
  level = 40,
  start_level = 40,
  exp_worth = 1000,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.FEAR] = true,
    [DamageType.FIRE] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
    [DamageType.TELEPORT] = true,
  },
  flags = {
    BASEANGBAND = true,
    DEMON = true,
    EVIL = true,
    FLY = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    INVISIBLE = true,
    NONLIVING = true,
    PASS_WALL = true,
    SMART = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ only_item=true, '2d2', '4d2', '90%' },
  drop = { treasure=0, combat=50, magic=50, tools=0, junk=0 },
  attacks = {
    { type=DamageType.LOSE_DEX, method=AttackType.BITE, dam={3,6} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={3,3} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={3,3} },
  },
  resolvers.talents {
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_CAUSE_3] = 1,
    [Talents.T_NPC_FORGET] = 1,
    [Talents.T_NPC_S_DEMON] = 1,
  },
  body = bodies.humanoid,
  speed = 20,
  vision = 20,
  alertness = 0,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'FALLEN_ANGEL',
  name = [[Fallen angel]],
  display = 'A',
  color = colors.C_s,
  image = 'npc/fallen_angel.png',
  desc = [[An angelic being, who was mighty once, but dared defy its Creator.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 3,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 100, 25 },
  ac = 90,
  max_life = resolvers.dice(100, 25),
  rarity = 6,
  level = 49,
  start_level = 49,
  exp_worth = 8000,
  resist_dam = {
    [DamageType.ACID] = true,
    [DamageType.COLD] = true,
    [DamageType.ELEC] = true,
    [DamageType.FEAR] = true,
    [DamageType.FIRE] = true,
    [DamageType.NETHER] = true,
    [DamageType.POISON] = true,
    [DamageType.TELEPORT] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    EVIL = true,
    FLY = true,
    FORCE_SLEEP = true,
    HAS_LITE = true,
    MOVE_BODY = true,
    OPEN_DOOR = true,
    POWERFUL = true,
    REFLECTING = true,
    SMART = true,
    TAKE_ITEM = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, only_item=true, '3d2', '4d2' },
  drop = { treasure=0, combat=50, magic=50, tools=0, junk=0 },
  attacks = {
    { type=DamageType.EXP_40, method=AttackType.GAZE, dam={4,4} },
    { type=DamageType.EXP_40, method=AttackType.GAZE, dam={4,4} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={6,6} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={6,6} },
  },
  resolvers.talents {
    [Talents.T_NPC_TELE_TO] = 1,
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_CAUSE_2] = 1,
    [Talents.T_NPC_CAUSE_4] = 1,
    [Talents.T_NPC_S_DEMON] = 1,
    [Talents.T_NPC_BO_NETH] = 1,
  },
  body = bodies.humanoid,
  speed = 20,
  vision = 30,
  alertness = 255,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'DARK_ELVEN_SORCERER',
  name = [[Dark elven sorcerer]],
  display = 'h',
  color = colors.C_R,
  image = 'npc/dark_elven_sorcerer.png',
  desc = [[A dark elven figure, dressed in deepest black. Power seems to crackle from his slender frame.]],
  corpse_weight = 130,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 2,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 80, 10 },
  ac = 70,
  max_life = 800,
  rarity = 2,
  level = 41,
  start_level = 41,
  exp_worth = 3000,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.DARK] = true,
    [DamageType.OLD_SLEEP] = true,
  },
  vuln_dam = {
    [DamageType.LITE] = true,
    [DamageType.LITE_WEAK] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    EVIL = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    HAS_LITE = true,
    MALE = true,
    OPEN_DOOR = true,
    SMART = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ only_item=true, '4d2', '90%' },
  drop = { treasure=0, combat=0, magic=100, tools=0, junk=0 },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={2,8} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={2,8} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={2,8} },
  },
  resolvers.talents {
    [Talents.T_NPC_HEAL] = 1,
    [Talents.T_NPC_BLINK] = 1,
    [Talents.T_NPC_TELE_TO] = 1,
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_CAUSE_3] = 1,
    [Talents.T_NPC_DARKNESS] = 1,
    [Talents.T_NPC_BO_ACID] = 1,
    [Talents.T_NPC_BA_FIRE] = 1,
    [Talents.T_NPC_BA_COLD] = 1,
    [Talents.T_NPC_ANIM_DEAD] = 1,
    [Talents.T_NPC_S_MONSTER] = 1,
    [Talents.T_NPC_S_UNDEAD] = 1,
    [Talents.T_NPC_S_DEMON] = 1,
    [Talents.T_NPC_MISSILE] = 1,
  },
  body = bodies.humanoid,
  speed = 20,
  vision = 20,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'MASTER_LICH',
  name = [[Master lich]],
  display = 'L',
  color = colors.C_r,
  image = 'npc/master_lich.png',
  desc = [[A skeletal form wrapped in robes. Powerful magic crackles along its bony fingers.]],
  corpse_weight = 180,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 3,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 18, 100 },
  ac = 80,
  max_life = 1800,
  rarity = 2,
  level = 41,
  start_level = 41,
  exp_worth = 7000,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
    [DamageType.TELEPORT] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    COLD_BLOOD = true,
    EVIL = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    NO_CUT = true,
    OPEN_DOOR = true,
    SMART = true,
    UNDEAD = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ only_item=true, '2d2', '4d2' },
  drop = { treasure=10, combat=45, magic=25, tools=10, junk=10 },
  attacks = {
    { type=DamageType.EXP_80, method=AttackType.TOUCH },
    { type=DamageType.UN_POWER, method=AttackType.TOUCH },
    { type=DamageType.LOSE_DEX, method=AttackType.TOUCH, dam={2,12} },
    { type=DamageType.LOSE_DEX, method=AttackType.TOUCH, dam={2,12} },
  },
  on_melee_hit = util.black_breath_melee_hit,
  resolvers.talents {
    [Talents.T_NPC_BLINK] = 1,
    [Talents.T_NPC_TELE_TO] = 1,
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_HOLD] = 1,
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_CAUSE_3] = 1,
    [Talents.T_NPC_CAUSE_4] = 1,
    [Talents.T_NPC_DRAIN_MANA] = 1,
    [Talents.T_NPC_BRAIN_SMASH] = 1,
    [Talents.T_NPC_S_UNDEAD] = 1,
  },
  body = bodies.humanoid,
  speed = 10,
  vision = 20,
  alertness = 50,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'EOL_THE_DARK_ELF',
  name = [[Eöl, the Dark Elf]],
  display = 'h',
  color = colors.C_D,
  image = 'npc/eol_the_dark_elf.png',
  desc = [[A lord of the Teleri, Eöl is a mighty metalsmith, the first one ever to forge weapons of meteorite iron.  His dark countenance glares at you in disdain.]],
  corpse_weight = 140,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 3,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 80, 30 },
  ac = 100,
  max_life = 2400,
  level = 49,
  start_level = 49,
  exp_worth = 25000,
  unique = 'EOL_THE_DARK_ELF',
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.DARK] = true,
    [DamageType.ELEC] = true,
    [DamageType.FIRE] = true,
    [DamageType.POISON] = true,
  },
  vuln_dam = {
    [DamageType.LITE] = true,
    [DamageType.LITE_WEAK] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    CAN_SPEAK = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    HAS_LITE = true,
    MALE = true,
    OPEN_DOOR = true,
    REFLECTING = true,
    SMART = true,
    SPECIAL_GENE = true,
    UNIQUE = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, only_item=true, '2d2', '4d2' },
  drop = { treasure=10, combat=40, magic=40, tools=10, junk=0 },
  drop_corpse = { corpse=true },
  drop_special = function(self) return rng.percent(50) and game.zone:makeEntityByName(game.level, 'artifact', 'ANGUIREL', false) end,
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={3,8} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={3,8} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={3,8} },
  },
  resolvers.talents {
    [Talents.T_NPC_HEAL] = 1,
    [Talents.T_NPC_BLINK] = 1,
    [Talents.T_NPC_TELE_TO] = 1,
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_CAUSE_4] = 1,
    [Talents.T_NPC_DARKNESS] = 1,
    [Talents.T_NPC_BA_NETH] = 1,
    [Talents.T_NPC_BA_ELEC] = 1,
    [Talents.T_NPC_BA_ACID] = 1,
    [Talents.T_NPC_BA_FIRE] = 1,
    [Talents.T_NPC_BA_COLD] = 1,
    [Talents.T_NPC_BO_MANA] = 1,
    [Talents.T_NPC_S_MONSTERS] = 1,
    [Talents.T_NPC_S_UNDEAD] = 1,
    [Talents.T_NPC_S_DRAGON] = 1,
    [Talents.T_NPC_S_DEMON] = 1,
  },
  body = bodies.humanoid,
  speed = 20,
  vision = 20,
  alertness = 60,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'ARCHON',
  name = [[Archon]],
  display = 'A',
  color = colors.C_y,
  image = 'npc/archon.png',
  desc = [[Never a more heavenly being have you seen. The very holiness of its presence makes you deeply respect it. Few creatures can match the powers of an Archon; fewer still live to tell the tale after attacking one.]],
  corpse_weight = 320,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 3,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 100, 35 },
  ac = 140,
  faction = 'eru_manwe',
  max_life = resolvers.dice(100, 35),
  rarity = 5,
  level = 55,
  start_level = 55,
  exp_worth = 12000,
  resist_dam = {
    [DamageType.ACID] = true,
    [DamageType.COLD] = true,
    [DamageType.ELEC] = true,
    [DamageType.FEAR] = true,
    [DamageType.FIRE] = true,
    [DamageType.POISON] = true,
    [DamageType.TELEPORT] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    FLY = true,
    FORCE_SLEEP = true,
    GOOD = true,
    HAS_LITE = true,
    MOVE_BODY = true,
    OPEN_DOOR = true,
    POWERFUL = true,
    REFLECTING = true,
    SMART = true,
    TAKE_ITEM = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, only_item=true, '3d2', '4d2' },
  drop = { treasure=0, combat=100, magic=0, tools=0, junk=0 },
  attacks = {
    { type=DamageType.FEAR, method=AttackType.GAZE, dam={4,4} },
    { type=DamageType.FEAR, method=AttackType.GAZE, dam={4,4} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={8,6} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={8,6} },
  },
  resolvers.talents {
    [Talents.T_NPC_TELE_TO] = 1,
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_CAUSE_2] = 1,
    [Talents.T_NPC_CAUSE_4] = 1,
    [Talents.T_NPC_BO_MANA] = 1,
    [Talents.T_NPC_S_ANGEL] = 1,
  },
  body = bodies.humanoid,
  speed = 20,
  vision = 30,
  alertness = 255,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'UNDEAD_BEHOLDER',
  name = [[Undead beholder]],
  display = 'e',
  color = colors.C_u,
  image = 'npc/undead_beholder.png',
  desc = [[A beholder which has cheated death.  Black nether storms rage around the bloodshot pupil of its central giant eye, and light seems to bend as it sucks its power from the very air around it.  Your soul chills as it drains your vitality for its evil enchantments.]],
  corpse_weight = 160,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 2,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 27, 100 },
  ac = 100,
  max_life = 2700,
  rarity = 3,
  level = 45,
  start_level = 45,
  exp_worth = 8000,
  resist_dam = {
    [DamageType.ACID] = true,
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.ELEC] = true,
    [DamageType.FIRE] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
    [DamageType.TELEPORT] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    COLD_BLOOD = true,
    EVIL = true,
    FLY = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    NO_CUT = true,
    UNDEAD = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.EXP_40, method=AttackType.GAZE, dam={3,6} },
    { type=DamageType.UN_POWER, method=AttackType.GAZE, dam={3,6} },
    { type=DamageType.INSANITY, method=AttackType.GAZE, dam={3,6} },
    { type=DamageType.EXP_40, method=AttackType.BITE, dam={7,6} },
  },
  on_melee_hit = util.black_breath_melee_hit,
  resolvers.talents {
    [Talents.T_NPC_SLOW] = 1,
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_CAUSE_4] = 1,
    [Talents.T_NPC_DRAIN_MANA] = 1,
    [Talents.T_NPC_MIND_BLAST] = 1,
    [Talents.T_NPC_FORGET] = 1,
    [Talents.T_NPC_BO_MANA] = 1,
    [Talents.T_NPC_BO_NETH] = 1,
    [Talents.T_NPC_BRAIN_SMASH] = 1,
    [Talents.T_NPC_BA_FIRE] = 1,
    [Talents.T_NPC_BA_COLD] = 1,
    [Talents.T_NPC_BO_ACID] = 1,
    [Talents.T_NPC_S_UNDEAD] = 1,
    [Talents.T_NPC_ANIM_DEAD] = 1,
  },
  body = bodies.none,
  speed = 10,
  vision = 30,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'SHADOW',
  name = [[Shadow]],
  display = 'G',
  color = colors.C_D,
  image = 'npc/shadow.png',
  desc = [[A mighty spirit of darkness of vaguely humanoid form. Razor-edged claws reach out to end your life as it glides towards you, seeking to suck the energy from your soul to feed its power.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 8,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 10, 20 },
  ac = 30,
  max_life = resolvers.dice(10, 20),
  rarity = 3,
  level = 37,
  start_level = 37,
  exp_worth = 400,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.DARK] = true,
    [DamageType.NETHER] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  vuln_dam = {
    [DamageType.LITE] = true,
    [DamageType.LITE_WEAK] = true,
  },
  flags = {
    BASEANGBAND = true,
    COLD_BLOOD = true,
    EVIL = true,
    FLY = true,
    FORCE_SLEEP = true,
    INVISIBLE = true,
    NO_CUT = true,
    PASS_WALL = true,
    POWERFUL = true,
    REGENERATE = true,
    UNDEAD = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ only_item=true, '1d2' },
  drop = { treasure=90, combat=10, magic=0, tools=0, junk=0 },
  attacks = {
    { type=DamageType.EXP_80, method=AttackType.TOUCH },
    { type=DamageType.EXP_40, method=AttackType.TOUCH },
    { type=DamageType.LOSE_INT, method=AttackType.CLAW, dam={1,10} },
    { type=DamageType.LOSE_WIS, method=AttackType.CLAW, dam={1,10} },
  },
  resolvers.talents {
    [Talents.T_NPC_BO_NETH] = 1,
    [Talents.T_NPC_TELE_TO] = 1,
    [Talents.T_NPC_SLOW] = 1,
  },
  body = bodies.none,
  speed = 10,
  vision = 30,
  alertness = 20,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'IRON_LICH',
  name = [[Iron lich]],
  display = 'L',
  color = colors.C_s,
  image = 'npc/iron_lich.png',
  desc = [[It is a huge, twisted grey skull floating through the air. Its cold eyes burn with hatred towards all who live.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 2,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 22, 100 },
  ac = 100,
  max_life = 2200,
  rarity = 4,
  level = 42,
  start_level = 42,
  exp_worth = 10000,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.ELEC] = true,
    [DamageType.FIRE] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
    [DamageType.TELEPORT] = true,
  },
  vuln_dam = {
    [DamageType.ACID] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    COLD_BLOOD = true,
    EVIL = true,
    FLY = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    NO_CUT = true,
    POWERFUL = true,
    REFLECTING = true,
    SMART = true,
    UNDEAD = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, only_item=true, '60%' },
  drop = { treasure=0, combat=0, magic=100, tools=0, junk=0 },
  attacks = {
    { type=DamageType.COLD, method=AttackType.BUTT, dam={3,6} },
    { type=DamageType.FIRE, method=AttackType.BUTT, dam={3,6} },
    { type=DamageType.ELEC, method=AttackType.BUTT, dam={3,6} },
  },
  on_melee_hit = util.black_breath_melee_hit,
  resolvers.talents {
    [Talents.T_NPC_BA_WATE] = 1,
    [Talents.T_NPC_BA_FIRE] = 1,
    [Talents.T_NPC_BO_ICEE] = 1,
    [Talents.T_NPC_BA_ELEC] = 1,
    [Talents.T_NPC_BA_COLD] = 1,
    [Talents.T_NPC_CAUSE_4] = 1,
    [Talents.T_NPC_DRAIN_MANA] = 1,
    [Talents.T_NPC_BRAIN_SMASH] = 1,
    [Talents.T_NPC_S_UNDEAD] = 1,
  },
  body = bodies.snake,
  speed = 10,
  vision = 30,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'DREAD_GRP',
  name = [[Dread]],
  display = 'G',
  color = colors.C_o,
  image = 'npc/dread_grp.png',
  desc = [[It is a form that screams its presence against the eye. Death incarnate, its hideous black body seems to struggle against reality as the universe itself struggles to banish it.]],
  corpse_weight = 100,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=25,
    talent_in = 15,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 25, 20 },
  ac = 30,
  max_life = resolvers.dice(25, 20),
  rarity = 1,
  level = 42,
  start_level = 42,
  exp_worth = 600,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    COLD_BLOOD = true,
    EVIL = true,
    FLY = true,
    FORCE_SLEEP = true,
    FRIENDS = true,
    INVISIBLE = true,
    NO_CUT = true,
    PASS_WALL = true,
    TAKE_ITEM = true,
    UNDEAD = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ only_item=true, '60%' },
  drop = { treasure=0, combat=50, magic=50, tools=0, junk=0 },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={6,6} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={6,6} },
    { type=DamageType.LOSE_STR, method=AttackType.HIT, dam={3,4} },
  },
  on_melee_hit = util.black_breath_melee_hit,
  resolvers.talents {
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_HOLD] = 1,
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_DRAIN_MANA] = 1,
    [Talents.T_NPC_BO_NETH] = 1,
  },
  body = bodies.none,
  speed = 10,
  vision = 20,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'GREATER_BASILISK',
  name = [[Greater basilisk]],
  display = 'R',
  color = colors.C_D,
  image = 'npc/greater_basilisk.png',
  desc = [[A large basilisk, whose shape resembles that of a great wyrm.]],
  corpse_weight = 300,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 8,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 20, 100 },
  ac = 100,
  max_life = resolvers.dice(20, 100),
  rarity = 2,
  level = 42,
  start_level = 42,
  exp_worth = 10000,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    CAN_SWIM = true,
    EVIL = true,
    MORTAL = true,
    OPEN_DOOR = true,
    POWERFUL = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, only_item=true, '1d2' },
  drop = { treasure=0, combat=50, magic=50, tools=0, junk=0 },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PARALYZE, method=AttackType.GAZE, dam={3,12} },
    { type=DamageType.PARALYZE, method=AttackType.GAZE, dam={3,12} },
    { type=DamageType.POISON, method=AttackType.BITE, dam={2,12} },
    { type=DamageType.POISON, method=AttackType.BITE, dam={2,12} },
  },
  resolvers.talents {
    [Talents.T_NPC_BR_POIS] = 1,
    [Talents.T_NPC_BR_DARK] = 1,
    [Talents.T_NPC_BR_NEXU] = 1,
  },
  body = bodies.quadruped,
  speed = 10,
  vision = 25,
  alertness = 15,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'MUMAK_GRP',
  name = [[Mûmak]],
  plural_name = [[Mûmakil]],
  display = 'q',
  color = colors.C_s,
  image = 'npc/mumak_grp.png',
  desc = [[A massive elephantine form with eyes twisted by madness.]],
  corpse_weight = 15000,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 90, 10 },
  ac = 55,
  max_life = resolvers.dice(90, 10),
  rarity = 2,
  level = 63,
  start_level = 63,
  exp_worth = 2100,
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    FRIENDS = true,
    MORTAL = true,
  },
  placement_flags = {},
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.BUTT, dam={8,6} },
    { type=DamageType.PHYSICAL, method=AttackType.BUTT, dam={8,6} },
    { type=DamageType.PHYSICAL, method=AttackType.CRUSH, dam={8,4} },
  },
  body = bodies.quadruped,
  speed = 0,
  vision = 20,
  alertness = 100,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'ANCIENT_MULTI_HUED_DRAGON',
  name = [[Ancient multi-hued dragon]],
  display = 'D',
  color = colors.C_v,
  multi_colors = { colors.C_d, colors.C_r, colors.C_w, colors.C_b, colors.C_g },
  image = 'npc/ancient_multi_hued_dragon.png',
  desc = [[A huge draconic form. Many colours ripple down its massive frame. Few live to see another.]],
  corpse_weight = 17000,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 5,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 21, 100 },
  ac = 100,
  max_life = 2100,
  rarity = 1,
  level = 43,
  start_level = 43,
  exp_worth = 13000,
  resist_dam = {
    [DamageType.ACID] = true,
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.ELEC] = true,
    [DamageType.FIRE] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    ATTR_MULTI = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    DRAGON = true,
    EVIL = true,
    FLY = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    HAS_LITE = true,
    MOVE_BODY = true,
    OPEN_DOOR = true,
    POWERFUL = true,
    SMART = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ only_item=true, '2d2', '3d2', '4d2' },
  drop = { treasure=50, combat=50, magic=0, tools=0, junk=0 },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={4,10} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={4,10} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={7,10} },
  },
  resolvers.talents {
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_BR_ACID] = 1,
    [Talents.T_NPC_BR_FIRE] = 1,
    [Talents.T_NPC_BR_COLD] = 1,
    [Talents.T_NPC_BR_ELEC] = 1,
    [Talents.T_NPC_BR_POIS] = 1,
  },
  body = bodies.dragon,
  speed = 10,
  vision = 25,
  alertness = 80,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'ETHEREAL_DRAGON',
  name = [[Ethereal dragon]],
  display = 'D',
  color = colors.C_o,
  multi_colors = { colors.C_y, colors.C_D, colors.C_U },
  image = 'npc/ethereal_dragon.png',
  desc = [[A huge dragon emanating from the ethereal plane, this terrible creature is a master of light and dark. Its form disappears from sight as it cloaks itself in unearthly shadows.]],
  corpse_weight = 17000,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 6,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 21, 100 },
  ac = 100,
  max_life = 2100,
  rarity = 2,
  level = 45,
  start_level = 45,
  exp_worth = 10000,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.OLD_SLEEP] = true,
  },
  flags = {
    ATTR_MULTI = true,
    BASEANGBAND = true,
    DRAGON = true,
    FLY = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    INVISIBLE = true,
    MOVE_BODY = true,
    PASS_WALL = true,
    POWERFUL = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ only_item=true, '2d2', '4d2' },
  drop = { treasure=50, combat=50, magic=0, tools=0, junk=0 },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={4,10} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={4,10} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={7,10} },
  },
  resolvers.talents {
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_BR_LITE] = 1,
    [Talents.T_NPC_BR_DARK] = 1,
    [Talents.T_NPC_BR_CONF] = 1,
  },
  body = bodies.dragon,
  speed = 10,
  vision = 25,
  alertness = 80,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'QUAKER_MASTER_OF_EARTH',
  name = [[Quaker, Master of Earth]],
  display = 'E',
  color = colors.C_u,
  image = 'npc/quaker_master_of_earth.png',
  desc = [[A towering stone elemental stands before you. The walls and ceiling are reduced to rubble as Quaker advances.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 6,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 28, 100 },
  ac = 97,
  max_life = 2800,
  rarity = 3,
  level = 43,
  start_level = 43,
  exp_worth = 4500,
  unique = 'QUAKER_MASTER_OF_EARTH',
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.ELEC] = true,
    [DamageType.FEAR] = true,
    [DamageType.FIRE] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  vuln_dam = {
    [DamageType.KILL_WALL] = true,
  },
  flags = {
    BASEANGBAND = true,
    CAN_SPEAK = true,
    COLD_BLOOD = true,
    EMPTY_MIND = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    KILL_BODY = true,
    KILL_ITEM = true,
    KILL_WALL = true,
    MALE = true,
    NO_CUT = true,
    NO_STUN = true,
    PASS_WALL = true,
    POWERFUL = true,
    UNIQUE = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={6,6} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={6,6} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={6,6} },
    { type=DamageType.SHATTER, method=AttackType.HIT, dam={10,10} },
  },
  resolvers.talents {
    [Talents.T_NPC_BO_ACID] = 1,
    [Talents.T_NPC_BA_ACID] = 1,
  },
  body = bodies.none,
  speed = 0,
  vision = 10,
  alertness = 90,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'ARIEL_QUEEN_OF_AIR',
  name = [[Ariel, Queen of Air]],
  display = 'E',
  color = colors.C_B,
  image = 'npc/ariel_queen_of_air.png',
  desc = [[A towering air elemental, Ariel the sorceress avoids your blows with her extreme speed.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=25,
    talent_in = 5,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 27, 100 },
  ac = 50,
  max_life = 2700,
  rarity = 3,
  level = 43,
  start_level = 43,
  exp_worth = 4750,
  unique = 'ARIEL_QUEEN_OF_AIR',
  resist_dam = {
    [DamageType.ACID] = true,
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.ELEC] = true,
    [DamageType.FEAR] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  melee_retal = {
    [DamageType.ELEC] = 'mondam',
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    CAN_SPEAK = true,
    COLD_BLOOD = true,
    EMPTY_MIND = true,
    FEMALE = true,
    FLY = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    KILL_BODY = true,
    KILL_ITEM = true,
    NO_CUT = true,
    POWERFUL = true,
    UNIQUE = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={4,6} },
    { type=DamageType.CONFUSION, method=AttackType.HIT, dam={4,4} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={4,6} },
    { type=DamageType.CONFUSION, method=AttackType.HIT, dam={4,4} },
  },
  resolvers.talents {
    [Talents.T_NPC_BO_ELEC] = 1,
    [Talents.T_NPC_BA_COLD] = 1,
    [Talents.T_NPC_BA_ELEC] = 1,
  },
  body = bodies.none,
  speed = 20,
  vision = 12,
  alertness = 50,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = '11_HEADED_HYDRA',
  name = [[11-headed hydra]],
  display = 'M',
  color = colors.C_R,
  image = 'npc/11_headed_hydra.png',
  desc = [[A strange reptilian hybrid with eleven smouldering heads.]],
  corpse_weight = 850,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 4,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 100, 18 },
  ac = 100,
  max_life = resolvers.dice(100, 18),
  rarity = 2,
  level = 44,
  start_level = 44,
  exp_worth = 6000,
  resist_dam = {
    [DamageType.FIRE] = true,
  },
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    CAN_SWIM = true,
    FORCE_SLEEP = true,
    MORTAL = true,
    MOVE_BODY = true,
    OPEN_DOOR = true,
  },
  placement_flags = { WILD_SHORE=true, WILD_SWAMP=true, WILD_TOO=true },
  resolvers.mon_inven{ only_gold=true, '2d2', '4d2' },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.FIRE, method=AttackType.BITE, dam={3,12} },
    { type=DamageType.FIRE, method=AttackType.BITE, dam={3,12} },
    { type=DamageType.FIRE, method=AttackType.BITE, dam={3,12} },
    { type=DamageType.FIRE, method=AttackType.BITE, dam={3,12} },
  },
  resolvers.talents {
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_BO_FIRE] = 1,
    [Talents.T_NPC_BO_PLAS] = 1,
    [Talents.T_NPC_BA_FIRE] = 1,
    [Talents.T_NPC_BR_FIRE] = 1,
  },
  body = bodies.hydra,
  speed = 10,
  vision = 20,
  alertness = 20,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'PATRIARCH',
  name = [[Patriarch]],
  plural_name = [[Patriarchs]],
  display = 'p',
  color = colors.C_G,
  image = 'npc/patriarch.png',
  desc = [[An evil priest, dressed all in black.  Deadly spells hit you at an alarming rate as his black spiked mace rains down blow after blow on your pitiful frame.]],
  corpse_weight = 180,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 2,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 52, 10 },
  ac = 60,
  max_life = 520,
  rarity = 2,
  level = 40,
  start_level = 40,
  exp_worth = 1800,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.OLD_SLEEP] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    EVIL = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    HAS_LITE = true,
    MALE = true,
    MORTAL = true,
    OPEN_DOOR = true,
    SMART = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ only_item=true, '2d2', '90%' },
  drop = { treasure=0, combat=10, magic=90, tools=0, junk=0 },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={3,4} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={3,4} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={3,5} },
  },
  resolvers.talents {
    [Talents.T_NPC_HEAL] = 1,
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_HOLD] = 1,
    [Talents.T_NPC_CAUSE_4] = 1,
    [Talents.T_NPC_CAUSE_3] = 1,
    [Talents.T_NPC_ANIM_DEAD] = 1,
    [Talents.T_NPC_S_MONSTERS] = 1,
    [Talents.T_NPC_S_UNDEAD] = 1,
  },
  body = bodies.humanoid,
  speed = 10,
  vision = 20,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'DREADMASTER',
  name = [[Dreadmaster]],
  display = 'G',
  color = colors.C_y,
  image = 'npc/dreadmaster.png',
  desc = [[It is an unlife of power almost unequalled. An affront to existence, its very touch abuses and disrupts the flow of life, and its unearthly limbs, of purest black, crush rock and flesh with ease.]],
  corpse_weight = 100,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=25,
    talent_in = 9,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 12, 100 },
  ac = 100,
  max_life = 1200,
  rarity = 2,
  level = 44,
  start_level = 44,
  exp_worth = 8000,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    COLD_BLOOD = true,
    EVIL = true,
    FLY = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    INVISIBLE = true,
    NO_CUT = true,
    PASS_WALL = true,
    SMART = true,
    TAKE_ITEM = true,
    UNDEAD = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ only_item=true, '1d2', '4d2' },
  drop = { treasure=10, combat=40, magic=25, tools=10, junk=15 },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={6,6} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={6,6} },
    { type=DamageType.LOSE_STR, method=AttackType.HIT, dam={3,4} },
    { type=DamageType.LOSE_STR, method=AttackType.HIT, dam={3,4} },
  },
  on_melee_hit = util.black_breath_melee_hit,
  resolvers.talents {
    [Talents.T_NPC_TELE_LEVEL] = 1,
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_HOLD] = 1,
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_CAUSE_4] = 1,
    [Talents.T_NPC_DRAIN_MANA] = 1,
    [Talents.T_NPC_BO_NETH] = 1,
    [Talents.T_NPC_S_UNDEAD] = 1,
  },
  body = bodies.none,
  speed = 10,
  vision = 20,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'DROLEM',
  name = [[Drolem]],
  display = 'g',
  color = colors.C_g,
  multi_colors = { colors.C_g, colors.C_G },
  image = 'npc/drolem.png',
  desc = [[A constructed dragon, the drolem has massive strength. Powerful spells weaved during its creation make it a fearsome adversary. Its eyes show little intelligence, but it has been instructed to destroy all it meets.]],
  corpse_weight = 4000,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 6,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 30, 100 },
  ac = 130,
  max_life = 3000,
  rarity = 3,
  level = 44,
  start_level = 44,
  exp_worth = 12000,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.ELEC] = true,
    [DamageType.FEAR] = true,
    [DamageType.FIRE] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
    [DamageType.TELEPORT] = true,
  },
  flags = {
    ATTR_MULTI = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    CAN_SWIM = true,
    COLD_BLOOD = true,
    DRAGON = true,
    EMPTY_MIND = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    NONLIVING = true,
    NO_CUT = true,
    OPEN_DOOR = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={3,10} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={3,10} },
    { type=DamageType.POISON, method=AttackType.BITE, dam={5,10} },
    { type=DamageType.POISON, method=AttackType.BITE, dam={5,10} },
  },
  resolvers.talents {
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_SLOW] = 1,
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_ARROW_3] = 1,
    [Talents.T_NPC_BR_POIS] = 1,
  },
  body = bodies.dragon,
  speed = 10,
  vision = 25,
  alertness = 30,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'SCATHA_THE_WORM',
  name = [[Scatha the Worm]],
  display = 'D',
  color = colors.C_W,
  image = 'npc/scatha_the_worm.png',
  desc = [[An ancient and wise dragon, Scatha has grown clever over the long years. His scales are covered with frost, and his breath sends a shower of ice into the air.]],
  corpse_weight = 21000,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 4,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 22, 100 },
  ac = 130,
  max_life = 2200,
  rarity = 2,
  level = 46,
  start_level = 46,
  exp_worth = 17000,
  unique = 'SCATHA_THE_WORM',
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
  },
  vuln_dam = {
    [DamageType.FIRE] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    DRAGON = true,
    EVIL = true,
    FLY = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    HAS_LITE = true,
    MALE = true,
    MOVE_BODY = true,
    POWERFUL = true,
    UNIQUE = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, only_item=true, '3d2', '4d2' },
  drop = { treasure=50, combat=50, magic=0, tools=0, junk=0 },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={4,10} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={4,10} },
    { type=DamageType.COLD, method=AttackType.BITE, dam={4,14} },
    { type=DamageType.COLD, method=AttackType.BITE, dam={4,14} },
  },
  resolvers.talents {
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_CAUSE_3] = 1,
    [Talents.T_NPC_BR_COLD] = 1,
  },
  body = bodies.dragon,
  speed = 10,
  vision = 30,
  alertness = 70,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'LESSER_BLACK_REAVER',
  name = [[Lesser black reaver]],
  display = 'L',
  color = colors.C_D,
  image = 'npc/lesser_black_reaver.png',
  desc = [[A humanoid form, black as night, advancing steadily and unstoppably.]],
  corpse_weight = 260,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 3,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 25, 100 },
  ac = 120,
  max_life = 2500,
  rarity = 3,
  level = 45,
  start_level = 45,
  exp_worth = 12000,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.FEAR] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
    [DamageType.TELEPORT] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    CAN_SWIM = true,
    COLD_BLOOD = true,
    EVIL = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    KILL_WALL = true,
    MORTAL = true,
    NO_CUT = true,
    OPEN_DOOR = true,
    SMART = true,
    UNDEAD = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, only_item=true, '2d2' },
  drop = { treasure=0, combat=0, magic=100, tools=0, junk=0 },
  attacks = {
    { type=DamageType.DISENCHANT, method=AttackType.HIT, dam={4,8} },
    { type=DamageType.DISENCHANT, method=AttackType.HIT, dam={4,8} },
    { type=DamageType.LOSE_STR, method=AttackType.HIT, dam={4,6} },
    { type=DamageType.LOSE_STR, method=AttackType.HIT, dam={4,6} },
  },
  on_melee_hit = util.black_breath_melee_hit,
  resolvers.talents {
    [Talents.T_NPC_TELE_TO] = 1,
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_HOLD] = 1,
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_CAUSE_3] = 1,
    [Talents.T_NPC_DRAIN_MANA] = 1,
    [Talents.T_NPC_MIND_BLAST] = 1,
    [Talents.T_NPC_BA_NETH] = 1,
    [Talents.T_NPC_ANIM_DEAD] = 1,
  },
  body = bodies.none,
  speed = 10,
  vision = 20,
  alertness = 50,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'GRAND_MASTER_THIEF',
  name = [[Grand master thief]],
  plural_name = [[Grand master thieves]],
  display = 'p',
  color = colors.C_b,
  image = 'npc/grand_master_thief.png',
  desc = [[A class of its own: you are already too late to protect your possessions - and he seems to have studied magic too, and is a master of setting traps.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 2,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 15, 100 },
  ac = 75,
  max_life = resolvers.dice(15, 100),
  rarity = 2,
  level = 46,
  start_level = 46,
  exp_worth = 1500,
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    EVIL = true,
    MALE = true,
    OPEN_DOOR = true,
    TAKE_ITEM = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ '2d2' },
  drop = { treasure=70, combat=10, magic=10, tools=10, junk=0 },
  attacks = {
    { type=DamageType.EAT_ITEM, method=AttackType.HIT, dam={5,5} },
    { type=DamageType.EAT_ITEM, method=AttackType.HIT, dam={5,5} },
    { type=DamageType.EAT_GOLD, method=AttackType.HIT, dam={5,5} },
    { type=DamageType.EAT_GOLD, method=AttackType.HIT, dam={5,5} },
  },
  resolvers.talents {
    [Talents.T_NPC_BLINK] = 1,
    [Talents.T_NPC_TPORT] = 1,
    [Talents.T_NPC_TELE_TO] = 1,
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_TRAPS] = 1,
    [Talents.T_NPC_ARROW_2] = 1,
  },
  body = bodies.humanoid,
  speed = 20,
  vision = 50,
  alertness = 40,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'SMAUG_THE_GOLDEN',
  name = [[Smaug the Golden]],
  display = 'D',
  color = colors.C_R,
  image = 'npc/smaug_the_golden.png',
  desc = [[Smaug is one of the Uruloki that still survive, a fire-drake of immense cunning and intelligence.  His speed through air is matched by few other dragons, his dragonfire is legendary, and his hide is armoured with diamonds. He is believed to be the greatest dragon still surviving into the Third Age.]],
  corpse_weight = 23000,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 4,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 24, 100 },
  ac = 150,
  max_life = 2400,
  rarity = 2,
  level = 48,
  start_level = 48,
  exp_worth = 23000,
  unique = 'SMAUG_THE_GOLDEN',
  resist_dam = {
    [DamageType.FIRE] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    CAN_SPEAK = true,
    DRAGON = true,
    EVIL = true,
    FLY = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    HAS_LITE = true,
    MALE = true,
    MOVE_BODY = true,
    OPEN_DOOR = true,
    POWERFUL = true,
    REFLECTING = true,
    SMART = true,
    UNIQUE = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, great=true, only_item=true, '4d2' },
  drop = { treasure=50, combat=50, magic=0, tools=0, junk=0 },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={4,12} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={4,12} },
    { type=DamageType.FIRE, method=AttackType.BITE, dam={5,14} },
    { type=DamageType.FIRE, method=AttackType.BITE, dam={5,14} },
  },
  resolvers.talents {
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_CAUSE_3] = 1,
    [Talents.T_NPC_BR_FIRE] = 1,
  },
  body = bodies.dragon,
  speed = 10,
  vision = 30,
  alertness = 80,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'KNIGHT_TEMPLAR',
  name = [[Knight Templar]],
  plural_name = [[Knights Templar]],
  display = 'p',
  color = colors.C_w,
  image = 'npc/knight_templar.png',
  desc = [[It seems that the more devout the person, the more likely they are to cross the boundary between piety and sanctimoniousness.  And such is the case with the Order of the Knights Templar; they are among the most pious and powerful of the religious knightly orders, but noted for their intolerance. Thus it is Morgoth's will that is unwittingly done, as the forces of good are set against each other.]],
  corpse_weight = 180,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 4,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 60, 20 },
  ac = 60,
  faction = 'eru_manwe',
  max_life = 1200,
  rarity = 2,
  level = 44,
  start_level = 44,
  exp_worth = 2000,
  resist_dam = {
    [DamageType.ACID] = true,
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.DISEASE] = true,
    [DamageType.ELEC] = true,
    [DamageType.FEAR] = true,
    [DamageType.FIRE] = true,
    [DamageType.NETHER] = true,
    [DamageType.NEXUS] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
    [DamageType.TELEPORT] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    FORCE_MAXHP = true,
    GOOD = true,
    HAS_LITE = true,
    MALE = true,
    MORTAL = true,
    NO_STUN = true,
    OPEN_DOOR = true,
    REFLECTING = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ '2d2', '90%' },
  drop = { treasure=0, combat=100, magic=0, tools=0, junk=0 },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={5,5} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={5,5} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={5,5} },
  },
  resolvers.talents {
    [Talents.T_NPC_HEAL] = 1,
    [Talents.T_NPC_CAUSE_3] = 1,
    [Talents.T_NPC_CAUSE_4] = 1,
    [Talents.T_NPC_HASTE] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_S_ANGEL] = 1,
  },
  body = bodies.humanoid,
  speed = 10,
  vision = 20,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'DRACOLICH',
  name = [[Dracolich]],
  display = 'D',
  color = colors.C_G,
  multi_colors = { colors.C_w, colors.C_G },
  image = 'npc/dracolich.png',
  desc = [[The skeletal form of a once-great dragon, enchanted by magic most perilous. Its animated form strikes with speed and drains life from its prey to satisfy its hunger.]],
  corpse_weight = 18000,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 6,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 35, 100 },
  ac = 120,
  max_life = 3500,
  rarity = 2,
  level = 55,
  start_level = 55,
  exp_worth = 18000,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
    [DamageType.TELEPORT] = true,
  },
  flags = {
    ATTR_MULTI = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    COLD_BLOOD = true,
    DRAGON = true,
    EVIL = true,
    FLY = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    MOVE_BODY = true,
    NO_CUT = true,
    OPEN_DOOR = true,
    POWERFUL = true,
    TAKE_ITEM = true,
    UNDEAD = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, only_item=true, '4d2' },
  drop = { treasure=10, combat=50, magic=40, tools=0, junk=0 },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={4,12} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={4,12} },
    { type=DamageType.EXP_80, method=AttackType.BITE, dam={7,14} },
  },
  on_melee_hit = util.black_breath_melee_hit,
  resolvers.talents {
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_BR_COLD] = 1,
    [Talents.T_NPC_BR_NETH] = 1,
  },
  body = bodies.dragon,
  speed = 10,
  vision = 25,
  alertness = 80,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'GREATER_TITAN',
  name = [[Greater titan]],
  display = 'P',
  color = colors.C_o,
  image = 'npc/greater_titan.png',
  desc = [[A forty foot tall humanoid that shakes the ground as it walks. The power radiating from its frame shakes your courage, its hatred inspired by your defiance.]],
  corpse_weight = 5000,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 3,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 38, 100 },
  ac = 125,
  max_life = 3800,
  rarity = 3,
  level = 66,
  start_level = 66,
  exp_worth = 23500,
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    EVIL = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    GIANT = true,
    HAS_LITE = true,
    MALE = true,
    MOVE_BODY = true,
    OPEN_DOOR = true,
    SMART = true,
    TAKE_ITEM = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, only_item=true, '1d2', '4d2' },
  drop = { treasure=0, combat=100, magic=0, tools=0, junk=0 },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.CONFUSION, method=AttackType.HIT, dam={12,12} },
    { type=DamageType.CONFUSION, method=AttackType.HIT, dam={12,12} },
    { type=DamageType.CONFUSION, method=AttackType.HIT, dam={12,12} },
    { type=DamageType.CONFUSION, method=AttackType.HIT, dam={12,12} },
  },
  resolvers.talents {
    [Talents.T_NPC_HEAL] = 1,
    [Talents.T_NPC_TELE_TO] = 1,
    [Talents.T_NPC_S_MONSTERS] = 1,
  },
  body = bodies.humanoid,
  speed = 10,
  vision = 30,
  alertness = 15,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'DRACOLISK',
  name = [[Dracolisk]],
  display = 'D',
  color = colors.C_R,
  multi_colors = { colors.C_r, colors.C_R },
  image = 'npc/dracolisk.png',
  desc = [[A mixture of dragon and basilisk, the dracolisk stares at you with deep piercing eyes, its evil breath burning the ground where it stands.]],
  corpse_weight = 18000,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 6,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 35, 100 },
  ac = 120,
  max_life = 3500,
  rarity = 2,
  level = 55,
  start_level = 55,
  exp_worth = 18000,
  resist_dam = {
    [DamageType.ACID] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.FIRE] = true,
    [DamageType.NEXUS] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.TELEPORT] = true,
  },
  flags = {
    ANIMAL = true,
    ATTR_MULTI = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    DRAGON = true,
    EVIL = true,
    FLY = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    OPEN_DOOR = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, only_item=true, '4d2' },
  drop = { treasure=0, combat=50, magic=40, tools=10, junk=0 },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={4,12} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={4,12} },
    { type=DamageType.FIRE, method=AttackType.BITE, dam={7,14} },
    { type=DamageType.PARALYZE, method=AttackType.GAZE },
  },
  resolvers.talents {
    [Talents.T_NPC_HOLD] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_BR_FIRE] = 1,
    [Talents.T_NPC_BR_NEXU] = 1,
  },
  body = bodies.dragon,
  speed = 10,
  vision = 25,
  alertness = 80,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'WINGED_HORROR',
  name = [[Winged Horror]],
  display = 'B',
  color = colors.C_D,
  image = 'npc/winged_horror.png',
  desc = [[A terrifying sight:  a winged creature greater than any bird you have ever seen, and with no feathers on its horrid black leathery wings.  Descended from a creature of an older world perhaps, bred by Sauron to be a winged steed for his Ringwraiths.]],
  corpse_weight = 450,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 6,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 25, 80 },
  ac = 80,
  max_life = resolvers.dice(25, 80),
  rarity = 3,
  level = 48,
  start_level = 48,
  exp_worth = 4000,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    EVIL = true,
    FLY = true,
    MORTAL = true,
  },
  placement_flags = { WILD_SWAMP=true, WILD_TOO=true, WILD_WASTE=true, WILD_WOOD=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={3,8} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={3,8} },
    { type=DamageType.EXP_40, method=AttackType.BITE, dam={4,6} },
    { type=DamageType.EXP_40, method=AttackType.BITE, dam={4,6} },
  },
  resolvers.talents {
    [Talents.T_NPC_BR_NETH] = 1,
    [Talents.T_NPC_BR_DARK] = 1,
    [Talents.T_NPC_BR_POIS] = 1,
  },
  speed = 10,
  vision = 30,
  alertness = 5,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'ENT',
  name = [[Ent]],
  display = '#',
  color = colors.C_G,
  image = 'npc/ent.png',
  desc = [[A tree-herd: a sentient, moving tree. Its wrath is fearsome, and it could split stones and even the very rock of Isengard with its roots.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 40, 100 },
  ac = 120,
  faction = 'friendlies',
  max_life = 4000,
  rarity = 3,
  level = 46,
  start_level = 46,
  exp_worth = 12500,
  vuln_dam = {
    [DamageType.FIRE] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    GOOD = true,
    KILL_WALL = true,
    MOVE_BODY = true,
    NO_CUT = true,
    PET = true,
    SMART = true,
    TAKE_ITEM = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, only_item=true, '4d2' },
  drop = { treasure=30, combat=50, magic=20, tools=0, junk=0 },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CRUSH, dam={12,13} },
    { type=DamageType.PHYSICAL, method=AttackType.CRUSH, dam={12,13} },
    { type=DamageType.PHYSICAL, method=AttackType.CRUSH, dam={12,13} },
    { type=DamageType.PHYSICAL, method=AttackType.CRUSH, dam={12,13} },
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 30,
  alertness = 15,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'HRU',
  name = [[Hru]],
  self_plural = true,
  display = 'P',
  color = colors.C_s,
  image = 'npc/hru.png',
  desc = [[A rock giant, a being made of living stone.]],
  corpse_weight = 4000,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 40, 100 },
  ac = 150,
  max_life = 4000,
  rarity = 3,
  level = 54,
  start_level = 54,
  exp_worth = 14500,
  vuln_dam = {
    [DamageType.KILL_WALL] = true,
  },
  flags = {
    BASH_DOOR = true,
    EVIL = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    GIANT = true,
    HAS_LITE = true,
    KILL_WALL = true,
    MALE = true,
    MOVE_BODY = true,
    NO_CUT = true,
    OPEN_DOOR = true,
    SMART = true,
    TAKE_ITEM = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ only_gold=true, '4d2' },
  attacks = {
    { type=DamageType.SHATTER, method=AttackType.HIT, dam={12,13} },
    { type=DamageType.SHATTER, method=AttackType.HIT, dam={12,13} },
    { type=DamageType.SHATTER, method=AttackType.HIT, dam={12,13} },
    { type=DamageType.SHATTER, method=AttackType.HIT, dam={12,13} },
  },
  body = bodies.humanoid,
  speed = 10,
  vision = 30,
  alertness = 15,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'ITANGAST_THE_FIRE_DRAKE',
  name = [[Itangast the Fire Drake]],
  display = 'D',
  color = colors.C_R,
  image = 'npc/itangast_the_fire_drake.png',
  desc = [[A mighty ancient dragon, Itangast's form scorches your flesh. Wisps of smoke curl up from his nostrils as he regards you with disdain.]],
  corpse_weight = 22000,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 4,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 22, 100 },
  ac = 120,
  max_life = 2200,
  rarity = 2,
  level = 47,
  start_level = 47,
  exp_worth = 20000,
  unique = 'ITANGAST_THE_FIRE_DRAKE',
  resist_dam = {
    [DamageType.FIRE] = true,
  },
  vuln_dam = {
    [DamageType.COLD] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    DRAGON = true,
    EVIL = true,
    FLY = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    HAS_LITE = true,
    MALE = true,
    MOVE_BODY = true,
    POWERFUL = true,
    UNIQUE = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, only_item=true, '3d2', '4d2' },
  drop = { treasure=50, combat=50, magic=0, tools=0, junk=0 },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={4,10} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={4,10} },
    { type=DamageType.FIRE, method=AttackType.BITE, dam={4,14} },
    { type=DamageType.FIRE, method=AttackType.BITE, dam={4,14} },
  },
  resolvers.talents {
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_CAUSE_3] = 1,
    [Talents.T_NPC_BR_FIRE] = 1,
  },
  body = bodies.dragon,
  speed = 10,
  vision = 30,
  alertness = 70,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'DEATH_MOLD',
  name = [[Death mold]],
  display = 'm',
  color = colors.C_D,
  image = 'npc/death_mold.png',
  desc = [[It is the epitome of all that is evil, in a mold. Its lifeless form draws power from sucking the souls of those that approach it; a nimbus of pure evil surrounds it. Luckily for you, it can't move...]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 100, 20 },
  ac = 60,
  max_life = resolvers.dice(100, 20),
  rarity = 1,
  level = 47,
  start_level = 47,
  exp_worth = 1000,
  resist_dam = {
    [DamageType.ACID] = true,
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.ELEC] = true,
    [DamageType.FEAR] = true,
    [DamageType.FIRE] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    CAN_SWIM = true,
    EVIL = true,
    FORCE_SLEEP = true,
    NEVER_MOVE = true,
    NO_CUT = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.DISENCHANT, method=AttackType.SPORE, dam={7,7} },
    { type=DamageType.DISENCHANT, method=AttackType.SPORE, dam={7,7} },
    { type=DamageType.DISENCHANT, method=AttackType.SPORE, dam={7,7} },
    { type=DamageType.EXP_80, method=AttackType.SPORE, dam={5,5} },
  },
  body = bodies.none,
  speed = 30,
  vision = 200,
  alertness = 0,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'QUICKBEAM_THE_ENT',
  name = [[Quickbeam, the Ent]],
  display = '#',
  color = colors.C_G,
  image = 'npc/quickbeam_the_ent.png',
  desc = [[Unusually hasty, for an ent.  Quickbeam hates evil creatures, and orcs in particular, since the destruction of his beloved rowan-trees to feed the fires of Orthanc.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 40, 100 },
  ac = 120,
  faction = 'friendlies',
  max_life = 4000,
  rarity = 3,
  level = 47,
  start_level = 47,
  exp_worth = 13500,
  unique = 'QUICKBEAM_THE_ENT',
  vuln_dam = {
    [DamageType.FIRE] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    CAN_SPEAK = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    GOOD = true,
    KILL_WALL = true,
    MOVE_BODY = true,
    NO_CUT = true,
    PET = true,
    SMART = true,
    TAKE_ITEM = true,
    UNIQUE = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, only_item=true, '4d2' },
  drop = { treasure=10, combat=50, magic=20, tools=10, junk=10 },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CRUSH, dam={12,13} },
    { type=DamageType.PHYSICAL, method=AttackType.CRUSH, dam={12,13} },
    { type=DamageType.PHYSICAL, method=AttackType.CRUSH, dam={12,13} },
    { type=DamageType.PHYSICAL, method=AttackType.CRUSH, dam={12,13} },
  },
  body = bodies.humanoid,
  speed = 10,
  vision = 30,
  alertness = 15,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'GLAURUNG_FATHER_OF_THE_DRAGONS',
  name = [[Glaurung, Father of the Dragons]],
  display = 'D',
  color = colors.C_R,
  image = 'npc/glaurung_father_of_the_dragons.png',
  desc = [[Glaurung is the father of all dragons, and was for a long time the most powerful.  Though this is no longer so, he still has full command over his brood and can command them to appear whenever he so wishes.  He is the definition of dragonfire.]],
  corpse_weight = 30000,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 3,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 120, 100 },
  ac = 125,
  max_life = 12000,
  rarity = 2,
  level = 70,
  start_level = 70,
  exp_worth = 50000,
  unique = 'GLAURUNG_FATHER_OF_THE_DRAGONS',
  resist_dam = {
    [DamageType.FIRE] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    CAN_SPEAK = true,
    DRAGON = true,
    EVIL = true,
    FLY = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    HAS_LITE = true,
    MALE = true,
    MOVE_BODY = true,
    OPEN_DOOR = true,
    POWERFUL = true,
    SMART = true,
    UNIQUE = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, great=true, only_item=true, randart=true, '3d2', '4d2' },
  drop = { treasure=30, combat=70, magic=0, tools=0, junk=0 },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={5,12} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={5,12} },
    { type=DamageType.FIRE, method=AttackType.BITE, dam={8,14} },
    { type=DamageType.POISON, method=AttackType.BITE, dam={8,14} },
  },
  resolvers.talents {
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_BR_FIRE] = 1,
    [Talents.T_NPC_BR_POIS] = 1,
    [Talents.T_NPC_BR_SOUN] = 1,
    [Talents.T_NPC_S_HI_DRAGON] = 1,
  },
  body = bodies.dragon,
  speed = 20,
  vision = 20,
  alertness = 70,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'BEHEMOTH',
  name = [[Behemoth]],
  display = 'H',
  color = colors.C_B,
  image = 'npc/behemoth.png',
  desc = [[A great water-beast, with an almost impenetrable skin.]],
  corpse_weight = 600,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 9,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 50, 100 },
  ac = 180,
  max_life = 5000,
  rarity = 3,
  level = 49,
  start_level = 49,
  exp_worth = 16000,
  resist_dam = {
    [DamageType.ACID] = true,
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.FEAR] = true,
    [DamageType.FIRE] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    ANIMAL = true,
    AQUATIC = true,
    BASEANGBAND = true,
    CAN_SWIM = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    MORTAL = true,
  },
  placement_flags = {},
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.FIRE, method=AttackType.BITE, dam={5,8} },
    { type=DamageType.FIRE, method=AttackType.BITE, dam={5,8} },
    { type=DamageType.PHYSICAL, method=AttackType.CRUSH, dam={3,15} },
    { type=DamageType.PHYSICAL, method=AttackType.CRUSH, dam={3,15} },
  },
  resolvers.talents {
    [Talents.T_NPC_BR_FIRE] = 1,
  },
  body = bodies.quadruped,
  speed = 10,
  vision = 25,
  alertness = 30,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'GREATER_WALL_MONSTER',
  name = [[Greater wall monster]],
  display = '#',
  color = colors.C_W,
  image = 'npc/greater_wall_monster.png',
  desc = [[A sentient, moving section of wall.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=50,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 15, 40 },
  ac = 80,
  max_life = resolvers.dice(15, 40),
  rarity = 4,
  level = 44,
  start_level = 44,
  exp_worth = 900,
  resist_dam = {
    [DamageType.ACID] = true,
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.ELEC] = true,
    [DamageType.FIRE] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  vuln_dam = {
    [DamageType.KILL_WALL] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    CHAR_MULTI = true,
    COLD_BLOOD = true,
    EMPTY_MIND = true,
    FLY = true,
    FORCE_SLEEP = true,
    MULTIPLY = true,
    NONLIVING = true,
    NO_CUT = true,
    PASS_WALL = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={3,6} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={3,6} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={3,6} },
  },
  body = bodies.none,
  speed = 10,
  vision = 20,
  alertness = 20,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'NYCADAEMON',
  name = [[Nycadaemon]],
  display = 'U',
  color = colors.C_o,
  image = 'npc/nycadaemon.png',
  desc = [[A loathsome, sturdy, winged, horned demon, with talons that could tear a stone wall down.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 4,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 29, 99 },
  ac = 80,
  max_life = 2871,
  rarity = 3,
  level = 51,
  start_level = 51,
  exp_worth = 10000,
  resist_dam = {
    [DamageType.ACID] = true,
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.FIRE] = true,
    [DamageType.OLD_SLEEP] = true,
  },
  melee_retal = {
    [DamageType.FIRE] = 'mondam',
  },
  flags = {
    BASEANGBAND = true,
    DEMON = true,
    EVIL = true,
    FLY = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    INVISIBLE = true,
    KILL_WALL = true,
    NONLIVING = true,
    NO_STUN = true,
    REGENERATE = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, only_item=true, '1d2' },
  drop = { treasure=50, combat=0, magic=50, tools=0, junk=0 },
  attacks = {
    { type=DamageType.FEAR, method=AttackType.TOUCH },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={6,6} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={6,6} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={6,6} },
  },
  resolvers.talents {
    [Talents.T_NPC_HOLD] = 1,
    [Talents.T_NPC_BLINK] = 1,
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_S_DEMON] = 1,
    [Talents.T_NPC_BRAIN_SMASH] = 1,
    [Talents.T_NPC_BR_NETH] = 1,
  },
  body = bodies.humanoid,
  speed = 10,
  vision = 20,
  alertness = 80,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'BARBAZU',
  name = [[Barbazu]],
  self_plural = true,
  display = 'U',
  color = colors.C_G,
  image = 'npc/barbazu.png',
  desc = [[A foul, humanoid creature with a long tail, clawed hands and feet, and a disgusting, wiry, snaky beard.  They are the elite shock troops of the hells, capable of a terrifying berserk fury.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 7,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 120, 10 },
  ac = 60,
  max_life = 1200,
  rarity = 2,
  level = 55,
  start_level = 55,
  exp_worth = 3000,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    DEMON = true,
    EVIL = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    FRIENDS = true,
    NONLIVING = true,
    OPEN_DOOR = true,
    POWERFUL = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ only_item=true, '1d2' },
  drop = { treasure=20, combat=40, magic=20, tools=20, junk=0 },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={4,10} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={4,10} },
    { type=DamageType.LOSE_CON, method=AttackType.HIT, dam={10,2} },
    { type=DamageType.POISON, method=AttackType.STING, dam={5,5} },
  },
  resolvers.talents {
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_S_DEMON] = 1,
  },
  body = bodies.humanoid,
  speed = 10,
  vision = 25,
  alertness = 80,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'NIGHTWING',
  name = [[Nightwing]],
  display = 'W',
  color = colors.C_D,
  image = 'npc/nightwing.png',
  desc = [[Everywhere colours seem paler and the air chiller. At the centre of the cold stands a mighty figure. Its wings envelop you in the chill of death as the nightwing reaches out to draw you into oblivion. Your muscles sag and your mind loses all will to fight as you stand in awe of this mighty being.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 4,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 60, 60 },
  ac = 120,
  max_life = 3600,
  rarity = 4,
  level = 61,
  start_level = 61,
  exp_worth = 10000,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.DARK] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
    [DamageType.TELEPORT] = true,
  },
  vuln_dam = {
    [DamageType.LITE] = true,
    [DamageType.LITE_WEAK] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    COLD_BLOOD = true,
    EVIL = true,
    FLY = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    NO_CUT = true,
    OPEN_DOOR = true,
    SMART = true,
    UNDEAD = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, only_item=true, '2d2' },
  drop = { treasure=0, combat=0, magic=100, tools=0, junk=0 },
  attacks = {
    { type=DamageType.POISON, method=AttackType.TOUCH, dam={6,5} },
    { type=DamageType.POISON, method=AttackType.TOUCH, dam={6,5} },
    { type=DamageType.DISENCHANT, method=AttackType.HIT, dam={6,8} },
    { type=DamageType.DISENCHANT, method=AttackType.HIT, dam={6,8} },
  },
  on_melee_hit = util.black_breath_melee_hit,
  resolvers.talents {
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_CAUSE_4] = 1,
    [Talents.T_NPC_BRAIN_SMASH] = 1,
    [Talents.T_NPC_BO_MANA] = 1,
    [Talents.T_NPC_BO_NETH] = 1,
    [Talents.T_NPC_BA_NETH] = 1,
    [Talents.T_NPC_S_UNDEAD] = 1,
  },
  body = bodies.humanoid,
  speed = 10,
  vision = 20,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'MAULOTAUR',
  name = [[Maulotaur]],
  display = 'H',
  color = colors.C_s,
  image = 'npc/maulotaur.png',
  desc = [[It is a belligerent minotaur with a destructive magical arsenal, armed with a hammer.]],
  corpse_weight = 4000,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 5,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 250, 13 },
  ac = 50,
  max_life = 3250,
  rarity = 2,
  level = 50,
  start_level = 50,
  exp_worth = 4500,
  resist_dam = {
    [DamageType.FIRE] = true,
    [DamageType.TELEPORT] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    EVIL = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    MORTAL = true,
    STUPID = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, only_item=true, '60%' },
  drop = { treasure=0, combat=50, magic=50, tools=0, junk=0 },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.SHATTER, method=AttackType.HIT, dam={8,8} },
    { type=DamageType.SHATTER, method=AttackType.HIT, dam={8,8} },
    { type=DamageType.PHYSICAL, method=AttackType.BUTT, dam={4,6} },
    { type=DamageType.PHYSICAL, method=AttackType.BUTT, dam={4,6} },
  },
  resolvers.talents {
    [Talents.T_NPC_BO_PLAS] = 1,
    [Talents.T_NPC_BA_FIRE] = 1,
  },
  body = bodies.humanoid,
  speed = 20,
  vision = 13,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'NETHER_HOUND',
  name = [[Nether hound]],
  display = 'Z',
  color = colors.C_G,
  image = 'npc/nether_hound.png',
  desc = [[You feel a soul-tearing chill upon viewing this beast, a ghostly form of darkness in the shape of a large dog.]],
  corpse_weight = 80,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 5,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 60, 10 },
  ac = 100,
  max_life = resolvers.dice(60, 10),
  rarity = 2,
  level = 51,
  start_level = 51,
  exp_worth = 5000,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.NETHER] = true,
    [DamageType.OLD_SLEEP] = true,
  },
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    FORCE_SLEEP = true,
    FRIENDS = true,
    MORTAL = true,
    NO_CUT = true,
    OPEN_DOOR = true,
  },
  placement_flags = {},
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={2,12} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={2,12} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={2,12} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={2,12} },
  },
  resolvers.talents {
    [Talents.T_NPC_BR_NETH] = 1,
  },
  body = bodies.quadruped,
  speed = 10,
  vision = 30,
  alertness = 0,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'TIME_HOUND',
  name = [[Time hound]],
  display = 'Z',
  color = colors.C_B,
  image = 'npc/time_hound.png',
  desc = [[You get a terrible sense of deja vu, or is it a premonition?  All at once you see a little puppy and a toothless old dog. Perhaps you should give up and go to bed.]],
  corpse_weight = 80,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 5,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 60, 10 },
  ac = 100,
  max_life = resolvers.dice(60, 10),
  rarity = 2,
  level = 51,
  start_level = 51,
  exp_worth = 5000,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.TIME] = true,
  },
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    FORCE_SLEEP = true,
    FRIENDS = true,
    MORTAL = true,
    OPEN_DOOR = true,
  },
  placement_flags = {},
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={2,12} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={2,12} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={2,12} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={2,12} },
  },
  resolvers.talents {
    [Talents.T_NPC_BR_TIME] = 1,
  },
  body = bodies.quadruped,
  speed = 20,
  vision = 30,
  alertness = 0,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'PLASMA_HOUND',
  name = [[Plasma hound]],
  display = 'Z',
  color = colors.C_R,
  image = 'npc/plasma_hound.png',
  desc = [[The very air warps as pure elemental energy stalks towards you in the shape of a giant hound. Your hair stands on end and your palms itch as you sense trouble.]],
  corpse_weight = 80,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 5,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 60, 10 },
  ac = 100,
  max_life = resolvers.dice(60, 10),
  rarity = 2,
  level = 51,
  start_level = 51,
  exp_worth = 5000,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.FIRE] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.PLASMA] = true,
  },
  vuln_dam = {
    [DamageType.COLD] = true,
  },
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    FORCE_SLEEP = true,
    FRIENDS = true,
    HAS_LITE = true,
    MORTAL = true,
    NO_CUT = true,
    OPEN_DOOR = true,
  },
  placement_flags = {},
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={2,12} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={2,12} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={2,12} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={2,12} },
  },
  resolvers.talents {
    [Talents.T_NPC_BR_PLAS] = 1,
  },
  body = bodies.quadruped,
  speed = 10,
  vision = 30,
  alertness = 0,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'DEMONIC_QUYLTHULG',
  name = [[Demonic quylthulg]],
  display = 'Q',
  color = colors.C_r,
  image = 'npc/demonic_quylthulg.png',
  desc = [[A pile of pulsing flesh that glows with an inner hellish fire. The world itself seems to cry out against it.]],
  corpse_weight = 300,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 2,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 48, 10 },
  ac = 1,
  max_life = 480,
  rarity = 1,
  level = 45,
  start_level = 45,
  exp_worth = 3000,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.FEAR] = true,
    [DamageType.OLD_SLEEP] = true,
  },
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    EMPTY_MIND = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    INVISIBLE = true,
    NEVER_BLOW = true,
    NEVER_MOVE = true,
  },
  placement_flags = {},
  resolvers.talents {
    [Talents.T_NPC_BLINK] = 1,
    [Talents.T_NPC_TPORT] = 1,
    [Talents.T_NPC_S_DEMON] = 1,
  },
  body = bodies.none,
  speed = 10,
  vision = 20,
  alertness = 0,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'GREAT_STORM_WYRM',
  name = [[Great Storm Wyrm]],
  display = 'D',
  color = colors.C_b,
  multi_colors = { colors.C_b, colors.C_B },
  image = 'npc/great_storm_wyrm.png',
  desc = [[A vast dragon of power. Storms and lightning crash around its titanic form. Deep blue scales reflect the flashes and highlight the creature's great muscles. It regards you with contempt.]],
  corpse_weight = 19000,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 4,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 40, 100 },
  ac = 150,
  max_life = 4000,
  rarity = 2,
  level = 63,
  start_level = 63,
  exp_worth = 20000,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.ELEC] = true,
    [DamageType.OLD_SLEEP] = true,
  },
  melee_retal = {
    [DamageType.ELEC] = 'mondam',
  },
  flags = {
    ATTR_MULTI = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    DRAGON = true,
    EVIL = true,
    FLY = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    HAS_LITE = true,
    MOVE_BODY = true,
    POWERFUL = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, only_item=true, '2d2', '3d2', '4d2' },
  drop = { treasure=50, combat=50, magic=0, tools=0, junk=0 },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={4,12} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={4,12} },
    { type=DamageType.ELEC, method=AttackType.BITE, dam={6,14} },
    { type=DamageType.ELEC, method=AttackType.BITE, dam={6,14} },
  },
  resolvers.talents {
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_BR_ELEC] = 1,
  },
  body = bodies.dragon,
  speed = 10,
  vision = 30,
  alertness = 80,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'ULIK_THE_TROLL',
  name = [[Ulik the Troll]],
  display = 'T',
  color = colors.C_v,
  image = 'npc/ulik_the_troll.png',
  desc = [[Ulik is the strongest troll who has ever lived. He could challenge the immortals and pound them to dust with his great strength.]],
  corpse_weight = 1600,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 35, 100 },
  ac = 120,
  max_life = 3500,
  level = 51,
  start_level = 51,
  exp_worth = 18000,
  unique = 'ULIK_THE_TROLL',
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.ELEC] = true,
    [DamageType.FIRE] = true,
    [DamageType.POISON] = true,
    [DamageType.TELEPORT] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    CAN_SPEAK = true,
    EVIL = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    KILL_BODY = true,
    KILL_WALL = true,
    MALE = true,
    OPEN_DOOR = true,
    REGENERATE = true,
    SPECIAL_GENE = true,
    TROLL = true,
    UNIQUE = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, only_item=true, '1d2', '4d2', '90%' },
  drop = { treasure=0, combat=100, magic=0, tools=0, junk=0 },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.SHATTER, method=AttackType.HIT, dam={20,12} },
    { type=DamageType.SHATTER, method=AttackType.HIT, dam={20,12} },
    { type=DamageType.POISON, method=AttackType.BITE, dam={6,14} },
  },
  body = bodies.humanoid,
  speed = 20,
  vision = 30,
  alertness = 30,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'BAPHOMET_THE_MINOTAUR_LORD',
  name = [[Baphomet the Minotaur Lord]],
  display = 'H',
  color = colors.C_v,
  image = 'npc/baphomet_the_minotaur_lord.png',
  desc = [[A fearsome bull-headed monster, Baphomet swings a mighty axe as he curses all that defy him.]],
  corpse_weight = 1600,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 6,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 35, 100 },
  ac = 120,
  max_life = 3500,
  rarity = 4,
  level = 58,
  start_level = 58,
  exp_worth = 18000,
  unique = 'BAPHOMET_THE_MINOTAUR_LORD',
  resist_dam = {
    [DamageType.FIRE] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    CAN_SPEAK = true,
    EVIL = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    MALE = true,
    MORTAL = true,
    UNIQUE = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, only_item=true, '1d2', '4d2' },
  drop = { treasure=0, combat=80, magic=20, tools=0, junk=0 },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.BUTT, dam={12,13} },
    { type=DamageType.PHYSICAL, method=AttackType.BUTT, dam={12,13} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={10,10} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={10,10} },
  },
  resolvers.talents {
    [Talents.T_NPC_SLOW] = 1,
    [Talents.T_NPC_ARROW_4] = 1,
    [Talents.T_NPC_BO_MANA] = 1,
    [Talents.T_NPC_BO_PLAS] = 1,
    [Talents.T_NPC_BA_ELEC] = 1,
    [Talents.T_NPC_BR_WALL] = 1,
  },
  body = bodies.humanoid,
  speed = 20,
  vision = 30,
  alertness = 30,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'HELL_KNIGHT',
  name = [[Hell knight]],
  display = 'p',
  color = colors.C_D,
  image = 'npc/hell_knight.png',
  desc = [[It is a humanoid form dressed in armour of ancient style. From beneath its helmet, eyes glow with hellfire.]],
  corpse_weight = 220,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 5,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 15, 100 },
  ac = 100,
  max_life = 1500,
  rarity = 1,
  level = 52,
  start_level = 52,
  exp_worth = 10000,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.FIRE] = true,
    [DamageType.NETHER] = true,
    [DamageType.NEXUS] = true,
    [DamageType.PLASMA] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    COLD_BLOOD = true,
    EVIL = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    HAS_LITE = true,
    MORTAL = true,
    OPEN_DOOR = true,
    SMART = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ only_item=true, '1d2', '2d2' },
  drop = { treasure=0, combat=40, magic=60, tools=0, junk=0 },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={10,5} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={10,5} },
    { type=DamageType.EXP_80, method=AttackType.HIT, dam={10,5} },
    { type=DamageType.EXP_80, method=AttackType.HIT, dam={10,5} },
  },
  resolvers.talents {
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_CAUSE_3] = 1,
    [Talents.T_NPC_BA_NETH] = 1,
    [Talents.T_NPC_BA_FIRE] = 1,
    [Talents.T_NPC_BO_PLAS] = 1,
    [Talents.T_NPC_S_MONSTERS] = 1,
    [Talents.T_NPC_S_DEMON] = 1,
  },
  body = bodies.humanoid,
  speed = 10,
  vision = 20,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'OLD_SORCERER',
  name = [[Old Sorcerer]],
  display = 'p',
  color = colors.C_R,
  image = 'npc/old_sorcerer.png',
  desc = [[A human figure in robes, he moves with magically improved speed, and his hands are ablur with spell casting. You stagger at the mighty sound of his spells as they echo hollowly through the dungeon.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 2,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 52, 25 },
  ac = 60,
  max_life = 1300,
  rarity = 2,
  level = 54,
  start_level = 54,
  exp_worth = 5000,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.OLD_SLEEP] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    EVIL = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    HAS_LITE = true,
    MALE = true,
    OPEN_DOOR = true,
    TAKE_ITEM = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ only_item=true, '4d2' },
  drop = { treasure=0, combat=0, magic=100, tools=0, junk=0 },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={6,8} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={6,8} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={6,8} },
  },
  resolvers.talents {
    [Talents.T_NPC_BLINK] = 1,
    [Talents.T_NPC_TELE_TO] = 1,
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_CAUSE_3] = 1,
    [Talents.T_NPC_CAUSE_4] = 1,
    [Talents.T_NPC_TRAPS] = 1,
    [Talents.T_NPC_BO_ACID] = 1,
    [Talents.T_NPC_BA_FIRE] = 1,
    [Talents.T_NPC_BA_COLD] = 1,
    [Talents.T_NPC_BA_POIS] = 1,
    [Talents.T_NPC_S_MONSTER] = 1,
    [Talents.T_NPC_S_DEMON] = 1,
    [Talents.T_NPC_S_HI_DRAGON] = 1,
    [Talents.T_NPC_S_UNDEAD] = 1,
  },
  body = bodies.humanoid,
  speed = 20,
  vision = 20,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'ETHEREAL_HOUND',
  name = [[Ethereal hound]],
  display = 'Z',
  color = colors.C_G,
  image = 'npc/ethereal_hound.png',
  desc = [[A pale green hound. Pulsing red lines and strange fluorescent light hint at internal organs best left to the imagination.]],
  corpse_weight = 90,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 5,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 60, 15 },
  ac = 100,
  max_life = resolvers.dice(60, 15),
  rarity = 3,
  level = 55,
  start_level = 55,
  exp_worth = 6000,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.OLD_SLEEP] = true,
  },
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    FORCE_SLEEP = true,
    FRIENDS = true,
    INVISIBLE = true,
    MORTAL = true,
    PASS_WALL = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={2,12} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={2,12} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={2,12} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={2,12} },
  },
  resolvers.talents {
    [Talents.T_NPC_BR_NETH] = 1,
  },
  body = bodies.none,
  speed = 10,
  vision = 30,
  alertness = 0,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'LESSER_KRAKEN',
  name = [[Lesser kraken]],
  display = '~',
  color = colors.C_G,
  image = 'npc/lesser_kraken.png',
  desc = [[An enormously fearsome and powerful inhabitant of the depths. It resembles a gargantuan octopus and its evil is almost tangible.]],
  corpse_weight = 800,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 4,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 30, 100 },
  ac = 150,
  max_life = 3000,
  rarity = 2,
  level = 54,
  start_level = 54,
  exp_worth = 20000,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.ELEC] = true,
    [DamageType.FIRE] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
    [DamageType.WATER] = true,
  },
  flags = {
    AQUATIC = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    EVIL = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    MOVE_BODY = true,
    POWERFUL = true,
    SMART = true,
  },
  placement_flags = { WILD_OCEAN=true, WILD_TOO=true },
  resolvers.mon_inven{ good=true, only_item=true, '3d2' },
  drop = { treasure=25, combat=25, magic=50, tools=0, junk=0 },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CRUSH, dam={16,12} },
    { type=DamageType.PHYSICAL, method=AttackType.CRUSH, dam={16,12} },
    { type=DamageType.PHYSICAL, method=AttackType.CRUSH, dam={16,12} },
    { type=DamageType.PHYSICAL, method=AttackType.CRUSH, dam={16,12} },
  },
  resolvers.talents {
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_CAUSE_4] = 1,
    [Talents.T_NPC_CAUSE_3] = 1,
    [Talents.T_NPC_BA_WATE] = 1,
    [Talents.T_NPC_DARKNESS] = 1,
    [Talents.T_NPC_BR_DARK] = 1,
    [Talents.T_NPC_TELE_TO] = 1,
  },
  body = { MAIN_HAND=3, OFF_HAND=3, BODY=0, CLOAK=0, LAUNCHER=1, QUIVER=0, GLOVES=3, BOOTS=0, HELM=1, RING=0, AMULET=1, LITE=0, TOOL=1, SYMBIOTE=0, INVEN=23 },
  speed = 10,
  vision = 30,
  alertness = 80,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'GREAT_ICE_WYRM',
  name = [[Great Ice Wyrm]],
  display = 'D',
  color = colors.C_w,
  multi_colors = { colors.C_w, colors.C_W },
  image = 'npc/great_ice_wyrm.png',
  desc = [[An immense dragon capable of awesome destruction. You have never felt such extreme cold, or witnessed such an icy stare. Begone quickly or feel its wrath!]],
  corpse_weight = 19000,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 4,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 40, 100 },
  ac = 150,
  max_life = 4000,
  rarity = 2,
  level = 63,
  start_level = 63,
  exp_worth = 20000,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.OLD_SLEEP] = true,
  },
  vuln_dam = {
    [DamageType.FIRE] = true,
  },
  melee_retal = {
    [DamageType.COLD] = 'mondam',
  },
  flags = {
    ATTR_MULTI = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    DRAGON = true,
    EVIL = true,
    FLY = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    HAS_LITE = true,
    MOVE_BODY = true,
    POWERFUL = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, only_item=true, '2d2', '3d2', '4d2' },
  drop = { treasure=50, combat=50, magic=0, tools=0, junk=0 },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={4,12} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={4,12} },
    { type=DamageType.COLD, method=AttackType.BITE, dam={6,14} },
    { type=DamageType.COLD, method=AttackType.BITE, dam={6,14} },
  },
  resolvers.talents {
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_BR_COLD] = 1,
  },
  body = bodies.dragon,
  speed = 10,
  vision = 30,
  alertness = 80,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'DEMILICH',
  name = [[Demilich]],
  display = 'L',
  color = colors.C_U,
  image = 'npc/demilich.png',
  desc = [[A lich who is partially immaterial, on its way to a new, ethereal form.]],
  corpse_weight = 300,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 3,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 35, 100 },
  ac = 100,
  max_life = 3500,
  rarity = 2,
  level = 54,
  start_level = 54,
  exp_worth = 12500,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
    [DamageType.TELEPORT] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    COLD_BLOOD = true,
    EVIL = true,
    FLY = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    NO_CUT = true,
    OPEN_DOOR = true,
    SMART = true,
    UNDEAD = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, only_item=true, '2d2', '3d2' },
  drop = { treasure=0, combat=0, magic=100, tools=0, junk=0 },
  attacks = {
    { type=DamageType.EXP_80, method=AttackType.TOUCH },
    { type=DamageType.UN_POWER, method=AttackType.TOUCH },
    { type=DamageType.LOSE_DEX, method=AttackType.TOUCH, dam={4,12} },
    { type=DamageType.LOSE_DEX, method=AttackType.TOUCH, dam={4,12} },
  },
  on_melee_hit = util.black_breath_melee_hit,
  resolvers.talents {
    [Talents.T_NPC_BLINK] = 1,
    [Talents.T_NPC_TELE_TO] = 1,
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_HOLD] = 1,
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_CAUSE_3] = 1,
    [Talents.T_NPC_CAUSE_4] = 1,
    [Talents.T_NPC_DRAIN_MANA] = 1,
    [Talents.T_NPC_BRAIN_SMASH] = 1,
    [Talents.T_NPC_S_HI_UNDEAD] = 1,
    [Talents.T_NPC_S_UNDEAD] = 1,
    [Talents.T_NPC_FORGET] = 1,
    [Talents.T_NPC_S_DEMON] = 1,
    [Talents.T_NPC_TPORT] = 1,
    [Talents.T_NPC_HEAL] = 1,
    [Talents.T_NPC_ANIM_DEAD] = 1,
  },
  body = bodies.none,
  speed = 10,
  vision = 20,
  alertness = 50,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'THE_PHOENIX',
  name = [[The Phoenix]],
  display = 'B',
  color = colors.C_r,
  image = 'npc/the_phoenix.png',
  desc = [[A massive glowing eagle bathed in flames. The searing heat chars your skin and melts your armour.]],
  corpse_weight = 600,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 3,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 36, 100 },
  ac = 130,
  max_life = 3600,
  rarity = 3,
  level = 54,
  start_level = 54,
  exp_worth = 40000,
  unique = 'THE_PHOENIX',
  resist_dam = {
    [DamageType.ACID] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.ELEC] = true,
    [DamageType.FIRE] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.PLASMA] = true,
    [DamageType.POISON] = true,
  },
  vuln_dam = {
    [DamageType.COLD] = true,
  },
  melee_retal = {
    [DamageType.FIRE] = 'mondam',
  },
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    CAN_SPEAK = true,
    FLY = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    HAS_LITE = true,
    OPEN_DOOR = true,
    REGENERATE = true,
    UNIQUE = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, only_item=true, '2d2' },
  drop = { treasure=0, combat=50, magic=50, tools=0, junk=0 },
  attacks = {
    { type=DamageType.FIRE, method=AttackType.BITE, dam={12,6} },
    { type=DamageType.FIRE, method=AttackType.BITE, dam={12,6} },
    { type=DamageType.FIRE, method=AttackType.HIT, dam={9,12} },
    { type=DamageType.FIRE, method=AttackType.HIT, dam={9,12} },
  },
  resolvers.talents {
    [Talents.T_NPC_BO_FIRE] = 1,
    [Talents.T_NPC_BO_PLAS] = 1,
    [Talents.T_NPC_BA_FIRE] = 1,
    [Talents.T_NPC_BR_FIRE] = 1,
    [Talents.T_NPC_BR_LITE] = 1,
    [Talents.T_NPC_BR_PLAS] = 1,
  },
  body = bodies.winged,
  speed = 10,
  vision = 60,
  alertness = 0,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'NIGHTCRAWLER',
  name = [[Nightcrawler]],
  display = 'W',
  color = colors.C_D,
  image = 'npc/nightcrawler.png',
  desc = [[This intensely evil creature bears the form of a gargantuan black worm. Its gaping maw is a void of blackness, and acid drips from its steely hide. It is like nothing you have ever seen before, and a terrible chill runs down your spine as you face it.]],
  corpse_weight = 1000,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 4,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 80, 60 },
  ac = 160,
  max_life = 4800,
  rarity = 3,
  level = 69,
  start_level = 69,
  exp_worth = 1500,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.DARK] = true,
    [DamageType.FIRE] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
    [DamageType.TELEPORT] = true,
  },
  vuln_dam = {
    [DamageType.LITE] = true,
    [DamageType.LITE_WEAK] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    CAN_SWIM = true,
    COLD_BLOOD = true,
    EVIL = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    KILL_WALL = true,
    NO_CUT = true,
    OPEN_DOOR = true,
    SMART = true,
    UNDEAD = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, only_item=true, '1d2', '2d2' },
  drop = { treasure=40, combat=0, magic=50, tools=10, junk=0 },
  attacks = {
    { type=DamageType.LOSE_CON, method=AttackType.STING, dam={8,8} },
    { type=DamageType.LOSE_CON, method=AttackType.STING, dam={8,8} },
    { type=DamageType.ACID, method=AttackType.BITE, dam={10,10} },
    { type=DamageType.ACID, method=AttackType.BITE, dam={10,10} },
  },
  on_melee_hit = util.black_breath_melee_hit,
  resolvers.talents {
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_BRAIN_SMASH] = 1,
    [Talents.T_NPC_BO_MANA] = 1,
    [Talents.T_NPC_BO_NETH] = 1,
    [Talents.T_NPC_BA_NETH] = 1,
    [Talents.T_NPC_BR_NETH] = 1,
    [Talents.T_NPC_S_UNDEAD] = 1,
  },
  body = bodies.snake,
  speed = 10,
  vision = 20,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'HAND_DRUJ',
  name = [[Hand druj]],
  self_plural = true,
  display = 's',
  color = colors.C_y,
  image = 'npc/hand_druj.png',
  desc = [[A skeletal hand floating in the air, motionless except for its flexing fingers.]],
  corpse_weight = 1,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 1,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 60, 10 },
  ac = 110,
  max_life = 600,
  rarity = 2,
  level = 57,
  start_level = 57,
  exp_worth = 18000,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.FEAR] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
    [DamageType.TELEPORT] = true,
  },
  flags = {
    BASEANGBAND = true,
    CAN_SWIM = true,
    COLD_BLOOD = true,
    EVIL = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    NEVER_BLOW = true,
    NEVER_MOVE = true,
    NO_CUT = true,
    SMART = true,
    UNDEAD = true,
  },
  placement_flags = {},
  resolvers.talents {
    [Talents.T_NPC_TELE_AWAY] = 1,
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_CAUSE_3] = 1,
    [Talents.T_NPC_FORGET] = 1,
    [Talents.T_NPC_DARKNESS] = 1,
    [Talents.T_NPC_BO_FIRE] = 1,
    [Talents.T_NPC_BO_ACID] = 1,
    [Talents.T_NPC_BO_COLD] = 1,
    [Talents.T_NPC_BO_ELEC] = 1,
  },
  body = { MAIN_HAND=0, OFF_HAND=0, BODY=0, CLOAK=0, LAUNCHER=0, QUIVER=0, GLOVES=0, BOOTS=0, HELM=0, RING=1, AMULET=0, LITE=0, TOOL=0, SYMBIOTE=0, INVEN=23 },
  speed = 20,
  vision = 20,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'EYE_DRUJ',
  name = [[Eye druj]],
  self_plural = true,
  display = 's',
  color = colors.C_r,
  image = 'npc/eye_druj.png',
  desc = [[A bloodshot eyeball floating in the air, you'd be forgiven for assuming it harmless.]],
  corpse_weight = 0.2,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 1,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 10, 100 },
  ac = 90,
  max_life = 1000,
  rarity = 2,
  level = 58,
  start_level = 58,
  exp_worth = 21000,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.FEAR] = true,
    [DamageType.FIRE] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
    [DamageType.TELEPORT] = true,
  },
  flags = {
    BASEANGBAND = true,
    CAN_SWIM = true,
    COLD_BLOOD = true,
    EVIL = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    NEVER_BLOW = true,
    NEVER_MOVE = true,
    NO_CUT = true,
    SMART = true,
    UNDEAD = true,
  },
  placement_flags = {},
  resolvers.talents {
    [Talents.T_NPC_BO_MANA] = 1,
    [Talents.T_NPC_BO_NETH] = 1,
    [Talents.T_NPC_BA_NETH] = 1,
    [Talents.T_NPC_BRAIN_SMASH] = 1,
    [Talents.T_NPC_S_UNDEAD] = 1,
  },
  body = bodies.none,
  speed = 20,
  vision = 20,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'SKULL_DRUJ',
  name = [[Skull druj]],
  self_plural = true,
  display = 's',
  color = colors.C_o,
  image = 'npc/skull_druj.png',
  desc = [[A glowing skull possessed by sorcerous power. It need not move, but merely blast you with mighty magic.]],
  corpse_weight = 100,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 1,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 14, 100 },
  ac = 120,
  max_life = 1400,
  rarity = 2,
  level = 59,
  start_level = 59,
  exp_worth = 24000,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.FEAR] = true,
    [DamageType.FIRE] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
    [DamageType.TELEPORT] = true,
  },
  flags = {
    BASEANGBAND = true,
    CAN_SWIM = true,
    COLD_BLOOD = true,
    EVIL = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    NEVER_MOVE = true,
    NO_CUT = true,
    SMART = true,
    UNDEAD = true,
  },
  placement_flags = {},
  resolvers.talents {
    [Talents.T_NPC_SLOW] = 1,
    [Talents.T_NPC_CAUSE_4] = 1,
    [Talents.T_NPC_MIND_BLAST] = 1,
    [Talents.T_NPC_BRAIN_SMASH] = 1,
    [Talents.T_NPC_TRAPS] = 1,
    [Talents.T_NPC_BO_PLAS] = 1,
    [Talents.T_NPC_BO_NETH] = 1,
    [Talents.T_NPC_BA_WATE] = 1,
    [Talents.T_NPC_S_UNDEAD] = 1,
  },
  body = bodies.snake,
  speed = 20,
  vision = 20,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'CHAOS_VORTEX',
  name = [[Chaos vortex]],
  display = 'v',
  color = colors.C_v,
  image = 'npc/chaos_vortex.png',
  desc = [[Void, nothingness, spinning destructively.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=75,
    talent_in = 6,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 32, 20 },
  ac = 80,
  max_life = resolvers.dice(32, 20),
  rarity = 1,
  level = 53,
  start_level = 53,
  exp_worth = 4000,
  resist_dam = {
    [DamageType.CHAOS] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.FEAR] = true,
    [DamageType.OLD_SLEEP] = true,
  },
  flags = {
    ATTR_ANY = true,
    ATTR_MULTI = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    EMPTY_MIND = true,
    FLY = true,
    FORCE_SLEEP = true,
    NONLIVING = true,
    NO_CUT = true,
    POWERFUL = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.CONFUSION, method=AttackType.ENGULF, dam={5,5} },
    { type=DamageType.CONFUSION, method=AttackType.ENGULF, dam={5,5} },
    { type=DamageType.PHYSICAL, method=AttackType.ENGULF, dam={5,5} },
    { type=DamageType.PHYSICAL, method=AttackType.ENGULF, dam={5,5} },
  },
  resolvers.talents {
    [Talents.T_NPC_BR_CHAO] = 1,
  },
  body = bodies.none,
  speed = 30,
  vision = 100,
  alertness = 0,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'AETHER_VORTEX',
  name = [[Aether vortex]],
  display = 'v',
  color = colors.C_v,
  image = 'npc/aether_vortex.png',
  desc = [[An awesome vortex of pure magic, power radiates from its frame.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=75,
    talent_in = 6,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 40, 20 },
  ac = 40,
  max_life = resolvers.dice(40, 20),
  rarity = 2,
  level = 54,
  start_level = 54,
  exp_worth = 5000,
  resist_dam = {
    [DamageType.ACID] = true,
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.DISEASE] = true,
    [DamageType.ELEC] = true,
    [DamageType.FEAR] = true,
    [DamageType.FIRE] = true,
    [DamageType.NETHER] = true,
    [DamageType.NEXUS] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.PLASMA] = true,
    [DamageType.POISON] = true,
    [DamageType.WATER] = true,
  },
  melee_retal = {
    [DamageType.COLD] = 'mondam',
    [DamageType.ELEC] = 'mondam',
    [DamageType.FIRE] = 'mondam',
  },
  flags = {
    ATTR_ANY = true,
    ATTR_MULTI = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    EMPTY_MIND = true,
    FLY = true,
    FORCE_SLEEP = true,
    NONLIVING = true,
    NO_CUT = true,
    POWERFUL = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.ELEC, method=AttackType.ENGULF, dam={5,5} },
    { type=DamageType.FIRE, method=AttackType.ENGULF, dam={5,5} },
    { type=DamageType.ACID, method=AttackType.ENGULF, dam={5,5} },
    { type=DamageType.COLD, method=AttackType.ENGULF, dam={5,5} },
  },
  resolvers.talents {
    [Talents.T_NPC_BR_ACID] = 1,
    [Talents.T_NPC_BR_FIRE] = 1,
    [Talents.T_NPC_BR_COLD] = 1,
    [Talents.T_NPC_BR_ELEC] = 1,
    [Talents.T_NPC_BR_POIS] = 1,
    [Talents.T_NPC_BR_LITE] = 1,
    [Talents.T_NPC_BR_DARK] = 1,
    [Talents.T_NPC_BR_SOUN] = 1,
    [Talents.T_NPC_BR_CONF] = 1,
    [Talents.T_NPC_BR_CHAO] = 1,
    [Talents.T_NPC_BR_SHAR] = 1,
    [Talents.T_NPC_BR_NETH] = 1,
    [Talents.T_NPC_BR_WALL] = 1,
    [Talents.T_NPC_BR_INER] = 1,
    [Talents.T_NPC_BR_TIME] = 1,
    [Talents.T_NPC_BR_GRAV] = 1,
    [Talents.T_NPC_BR_PLAS] = 1,
    [Talents.T_NPC_BR_NEXU] = 1,
  },
  body = bodies.none,
  speed = 20,
  vision = 100,
  alertness = 0,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'THE_LERNAEAN_HYDRA',
  name = [[The Lernaean Hydra]],
  display = 'M',
  color = colors.C_v,
  image = 'npc/the_lernaean_hydra.png',
  desc = [[A massive legendary hydra. It has twelve powerful heads. Its many eyes stare at you as clouds of smoke and poisonous vapour rise from its seething form.  It grows new heads as fast as you chop them off.]],
  corpse_weight = 1300,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 3,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 45, 100 },
  ac = 140,
  max_life = 4500,
  rarity = 2,
  level = 55,
  start_level = 55,
  exp_worth = 20000,
  unique = 'THE_LERNAEAN_HYDRA',
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.FIRE] = true,
    [DamageType.POISON] = true,
  },
  vuln_dam = {
    [DamageType.COLD] = true,
  },
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    CAN_SWIM = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    KILL_BODY = true,
    MORTAL = true,
    NO_STUN = true,
    OPEN_DOOR = true,
    POWERFUL = true,
    REGENERATE = true,
    SMART = true,
    UNIQUE = true,
  },
  placement_flags = { WILD_SHORE=true, WILD_SWAMP=true, WILD_TOO=true },
  resolvers.mon_inven{ only_gold=true, '3d2', '4d2' },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.POISON, method=AttackType.BITE, dam={8,6} },
    { type=DamageType.POISON, method=AttackType.BITE, dam={8,6} },
    { type=DamageType.FIRE, method=AttackType.BITE, dam={12,6} },
    { type=DamageType.FIRE, method=AttackType.BITE, dam={12,6} },
  },
  resolvers.talents {
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_BO_FIRE] = 1,
    [Talents.T_NPC_BO_PLAS] = 1,
    [Talents.T_NPC_BA_FIRE] = 1,
    [Talents.T_NPC_BA_POIS] = 1,
    [Talents.T_NPC_BR_FIRE] = 1,
    [Talents.T_NPC_BR_POIS] = 1,
    [Talents.T_NPC_S_HYDRA] = 1,
    [Talents.T_NPC_S_KIN] = 1,
  },
  body = bodies.hydra,
  speed = 10,
  vision = 20,
  alertness = 20,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'THURINGWETHIL_THE_VAMPIRE_MESSENGER',
  name = [[Thuringwethil, the Vampire Messenger]],
  display = 'V',
  color = colors.C_v,
  image = 'npc/thuringwethil_the_vampire_messenger.png',
  desc = [[Chief messenger between Sauron and Morgoth, she is the most deadly of her vampire race on Middle-earth.  At first she is charming to meet, but her wings and eyes give away her true form.]],
  corpse_weight = 150,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 3,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 50, 100 },
  ac = 145,
  max_life = 5000,
  level = 67,
  start_level = 67,
  exp_worth = 23000,
  unique = 'THURINGWETHIL_THE_VAMPIRE_MESSENGER',
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.DARK] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
    [DamageType.TELEPORT] = true,
  },
  vuln_dam = {
    [DamageType.LITE] = true,
    [DamageType.LITE_WEAK] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    CAN_SPEAK = true,
    COLD_BLOOD = true,
    EVIL = true,
    FEMALE = true,
    FLY = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    NO_CUT = true,
    NO_STUN = true,
    OPEN_DOOR = true,
    REGENERATE = true,
    SMART = true,
    SPECIAL_GENE = true,
    UNDEAD = true,
    UNIQUE = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, only_item=true, '2d2', '3d2', '4d2' },
  drop = { treasure=0, combat=50, magic=50, tools=0, junk=0 },
  attacks = {
    { type=DamageType.EXP_80, method=AttackType.BITE, dam={6,6} },
    { type=DamageType.EXP_80, method=AttackType.BITE, dam={6,6} },
    { type=DamageType.CONFUSION, method=AttackType.HIT, dam={6,6} },
    { type=DamageType.CONFUSION, method=AttackType.HIT, dam={6,6} },
  },
  on_melee_hit = util.black_breath_melee_hit,
  resolvers.talents {
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_HOLD] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_CAUSE_3] = 1,
    [Talents.T_NPC_CAUSE_4] = 1,
    [Talents.T_NPC_DRAIN_MANA] = 1,
    [Talents.T_NPC_BRAIN_SMASH] = 1,
    [Talents.T_NPC_BA_NETH] = 1,
    [Talents.T_NPC_S_KIN] = 1,
    [Talents.T_NPC_S_HI_UNDEAD] = 1,
  },
  body = bodies.humanoid,
  speed = 20,
  vision = 20,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'GREAT_HELL_WYRM',
  name = [[Great Hell Wyrm]],
  display = 'D',
  color = colors.C_r,
  multi_colors = { colors.C_r, colors.C_R },
  image = 'npc/great_hell_wyrm.png',
  desc = [[A vast dragon of immense power. Fire leaps continuously from its huge form. The air around it scalds you. Its slightest glance burns you, and you realise how truly insignificant you are.]],
  corpse_weight = 19000,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 4,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 50, 100 },
  ac = 150,
  max_life = 5000,
  rarity = 2,
  level = 67,
  start_level = 67,
  exp_worth = 23000,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.FIRE] = true,
    [DamageType.OLD_SLEEP] = true,
  },
  vuln_dam = {
    [DamageType.COLD] = true,
  },
  melee_retal = {
    [DamageType.FIRE] = 'mondam',
  },
  flags = {
    ATTR_MULTI = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    DRAGON = true,
    EVIL = true,
    FLY = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    HAS_LITE = true,
    MOVE_BODY = true,
    POWERFUL = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, only_item=true, '2d2', '3d2', '4d2' },
  drop = { treasure=50, combat=50, magic=0, tools=0, junk=0 },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={4,12} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={4,12} },
    { type=DamageType.FIRE, method=AttackType.BITE, dam={6,14} },
    { type=DamageType.FIRE, method=AttackType.BITE, dam={6,14} },
  },
  resolvers.talents {
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_BR_FIRE] = 1,
  },
  body = bodies.dragon,
  speed = 10,
  vision = 30,
  alertness = 80,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'DRACONIC_QUYLTHULG',
  name = [[Draconic quylthulg]],
  display = 'Q',
  color = colors.C_g,
  image = 'npc/draconic_quylthulg.png',
  desc = [[It looks like it was once a dragon corpse, now deeply infected with magical bacteria that make it pulse in a foul and degrading way.]],
  corpse_weight = 300,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 2,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 48, 10 },
  ac = 1,
  max_life = 480,
  rarity = 1,
  level = 45,
  start_level = 45,
  exp_worth = 3000,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.FEAR] = true,
    [DamageType.OLD_SLEEP] = true,
  },
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    EMPTY_MIND = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    INVISIBLE = true,
    NEVER_BLOW = true,
    NEVER_MOVE = true,
  },
  placement_flags = {},
  resolvers.talents {
    [Talents.T_NPC_BLINK] = 1,
    [Talents.T_NPC_TPORT] = 1,
    [Talents.T_NPC_S_DRAGON] = 1,
  },
  body = bodies.none,
  speed = 10,
  vision = 20,
  alertness = 0,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'FUNDIN_BLUECLOAK',
  name = [[Fundin Bluecloak]],
  display = 'h',
  color = colors.C_B,
  image = 'npc/fundin_bluecloak.png',
  desc = [[He is one of the greatest dwarven priests to walk the earth. Fundin has earned a high position in the church, and his skill with both weapon and spell only justify his position further. His combination of both dwarven strength and priestly wisdom are a true match for any adventurer.]],
  corpse_weight = 140,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 4,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 50, 100 },
  ac = 195,
  faction = 'friendlies',
  max_life = 5000,
  rarity = 2,
  level = 56,
  start_level = 56,
  exp_worth = 20000,
  unique = 'FUNDIN_BLUECLOAK',
  resist_dam = {
    [DamageType.ACID] = true,
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.ELEC] = true,
    [DamageType.FIRE] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    CAN_SPEAK = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    HAS_LITE = true,
    MALE = true,
    MORTAL = true,
    OPEN_DOOR = true,
    PET = true,
    UNIQUE = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, only_item=true, '1d2', '4d2' },
  drop = { treasure=0, combat=80, magic=20, tools=0, junk=0 },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={10,10} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={8,6} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={8,6} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={8,6} },
  },
  resolvers.talents {
    [Talents.T_NPC_HEAL] = 1,
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_CAUSE_3] = 1,
    [Talents.T_NPC_CAUSE_4] = 1,
    [Talents.T_NPC_BRAIN_SMASH] = 1,
    [Talents.T_NPC_FORGET] = 1,
    [Talents.T_NPC_S_MONSTERS] = 1,
    [Talents.T_NPC_S_ANIMALS] = 1,
  },
  body = bodies.humanoid,
  speed = 20,
  vision = 25,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'BILE_DEMON',
  name = [[Bile Demon]],
  display = 'U',
  color = colors.C_R,
  image = 'npc/bile_demon.png',
  desc = [[It's big.  It's fat.  It's red.  It's ugly.  It's got a severe attack of highly poisonous flatulence.  And its insides are corrosive.  All of which go together to make the single most repulsive sight - and smell - you have ever experienced.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 6,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 35, 100 },
  ac = 90,
  max_life = 3500,
  rarity = 2,
  level = 61,
  start_level = 61,
  exp_worth = 12000,
  resist_dam = {
    [DamageType.ACID] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    DEMON = true,
    EVIL = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    NONLIVING = true,
    POWERFUL = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, only_item=true, '3d2' },
  drop = { treasure=30, combat=70, magic=0, tools=0, junk=0 },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={8,8} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={8,8} },
    { type=DamageType.ACID, method=AttackType.CRUSH, dam={9,9} },
    { type=DamageType.ACID, method=AttackType.CRUSH, dam={9,9} },
  },
  resolvers.talents {
    [Talents.T_NPC_BR_POIS] = 1,
    [Talents.T_NPC_BR_ACID] = 1,
    [Talents.T_NPC_S_DEMON] = 1,
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_ARROW_4] = 1,
  },
  body = { MAIN_HAND=1, OFF_HAND=1, BODY=0, CLOAK=0, LAUNCHER=1, QUIVER=0, GLOVES=1, BOOTS=0, HELM=1, RING=2, AMULET=1, LITE=0, TOOL=1, SYMBIOTE=0, INVEN=23 },
  speed = 10,
  vision = 40,
  alertness = 80,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'URIEL_ANGEL_OF_FIRE',
  name = [[Uriel, Angel of Fire]],
  display = 'A',
  color = colors.C_R,
  image = 'npc/uriel_angel_of_fire.png',
  desc = [[A creature of godly appearance. You dare not challenge Uriel's supremacy. Those who stood against him before are but a memory, cremated by his mastery of elemental fire.]],
  corpse_weight = 340,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 2,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 55, 100 },
  ac = 160,
  faction = 'eru_manwe',
  max_life = 5500,
  rarity = 3,
  level = 61,
  start_level = 61,
  exp_worth = 25000,
  unique = 'URIEL_ANGEL_OF_FIRE',
  resist_dam = {
    [DamageType.ACID] = true,
    [DamageType.ELEC] = true,
    [DamageType.FEAR] = true,
    [DamageType.FIRE] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
    [DamageType.TELEPORT] = true,
  },
  vuln_dam = {
    [DamageType.COLD] = true,
  },
  melee_retal = {
    [DamageType.FIRE] = 'mondam',
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    CAN_SPEAK = true,
    FLY = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    GOOD = true,
    HAS_LITE = true,
    MALE = true,
    MOVE_BODY = true,
    OPEN_DOOR = true,
    POWERFUL = true,
    REFLECTING = true,
    SMART = true,
    TAKE_ITEM = true,
    UNIQUE = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, only_item=true, '3d2', '4d2' },
  drop = { treasure=0, combat=100, magic=0, tools=0, junk=0 },
  attacks = {
    { type=DamageType.FIRE, method=AttackType.HIT, dam={4,12} },
    { type=DamageType.FIRE, method=AttackType.HIT, dam={4,12} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={10,10} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={10,10} },
  },
  resolvers.talents {
    [Talents.T_NPC_TELE_TO] = 1,
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_BO_FIRE] = 1,
    [Talents.T_NPC_BO_MANA] = 1,
    [Talents.T_NPC_BA_FIRE] = 1,
    [Talents.T_NPC_BR_FIRE] = 1,
    [Talents.T_NPC_BR_PLAS] = 1,
    [Talents.T_NPC_S_ANGEL] = 1,
  },
  body = bodies.humanoid,
  speed = 20,
  vision = 40,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'AZRIEL_ANGEL_OF_DEATH',
  name = [[Azriel, Angel of Death]],
  display = 'A',
  color = colors.C_D,
  image = 'npc/azriel_angel_of_death.png',
  desc = [[Azriel commands awesome power, his visage holy enough to shrivel your soul. You shriek with disbelief as his mastery of death draws you to your grave. It is truly beyond all but the mightiest of warriors to stand against him and live.]],
  corpse_weight = 340,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 2,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 60, 100 },
  ac = 170,
  faction = 'eru_manwe',
  max_life = 6000,
  rarity = 3,
  level = 62,
  start_level = 62,
  exp_worth = 30000,
  unique = 'AZRIEL_ANGEL_OF_DEATH',
  resist_dam = {
    [DamageType.ACID] = true,
    [DamageType.COLD] = true,
    [DamageType.ELEC] = true,
    [DamageType.FEAR] = true,
    [DamageType.FIRE] = true,
    [DamageType.NETHER] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
    [DamageType.TELEPORT] = true,
  },
  melee_retal = {
    [DamageType.COLD] = 'mondam',
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    CAN_SPEAK = true,
    FLY = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    GOOD = true,
    HAS_LITE = true,
    MALE = true,
    MOVE_BODY = true,
    OPEN_DOOR = true,
    POWERFUL = true,
    REFLECTING = true,
    SMART = true,
    TAKE_ITEM = true,
    UNIQUE = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, only_item=true, '3d2', '4d2' },
  drop = { treasure=0, combat=100, magic=0, tools=0, junk=0 },
  attacks = {
    { type=DamageType.EXP_80, method=AttackType.HIT, dam={10,5} },
    { type=DamageType.EXP_80, method=AttackType.HIT, dam={10,5} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={10,10} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={10,10} },
  },
  resolvers.talents {
    [Talents.T_NPC_TELE_TO] = 1,
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_BO_MANA] = 1,
    [Talents.T_NPC_BO_NETH] = 1,
    [Talents.T_NPC_BA_NETH] = 1,
    [Talents.T_NPC_BR_NETH] = 1,
    [Talents.T_NPC_S_ANGEL] = 1,
  },
  body = bodies.humanoid,
  speed = 20,
  vision = 40,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'ANCALAGON_THE_BLACK',
  name = [[Ancalagon the Black]],
  display = 'D',
  color = colors.C_D,
  image = 'npc/ancalagon_the_black.png',
  desc = [["Rushing Jaws" is his name, and death is his game; the greatest and most terrible of all dragonkind, his power dismayed even the Valar for a time.]],
  corpse_weight = 33000,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 3,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 180, 100 },
  ac = 170,
  max_life = 18000,
  rarity = 1,
  level = 90,
  start_level = 90,
  exp_worth = 60000,
  unique = 'ANCALAGON_THE_BLACK',
  resist_dam = {
    [DamageType.ACID] = true,
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.ELEC] = true,
    [DamageType.FIRE] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    DRAGON = true,
    ESCORT = true,
    EVIL = true,
    FLY = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    HAS_LITE = true,
    MALE = true,
    MOVE_BODY = true,
    OPEN_DOOR = true,
    POWERFUL = true,
    UNIQUE = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, great=true, only_item=true, '2d2', '3d2', '4d2' },
  drop = { treasure=60, combat=40, magic=0, tools=0, junk=0 },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={10,12} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={10,12} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={10,14} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={10,14} },
  },
  resolvers.talents {
    [Talents.T_NPC_BR_ACID] = 1,
    [Talents.T_NPC_BR_FIRE] = 1,
    [Talents.T_NPC_BR_DISI] = 1,
    [Talents.T_NPC_BR_WALL] = 1,
    [Talents.T_NPC_BR_TIME] = 1,
    [Talents.T_NPC_S_HI_DRAGON] = 1,
    [Talents.T_NPC_S_KIN] = 1,
  },
  body = bodies.dragon,
  speed = 30,
  vision = 40,
  alertness = 70,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'NIGHTWALKER',
  name = [[Nightwalker]],
  display = 'W',
  color = colors.C_D,
  image = 'npc/nightwalker.png',
  desc = [[A huge giant garbed in black, more massive than a titan and stronger than a dragon. With terrible blows, it breaks your armour from your back, leaving you defenceless against its evil wrath. It can smell your fear, and you in turn smell the awful stench of death as this ghastly figure strides towards you menacingly.]],
  corpse_weight = 7500,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 4,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 80, 70 },
  ac = 175,
  max_life = 5600,
  rarity = 3,
  level = 73,
  start_level = 73,
  exp_worth = 20000,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.DARK] = true,
    [DamageType.ELEC] = true,
    [DamageType.FIRE] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
    [DamageType.TELEPORT] = true,
  },
  vuln_dam = {
    [DamageType.LITE] = true,
    [DamageType.LITE_WEAK] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    CAN_SWIM = true,
    COLD_BLOOD = true,
    EVIL = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    NO_CUT = true,
    OPEN_DOOR = true,
    SMART = true,
    UNDEAD = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, only_item=true, '4d2' },
  drop = { treasure=30, combat=0, magic=70, tools=0, junk=0 },
  attacks = {
    { type=DamageType.DISENCHANT, method=AttackType.HIT, dam={10,10} },
    { type=DamageType.DISENCHANT, method=AttackType.HIT, dam={10,10} },
    { type=DamageType.DISENCHANT, method=AttackType.HIT, dam={7,7} },
    { type=DamageType.DISENCHANT, method=AttackType.HIT, dam={7,7} },
  },
  on_melee_hit = util.black_breath_melee_hit,
  resolvers.talents {
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_BRAIN_SMASH] = 1,
    [Talents.T_NPC_BO_MANA] = 1,
    [Talents.T_NPC_BO_NETH] = 1,
    [Talents.T_NPC_BA_NETH] = 1,
    [Talents.T_NPC_S_UNDEAD] = 1,
  },
  body = bodies.humanoid,
  speed = 20,
  vision = 20,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'GABRIEL_THE_MESSENGER',
  name = [[Gabriel, the Messenger]],
  display = 'A',
  color = colors.C_w,
  image = 'npc/gabriel_the_messenger.png',
  desc = [[Commanding a legion of angels, Gabriel will destroy you for your sins. He will crush you like the pitiful insignificant being he sees you to be. Your very soul will be taken into judgement by his supreme authority as he cleanses the world of evil.]],
  corpse_weight = 350,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 2,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 75, 100 },
  ac = 180,
  faction = 'eru_manwe',
  max_life = 7500,
  rarity = 3,
  level = 64,
  start_level = 64,
  exp_worth = 35000,
  unique = 'GABRIEL_THE_MESSENGER',
  resist_dam = {
    [DamageType.ACID] = true,
    [DamageType.COLD] = true,
    [DamageType.ELEC] = true,
    [DamageType.FIRE] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
    [DamageType.TELEPORT] = true,
  },
  melee_retal = {
    [DamageType.ELEC] = 'mondam',
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    CAN_SPEAK = true,
    ESCORT = true,
    FLY = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    GOOD = true,
    HAS_LITE = true,
    MALE = true,
    MOVE_BODY = true,
    OPEN_DOOR = true,
    POWERFUL = true,
    REFLECTING = true,
    SMART = true,
    TAKE_ITEM = true,
    UNIQUE = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, only_item=true, '3d2', '4d2' },
  drop = { treasure=0, combat=40, magic=60, tools=0, junk=0 },
  attacks = {
    { type=DamageType.DISENCHANT, method=AttackType.HIT, dam={6,8} },
    { type=DamageType.FIRE, method=AttackType.HIT, dam={6,8} },
    { type=DamageType.BLIND, method=AttackType.HIT, dam={10,10} },
    { type=DamageType.BLIND, method=AttackType.HIT, dam={10,10} },
  },
  resolvers.talents {
    [Talents.T_NPC_TELE_TO] = 1,
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_BO_MANA] = 1,
    [Talents.T_NPC_S_ANGEL] = 1,
    [Talents.T_NPC_S_KIN] = 1,
  },
  body = bodies.humanoid,
  speed = 20,
  vision = 40,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'SARUMAN_OF_MANY_COLOURS',
  name = [[Saruman of Many Colours]],
  display = 'p',
  color = colors.C_v,
  image = 'npc/saruman_of_many_colours.png',
  desc = [[Originally known as the White, Saruman fell prey to Sauron's wiles. He searches forever for the One Ring, to become a mighty Sorcerer-King of the world.]],
  corpse_weight = 160,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 2,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 70, 100 },
  ac = 100,
  max_life = 7000,
  rarity = 1,
  level = 60,
  start_level = 60,
  exp_worth = 35000,
  unique = 'SARUMAN_OF_MANY_COLOURS',
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.ELEC] = true,
    [DamageType.FIRE] = true,
    [DamageType.POISON] = true,
    [DamageType.TELEPORT] = true,
  },
  flags = {
    ATTR_MULTI = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    CAN_SPEAK = true,
    EVIL = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    HAS_LITE = true,
    MALE = true,
    OPEN_DOOR = true,
    REFLECTING = true,
    SMART = true,
    UNIQUE = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, great=true, only_item=true, '2d2', '3d2', '4d2' },
  drop = { treasure=0, combat=0, magic=100, tools=0, junk=0 },
  drop_special = function(self) return rng.percent(30) and game.zone:makeEntityByName(game.level, 'artifact', 'OF_ORTHANC', false) end,
  attacks = {
    { type=DamageType.DISENCHANT, method=AttackType.HIT, dam={6,8} },
    { type=DamageType.DISENCHANT, method=AttackType.HIT, dam={6,8} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={5,5} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={5,5} },
  },
  resolvers.talents {
    [Talents.T_NPC_HEAL] = 1,
    [Talents.T_NPC_HASTE] = 1,
    [Talents.T_NPC_TPORT] = 1,
    [Talents.T_NPC_TELE_AWAY] = 1,
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_CAUSE_4] = 1,
    [Talents.T_NPC_MIND_BLAST] = 1,
    [Talents.T_NPC_FORGET] = 1,
    [Talents.T_NPC_TRAPS] = 1,
    [Talents.T_NPC_ANIM_DEAD] = 1,
    [Talents.T_NPC_BO_MANA] = 1,
    [Talents.T_NPC_BO_ICEE] = 1,
    [Talents.T_NPC_BA_ACID] = 1,
    [Talents.T_NPC_BA_FIRE] = 1,
    [Talents.T_NPC_BA_COLD] = 1,
    [Talents.T_NPC_BA_WATE] = 1,
    [Talents.T_NPC_BA_CHAO] = 1,
    [Talents.T_NPC_S_UNDEAD] = 1,
    [Talents.T_NPC_S_DEMON] = 1,
    [Talents.T_NPC_S_HI_DRAGON] = 1,
    [Talents.T_NPC_S_ANIMALS] = 1,
  },
  body = bodies.humanoid,
  speed = 10,
  vision = 100,
  alertness = 0,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'HAROWEN_THE_BLACK_HAND',
  name = [[Harowen the Black Hand]],
  display = 'p',
  color = colors.C_B,
  image = 'npc/harowen_the_black_hand.png',
  desc = [[He is a master of disguise, an expert of stealth, a genius at traps, and moves with blinding speed. Check your pockets!]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 6,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 25, 100 },
  ac = 36,
  max_life = 2500,
  rarity = 3,
  level = 51,
  start_level = 51,
  exp_worth = 20000,
  unique = 'HAROWEN_THE_BLACK_HAND',
  resist_dam = {
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    CAN_SPEAK = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    MALE = true,
    MOVE_BODY = true,
    OPEN_DOOR = true,
    SMART = true,
    TAKE_ITEM = true,
    UNIQUE = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, only_item=true, '1d2', '4d2' },
  drop = { treasure=90, combat=10, magic=0, tools=0, junk=0 },
  attacks = {
    { type=DamageType.EAT_GOLD, method=AttackType.TOUCH, dam={5,5} },
    { type=DamageType.EAT_ITEM, method=AttackType.TOUCH, dam={5,5} },
    { type=DamageType.BLIND, method=AttackType.HIT, dam={10,5} },
    { type=DamageType.POISON, method=AttackType.HIT, dam={8,5} },
  },
  resolvers.talents {
    [Talents.T_NPC_TELE_TO] = 1,
    [Talents.T_NPC_TRAPS] = 1,
  },
  body = bodies.humanoid,
  speed = 30,
  vision = 30,
  alertness = 0,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'OSYLUTH',
  name = [[Osyluth]],
  display = 'U',
  color = colors.C_W,
  image = 'npc/osyluth.png',
  desc = [[It is a demon made almost entirely out of bones.  It is humanoid, but with a large tail similar to that of a giant scorpion, and emits a foul smell of decay and rot.  They are despised even in the hells.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 6,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 40, 100 },
  ac = 75,
  max_life = 4000,
  rarity = 2,
  level = 65,
  start_level = 65,
  exp_worth = 13000,
  resist_dam = {
    [DamageType.ACID] = true,
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.ELEC] = true,
    [DamageType.FIRE] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    DEMON = true,
    EVIL = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    INVISIBLE = true,
    MOVE_BODY = true,
    NONLIVING = true,
    NO_CUT = true,
    OPEN_DOOR = true,
    POWERFUL = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, only_item=true, '3d2' },
  drop = { treasure=20, combat=40, magic=20, tools=20, junk=0 },
  attacks = {
    { type=DamageType.LOSE_CHR, method=AttackType.HIT, dam={8,8} },
    { type=DamageType.LOSE_CHR, method=AttackType.HIT, dam={8,8} },
    { type=DamageType.POISON, method=AttackType.BITE, dam={10,10} },
    { type=DamageType.LOSE_STR, method=AttackType.STING, dam={9,9} },
  },
  resolvers.talents {
    [Talents.T_NPC_BA_ELEC] = 1,
    [Talents.T_NPC_BA_COLD] = 1,
    [Talents.T_NPC_BO_ICEE] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_S_DEMON] = 1,
  },
  body = bodies.humanoid,
  speed = 20,
  vision = 20,
  alertness = 80,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'DREADLORD',
  name = [[Dreadlord]],
  display = 'G',
  color = colors.C_r,
  image = 'npc/dreadlord.png',
  desc = [[It is a massive form of animated death, its colour deeper than black.  It drinks in light, and space around it is twisted and torn by the weight of its evil.  It is unlife and it knows nothing but the stealing of souls and the stench of death.  Flee its hunger!]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 3,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 30, 100 },
  ac = 150,
  max_life = 3000,
  rarity = 2,
  level = 62,
  start_level = 62,
  exp_worth = 20000,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
    [DamageType.TELEPORT] = true,
  },
  flags = {
    BASEANGBAND = true,
    COLD_BLOOD = true,
    EVIL = true,
    FLY = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    INVISIBLE = true,
    NO_CUT = true,
    PASS_WALL = true,
    TAKE_ITEM = true,
    UNDEAD = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ only_item=true, '2d2', '3d2', '4d2' },
  drop = { treasure=10, combat=10, magic=60, tools=10, junk=10 },
  attacks = {
    { type=DamageType.EXP_40, method=AttackType.HIT, dam={6,6} },
    { type=DamageType.EXP_40, method=AttackType.HIT, dam={6,6} },
    { type=DamageType.LOSE_STR, method=AttackType.HIT, dam={4,6} },
    { type=DamageType.LOSE_STR, method=AttackType.HIT, dam={4,6} },
  },
  on_melee_hit = util.black_breath_melee_hit,
  resolvers.talents {
    [Talents.T_NPC_HOLD] = 1,
    [Talents.T_NPC_DRAIN_MANA] = 1,
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_S_UNDEAD] = 1,
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_TELE_TO] = 1,
    [Talents.T_NPC_TPORT] = 1,
    [Talents.T_NPC_BRAIN_SMASH] = 1,
    [Talents.T_NPC_ANIM_DEAD] = 1,
    [Talents.T_NPC_BA_NETH] = 1,
    [Talents.T_NPC_DARKNESS] = 1,
  },
  body = bodies.none,
  speed = 10,
  vision = 20,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'GREATER_KRAKEN',
  name = [[Greater kraken]],
  display = '~',
  color = colors.C_G,
  image = 'npc/greater_kraken.png',
  desc = [[An enormously fearsome and powerful inhabitant of the depths. It resembles a gargantuan octopus and its evil is almost tangible.]],
  corpse_weight = 1000,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 3,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 40, 100 },
  ac = 175,
  max_life = 4000,
  rarity = 2,
  level = 60,
  start_level = 60,
  exp_worth = 25000,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.ELEC] = true,
    [DamageType.FIRE] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
    [DamageType.WATER] = true,
  },
  flags = {
    AQUATIC = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    EVIL = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    MOVE_BODY = true,
    POWERFUL = true,
    SMART = true,
  },
  placement_flags = { WILD_OCEAN=true, WILD_TOO=true },
  resolvers.mon_inven{ good=true, only_item=true, '3d2' },
  drop = { treasure=10, combat=80, magic=0, tools=10, junk=0 },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CRUSH, dam={15,15} },
    { type=DamageType.PHYSICAL, method=AttackType.CRUSH, dam={15,15} },
    { type=DamageType.PHYSICAL, method=AttackType.CRUSH, dam={15,15} },
    { type=DamageType.PHYSICAL, method=AttackType.CRUSH, dam={15,15} },
  },
  resolvers.talents {
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_CAUSE_4] = 1,
    [Talents.T_NPC_CAUSE_3] = 1,
    [Talents.T_NPC_TELE_TO] = 1,
    [Talents.T_NPC_TELE_AWAY] = 1,
    [Talents.T_NPC_BA_WATE] = 1,
    [Talents.T_NPC_DARKNESS] = 1,
    [Talents.T_NPC_BR_DARK] = 1,
    [Talents.T_NPC_BR_ACID] = 1,
    [Talents.T_NPC_BR_POIS] = 1,
  },
  body = { MAIN_HAND=3, OFF_HAND=3, BODY=0, CLOAK=0, LAUNCHER=1, QUIVER=0, GLOVES=3, BOOTS=0, HELM=1, RING=0, AMULET=1, LITE=0, TOOL=1, SYMBIOTE=0, INVEN=23 },
  speed = 10,
  vision = 30,
  alertness = 80,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'ARCHLICH',
  name = [[Archlich]],
  display = 'L',
  color = colors.C_B,
  image = 'npc/archlich.png',
  desc = [[A lich who has reached its ultimate evolutionary stage: a completely immaterial state.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 3,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 45, 100 },
  ac = 120,
  max_life = 4500,
  rarity = 2,
  level = 64,
  start_level = 64,
  exp_worth = 20000,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
    [DamageType.TELEPORT] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    COLD_BLOOD = true,
    EVIL = true,
    FLY = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    NO_CUT = true,
    OPEN_DOOR = true,
    PASS_WALL = true,
    SMART = true,
    UNDEAD = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, only_item=true, '2d2', '4d2' },
  drop = { treasure=0, combat=0, magic=100, tools=0, junk=0 },
  attacks = {
    { type=DamageType.EXP_80, method=AttackType.TOUCH },
    { type=DamageType.UN_POWER, method=AttackType.TOUCH },
    { type=DamageType.LOSE_DEX, method=AttackType.TOUCH, dam={8,12} },
    { type=DamageType.LOSE_DEX, method=AttackType.TOUCH, dam={8,12} },
  },
  on_melee_hit = util.black_breath_melee_hit,
  resolvers.talents {
    [Talents.T_NPC_BLINK] = 1,
    [Talents.T_NPC_TELE_TO] = 1,
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_HOLD] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_CAUSE_4] = 1,
    [Talents.T_NPC_DRAIN_MANA] = 1,
    [Talents.T_NPC_BRAIN_SMASH] = 1,
    [Talents.T_NPC_S_HI_UNDEAD] = 1,
    [Talents.T_NPC_FORGET] = 1,
    [Talents.T_NPC_TPORT] = 1,
    [Talents.T_NPC_HEAL] = 1,
    [Talents.T_NPC_S_DEMON] = 1,
    [Talents.T_NPC_BA_NETH] = 1,
    [Talents.T_NPC_ANIM_DEAD] = 1,
  },
  body = bodies.none,
  speed = 10,
  vision = 20,
  alertness = 50,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'THE_CAT_LORD',
  name = [[The Cat Lord]],
  display = 'f',
  color = colors.C_v,
  image = 'npc/the_cat_lord.png',
  desc = [[Master of all things feline, the Cat Lord moves with catlike stealth.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 3,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 48, 100 },
  ac = 200,
  max_life = 4800,
  rarity = 3,
  level = 66,
  start_level = 66,
  exp_worth = 30000,
  unique = 'THE_CAT_LORD',
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.FIRE] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    ESCORT = true,
    ESCORTS = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    INVISIBLE = true,
    MALE = true,
    OPEN_DOOR = true,
    UNIQUE = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, only_item=true, '4d2' },
  drop = { treasure=30, combat=60, magic=0, tools=10, junk=0 },
  attacks = {
    { type=DamageType.CONFUSION, method=AttackType.CLAW, dam={12,12} },
    { type=DamageType.LOSE_DEX, method=AttackType.CLAW, dam={2,12} },
    { type=DamageType.BLIND, method=AttackType.CLAW, dam={10,5} },
    { type=DamageType.PARALYZE, method=AttackType.BITE, dam={15,1} },
  },
  resolvers.talents {
    [Talents.T_NPC_TELE_TO] = 1,
    [Talents.T_NPC_S_KIN] = 1,
  },
  body = bodies.quadruped,
  speed = 20,
  vision = 100,
  alertness = 0,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'JABBERWOCK',
  name = [[Jabberwock]],
  display = 'H',
  color = colors.C_v,
  image = 'npc/jabberwock.png',
  desc = [['Twas brillig, and the slithy toves / Did gyre and gimble in the wabe: / All mimsy were the borogoves, / And the mome raths outgrabe. / "Beware the Jabberwock, my son! / The jaws that bite, the claws that catch!"]],
  corpse_weight = 230,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 5,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 32, 100 },
  ac = 125,
  max_life = 3200,
  rarity = 3,
  level = 68,
  start_level = 68,
  exp_worth = 19000,
  resist_dam = {
    [DamageType.TELEPORT] = true,
  },
  flags = {
    ANIMAL = true,
    ATTR_MULTI = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    FLY = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    MORTAL = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ only_item=true, '60%', '90%' },
  drop = { treasure=20, combat=50, magic=20, tools=0, junk=10 },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={10,10} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={10,10} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={10,10} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={10,10} },
  },
  resolvers.talents {
    [Talents.T_NPC_CAUSE_4] = 1,
    [Talents.T_NPC_BR_CHAO] = 1,
  },
  body = bodies.quadruped,
  speed = 20,
  vision = 35,
  alertness = 255,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'CHAOS_HOUND',
  name = [[Chaos hound]],
  display = 'Z',
  color = colors.C_v,
  image = 'npc/chaos_hound.png',
  desc = [[A constantly changing canine form, this hound rushes towards you as if expecting mayhem and chaos ahead. It appears to have an almost kamikaze relish for combat. You suspect all may not be as it seems.]],
  corpse_weight = 90,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 5,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 60, 30 },
  ac = 100,
  max_life = resolvers.dice(60, 30),
  rarity = 2,
  level = 65,
  start_level = 65,
  exp_worth = 10000,
  resist_dam = {
    [DamageType.CHAOS] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.OLD_SLEEP] = true,
  },
  flags = {
    ANIMAL = true,
    ATTR_ANY = true,
    ATTR_MULTI = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    FORCE_SLEEP = true,
    FRIENDS = true,
  },
  placement_flags = {},
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={2,12} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={2,12} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={2,12} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={2,12} },
  },
  resolvers.talents {
    [Talents.T_NPC_BR_CHAO] = 1,
  },
  body = bodies.quadruped,
  speed = 10,
  vision = 30,
  alertness = 0,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'BEHOLDER_HIVE_MOTHER',
  name = [[Beholder hive-mother]],
  display = 'e',
  color = colors.C_y,
  image = 'npc/beholder_hive_mother.png',
  desc = [[A hive mother of the race of beholders, she can summon her brood to her aid whenever she wishes.]],
  corpse_weight = 260,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 2,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 40, 100 },
  ac = 80,
  max_life = 4000,
  rarity = 3,
  level = 67,
  start_level = 67,
  exp_worth = 17000,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
    [DamageType.TELEPORT] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    EVIL = true,
    FEMALE = true,
    FLY = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    SMART = true,
  },
  placement_flags = {},
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.EXP_80, method=AttackType.BITE, dam={6,6} },
    { type=DamageType.PARALYZE, method=AttackType.GAZE, dam={5,5} },
    { type=DamageType.INSANITY, method=AttackType.GAZE, dam={5,5} },
    { type=DamageType.UN_POWER, method=AttackType.GAZE, dam={5,5} },
  },
  resolvers.talents {
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_FORGET] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_DRAIN_MANA] = 1,
    [Talents.T_NPC_BRAIN_SMASH] = 1,
    [Talents.T_NPC_BA_DARK] = 1,
    [Talents.T_NPC_BO_MANA] = 1,
    [Talents.T_NPC_BA_ACID] = 1,
    [Talents.T_NPC_BA_FIRE] = 1,
    [Talents.T_NPC_BA_COLD] = 1,
    [Talents.T_NPC_BO_NETH] = 1,
    [Talents.T_NPC_S_KIN] = 1,
  },
  body = bodies.none,
  speed = 10,
  vision = 30,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'LEVIATHAN',
  name = [[Leviathan]],
  display = '~',
  color = colors.C_v,
  image = 'npc/leviathan.png',
  desc = [[An enormous, terrible sea-monster, the true master of the ocean.]],
  corpse_weight = 30000,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 9,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 50, 100 },
  ac = 180,
  max_life = 5000,
  rarity = 3,
  level = 67,
  start_level = 67,
  exp_worth = 28000,
  resist_dam = {
    [DamageType.ACID] = true,
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.FEAR] = true,
    [DamageType.FIRE] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    ANIMAL = true,
    AQUATIC = true,
    BASEANGBAND = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
  },
  placement_flags = { WILD_OCEAN=true, WILD_TOO=true },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.FIRE, method=AttackType.BITE, dam={5,12} },
    { type=DamageType.FIRE, method=AttackType.BITE, dam={5,12} },
    { type=DamageType.PHYSICAL, method=AttackType.CRUSH, dam={6,15} },
    { type=DamageType.PHYSICAL, method=AttackType.CRUSH, dam={6,15} },
  },
  resolvers.talents {
    [Talents.T_NPC_BR_FIRE] = 1,
    [Talents.T_NPC_BR_ACID] = 1,
    [Talents.T_NPC_BR_DARK] = 1,
    [Talents.T_NPC_BR_POIS] = 1,
    [Talents.T_NPC_BA_WATE] = 1,
    [Talents.T_NPC_S_DRAGON] = 1,
    [Talents.T_NPC_S_HYDRA] = 1,
    [Talents.T_NPC_HEAL] = 1,
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_DARKNESS] = 1,
  },
  body = bodies.dragon,
  speed = 10,
  vision = 40,
  alertness = 30,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'GREAT_WYRM_OF_CHAOS',
  name = [[Great Wyrm of Chaos]],
  display = 'D',
  color = colors.C_v,
  image = 'npc/great_wyrm_of_chaos.png',
  desc = [[A massive dragon of changing form. As you watch, it appears first fair and then foul. Its body is twisted by chaotic forces as it strives to stay real. Its very existence distorts the universe around it.]],
  corpse_weight = 19000,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 4,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 60, 100 },
  ac = 170,
  max_life = 6000,
  rarity = 2,
  level = 75,
  start_level = 75,
  exp_worth = 29000,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.DISEASE] = true,
    [DamageType.OLD_SLEEP] = true,
  },
  flags = {
    ATTR_ANY = true,
    ATTR_MULTI = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    DRAGON = true,
    EVIL = true,
    FLY = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    HAS_LITE = true,
    MOVE_BODY = true,
    POWERFUL = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, only_item=true, '2d2', '3d2', '4d2' },
  drop = { treasure=50, combat=50, magic=0, tools=0, junk=0 },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={5,12} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={5,12} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={7,14} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={7,14} },
  },
  resolvers.talents {
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_BR_CHAO] = 1,
    [Talents.T_NPC_BR_DISE] = 1,
    [Talents.T_NPC_S_DRAGON] = 1,
    [Talents.T_NPC_S_HI_DRAGON] = 1,
  },
  body = bodies.dragon,
  speed = 10,
  vision = 40,
  alertness = 100,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'GREAT_WYRM_OF_LAW',
  name = [[Great Wyrm of Law]],
  display = 'D',
  color = colors.C_B,
  multi_colors = { colors.C_y, colors.C_u },
  image = 'npc/great_wyrm_of_law.png',
  desc = [[A massive dragon of powerful intellect. It seeks to dominate the universe and despises all other life. It sees all who do not obey it as mere insects to be crushed underfoot.]],
  corpse_weight = 19000,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 4,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 60, 100 },
  ac = 170,
  max_life = 6000,
  rarity = 2,
  level = 75,
  start_level = 75,
  exp_worth = 29000,
  resist_dam = {
    [DamageType.OLD_SLEEP] = true,
  },
  flags = {
    ATTR_MULTI = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    DRAGON = true,
    EVIL = true,
    FLY = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    HAS_LITE = true,
    MOVE_BODY = true,
    NO_CUT = true,
    NO_STUN = true,
    POWERFUL = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, only_item=true, '2d2', '3d2', '4d2' },
  drop = { treasure=50, combat=50, magic=0, tools=0, junk=0 },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={5,12} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={5,12} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={7,14} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={7,14} },
  },
  resolvers.talents {
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_BR_SOUN] = 1,
    [Talents.T_NPC_BR_SHAR] = 1,
    [Talents.T_NPC_S_DRAGON] = 1,
    [Talents.T_NPC_S_HI_DRAGON] = 1,
  },
  body = bodies.dragon,
  speed = 10,
  vision = 40,
  alertness = 100,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'GREAT_WYRM_OF_BALANCE',
  name = [[Great Wyrm of Balance]],
  display = 'D',
  color = colors.C_v,
  image = 'npc/great_wyrm_of_balance.png',
  desc = [[A massive dragon, it is thousands of years old and seeks to maintain the Cosmic Balance. It sees you as an upstart troublemaker without the wisdom to control your actions.]],
  corpse_weight = 19000,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 4,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 70, 100 },
  ac = 170,
  max_life = 7000,
  rarity = 2,
  level = 80,
  start_level = 80,
  exp_worth = 31000,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.DISEASE] = true,
    [DamageType.OLD_SLEEP] = true,
  },
  flags = {
    ATTR_MULTI = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    DRAGON = true,
    EVIL = true,
    FLY = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    HAS_LITE = true,
    MOVE_BODY = true,
    NO_CUT = true,
    NO_STUN = true,
    POWERFUL = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, only_item=true, '2d2', '3d2', '4d2' },
  drop = { treasure=50, combat=50, magic=0, tools=0, junk=0 },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={6,12} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={6,12} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={8,14} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={8,14} },
  },
  resolvers.talents {
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_BR_SOUN] = 1,
    [Talents.T_NPC_BR_CHAO] = 1,
    [Talents.T_NPC_BR_SHAR] = 1,
    [Talents.T_NPC_BR_DISE] = 1,
    [Talents.T_NPC_S_DRAGON] = 1,
    [Talents.T_NPC_S_HI_DRAGON] = 1,
  },
  body = bodies.dragon,
  speed = 10,
  vision = 40,
  alertness = 100,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'GELUGON',
  name = [[Gelugon]],
  display = 'U',
  color = colors.C_w,
  image = 'npc/gelugon.png',
  desc = [[This demon from the ice planes is a truly terrifying sight.  It has an extremely large, insect-like body towering a full twelve feet tall, with great claws on its hands and pincers on its mouth, and its head bulges with great multi-faceted eyes.  Its tail is covered with razor-sharp spikes.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 6,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 45, 100 },
  ac = 100,
  max_life = 4500,
  rarity = 3,
  level = 69,
  start_level = 69,
  exp_worth = 14000,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.OLD_SLEEP] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    DEMON = true,
    EVIL = true,
    FLY = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    NONLIVING = true,
    OPEN_DOOR = true,
    POWERFUL = true,
    REGENERATE = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, only_item=true, '4d2' },
  drop = { treasure=20, combat=60, magic=20, tools=0, junk=0 },
  attacks = {
    { type=DamageType.COLD, method=AttackType.CLAW, dam={6,10} },
    { type=DamageType.COLD, method=AttackType.CLAW, dam={6,10} },
    { type=DamageType.COLD, method=AttackType.BITE, dam={9,9} },
    { type=DamageType.PARALYZE, method=AttackType.HIT, dam={8,8} },
  },
  resolvers.talents {
    [Talents.T_NPC_BR_COLD] = 1,
    [Talents.T_NPC_BR_SHAR] = 1,
    [Talents.T_NPC_BA_COLD] = 1,
    [Talents.T_NPC_BO_ICEE] = 1,
    [Talents.T_NPC_S_HI_DEMON] = 1,
    [Talents.T_NPC_SLOW] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_HOLD] = 1,
  },
  body = { MAIN_HAND=2, OFF_HAND=2, BODY=1, CLOAK=1, LAUNCHER=1, QUIVER=1, GLOVES=2, BOOTS=1, HELM=0, RING=0, AMULET=0, LITE=1, TOOL=1, SYMBIOTE=1, INVEN=23 },
  speed = 20,
  vision = 20,
  alertness = 80,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'TRONE_THE_REBEL_THUNDERLORD',
  name = [[Trone, the Rebel Thunderlord]],
  display = 'B',
  color = colors.C_D,
  image = 'npc/trone_the_rebel_thunderlord.png',
  desc = [[As the Thunderlords came from afar to help the elves, Trone and his rebel wing came to defend Morgoth! He is an evil and powerful Thunderlord.]],
  corpse_weight = 40000,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 4,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 80, 100 },
  ac = 120,
  max_life = 8000,
  level = 72,
  start_level = 72,
  exp_worth = 45000,
  unique = 'TRONE_THE_REBEL_THUNDERLORD',
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.FIRE] = true,
    [DamageType.POISON] = true,
    [DamageType.TELEPORT] = true,
  },
  flags = {
    BASH_DOOR = true,
    CAN_SPEAK = true,
    EVIL = true,
    FLY = true,
    FORCE_MAXHP = true,
    HAS_LITE = true,
    MALE = true,
    MORTAL = true,
    OPEN_DOOR = true,
    REGENERATE = true,
    SMART = true,
    SPECIAL_GENE = true,
    THUNDERLORD = true,
    UNIQUE = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, great=true, only_item=true, '2d2', '3d2', '4d2' },
  drop = { treasure=50, combat=50, magic=0, tools=0, junk=0 },
  drop_special = function(self) return game.zone:makeEntityByName(game.level, 'artifact', 'OF_TRONE', false) end,
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={12,10} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={12,10} },
    { type=DamageType.PHYSICAL, method=AttackType.CHARGE, dam={10,10} },
    { type=DamageType.PHYSICAL, method=AttackType.CHARGE, dam={10,10} },
  },
  resolvers.talents {
    [Talents.T_NPC_TELE_TO] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_BR_TIME] = 1,
    [Talents.T_NPC_BR_FIRE] = 1,
    [Talents.T_NPC_BO_MANA] = 1,
    [Talents.T_NPC_S_THUNDERLORD] = 1,
  },
  body = bodies.humanoid,
  speed = 20,
  vision = 20,
  alertness = 80,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'GREAT_WYRM_OF_MANY_COLOURS',
  name = [[Great Wyrm of Many Colours]],
  display = 'D',
  color = colors.C_v,
  multi_colors = { colors.C_g, colors.C_b, colors.C_d, colors.C_r, colors.C_w },
  image = 'npc/great_wyrm_of_many_colours.png',
  desc = [[A huge dragon whose scales shimmer in myriad hues.]],
  corpse_weight = 19000,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 4,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 70, 100 },
  ac = 170,
  max_life = 7000,
  rarity = 2,
  level = 80,
  start_level = 80,
  exp_worth = 31000,
  resist_dam = {
    [DamageType.ACID] = true,
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.ELEC] = true,
    [DamageType.FIRE] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
    [DamageType.TELEPORT] = true,
  },
  melee_retal = {
    [DamageType.COLD] = 'mondam',
    [DamageType.ELEC] = 'mondam',
    [DamageType.FIRE] = 'mondam',
  },
  flags = {
    ATTR_MULTI = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    DRAGON = true,
    FLY = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    HAS_LITE = true,
    MOVE_BODY = true,
    POWERFUL = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, only_item=true, '2d2', '3d2', '4d2' },
  drop = { treasure=50, combat=50, magic=0, tools=0, junk=0 },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={6,12} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={6,12} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={8,14} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={8,14} },
  },
  resolvers.talents {
    [Talents.T_NPC_BR_POIS] = 1,
    [Talents.T_NPC_BR_ELEC] = 1,
    [Talents.T_NPC_BR_ACID] = 1,
    [Talents.T_NPC_BR_FIRE] = 1,
    [Talents.T_NPC_BR_COLD] = 1,
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_BLIND] = 1,
  },
  body = bodies.dragon,
  speed = 10,
  vision = 40,
  alertness = 255,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'MARDA_RIDER_OF_GOLD_LARONTH',
  name = [[Marda, rider of gold Laronth]],
  display = 'B',
  color = colors.C_y,
  image = 'npc/marda_rider_of_gold_laronth.png',
  desc = [[Former leader among the Thunderlords, she and Trone have fallen under the control of Morgoth. Laronth, her eagle, can summon Thunderlords to her aid.]],
  corpse_weight = 42000,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 4,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 100, 85 },
  ac = 100,
  max_life = 8500,
  rarity = 6,
  level = 75,
  start_level = 75,
  exp_worth = 35000,
  unique = 'MARDA_RIDER_OF_GOLD_LARONTH',
  resist_dam = {
    [DamageType.ELEC] = true,
    [DamageType.POISON] = true,
    [DamageType.TELEPORT] = true,
  },
  flags = {
    BASH_DOOR = true,
    CAN_SPEAK = true,
    EVIL = true,
    FEMALE = true,
    FLY = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    HAS_LITE = true,
    MORTAL = true,
    OPEN_DOOR = true,
    REGENERATE = true,
    SMART = true,
    THUNDERLORD = true,
    UNIQUE = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, only_item=true, '1d2', '4d2', '60%', '90%' },
  drop = { treasure=50, combat=50, magic=0, tools=0, junk=0 },
  drop_corpse = { corpse=true, skeleton=true },
  drop_special = function(self) return rng.percent(50) and game.zone:makeEntityByName(game.level, 'artifact', 'OF_MARDA', false) end,
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={12,15} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={12,15} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={12,15} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={12,15} },
  },
  resolvers.talents {
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_TPORT] = 1,
    [Talents.T_NPC_BLINK] = 1,
    [Talents.T_NPC_TELE_AWAY] = 1,
    [Talents.T_NPC_TELE_TO] = 1,
    [Talents.T_NPC_BR_FIRE] = 1,
    [Talents.T_NPC_BA_MANA] = 1,
    [Talents.T_NPC_S_THUNDERLORD] = 1,
  },
  body = bodies.humanoid,
  speed = 20,
  vision = 100,
  alertness = 50,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'TSELAKUS_THE_DREADLORD',
  name = [[Tselakus, the Dreadlord]],
  display = 'G',
  color = colors.C_R,
  image = 'npc/tselakus_the_dreadlord.png',
  desc = [[This huge affront to existence twists and tears at the fabric of space. Darkness itself recoils from the touch of Tselakus as he leaves a trail of death and destruction. Mighty claws rend reality as he annihilates all in his path to your soul!]],
  corpse_weight = 100,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 3,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 65, 100 },
  ac = 150,
  max_life = 6500,
  rarity = 2,
  level = 68,
  start_level = 68,
  exp_worth = 35000,
  unique = 'TSELAKUS_THE_DREADLORD',
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  melee_retal = {
    [DamageType.COLD] = 'mondam',
  },
  flags = {
    BASEANGBAND = true,
    CAN_SPEAK = true,
    COLD_BLOOD = true,
    EVIL = true,
    FLY = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    INVISIBLE = true,
    MALE = true,
    NO_CUT = true,
    NO_STUN = true,
    PASS_WALL = true,
    UNDEAD = true,
    UNIQUE = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, only_item=true, '3d2', '4d2' },
  drop = { treasure=0, combat=80, magic=20, tools=0, junk=0 },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={10,10} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={10,10} },
    { type=DamageType.LOSE_STR, method=AttackType.HIT, dam={4,6} },
    { type=DamageType.LOSE_STR, method=AttackType.HIT, dam={4,6} },
  },
  on_melee_hit = util.black_breath_melee_hit,
  resolvers.talents {
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_HOLD] = 1,
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_BA_DARK] = 1,
    [Talents.T_NPC_BA_NETH] = 1,
    [Talents.T_NPC_S_WRAITH] = 1,
    [Talents.T_NPC_S_HI_UNDEAD] = 1,
    [Talents.T_NPC_S_KIN] = 1,
  },
  body = bodies.humanoid,
  speed = 20,
  vision = 20,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'SKY_DRAKE',
  name = [[Sky Drake]],
  display = 'D',
  color = colors.C_B,
  multi_colors = { colors.C_b, colors.C_W, colors.C_y },
  image = 'npc/sky_drake.png',
  desc = [[The mightiest elemental dragon of air, it can destroy you with ease.]],
  corpse_weight = 22000,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 4,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 60, 100 },
  ac = 200,
  max_life = 6000,
  rarity = 2,
  level = 77,
  start_level = 77,
  exp_worth = 40000,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.ELEC] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.TELEPORT] = true,
  },
  melee_retal = {
    [DamageType.COLD] = 'mondam',
    [DamageType.ELEC] = 'mondam',
  },
  flags = {
    ATTR_MULTI = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    DRAGON = true,
    EVIL = true,
    FLY = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    HAS_LITE = true,
    MOVE_BODY = true,
    POWERFUL = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, only_item=true, '2d2', '3d2', '4d2' },
  drop = { treasure=50, combat=50, magic=0, tools=0, junk=0 },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={6,12} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={6,12} },
    { type=DamageType.ELEC, method=AttackType.BITE, dam={8,14} },
    { type=DamageType.ELEC, method=AttackType.BITE, dam={8,14} },
  },
  resolvers.talents {
    [Talents.T_NPC_BR_ELEC] = 1,
    [Talents.T_NPC_BR_GRAV] = 1,
    [Talents.T_NPC_BR_LITE] = 1,
    [Talents.T_NPC_S_DRAGON] = 1,
    [Talents.T_NPC_S_HI_DRAGON] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_BLIND] = 1,
  },
  body = bodies.dragon,
  speed = 20,
  vision = 40,
  alertness = 255,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'HORNED_REAPER',
  name = [[Horned Reaper]],
  display = 'U',
  color = colors.C_B,
  image = 'npc/horned_reaper.png',
  desc = [[A giant humanoid demon wielding a massive, heavy and sharp scythe.  Feared by foes and friends alike when it flies into one of its berserk rages, the Horned Reaper will cut down anything in its path between it and you - even the minions it has just summoned.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 5,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 50, 100 },
  ac = 120,
  max_life = 5000,
  rarity = 3,
  level = 72,
  start_level = 72,
  exp_worth = 18000,
  resist_dam = {
    [DamageType.ACID] = true,
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.ELEC] = true,
    [DamageType.FIRE] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    DEMON = true,
    EVIL = true,
    FLY = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    KILL_BODY = true,
    NONLIVING = true,
    OPEN_DOOR = true,
    POWERFUL = true,
    REGENERATE = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, only_item=true, '2d2', '4d2' },
  drop = { treasure=0, combat=100, magic=0, tools=0, junk=0 },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={11,11} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={11,11} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={11,11} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={11,11} },
  },
  resolvers.talents {
    [Talents.T_NPC_HASTE] = 1,
    [Talents.T_NPC_SLOW] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_S_HI_DEMON] = 1,
  },
  body = bodies.humanoid,
  speed = 20,
  vision = 40,
  alertness = 80,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'BLACK_REAVER',
  name = [[Black reaver]],
  display = 'L',
  color = colors.C_D,
  image = 'npc/black_reaver.png',
  desc = [[A humanoid form,  black as night, advancing steadily and unstoppably, even the very rock of the dungeon cannot prevent it reaching you.]],
  corpse_weight = 190,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 3,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 50, 100 },
  ac = 170,
  max_life = 5000,
  rarity = 3,
  level = 74,
  start_level = 74,
  exp_worth = 23000,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.FEAR] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
    [DamageType.TELEPORT] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    CAN_SWIM = true,
    COLD_BLOOD = true,
    EVIL = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    KILL_WALL = true,
    MORTAL = true,
    NO_CUT = true,
    OPEN_DOOR = true,
    SMART = true,
    UNDEAD = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, only_item=true, '1d2', '2d2' },
  drop = { treasure=0, combat=60, magic=40, tools=0, junk=0 },
  attacks = {
    { type=DamageType.DISENCHANT, method=AttackType.HIT, dam={6,8} },
    { type=DamageType.DISENCHANT, method=AttackType.HIT, dam={6,8} },
    { type=DamageType.LOSE_STR, method=AttackType.HIT, dam={4,6} },
    { type=DamageType.LOSE_STR, method=AttackType.HIT, dam={4,6} },
  },
  on_melee_hit = util.black_breath_melee_hit,
  resolvers.talents {
    [Talents.T_NPC_TELE_TO] = 1,
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_HOLD] = 1,
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_CAUSE_3] = 1,
    [Talents.T_NPC_CAUSE_4] = 1,
    [Talents.T_NPC_DRAIN_MANA] = 1,
    [Talents.T_NPC_BRAIN_SMASH] = 1,
    [Talents.T_NPC_BA_MANA] = 1,
    [Talents.T_NPC_BA_NETH] = 1,
    [Talents.T_NPC_S_UNDEAD] = 1,
  },
  body = bodies.none,
  speed = 10,
  vision = 20,
  alertness = 50,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'MASTER_MINDCRAFTER',
  name = [[Master mindcrafter]],
  display = 'p',
  color = colors.C_y,
  image = 'npc/master_mindcrafter.png',
  desc = [[A mindcrafter of the highest order.  Powerful and evil, and a dangerous enemy: a master of mind over matter, of his own mind, and of the minds of others, who slavishly follow him into battle when he calls them.]],
  corpse_weight = 170,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 2,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 80, 10 },
  ac = 60,
  max_life = 800,
  rarity = 2,
  level = 40,
  start_level = 40,
  exp_worth = 2000,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.ELEC] = true,
    [DamageType.FEAR] = true,
    [DamageType.FIRE] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    EVIL = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    MALE = true,
    MOVE_BODY = true,
    NO_STUN = true,
    SMART = true,
    TAKE_ITEM = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ only_item=true, '4d2' },
  drop = { treasure=20, combat=40, magic=40, tools=0, junk=0 },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={4,5} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={4,5} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={4,5} },
  },
  resolvers.talents {
    [Talents.T_NPC_HEAL] = 1,
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_HOLD] = 1,
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_TPORT] = 1,
    [Talents.T_NPC_BA_COLD] = 1,
    [Talents.T_NPC_BA_FIRE] = 1,
    [Talents.T_NPC_MIND_BLAST] = 1,
    [Talents.T_NPC_BRAIN_SMASH] = 1,
    [Talents.T_NPC_S_MONSTERS] = 1,
    [Talents.T_NPC_TELE_AWAY] = 1,
    [Talents.T_NPC_BLINK] = 1,
    [Talents.T_NPC_BO_NETH] = 1,
  },
  body = bodies.humanoid,
  speed = 10,
  vision = 20,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'GREATER_DEMONIC_QUYLTHULG',
  name = [[Greater demonic quylthulg]],
  display = 'Q',
  color = colors.C_R,
  image = 'npc/greater_demonic_quylthulg.png',
  desc = [[A massive pulsating mound of flesh, glowing with an inner hellish light.]],
  corpse_weight = 500,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 2,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 15, 100 },
  ac = 1,
  max_life = 1500,
  rarity = 2,
  level = 71,
  start_level = 71,
  exp_worth = 10500,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.FEAR] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.TELEPORT] = true,
  },
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    EMPTY_MIND = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    INVISIBLE = true,
    NEVER_BLOW = true,
    NEVER_MOVE = true,
  },
  placement_flags = {},
  resolvers.talents {
    [Talents.T_NPC_BLINK] = 1,
    [Talents.T_NPC_TELE_TO] = 1,
    [Talents.T_NPC_S_HI_DEMON] = 1,
  },
  body = bodies.none,
  speed = 10,
  vision = 20,
  alertness = 0,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'GREATER_DRACONIC_QUYLTHULG',
  name = [[Greater draconic quylthulg]],
  display = 'Q',
  color = colors.C_G,
  image = 'npc/greater_draconic_quylthulg.png',
  desc = [[A massive mound of scaled flesh, throbbing and pulsating with multi-hued light.]],
  corpse_weight = 500,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 2,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 15, 100 },
  ac = 1,
  max_life = 1500,
  rarity = 2,
  level = 71,
  start_level = 71,
  exp_worth = 10500,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.FEAR] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.TELEPORT] = true,
  },
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    EMPTY_MIND = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    INVISIBLE = true,
    NEVER_BLOW = true,
    NEVER_MOVE = true,
  },
  placement_flags = {},
  resolvers.talents {
    [Talents.T_NPC_BLINK] = 1,
    [Talents.T_NPC_TELE_TO] = 1,
    [Talents.T_NPC_S_HI_DRAGON] = 1,
  },
  body = bodies.none,
  speed = 10,
  vision = 20,
  alertness = 0,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'GREATER_ROTTING_QUYLTHULG',
  name = [[Greater rotting quylthulg]],
  display = 'Q',
  color = colors.C_U,
  image = 'npc/greater_rotting_quylthulg.png',
  desc = [[A massive pile of rotting flesh. A disgusting stench fills the air as it throbs and writhes.]],
  corpse_weight = 500,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 2,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 15, 100 },
  ac = 1,
  max_life = 1500,
  rarity = 2,
  level = 71,
  start_level = 71,
  exp_worth = 10500,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.FEAR] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.TELEPORT] = true,
  },
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    EMPTY_MIND = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    INVISIBLE = true,
    NEVER_BLOW = true,
    NEVER_MOVE = true,
    NO_CUT = true,
  },
  placement_flags = {},
  resolvers.talents {
    [Talents.T_NPC_BLINK] = 1,
    [Talents.T_NPC_TELE_TO] = 1,
    [Talents.T_NPC_S_HI_UNDEAD] = 1,
  },
  body = bodies.none,
  speed = 10,
  vision = 20,
  alertness = 0,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'FEAGWATH_THE_UNDEAD_SORCERER',
  name = [[Feagwath, the Undead Sorcerer]],
  display = 'L',
  color = colors.C_y,
  image = 'npc/feagwath_the_undead_sorcerer.png',
  desc = [[A stench of corruption and decay surrounds this sorcerer, who has clearly risen from the dead to continue his foul plots and schemes.]],
  corpse_weight = 190,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 2,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 60, 100 },
  ac = 85,
  max_life = 6000,
  level = 77,
  start_level = 77,
  exp_worth = 30000,
  unique = 'FEAGWATH_THE_UNDEAD_SORCERER',
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
    [DamageType.TELEPORT] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    CAN_SPEAK = true,
    COLD_BLOOD = true,
    ESCORT = true,
    EVIL = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    MALE = true,
    NO_CUT = true,
    OPEN_DOOR = true,
    SMART = true,
    SPECIAL_GENE = true,
    UNDEAD = true,
    UNIQUE = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, great=true, only_item=true, '2d2', '4d2' },
  drop = { treasure=0, combat=50, magic=50, tools=0, junk=0 },
  drop_special = function(self) return game.zone:makeEntityByName(game.level, 'artifact', 'DOOMCALLER', false) end,
  attacks = {
    { type=DamageType.EXP_80, method=AttackType.TOUCH, dam={6,12} },
    { type=DamageType.UN_POWER, method=AttackType.TOUCH, dam={6,12} },
    { type=DamageType.LOSE_DEX, method=AttackType.TOUCH, dam={6,12} },
    { type=DamageType.LOSE_DEX, method=AttackType.TOUCH, dam={6,12} },
  },
  on_melee_hit = util.black_breath_melee_hit,
  resolvers.talents {
    [Talents.T_NPC_BLINK] = 1,
    [Talents.T_NPC_TELE_TO] = 1,
    [Talents.T_NPC_HOLD] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_CAUSE_4] = 1,
    [Talents.T_NPC_BRAIN_SMASH] = 1,
    [Talents.T_NPC_TRAPS] = 1,
    [Talents.T_NPC_BA_MANA] = 1,
    [Talents.T_NPC_BO_MANA] = 1,
    [Talents.T_NPC_BA_NETH] = 1,
    [Talents.T_NPC_S_MONSTERS] = 1,
    [Talents.T_NPC_S_UNDEAD] = 1,
    [Talents.T_NPC_S_KIN] = 1,
    [Talents.T_NPC_ANIM_DEAD] = 1,
  },
  body = bodies.humanoid,
  speed = 20,
  vision = 20,
  alertness = 50,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'OMARAX_THE_EYE_TYRANT',
  name = [[Omarax the Eye Tyrant]],
  display = 'e',
  color = colors.C_v,
  image = 'npc/omarax_the_eye_tyrant.png',
  desc = [[A beholder of great size and age, floating in the air.  His gaze seems to shred your soul and his spells crush your will.  He is ancient, his history steeped in forgotten evils, his atrocities numerous and sickening.]],
  corpse_weight = 60,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 2,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 65, 100 },
  ac = 80,
  max_life = 6500,
  rarity = 3,
  level = 73,
  start_level = 73,
  exp_worth = 25000,
  unique = 'OMARAX_THE_EYE_TYRANT',
  resist_dam = {
    [DamageType.POISON] = true,
    [DamageType.TELEPORT] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    CAN_SPEAK = true,
    EVIL = true,
    FLY = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    MALE = true,
    SMART = true,
    UNIQUE = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.DISENCHANT, method=AttackType.GAZE, dam={6,6} },
    { type=DamageType.UN_POWER, method=AttackType.GAZE, dam={6,6} },
    { type=DamageType.INSANITY, method=AttackType.GAZE, dam={6,6} },
    { type=DamageType.EXP_80, method=AttackType.BITE, dam={8,8} },
  },
  resolvers.talents {
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_FORGET] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_DRAIN_MANA] = 1,
    [Talents.T_NPC_BRAIN_SMASH] = 1,
    [Talents.T_NPC_BA_DARK] = 1,
    [Talents.T_NPC_BO_MANA] = 1,
    [Talents.T_NPC_BA_NETH] = 1,
    [Talents.T_NPC_BA_ACID] = 1,
    [Talents.T_NPC_BA_FIRE] = 1,
    [Talents.T_NPC_BA_COLD] = 1,
    [Talents.T_NPC_S_KIN] = 1,
  },
  body = bodies.none,
  speed = 20,
  vision = 30,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'GREATER_BALROG',
  name = [[Greater Balrog]],
  display = 'U',
  color = colors.C_v,
  image = 'npc/greater_balrog.png',
  desc = [[Originally of the semi-divine Maiar, this evil spirit swore allegiance to Morgoth at the beginning of time and is now one of his most terrible demonic servants.  With its flaming whip and sword it seeks to destroy you.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 3,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 75, 100 },
  ac = 140,
  max_life = 7500,
  rarity = 3,
  level = 80,
  start_level = 80,
  exp_worth = 25000,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.FIRE] = true,
    [DamageType.NETHER] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.PLASMA] = true,
  },
  melee_retal = {
    [DamageType.FIRE] = 'mondam',
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    DEMON = true,
    EVIL = true,
    FLY = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    HAS_LITE = true,
    KILL_WALL = true,
    MOVE_BODY = true,
    NONLIVING = true,
    OPEN_DOOR = true,
    POWERFUL = true,
    REGENERATE = true,
    SMART = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, only_item=true, '2d2' },
  drop = { treasure=0, combat=50, magic=50, tools=0, junk=0 },
  attacks = {
    { type=DamageType.FIRE, method=AttackType.HIT, dam={8,12} },
    { type=DamageType.FIRE, method=AttackType.HIT, dam={8,12} },
    { type=DamageType.PHYSICAL, method=AttackType.CRUSH, dam={7,12} },
    { type=DamageType.UN_POWER, method=AttackType.TOUCH },
  },
  resolvers.talents {
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_BRAIN_SMASH] = 1,
    [Talents.T_NPC_BR_FIRE] = 1,
    [Talents.T_NPC_BA_NETH] = 1,
    [Talents.T_NPC_BA_FIRE] = 1,
    [Talents.T_NPC_BR_PLAS] = 1,
    [Talents.T_NPC_BO_PLAS] = 1,
    [Talents.T_NPC_S_HI_DEMON] = 1,
    [Talents.T_NPC_S_UNDEAD] = 1,
    [Talents.T_NPC_S_DEMON] = 1,
  },
  body = bodies.humanoid,
  speed = 20,
  vision = 40,
  alertness = 40,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'UNGOLIANT_THE_UNLIGHT',
  name = [[Ungoliant, the Unlight]],
  display = 'S',
  color = colors.C_D,
  image = 'npc/ungoliant_the_unlight.png',
  desc = [[This enormous, hideous spirit of void is in the form of a spider of immense proportions.  She is surrounded by a cloud of Unlight as she sucks in all living light into her bloated body, and breathes out the blackest of darkness.  She is always ravenously hungry and would even eat herself to avoid starvation.]],
  corpse_weight = 150,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 3,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 130, 100 },
  ac = 160,
  max_life = 13000,
  rarity = 1,
  level = 75,
  start_level = 75,
  exp_worth = 35000,
  unique = 'UNGOLIANT_THE_UNLIGHT',
  resist_dam = {
    [DamageType.ACID] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.DARK] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  vuln_dam = {
    [DamageType.LITE] = true,
    [DamageType.LITE_WEAK] = true,
  },
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    EVIL = true,
    FEMALE = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    SMART = true,
    SPIDER = true,
    UNIQUE = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, only_item=true, '4d2' },
  drop = { treasure=20, combat=0, magic=80, tools=0, junk=0 },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.POISON, method=AttackType.CLAW, dam={8,6} },
    { type=DamageType.POISON, method=AttackType.CLAW, dam={8,6} },
    { type=DamageType.PARALYZE, method=AttackType.BITE, dam={8,10} },
    { type=DamageType.LOSE_STR, method=AttackType.STING, dam={8,4} },
  },
  resolvers.talents {
    [Talents.T_NPC_HEAL] = 1,
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_SLOW] = 1,
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_DARKNESS] = 1,
    [Talents.T_NPC_BA_DARK] = 1,
    [Talents.T_NPC_BR_POIS] = 1,
    [Talents.T_NPC_BR_DARK] = 1,
    [Talents.T_NPC_S_SPIDER] = 1,
  },
  body = bodies.quadruped,
  speed = 20,
  vision = 8,
  alertness = 80,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'AETHER_HOUND',
  name = [[Aether hound]],
  display = 'Z',
  color = colors.C_v,
  image = 'npc/aether_hound.png',
  desc = [[A shifting, swirling form. It seems to be all colours and sizes and shapes, though the dominant form is that of a huge dog. You feel very uncertain all of a sudden.]],
  corpse_weight = 100,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 5,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 60, 40 },
  ac = 100,
  max_life = resolvers.dice(60, 40),
  rarity = 3,
  level = 74,
  start_level = 74,
  exp_worth = 10000,
  resist_dam = {
    [DamageType.ACID] = true,
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.DISEASE] = true,
    [DamageType.ELEC] = true,
    [DamageType.FIRE] = true,
    [DamageType.NETHER] = true,
    [DamageType.NEXUS] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.PLASMA] = true,
    [DamageType.POISON] = true,
  },
  melee_retal = {
    [DamageType.COLD] = 'mondam',
    [DamageType.ELEC] = 'mondam',
    [DamageType.FIRE] = 'mondam',
  },
  flags = {
    ANIMAL = true,
    ATTR_ANY = true,
    ATTR_MULTI = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    FLY = true,
    FORCE_SLEEP = true,
    FRIENDS = true,
    NO_CUT = true,
  },
  placement_flags = {},
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={3,12} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={3,12} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={3,12} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={3,12} },
  },
  resolvers.talents {
    [Talents.T_NPC_BR_ACID] = 1,
    [Talents.T_NPC_BR_FIRE] = 1,
    [Talents.T_NPC_BR_COLD] = 1,
    [Talents.T_NPC_BR_ELEC] = 1,
    [Talents.T_NPC_BR_POIS] = 1,
    [Talents.T_NPC_BR_LITE] = 1,
    [Talents.T_NPC_BR_DARK] = 1,
    [Talents.T_NPC_BR_SOUN] = 1,
    [Talents.T_NPC_BR_CONF] = 1,
    [Talents.T_NPC_BR_CHAO] = 1,
    [Talents.T_NPC_BR_SHAR] = 1,
    [Talents.T_NPC_BR_NETH] = 1,
    [Talents.T_NPC_BR_DISE] = 1,
    [Talents.T_NPC_BR_WALL] = 1,
    [Talents.T_NPC_BR_INER] = 1,
    [Talents.T_NPC_BR_TIME] = 1,
    [Talents.T_NPC_BR_GRAV] = 1,
    [Talents.T_NPC_BR_PLAS] = 1,
    [Talents.T_NPC_BR_NEXU] = 1,
  },
  body = bodies.quadruped,
  speed = 10,
  vision = 30,
  alertness = 0,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'PIT_FIEND',
  name = [[Pit Fiend]],
  display = 'U',
  color = colors.C_o,
  image = 'npc/pit_fiend.png',
  desc = [[Appearing as a giant, clawed and winged humanoid with a scaly red body and massive fangs dripping a foul green liquid, the Pit Fiend is a dreadful enemy from the lowest depths of the hells.  They are often the commanders of vast demon armies.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 5,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 60, 100 },
  ac = 120,
  max_life = 6000,
  rarity = 3,
  level = 77,
  start_level = 77,
  exp_worth = 22000,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.FIRE] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    DEMON = true,
    EVIL = true,
    FLY = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    MOVE_BODY = true,
    NONLIVING = true,
    OPEN_DOOR = true,
    POWERFUL = true,
    REGENERATE = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, only_item=true, '2d2', '4d2' },
  drop = { treasure=0, combat=100, magic=0, tools=0, junk=0 },
  attacks = {
    { type=DamageType.FIRE, method=AttackType.CLAW, dam={8,10} },
    { type=DamageType.FIRE, method=AttackType.CLAW, dam={8,10} },
    { type=DamageType.POISON, method=AttackType.BITE, dam={7,10} },
    { type=DamageType.LOSE_CON, method=AttackType.BITE, dam={7,10} },
  },
  resolvers.talents {
    [Talents.T_NPC_S_HI_DEMON] = 1,
    [Talents.T_NPC_S_HI_DRAGON] = 1,
    [Talents.T_NPC_BR_FIRE] = 1,
    [Talents.T_NPC_BR_POIS] = 1,
    [Talents.T_NPC_BR_CHAO] = 1,
    [Talents.T_NPC_BA_CHAO] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_BA_FIRE] = 1,
    [Talents.T_NPC_CAUSE_4] = 1,
  },
  body = bodies.humanoid,
  speed = 20,
  vision = 30,
  alertness = 75,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'THE_MOUTH_OF_SAURON',
  name = [[The Mouth of Sauron]],
  display = 'p',
  color = colors.C_v,
  image = 'npc/the_mouth_of_sauron.png',
  desc = [[The Mouth of Sauron is a mighty spell caster. So old that even he cannot remember his own name, his power and evil are undeniable. He believes unshakeably that he is unbeatable and laughs as he weaves his awesome spells.]],
  corpse_weight = 190,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 2,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 90, 100 },
  ac = 100,
  max_life = 9000,
  rarity = 3,
  level = 78,
  start_level = 78,
  exp_worth = 38000,
  unique = 'THE_MOUTH_OF_SAURON',
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.ELEC] = true,
    [DamageType.FIRE] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    EVIL = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    HAS_LITE = true,
    INVISIBLE = true,
    MALE = true,
    OPEN_DOOR = true,
    SMART = true,
    UNIQUE = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, only_item=true, '1d2', '4d2' },
  drop = { treasure=0, combat=0, magic=100, tools=0, junk=0 },
  attacks = {
    { type=DamageType.DISENCHANT, method=AttackType.HIT, dam={6,8} },
    { type=DamageType.DISENCHANT, method=AttackType.HIT, dam={6,8} },
    { type=DamageType.UN_POWER, method=AttackType.TOUCH },
    { type=DamageType.UN_POWER, method=AttackType.TOUCH },
  },
  resolvers.talents {
    [Talents.T_NPC_TELE_TO] = 1,
    [Talents.T_NPC_HOLD] = 1,
    [Talents.T_NPC_CAUSE_3] = 1,
    [Talents.T_NPC_TRAPS] = 1,
    [Talents.T_NPC_ANIM_DEAD] = 1,
    [Talents.T_NPC_BO_PLAS] = 1,
    [Talents.T_NPC_BA_DARK] = 1,
    [Talents.T_NPC_BA_MANA] = 1,
    [Talents.T_NPC_BA_FIRE] = 1,
    [Talents.T_NPC_BA_WATE] = 1,
    [Talents.T_NPC_BA_NETH] = 1,
    [Talents.T_NPC_S_HI_DEMON] = 1,
    [Talents.T_NPC_S_HI_UNDEAD] = 1,
  },
  body = bodies.humanoid,
  speed = 20,
  vision = 60,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'THE_NECROMANCER_OF_DOL_GULDUR',
  name = [[The Necromancer of Dol Guldur]],
  display = 'p',
  color = colors.C_v,
  image = 'npc/the_necromancer_of_dol_guldur.png',
  desc = [[The dark master of the terrible fortress of southern Mirkwood.  It is rumoured that this is in fact none other than Sauron in disguise: although if this is so, he has yet to reveal his full power - and perhaps will not do so while his deception lasts, in the hope of keeping it going.]],
  corpse_weight = 190,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 2,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 82, 100 },
  ac = 100,
  max_life = 8200,
  level = 75,
  start_level = 75,
  exp_worth = 40000,
  unique = 'THE_NECROMANCER_OF_DOL_GULDUR',
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.ELEC] = true,
    [DamageType.FIRE] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.TELEPORT] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    CAN_SPEAK = true,
    EVIL = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    INVISIBLE = true,
    MALE = true,
    OPEN_DOOR = true,
    POWERFUL = true,
    SMART = true,
    SPECIAL_GENE = true,
    UNIQUE = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, great=true, only_item=true, '1d2' },
  drop = { treasure=0, combat=0, magic=100, tools=0, junk=0 },
  drop_special = function(self) return game.zone:makeEntityByName(game.level, 'artifact', 'RING_OF_DURIN', false) end,
  attacks = {
    { type=DamageType.DISENCHANT, method=AttackType.HIT, dam={6,8} },
    { type=DamageType.UN_POWER, method=AttackType.HIT, dam={6,8} },
    { type=DamageType.BLIND, method=AttackType.HIT, dam={6,8} },
    { type=DamageType.CONFUSION, method=AttackType.HIT, dam={6,8} },
  },
  resolvers.talents {
    [Talents.T_NPC_CAUSE_3] = 1,
    [Talents.T_NPC_TELE_TO] = 1,
    [Talents.T_NPC_BA_FIRE] = 1,
    [Talents.T_NPC_DRAIN_MANA] = 1,
    [Talents.T_NPC_HOLD] = 1,
    [Talents.T_NPC_TRAPS] = 1,
    [Talents.T_NPC_BA_WATE] = 1,
    [Talents.T_NPC_BO_PLAS] = 1,
    [Talents.T_NPC_BA_NETH] = 1,
    [Talents.T_NPC_BA_MANA] = 1,
    [Talents.T_NPC_BA_DARK] = 1,
    [Talents.T_NPC_S_HI_UNDEAD] = 1,
    [Talents.T_NPC_BA_CHAO] = 1,
    [Talents.T_NPC_HAND_DOOM] = 1,
    [Talents.T_NPC_ANIM_DEAD] = 1,
  },
  body = bodies.humanoid,
  speed = 20,
  vision = 60,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'LISA_RIDER_OF_GOLD_ROMTH',
  name = [[Lisa, rider of gold Romth]],
  display = 'B',
  color = colors.C_y,
  image = 'npc/lisa_rider_of_gold_romth.png',
  desc = [[She came to help you.]],
  corpse_weight = 42000,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 4,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 65, 100 },
  ac = 100,
  faction = 'friendlies',
  max_life = 6500,
  rarity = 6,
  level = 78,
  start_level = 78,
  exp_worth = 35500,
  unique = 'LISA_RIDER_OF_GOLD_ROMTH',
  resist_dam = {
    [DamageType.ACID] = true,
    [DamageType.COLD] = true,
    [DamageType.ELEC] = true,
    [DamageType.POISON] = true,
    [DamageType.TELEPORT] = true,
  },
  flags = {
    BASH_DOOR = true,
    CAN_SPEAK = true,
    FEMALE = true,
    FLY = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    GOOD = true,
    HAS_LITE = true,
    MORTAL = true,
    OPEN_DOOR = true,
    PET = true,
    REGENERATE = true,
    THUNDERLORD = true,
    UNIQUE = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, only_item=true, '1d2', '4d2', '60%', '90%' },
  drop = { treasure=50, combat=50, magic=0, tools=0, junk=0 },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={10,15} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={10,15} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={10,15} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={10,15} },
  },
  resolvers.talents {
    [Talents.T_NPC_TPORT] = 1,
    [Talents.T_NPC_TELE_TO] = 1,
    [Talents.T_NPC_BR_FIRE] = 1,
    [Talents.T_NPC_S_THUNDERLORD] = 1,
    [Talents.T_NPC_TELE_AWAY] = 1,
    [Talents.T_NPC_HEAL] = 1,
    [Talents.T_NPC_BA_NETH] = 1,
    [Talents.T_NPC_BO_NETH] = 1,
    [Talents.T_NPC_BA_FIRE] = 1,
    [Talents.T_NPC_BO_FIRE] = 1,
  },
  body = bodies.humanoid,
  speed = 20,
  vision = 100,
  alertness = 15,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'MASTER_QUYLTHULG',
  name = [[Master quylthulg]],
  display = 'Q',
  color = colors.C_B,
  image = 'npc/master_quylthulg.png',
  desc = [[A giant seething mass of flesh, overwhelming you with monster after monster.]],
  corpse_weight = 700,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 2,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 30, 100 },
  ac = 1,
  max_life = 3000,
  rarity = 2,
  level = 76,
  start_level = 76,
  exp_worth = 15000,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.FEAR] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.TELEPORT] = true,
  },
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    EMPTY_MIND = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    INVISIBLE = true,
    NEVER_BLOW = true,
    NEVER_MOVE = true,
  },
  placement_flags = {},
  resolvers.talents {
    [Talents.T_NPC_S_MONSTERS] = 1,
    [Talents.T_NPC_S_HI_UNDEAD] = 1,
    [Talents.T_NPC_S_HI_DRAGON] = 1,
    [Talents.T_NPC_S_HI_DEMON] = 1,
    [Talents.T_NPC_S_ANIMALS] = 1,
    [Talents.T_NPC_BLINK] = 1,
    [Talents.T_NPC_TELE_TO] = 1,
  },
  body = bodies.none,
  speed = 10,
  vision = 20,
  alertness = 0,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'QLZQQLZUUP_THE_LORD_OF_FLESH',
  name = [[Qlzqqlzuup, the Lord of Flesh]],
  display = 'Q',
  color = colors.C_v,
  image = 'npc/qlzqqlzuup_the_lord_of_flesh.png',
  desc = [[A gigantic seething mass of flesh, Qlzqqlzuup changes colours in front of your eyes.  Pulsating first one colour then the next, it knows only it must bring help to protect itself.]],
  corpse_weight = 1000,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 1,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 50, 100 },
  ac = 1,
  max_life = 5000,
  rarity = 3,
  level = 79,
  start_level = 79,
  exp_worth = 20000,
  unique = 'QLZQQLZUUP_THE_LORD_OF_FLESH',
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.FEAR] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.TELEPORT] = true,
  },
  flags = {
    ANIMAL = true,
    ATTR_MULTI = true,
    BASEANGBAND = true,
    EMPTY_MIND = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    INVISIBLE = true,
    NEVER_BLOW = true,
    NEVER_MOVE = true,
    UNIQUE = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ only_item=true, '4d2' },
  drop = { treasure=20, combat=20, magic=20, tools=20, junk=20 },
  resolvers.talents {
    [Talents.T_NPC_S_MONSTERS] = 1,
    [Talents.T_NPC_S_ANGEL] = 1,
    [Talents.T_NPC_S_HOUND] = 1,
    [Talents.T_NPC_S_HYDRA] = 1,
    [Talents.T_NPC_S_SPIDER] = 1,
    [Talents.T_NPC_S_ANT] = 1,
    [Talents.T_NPC_S_ANIMALS] = 1,
    [Talents.T_NPC_S_HI_UNDEAD] = 1,
    [Talents.T_NPC_S_HI_DRAGON] = 1,
    [Talents.T_NPC_S_HI_DEMON] = 1,
    [Talents.T_NPC_S_WRAITH] = 1,
    [Talents.T_NPC_S_UNIQUE] = 1,
    [Talents.T_NPC_S_KIN] = 1,
  },
  body = bodies.none,
  speed = 20,
  vision = 30,
  alertness = 0,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'FLARE_RIDER_OF_BRONZE_MOONTH',
  name = [[Flare, rider of bronze Moonth]],
  display = 'B',
  color = colors.C_U,
  image = 'npc/flare_rider_of_bronze_moonth.png',
  desc = [[A leader from afar, he has come with his eagle to help you in your battle. Having already saved his home, he now wants to save Arda!]],
  corpse_weight = 40000,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 4,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 70, 100 },
  ac = 100,
  faction = 'friendlies',
  max_life = 7000,
  rarity = 5,
  level = 79,
  start_level = 79,
  exp_worth = 38500,
  unique = 'FLARE_RIDER_OF_BRONZE_MOONTH',
  resist_dam = {
    [DamageType.ACID] = true,
    [DamageType.COLD] = true,
    [DamageType.ELEC] = true,
    [DamageType.FIRE] = true,
    [DamageType.POISON] = true,
    [DamageType.TELEPORT] = true,
  },
  flags = {
    BASH_DOOR = true,
    CAN_SPEAK = true,
    FLY = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    GOOD = true,
    HAS_LITE = true,
    MALE = true,
    MORTAL = true,
    OPEN_DOOR = true,
    PET = true,
    REGENERATE = true,
    THUNDERLORD = true,
    UNIQUE = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, only_item=true, '1d2', '4d2', '60%', '90%' },
  drop = { treasure=50, combat=50, magic=0, tools=0, junk=0 },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={15,15} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={15,15} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={15,15} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={15,15} },
  },
  resolvers.talents {
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_TPORT] = 1,
    [Talents.T_NPC_TELE_TO] = 1,
    [Talents.T_NPC_S_THUNDERLORD] = 1,
    [Talents.T_NPC_TELE_LEVEL] = 1,
    [Talents.T_NPC_HEAL] = 1,
    [Talents.T_NPC_BR_FIRE] = 1,
    [Talents.T_NPC_BR_TIME] = 1,
    [Talents.T_NPC_ROCKET] = 1,
  },
  body = bodies.humanoid,
  speed = 20,
  vision = 100,
  alertness = 15,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'MAEGLIN_THE_TRAITOR_OF_GONDOLIN',
  name = [[Maeglin, the Traitor of Gondolin]],
  display = 'h',
  color = colors.C_D,
  image = 'npc/maeglin_the_traitor_of_gondolin.png',
  desc = [[The son of Eöl the Dark Elf, Maeglin is every bit as evil as his father and more.  His greed for gold led him to betray the Hidden Kingdom of Gondolin to Morgoth's forces.  He is a mighty warrior himself, and some of Morgoth's greatest servants answer to his call.]],
  corpse_weight = 140,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 6,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 60, 100 },
  ac = 120,
  max_life = 6000,
  level = 81,
  start_level = 81,
  exp_worth = 35000,
  unique = 'MAEGLIN_THE_TRAITOR_OF_GONDOLIN',
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.FIRE] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    AI_SPECIAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    CAN_SPEAK = true,
    EVIL = true,
    FORCE_MAXHP = true,
    HAS_LITE = true,
    KILL_WALL = true,
    MALE = true,
    MOVE_BODY = true,
    OPEN_DOOR = true,
    REFLECTING = true,
    REGENERATE = true,
    SMART = true,
    SPECIAL_GENE = true,
    TAKE_ITEM = true,
    UNIQUE = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, great=true, only_item=true, '3d2', '4d2' },
  drop = { treasure=30, combat=70, magic=0, tools=0, junk=0 },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={8,8} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={8,8} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={8,8} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={8,8} },
  },
  resolvers.talents {
    [Talents.T_NPC_S_MONSTERS] = 1,
    [Talents.T_NPC_S_WRAITH] = 1,
    [Talents.T_NPC_S_HI_UNDEAD] = 1,
    [Talents.T_NPC_S_HI_DRAGON] = 1,
    [Talents.T_NPC_S_HI_DEMON] = 1,
    [Talents.T_NPC_S_UNIQUE] = 1,
    [Talents.T_NPC_S_ANIMALS] = 1,
  },
  body = bodies.humanoid,
  speed = 20,
  vision = 220,
  alertness = 20,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'PAZUZU_LORD_OF_AIR',
  name = [[Pazuzu, Lord of Air]],
  display = 'U',
  color = colors.C_b,
  image = 'npc/pazuzu_lord_of_air.png',
  desc = [[A winged humanoid demon from the Planes of Hell, Pazuzu grins inhumanely at you as he decides your fate.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 3,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 55, 100 },
  ac = 125,
  max_life = 5500,
  rarity = 2,
  level = 82,
  start_level = 82,
  exp_worth = 30000,
  unique = 'PAZUZU_LORD_OF_AIR',
  resist_dam = {
    [DamageType.ACID] = true,
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.ELEC] = true,
    [DamageType.FIRE] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    DEMON = true,
    EVIL = true,
    FLY = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    INVISIBLE = true,
    MALE = true,
    OPEN_DOOR = true,
    UNIQUE = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, only_item=true, '4d2' },
  drop = { treasure=0, combat=100, magic=0, tools=0, junk=0 },
  attacks = {
    { type=DamageType.ELEC, method=AttackType.HIT, dam={12,12} },
    { type=DamageType.ELEC, method=AttackType.HIT, dam={12,12} },
    { type=DamageType.ELEC, method=AttackType.HIT, dam={12,12} },
    { type=DamageType.ELEC, method=AttackType.HIT, dam={12,12} },
  },
  resolvers.talents {
    [Talents.T_NPC_MIND_BLAST] = 1,
    [Talents.T_NPC_BO_ELEC] = 1,
    [Talents.T_NPC_BO_MANA] = 1,
    [Talents.T_NPC_BA_ELEC] = 1,
    [Talents.T_NPC_S_HI_DEMON] = 1,
  },
  body = bodies.humanoid,
  speed = 30,
  vision = 40,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'GREATER_HELLHOUND',
  name = [[Greater Hellhound]],
  display = 'C',
  color = colors.C_r,
  image = 'npc/greater_hellhound.png',
  desc = [[It is a giant dog that glows with heat. Flames pour from its nostrils.]],
  corpse_weight = 60,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=25,
    talent_in = 5,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 48, 30 },
  ac = 80,
  max_life = 1440,
  rarity = 2,
  level = 78,
  start_level = 78,
  exp_worth = 600,
  resist_dam = {
    [DamageType.FIRE] = true,
  },
  vuln_dam = {
    [DamageType.COLD] = true,
  },
  melee_retal = {
    [DamageType.FIRE] = 'mondam',
  },
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    EVIL = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    FRIENDS = true,
    HAS_LITE = true,
    MOVE_BODY = true,
  },
  placement_flags = {},
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.FIRE, method=AttackType.BITE, dam={5,12} },
    { type=DamageType.FIRE, method=AttackType.BITE, dam={5,12} },
    { type=DamageType.FIRE, method=AttackType.BITE, dam={5,12} },
  },
  resolvers.talents {
    [Talents.T_NPC_BR_FIRE] = 1,
  },
  body = bodies.quadruped,
  speed = 10,
  vision = 25,
  alertness = 30,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'CANTORAS_THE_SKELETAL_LORD',
  name = [[Cantoras, the Skeletal Lord]],
  display = 's',
  color = colors.C_v,
  image = 'npc/cantoras_the_skeletal_lord.png',
  desc = [[A legion of evil undead druj animating the skeleton of a once mighty sorcerer. His power is devastating and his speed unmatched in the underworld. Flee his wrath!]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 2,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 75, 100 },
  ac = 120,
  max_life = 7500,
  rarity = 2,
  level = 84,
  start_level = 84,
  exp_worth = 45000,
  unique = 'CANTORAS_THE_SKELETAL_LORD',
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.FEAR] = true,
    [DamageType.FIRE] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
    [DamageType.TELEPORT] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    CAN_SPEAK = true,
    COLD_BLOOD = true,
    EVIL = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    MALE = true,
    NO_CUT = true,
    OPEN_DOOR = true,
    SMART = true,
    UNDEAD = true,
    UNIQUE = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, great=true, only_item=true, '2d2', '3d2', '4d2' },
  drop = { treasure=50, combat=0, magic=50, tools=0, junk=0 },
  attacks = {
    { type=DamageType.EXP_80, method=AttackType.GAZE, dam={5,5} },
    { type=DamageType.EXP_80, method=AttackType.GAZE, dam={5,5} },
    { type=DamageType.POISON, method=AttackType.TOUCH, dam={5,5} },
    { type=DamageType.POISON, method=AttackType.TOUCH, dam={5,5} },
  },
  on_melee_hit = util.black_breath_melee_hit,
  resolvers.talents {
    [Talents.T_NPC_TELE_TO] = 1,
    [Talents.T_NPC_SLOW] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_CAUSE_4] = 1,
    [Talents.T_NPC_BRAIN_SMASH] = 1,
    [Talents.T_NPC_BO_ICEE] = 1,
    [Talents.T_NPC_BO_MANA] = 1,
    [Talents.T_NPC_BA_WATE] = 1,
    [Talents.T_NPC_BA_NETH] = 1,
    [Talents.T_NPC_S_HI_UNDEAD] = 1,
    [Talents.T_NPC_ANIM_DEAD] = 1,
  },
  body = bodies.humanoid,
  speed = 30,
  vision = 20,
  alertness = 80,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'THE_TARRASQUE',
  name = [[The Tarrasque]],
  display = 'R',
  color = colors.C_v,
  multi_colors = { colors.C_r, colors.C_w, colors.C_v },
  image = 'npc/the_tarrasque.png',
  desc = [[The Tarrasque is a massive reptile of legend, rumoured to be unkillable and immune to magic. Fear its anger, for its devastation is unmatched!]],
  corpse_weight = 5000,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 2,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 130, 100 },
  ac = 185,
  max_life = 13000,
  rarity = 2,
  level = 84,
  start_level = 84,
  exp_worth = 35000,
  unique = 'THE_TARRASQUE',
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.FIRE] = true,
    [DamageType.OLD_SLEEP] = true,
  },
  flags = {
    ATTR_MULTI = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    EVIL = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    MOVE_BODY = true,
    OPEN_DOOR = true,
    POWERFUL = true,
    UNIQUE = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, only_item=true, '2d2', '4d2' },
  drop = { treasure=20, combat=50, magic=25, tools=5, junk=0 },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={10,10} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={10,10} },
    { type=DamageType.UN_POWER, method=AttackType.TOUCH, dam={10,10} },
    { type=DamageType.UN_POWER, method=AttackType.TOUCH, dam={10,10} },
  },
  resolvers.talents {
    [Talents.T_NPC_BR_FIRE] = 1,
    [Talents.T_NPC_BR_COLD] = 1,
    [Talents.T_NPC_BR_DISE] = 1,
  },
  body = bodies.humanoid,
  speed = 20,
  vision = 50,
  alertness = 20,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'LUNGORTHIN_THE_BALROG_OF_WHITE_FIRE',
  name = [[Lungorthin, the Balrog of White Fire]],
  display = 'U',
  color = colors.C_v,
  image = 'npc/lungorthin_the_balrog_of_white_fire.png',
  desc = [[A massive form cloaked in flame. Lungorthin stares balefully at you with eyes that smoulder red. The dungeon floor where he stands is scorched by the heat of his body.]],
  corpse_weight = 1400,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 4,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 80, 100 },
  ac = 125,
  max_life = 8000,
  rarity = 2,
  level = 88,
  start_level = 88,
  exp_worth = 37000,
  unique = 'LUNGORTHIN_THE_BALROG_OF_WHITE_FIRE',
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.FIRE] = true,
    [DamageType.OLD_SLEEP] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    DEMON = true,
    ESCORT = true,
    ESCORTS = true,
    EVIL = true,
    FLY = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    HAS_LITE = true,
    MALE = true,
    MOVE_BODY = true,
    OPEN_DOOR = true,
    POWERFUL = true,
    UNIQUE = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, only_item=true, '2d2', '3d2', '4d2' },
  drop = { treasure=0, combat=100, magic=0, tools=0, junk=0 },
  attacks = {
    { type=DamageType.FIRE, method=AttackType.HIT, dam={8,12} },
    { type=DamageType.FIRE, method=AttackType.HIT, dam={8,12} },
    { type=DamageType.PHYSICAL, method=AttackType.CRUSH, dam={8,12} },
    { type=DamageType.UN_POWER, method=AttackType.TOUCH },
  },
  resolvers.talents {
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_BR_FIRE] = 1,
    [Talents.T_NPC_BR_PLAS] = 1,
    [Talents.T_NPC_S_HI_DEMON] = 1,
    [Talents.T_NPC_S_UNDEAD] = 1,
  },
  body = bodies.humanoid,
  speed = 20,
  vision = 20,
  alertness = 80,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'DRAUGLUIN_SIRE_OF_ALL_WEREWOLVES',
  name = [[Draugluin, Sire of All Werewolves]],
  display = 'C',
  color = colors.C_v,
  image = 'npc/draugluin_sire_of_all_werewolves.png',
  desc = [[Draugluin provides Sauron with a fearsome personal guard. He is an enormous wolf inhabited by a human spirit. He is chief of all his kind.]],
  corpse_weight = 100,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=25,
    talent_in = 3,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 80, 100 },
  ac = 90,
  max_life = 8000,
  rarity = 2,
  level = 83,
  start_level = 83,
  exp_worth = 40000,
  unique = 'DRAUGLUIN_SIRE_OF_ALL_WEREWOLVES',
  resist_dam = {
    [DamageType.POISON] = true,
  },
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    CAN_SPEAK = true,
    ESCORT = true,
    ESCORTS = true,
    EVIL = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    MALE = true,
    MOVE_BODY = true,
    OPEN_DOOR = true,
    TAKE_ITEM = true,
    UNIQUE = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, only_item=true, '1d2' },
  drop = { treasure=0, combat=0, magic=100, tools=0, junk=0 },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={6,8} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={6,8} },
    { type=DamageType.POISON, method=AttackType.BITE, dam={6,6} },
    { type=DamageType.POISON, method=AttackType.BITE, dam={6,6} },
  },
  resolvers.talents {
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_S_MONSTERS] = 1,
    [Talents.T_NPC_S_HOUND] = 1,
  },
  body = bodies.quadruped,
  speed = 20,
  vision = 80,
  alertness = 90,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'VECNA_THE_EMPEROR_LICH',
  name = [[Vecna, the Emperor Lich]],
  display = 'L',
  color = colors.C_v,
  image = 'npc/vecna_the_emperor_lich.png',
  desc = [[The greatest of all undead sorcerers, even the gods once feared him.  This ancient shadow of death wilts every living thing it passes.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 3,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 80, 100 },
  ac = 100,
  max_life = 8000,
  rarity = 3,
  level = 92,
  start_level = 92,
  exp_worth = 45000,
  unique = 'VECNA_THE_EMPEROR_LICH',
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.ELEC] = true,
    [DamageType.FIRE] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
    [DamageType.TELEPORT] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    CAN_SPEAK = true,
    COLD_BLOOD = true,
    ESCORT = true,
    EVIL = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    MALE = true,
    NO_CUT = true,
    OPEN_DOOR = true,
    SMART = true,
    UNDEAD = true,
    UNIQUE = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, great=true, only_item=true, '2d2', '3d2', '4d2' },
  drop = { treasure=0, combat=50, magic=50, tools=0, junk=0 },
  attacks = {
    { type=DamageType.EXP_80, method=AttackType.HIT, dam={7,12} },
    { type=DamageType.LOSE_DEX, method=AttackType.HIT, dam={7,12} },
    { type=DamageType.UN_POWER, method=AttackType.HIT, dam={7,12} },
    { type=DamageType.UN_POWER, method=AttackType.HIT, dam={7,12} },
  },
  on_melee_hit = util.black_breath_melee_hit,
  resolvers.talents {
    [Talents.T_NPC_TPORT] = 1,
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_CAUSE_4] = 1,
    [Talents.T_NPC_BRAIN_SMASH] = 1,
    [Talents.T_NPC_BA_MANA] = 1,
    [Talents.T_NPC_BO_MANA] = 1,
    [Talents.T_NPC_BA_FIRE] = 1,
    [Talents.T_NPC_BA_NETH] = 1,
    [Talents.T_NPC_S_MONSTERS] = 1,
    [Talents.T_NPC_S_HI_DEMON] = 1,
    [Talents.T_NPC_S_HI_UNDEAD] = 1,
    [Talents.T_NPC_S_KIN] = 1,
    [Talents.T_NPC_HAND_DOOM] = 1,
    [Talents.T_NPC_ANIM_DEAD] = 1,
  },
  body = bodies.humanoid,
  speed = 20,
  vision = 100,
  alertness = 0,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'GREAT_WYRM_OF_POWER',
  name = [[Great Wyrm of Power]],
  display = 'D',
  color = colors.C_v,
  image = 'npc/great_wyrm_of_power.png',
  desc = [[The mightiest of all dragonkind, a great wyrm of power is seldom encountered in our world. It can crush stars with its might.]],
  corpse_weight = 22000,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 4,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 111, 111 },
  ac = 160,
  max_life = 12321,
  rarity = 4,
  level = 85,
  start_level = 85,
  exp_worth = 47500,
  resist_dam = {
    [DamageType.ACID] = true,
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.DISEASE] = true,
    [DamageType.ELEC] = true,
    [DamageType.FIRE] = true,
    [DamageType.NETHER] = true,
    [DamageType.NEXUS] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.PLASMA] = true,
    [DamageType.POISON] = true,
    [DamageType.TELEPORT] = true,
  },
  melee_retal = {
    [DamageType.COLD] = 'mondam',
    [DamageType.ELEC] = 'mondam',
    [DamageType.FIRE] = 'mondam',
  },
  flags = {
    ATTR_MULTI = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    DRAGON = true,
    FLY = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    GOOD = true,
    HAS_LITE = true,
    MOVE_BODY = true,
    NO_CUT = true,
    OPEN_DOOR = true,
    POWERFUL = true,
    REFLECTING = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, only_item=true, '2d2', '3d2', '4d2' },
  drop = { treasure=50, combat=50, magic=0, tools=0, junk=0 },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={8,12} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={8,12} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={10,14} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={10,14} },
  },
  resolvers.talents {
    [Talents.T_NPC_S_HI_DRAGON] = 1,
    [Talents.T_NPC_S_DRAGON] = 1,
    [Talents.T_NPC_S_KIN] = 1,
    [Talents.T_NPC_BR_ACID] = 1,
    [Talents.T_NPC_BR_ELEC] = 1,
    [Talents.T_NPC_BR_FIRE] = 1,
    [Talents.T_NPC_BR_COLD] = 1,
    [Talents.T_NPC_BR_POIS] = 1,
    [Talents.T_NPC_BR_NETH] = 1,
    [Talents.T_NPC_BR_LITE] = 1,
    [Talents.T_NPC_BR_DARK] = 1,
    [Talents.T_NPC_BR_CONF] = 1,
    [Talents.T_NPC_BR_SOUN] = 1,
    [Talents.T_NPC_BR_CHAO] = 1,
    [Talents.T_NPC_BR_DISE] = 1,
    [Talents.T_NPC_BR_NEXU] = 1,
    [Talents.T_NPC_BR_TIME] = 1,
    [Talents.T_NPC_BR_INER] = 1,
    [Talents.T_NPC_BR_GRAV] = 1,
    [Talents.T_NPC_BR_SHAR] = 1,
    [Talents.T_NPC_BR_PLAS] = 1,
    [Talents.T_NPC_BR_WALL] = 1,
    [Talents.T_NPC_BR_MANA] = 1,
    [Talents.T_NPC_BR_DISI] = 1,
  },
  body = bodies.dragon,
  speed = 20,
  vision = 40,
  alertness = 70,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'CARCHAROTH_THE_JAWS_OF_THIRST',
  name = [[Carcharoth, the Jaws of Thirst]],
  display = 'C',
  color = colors.C_D,
  image = 'npc/carcharoth_the_jaws_of_thirst.png',
  desc = [[The first guard of Angband, Carcharoth, also known as 'The Red Maw', is the largest wolf to ever walk the earth. He is highly intelligent and a deadly opponent in combat.]],
  corpse_weight = 340,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 3,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 90, 100 },
  ac = 110,
  max_life = 9000,
  rarity = 1,
  level = 94,
  start_level = 94,
  exp_worth = 40000,
  unique = 'CARCHAROTH_THE_JAWS_OF_THIRST',
  resist_dam = {
    [DamageType.DARK] = true,
    [DamageType.FIRE] = true,
    [DamageType.POISON] = true,
  },
  melee_retal = {
    [DamageType.FIRE] = 'mondam',
  },
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    CAN_SPEAK = true,
    EVIL = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    MALE = true,
    MOVE_BODY = true,
    OPEN_DOOR = true,
    SMART = true,
    UNIQUE = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, only_item=true, '4d2' },
  drop = { treasure=30, combat=10, magic=60, tools=0, junk=0 },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.POISON, method=AttackType.CLAW, dam={9,12} },
    { type=DamageType.POISON, method=AttackType.CLAW, dam={9,12} },
    { type=DamageType.FIRE, method=AttackType.BITE, dam={9,12} },
    { type=DamageType.FIRE, method=AttackType.BITE, dam={9,12} },
  },
  resolvers.talents {
    [Talents.T_NPC_BR_DARK] = 1,
    [Talents.T_NPC_BR_POIS] = 1,
    [Talents.T_NPC_BR_FIRE] = 1,
    [Talents.T_NPC_BR_NETH] = 1,
    [Talents.T_NPC_S_HOUND] = 1,
  },
  body = bodies.quadruped,
  speed = 20,
  vision = 80,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'HUAN_WOLFHOUND_OF_THE_VALAR',
  name = [[Huan, Wolfhound of the Valar]],
  display = 'C',
  color = colors.C_W,
  image = 'npc/huan_wolfhound_of_the_valar.png',
  desc = [[The wolfhound of the Valar, Huan has served many masters in his time, from Celegorm son of Fëanor to Beren son of Barahir: but now he runs wild and acknowledges no master save himself, as he hunts alone for his nemesis - Carcharoth, the terrible wolf of Angband.]],
  corpse_weight = 340,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 5,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 90, 100 },
  ac = 160,
  faction = 'eru_manwe',
  max_life = 9000,
  rarity = 2,
  level = 93,
  start_level = 93,
  exp_worth = 40000,
  unique = 'HUAN_WOLFHOUND_OF_THE_VALAR',
  resist_dam = {
    [DamageType.ACID] = true,
    [DamageType.COLD] = true,
    [DamageType.ELEC] = true,
  },
  melee_retal = {
    [DamageType.COLD] = 'mondam',
  },
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    CAN_SPEAK = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    GOOD = true,
    KILL_BODY = true,
    MALE = true,
    OPEN_DOOR = true,
    SMART = true,
    UNIQUE = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, only_item=true, '4d2' },
  drop = { treasure=30, combat=10, magic=60, tools=0, junk=0 },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.COLD, method=AttackType.CLAW, dam={9,12} },
    { type=DamageType.COLD, method=AttackType.CLAW, dam={9,12} },
    { type=DamageType.COLD, method=AttackType.BITE, dam={9,12} },
    { type=DamageType.COLD, method=AttackType.BITE, dam={9,12} },
  },
  resolvers.talents {
    [Talents.T_NPC_BR_COLD] = 1,
    [Talents.T_NPC_BR_SHAR] = 1,
    [Talents.T_NPC_BR_SOUN] = 1,
    [Talents.T_NPC_BR_LITE] = 1,
  },
  body = bodies.quadruped,
  speed = 20,
  vision = 50,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'GOTHMOG_THE_HIGH_CAPTAIN_OF_BALROGS',
  name = [[Gothmog, the High Captain of Balrogs]],
  display = 'U',
  color = colors.C_v,
  image = 'npc/gothmog_the_high_captain_of_balrogs.png',
  desc = [[Gothmog is the Chief Balrog in Morgoth's personal guard. He is renowned for slaying three High Kings of the Ñoldor Elves, and he has never been defeated in combat. With his whip of flame and awesome fiery breath he saved his master from Ungoliant's rage.]],
  corpse_weight = 1700,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 3,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 120, 100 },
  ac = 140,
  max_life = 12000,
  rarity = 1,
  level = 95,
  start_level = 95,
  exp_worth = 43000,
  unique = 'GOTHMOG_THE_HIGH_CAPTAIN_OF_BALROGS',
  resist_dam = {
    [DamageType.ELEC] = true,
    [DamageType.FIRE] = true,
  },
  melee_retal = {
    [DamageType.FIRE] = 'mondam',
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    CAN_SPEAK = true,
    DEMON = true,
    ESCORT = true,
    ESCORTS = true,
    EVIL = true,
    FLY = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    HAS_LITE = true,
    KILL_WALL = true,
    MALE = true,
    MOVE_BODY = true,
    NONLIVING = true,
    OPEN_DOOR = true,
    POWERFUL = true,
    UNIQUE = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, great=true, only_item=true, '2d2', '3d2', '4d2' },
  drop = { treasure=0, combat=100, magic=0, tools=0, junk=0 },
  attacks = {
    { type=DamageType.FIRE, method=AttackType.HIT, dam={9,12} },
    { type=DamageType.FIRE, method=AttackType.HIT, dam={9,12} },
    { type=DamageType.PHYSICAL, method=AttackType.CRUSH, dam={8,12} },
    { type=DamageType.UN_POWER, method=AttackType.TOUCH },
  },
  resolvers.talents {
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_BR_FIRE] = 1,
    [Talents.T_NPC_S_KIN] = 1,
    [Talents.T_NPC_S_HI_DEMON] = 1,
    [Talents.T_NPC_S_HI_UNDEAD] = 1,
  },
  body = bodies.humanoid,
  speed = 20,
  vision = 100,
  alertness = 0,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'SARKO_RIDER_OF_GOLD_FORONTH',
  name = [[Sarko, rider of gold Foronth]],
  display = 'B',
  color = colors.C_y,
  multi_colors = { colors.C_r, colors.C_B },
  image = 'npc/sarko_rider_of_gold_foronth.png',
  desc = [[Foronth is the first Eagle queen, and Sarko the first to discover the Firebirds, the ancestor of the Thunderlord eagles. She will try to help you!]],
  corpse_weight = 42000,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 4,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 99, 111 },
  ac = 165,
  faction = 'friendlies',
  max_life = 10989,
  rarity = 6,
  level = 97,
  start_level = 97,
  exp_worth = 65000,
  unique = 'SARKO_RIDER_OF_GOLD_FORONTH',
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.ELEC] = true,
    [DamageType.FIRE] = true,
    [DamageType.POISON] = true,
    [DamageType.TELEPORT] = true,
  },
  melee_retal = {
    [DamageType.ELEC] = 'mondam',
    [DamageType.FIRE] = 'mondam',
  },
  flags = {
    ATTR_MULTI = true,
    BASH_DOOR = true,
    CAN_SPEAK = true,
    FEMALE = true,
    FLY = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    GOOD = true,
    HAS_LITE = true,
    MORTAL = true,
    MOVE_BODY = true,
    OPEN_DOOR = true,
    PET = true,
    POWERFUL = true,
    REFLECTING = true,
    REGENERATE = true,
    SMART = true,
    THUNDERLORD = true,
    UNIQUE = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, great=true, only_item=true, '2d2', '3d2', '4d2' },
  drop = { treasure=50, combat=50, magic=0, tools=0, junk=0 },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={12,12} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={12,12} },
    { type=DamageType.FIRE, method=AttackType.HIT, dam={12,12} },
    { type=DamageType.FIRE, method=AttackType.HIT, dam={12,12} },
  },
  resolvers.talents {
    [Talents.T_NPC_TPORT] = 1,
    [Talents.T_NPC_TELE_TO] = 1,
    [Talents.T_NPC_BR_FIRE] = 1,
    [Talents.T_NPC_BR_TIME] = 1,
    [Talents.T_NPC_S_THUNDERLORD] = 1,
    [Talents.T_NPC_TELE_AWAY] = 1,
  },
  body = bodies.humanoid,
  speed = 35,
  vision = 100,
  alertness = 0,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'SAURON_THE_SORCERER',
  name = [[Sauron, the Sorcerer]],
  display = 'p',
  color = colors.C_v,
  image = 'npc/sauron_the_sorcerer.png',
  desc = [[Mighty in spells and enchantments, he created the One Ring. His eyes glow with power and with his gaze he seeks to destroy your soul. He has many servants, and rarely fights without them.]],
  corpse_weight = 230,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 2,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 100, 225 },
  ac = 160,
  max_life = 22500,
  rarity = 1,
  level = 99,
  start_level = 99,
  exp_worth = 50000,
  unique = 'SAURON_THE_SORCERER',
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.ELEC] = true,
    [DamageType.FEAR] = true,
    [DamageType.FIRE] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
    [DamageType.TELEPORT] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    CAN_SPEAK = true,
    EVIL = true,
    FORCE_DEPTH = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    HAS_LITE = true,
    MALE = true,
    MOVE_BODY = true,
    OPEN_DOOR = true,
    REFLECTING = true,
    REGENERATE = true,
    SMART = true,
    UNIQUE = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, great=true, only_item=true, '2d2', '3d2', '4d2' },
  drop = { treasure=0, combat=0, magic=100, tools=0, junk=0 },
  attacks = {
    { type=DamageType.DISENCHANT, method=AttackType.HIT, dam={10,12} },
    { type=DamageType.DISENCHANT, method=AttackType.HIT, dam={10,12} },
    { type=DamageType.UN_POWER, method=AttackType.HIT, dam={8,12} },
    { type=DamageType.UN_POWER, method=AttackType.HIT, dam={8,12} },
  },
  resolvers.talents {
    [Talents.T_NPC_TPORT] = 1,
    [Talents.T_NPC_TELE_LEVEL] = 1,
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_CAUSE_4] = 1,
    [Talents.T_NPC_BRAIN_SMASH] = 1,
    [Talents.T_NPC_FORGET] = 1,
    [Talents.T_NPC_BO_ICEE] = 1,
    [Talents.T_NPC_BO_MANA] = 1,
    [Talents.T_NPC_BO_PLAS] = 1,
    [Talents.T_NPC_BA_MANA] = 1,
    [Talents.T_NPC_BA_FIRE] = 1,
    [Talents.T_NPC_BA_WATE] = 1,
    [Talents.T_NPC_BA_NETH] = 1,
    [Talents.T_NPC_BA_DARK] = 1,
    [Talents.T_NPC_BA_CHAO] = 1,
    [Talents.T_NPC_S_MONSTERS] = 1,
    [Talents.T_NPC_S_HI_DEMON] = 1,
    [Talents.T_NPC_S_HI_UNDEAD] = 1,
    [Talents.T_NPC_S_HI_DRAGON] = 1,
    [Talents.T_NPC_S_WRAITH] = 1,
    [Talents.T_NPC_S_UNIQUE] = 1,
    [Talents.T_NPC_HAND_DOOM] = 1,
    [Talents.T_NPC_ANIM_DEAD] = 1,
  },
  body = bodies.humanoid,
  speed = 20,
  vision = 100,
  alertness = 0,
  resolvers.mon_global_speed(),
  -- BEGIN VERBATIM
  on_die_post = util.nazgul_die,
  -- END VERBATIM
}

newEntity {
  define_as = 'MORGOTH_LORD_OF_DARKNESS',
  name = [[Morgoth, Lord of Darkness]],
  display = 'P',
  color = colors.C_D,
  image = 'npc/morgoth_lord_of_darkness.png',
  desc = [[He was the most powerful of the Valar, the equal of Manwë. He is the Master of the Pits of Angband. His figure is like a black mountain crowned with Lightning. He rages with everlasting anger, his body scarred by Fingolfin's eight mighty wounds. He can never rest from his pain, but seeks forever to dominate all that is light and good in the world. He is the origin of man's fear of darkness and created many foul creatures with his evil powers. Orcs, Dragons, and Trolls are his most foul corruptions, causing much pain and suffering in the world to please him. His disgusting visage, twisted with evil, is crowned with iron, the two remaining Silmarils forever burning him. Grond, the mighty Hammer of the Underworld, cries defiance as he strides towards you to crush you to a pulp!]],
  corpse_weight = 20000,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 3,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 200, 150 },
  ac = 150,
  max_life = 30000,
  rarity = 1,
  level = 100,
  start_level = 100,
  exp_worth = 60000,
  unique = 'MORGOTH_LORD_OF_DARKNESS',
  resist_dam = {
    [DamageType.ACID] = true,
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.ELEC] = true,
    [DamageType.FEAR] = true,
    [DamageType.FIRE] = true,
    [DamageType.NETHER] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
    [DamageType.TELEPORT] = true,
  },
  melee_retal = {
    [DamageType.COLD] = 'mondam',
  },
  flags = {
    BASEANGBAND = true,
    CAN_SPEAK = true,
    EVIL = true,
    FORCE_DEPTH = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    HAS_LITE = true,
    KILL_WALL = true,
    MALE = true,
    MOVE_BODY = true,
    NO_STUN = true,
    POWERFUL = true,
    REGENERATE = true,
    SMART = true,
    UNIQUE = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, great=true, only_item=true, '1d2', '2d2', '3d2', '4d2' },
  drop = { treasure=0, combat=100, magic=0, tools=0, junk=0 },
  drop_special = function(self) return game.zone:makeEntityByName(game.level, 'artifact', 'GROND', false) end,
  attacks = {
    { type=DamageType.SHATTER, method=AttackType.HIT, dam={24,10} },
    { type=DamageType.SHATTER, method=AttackType.HIT, dam={24,10} },
    { type=DamageType.LOSE_ALL, method=AttackType.HIT, dam={10,12} },
    { type=DamageType.UN_POWER, method=AttackType.TOUCH },
  },
  resolvers.talents {
    [Talents.T_NPC_BRAIN_SMASH] = 1,
    [Talents.T_NPC_BA_MANA] = 1,
    [Talents.T_NPC_BO_MANA] = 1,
    [Talents.T_NPC_BA_NETH] = 1,
    [Talents.T_NPC_BA_CHAO] = 1,
    [Talents.T_NPC_BA_DARK] = 1,
    [Talents.T_NPC_ANIM_DEAD] = 1,
    [Talents.T_NPC_S_MONSTERS] = 1,
    [Talents.T_NPC_S_UNIQUE] = 1,
    [Talents.T_NPC_S_HI_DEMON] = 1,
    [Talents.T_NPC_S_HI_UNDEAD] = 1,
    [Talents.T_NPC_S_HI_DRAGON] = 1,
    [Talents.T_NPC_ROCKET] = 1,
    [Talents.T_NPC_BR_NETH] = 1,
    [Talents.T_NPC_BR_DISI] = 1,
    [Talents.T_NPC_HAND_DOOM] = 1,
    [Talents.T_NPC_S_WRAITH] = 1,
  },
  body = bodies.humanoid,
  speed = 30,
  vision = 100,
  alertness = 0,
  resolvers.mon_global_speed(),
  -- BEGIN VERBATIM
  on_die_post = function(self, src)
    local Dialog = require 'engine.ui.Dialog'
    local evil = game.player:isQuestStatus('one-ring', engine.Quest.FAILED)
    local text = [[You have banished Morgoth's foul spirit from Ea.  As you watch, a cleansing wind roars through the dungeon, dispersing the nether mists from where Morgoth's body fell.  You feel thanks, and a touch of sorrow, from the Valar for your deed.  You will be forever heralded, your deed forever legendary.

#YELLOW#You may retire your character when you are ready.#LAST#]]
    if evil then
      text = [[You have banished Morgoth's foul spirit from Ea.  As you look down at the dispersing mists around Morgoth, a sudden intuition grasps you.  Fingering the One Ring, you gather the nether mists around yourself and inhale deeply their seductive power.  You will be forever feared, your orders forever obeyed.

#YELLOW#You may retire your character when you are ready.#LAST#]]
    end
    local function cb()
      game.player:setQuestStatus('morgoth', engine.Quest.DONE)
      world:gainAchievement(evil and 'KILL_MORGOTH_EVIL' or 'KILL_MORGOTH', game.player)
    end
    Dialog:simpleLongPopup('VICTORY!', text, 600, cb)
  end,
  -- END VERBATIM
}

newEntity {
  define_as = 'HUMAN_WARRIOR',
  name = [[Human Warrior]],
  display = 'p',
  color = colors.C_u,
  image = 'npc/human_warrior.png',
  desc = [[They are used as the main assault force of the human kings. They will help you in some quests.]],
  corpse_weight = 170,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 9, 8 },
  ac = 10,
  faction = 'friendlies',
  max_life = resolvers.dice(9, 8),
  rarity = 20,
  level = 0,
  start_level = 0,
  exp_worth = 0,
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    FRIENDS = true,
    HAS_LITE = true,
    MALE = true,
    MORTAL = true,
    OPEN_DOOR = true,
    PET = true,
  },
  placement_flags = { WILD_ONLY=true },
  resolvers.mon_inven{ only_gold=true, '1d2' },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={5,8} },
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 10,
  alertness = 0,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'ELVEN_ARCHER',
  name = [[Elven archer]],
  display = 'h',
  color = colors.C_W,
  image = 'npc/elven_archer.png',
  desc = [[They are used as the main assault force of the elven kings. They will help you in some quests.]],
  corpse_weight = 140,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 1,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 9, 7 },
  ac = 10,
  faction = 'friendlies',
  max_life = resolvers.dice(9, 7),
  rarity = 20,
  level = 0,
  start_level = 0,
  exp_worth = 0,
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    FRIENDS = true,
    HAS_LITE = true,
    MALE = true,
    MORTAL = true,
    OPEN_DOOR = true,
    PET = true,
  },
  placement_flags = { WILD_ONLY=true },
  resolvers.mon_inven{ only_gold=true, '1d2' },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={2,8} },
  },
  resolvers.talents {
    [Talents.T_NPC_ARROW_2] = 1,
    [Talents.T_NPC_ARROW_1] = 1,
    [Talents.T_NPC_ARROW_2] = 1,
    [Talents.T_NPC_ARROW_1] = 1,
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 10,
  alertness = 0,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'DWARVEN_WARRIOR',
  name = [[Dwarven warrior]],
  display = 'h',
  color = colors.C_U,
  image = 'npc/dwarven_warrior.png',
  desc = [[They are used as the main assault force of the dwarven kings. They will help you in some quests.]],
  corpse_weight = 150,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 8, 8 },
  ac = 10,
  faction = 'friendlies',
  max_life = resolvers.dice(8, 8),
  rarity = 20,
  level = 0,
  start_level = 0,
  exp_worth = 0,
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    FRIENDS = true,
    HAS_LITE = true,
    MALE = true,
    MORTAL = true,
    OPEN_DOOR = true,
    PET = true,
  },
  placement_flags = { WILD_ONLY=true },
  resolvers.mon_inven{ only_gold=true, '1d2' },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={6,8} },
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 10,
  alertness = 0,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'ELITE_URUK',
  name = [[Elite uruk]],
  display = 'o',
  color = colors.C_w,
  image = 'npc/elite_uruk.png',
  desc = [[It is a cunning orc of power, taller than a man, and stronger. It fears little.]],
  corpse_weight = 200,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 8,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 10, 10 },
  ac = 50,
  max_life = 100,
  rarity = 1,
  level = 20,
  start_level = 20,
  exp_worth = 70,
  resist_dam = {
    [DamageType.DARK] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    EVIL = true,
    FORCE_MAXHP = true,
    FRIENDS = true,
    HAS_LITE = true,
    MALE = true,
    MORTAL = true,
    OPEN_DOOR = true,
    ORC = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ '60%' },
  drop = { treasure=10, combat=90, magic=0, tools=0, junk=0 },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={8,5} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={8,5} },
  },
  resolvers.talents {
    [Talents.T_NPC_ARROW_2] = 1,
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 20,
  alertness = 0,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'DURIN_S_BANE',
  name = [[Durin's Bane]],
  display = 'U',
  color = colors.C_v,
  image = 'npc/durin_s_bane.png',
  desc = [[A huge Balrog surrounded by raging pillars of fire, this is indeed a terrible opponent. Wielding a great whip of fire and a blazing sword, his fury blisters your skin and melts your flesh!]],
  corpse_weight = 1300,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 4,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 30, 100 },
  ac = 100,
  max_life = 3000,
  level = 50,
  start_level = 50,
  exp_worth = 30000,
  unique = 'DURIN_S_BANE',
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.FIRE] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    DEMON = true,
    ESCORT = true,
    ESCORTS = true,
    EVIL = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    HAS_LITE = true,
    KILL_WALL = true,
    MALE = true,
    MOVE_BODY = true,
    NONLIVING = true,
    OPEN_DOOR = true,
    POWERFUL = true,
    SPECIAL_GENE = true,
    UNIQUE = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, only_item=true, randart=true, '2d2', '3d2', '4d2' },
  drop = { treasure=0, combat=50, magic=50, tools=0, junk=0 },
  drop_corpse = { corpse=true },
  drop_special = function(self) return rng.percent(60) and game.zone:makeEntityByName(game.level, 'artifact', 'CALRIS', false) end,
  attacks = {
    { type=DamageType.FIRE, method=AttackType.HIT, dam={6,12} },
    { type=DamageType.FIRE, method=AttackType.HIT, dam={6,12} },
    { type=DamageType.PHYSICAL, method=AttackType.CRUSH, dam={5,12} },
    { type=DamageType.UN_POWER, method=AttackType.TOUCH },
  },
  resolvers.talents {
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_BR_FIRE] = 1,
    [Talents.T_NPC_S_UNDEAD] = 1,
    [Talents.T_NPC_S_DEMON] = 1,
  },
  body = bodies.humanoid,
  speed = 20,
  vision = 20,
  alertness = 80,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'THE_ICKY_QUEEN',
  name = [[The Icky Queen]],
  display = 'i',
  color = colors.C_v,
  image = 'npc/the_icky_queen.png',
  desc = [[And you thought her offspring were icky!]],
  corpse_weight = 300,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 5,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 40, 10 },
  ac = 50,
  max_life = 400,
  rarity = 5,
  level = 20,
  start_level = 20,
  exp_worth = 400,
  unique = 'THE_ICKY_QUEEN',
  resist_dam = {
    [DamageType.ACID] = true,
    [DamageType.COLD] = true,
    [DamageType.ELEC] = true,
    [DamageType.FIRE] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    CAN_SPEAK = true,
    ESCORT = true,
    ESCORTS = true,
    EVIL = true,
    FEMALE = true,
    FORCE_MAXHP = true,
    MORTAL = true,
    OPEN_DOOR = true,
    SMART = true,
    TAKE_ITEM = true,
    UNIQUE = true,
    WEIRD_MIND = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, only_item=true, '1d2' },
  drop = { treasure=40, combat=30, magic=10, tools=10, junk=10 },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.POISON, method=AttackType.CRAWL, dam={3,4} },
    { type=DamageType.EAT_FOOD, method=AttackType.CRAWL, dam={3,4} },
    { type=DamageType.ACID, method=AttackType.TOUCH, dam={3,5} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={3,5} },
  },
  resolvers.talents {
    [Talents.T_NPC_DRAIN_MANA] = 1,
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_S_KIN] = 1,
  },
  body = bodies.none,
  speed = 10,
  vision = 20,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'ROT_JELLY',
  name = [[Rot jelly]],
  display = 'j',
  color = colors.C_u,
  image = 'npc/rot_jelly.png',
  desc = [[It is a large pile of rotting flesh, whose touch spoils your food.  The terrible smell it exudes is also very hard to get rid of...]],
  corpse_weight = 200,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 20, 8 },
  ac = 30,
  max_life = resolvers.dice(20, 8),
  rarity = 1,
  level = 5,
  start_level = 5,
  exp_worth = 15,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.DARK] = true,
    [DamageType.FEAR] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  vuln_dam = {
    [DamageType.LITE] = true,
    [DamageType.LITE_WEAK] = true,
  },
  flags = {
    BASEANGBAND = true,
    CAN_SWIM = true,
    EMPTY_MIND = true,
    NEVER_MOVE = true,
    NO_CUT = true,
    STUPID = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.EAT_FOOD, method=AttackType.TOUCH, dam={2,3} },
    { type=DamageType.LOSE_CHR, method=AttackType.TOUCH, dam={2,3} },
  },
  body = bodies.none,
  speed = 10,
  vision = 2,
  alertness = 99,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'PIKE',
  name = [[Pike]],
  display = '~',
  color = colors.C_s,
  image = 'npc/pike.png',
  desc = [[It's a common fresh-water predatory fish.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 2, 7 },
  ac = 35,
  max_life = resolvers.dice(2, 7),
  rarity = 1,
  level = 2,
  start_level = 2,
  exp_worth = 7,
  flags = {
    ANIMAL = true,
    AQUATIC = true,
    BASEANGBAND = true,
    COLD_BLOOD = true,
    MORTAL = true,
    STUPID = true,
  },
  placement_flags = {},
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={2,3} },
  },
  body = bodies.snake,
  speed = 15,
  vision = 80,
  alertness = 0,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'ELECTRIC_EEL',
  name = [[Electric eel]],
  display = 'J',
  color = colors.C_B,
  image = 'npc/electric_eel.png',
  desc = [[This serpentine creature can create a deadly voltage.  Better watch out!]],
  corpse_weight = 50,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=25,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 15, 15 },
  ac = 40,
  max_life = resolvers.dice(15, 15),
  rarity = 2,
  level = 20,
  start_level = 20,
  exp_worth = 145,
  resist_dam = {
    [DamageType.ELEC] = true,
    [DamageType.WATER] = true,
  },
  flags = {
    ANIMAL = true,
    AQUATIC = true,
    BASEANGBAND = true,
    COLD_BLOOD = true,
    MORTAL = true,
  },
  placement_flags = { WILD_OCEAN=true, WILD_TOO=true },
  attacks = {
    { type=DamageType.ELEC, method=AttackType.TOUCH, dam={2,7} },
    { type=DamageType.ELEC, method=AttackType.TOUCH, dam={2,7} },
    { type=DamageType.ELEC, method=AttackType.TOUCH, dam={2,7} },
  },
  body = bodies.quadruped,
  speed = 0,
  vision = 15,
  alertness = 70,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'GIANT_CRAYFISH',
  name = [[Giant crayfish]],
  self_plural = true,
  display = '~',
  color = colors.C_R,
  image = 'npc/giant_crayfish.png',
  desc = [[A man-sized, heavily armoured fresh-water relative of the lobster.]],
  corpse_weight = 120,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 4, 10 },
  ac = 100,
  max_life = resolvers.dice(4, 10),
  rarity = 1,
  level = 4,
  start_level = 4,
  exp_worth = 10,
  flags = {
    ANIMAL = true,
    AQUATIC = true,
    BASEANGBAND = true,
    COLD_BLOOD = true,
    MORTAL = true,
    STUPID = true,
    WEIRD_MIND = true,
  },
  placement_flags = {},
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={3,4} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={3,4} },
  },
  body = bodies.snake,
  speed = -20,
  vision = 6,
  alertness = 20,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'BOX_JELLYFISH',
  name = [[Box jellyfish]],
  self_plural = true,
  display = '~',
  color = colors.C_B,
  image = 'npc/box_jellyfish.png',
  desc = [[A strange water creature, whose touch can be deadly.]],
  corpse_weight = 300,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 10, 10 },
  ac = 30,
  max_life = resolvers.dice(10, 10),
  rarity = 2,
  level = 10,
  start_level = 10,
  exp_worth = 25,
  resist_dam = {
    [DamageType.POISON] = true,
  },
  flags = {
    ANIMAL = true,
    AQUATIC = true,
    BASEANGBAND = true,
    COLD_BLOOD = true,
    MORTAL = true,
  },
  placement_flags = { WILD_TOO=true },
  attacks = {
    { type=DamageType.PARALYZE, method=AttackType.TOUCH, dam={1,6} },
    { type=DamageType.PARALYZE, method=AttackType.TOUCH, dam={1,6} },
  },
  body = bodies.none,
  speed = 0,
  vision = 20,
  alertness = 75,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'GIANT_PIRANHA',
  name = [[Giant piranha]],
  display = '~',
  color = colors.C_g,
  image = 'npc/giant_piranha.png',
  desc = [[A very large and bloodthirsty fish.]],
  corpse_weight = 30,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 6, 8 },
  ac = 20,
  max_life = resolvers.dice(6, 8),
  rarity = 2,
  level = 10,
  start_level = 10,
  exp_worth = 40,
  resist_dam = {
    [DamageType.OLD_SLEEP] = true,
  },
  flags = {
    ANIMAL = true,
    AQUATIC = true,
    BASEANGBAND = true,
    COLD_BLOOD = true,
    FRIENDS = true,
    MORTAL = true,
  },
  placement_flags = { WILD_TOO=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={5,1} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={5,1} },
  },
  body = bodies.snake,
  speed = 10,
  vision = 30,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'PIRANHA',
  name = [[Piranha]],
  display = '~',
  color = colors.C_g,
  image = 'npc/piranha.png',
  desc = [[Bloodthirsty fish who can smell your blood from a great distance.]],
  corpse_weight = 20,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 2, 6 },
  ac = 8,
  max_life = resolvers.dice(2, 6),
  rarity = 1,
  level = 3,
  start_level = 3,
  exp_worth = 8,
  flags = {
    ANIMAL = true,
    AQUATIC = true,
    BASEANGBAND = true,
    COLD_BLOOD = true,
    FRIENDS = true,
    MORTAL = true,
  },
  placement_flags = { WILD_TOO=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={1,6} },
  },
  body = bodies.snake,
  speed = 10,
  vision = 20,
  alertness = 5,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'BULLYWUG',
  name = [[Bullywug]],
  display = 'h',
  color = colors.C_g,
  image = 'npc/bullywug.png',
  desc = [[A vaguely humanoid creature, it looks like a cross between a hobbit and a frog.]],
  corpse_weight = 70,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 6, 10 },
  ac = 15,
  max_life = resolvers.dice(6, 10),
  rarity = 1,
  level = 7,
  start_level = 7,
  exp_worth = 25,
  flags = {
    AQUATIC = true,
    BASEANGBAND = true,
    COLD_BLOOD = true,
    FRIENDS = true,
    HAS_LITE = true,
    MALE = true,
    MORTAL = true,
    SMART = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ only_item=true, '1d2' },
  drop = { treasure=30, combat=40, magic=10, tools=10, junk=10 },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={2,4} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={2,4} },
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 20,
  alertness = 0,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'BULLYWUG_WARRIOR',
  name = [[Bullywug warrior]],
  display = 'h',
  color = colors.C_g,
  image = 'npc/bullywug_warrior.png',
  desc = [[A member of the frog-people clan. He is wielding a long, sharp shark tooth.]],
  corpse_weight = 75,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 8, 10 },
  ac = 15,
  max_life = resolvers.dice(8, 10),
  rarity = 1,
  level = 8,
  start_level = 8,
  exp_worth = 35,
  flags = {
    AQUATIC = true,
    BASEANGBAND = true,
    COLD_BLOOD = true,
    HAS_LITE = true,
    MALE = true,
    MORTAL = true,
    SMART = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ only_item=true, '1d2' },
  drop = { treasure=15, combat=60, magic=10, tools=10, junk=5 },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={2,5} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={2,5} },
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 20,
  alertness = 0,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'BULLYWUG_SHAMAN',
  name = [[Bullywug shaman]],
  display = 'h',
  color = colors.C_g,
  image = 'npc/bullywug_shaman.png',
  desc = [[A leader of a clan of frog-people, he is cloaked in a cloak made of shark skin.]],
  corpse_weight = 80,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 5,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 6, 10 },
  ac = 15,
  max_life = resolvers.dice(6, 10),
  rarity = 1,
  level = 8,
  start_level = 8,
  exp_worth = 35,
  flags = {
    AQUATIC = true,
    BASEANGBAND = true,
    COLD_BLOOD = true,
    HAS_LITE = true,
    MALE = true,
    MORTAL = true,
    SMART = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ only_item=true, '1d2' },
  drop = { treasure=25, combat=10, magic=50, tools=10, junk=5 },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,6} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,6} },
  },
  resolvers.talents {
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_DARKNESS] = 1,
    [Talents.T_NPC_BO_COLD] = 1,
    [Talents.T_NPC_HEAL] = 1,
    [Talents.T_NPC_MISSILE] = 1,
    [Talents.T_NPC_CAUSE_2] = 1,
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 20,
  alertness = 0,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'WHALE',
  name = [[Whale]],
  display = '~',
  color = colors.C_G,
  image = 'npc/whale.png',
  desc = [[Although it looks like a fish and lives in water, it is in fact a mammal. And it is huge!]],
  corpse_weight = 900,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=25,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 22, 22 },
  ac = 50,
  max_life = 484,
  rarity = 4,
  level = 20,
  start_level = 20,
  exp_worth = 175,
  resist_dam = {
    [DamageType.WATER] = true,
  },
  flags = {
    ANIMAL = true,
    AQUATIC = true,
    BASEANGBAND = true,
    FORCE_MAXHP = true,
    MORTAL = true,
  },
  placement_flags = { WILD_TOO=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CRUSH, dam={1,20} },
    { type=DamageType.PHYSICAL, method=AttackType.CRUSH, dam={1,20} },
  },
  body = bodies.snake,
  speed = 0,
  vision = 15,
  alertness = 70,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'SAND_MITE',
  name = [[Sand mite]],
  display = '~',
  color = colors.C_B,
  image = 'npc/sand_mite.png',
  desc = [[A relative of crabs and shrimp, this is a tiny creature that inhabits sandy bottoms. It has a pair of dangerous-looking claws.]],
  corpse_weight = 50,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 3, 10 },
  ac = 25,
  max_life = resolvers.dice(3, 10),
  rarity = 2,
  level = 10,
  start_level = 10,
  exp_worth = 25,
  resist_dam = {
    [DamageType.POISON] = true,
  },
  flags = {
    ANIMAL = true,
    AQUATIC = true,
    ATTR_CLEAR = true,
    BASEANGBAND = true,
    CHAR_CLEAR = true,
    COLD_BLOOD = true,
    FRIENDS = true,
    MORTAL = true,
    MULTIPLY = true,
  },
  placement_flags = {},
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.POISON, method=AttackType.BITE, dam={3,6} },
    { type=DamageType.POISON, method=AttackType.BITE, dam={3,6} },
  },
  body = bodies.none,
  speed = 0,
  vision = 5,
  alertness = 80,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'OCTOPUS',
  name = [[Octopus]],
  plural_name = [[Octopodes]],
  display = '~',
  color = colors.C_g,
  image = 'npc/octopus.png',
  desc = [[It doesn't move very fast, but when it does - watch out!]],
  corpse_weight = 120,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=25,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 60, 6 },
  ac = 60,
  max_life = resolvers.dice(60, 6),
  rarity = 2,
  level = 15,
  start_level = 15,
  exp_worth = 60,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.WATER] = true,
  },
  flags = {
    ANIMAL = true,
    AQUATIC = true,
    BASEANGBAND = true,
    COLD_BLOOD = true,
    MORTAL = true,
  },
  placement_flags = { WILD_TOO=true },
  attacks = {
    { type=DamageType.BLIND, method=AttackType.SPIT, dam={1,3} },
    { type=DamageType.PHYSICAL, method=AttackType.CRUSH, dam={6,3} },
    { type=DamageType.PHYSICAL, method=AttackType.CRUSH, dam={6,3} },
    { type=DamageType.PHYSICAL, method=AttackType.CRUSH, dam={6,3} },
  },
  body = { MAIN_HAND=3, OFF_HAND=3, BODY=0, CLOAK=0, LAUNCHER=1, QUIVER=0, GLOVES=3, BOOTS=0, HELM=1, RING=6, AMULET=1, LITE=0, TOOL=1, SYMBIOTE=0, INVEN=23 },
  speed = -5,
  vision = 60,
  alertness = 60,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'GIANT_OCTOPUS',
  name = [[Giant octopus]],
  plural_name = [[Giant octopodes]],
  display = '~',
  color = colors.C_g,
  image = 'npc/giant_octopus.png',
  desc = [[A cunning and dangerous undersea opponent.]],
  corpse_weight = 180,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 15,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 100, 6 },
  ac = 35,
  max_life = resolvers.dice(100, 6),
  rarity = 1,
  level = 30,
  start_level = 30,
  exp_worth = 180,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.FEAR] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    ANIMAL = true,
    AQUATIC = true,
    BASEANGBAND = true,
    COLD_BLOOD = true,
    MORTAL = true,
    SMART = true,
    WEIRD_MIND = true,
  },
  placement_flags = {},
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.BLIND, method=AttackType.SPIT, dam={1,4} },
    { type=DamageType.PHYSICAL, method=AttackType.CRUSH, dam={8,4} },
    { type=DamageType.PHYSICAL, method=AttackType.CRUSH, dam={8,4} },
    { type=DamageType.PARALYZE, method=AttackType.CRUSH, dam={8,4} },
  },
  resolvers.talents {
    [Talents.T_NPC_DARKNESS] = 1,
    [Talents.T_NPC_SLOW] = 1,
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_SCARE] = 1,
  },
  body = { MAIN_HAND=3, OFF_HAND=3, BODY=0, CLOAK=0, LAUNCHER=1, QUIVER=0, GLOVES=3, BOOTS=0, HELM=1, RING=6, AMULET=1, LITE=0, TOOL=1, SYMBIOTE=0, INVEN=23 },
  speed = 5,
  vision = 10,
  alertness = 5,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'EYE_OF_THE_DEEP',
  name = [[Eye of the deep]],
  display = 'e',
  color = colors.C_b,
  image = 'npc/eye_of_the_deep.png',
  desc = [[A beholder that inhabits the depths of the sea, sleeping and pondering alien thoughts for centuries. Occasionally, it will float to the surface to wreck the lives of surface dwellers.]],
  corpse_weight = 160,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 2,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 16, 100 },
  ac = 20,
  max_life = 1600,
  rarity = 3,
  level = 40,
  start_level = 40,
  exp_worth = 6000,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
    [DamageType.TELEPORT] = true,
  },
  flags = {
    AQUATIC = true,
    BASEANGBAND = true,
    EVIL = true,
    FLY = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    SMART = true,
  },
  placement_flags = {},
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.EXP_20, method=AttackType.GAZE, dam={2,6} },
    { type=DamageType.UN_POWER, method=AttackType.GAZE, dam={2,6} },
    { type=DamageType.INSANITY, method=AttackType.GAZE, dam={2,6} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={6,6} },
  },
  resolvers.talents {
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_SLOW] = 1,
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_DRAIN_MANA] = 1,
    [Talents.T_NPC_MIND_BLAST] = 1,
    [Talents.T_NPC_FORGET] = 1,
    [Talents.T_NPC_DARKNESS] = 1,
    [Talents.T_NPC_BO_WATE] = 1,
    [Talents.T_NPC_BO_ICEE] = 1,
    [Talents.T_NPC_BO_MANA] = 1,
    [Talents.T_NPC_BO_COLD] = 1,
  },
  body = bodies.none,
  speed = 10,
  vision = 10,
  alertness = 40,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'MURK_DWELLER',
  name = [[Murk dweller]],
  display = 'S',
  color = colors.C_s,
  image = 'npc/murk_dweller.png',
  desc = [[A gigantic aquatic monster, somewhat resembling a cross between a lobster and a spider. It is coated in poisonous slime and noxious parasites. This foul creature hides in the silt of the deep ocean floor, waiting to trap unsuspecting prey.]],
  corpse_weight = 300,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 5,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 200, 5 },
  ac = 30,
  max_life = 1000,
  rarity = 3,
  level = 27,
  start_level = 27,
  exp_worth = 800,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.DARK] = true,
    [DamageType.OLD_SLEEP] = true,
  },
  vuln_dam = {
    [DamageType.LITE] = true,
    [DamageType.LITE_WEAK] = true,
  },
  flags = {
    ANIMAL = true,
    AQUATIC = true,
    BASEANGBAND = true,
    EVIL = true,
    FORCE_MAXHP = true,
    MORTAL = true,
    SMART = true,
    WEIRD_MIND = true,
  },
  placement_flags = {},
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.POISON, method=AttackType.BITE, dam={5,10} },
    { type=DamageType.PARALYZE, method=AttackType.CLAW },
    { type=DamageType.INSANITY, method=AttackType.STING, dam={5,10} },
    { type=DamageType.DISENCHANT, method=AttackType.STING },
  },
  resolvers.talents {
    [Talents.T_NPC_BA_POIS] = 1,
    [Talents.T_NPC_BR_DARK] = 1,
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_BR_POIS] = 1,
    [Talents.T_NPC_SLOW] = 1,
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_MIND_BLAST] = 1,
    [Talents.T_NPC_BRAIN_SMASH] = 1,
    [Talents.T_NPC_DARKNESS] = 1,
  },
  body = bodies.quadruped,
  speed = 0,
  vision = 70,
  alertness = 0,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'DROWNED_SOUL',
  name = [[Drowned soul]],
  display = 'G',
  color = colors.C_B,
  image = 'npc/drowned_soul.png',
  desc = [[A ghastly victim of drowning, forever doomed to wander the ocean waters looking for revenge.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 8,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 9, 8 },
  ac = 33,
  max_life = resolvers.dice(9, 8),
  rarity = 1,
  level = 11,
  start_level = 11,
  exp_worth = 30,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.FEAR] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    AQUATIC = true,
    BASEANGBAND = true,
    COLD_BLOOD = true,
    EMPTY_MIND = true,
    EVIL = true,
    INVISIBLE = true,
    NO_CUT = true,
    UNDEAD = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.BLIND, method=AttackType.TOUCH, dam={3,3} },
    { type=DamageType.POISON, method=AttackType.TOUCH, dam={2,4} },
    { type=DamageType.FEAR, method=AttackType.WAIL },
  },
  resolvers.talents {
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_HOLD] = 1,
    [Talents.T_NPC_CONF] = 1,
  },
  body = bodies.none,
  speed = 0,
  vision = 5,
  alertness = 50,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'TIGER_SHARK',
  name = [[Tiger shark]],
  display = '~',
  color = colors.C_g,
  image = 'npc/tiger_shark.png',
  desc = [[A small species of shark, although the teeth are still as deadly.]],
  corpse_weight = 300,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=25,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 10, 5 },
  ac = 32,
  max_life = resolvers.dice(10, 5),
  rarity = 1,
  level = 12,
  start_level = 12,
  exp_worth = 40,
  flags = {
    ANIMAL = true,
    AQUATIC = true,
    BASEANGBAND = true,
    MORTAL = true,
    STUPID = true,
  },
  placement_flags = {},
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={4,4} },
  },
  body = bodies.snake,
  speed = 10,
  vision = 100,
  alertness = 0,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'HAMMERHEAD_SHARK',
  name = [[Hammerhead shark]],
  display = '~',
  color = colors.C_g,
  image = 'npc/hammerhead_shark.png',
  desc = [[A hungry shark with a strange head.]],
  corpse_weight = 150,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 16, 10 },
  ac = 59,
  max_life = resolvers.dice(16, 10),
  rarity = 3,
  level = 16,
  start_level = 16,
  exp_worth = 40,
  flags = {
    ANIMAL = true,
    AQUATIC = true,
    BASEANGBAND = true,
    COLD_BLOOD = true,
    MORTAL = true,
  },
  placement_flags = { WILD_TOO=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={3,4} },
    { type=DamageType.PHYSICAL, method=AttackType.BUTT, dam={3,4} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={3,4} },
  },
  body = bodies.snake,
  speed = 5,
  vision = 20,
  alertness = 20,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'GREAT_WHITE_SHARK',
  name = [[Great white shark]],
  display = '~',
  color = colors.C_w,
  image = 'npc/great_white_shark.png',
  desc = [[A very large carnivorous fish.]],
  corpse_weight = 500,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 100, 6 },
  ac = 70,
  max_life = resolvers.dice(100, 6),
  rarity = 2,
  level = 24,
  start_level = 24,
  exp_worth = 250,
  flags = {
    ANIMAL = true,
    AQUATIC = true,
    BASEANGBAND = true,
    COLD_BLOOD = true,
    FORCE_SLEEP = true,
    MORTAL = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={4,6} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={4,6} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={4,6} },
  },
  body = bodies.snake,
  speed = 10,
  vision = 20,
  alertness = 20,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'AQUATIC_GOLEM',
  name = [[Aquatic golem]],
  display = 'g',
  color = colors.C_b,
  image = 'npc/aquatic_golem.png',
  desc = [[An ingenious gnomish invention -- a golem designed for underwater usage.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 25, 10 },
  ac = 75,
  max_life = resolvers.dice(25, 10),
  rarity = 1,
  level = 19,
  start_level = 19,
  exp_worth = 100,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.ELEC] = true,
    [DamageType.FEAR] = true,
    [DamageType.FIRE] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    AQUATIC = true,
    BASEANGBAND = true,
    COLD_BLOOD = true,
    EMPTY_MIND = true,
    NO_CUT = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={3,10} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={3,10} },
  },
  body = bodies.humanoid,
  speed = -10,
  vision = 35,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'AQUATIC_KOBOLD',
  name = [[Aquatic kobold]],
  display = 'k',
  color = colors.C_B,
  image = 'npc/aquatic_kobold.png',
  desc = [[Yes, your favourite denizen of evil also comes in an aquatic variety.]],
  corpse_weight = 150,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 13, 9 },
  ac = 30,
  max_life = resolvers.dice(13, 9),
  rarity = 1,
  level = 5,
  start_level = 5,
  exp_worth = 35,
  resist_dam = {
    [DamageType.POISON] = true,
  },
  flags = {
    AQUATIC = true,
    BASEANGBAND = true,
    EVIL = true,
    MORTAL = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ '90%' },
  drop = { treasure=0, combat=50, magic=0, tools=30, junk=20 },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,10} },
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 10,
  alertness = 15,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'WHITE_SHARK',
  name = [[White shark]],
  display = '~',
  color = colors.C_W,
  image = 'npc/white_shark.png',
  desc = [[A fast-moving hunter of the depths. When this creature moves, everybody in the water is in danger!]],
  corpse_weight = 300,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 30, 10 },
  ac = 50,
  max_life = resolvers.dice(30, 10),
  rarity = 1,
  level = 18,
  start_level = 18,
  exp_worth = 100,
  flags = {
    ANIMAL = true,
    AQUATIC = true,
    BASEANGBAND = true,
    COLD_BLOOD = true,
    MORTAL = true,
  },
  placement_flags = { WILD_TOO=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={3,5} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={3,5} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={3,5} },
  },
  body = bodies.snake,
  speed = 10,
  vision = 20,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'SCRAG',
  name = [[Scrag]],
  display = 'T',
  color = colors.C_B,
  image = 'npc/scrag.png',
  desc = [[A troll of the sea, he reeks of brine.]],
  corpse_weight = 500,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 40, 10 },
  ac = 50,
  max_life = 400,
  rarity = 1,
  level = 35,
  start_level = 35,
  exp_worth = 440,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.DARK] = true,
    [DamageType.POISON] = true,
    [DamageType.WATER] = true,
  },
  vuln_dam = {
    [DamageType.LITE] = true,
    [DamageType.LITE_WEAK] = true,
  },
  flags = {
    AQUATIC = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    EVIL = true,
    FORCE_MAXHP = true,
    FRIENDS = true,
    MALE = true,
    OPEN_DOOR = true,
    REGENERATE = true,
    TROLL = true,
  },
  placement_flags = { WILD_OCEAN=true, WILD_TOO=true },
  resolvers.mon_inven{ '60%' },
  drop = { treasure=0, combat=100, magic=0, tools=0, junk=0 },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,10} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,10} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={3,2} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={3,2} },
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 20,
  alertness = 50,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'STARGAZER',
  name = [[Stargazer]],
  display = '~',
  color = colors.C_y,
  image = 'npc/stargazer.png',
  desc = [[A giant fish shaped like a flounder. There are two enormous eyes occupying half of the creature's body.]],
  corpse_weight = 80,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=25,
    talent_in = 10,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 15, 9 },
  ac = 25,
  max_life = resolvers.dice(15, 9),
  rarity = 1,
  level = 21,
  start_level = 21,
  exp_worth = 60,
  flags = {
    ANIMAL = true,
    AQUATIC = true,
    BASEANGBAND = true,
    MORTAL = true,
    SMART = true,
  },
  placement_flags = {},
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PARALYZE, method=AttackType.GAZE },
  },
  resolvers.talents {
    [Talents.T_NPC_S_MONSTER] = 1,
  },
  body = bodies.snake,
  speed = -10,
  vision = 10,
  alertness = 30,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'ELDER_STARGAZER',
  name = [[Elder stargazer]],
  display = '~',
  color = colors.C_y,
  image = 'npc/elder_stargazer.png',
  desc = [[A stargazer a bit larger than average, covered with barnacles.]],
  corpse_weight = 100,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 10,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 20, 10 },
  ac = 25,
  max_life = resolvers.dice(20, 10),
  rarity = 1,
  level = 29,
  start_level = 29,
  exp_worth = 75,
  flags = {
    ANIMAL = true,
    AQUATIC = true,
    BASEANGBAND = true,
    MORTAL = true,
    SMART = true,
  },
  placement_flags = {},
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PARALYZE, method=AttackType.GAZE },
    { type=DamageType.CONFUSION, method=AttackType.GAZE },
  },
  resolvers.talents {
    [Talents.T_NPC_S_MONSTERS] = 1,
  },
  body = bodies.snake,
  speed = -10,
  vision = 15,
  alertness = 30,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'FLOUNDER',
  name = [[Flounder]],
  display = '~',
  color = colors.C_s,
  image = 'npc/flounder.png',
  desc = [[A flattened fish which is able to change body colouring for camouflage.]],
  corpse_weight = 70,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=25,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 10, 5 },
  ac = 25,
  max_life = resolvers.dice(10, 5),
  rarity = 1,
  level = 13,
  start_level = 13,
  exp_worth = 55,
  flags = {
    ANIMAL = true,
    AQUATIC = true,
    ATTR_CLEAR = true,
    BASEANGBAND = true,
    INVISIBLE = true,
    MORTAL = true,
  },
  placement_flags = {},
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={2,6} },
  },
  body = bodies.snake,
  speed = -10,
  vision = 5,
  alertness = 30,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'GIANT_TURTLE',
  name = [[Giant turtle]],
  display = 'R',
  color = colors.C_G,
  image = 'npc/giant_turtle.png',
  desc = [[A giant turtle with flippers, adapted for life in the ocean.]],
  corpse_weight = 300,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 5, 8 },
  ac = 14,
  max_life = resolvers.dice(5, 8),
  rarity = 1,
  level = 7,
  start_level = 7,
  exp_worth = 30,
  flags = {
    ANIMAL = true,
    AQUATIC = true,
    BASEANGBAND = true,
    MORTAL = true,
  },
  placement_flags = {},
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={2,2} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={2,2} },
  },
  body = bodies.quadruped,
  speed = 0,
  vision = 10,
  alertness = 30,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'BABY_DRAGON_TURTLE',
  name = [[Baby dragon turtle]],
  display = 'd',
  color = colors.C_W,
  multi_colors = { colors.C_y, colors.C_U },
  image = 'npc/baby_dragon_turtle.png',
  desc = [[A newly-hatched dragon turtle. It still hasn't grown a proper shell.]],
  corpse_weight = 2000,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 12,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 10, 10 },
  ac = 60,
  max_life = 100,
  rarity = 1,
  level = 9,
  start_level = 9,
  exp_worth = 35,
  resist_dam = {
    [DamageType.SOUND] = true,
  },
  flags = {
    AQUATIC = true,
    ATTR_MULTI = true,
    BASEANGBAND = true,
    DRAGON = true,
    EVIL = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ only_gold=true, '1d2', '60%' },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={1,3} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={1,3} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={1,5} },
  },
  resolvers.talents {
    [Talents.T_NPC_BR_SOUN] = 1,
  },
  body = bodies.dragon,
  speed = 0,
  vision = 20,
  alertness = 50,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'YOUNG_DRAGON_TURTLE',
  name = [[Young dragon turtle]],
  display = 'd',
  color = colors.C_W,
  multi_colors = { colors.C_y, colors.C_U },
  image = 'npc/young_dragon_turtle.png',
  desc = [[A dragon-like creature inhabiting lightless reaches of ocean caves. It has a long neck with a tiny head, and four massive flippers. It has a soft and flexible shell.]],
  corpse_weight = 8000,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 11,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 30, 10 },
  ac = 70,
  max_life = 300,
  rarity = 1,
  level = 31,
  start_level = 31,
  exp_worth = 700,
  flags = {
    AQUATIC = true,
    ATTR_MULTI = true,
    BASEANGBAND = true,
    DRAGON = true,
    EVIL = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ '3d2' },
  drop = { treasure=50, combat=50, magic=0, tools=0, junk=0 },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={2,6} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={2,6} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={2,8} },
  },
  resolvers.talents {
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_BR_SOUN] = 1,
  },
  body = bodies.dragon,
  speed = 0,
  vision = 20,
  alertness = 70,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'MATURE_DRAGON_TURTLE',
  name = [[Mature dragon turtle]],
  display = 'd',
  color = colors.C_W,
  multi_colors = { colors.C_y, colors.C_U },
  image = 'npc/mature_dragon_turtle.png',
  desc = [[A large dragon turtle, covered with a tough white shell.]],
  corpse_weight = 17000,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 9,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 50, 10 },
  ac = 80,
  max_life = 500,
  rarity = 1,
  level = 38,
  start_level = 38,
  exp_worth = 1500,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.OLD_SLEEP] = true,
  },
  flags = {
    AQUATIC = true,
    ATTR_MULTI = true,
    BASEANGBAND = true,
    DRAGON = true,
    EVIL = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    HAS_LITE = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ '4d2' },
  drop = { treasure=50, combat=50, magic=0, tools=0, junk=0 },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={2,10} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={2,10} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={4,10} },
  },
  resolvers.talents {
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_BR_SOUN] = 1,
  },
  body = bodies.dragon,
  speed = 0,
  vision = 20,
  alertness = 70,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'ANCIENT_DRAGON_TURTLE',
  name = [[Ancient dragon turtle]],
  display = 'D',
  color = colors.C_W,
  multi_colors = { colors.C_y, colors.C_U },
  image = 'npc/ancient_dragon_turtle.png',
  desc = [[A huge dragon turtle. You can see many barnacles covering its body.]],
  corpse_weight = 22000,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 9,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 70, 10 },
  ac = 90,
  max_life = 700,
  rarity = 1,
  level = 41,
  start_level = 41,
  exp_worth = 2500,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.OLD_SLEEP] = true,
  },
  flags = {
    AQUATIC = true,
    ATTR_MULTI = true,
    BASEANGBAND = true,
    DRAGON = true,
    EVIL = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    HAS_LITE = true,
    MOVE_BODY = true,
    POWERFUL = true,
    SMART = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ '1d2', '4d2' },
  drop = { treasure=50, combat=50, magic=0, tools=0, junk=0 },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={4,8} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={4,8} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={7,8} },
  },
  resolvers.talents {
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_BR_SOUN] = 1,
  },
  body = bodies.dragon,
  speed = 10,
  vision = 20,
  alertness = 80,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'FASTITOCALON',
  name = [[Fastitocalon]],
  display = 'D',
  color = colors.C_g,
  multi_colors = { colors.C_r, colors.C_d, colors.C_y },
  image = 'npc/fastitocalon.png',
  desc = [[A huge aquatic dragon-turtle, its shell is as large as a small island.]],
  corpse_weight = 25000,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 6,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 40, 100 },
  ac = 150,
  max_life = 4000,
  rarity = 3,
  level = 52,
  start_level = 52,
  exp_worth = 16000,
  resist_dam = {
    [DamageType.ACID] = true,
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.FEAR] = true,
    [DamageType.FIRE] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
    [DamageType.TELEPORT] = true,
  },
  flags = {
    AQUATIC = true,
    ATTR_MULTI = true,
    BASEANGBAND = true,
    DRAGON = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
  },
  placement_flags = { WILD_OCEAN=true, WILD_TOO=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={5,8} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={5,8} },
    { type=DamageType.POISON, method=AttackType.CRUSH, dam={3,10} },
    { type=DamageType.POISON, method=AttackType.CRUSH, dam={3,10} },
  },
  resolvers.talents {
    [Talents.T_NPC_BR_FIRE] = 1,
    [Talents.T_NPC_BR_ACID] = 1,
    [Talents.T_NPC_BR_SOUN] = 1,
    [Talents.T_NPC_BA_WATE] = 1,
  },
  body = bodies.dragon,
  speed = 10,
  vision = 25,
  alertness = 30,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'UNDEAD_STARGAZER',
  name = [[Undead stargazer]],
  display = '~',
  color = colors.C_y,
  image = 'npc/undead_stargazer.png',
  desc = [[A stargazer brought back from the dead under control of some unholy sorceror.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 10,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 18, 9 },
  ac = 25,
  max_life = resolvers.dice(18, 9),
  rarity = 1,
  level = 25,
  start_level = 25,
  exp_worth = 100,
  flags = {
    ANIMAL = true,
    AQUATIC = true,
    BASEANGBAND = true,
    INVISIBLE = true,
    NO_CUT = true,
    SMART = true,
    UNDEAD = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.PARALYZE, method=AttackType.GAZE },
    { type=DamageType.EXP_20, method=AttackType.GAZE },
  },
  resolvers.talents {
    [Talents.T_NPC_S_UNDEAD] = 1,
    [Talents.T_NPC_S_MONSTER] = 1,
  },
  body = bodies.snake,
  speed = -10,
  vision = 10,
  alertness = 30,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'KILLER_WHALE',
  name = [[Killer whale]],
  display = '~',
  color = colors.C_w,
  image = 'npc/killer_whale.png',
  desc = [[An almost beautiful, deadly beast.]],
  corpse_weight = 950,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 20, 50 },
  ac = 55,
  max_life = resolvers.dice(20, 50),
  rarity = 1,
  level = 25,
  start_level = 25,
  exp_worth = 85,
  flags = {
    ANIMAL = true,
    AQUATIC = true,
    BASEANGBAND = true,
    MORTAL = true,
  },
  placement_flags = { WILD_OCEAN=true, WILD_TOO=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={7,4} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={7,4} },
  },
  body = bodies.snake,
  speed = 10,
  vision = 12,
  alertness = 30,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'MERROW',
  name = [[Merrow]],
  display = 'O',
  color = colors.C_B,
  image = 'npc/merrow.png',
  desc = [[A great ogre of the sea, it is violent and stupid.]],
  corpse_weight = 230,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 30, 9 },
  ac = 33,
  max_life = resolvers.dice(30, 9),
  rarity = 2,
  level = 28,
  start_level = 28,
  exp_worth = 80,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.POISON] = true,
    [DamageType.WATER] = true,
  },
  flags = {
    AQUATIC = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    EVIL = true,
    FRIENDS = true,
    GIANT = true,
    HAS_LITE = true,
    MORTAL = true,
    OPEN_DOOR = true,
  },
  placement_flags = { WILD_OCEAN=true, WILD_TOO=true },
  resolvers.mon_inven{ '60%' },
  drop = { treasure=20, combat=70, magic=0, tools=10, junk=0 },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={3,8} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={3,8} },
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 20,
  alertness = 30,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'WATER_NAGA',
  name = [[Water naga]],
  display = 'n',
  color = colors.C_B,
  image = 'npc/water_naga.png',
  desc = [[A naga adapted to underwater life. She has a fish-like tail and a pair of gills.]],
  corpse_weight = 160,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 7,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 30, 10 },
  ac = 55,
  max_life = resolvers.dice(30, 10),
  rarity = 1,
  level = 24,
  start_level = 24,
  exp_worth = 60,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.OLD_SLEEP] = true,
  },
  flags = {
    AQUATIC = true,
    BASEANGBAND = true,
    EVIL = true,
    FEMALE = true,
    MORTAL = true,
    SMART = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ only_item=true, '2d2', '90%' },
  drop = { treasure=40, combat=0, magic=50, tools=10, junk=0 },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CRUSH, dam={2,8} },
    { type=DamageType.PHYSICAL, method=AttackType.CRUSH, dam={2,8} },
    { type=DamageType.POISON, method=AttackType.BITE, dam={1,8} },
    { type=DamageType.POISON, method=AttackType.BITE, dam={1,8} },
  },
  resolvers.talents {
    [Talents.T_NPC_DARKNESS] = 1,
    [Talents.T_NPC_CAUSE_3] = 1,
    [Talents.T_NPC_BO_ICEE] = 1,
  },
  body = bodies.snake,
  speed = 0,
  vision = 10,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'AQUATIC_HOUND',
  name = [[Aquatic hound]],
  display = 'Z',
  color = colors.C_B,
  image = 'npc/aquatic_hound.png',
  desc = [[A dog with a finned tail and large, muscular flippers for hind legs. It has a rubbery skin instead of fur.]],
  corpse_weight = 60,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 10,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 15, 5 },
  ac = 60,
  max_life = resolvers.dice(15, 5),
  rarity = 1,
  level = 20,
  start_level = 20,
  exp_worth = 200,
  flags = {
    ANIMAL = true,
    AQUATIC = true,
    BASEANGBAND = true,
    FRIENDS = true,
    MORTAL = true,
  },
  placement_flags = {},
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.CONFUSION, method=AttackType.BITE, dam={2,8} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={2,8} },
    { type=DamageType.POISON, method=AttackType.CLAW, dam={2,8} },
  },
  resolvers.talents {
    [Talents.T_NPC_BO_ICEE] = 1,
    [Talents.T_NPC_BO_WATE] = 1,
  },
  body = bodies.quadruped,
  speed = 0,
  vision = 60,
  alertness = 0,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'WATER_DEMON',
  name = [[Water demon]],
  display = 'U',
  color = colors.C_B,
  image = 'npc/water_demon.png',
  desc = [[A hideous scaled demon, it is a sleek form with many fins but no visible arms or legs. It has a toothed gaping maw, reminiscent of a caricature of a shark's jaws.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 8,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 35, 20 },
  ac = 50,
  max_life = 700,
  rarity = 1,
  level = 40,
  start_level = 40,
  exp_worth = 1000,
  resist_dam = {
    [DamageType.ACID] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.OLD_SLEEP] = true,
  },
  flags = {
    AQUATIC = true,
    BASEANGBAND = true,
    DEMON = true,
    EVIL = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    FRIENDS = true,
    HAS_LITE = true,
    POWERFUL = true,
    SMART = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ only_item=true, '60%' },
  drop = { treasure=20, combat=60, magic=20, tools=0, junk=0 },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={3,4} },
    { type=DamageType.POISON, method=AttackType.GAZE, dam={8,12} },
    { type=DamageType.INSANITY, method=AttackType.CLAW, dam={8,12} },
  },
  resolvers.talents {
    [Talents.T_NPC_BO_ICEE] = 1,
    [Talents.T_NPC_BA_WATE] = 1,
  },
  body = bodies.snake,
  speed = 0,
  vision = 30,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'IXITXACHITL',
  name = [[Ixitxachitl]],
  display = '~',
  color = colors.C_s,
  image = 'npc/ixitxachitl.png',
  desc = [[An intelligent devil-ray of the depths.]],
  corpse_weight = 160,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 12, 8 },
  ac = 30,
  max_life = resolvers.dice(12, 8),
  rarity = 1,
  level = 12,
  start_level = 12,
  exp_worth = 40,
  resist_dam = {
    [DamageType.POISON] = true,
  },
  flags = {
    ANIMAL = true,
    AQUATIC = true,
    BASEANGBAND = true,
    COLD_BLOOD = true,
    EVIL = true,
    MORTAL = true,
  },
  placement_flags = { WILD_TOO=true },
  attacks = {
    { type=DamageType.POISON, method=AttackType.STING, dam={2,5} },
    { type=DamageType.POISON, method=AttackType.STING, dam={2,5} },
  },
  body = bodies.snake,
  speed = 0,
  vision = 20,
  alertness = 20,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'IXITXACHITL_PRIEST',
  name = [[Ixitxachitl priest]],
  display = '~',
  color = colors.C_s,
  image = 'npc/ixitxachitl_priest.png',
  desc = [[A devil-ray of the depths, with priestly magic.]],
  corpse_weight = 160,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 6,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 10, 10 },
  ac = 40,
  max_life = resolvers.dice(10, 10),
  rarity = 1,
  level = 19,
  start_level = 19,
  exp_worth = 80,
  resist_dam = {
    [DamageType.POISON] = true,
  },
  flags = {
    ANIMAL = true,
    AQUATIC = true,
    BASEANGBAND = true,
    COLD_BLOOD = true,
    EVIL = true,
    MORTAL = true,
  },
  placement_flags = { WILD_TOO=true },
  attacks = {
    { type=DamageType.POISON, method=AttackType.STING, dam={2,7} },
    { type=DamageType.POISON, method=AttackType.STING, dam={2,7} },
  },
  resolvers.talents {
    [Talents.T_NPC_TELE_TO] = 1,
    [Talents.T_NPC_HEAL] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_CAUSE_2] = 1,
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_S_MONSTER] = 1,
  },
  body = bodies.snake,
  speed = 0,
  vision = 20,
  alertness = 20,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'VAMPIRIC_IXITXACHITL',
  name = [[Vampiric ixitxachitl]],
  display = '~',
  color = colors.C_D,
  image = 'npc/vampiric_ixitxachitl.png',
  desc = [[A devil-ray of the depths, with vampiric powers.]],
  corpse_weight = 180,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 6,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 15, 15 },
  ac = 50,
  max_life = resolvers.dice(15, 15),
  rarity = 1,
  level = 26,
  start_level = 26,
  exp_worth = 120,
  resist_dam = {
    [DamageType.NETHER] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    ANIMAL = true,
    AQUATIC = true,
    BASEANGBAND = true,
    COLD_BLOOD = true,
    EVIL = true,
  },
  placement_flags = { WILD_TOO=true },
  attacks = {
    { type=DamageType.POISON, method=AttackType.STING, dam={3,8} },
    { type=DamageType.EXP_40, method=AttackType.STING, dam={3,8} },
  },
  resolvers.talents {
    [Talents.T_NPC_HEAL] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_CAUSE_3] = 1,
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_FORGET] = 1,
    [Talents.T_NPC_HASTE] = 1,
  },
  body = bodies.snake,
  speed = 0,
  vision = 20,
  alertness = 20,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'CHILD_SPIRIT',
  name = [[Child spirit]],
  display = 'G',
  color = colors.C_W,
  image = 'npc/child_spirit.png',
  desc = [[A helpful spirit from beyond the grave.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 5, 5 },
  ac = 15,
  faction = 'friendlies',
  max_life = resolvers.dice(5, 5),
  rarity = 3,
  level = 5,
  start_level = 5,
  exp_worth = 0,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    COLD_BLOOD = true,
    INVISIBLE = true,
    NO_CUT = true,
    PASS_WALL = true,
    PET = true,
    SMART = true,
    UNDEAD = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.FEAR, method=AttackType.TOUCH },
    { type=DamageType.PHYSICAL, method=AttackType.TOUCH, dam={3,4} },
  },
  body = bodies.none,
  speed = 10,
  vision = 8,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'YOUNG_SPIRIT',
  name = [[Young spirit]],
  display = 'G',
  color = colors.C_W,
  image = 'npc/young_spirit.png',
  desc = [[A helpful spirit from beyond the grave.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 8, 8 },
  ac = 15,
  faction = 'friendlies',
  max_life = resolvers.dice(8, 8),
  rarity = 3,
  level = 10,
  start_level = 10,
  exp_worth = 0,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    COLD_BLOOD = true,
    INVISIBLE = true,
    NO_CUT = true,
    PASS_WALL = true,
    PET = true,
    SMART = true,
    UNDEAD = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.FEAR, method=AttackType.TOUCH },
    { type=DamageType.PHYSICAL, method=AttackType.TOUCH, dam={9,4} },
  },
  body = bodies.none,
  speed = 10,
  vision = 8,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'MATURE_SPIRIT',
  name = [[Mature spirit]],
  display = 'G',
  color = colors.C_W,
  image = 'npc/mature_spirit.png',
  desc = [[A helpful spirit from beyond the grave.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 16, 16 },
  ac = 15,
  faction = 'friendlies',
  max_life = resolvers.dice(16, 16),
  rarity = 3,
  level = 40,
  start_level = 40,
  exp_worth = 0,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    COLD_BLOOD = true,
    INVISIBLE = true,
    NO_CUT = true,
    PASS_WALL = true,
    PET = true,
    SMART = true,
    UNDEAD = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.FEAR, method=AttackType.TOUCH },
    { type=DamageType.PHYSICAL, method=AttackType.TOUCH, dam={18,4} },
  },
  on_melee_hit = util.black_breath_melee_hit,
  body = bodies.none,
  speed = 10,
  vision = 8,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'EXPERIENCED_SPIRIT',
  name = [[Experienced spirit]],
  display = 'G',
  color = colors.C_W,
  image = 'npc/experienced_spirit.png',
  desc = [[A helpful spirit from beyond the grave.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 18, 18 },
  ac = 15,
  faction = 'friendlies',
  max_life = resolvers.dice(18, 18),
  rarity = 3,
  level = 60,
  start_level = 60,
  exp_worth = 0,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    COLD_BLOOD = true,
    INVISIBLE = true,
    NO_CUT = true,
    PASS_WALL = true,
    PET = true,
    SMART = true,
    UNDEAD = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.FEAR, method=AttackType.TOUCH },
    { type=DamageType.PHYSICAL, method=AttackType.TOUCH, dam={20,4} },
  },
  on_melee_hit = util.black_breath_melee_hit,
  body = bodies.none,
  speed = 10,
  vision = 8,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'WISE_SPIRIT',
  name = [[Wise spirit]],
  display = 'G',
  color = colors.C_W,
  image = 'npc/wise_spirit.png',
  desc = [[A helpful spirit from beyond the grave.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 25, 25 },
  ac = 15,
  faction = 'friendlies',
  max_life = resolvers.dice(25, 25),
  rarity = 3,
  level = 90,
  start_level = 90,
  exp_worth = 0,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    COLD_BLOOD = true,
    INVISIBLE = true,
    NO_CUT = true,
    PASS_WALL = true,
    PET = true,
    SMART = true,
    UNDEAD = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.FEAR, method=AttackType.TOUCH },
    { type=DamageType.PHYSICAL, method=AttackType.TOUCH, dam={30,4} },
  },
  on_melee_hit = util.black_breath_melee_hit,
  body = bodies.none,
  speed = 10,
  vision = 8,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'FANGORN_THE_TREEBEARD_LORD_OF_THE_ENTS',
  name = [[Fangorn the Treebeard, Lord of the Ents]],
  display = '#',
  color = colors.C_G,
  image = 'npc/fangorn_the_treebeard_lord_of_the_ents.png',
  desc = [[The first being to awoke on Arda, apart from the Valar themselves.  He is the first, oldest, greatest and most respected of all the Ents:  and though he is slow to anger, he is a terrible foe when roused.]],
  corpse_weight = 600,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 50, 100 },
  ac = 120,
  faction = 'friendlies',
  max_life = 5000,
  rarity = 3,
  level = 52,
  start_level = 52,
  exp_worth = 15500,
  unique = 'FANGORN_THE_TREEBEARD_LORD_OF_THE_ENTS',
  resist_dam = {
    [DamageType.OLD_SLEEP] = true,
  },
  vuln_dam = {
    [DamageType.FIRE] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    CAN_SPEAK = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    GOOD = true,
    KILL_WALL = true,
    MOVE_BODY = true,
    NO_CUT = true,
    PET = true,
    SMART = true,
    TAKE_ITEM = true,
    UNIQUE = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, only_item=true, '4d2' },
  drop = { treasure=0, combat=50, magic=50, tools=0, junk=0 },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CRUSH, dam={13,13} },
    { type=DamageType.PHYSICAL, method=AttackType.CRUSH, dam={13,13} },
    { type=DamageType.PHYSICAL, method=AttackType.CRUSH, dam={13,13} },
    { type=DamageType.PHYSICAL, method=AttackType.CRUSH, dam={13,13} },
  },
  body = bodies.humanoid,
  speed = 10,
  vision = 30,
  alertness = 15,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'GANDALF_THE_GREY',
  name = [[Gandalf the Grey]],
  display = 'p',
  color = colors.C_s,
  image = 'npc/gandalf_the_grey.png',
  desc = [[The wizard who opposed Sauron and, in the end, was the only one of the Istari to succeed in his task. Gandalf is very wise and specialises in fire magic.]],
  corpse_weight = 160,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 2,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 49, 101 },
  ac = 100,
  faction = 'friendlies',
  max_life = 4949,
  rarity = 7,
  level = 60,
  start_level = 60,
  exp_worth = 35000,
  unique = 'GANDALF_THE_GREY',
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.ELEC] = true,
    [DamageType.FIRE] = true,
    [DamageType.POISON] = true,
    [DamageType.TELEPORT] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    CAN_SPEAK = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    GOOD = true,
    HAS_LITE = true,
    MALE = true,
    OPEN_DOOR = true,
    PET = true,
    REFLECTING = true,
    SMART = true,
    UNIQUE = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, only_item=true, '2d2', '3d2', '4d2' },
  drop = { treasure=0, combat=0, magic=100, tools=0, junk=0 },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.DISENCHANT, method=AttackType.HIT, dam={6,8} },
    { type=DamageType.DISENCHANT, method=AttackType.HIT, dam={6,8} },
    { type=DamageType.FEAR, method=AttackType.HIT, dam={5,5} },
    { type=DamageType.FEAR, method=AttackType.HIT, dam={5,5} },
  },
  resolvers.talents {
    [Talents.T_NPC_HEAL] = 1,
    [Talents.T_NPC_HASTE] = 1,
    [Talents.T_NPC_TPORT] = 1,
    [Talents.T_NPC_TELE_AWAY] = 1,
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_CAUSE_4] = 1,
    [Talents.T_NPC_BRAIN_SMASH] = 1,
    [Talents.T_NPC_FORGET] = 1,
    [Talents.T_NPC_TRAPS] = 1,
    [Talents.T_NPC_BA_FIRE] = 1,
    [Talents.T_NPC_BO_FIRE] = 1,
    [Talents.T_NPC_BO_PLAS] = 1,
    [Talents.T_NPC_BO_MANA] = 1,
    [Talents.T_NPC_CAUSE_4] = 1,
    [Talents.T_NPC_S_MONSTERS] = 1,
    [Talents.T_NPC_S_ANGEL] = 1,
    [Talents.T_NPC_S_DRAGON] = 1,
    [Talents.T_NPC_S_KIN] = 1,
  },
  body = bodies.humanoid,
  speed = 10,
  vision = 101,
  alertness = 0,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'NAR_THE_DWARF',
  name = [[Nar, the Dwarf]],
  display = 'h',
  color = colors.C_y,
  image = 'npc/nar_the_dwarf.png',
  desc = [[The friend and companion of the dwarven king Thrór, he went mad with grief after Thrór's death at the hands of Azog the Orc.  With torn beard and ragged clothes, he seems to have fixed on you as a convenient target to vent his anger.]],
  corpse_weight = 140,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 6,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 45, 10 },
  ac = 70,
  max_life = 450,
  rarity = 2,
  level = 17,
  start_level = 17,
  exp_worth = 250,
  unique = 'NAR_THE_DWARF',
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.FIRE] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    HAS_LITE = true,
    MALE = true,
    OPEN_DOOR = true,
    UNIQUE = true,
  },
  placement_flags = {},
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={3,5} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={3,5} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={3,5} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={3,5} },
  },
  resolvers.talents {
    [Talents.T_NPC_HEAL] = 1,
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_CAUSE_2] = 1,
    [Talents.T_NPC_MIND_BLAST] = 1,
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 25,
  alertness = 25,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'NOVICE_MINDCRAFTER_GRP',
  name = [[Novice mindcrafter]],
  display = 'p',
  color = colors.C_y,
  image = 'npc/novice_mindcrafter_grp.png',
  desc = [[A novice in the arts of mind over matter.]],
  corpse_weight = 90,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 12,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 6, 8 },
  ac = 10,
  max_life = resolvers.dice(6, 8),
  rarity = 1,
  level = 8,
  start_level = 8,
  exp_worth = 18,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.OLD_SLEEP] = true,
  },
  flags = {
    BASEANGBAND = true,
    FRIENDS = true,
    HAS_LITE = true,
    MORTAL = true,
    OPEN_DOOR = true,
  },
  placement_flags = { WILD_TOO=true },
  resolvers.mon_inven{ '60%' },
  drop = { treasure=0, combat=50, magic=0, tools=30, junk=20 },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,6} },
  },
  resolvers.talents {
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_SLOW] = 1,
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_SCARE] = 1,
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 20,
  alertness = 5,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'GREAT_SWAMP_WYRM',
  name = [[Great Swamp Wyrm]],
  display = 'D',
  color = colors.C_g,
  multi_colors = { colors.C_g, colors.C_G },
  image = 'npc/great_swamp_wyrm.png',
  desc = [[A truly enormous dragon with great powers.  The foul gases issuing from the beast nearly make you vomit; and while you may try to hold your breath as you fight it, it sees no reason to do likewise.]],
  corpse_weight = 19000,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 4,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 40, 100 },
  ac = 150,
  max_life = 4000,
  rarity = 2,
  level = 63,
  start_level = 63,
  exp_worth = 20000,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    ATTR_MULTI = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    DRAGON = true,
    EVIL = true,
    FLY = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    HAS_LITE = true,
    MOVE_BODY = true,
    POWERFUL = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, only_item=true, '2d2', '3d2', '4d2' },
  drop = { treasure=50, combat=50, magic=0, tools=0, junk=0 },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={4,12} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={4,12} },
    { type=DamageType.POISON, method=AttackType.BITE, dam={6,14} },
    { type=DamageType.POISON, method=AttackType.BITE, dam={6,14} },
  },
  resolvers.talents {
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_BR_POIS] = 1,
  },
  body = bodies.dragon,
  speed = 10,
  vision = 30,
  alertness = 80,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'GREAT_BILE_WYRM',
  name = [[Great Bile Wyrm]],
  display = 'D',
  color = colors.C_s,
  multi_colors = { colors.C_d, colors.C_D },
  image = 'npc/great_bile_wyrm.png',
  desc = [[A huge and very powerful dragon.  Great steaming pools of acid drip from its form onto the ground.  You shudder when you see the acid eating away the very stones of the dungeon - what could it do to you?]],
  corpse_weight = 19000,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 4,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 50, 100 },
  ac = 150,
  max_life = 5000,
  rarity = 2,
  level = 67,
  start_level = 67,
  exp_worth = 23000,
  resist_dam = {
    [DamageType.ACID] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.OLD_SLEEP] = true,
  },
  flags = {
    ATTR_MULTI = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    DRAGON = true,
    EVIL = true,
    FLY = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    HAS_LITE = true,
    MOVE_BODY = true,
    POWERFUL = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, only_item=true, '2d2', '3d2', '4d2' },
  drop = { treasure=50, combat=50, magic=0, tools=0, junk=0 },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={4,12} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={4,12} },
    { type=DamageType.ACID, method=AttackType.BITE, dam={6,14} },
    { type=DamageType.ACID, method=AttackType.BITE, dam={6,14} },
  },
  resolvers.talents {
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_BR_ACID] = 1,
  },
  body = bodies.dragon,
  speed = 10,
  vision = 30,
  alertness = 80,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'BLUE_FIREBIRD',
  name = [[Blue Firebird]],
  display = 'B',
  color = colors.C_B,
  image = 'npc/blue_firebird.png',
  desc = [[The ancestors of the Eagles of the Thunderlords, these are friendly funny flying creatures with power.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 10,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 4, 5 },
  ac = 15,
  faction = 'friendlies',
  max_life = resolvers.dice(4, 5),
  rarity = 3,
  level = 5,
  start_level = 5,
  exp_worth = 0,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.FIRE] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    FLY = true,
    GOOD = true,
    HAS_EGG = true,
    HAS_LITE = true,
    IMPRESED = true,
    MORTAL = true,
    PET = true,
    SMART = true,
  },
  placement_flags = {},
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={3,4} },
    { type=DamageType.FIRE, method=AttackType.CLAW, dam={5,4} },
  },
  resolvers.talents {
    [Talents.T_NPC_TELE_TO] = 1,
  },
  body = bodies.dragon,
  speed = 10,
  vision = 8,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'GREEN_FIREBIRD',
  name = [[Green Firebird]],
  display = 'B',
  color = colors.C_G,
  image = 'npc/green_firebird.png',
  desc = [[The ancestors of the Eagles of the Thunderlords, these are friendly funny flying creatures with power.]],
  corpse_weight = 11,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 10,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 4, 5 },
  ac = 15,
  faction = 'friendlies',
  max_life = resolvers.dice(4, 5),
  rarity = 3,
  level = 7,
  start_level = 7,
  exp_worth = 0,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.FIRE] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    FLY = true,
    GOOD = true,
    HAS_EGG = true,
    HAS_LITE = true,
    IMPRESED = true,
    MORTAL = true,
    PET = true,
    SMART = true,
  },
  placement_flags = {},
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={4,4} },
    { type=DamageType.FIRE, method=AttackType.CLAW, dam={5,4} },
  },
  resolvers.talents {
    [Talents.T_NPC_TELE_TO] = 1,
  },
  body = bodies.dragon,
  speed = 10,
  vision = 10,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'BROWN_FIREBIRD',
  name = [[Brown Firebird]],
  display = 'B',
  color = colors.C_u,
  image = 'npc/brown_firebird.png',
  desc = [[The ancestors of the Eagles of the Thunderlords, these are friendly funny flying creatures with power.]],
  corpse_weight = 12,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 10,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 5, 5 },
  ac = 15,
  faction = 'friendlies',
  max_life = resolvers.dice(5, 5),
  rarity = 3,
  level = 10,
  start_level = 10,
  exp_worth = 0,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.FIRE] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    FLY = true,
    GOOD = true,
    HAS_EGG = true,
    HAS_LITE = true,
    IMPRESED = true,
    MORTAL = true,
    PET = true,
    SMART = true,
  },
  placement_flags = {},
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={5,4} },
    { type=DamageType.FIRE, method=AttackType.CLAW, dam={7,4} },
  },
  resolvers.talents {
    [Talents.T_NPC_TELE_TO] = 1,
  },
  body = bodies.dragon,
  speed = 10,
  vision = 10,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'BRONZE_FIREBIRD',
  name = [[Bronze Firebird]],
  display = 'B',
  color = colors.C_U,
  image = 'npc/bronze_firebird.png',
  desc = [[The ancestors of the Eagles of the Thunderlords, these are friendly funny flying creatures with power.]],
  corpse_weight = 13,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 10,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 6, 5 },
  ac = 15,
  faction = 'friendlies',
  max_life = resolvers.dice(6, 5),
  rarity = 3,
  level = 13,
  start_level = 13,
  exp_worth = 0,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.FIRE] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    FLY = true,
    GOOD = true,
    HAS_EGG = true,
    HAS_LITE = true,
    IMPRESED = true,
    MORTAL = true,
    PET = true,
    SMART = true,
  },
  placement_flags = {},
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={6,4} },
    { type=DamageType.FIRE, method=AttackType.CLAW, dam={7,4} },
  },
  resolvers.talents {
    [Talents.T_NPC_TELE_TO] = 1,
  },
  body = bodies.dragon,
  speed = 10,
  vision = 15,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'GOLD_FIREBIRD',
  name = [[Gold Firebird]],
  display = 'B',
  color = colors.C_y,
  image = 'npc/gold_firebird.png',
  desc = [[The ancestors of the Eagles of the Thunderlords, these are friendly funny flying creatures with power.]],
  corpse_weight = 14,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 10,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 6, 5 },
  ac = 15,
  faction = 'friendlies',
  max_life = resolvers.dice(6, 5),
  rarity = 3,
  level = 15,
  start_level = 15,
  exp_worth = 0,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.FIRE] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    FLY = true,
    GOOD = true,
    HAS_EGG = true,
    HAS_LITE = true,
    IMPRESED = true,
    MORTAL = true,
    PET = true,
    SMART = true,
  },
  placement_flags = {},
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={6,4} },
    { type=DamageType.FIRE, method=AttackType.CLAW, dam={8,4} },
  },
  resolvers.talents {
    [Talents.T_NPC_TELE_TO] = 1,
  },
  body = bodies.dragon,
  speed = 10,
  vision = 20,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'HIGH_ELVEN_RANGER',
  name = [[High-elven ranger]],
  display = 'h',
  color = colors.C_G,
  image = 'npc/high_elven_ranger.png',
  desc = [[An elf cloaked in green wielding a longbow.]],
  corpse_weight = 140,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 2,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 50, 30 },
  ac = 70,
  faction = 'friendlies',
  max_life = resolvers.dice(50, 30),
  rarity = 3,
  level = 40,
  start_level = 40,
  exp_worth = 500,
  resist_dam = {
    [DamageType.ACID] = true,
    [DamageType.COLD] = true,
    [DamageType.NETHER] = true,
    [DamageType.WATER] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    FRIENDS = true,
    GOOD = true,
    HAS_LITE = true,
    MALE = true,
    MORTAL = true,
    OPEN_DOOR = true,
    PET = true,
    SMART = true,
  },
  placement_flags = {},
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={10,8} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={10,8} },
  },
  resolvers.talents {
    [Talents.T_NPC_ARROW_4] = 1,
  },
  body = bodies.humanoid,
  speed = 10,
  vision = 20,
  alertness = 0,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'UVATHA_THE_HORSEMAN',
  name = [[Uvatha the Horseman]],
  display = 'W',
  color = colors.C_D,
  image = 'npc/uvatha_the_horseman.png',
  desc = [[A tall black Ringwraith, he is a master of horsemanship. He longs to taste your blood.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 24, 100 },
  ac = 60,
  max_life = 2400,
  level = 40,
  start_level = 40,
  exp_worth = 10000,
  unique = 'UVATHA_THE_HORSEMAN',
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.DARK] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  vuln_dam = {
    [DamageType.LITE] = true,
    [DamageType.LITE_WEAK] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    COLD_BLOOD = true,
    EVIL = true,
    FORCE_MAXHP = true,
    MALE = true,
    MOVE_BODY = true,
    NAZGUL = true,
    NO_CUT = true,
    OPEN_DOOR = true,
    SPECIAL_GENE = true,
    UNDEAD = true,
    UNIQUE = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, only_item=true, '2d2' },
  drop = { treasure=30, combat=30, magic=30, tools=10, junk=0 },
  drop_special = obj_util.create_nazgul_ring,
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={6,6} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={6,6} },
    { type=DamageType.EXP_80, method=AttackType.HIT, dam={4,6} },
    { type=DamageType.EXP_80, method=AttackType.HIT, dam={4,6} },
  },
  on_melee_hit = util.black_breath_melee_hit,
  body = bodies.none,
  speed = 10,
  vision = 90,
  alertness = 10,
  resolvers.mon_global_speed(),
  -- BEGIN VERBATIM
  on_die_post = util.nazgul_die,
  -- END VERBATIM
}

newEntity {
  define_as = 'ADUNAPHEL_THE_QUIET',
  name = [[Adunaphel the Quiet]],
  display = 'W',
  color = colors.C_D,
  image = 'npc/adunaphel_the_quiet.png',
  desc = [[A sorceress in life, Adunaphel quickly fell under Sauron's sway and the power of the rings.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 3,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 27, 100 },
  ac = 60,
  max_life = 2700,
  rarity = 13,
  level = 43,
  start_level = 43,
  exp_worth = 13000,
  unique = 'ADUNAPHEL_THE_QUIET',
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.DARK] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  vuln_dam = {
    [DamageType.LITE] = true,
    [DamageType.LITE_WEAK] = true,
  },
  flags = {
    BASEANGBAND = true,
    COLD_BLOOD = true,
    EVIL = true,
    FEMALE = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    INVISIBLE = true,
    MOVE_BODY = true,
    NAZGUL = true,
    NO_CUT = true,
    PASS_WALL = true,
    UNDEAD = true,
    UNIQUE = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, only_item=true, '4d2' },
  drop = { treasure=30, combat=30, magic=30, tools=10, junk=0 },
  drop_special = obj_util.create_nazgul_ring,
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={6,6} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={6,6} },
    { type=DamageType.EXP_80, method=AttackType.TOUCH, dam={5,6} },
    { type=DamageType.EXP_80, method=AttackType.TOUCH, dam={5,6} },
  },
  on_melee_hit = util.black_breath_melee_hit,
  resolvers.talents {
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_HOLD] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_CAUSE_3] = 1,
    [Talents.T_NPC_FORGET] = 1,
    [Talents.T_NPC_BO_ACID] = 1,
    [Talents.T_NPC_BO_FIRE] = 1,
    [Talents.T_NPC_BO_COLD] = 1,
    [Talents.T_NPC_BO_NETH] = 1,
    [Talents.T_NPC_S_MONSTER] = 1,
  },
  body = bodies.humanoid,
  speed = 10,
  vision = 90,
  alertness = 10,
  resolvers.mon_global_speed(),
  -- BEGIN VERBATIM
  on_die_post = util.nazgul_die,
  -- END VERBATIM
}

newEntity {
  define_as = 'AKHORAHIL_THE_BLIND',
  name = [[Akhorahil the Blind]],
  display = 'W',
  color = colors.C_D,
  image = 'npc/akhorahil_the_blind.png',
  desc = [[A mighty sorcerer king, Akhorahil was blind in life. With powerful enchantments, he created jewelled eyes that enabled him to see better than any ordinary man ever could.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 3,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 30, 100 },
  ac = 70,
  max_life = 3000,
  rarity = 13,
  level = 45,
  start_level = 45,
  exp_worth = 15000,
  unique = 'AKHORAHIL_THE_BLIND',
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.DARK] = true,
    [DamageType.FIRE] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  vuln_dam = {
    [DamageType.LITE] = true,
    [DamageType.LITE_WEAK] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    COLD_BLOOD = true,
    EVIL = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    MALE = true,
    MOVE_BODY = true,
    NAZGUL = true,
    NO_CUT = true,
    OPEN_DOOR = true,
    UNDEAD = true,
    UNIQUE = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, only_item=true, '4d2' },
  drop = { treasure=30, combat=30, magic=30, tools=10, junk=0 },
  drop_special = obj_util.create_nazgul_ring,
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={7,6} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={7,6} },
    { type=DamageType.EXP_80, method=AttackType.GAZE, dam={6,6} },
    { type=DamageType.FEAR, method=AttackType.WAIL, dam={6,6} },
  },
  on_melee_hit = util.black_breath_melee_hit,
  resolvers.talents {
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_HOLD] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_CAUSE_3] = 1,
    [Talents.T_NPC_DARKNESS] = 1,
    [Talents.T_NPC_BO_FIRE] = 1,
    [Talents.T_NPC_BO_COLD] = 1,
    [Talents.T_NPC_BO_NETH] = 1,
    [Talents.T_NPC_S_MONSTERS] = 1,
  },
  body = bodies.humanoid,
  speed = 10,
  vision = 90,
  alertness = 10,
  resolvers.mon_global_speed(),
  -- BEGIN VERBATIM
  on_die_post = util.nazgul_die,
  -- END VERBATIM
}

newEntity {
  define_as = 'REN_THE_UNCLEAN',
  name = [[Ren the Unclean]],
  display = 'W',
  color = colors.C_D,
  image = 'npc/ren_the_unclean.png',
  desc = [[Ren was an insane eastern king who believed himself to be the son of a volcano god. At an early age his sanity was destroyed by a plague that wiped out his family, and he never recovered.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 3,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 35, 100 },
  ac = 70,
  max_life = 3500,
  rarity = 13,
  level = 48,
  start_level = 48,
  exp_worth = 18000,
  unique = 'REN_THE_UNCLEAN',
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.DARK] = true,
    [DamageType.FIRE] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  vuln_dam = {
    [DamageType.LITE] = true,
    [DamageType.LITE_WEAK] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    COLD_BLOOD = true,
    EVIL = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    INVISIBLE = true,
    MALE = true,
    MOVE_BODY = true,
    NAZGUL = true,
    NO_CUT = true,
    OPEN_DOOR = true,
    UNDEAD = true,
    UNIQUE = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, only_item=true, '4d2' },
  drop = { treasure=30, combat=30, magic=30, tools=10, junk=0 },
  drop_special = obj_util.create_nazgul_ring,
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={7,7} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={7,7} },
    { type=DamageType.EXP_80, method=AttackType.TOUCH, dam={6,7} },
    { type=DamageType.FEAR, method=AttackType.WAIL, dam={6,7} },
  },
  on_melee_hit = util.black_breath_melee_hit,
  resolvers.talents {
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_HOLD] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_CAUSE_3] = 1,
    [Talents.T_NPC_BO_FIRE] = 1,
    [Talents.T_NPC_BO_NETH] = 1,
    [Talents.T_NPC_BA_FIRE] = 1,
    [Talents.T_NPC_S_MONSTER] = 1,
  },
  body = bodies.humanoid,
  speed = 10,
  vision = 90,
  alertness = 10,
  resolvers.mon_global_speed(),
  -- BEGIN VERBATIM
  on_die_post = util.nazgul_die,
  -- END VERBATIM
}

newEntity {
  define_as = 'JI_INDUR_DAWNDEATH',
  name = [[Ji Indur Dawndeath]],
  display = 'W',
  color = colors.C_D,
  image = 'npc/ji_indur_dawndeath.png',
  desc = [[This Ringwraith was a weak-minded sorcerer-king who fell easily under Sauron's power.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 3,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 40, 100 },
  ac = 70,
  max_life = 4000,
  rarity = 13,
  level = 52,
  start_level = 52,
  exp_worth = 22000,
  unique = 'JI_INDUR_DAWNDEATH',
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.DARK] = true,
    [DamageType.FIRE] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  vuln_dam = {
    [DamageType.LITE] = true,
    [DamageType.LITE_WEAK] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    COLD_BLOOD = true,
    EVIL = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    INVISIBLE = true,
    MALE = true,
    MOVE_BODY = true,
    NAZGUL = true,
    NO_CUT = true,
    OPEN_DOOR = true,
    UNDEAD = true,
    UNIQUE = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, only_item=true, '4d2' },
  drop = { treasure=30, combat=30, magic=30, tools=10, junk=0 },
  drop_special = obj_util.create_nazgul_ring,
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={8,7} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={8,7} },
    { type=DamageType.EXP_40, method=AttackType.TOUCH, dam={6,7} },
    { type=DamageType.EXP_40, method=AttackType.TOUCH, dam={6,7} },
  },
  on_melee_hit = util.black_breath_melee_hit,
  resolvers.talents {
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_HOLD] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_CAUSE_3] = 1,
    [Talents.T_NPC_BA_FIRE] = 1,
    [Talents.T_NPC_BA_NETH] = 1,
    [Talents.T_NPC_BA_COLD] = 1,
    [Talents.T_NPC_BA_ELEC] = 1,
    [Talents.T_NPC_BA_ACID] = 1,
    [Talents.T_NPC_S_UNDEAD] = 1,
  },
  body = bodies.none,
  speed = 10,
  vision = 90,
  alertness = 10,
  resolvers.mon_global_speed(),
  -- BEGIN VERBATIM
  on_die_post = util.nazgul_die,
  -- END VERBATIM
}

newEntity {
  define_as = 'DWAR_DOG_LORD_OF_WAW',
  name = [[Dwar, Dog Lord of Waw]],
  display = 'W',
  color = colors.C_D,
  image = 'npc/dwar_dog_lord_of_waw.png',
  desc = [[Dwar had a special affinity for dogs in life, and can still command them at will. He howls manically as he reaches out to destroy you.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 3,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 45, 100 },
  ac = 90,
  max_life = 4500,
  rarity = 13,
  level = 56,
  start_level = 56,
  exp_worth = 25000,
  unique = 'DWAR_DOG_LORD_OF_WAW',
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.DARK] = true,
    [DamageType.FIRE] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  vuln_dam = {
    [DamageType.LITE] = true,
    [DamageType.LITE_WEAK] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    COLD_BLOOD = true,
    EVIL = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    MALE = true,
    MOVE_BODY = true,
    NAZGUL = true,
    NO_CUT = true,
    OPEN_DOOR = true,
    SMART = true,
    UNDEAD = true,
    UNIQUE = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, only_item=true, '4d2' },
  drop = { treasure=30, combat=30, magic=30, tools=10, junk=0 },
  drop_special = obj_util.create_nazgul_ring,
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={8,8} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={8,8} },
    { type=DamageType.EXP_40, method=AttackType.BITE, dam={6,7} },
    { type=DamageType.FEAR, method=AttackType.WAIL, dam={6,7} },
  },
  on_melee_hit = util.black_breath_melee_hit,
  resolvers.talents {
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_HOLD] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_CAUSE_3] = 1,
    [Talents.T_NPC_BA_FIRE] = 1,
    [Talents.T_NPC_BA_NETH] = 1,
    [Talents.T_NPC_S_MONSTERS] = 1,
    [Talents.T_NPC_S_UNDEAD] = 1,
    [Talents.T_NPC_S_HOUND] = 1,
  },
  body = bodies.quadruped,
  speed = 10,
  vision = 90,
  alertness = 10,
  resolvers.mon_global_speed(),
  -- BEGIN VERBATIM
  on_die_post = util.nazgul_die,
  -- END VERBATIM
}

newEntity {
  define_as = 'HOARMURATH_OF_DIR',
  name = [[Hoarmurath of Dir]],
  display = 'W',
  color = colors.C_D,
  image = 'npc/hoarmurath_of_dir.png',
  desc = [[A Ringwraith powerful in fell sorcery, he yearns for the life he has exchanged for an unlife of everlasting torment.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 3,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 60, 100 },
  ac = 100,
  max_life = 6000,
  rarity = 13,
  level = 64,
  start_level = 64,
  exp_worth = 30000,
  unique = 'HOARMURATH_OF_DIR',
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.DARK] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  vuln_dam = {
    [DamageType.LITE] = true,
    [DamageType.LITE_WEAK] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    COLD_BLOOD = true,
    EVIL = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    MALE = true,
    MOVE_BODY = true,
    NAZGUL = true,
    NO_CUT = true,
    OPEN_DOOR = true,
    SMART = true,
    UNDEAD = true,
    UNIQUE = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, only_item=true, '2d2', '4d2' },
  drop = { treasure=30, combat=30, magic=30, tools=10, junk=0 },
  drop_special = obj_util.create_nazgul_ring,
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={9,9} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={9,9} },
    { type=DamageType.EXP_80, method=AttackType.TOUCH, dam={6,7} },
    { type=DamageType.FEAR, method=AttackType.WAIL, dam={6,7} },
  },
  on_melee_hit = util.black_breath_melee_hit,
  resolvers.talents {
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_HOLD] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_CAUSE_3] = 1,
    [Talents.T_NPC_CAUSE_4] = 1,
    [Talents.T_NPC_MIND_BLAST] = 1,
    [Talents.T_NPC_BO_COLD] = 1,
    [Talents.T_NPC_BA_COLD] = 1,
    [Talents.T_NPC_BA_NETH] = 1,
    [Talents.T_NPC_S_UNDEAD] = 1,
  },
  body = bodies.none,
  speed = 20,
  vision = 90,
  alertness = 10,
  resolvers.mon_global_speed(),
  -- BEGIN VERBATIM
  on_die_post = util.nazgul_die,
  -- END VERBATIM
}

newEntity {
  define_as = 'KHAMUL_THE_BLACK_EASTERLING',
  name = [[Khamûl, the Black Easterling]],
  display = 'W',
  color = colors.C_D,
  image = 'npc/khamul_the_black_easterling.png',
  desc = [[He was the warrior-king of the East, now a Ringwraith. Khamûl is a powerful opponent, his skill in combat awesome and his form twisted by evil cunning.]],
  corpse_weight = 260,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 2,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 70, 100 },
  ac = 100,
  max_life = 7000,
  rarity = 13,
  level = 72,
  start_level = 72,
  exp_worth = 40000,
  unique = 'KHAMUL_THE_BLACK_EASTERLING',
  resist_dam = {
    [DamageType.ACID] = true,
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.DARK] = true,
    [DamageType.FIRE] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
    [DamageType.TELEPORT] = true,
  },
  vuln_dam = {
    [DamageType.LITE] = true,
    [DamageType.LITE_WEAK] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    CAN_SPEAK = true,
    COLD_BLOOD = true,
    EVIL = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    MALE = true,
    MOVE_BODY = true,
    NAZGUL = true,
    NO_CUT = true,
    OPEN_DOOR = true,
    SMART = true,
    UNDEAD = true,
    UNIQUE = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, only_item=true, '3d2', '4d2' },
  drop = { treasure=0, combat=100, magic=0, tools=0, junk=0 },
  drop_special = obj_util.create_nazgul_ring,
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={9,10} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={9,10} },
    { type=DamageType.EXP_80, method=AttackType.TOUCH, dam={7,7} },
    { type=DamageType.EXP_80, method=AttackType.TOUCH, dam={7,7} },
  },
  on_melee_hit = util.black_breath_melee_hit,
  resolvers.talents {
    [Talents.T_NPC_TELE_LEVEL] = 1,
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_HOLD] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_CAUSE_3] = 1,
    [Talents.T_NPC_CAUSE_4] = 1,
    [Talents.T_NPC_BO_MANA] = 1,
    [Talents.T_NPC_BA_FIRE] = 1,
    [Talents.T_NPC_BA_COLD] = 1,
    [Talents.T_NPC_BA_NETH] = 1,
    [Talents.T_NPC_ANIM_DEAD] = 1,
    [Talents.T_NPC_S_HI_UNDEAD] = 1,
    [Talents.T_NPC_S_KIN] = 1,
  },
  body = bodies.humanoid,
  speed = 20,
  vision = 90,
  alertness = 10,
  resolvers.mon_global_speed(),
  -- BEGIN VERBATIM
  on_die_post = util.nazgul_die,
  -- END VERBATIM
}

newEntity {
  define_as = 'THE_WITCH_KING_OF_ANGMAR',
  name = [[The Witch-King of Angmar]],
  display = 'W',
  color = colors.C_D,
  image = 'npc/the_witch_king_of_angmar.png',
  desc = [[The Chief of the Ringwraiths. A fell being of devastating power, his spells are lethal and his combat blows crushingly hard. He moves at speed, and commands legions of evil to do his bidding. It is said that he is fated never to die by the hand of mortal man.]],
  corpse_weight = 180,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 2,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 90, 100 },
  ac = 120,
  max_life = 9000,
  rarity = 14,
  level = 80,
  start_level = 80,
  exp_worth = 60000,
  unique = 'THE_WITCH_KING_OF_ANGMAR',
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.DARK] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
    [DamageType.TELEPORT] = true,
  },
  vuln_dam = {
    [DamageType.LITE] = true,
    [DamageType.LITE_WEAK] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    CAN_SPEAK = true,
    COLD_BLOOD = true,
    EVIL = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    MALE = true,
    MOVE_BODY = true,
    NAZGUL = true,
    NO_CUT = true,
    OPEN_DOOR = true,
    SMART = true,
    UNDEAD = true,
    UNIQUE = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, only_item=true, '3d2', '4d2' },
  drop = { treasure=30, combat=30, magic=30, tools=10, junk=0 },
  drop_special = obj_util.create_nazgul_ring,
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={10,10} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={10,10} },
    { type=DamageType.EXP_80, method=AttackType.HIT, dam={7,7} },
    { type=DamageType.EXP_80, method=AttackType.HIT, dam={7,7} },
  },
  on_melee_hit = util.black_breath_melee_hit,
  resolvers.talents {
    [Talents.T_NPC_TELE_AWAY] = 1,
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_HOLD] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_CAUSE_3] = 1,
    [Talents.T_NPC_BRAIN_SMASH] = 1,
    [Talents.T_NPC_BO_MANA] = 1,
    [Talents.T_NPC_BA_NETH] = 1,
    [Talents.T_NPC_S_WRAITH] = 1,
    [Talents.T_NPC_S_KIN] = 1,
    [Talents.T_NPC_S_HI_UNDEAD] = 1,
    [Talents.T_NPC_S_HI_DRAGON] = 1,
    [Talents.T_NPC_S_MONSTERS] = 1,
    [Talents.T_NPC_ANIM_DEAD] = 1,
  },
  body = bodies.humanoid,
  speed = 20,
  vision = 90,
  alertness = 10,
  resolvers.mon_global_speed(),
  -- BEGIN VERBATIM
  on_die_post = util.nazgul_die,
  -- END VERBATIM
}

newEntity {
  define_as = 'GREEN_THUNDERLORD',
  name = [[Green Thunderlord]],
  display = 'B',
  color = colors.C_g,
  image = 'npc/green_thunderlord.png',
  desc = [[A Thunderlord. Among the weaker breeds, but still dangerous.]],
  corpse_weight = 3000,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 4,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 50, 50 },
  ac = 100,
  max_life = resolvers.dice(50, 50),
  rarity = 4,
  level = 30,
  start_level = 30,
  exp_worth = 10000,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.FIRE] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.TELEPORT] = true,
  },
  flags = {
    BASH_DOOR = true,
    FEMALE = true,
    FLY = true,
    HAS_LITE = true,
    OPEN_DOOR = true,
    REGENERATE = true,
    THUNDERLORD = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, only_item=true, '1d2' },
  drop = { treasure=50, combat=50, magic=0, tools=0, junk=0 },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={8,6} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={8,6} },
  },
  resolvers.talents {
    [Talents.T_NPC_BR_FIRE] = 1,
    [Talents.T_NPC_BLINK] = 1,
    [Talents.T_NPC_TELE_AWAY] = 1,
  },
  body = bodies.humanoid,
  speed = 10,
  vision = 20,
  alertness = 50,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'BLUE_THUNDERLORD',
  name = [[Blue Thunderlord]],
  display = 'B',
  color = colors.C_b,
  image = 'npc/blue_thunderlord.png',
  desc = [[A Thunderlord. Among the weaker breeds, but still dangerous.]],
  corpse_weight = 3000,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 4,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 60, 60 },
  ac = 100,
  max_life = resolvers.dice(60, 60),
  rarity = 4,
  level = 40,
  start_level = 40,
  exp_worth = 20000,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.FIRE] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.TELEPORT] = true,
  },
  flags = {
    BASH_DOOR = true,
    FLY = true,
    HAS_LITE = true,
    MALE = true,
    OPEN_DOOR = true,
    REGENERATE = true,
    SMART = true,
    THUNDERLORD = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, only_item=true, '2d2' },
  drop = { treasure=50, combat=50, magic=0, tools=0, junk=0 },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={8,7} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={8,7} },
  },
  resolvers.talents {
    [Talents.T_NPC_BR_FIRE] = 1,
    [Talents.T_NPC_TPORT] = 1,
    [Talents.T_NPC_BLINK] = 1,
  },
  body = bodies.humanoid,
  speed = 10,
  vision = 20,
  alertness = 50,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'BROWN_THUNDERLORD',
  name = [[Brown Thunderlord]],
  display = 'B',
  color = colors.C_u,
  image = 'npc/brown_thunderlord.png',
  desc = [[A Thunderlord. Beware its flame.]],
  corpse_weight = 3000,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 4,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 70, 70 },
  ac = 100,
  max_life = resolvers.dice(70, 70),
  rarity = 4,
  level = 50,
  start_level = 50,
  exp_worth = 20000,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.FIRE] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.TELEPORT] = true,
  },
  flags = {
    BASH_DOOR = true,
    FLY = true,
    HAS_LITE = true,
    MALE = true,
    OPEN_DOOR = true,
    REGENERATE = true,
    SMART = true,
    THUNDERLORD = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, only_item=true, '2d2' },
  drop = { treasure=50, combat=50, magic=0, tools=0, junk=0 },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={8,9} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={8,9} },
  },
  resolvers.talents {
    [Talents.T_NPC_BR_FIRE] = 1,
    [Talents.T_NPC_TPORT] = 1,
    [Talents.T_NPC_BLINK] = 1,
  },
  body = bodies.humanoid,
  speed = 20,
  vision = 30,
  alertness = 50,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'BRONZE_THUNDERLORD',
  name = [[Bronze Thunderlord]],
  display = 'B',
  color = colors.C_U,
  image = 'npc/bronze_thunderlord.png',
  desc = [[A Thunderlord, mightiest among the males.]],
  corpse_weight = 3000,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 4,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 80, 80 },
  ac = 100,
  max_life = resolvers.dice(80, 80),
  rarity = 5,
  level = 60,
  start_level = 60,
  exp_worth = 20000,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.FIRE] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.TELEPORT] = true,
  },
  flags = {
    BASH_DOOR = true,
    FLY = true,
    HAS_LITE = true,
    MALE = true,
    OPEN_DOOR = true,
    REGENERATE = true,
    SMART = true,
    THUNDERLORD = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, only_item=true, '2d2' },
  drop = { treasure=50, combat=50, magic=0, tools=0, junk=0 },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={10,9} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={10,9} },
  },
  resolvers.talents {
    [Talents.T_NPC_BR_FIRE] = 1,
    [Talents.T_NPC_BR_TIME] = 1,
    [Talents.T_NPC_TPORT] = 1,
    [Talents.T_NPC_BLINK] = 1,
  },
  body = bodies.humanoid,
  speed = 20,
  vision = 30,
  alertness = 50,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'GOLD_THUNDERLORD',
  name = [[Gold Thunderlord]],
  display = 'B',
  color = colors.C_y,
  image = 'npc/gold_thunderlord.png',
  desc = [[A Thunderlord, among the queens of their kind.]],
  corpse_weight = 3000,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 4,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 90, 90 },
  ac = 100,
  max_life = resolvers.dice(90, 90),
  rarity = 5,
  level = 70,
  start_level = 70,
  exp_worth = 20000,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.FIRE] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.TELEPORT] = true,
  },
  flags = {
    BASH_DOOR = true,
    FEMALE = true,
    FLY = true,
    HAS_LITE = true,
    OPEN_DOOR = true,
    REGENERATE = true,
    SMART = true,
    THUNDERLORD = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, only_item=true, '2d2' },
  drop = { treasure=50, combat=50, magic=0, tools=0, junk=0 },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={10,9} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={10,9} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={10,9} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={10,9} },
  },
  resolvers.talents {
    [Talents.T_NPC_BR_FIRE] = 1,
    [Talents.T_NPC_BR_TIME] = 1,
    [Talents.T_NPC_TPORT] = 1,
    [Talents.T_NPC_BLINK] = 1,
    [Talents.T_NPC_TELE_TO] = 1,
    [Talents.T_NPC_TELE_AWAY] = 1,
    [Talents.T_NPC_S_THUNDERLORD] = 1,
  },
  body = bodies.humanoid,
  speed = 20,
  vision = 30,
  alertness = 50,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'BLOOD_SPROUT',
  name = [[Blood Sprout]],
  display = ',',
  color = colors.C_g,
  image = 'npc/blood_sprout.png',
  desc = [[A kind of giant mycorrhiza, corrupted into a carnivore by Morgoth.]],
  corpse_weight = 5,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 3, 5 },
  ac = 1,
  max_life = resolvers.dice(3, 5),
  rarity = 1,
  level = 50,
  start_level = 50,
  exp_worth = 3,
  resist_dam = {
    [DamageType.ACID] = true,
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.ELEC] = true,
    [DamageType.FEAR] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    EMPTY_MIND = true,
    KILL_TREES = true,
    MORTAL = true,
    MULTIPLY = true,
    STUPID = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.TOUCH, dam={3,15} },
    { type=DamageType.PHYSICAL, method=AttackType.TOUCH, dam={3,15} },
    { type=DamageType.PHYSICAL, method=AttackType.TOUCH, dam={3,15} },
    { type=DamageType.PHYSICAL, method=AttackType.TOUCH, dam={3,15} },
  },
  body = bodies.none,
  speed = 30,
  vision = 10,
  alertness = 0,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'GORLIM_BETRAYER_OF_BARAHIR',
  name = [[Gorlim, Betrayer of Barahir]],
  display = 'p',
  color = colors.C_s,
  image = 'npc/gorlim_betrayer_of_barahir.png',
  desc = [[This sad creature - once a mighty warrior - betrayed his former friends to Morgoth's army in return for, he thought, safety for himself and his wife. And so he fell under Morgoth's power and became little more than a mindless servant of evil, even though the other side of his "bargain" was not kept.]],
  corpse_weight = 180,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 2,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 16, 100 },
  ac = 120,
  max_life = 1600,
  rarity = 3,
  level = 41,
  start_level = 41,
  exp_worth = 7000,
  unique = 'GORLIM_BETRAYER_OF_BARAHIR',
  resist_dam = {
    [DamageType.ACID] = true,
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.ELEC] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    HAS_LITE = true,
    MALE = true,
    OPEN_DOOR = true,
    SMART = true,
    UNIQUE = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, only_item=true, '2d2' },
  drop = { treasure=20, combat=80, magic=0, tools=0, junk=0 },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={8,6} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={8,6} },
    { type=DamageType.DISENCHANT, method=AttackType.HIT, dam={6,8} },
    { type=DamageType.DISENCHANT, method=AttackType.HIT, dam={6,8} },
  },
  resolvers.talents {
    [Talents.T_NPC_CAUSE_3] = 1,
    [Talents.T_NPC_BO_WATE] = 1,
    [Talents.T_NPC_BO_MANA] = 1,
  },
  body = bodies.humanoid,
  speed = 10,
  vision = 20,
  alertness = 40,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'ARANEA',
  name = [[Aranea]],
  display = 'S',
  color = colors.C_r,
  image = 'npc/aranea.png',
  desc = [[A red arachnid with legs weaving spells in the air.]],
  corpse_weight = 100,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 4,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 20, 10 },
  ac = 45,
  max_life = 200,
  rarity = 2,
  level = 30,
  start_level = 30,
  exp_worth = 250,
  resist_dam = {
    [DamageType.DARK] = true,
    [DamageType.POISON] = true,
  },
  vuln_dam = {
    [DamageType.LITE] = true,
    [DamageType.LITE_WEAK] = true,
  },
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    EVIL = true,
    FORCE_MAXHP = true,
    FRIENDS = true,
    OPEN_DOOR = true,
    SPIDER = true,
  },
  placement_flags = {},
  drop_corpse = { skeleton=true },
  attacks = {
    { type=DamageType.POISON, method=AttackType.CLAW, dam={2,8} },
    { type=DamageType.POISON, method=AttackType.CLAW, dam={2,8} },
    { type=DamageType.POISON, method=AttackType.BITE, dam={2,6} },
    { type=DamageType.POISON, method=AttackType.BITE, dam={2,6} },
  },
  resolvers.talents {
    [Talents.T_NPC_BO_FIRE] = 1,
    [Talents.T_NPC_SLOW] = 1,
    [Talents.T_NPC_HOLD] = 1,
    [Talents.T_NPC_CAUSE_3] = 1,
    [Talents.T_NPC_MISSILE] = 1,
  },
  body = bodies.quadruped,
  speed = 10,
  vision = 20,
  alertness = 50,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'ELDER_ARANEA',
  name = [[Elder aranea]],
  display = 'S',
  color = colors.C_v,
  image = 'npc/elder_aranea.png',
  desc = [[A vast, bloated arachnid, master of its brood: among the more terrible of Ungoliant's descendants, this is a monster such as those who haunted the dread valley of Nan Dungortheb long ago.]],
  corpse_weight = 180,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 6,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 30, 20 },
  ac = 65,
  max_life = 600,
  rarity = 3,
  level = 40,
  start_level = 40,
  exp_worth = 2500,
  resist_dam = {
    [DamageType.DARK] = true,
    [DamageType.FIRE] = true,
    [DamageType.POISON] = true,
  },
  vuln_dam = {
    [DamageType.LITE] = true,
    [DamageType.LITE_WEAK] = true,
  },
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    EVIL = true,
    FORCE_MAXHP = true,
    OPEN_DOOR = true,
    SMART = true,
    SPIDER = true,
  },
  placement_flags = {},
  drop_corpse = { skeleton=true },
  attacks = {
    { type=DamageType.POISON, method=AttackType.CLAW, dam={5,8} },
    { type=DamageType.POISON, method=AttackType.CLAW, dam={5,8} },
    { type=DamageType.HALLUCINATION, method=AttackType.BITE, dam={5,6} },
    { type=DamageType.HALLUCINATION, method=AttackType.BITE, dam={5,6} },
  },
  resolvers.talents {
    [Talents.T_NPC_SLOW] = 1,
    [Talents.T_NPC_HOLD] = 1,
    [Talents.T_NPC_DRAIN_MANA] = 1,
    [Talents.T_NPC_MIND_BLAST] = 1,
    [Talents.T_NPC_HEAL] = 1,
    [Talents.T_NPC_BA_FIRE] = 1,
    [Talents.T_NPC_BO_FIRE] = 1,
    [Talents.T_NPC_CAUSE_3] = 1,
    [Talents.T_NPC_S_SPIDER] = 1,
  },
  body = bodies.quadruped,
  speed = 10,
  vision = 20,
  alertness = 50,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'GIANT_BROWN_TICK',
  name = [[Giant brown tick]],
  display = 'S',
  color = colors.C_u,
  image = 'npc/giant_brown_tick.png',
  desc = [[It is moving slowly towards you.]],
  corpse_weight = 40,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 16, 8 },
  ac = 50,
  max_life = resolvers.dice(16, 8),
  rarity = 2,
  level = 25,
  start_level = 25,
  exp_worth = 27,
  resist_dam = {
    [DamageType.POISON] = true,
  },
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    FLY = true,
    MORTAL = true,
    WEIRD_MIND = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.POISON, method=AttackType.BITE, dam={2,6} },
    { type=DamageType.BLIND, method=AttackType.STING, dam={1,1} },
  },
  body = bodies.quadruped,
  speed = 0,
  vision = 12,
  alertness = 20,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'WAVELORD',
  name = [[Wavelord]],
  display = 'p',
  color = colors.C_b,
  image = 'npc/wavelord.png',
  desc = [[The Dolphiners came with the Thunderlords from their far home. These friendly beings ride their sharks into combat to assist you.]],
  corpse_weight = 180,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 4,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 16, 100 },
  ac = 120,
  faction = 'friendlies',
  max_life = resolvers.dice(16, 100),
  rarity = 3,
  level = 61,
  start_level = 61,
  exp_worth = 7000,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.FEAR] = true,
    [DamageType.NEXUS] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
    [DamageType.WATER] = true,
  },
  vuln_dam = {
    [DamageType.FIRE] = true,
  },
  flags = {
    AQUATIC = true,
    CAN_SWIM = true,
    FRIENDS = true,
    GOOD = true,
    HAS_LITE = true,
    MORTAL = true,
    PET = true,
    REGENERATE = true,
    SMART = true,
    TAKE_ITEM = true,
  },
  placement_flags = { WILD_OCEAN=true, WILD_SHORE=true, WILD_TOO=true },
  resolvers.mon_inven{ good=true, useful=true, '3d2' },
  drop = { treasure=20, combat=50, magic=10, tools=5, junk=15 },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={8,9} },
    { type=DamageType.COLD, method=AttackType.HIT, dam={8,9} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={8,9} },
    { type=DamageType.COLD, method=AttackType.HIT, dam={8,9} },
  },
  resolvers.talents {
    [Talents.T_NPC_BO_WATE] = 1,
    [Talents.T_NPC_BA_WATE] = 1,
    [Talents.T_NPC_BO_ICEE] = 1,
  },
  body = bodies.humanoid,
  speed = 10,
  vision = 30,
  alertness = 40,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'NOVICE_POSSESSOR_SOUL_',
  name = [[Novice possessor (soul)]],
  plural_name = [[Novice possessors (soul)]],
  display = 'G',
  color = colors.C_D,
  image = 'npc/novice_possessor_soul_.png',
  desc = [[It does not look that powerful.]],
  corpse_weight = 1,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 1, 1 },
  ac = 1,
  max_life = resolvers.dice(1, 1),
  rarity = 3,
  level = 10,
  start_level = 10,
  exp_worth = 0,
  flags = {
    BASEANGBAND = true,
    NO_CUT = true,
    POSSESSOR = true,
    SMART = true,
  },
  placement_flags = {},
  body = bodies.none,
  speed = 0,
  vision = 30,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'BAT_OF_GORGOROTH',
  name = [[Bat of Gorgoroth]],
  display = 'b',
  color = colors.C_g,
  image = 'npc/bat_of_gorgoroth.png',
  desc = [[Fed with horrid meats and grown to enormous size, this slavering creature seeks livelier prey.]],
  corpse_weight = 15,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=25,
    talent_in = 8,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 20, 10 },
  ac = 30,
  max_life = resolvers.dice(20, 10),
  rarity = 3,
  level = 28,
  start_level = 28,
  exp_worth = 100,
  resist_dam = {
    [DamageType.POISON] = true,
  },
  flags = {
    AI_ANNOY = true,
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    FLY = true,
    FRIENDS = true,
    MORTAL = true,
    MOVE_BODY = true,
    WEIRD_MIND = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ '60%' },
  drop = { treasure=0, combat=0, magic=0, tools=0, junk=100 },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.POISON, method=AttackType.BITE, dam={1,10} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={1,4} },
  },
  resolvers.talents {
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_BR_POIS] = 1,
    [Talents.T_NPC_BR_DARK] = 1,
  },
  body = bodies.winged,
  speed = 10,
  vision = 20,
  alertness = 30,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'THE_PRINCESS',
  name = [[The Princess]],
  display = 'p',
  color = colors.C_y,
  image = 'npc/the_princess.png',
  desc = [[The princess of an unknown kingdom, you need to save her!]],
  corpse_weight = 73,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 1, 1 },
  ac = 250,
  faction = 'quest_givers',
  max_life = 1,
  level = 0,
  start_level = 0,
  exp_worth = 0,
  unique = 'THE_PRINCESS',
  resist_dam = {
    [DamageType.TELEPORT] = true,
  },
  flags = {
    BASEANGBAND = true,
    CAN_SPEAK = true,
    FEMALE = true,
    FORCE_MAXHP = true,
    GOOD = true,
    MORTAL = true,
    NEVER_BLOW = true,
    NEVER_MOVE = true,
    NO_DEATH = true,
    NO_TARGET = true,
    PET = true,
    SPECIAL_GENE = true,
    UNIQUE = true,
  },
  placement_flags = {},
  body = { MAIN_HAND=0, OFF_HAND=1, BODY=1, CLOAK=1, LAUNCHER=0, QUIVER=1, GLOVES=1, BOOTS=1, HELM=1, RING=2, AMULET=1, LITE=1, TOOL=1, SYMBIOTE=1, INVEN=23 },
  speed = 0,
  vision = 40,
  alertness = 3,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'MERTON_PROUDFOOT_THE_LOST_HOBBIT',
  name = [[Merton Proudfoot, the lost hobbit]],
  display = 'h',
  color = colors.C_v,
  image = 'npc/merton_proudfoot_the_lost_hobbit.png',
  desc = [[The poor hobbit got lost in the dreadful maze!]],
  corpse_weight = 73,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 1, 1 },
  ac = 250,
  faction = 'quest_givers',
  max_life = 1,
  level = 1,
  start_level = 1,
  exp_worth = 0,
  unique = 'MERTON_PROUDFOOT_THE_LOST_HOBBIT',
  flags = {
    BASEANGBAND = true,
    CAN_SPEAK = true,
    FORCE_MAXHP = true,
    GOOD = true,
    MALE = true,
    MORTAL = true,
    NEVER_BLOW = true,
    NEVER_MOVE = true,
    NO_DEATH = true,
    NO_TARGET = true,
    PET = true,
    SPECIAL_GENE = true,
    UNIQUE = true,
  },
  placement_flags = {},
  body = { MAIN_HAND=0, OFF_HAND=1, BODY=1, CLOAK=1, LAUNCHER=0, QUIVER=1, GLOVES=1, BOOTS=1, HELM=1, RING=2, AMULET=1, LITE=1, TOOL=1, SYMBIOTE=1, INVEN=23 },
  speed = 0,
  vision = 40,
  alertness = 3,
  resolvers.mon_global_speed(),
  -- BEGIN VERBATIM
  can_talk = 'merton-proudfoot',
  -- END VERBATIM
}

newEntity {
  define_as = 'THE_WIGHT_KING_OF_THE_BARROW_DOWNS',
  name = [[The Wight-King of the Barrow-downs]],
  display = 'W',
  color = colors.C_v,
  image = 'npc/the_wight_king_of_the_barrow_downs.png',
  desc = [[He has lived in the Barrow-Downs for centuries after his first death at the hands of the Witch-King of Angmar.  A once loyal captain under the Witch-King's command, he now awaits a time when his undead forces shall rise again to avenge their deaths.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 4,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 38, 22 },
  ac = 45,
  max_life = 836,
  level = 46,
  start_level = 46,
  exp_worth = 22000,
  unique = 'THE_WIGHT_KING_OF_THE_BARROW_DOWNS',
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.DARK] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  vuln_dam = {
    [DamageType.LITE] = true,
    [DamageType.LITE_WEAK] = true,
  },
  flags = {
    BASEANGBAND = true,
    CAN_SPEAK = true,
    CAN_SWIM = true,
    COLD_BLOOD = true,
    EVIL = true,
    FLY = true,
    FORCE_MAXHP = true,
    NO_CUT = true,
    SMART = true,
    SPECIAL_GENE = true,
    UNDEAD = true,
    UNIQUE = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ '2d2', '4d2' },
  drop = { treasure=15, combat=55, magic=15, tools=0, junk=15 },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={2,10} },
    { type=DamageType.PARALYZE, method=AttackType.WAIL, dam={2,6} },
    { type=DamageType.EXP_80, method=AttackType.TOUCH, dam={4,8} },
    { type=DamageType.EXP_80, method=AttackType.TOUCH, dam={4,8} },
  },
  on_melee_hit = util.black_breath_melee_hit,
  resolvers.talents {
    [Talents.T_NPC_HOLD] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_CAUSE_3] = 1,
    [Talents.T_NPC_BA_NETH] = 1,
  },
  body = bodies.none,
  speed = 10,
  vision = 30,
  alertness = 0,
  resolvers.mon_global_speed(),
  -- BEGIN VERBATIM
  drop_special = function(self)
    -- Build the Filthy Rag of the Wight.
    local o = game.zone:makeEntityByName(game.level, 'object', 'FILTHY_RAG', false)
    if o then
      local DamageType = require 'engine.DamageType'
      o.artifact_name = 'of the Wight'
      o.convey_flags = { SEE_INVIS=true }
      o.stat_flags = { INT=true }
      o.pval_flags = { skill_searching=true }
      o.convey_resist_dam = { [DamageType.BLIND]=true, [DamageType.CONFUSION]=true }
      o.convey_vuln_dam = { [DamageType.FIRE]=true }
      o.flags = { CURSED=true, HEAVY_CURSE=true }
      o.ignore_dam = { [DamageType.ACID]=true, [DamageType.ELEC]=true, [DamageType.FIRE]=true, [DamageType.COLD]=true }
      if rng.chance(2) then
	o.pval_flags.spellpower = true
	o.pval = 6
      else
	o.pval_flags.mana_mult = true
	o.pval = 2
      end
    end
    return o
  end,
  -- END VERBATIM
}

newEntity {
  define_as = 'ADVENTURER',
  name = [[Adventurer]],
  display = '@',
  color = colors.C_U,
  image = 'npc/adventurer.png',
  desc = [[A great warrior.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 3, 20 },
  ac = 50,
  max_life = 60,
  level = 0,
  start_level = 0,
  exp_worth = 0,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.OLD_SLEEP] = true,
  },
  flags = {
    BASEANGBAND = true,
    CAN_SWIM = true,
    FORCE_MAXHP = true,
    OPEN_DOOR = true,
    SMART = true,
    SPECIAL_GENE = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={2,6} },
    { type=DamageType.PHYSICAL, method=AttackType.PUNCH, dam={1,7} },
    { type=DamageType.PHYSICAL, method=AttackType.KICK, dam={1,8} },
  },
  speed = 5,
  vision = 50,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'EXPERIENCED_POSSESSOR_SOUL_',
  name = [[Experienced possessor (soul)]],
  plural_name = [[Experienced possessors (soul)]],
  display = 'G',
  color = colors.C_D,
  image = 'npc/experienced_possessor_soul_.png',
  desc = [[It does not look that powerful.]],
  corpse_weight = 1,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 9,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 5, 5 },
  ac = 50,
  max_life = resolvers.dice(5, 5),
  rarity = 3,
  level = 30,
  start_level = 30,
  exp_worth = 0,
  flags = {
    BASEANGBAND = true,
    NO_CUT = true,
    POSSESSOR = true,
    SMART = true,
  },
  placement_flags = {},
  resolvers.talents {
    [Talents.T_NPC_S_KIN] = 1,
  },
  speed = 10,
  vision = 30,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'OLD_POSSESSOR_SOUL_',
  name = [[Old possessor (soul)]],
  plural_name = [[Old possessors (soul)]],
  display = 'G',
  color = colors.C_D,
  image = 'npc/old_possessor_soul_.png',
  desc = [[It does not look that powerful.]],
  corpse_weight = 1,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 4,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 10, 10 },
  ac = 100,
  max_life = resolvers.dice(10, 10),
  rarity = 3,
  level = 95,
  start_level = 95,
  exp_worth = 0,
  flags = {
    BASEANGBAND = true,
    NO_CUT = true,
    POSSESSOR = true,
    SMART = true,
  },
  placement_flags = {},
  resolvers.talents {
    [Talents.T_NPC_S_KIN] = 1,
  },
  speed = 20,
  vision = 30,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'BRONZE_DRAGON_WORM',
  name = [[Bronze dragon worm]],
  display = 'w',
  color = colors.C_U,
  multi_colors = { colors.C_U, colors.C_u },
  image = 'npc/bronze_dragon_worm.png',
  desc = [[You thought dragons used eggs, but this worm has the scales, and the bad breath, and the fiery eyes, of a real dragon. Its scales glitter in a multitude of perplexing and distracting ways.]],
  corpse_weight = 450,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=75,
    talent_in = 6,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 10, 15 },
  ac = 40,
  max_life = resolvers.dice(10, 15),
  rarity = 3,
  level = 20,
  start_level = 20,
  exp_worth = 12,
  resist_dam = {
    [DamageType.CONFUSION] = true,
  },
  flags = {
    ATTR_MULTI = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    DRAGON = true,
    EVIL = true,
    MORTAL = true,
    MULTIPLY = true,
    OPEN_DOOR = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ only_gold=true, '60%' },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={3,3} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={3,3} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={3,5} },
  },
  resolvers.talents {
    [Talents.T_NPC_BR_CONF] = 1,
  },
  body = bodies.snake,
  speed = -10,
  vision = 10,
  alertness = 80,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'GOLD_DRAGON_WORM',
  name = [[Gold dragon worm]],
  display = 'w',
  color = colors.C_y,
  multi_colors = { colors.C_y, colors.C_U },
  image = 'npc/gold_dragon_worm.png',
  desc = [[You thought dragons used eggs, but this worm has the scales, and the bad breath, and the fiery eyes, of a real dragon. You can feel the air itself vibrating as you near it.]],
  corpse_weight = 450,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=75,
    talent_in = 6,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 10, 15 },
  ac = 40,
  max_life = resolvers.dice(10, 15),
  rarity = 3,
  level = 20,
  start_level = 20,
  exp_worth = 12,
  resist_dam = {
    [DamageType.SOUND] = true,
  },
  flags = {
    ATTR_MULTI = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    DRAGON = true,
    EVIL = true,
    MORTAL = true,
    MULTIPLY = true,
    NO_STUN = true,
    OPEN_DOOR = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ only_gold=true, '60%' },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={3,3} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={3,3} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={3,5} },
  },
  resolvers.talents {
    [Talents.T_NPC_BR_SOUN] = 1,
  },
  body = bodies.snake,
  speed = -10,
  vision = 10,
  alertness = 80,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'AR_PHARAZON_THE_GOLDEN',
  name = [[Ar-Pharazôn the Golden]],
  display = 'p',
  color = colors.C_y,
  image = 'npc/ar_pharazon_the_golden.png',
  desc = [[Last and proudest king of ancient Númenor. Corrupted by power and avarice, he fell victim to Sauron's wiles, tried to fight the immortals themselves, and condemned Númenor to oblivion.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 6,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 50, 100 },
  ac = 45,
  max_life = 5000,
  level = 55,
  start_level = 55,
  exp_worth = 2500,
  unique = 'AR_PHARAZON_THE_GOLDEN',
  flags = {
    AQUATIC = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    CAN_SPEAK = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    HAS_LITE = true,
    MOVE_BODY = true,
    OPEN_DOOR = true,
    SMART = true,
    SPECIAL_GENE = true,
    TAKE_ITEM = true,
    UNIQUE = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, only_item=true, '1d2', '2d2' },
  drop = { treasure=20, combat=70, magic=10, tools=0, junk=0 },
  drop_corpse = { corpse=true, skeleton=true },
  drop_special = function(self) return game.zone:makeEntityByName(game.level, 'artifact', 'TORIS_MEJISTOS', false) end,
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={8,12} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={8,12} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={8,12} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={8,12} },
  },
  resolvers.talents {
    [Talents.T_NPC_HEAL] = 1,
    [Talents.T_NPC_HASTE] = 1,
    [Talents.T_NPC_TELE_AWAY] = 1,
    [Talents.T_NPC_S_MONSTERS] = 1,
    [Talents.T_NPC_S_KIN] = 1,
  },
  body = bodies.humanoid,
  speed = 20,
  vision = 30,
  alertness = 255,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'DOPPELGANGER',
  name = [[Doppelganger]],
  display = '@',
  color = colors.C_w,
  image = 'npc/doppelganger.png',
  desc = [[It looks like you...]],
  corpse_weight = 0,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 1, 1 },
  ac = 1,
  max_life = resolvers.dice(1, 1),
  flags = {
    BASEANGBAND = true,
    DOPPLEGANGER = true,
    HAS_LITE = true,
    NEVER_BLOW = true,
    NEVER_MOVE = true,
    SPECIAL_GENE = true,
  },
  placement_flags = {},
  body = bodies.none,
  speed = 0,
  vision = 1,
  alertness = 1,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'BULLROARER_THE_HOBBIT',
  name = [[Bullroarer the Hobbit]],
  display = 'h',
  color = colors.C_U,
  image = 'npc/bullroarer_the_hobbit.png',
  desc = [[He is a sturdy hobbit who is renowned for his unusual strength and vigour. He can prove a troublesome opponent.]],
  corpse_weight = 100,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 6, 10 },
  ac = 8,
  max_life = 60,
  rarity = 3,
  level = 5,
  start_level = 5,
  exp_worth = 90,
  unique = 'BULLROARER_THE_HOBBIT',
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    CAN_SPEAK = true,
    FORCE_MAXHP = true,
    HAS_LITE = true,
    MALE = true,
    MORTAL = true,
    OPEN_DOOR = true,
    UNIQUE = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, only_item=true, '2d2' },
  drop = { treasure=25, combat=55, magic=0, tools=20, junk=0 },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,8} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,8} },
  },
  body = bodies.humanoid,
  speed = 10,
  vision = 16,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = '3_HEADED_HYDRA',
  name = [[3-headed hydra]],
  display = 'M',
  color = colors.C_o,
  image = 'npc/3_headed_hydra.png',
  desc = [[A strange reptilian creature with three heads, guarding its hoard.]],
  corpse_weight = 450,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 9,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 100, 5 },
  ac = 65,
  max_life = resolvers.dice(100, 5),
  rarity = 2,
  level = 20,
  start_level = 20,
  exp_worth = 350,
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    CAN_SWIM = true,
    FORCE_SLEEP = true,
    MORTAL = true,
    MOVE_BODY = true,
    OPEN_DOOR = true,
  },
  placement_flags = { WILD_SHORE=true, WILD_SWAMP=true, WILD_TOO=true },
  resolvers.mon_inven{ only_gold=true, '2d2' },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={2,6} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={2,6} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={2,6} },
  },
  resolvers.talents {
    [Talents.T_NPC_SCARE] = 1,
  },
  body = bodies.hydra,
  speed = 10,
  vision = 20,
  alertness = 20,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'ULDOR_THE_ACCURSED',
  name = [[Uldor the Accursed]],
  display = 'p',
  color = colors.C_U,
  image = 'npc/uldor_the_accursed.png',
  desc = [[An evil and cunning man from the East.  Having once sworn allegiance to the sons of Fëanor, it was Uldor's treachery that turned the tide of the Battle of Unnumbered Tears in Morgoth's favour.]],
  corpse_weight = 200,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 10,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 10, 100 },
  ac = 70,
  max_life = 1000,
  rarity = 4,
  level = 28,
  start_level = 28,
  exp_worth = 600,
  unique = 'ULDOR_THE_ACCURSED',
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    CAN_SPEAK = true,
    EVIL = true,
    FORCE_MAXHP = true,
    HAS_LITE = true,
    MALE = true,
    MORTAL = true,
    OPEN_DOOR = true,
    TAKE_ITEM = true,
    UNIQUE = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, only_item=true, '1d2' },
  drop = { treasure=10, combat=90, magic=0, tools=0, junk=0 },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={4,6} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={4,6} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={4,6} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={4,6} },
  },
  resolvers.talents {
    [Talents.T_NPC_S_KIN] = 1,
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 20,
  alertness = 40,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'MYSTIC',
  name = [[Mystic]],
  display = 'p',
  color = colors.C_o,
  image = 'npc/mystic.png',
  desc = [[An adept at unarmed combat, the mystic strikes with stunning power. He can summon help from nature and is able to focus his power to ease any pain.]],
  corpse_weight = 140,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 6,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 35, 10 },
  ac = 50,
  max_life = 350,
  rarity = 3,
  level = 33,
  start_level = 33,
  exp_worth = 500,
  resist_dam = {
    [DamageType.ACID] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    HAS_LITE = true,
    INVISIBLE = true,
    MALE = true,
    MORTAL = true,
    OPEN_DOOR = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ only_item=true, '1d2' },
  drop = { treasure=30, combat=0, magic=60, tools=10, junk=0 },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.KICK, dam={10,2} },
    { type=DamageType.PHYSICAL, method=AttackType.KICK, dam={10,2} },
    { type=DamageType.PHYSICAL, method=AttackType.KICK, dam={10,2} },
    { type=DamageType.PHYSICAL, method=AttackType.KICK, dam={10,2} },
  },
  resolvers.talents {
    [Talents.T_NPC_HEAL] = 1,
    [Talents.T_NPC_S_SPIDER] = 1,
    [Talents.T_NPC_S_ANIMAL] = 1,
  },
  body = bodies.humanoid,
  speed = 10,
  vision = 30,
  alertness = 5,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'ELDER_VAMPIRE',
  name = [[Elder vampire]],
  display = 'V',
  color = colors.C_r,
  image = 'npc/elder_vampire.png',
  desc = [[A terrible robed undead figure, this creature has existed in its unlife for many centuries by stealing the life of others. It can summon the very shades of its victims from beyond the grave to come enslaved to its aid.]],
  corpse_weight = 170,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 7,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 34, 100 },
  ac = 90,
  max_life = 3400,
  rarity = 3,
  level = 54,
  start_level = 54,
  exp_worth = 4500,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.DARK] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
    [DamageType.TELEPORT] = true,
  },
  vuln_dam = {
    [DamageType.LITE] = true,
    [DamageType.LITE_WEAK] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    COLD_BLOOD = true,
    EVIL = true,
    FLY = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    NO_CUT = true,
    OPEN_DOOR = true,
    REGENERATE = true,
    UNDEAD = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, '4d2', '60%' },
  drop = { treasure=0, combat=70, magic=30, tools=0, junk=0 },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={4,6} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={4,6} },
    { type=DamageType.EXP_80, method=AttackType.BITE, dam={5,6} },
    { type=DamageType.EXP_80, method=AttackType.BITE, dam={5,6} },
  },
  on_melee_hit = util.black_breath_melee_hit,
  resolvers.talents {
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_HOLD] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_CAUSE_3] = 1,
    [Talents.T_NPC_CAUSE_4] = 1,
    [Talents.T_NPC_DRAIN_MANA] = 1,
    [Talents.T_NPC_BRAIN_SMASH] = 1,
    [Talents.T_NPC_DARKNESS] = 1,
    [Talents.T_NPC_BO_NETH] = 1,
    [Talents.T_NPC_S_UNDEAD] = 1,
  },
  body = bodies.humanoid,
  speed = 10,
  vision = 20,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'ULFANG_THE_BLACK',
  name = [[Ulfang the Black]],
  display = 'p',
  color = colors.C_U,
  image = 'npc/ulfang_the_black.png',
  desc = [[A short and swarthy Easterling dressed in black.  He and his three sons once openly swore allegiance to the High Elves, but were secretly in the pay of Morgoth.]],
  corpse_weight = 210,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 10,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 25, 100 },
  ac = 90,
  max_life = 2500,
  level = 44,
  start_level = 44,
  exp_worth = 1200,
  unique = 'ULFANG_THE_BLACK',
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.ELEC] = true,
    [DamageType.FIRE] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    CAN_SPEAK = true,
    EVIL = true,
    FORCE_MAXHP = true,
    HAS_LITE = true,
    MALE = true,
    MORTAL = true,
    OPEN_DOOR = true,
    SPECIAL_GENE = true,
    TAKE_ITEM = true,
    UNIQUE = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, only_item=true, randart=true, '2d2' },
  drop = { treasure=10, combat=90, magic=0, tools=0, junk=0 },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={5,8} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={5,8} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={5,8} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={5,8} },
  },
  resolvers.talents {
    [Talents.T_NPC_S_KIN] = 1,
    [Talents.T_NPC_S_MONSTERS] = 1,
  },
  body = bodies.humanoid,
  speed = 10,
  vision = 20,
  alertness = 40,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'DEMONOLOGIST',
  name = [[Demonologist]],
  display = 'p',
  color = colors.C_R,
  image = 'npc/demonologist.png',
  desc = [[A figure twisted by evil standing in robes of deepest crimson.]],
  corpse_weight = 110,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 2,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 28, 10 },
  ac = 50,
  max_life = 280,
  rarity = 2,
  level = 36,
  start_level = 36,
  exp_worth = 700,
  resist_dam = {
    [DamageType.NETHER] = true,
    [DamageType.NEXUS] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    EVIL = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    HAS_LITE = true,
    MALE = true,
    MORTAL = true,
    OPEN_DOOR = true,
    SMART = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ only_item=true, '1d2' },
  drop = { treasure=0, combat=0, magic=100, tools=0, junk=0 },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={2,6} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={2,6} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={2,6} },
  },
  resolvers.talents {
    [Talents.T_NPC_TPORT] = 1,
    [Talents.T_NPC_HOLD] = 1,
    [Talents.T_NPC_S_DEMON] = 1,
    [Talents.T_NPC_BO_FIRE] = 1,
  },
  body = bodies.humanoid,
  speed = 10,
  vision = 20,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'HEZROU',
  name = [[Hezrou]],
  display = 'U',
  color = colors.C_g,
  image = 'npc/hezrou.png',
  desc = [[It is a demon of lizard form with cruel-looking jaws.]],
  corpse_weight = 210,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 9,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 52, 10 },
  ac = 40,
  max_life = 520,
  rarity = 3,
  level = 41,
  start_level = 41,
  exp_worth = 2500,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.FIRE] = true,
    [DamageType.OLD_SLEEP] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    DEMON = true,
    EVIL = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    FRIENDS = true,
    NONLIVING = true,
    OPEN_DOOR = true,
    POWERFUL = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ only_item=true, '2d2' },
  drop = { treasure=0, combat=50, magic=50, tools=0, junk=0 },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={3,4} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={3,4} },
  },
  resolvers.talents {
    [Talents.T_NPC_BO_FIRE] = 1,
    [Talents.T_NPC_S_DEMON] = 1,
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 20,
  alertness = 80,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'GLABREZU',
  name = [[Glabrezu]],
  self_plural = true,
  display = 'U',
  color = colors.C_U,
  image = 'npc/glabrezu.png',
  desc = [[It is a demon with arms and pincers, its form a true mockery of life.]],
  corpse_weight = 230,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 9,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 70, 10 },
  ac = 40,
  max_life = 700,
  rarity = 2,
  level = 43,
  start_level = 43,
  exp_worth = 3000,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.FIRE] = true,
    [DamageType.OLD_SLEEP] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    DEMON = true,
    EVIL = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    NONLIVING = true,
    OPEN_DOOR = true,
    POWERFUL = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ only_item=true, '90%' },
  drop = { treasure=0, combat=50, magic=50, tools=0, junk=0 },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={3,4} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={3,4} },
  },
  resolvers.talents {
    [Talents.T_NPC_BO_FIRE] = 1,
    [Talents.T_NPC_S_DEMON] = 1,
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 20,
  alertness = 80,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'NALFESHNEE',
  name = [[Nalfeshnee]],
  display = 'U',
  color = colors.C_r,
  image = 'npc/nalfeshnee.png',
  desc = [[It is a large demon with the head of a giant boar. Flames run up and down its length.]],
  corpse_weight = 600,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 9,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 90, 10 },
  ac = 50,
  max_life = 900,
  rarity = 2,
  level = 45,
  start_level = 45,
  exp_worth = 5000,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.FIRE] = true,
    [DamageType.OLD_SLEEP] = true,
  },
  melee_retal = {
    [DamageType.FIRE] = 'mondam',
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    DEMON = true,
    EVIL = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    NONLIVING = true,
    OPEN_DOOR = true,
    POWERFUL = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ only_item=true, '1d2' },
  drop = { treasure=0, combat=50, magic=50, tools=0, junk=0 },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={3,4} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={3,4} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={3,4} },
  },
  resolvers.talents {
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_BR_FIRE] = 1,
    [Talents.T_NPC_S_DEMON] = 1,
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 20,
  alertness = 80,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'MARILITH',
  name = [[Marilith]],
  display = 'U',
  color = colors.C_y,
  image = 'npc/marilith.png',
  desc = [[She is a demon of female form with many arms, each bearing deadly weapons.]],
  corpse_weight = 300,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 9,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 20, 70 },
  ac = 75,
  max_life = 1400,
  rarity = 2,
  level = 47,
  start_level = 47,
  exp_worth = 7000,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.FIRE] = true,
    [DamageType.OLD_SLEEP] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    DEMON = true,
    EVIL = true,
    FEMALE = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    NONLIVING = true,
    OPEN_DOOR = true,
    POWERFUL = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ only_item=true, '1d2' },
  drop = { treasure=0, combat=50, magic=50, tools=0, junk=0 },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={3,6} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={3,6} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={3,6} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={3,6} },
  },
  resolvers.talents {
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_CAUSE_2] = 1,
    [Talents.T_NPC_S_DEMON] = 1,
  },
  body = { MAIN_HAND=3, OFF_HAND=3, BODY=0, CLOAK=0, LAUNCHER=1, QUIVER=0, GLOVES=3, BOOTS=0, HELM=1, RING=4, AMULET=1, LITE=0, TOOL=1, SYMBIOTE=0, INVEN=23 },
  speed = 10,
  vision = 20,
  alertness = 80,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'LESSER_BALROG',
  name = [[Lesser Balrog]],
  display = 'U',
  color = colors.C_v,
  image = 'npc/lesser_balrog.png',
  desc = [[It is a massive humanoid demon wreathed in flames.]],
  corpse_weight = 900,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 4,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 20, 100 },
  ac = 50,
  max_life = 2000,
  rarity = 2,
  level = 49,
  start_level = 49,
  exp_worth = 10000,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.FIRE] = true,
    [DamageType.OLD_SLEEP] = true,
  },
  melee_retal = {
    [DamageType.FIRE] = 'mondam',
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    DEMON = true,
    EVIL = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    HAS_LITE = true,
    KILL_WALL = true,
    MOVE_BODY = true,
    NONLIVING = true,
    OPEN_DOOR = true,
    POWERFUL = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, only_item=true, '1d2', '2d2' },
  drop = { treasure=0, combat=50, magic=50, tools=0, junk=0 },
  attacks = {
    { type=DamageType.FIRE, method=AttackType.HIT, dam={4,12} },
    { type=DamageType.FIRE, method=AttackType.HIT, dam={4,12} },
    { type=DamageType.PHYSICAL, method=AttackType.CRUSH, dam={3,12} },
    { type=DamageType.UN_POWER, method=AttackType.TOUCH },
  },
  resolvers.talents {
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_BR_FIRE] = 1,
    [Talents.T_NPC_S_DEMON] = 1,
  },
  body = bodies.humanoid,
  speed = 10,
  vision = 20,
  alertness = 80,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'MASTER_MYSTIC',
  name = [[Master mystic]],
  display = 'p',
  color = colors.C_o,
  image = 'npc/master_mystic.png',
  desc = [[A lord of all that is natural, skilled in the mystic ways. He is a master of martial arts and is at one with nature, able to summon help from the wild if need be.]],
  corpse_weight = 160,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 3,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 11, 100 },
  ac = 60,
  max_life = 1100,
  rarity = 3,
  level = 50,
  start_level = 50,
  exp_worth = 6000,
  resist_dam = {
    [DamageType.ACID] = true,
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.ELEC] = true,
    [DamageType.FIRE] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    HAS_LITE = true,
    INVISIBLE = true,
    MALE = true,
    MORTAL = true,
    OPEN_DOOR = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ only_item=true, '1d2', '2d2' },
  drop = { treasure=40, combat=0, magic=40, tools=20, junk=0 },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.KICK, dam={10,2} },
    { type=DamageType.PHYSICAL, method=AttackType.KICK, dam={10,2} },
    { type=DamageType.POISON, method=AttackType.HIT, dam={20,1} },
    { type=DamageType.PARALYZE, method=AttackType.HIT, dam={15,1} },
  },
  resolvers.talents {
    [Talents.T_NPC_HEAL] = 1,
    [Talents.T_NPC_S_SPIDER] = 1,
    [Talents.T_NPC_S_ANIMALS] = 1,
  },
  body = bodies.humanoid,
  speed = 20,
  vision = 30,
  alertness = 5,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'GRAND_MASTER_MYSTIC',
  name = [[Grand master mystic]],
  display = 'p',
  color = colors.C_o,
  image = 'npc/grand_master_mystic.png',
  desc = [[He is one of the few true masters of the art, being extremely skillful in all forms of unarmed combat and controlling the world's natural creatures with disdainful ease.]],
  corpse_weight = 180,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 2,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 22, 100 },
  ac = 80,
  max_life = 2200,
  rarity = 3,
  level = 57,
  start_level = 57,
  exp_worth = 15000,
  resist_dam = {
    [DamageType.ACID] = true,
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.ELEC] = true,
    [DamageType.FIRE] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    HAS_LITE = true,
    INVISIBLE = true,
    MALE = true,
    MORTAL = true,
    OPEN_DOOR = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ only_item=true, '4d2' },
  drop = { treasure=40, combat=0, magic=40, tools=20, junk=0 },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.KICK, dam={20,2} },
    { type=DamageType.PHYSICAL, method=AttackType.KICK, dam={10,2} },
    { type=DamageType.POISON, method=AttackType.HIT, dam={20,1} },
    { type=DamageType.PARALYZE, method=AttackType.HIT, dam={15,1} },
  },
  resolvers.talents {
    [Talents.T_NPC_HEAL] = 1,
    [Talents.T_NPC_MIND_BLAST] = 1,
    [Talents.T_NPC_S_SPIDER] = 1,
    [Talents.T_NPC_S_HOUND] = 1,
    [Talents.T_NPC_S_ANIMALS] = 1,
  },
  body = bodies.humanoid,
  speed = 20,
  vision = 30,
  alertness = 5,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'ERINYES',
  name = [[Erinys]],
  plural_name = [[Erinyes]],
  display = 'U',
  color = colors.C_u,
  image = 'npc/erinyes.png',
  desc = [[It is a lesser demon of female form; however, she takes little time to show her true colours.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 7,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 24, 10 },
  ac = 50,
  max_life = 240,
  rarity = 2,
  level = 38,
  start_level = 38,
  exp_worth = 1000,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.FIRE] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    DEMON = true,
    EVIL = true,
    FEMALE = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    OPEN_DOOR = true,
    POWERFUL = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ only_item=true, '60%' },
  drop = { treasure=0, combat=50, magic=50, tools=0, junk=0 },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={3,4} },
    { type=DamageType.LOSE_STR, method=AttackType.TOUCH, dam={1,5} },
  },
  resolvers.talents {
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_BO_FIRE] = 1,
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 20,
  alertness = 80,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'NOVICE_MINDCRAFTER',
  name = [[Novice mindcrafter]],
  display = 'p',
  color = colors.C_y,
  image = 'npc/novice_mindcrafter.png',
  desc = [[A novice in the arts of mind over matter.]],
  corpse_weight = 90,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 9,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 6, 8 },
  ac = 10,
  max_life = resolvers.dice(6, 8),
  rarity = 1,
  level = 4,
  start_level = 4,
  exp_worth = 18,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.OLD_SLEEP] = true,
  },
  flags = {
    BASEANGBAND = true,
    HAS_LITE = true,
    MORTAL = true,
    OPEN_DOOR = true,
  },
  placement_flags = { WILD_TOO=true },
  resolvers.mon_inven{ '60%' },
  drop = { treasure=0, combat=50, magic=0, tools=30, junk=20 },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,6} },
  },
  resolvers.talents {
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_SLOW] = 1,
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_SCARE] = 1,
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 20,
  alertness = 5,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'POLYPHEMUS_THE_BLIND_CYCLOPS',
  name = [[Polyphemus, the Blind Cyclops]],
  display = 'P',
  color = colors.C_g,
  image = 'npc/polyphemus_the_blind_cyclops.png',
  desc = [[No ordinary cyclops, but the son of a sea-god:  he wields the powers of elemental water as well as the considerable strength of a cyclops.  His one eye was blinded long ago by the warrior Odysseus, but he has trained himself to hear so well that it nearly makes up for his disability.]],
  corpse_weight = 4000,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=25,
    talent_in = 5,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 65, 100 },
  ac = 140,
  max_life = 6500,
  rarity = 3,
  level = 69,
  start_level = 69,
  exp_worth = 29000,
  unique = 'POLYPHEMUS_THE_BLIND_CYCLOPS',
  resist_dam = {
    [DamageType.ACID] = true,
    [DamageType.COLD] = true,
    [DamageType.FIRE] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    CAN_SWIM = true,
    EVIL = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    GIANT = true,
    HAS_LITE = true,
    KILL_BODY = true,
    KILL_ITEM = true,
    MALE = true,
    UNIQUE = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, only_item=true, '2d2', '3d2' },
  drop = { treasure=0, combat=100, magic=0, tools=0, junk=0 },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={11,10} },
    { type=DamageType.SHATTER, method=AttackType.HIT, dam={11,10} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={11,10} },
    { type=DamageType.SHATTER, method=AttackType.HIT, dam={11,10} },
  },
  resolvers.talents {
    [Talents.T_NPC_BO_WATE] = 1,
    [Talents.T_NPC_BA_WATE] = 1,
    [Talents.T_NPC_BO_ICEE] = 1,
    [Talents.T_NPC_BA_ACID] = 1,
    [Talents.T_NPC_ARROW_4] = 1,
  },
  body = bodies.humanoid,
  speed = 20,
  vision = 40,
  alertness = 40,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'GREAT_WYRM_OF_PERPLEXITY',
  name = [[Great Wyrm of Perplexity]],
  display = 'D',
  color = colors.C_U,
  multi_colors = { colors.C_U, colors.C_u },
  image = 'npc/great_wyrm_of_perplexity.png',
  desc = [[A dragon of great size and power.  Its polished bronze scales reflect the light in strange and confusing patterns, and you find it hard to keep your mind on the job of fighting for your life.]],
  corpse_weight = 19000,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 4,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 40, 100 },
  ac = 150,
  max_life = 4000,
  rarity = 2,
  level = 63,
  start_level = 63,
  exp_worth = 20000,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.OLD_SLEEP] = true,
  },
  flags = {
    ATTR_MULTI = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    DRAGON = true,
    EVIL = true,
    FLY = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    HAS_LITE = true,
    MOVE_BODY = true,
    POWERFUL = true,
    SMART = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, only_item=true, '2d2', '3d2', '4d2' },
  drop = { treasure=50, combat=50, magic=0, tools=0, junk=0 },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={4,12} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={4,12} },
    { type=DamageType.CONFUSION, method=AttackType.BITE, dam={6,14} },
    { type=DamageType.CONFUSION, method=AttackType.BITE, dam={6,14} },
  },
  resolvers.talents {
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_BR_CONF] = 1,
  },
  body = bodies.dragon,
  speed = 10,
  vision = 30,
  alertness = 80,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'GREAT_WYRM_OF_THUNDER',
  name = [[Great Wyrm of Thunder]],
  display = 'D',
  color = colors.C_y,
  multi_colors = { colors.C_y, colors.C_U },
  image = 'npc/great_wyrm_of_thunder.png',
  desc = [[A dragon of gigantic proportions, with destructive abilities to match.  The sheer loudness of its roar leaves you stunned and unable to think clearly enough to defend yourself adequately.]],
  corpse_weight = 19000,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 4,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 50, 100 },
  ac = 150,
  max_life = 5000,
  rarity = 2,
  level = 67,
  start_level = 67,
  exp_worth = 23000,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.OLD_SLEEP] = true,
  },
  flags = {
    ATTR_MULTI = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    DRAGON = true,
    EVIL = true,
    FLY = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    HAS_LITE = true,
    MOVE_BODY = true,
    NO_STUN = true,
    POWERFUL = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, only_item=true, '2d2', '3d2', '4d2' },
  drop = { treasure=50, combat=50, magic=0, tools=0, junk=0 },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={4,12} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={4,12} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={6,14} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={6,14} },
  },
  resolvers.talents {
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_BR_SOUN] = 1,
  },
  body = bodies.dragon,
  speed = 10,
  vision = 30,
  alertness = 80,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'SILVER_MOUSE',
  name = [[Silver mouse]],
  plural_name = [[Sliver mice]],
  display = 'r',
  color = colors.C_W,
  image = 'npc/silver_mouse.png',
  desc = [[It is about three feet long with large teeth.  As the light of your lamp falls on it, it seems to grow stronger.]],
  corpse_weight = 20,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=25,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 1, 3 },
  ac = 4,
  max_life = resolvers.dice(1, 3),
  rarity = 1,
  level = 4,
  start_level = 4,
  exp_worth = 1,
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    CAN_SWIM = true,
    MORTAL = true,
    MULTIPLY = true,
  },
  placement_flags = {},
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.EAT_LITE, method=AttackType.BITE, dam={1,2} },
  },
  body = bodies.quadruped,
  speed = 0,
  vision = 8,
  alertness = 20,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'THE_RAT_KING',
  name = [[The Rat King]],
  display = 'r',
  color = colors.C_v,
  image = 'npc/the_rat_king.png',
  desc = [[A massive rat. He's the leader of the pack.]],
  corpse_weight = 95,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 20, 12 },
  ac = 30,
  max_life = 240,
  rarity = 1,
  level = 18,
  start_level = 18,
  exp_worth = 32,
  unique = 'THE_RAT_KING',
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.OLD_SLEEP] = true,
  },
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    ESCORT = true,
    ESCORTS = true,
    FORCE_MAXHP = true,
    MORTAL = true,
    UNIQUE = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={3,2} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={3,2} },
    { type=DamageType.DISEASE, method=AttackType.BITE, dam={4,2} },
    { type=DamageType.DISEASE, method=AttackType.BITE, dam={4,2} },
  },
  body = bodies.humanoid,
  speed = 10,
  vision = 30,
  alertness = 0,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'VORT_THE_KOBOLD_QUEEN',
  name = [[Vort the Kobold Queen]],
  display = 'k',
  color = colors.C_v,
  image = 'npc/vort_the_kobold_queen.png',
  desc = [[Where Mughash is the strongest of his kind, his consort Vort is the wisest: she is her tribe's chief shamaness.]],
  corpse_weight = 100,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 6,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 12, 10 },
  ac = 20,
  max_life = 120,
  rarity = 3,
  level = 7,
  start_level = 7,
  exp_worth = 100,
  unique = 'VORT_THE_KOBOLD_QUEEN',
  resist_dam = {
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    CAN_SPEAK = true,
    ESCORT = true,
    ESCORTS = true,
    EVIL = true,
    FEMALE = true,
    FORCE_MAXHP = true,
    HAS_LITE = true,
    MORTAL = true,
    OPEN_DOOR = true,
    UNIQUE = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, only_item=true, '1d2' },
  drop = { treasure=0, combat=100, magic=0, tools=0, junk=0 },
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,10} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={1,10} },
  },
  resolvers.talents {
    [Talents.T_NPC_MISSILE] = 1,
    [Talents.T_NPC_HEAL] = 1,
    [Talents.T_NPC_CAUSE_1] = 1,
    [Talents.T_NPC_CONF] = 1,
  },
  body = bodies.humanoid,
  speed = 0,
  vision = 20,
  alertness = 20,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'GIANT_BLACK_LOUSE',
  name = [[Giant black louse]],
  plural_name = [[Giant black lice]],
  display = 'I',
  color = colors.C_D,
  image = 'npc/giant_black_louse.png',
  desc = [[It is six inches long.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=75,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 1, 2 },
  ac = 7,
  max_life = resolvers.dice(1, 2),
  rarity = 1,
  level = 14,
  start_level = 14,
  exp_worth = 3,
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    FLY = true,
    MORTAL = true,
    MULTIPLY = true,
    WEIRD_MIND = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={1,2} },
  },
  body = bodies.none,
  speed = 10,
  vision = 6,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'FIRE_PHANTOM',
  name = [[Fire Phantom]],
  display = 'G',
  color = colors.C_r,
  image = 'npc/fire_phantom.png',
  desc = [[He's back from the grave for vengeance on those who burnt him. He has no mercy for those in his way.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 6,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 10, 100 },
  ac = 90,
  max_life = 1000,
  rarity = 5,
  level = 34,
  start_level = 34,
  exp_worth = 1200,
  unique = 'FIRE_PHANTOM',
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.OLD_SLEEP] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    CAN_SPEAK = true,
    FORCE_MAXHP = true,
    HAS_LITE = true,
    MALE = true,
    MORTAL = true,
    NO_CUT = true,
    NO_STUN = true,
    OPEN_DOOR = true,
    PASS_WALL = true,
    REGENERATE = true,
    TAKE_ITEM = true,
    UNDEAD = true,
    UNIQUE = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, only_item=true, '2d2' },
  drop = { treasure=0, combat=0, magic=100, tools=0, junk=0 },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={5,5} },
  },
  resolvers.talents {
    [Talents.T_NPC_BR_FIRE] = 1,
    [Talents.T_NPC_HOLD] = 1,
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_MIND_BLAST] = 1,
  },
  body = bodies.none,
  speed = 10,
  vision = 20,
  alertness = 40,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'BONE_GOLEM',
  name = [[Bone golem]],
  display = 'g',
  color = colors.C_w,
  image = 'npc/bone_golem.png',
  desc = [[A skeletal form, black as night, constructed from the bones of its previous victims.]],
  corpse_weight = 500,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 3,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 35, 100 },
  ac = 170,
  max_life = 3500,
  rarity = 3,
  level = 61,
  start_level = 61,
  exp_worth = 23000,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.ELEC] = true,
    [DamageType.FEAR] = true,
    [DamageType.FIRE] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
    [DamageType.TELEPORT] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    COLD_BLOOD = true,
    EMPTY_MIND = true,
    EVIL = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    NONLIVING = true,
    NO_CUT = true,
    OPEN_DOOR = true,
    UNDEAD = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.DISENCHANT, method=AttackType.HIT, dam={8,8} },
    { type=DamageType.DISENCHANT, method=AttackType.HIT, dam={8,8} },
    { type=DamageType.LOSE_STR, method=AttackType.HIT, dam={6,6} },
    { type=DamageType.LOSE_STR, method=AttackType.HIT, dam={6,6} },
  },
  on_melee_hit = util.black_breath_melee_hit,
  resolvers.talents {
    [Talents.T_NPC_TELE_TO] = 1,
    [Talents.T_NPC_CAUSE_4] = 1,
    [Talents.T_NPC_DRAIN_MANA] = 1,
    [Talents.T_NPC_BRAIN_SMASH] = 1,
    [Talents.T_NPC_BA_NETH] = 1,
    [Talents.T_NPC_S_HI_UNDEAD] = 1,
  },
  body = bodies.humanoid,
  speed = 10,
  vision = 20,
  alertness = 50,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'BRONZE_GOLEM',
  name = [[Bronze golem]],
  display = 'g',
  color = colors.C_o,
  image = 'npc/bronze_golem.png',
  desc = [[A gigantic four-armed animated bronze statue, glowing with great heat.]],
  corpse_weight = 550,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 3,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 40, 100 },
  ac = 170,
  max_life = 4000,
  rarity = 3,
  level = 65,
  start_level = 65,
  exp_worth = 26000,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.ELEC] = true,
    [DamageType.FEAR] = true,
    [DamageType.FIRE] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
    [DamageType.TELEPORT] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    COLD_BLOOD = true,
    EMPTY_MIND = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    NONLIVING = true,
    NO_CUT = true,
    NO_STUN = true,
    OPEN_DOOR = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={10,10} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={10,10} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={10,10} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={10,10} },
  },
  resolvers.talents {
    [Talents.T_NPC_BO_PLAS] = 1,
    [Talents.T_NPC_BA_FIRE] = 1,
    [Talents.T_NPC_BR_FIRE] = 1,
    [Talents.T_NPC_BA_ELEC] = 1,
    [Talents.T_NPC_S_HI_DEMON] = 1,
    [Talents.T_NPC_TELE_TO] = 1,
  },
  body = { MAIN_HAND=2, OFF_HAND=2, BODY=1, CLOAK=1, LAUNCHER=1, QUIVER=1, GLOVES=2, BOOTS=1, HELM=1, RING=4, AMULET=1, LITE=1, TOOL=1, SYMBIOTE=1, INVEN=23 },
  speed = 10,
  vision = 25,
  alertness = 50,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'BLUE_DRAGON_WORM',
  name = [[Blue dragon worm]],
  display = 'w',
  color = colors.C_B,
  multi_colors = { colors.C_b, colors.C_B },
  image = 'npc/blue_dragon_worm.png',
  desc = [[You thought dragons used eggs, but this worm has the scales, and the bad breath, and the fiery eyes, of a real dragon. Sparks fly from its jaws.]],
  corpse_weight = 450,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=75,
    talent_in = 6,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 10, 15 },
  ac = 40,
  max_life = resolvers.dice(10, 15),
  rarity = 3,
  level = 20,
  start_level = 20,
  exp_worth = 12,
  resist_dam = {
    [DamageType.ELEC] = true,
  },
  flags = {
    ATTR_MULTI = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    DRAGON = true,
    EVIL = true,
    MORTAL = true,
    MULTIPLY = true,
    OPEN_DOOR = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ only_gold=true, '60%' },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={3,3} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={3,3} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={3,5} },
  },
  resolvers.talents {
    [Talents.T_NPC_BR_ELEC] = 1,
  },
  body = bodies.snake,
  speed = -10,
  vision = 10,
  alertness = 80,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'WHITE_DRAGON_WORM',
  name = [[White dragon worm]],
  display = 'w',
  color = colors.C_W,
  multi_colors = { colors.C_w, colors.C_W },
  image = 'npc/white_dragon_worm.png',
  desc = [[You thought dragons used eggs, but this worm has the scales, and the bad breath, and the fiery eyes, of a real dragon. Its breath condenses in the air.]],
  corpse_weight = 450,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=75,
    talent_in = 6,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 10, 15 },
  ac = 40,
  max_life = resolvers.dice(10, 15),
  rarity = 3,
  level = 20,
  start_level = 20,
  exp_worth = 12,
  resist_dam = {
    [DamageType.COLD] = true,
  },
  flags = {
    ATTR_MULTI = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    DRAGON = true,
    EVIL = true,
    MORTAL = true,
    MULTIPLY = true,
    OPEN_DOOR = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ only_gold=true, '60%' },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={3,3} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={3,3} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={3,5} },
  },
  resolvers.talents {
    [Talents.T_NPC_BR_COLD] = 1,
  },
  body = bodies.snake,
  speed = -10,
  vision = 10,
  alertness = 80,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'GREEN_DRAGON_WORM',
  name = [[Green dragon worm]],
  display = 'w',
  color = colors.C_G,
  multi_colors = { colors.C_g, colors.C_G },
  image = 'npc/green_dragon_worm.png',
  desc = [[You thought dragons used eggs, but this worm has the scales, and the bad breath, and the fiery eyes, of a real dragon. You can smell foul gases on its breath.]],
  corpse_weight = 450,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=75,
    talent_in = 6,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 10, 15 },
  ac = 40,
  max_life = resolvers.dice(10, 15),
  rarity = 3,
  level = 20,
  start_level = 20,
  exp_worth = 12,
  resist_dam = {
    [DamageType.POISON] = true,
  },
  flags = {
    ATTR_MULTI = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    DRAGON = true,
    EVIL = true,
    MORTAL = true,
    MULTIPLY = true,
    OPEN_DOOR = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ only_gold=true, '60%' },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={3,3} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={3,3} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={3,5} },
  },
  resolvers.talents {
    [Talents.T_NPC_BR_POIS] = 1,
  },
  body = bodies.snake,
  speed = -10,
  vision = 10,
  alertness = 80,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'BLACK_DRAGON_WORM',
  name = [[Black dragon worm]],
  display = 'w',
  color = colors.C_s,
  multi_colors = { colors.C_d, colors.C_D },
  image = 'npc/black_dragon_worm.png',
  desc = [[You thought dragons used eggs, but this worm has the scales, and the bad breath, and the fiery eyes, of a real dragon. Acidic drool drips from its jaws.]],
  corpse_weight = 450,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=75,
    talent_in = 6,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 10, 15 },
  ac = 40,
  max_life = resolvers.dice(10, 15),
  rarity = 3,
  level = 20,
  start_level = 20,
  exp_worth = 12,
  resist_dam = {
    [DamageType.ACID] = true,
  },
  flags = {
    ATTR_MULTI = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    DRAGON = true,
    EVIL = true,
    MORTAL = true,
    MULTIPLY = true,
    OPEN_DOOR = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ only_gold=true, '60%' },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={3,3} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={3,3} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={3,5} },
  },
  resolvers.talents {
    [Talents.T_NPC_BR_ACID] = 1,
  },
  body = bodies.snake,
  speed = -10,
  vision = 10,
  alertness = 80,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'RED_DRAGON_WORM',
  name = [[Red dragon worm]],
  display = 'w',
  color = colors.C_R,
  multi_colors = { colors.C_r, colors.C_R },
  image = 'npc/red_dragon_worm.png',
  desc = [[You thought dragons used eggs, but this worm has the scales, and the bad breath, and the fiery eyes, of a real dragon. Smoke comes from its mouth.]],
  corpse_weight = 450,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=75,
    talent_in = 6,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 10, 15 },
  ac = 40,
  max_life = resolvers.dice(10, 15),
  rarity = 3,
  level = 20,
  start_level = 20,
  exp_worth = 12,
  resist_dam = {
    [DamageType.FIRE] = true,
  },
  flags = {
    ATTR_MULTI = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    DRAGON = true,
    EVIL = true,
    MORTAL = true,
    MULTIPLY = true,
    OPEN_DOOR = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ only_gold=true, '60%' },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={3,3} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={3,3} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={3,5} },
  },
  resolvers.talents {
    [Talents.T_NPC_BR_FIRE] = 1,
  },
  body = bodies.snake,
  speed = -10,
  vision = 10,
  alertness = 80,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'MULTI_HUED_DRAGON_WORM',
  name = [[Multi-hued dragon worm]],
  display = 'w',
  color = colors.C_v,
  multi_colors = { colors.C_b, colors.C_w, colors.C_r, colors.C_d, colors.C_g },
  image = 'npc/multi_hued_dragon_worm.png',
  desc = [[You thought dragons used eggs, but this worm has the scales, and the bad breath, and the fiery eyes, of a real dragon. Its scales shimmer different colours as you watch.]],
  corpse_weight = 450,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=75,
    talent_in = 6,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 10, 20 },
  ac = 40,
  max_life = resolvers.dice(10, 20),
  rarity = 3,
  level = 23,
  start_level = 23,
  exp_worth = 12,
  resist_dam = {
    [DamageType.ACID] = true,
    [DamageType.COLD] = true,
    [DamageType.ELEC] = true,
    [DamageType.FIRE] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    ATTR_MULTI = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    DRAGON = true,
    EVIL = true,
    MORTAL = true,
    MULTIPLY = true,
    OPEN_DOOR = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ only_gold=true, '60%' },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={3,3} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={3,3} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={3,5} },
  },
  resolvers.talents {
    [Talents.T_NPC_BR_ELEC] = 1,
    [Talents.T_NPC_BR_COLD] = 1,
    [Talents.T_NPC_BR_FIRE] = 1,
    [Talents.T_NPC_BR_ACID] = 1,
    [Talents.T_NPC_BR_POIS] = 1,
  },
  body = bodies.snake,
  speed = -10,
  vision = 10,
  alertness = 80,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'THE_MINOTAUR_OF_THE_LABYRINTH',
  name = [[The Minotaur of the Labyrinth]],
  display = 'H',
  color = colors.C_s,
  image = 'npc/the_minotaur_of_the_labyrinth.png',
  desc = [[It is a cross between a human and a bull.]],
  corpse_weight = 1750,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 150, 10 },
  ac = 25,
  max_life = resolvers.dice(150, 10),
  level = 40,
  start_level = 40,
  exp_worth = 3100,
  unique = 'THE_MINOTAUR_OF_THE_LABYRINTH',
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    EVIL = true,
    MORTAL = true,
    SPECIAL_GENE = true,
    UNIQUE = true,
  },
  placement_flags = {},
  drop_corpse = { corpse=true, skeleton=true },
  drop_special = function(self) return game.zone:makeEntityByName(game.level, 'artifact', 'OF_HAMMERHAND', false) end,
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.BUTT, dam={4,6} },
    { type=DamageType.PHYSICAL, method=AttackType.BUTT, dam={4,6} },
    { type=DamageType.PHYSICAL, method=AttackType.BUTT, dam={3,6} },
    { type=DamageType.PHYSICAL, method=AttackType.BUTT, dam={3,6} },
  },
  body = bodies.humanoid,
  speed = 20,
  vision = 13,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'THE_SANDWORM_QUEEN',
  name = [[The Sandworm Queen]],
  display = 'w',
  color = colors.C_v,
  image = 'npc/the_sandworm_queen.png',
  desc = [[Queen and mother of the sandworms, fear her and her prolific children.]],
  corpse_weight = 450,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 2,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 30, 20 },
  ac = 40,
  max_life = 600,
  level = 30,
  start_level = 30,
  exp_worth = 12,
  unique = 'THE_SANDWORM_QUEEN',
  resist_dam = {
    [DamageType.ACID] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.ELEC] = true,
    [DamageType.FIRE] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    EMPTY_MIND = true,
    ESCORT = true,
    EVIL = true,
    FEMALE = true,
    FORCE_MAXHP = true,
    MORTAL = true,
    OPEN_DOOR = true,
    POWERFUL = true,
    REFLECTING = true,
    SPECIAL_GENE = true,
    UNIQUE = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, great=true, only_item=true, '60%' },
  drop = { treasure=30, combat=60, magic=0, tools=10, junk=0 },
  drop_corpse = { corpse=true },
  drop_special = function(self) return game.zone:makeEntityByName(game.level, 'artifact', 'OF_THE_SANDWORM', false) end,
  attacks = {
    { type=DamageType.ACID, method=AttackType.CLAW, dam={5,4} },
    { type=DamageType.POISON, method=AttackType.CLAW, dam={5,4} },
    { type=DamageType.FIRE, method=AttackType.BITE, dam={5,4} },
    { type=DamageType.ELEC, method=AttackType.BITE, dam={5,4} },
  },
  resolvers.talents {
    [Talents.T_NPC_BR_POIS] = 1,
    [Talents.T_NPC_S_KIN] = 1,
  },
  body = bodies.snake,
  speed = 10,
  vision = 10,
  alertness = 80,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'SANDWORM',
  name = [[Sandworm]],
  display = 'w',
  color = colors.C_y,
  image = 'npc/sandworm.png',
  desc = [[Offbreed of the Sandworm Queen, they are harmless alone...]],
  corpse_weight = 450,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    random_move=25,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 10, 15 },
  ac = 40,
  max_life = 150,
  rarity = 6,
  level = 27,
  start_level = 27,
  exp_worth = 12,
  resist_dam = {
    [DamageType.ELEC] = true,
    [DamageType.FIRE] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    EMPTY_MIND = true,
    EVIL = true,
    FORCE_MAXHP = true,
    MORTAL = true,
    MULTIPLY = true,
    POWERFUL = true,
  },
  placement_flags = {},
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.POISON, method=AttackType.CLAW, dam={4,4} },
    { type=DamageType.POISON, method=AttackType.CLAW, dam={4,4} },
    { type=DamageType.POISON, method=AttackType.CLAW, dam={4,4} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={5,5} },
  },
  body = bodies.snake,
  speed = 5,
  vision = 10,
  alertness = 80,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'TIK_SRVZLLAT',
  name = [[Tik'srvzllat]],
  display = 'G',
  color = colors.C_v,
  image = 'npc/tik_srvzllat.png',
  desc = [[A disembodied and barely sentient mind, Tik'srvzllat floated through the void for eons before being awakened by sorcery, pulled into the nether realm, and shaped into the being you see before you. A flickering purple outline of a sphere, with eerie yellow-purple mist circling rapidly around it, Tik'srvzllat threatens your sanity with its appearance alone.]],
  corpse_weight = 100,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 2,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 180, 100 },
  ac = 170,
  max_life = 18000,
  level = 127,
  start_level = 127,
  exp_worth = 350000,
  unique = 'TIK_SRVZLLAT',
  resist_dam = {
    [DamageType.ACID] = true,
    [DamageType.COLD] = true,
    [DamageType.ELEC] = true,
    [DamageType.FIRE] = true,
    [DamageType.NETHER] = true,
    [DamageType.POISON] = true,
  },
  melee_retal = {
    [DamageType.COLD] = 'mondam',
  },
  flags = {
    BASEANGBAND = true,
    COLD_BLOOD = true,
    EVIL = true,
    FORCE_MAXHP = true,
    INVISIBLE = true,
    NO_CUT = true,
    PASS_WALL = true,
    POWERFUL = true,
    SPECIAL_GENE = true,
    UNDEAD = true,
    UNIQUE = true,
    WEIRD_MIND = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, great=true, only_item=true, '3d2', '4d2' },
  drop = { treasure=50, combat=0, magic=50, tools=0, junk=0 },
  drop_special = function(self) return game.zone:makeEntityByName(game.level, 'artifact', 'OF_PHASING', false) end,
  attacks = {
    { type=DamageType.DISENCHANT, method=AttackType.GAZE, dam={10,10} },
    { type=DamageType.TIME, method=AttackType.GAZE, dam={10,10} },
    { type=DamageType.INSANITY, method=AttackType.GAZE, dam={10,10} },
    { type=DamageType.INSANITY, method=AttackType.GAZE, dam={10,5} },
  },
  on_melee_hit = util.black_breath_melee_hit,
  resolvers.talents {
    [Talents.T_NPC_S_UNDEAD] = 1,
    [Talents.T_NPC_S_DEMON] = 1,
    [Talents.T_NPC_S_DRAGON] = 1,
    [Talents.T_NPC_S_UNIQUE] = 1,
    [Talents.T_NPC_S_WRAITH] = 1,
    [Talents.T_NPC_S_HI_DEMON] = 1,
    [Talents.T_NPC_S_HI_UNDEAD] = 1,
    [Talents.T_NPC_S_HI_DRAGON] = 1,
    [Talents.T_NPC_S_KIN] = 1,
    [Talents.T_NPC_BR_DISE] = 1,
    [Talents.T_NPC_BA_NETH] = 1,
  },
  body = bodies.humanoid,
  speed = 32,
  vision = 200,
  alertness = 0,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'THE_GLASS_GOLEM',
  name = [[The Glass Golem]],
  display = 'g',
  color = colors.C_W,
  image = 'npc/the_glass_golem.png',
  desc = [[One of the last creations of the petty dwarves of Ludarin, its existence explains their destruction. A creation of finest glass, the body of this creature bends and amplifies light in a way that makes you unsure of its position. You feel somewhat dizzy as the radiant light reflects off the walls, the ceiling and your gear.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 4,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 100, 15 },
  ac = 170,
  max_life = 1500,
  level = 52,
  start_level = 52,
  exp_worth = 2000,
  unique = 'THE_GLASS_GOLEM',
  resist_dam = {
    [DamageType.ACID] = true,
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.ELEC] = true,
    [DamageType.FEAR] = true,
    [DamageType.FIRE] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    CHAR_MULTI = true,
    COLD_BLOOD = true,
    EMPTY_MIND = true,
    ESCORT = true,
    ESCORTS = true,
    FLY = true,
    FORCE_MAXHP = true,
    KILL_WALL = true,
    NONLIVING = true,
    NO_CUT = true,
    NO_STUN = true,
    POWERFUL = true,
    SPECIAL_GENE = true,
    UNIQUE = true,
  },
  placement_flags = {},
  drop_special = function(self) return game.zone:makeEntityByName(game.level, 'artifact', 'OF_KNOWLEDGE', false) end,
  attacks = {
    { type=DamageType.INSANITY, method=AttackType.HIT, dam={5,6} },
    { type=DamageType.INSANITY, method=AttackType.HIT, dam={6,6} },
    { type=DamageType.INSANITY, method=AttackType.HIT, dam={7,6} },
    { type=DamageType.INSANITY, method=AttackType.HIT, dam={6,6} },
  },
  resolvers.talents {
    [Talents.T_NPC_BR_CONF] = 1,
    [Talents.T_NPC_BR_LITE] = 1,
    [Talents.T_NPC_BR_DARK] = 1,
    [Talents.T_NPC_BR_WALL] = 1,
    [Talents.T_NPC_S_KIN] = 1,
    [Talents.T_NPC_TELE_LEVEL] = 1,
    [Talents.T_NPC_SHRIEK] = 1,
  },
  body = bodies.none,
  speed = 20,
  vision = 200,
  alertness = 0,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'THE_WHITE_BALROG',
  name = [[The White Balrog]],
  display = 'U',
  color = colors.C_W,
  image = 'npc/the_white_balrog.png',
  desc = [[It is a massive humanoid demon wreathed in frost, wielding a cruel looking pike in its hands.]],
  corpse_weight = 1200,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 4,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 25, 100 },
  ac = 100,
  max_life = 2500,
  level = 50,
  start_level = 50,
  exp_worth = 25000,
  unique = 'THE_WHITE_BALROG',
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
  },
  melee_retal = {
    [DamageType.COLD] = 'mondam',
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    DEMON = true,
    EVIL = true,
    FLY = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    HAS_LITE = true,
    KILL_WALL = true,
    MOVE_BODY = true,
    NONLIVING = true,
    OPEN_DOOR = true,
    POWERFUL = true,
    SMART = true,
    SPECIAL_GENE = true,
    UNIQUE = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, only_item=true, randart=true, '2d2' },
  drop = { treasure=0, combat=50, magic=50, tools=0, junk=0 },
  attacks = {
    { type=DamageType.COLD, method=AttackType.HIT, dam={4,12} },
    { type=DamageType.COLD, method=AttackType.HIT, dam={4,12} },
    { type=DamageType.PHYSICAL, method=AttackType.CRUSH, dam={3,12} },
    { type=DamageType.UN_POWER, method=AttackType.TOUCH },
  },
  resolvers.talents {
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_BRAIN_SMASH] = 1,
    [Talents.T_NPC_BR_COLD] = 1,
    [Talents.T_NPC_BO_COLD] = 1,
    [Talents.T_NPC_BA_NETH] = 1,
    [Talents.T_NPC_S_UNDEAD] = 1,
    [Talents.T_NPC_S_DEMON] = 1,
  },
  body = bodies.humanoid,
  speed = 10,
  vision = 20,
  alertness = 100,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'GOLGARACH_THE_LIVING_ROCK',
  name = [[Golgarach, the Living Rock]],
  display = '#',
  color = colors.C_W,
  image = 'npc/golgarach_the_living_rock.png',
  desc = [[Deep in the heart of the earth, even the rock itself is sentient and has learned to despise intruders.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 10,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 50, 30 },
  ac = 100,
  max_life = resolvers.dice(50, 30),
  level = 45,
  start_level = 45,
  exp_worth = 1500,
  unique = 'GOLGARACH_THE_LIVING_ROCK',
  resist_dam = {
    [DamageType.ACID] = true,
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.ELEC] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  vuln_dam = {
    [DamageType.KILL_WALL] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    CHAR_MULTI = true,
    COLD_BLOOD = true,
    EMPTY_MIND = true,
    ESCORT = true,
    FORCE_SLEEP = true,
    KILL_BODY = true,
    NONLIVING = true,
    NO_CUT = true,
    PASS_WALL = true,
    SPECIAL_GENE = true,
    UNIQUE = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ randart=true },
  drop = { treasure=60, combat=0, magic=40, tools=0, junk=0 },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={4,6} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={4,6} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={4,6} },
  },
  resolvers.talents {
    [Talents.T_NPC_S_KIN] = 1,
    [Talents.T_NPC_BO_ACID] = 1,
    [Talents.T_NPC_BA_FIRE] = 1,
  },
  body = bodies.none,
  speed = 10,
  vision = 20,
  alertness = 40,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'ATLAS_THE_TITAN',
  name = [[Atlas, the Titan]],
  display = 'P',
  color = colors.C_s,
  image = 'npc/atlas_the_titan.png',
  desc = [[The strongest of all the Titans.  Legend has it that he once held the sky on his shoulders; and the mountain range that now does so is named after him.]],
  corpse_weight = 7000,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 100, 100 },
  ac = 160,
  max_life = 10000,
  rarity = 3,
  level = 76,
  start_level = 76,
  exp_worth = 37000,
  unique = 'ATLAS_THE_TITAN',
  resist_dam = {
    [DamageType.ACID] = true,
    [DamageType.COLD] = true,
    [DamageType.ELEC] = true,
    [DamageType.FIRE] = true,
    [DamageType.POISON] = true,
  },
  vuln_dam = {
    [DamageType.KILL_WALL] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    EVIL = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    GIANT = true,
    HAS_LITE = true,
    KILL_BODY = true,
    KILL_WALL = true,
    MALE = true,
    OPEN_DOOR = true,
    SMART = true,
    TAKE_ITEM = true,
    UNIQUE = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, only_item=true, '4d2' },
  drop = { treasure=0, combat=100, magic=0, tools=0, junk=0 },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.SHATTER, method=AttackType.HIT, dam={13,13} },
    { type=DamageType.CONFUSION, method=AttackType.HIT, dam={13,13} },
    { type=DamageType.SHATTER, method=AttackType.HIT, dam={13,13} },
    { type=DamageType.CONFUSION, method=AttackType.HIT, dam={13,13} },
  },
  body = bodies.humanoid,
  speed = 20,
  vision = 30,
  alertness = 15,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'KRONOS_LORD_OF_THE_TITANS',
  name = [[Kronos, Lord of the Titans]],
  display = 'P',
  color = colors.C_v,
  image = 'npc/kronos_lord_of_the_titans.png',
  desc = [[The lord of the Titans, he has broken loose from his confinement in the nether hells to seek revenge on the world.]],
  corpse_weight = 8000,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 3,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 130, 100 },
  ac = 150,
  max_life = 13000,
  rarity = 3,
  level = 87,
  start_level = 87,
  exp_worth = 42000,
  unique = 'KRONOS_LORD_OF_THE_TITANS',
  resist_dam = {
    [DamageType.ACID] = true,
    [DamageType.COLD] = true,
    [DamageType.ELEC] = true,
    [DamageType.FIRE] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    ESCORT = true,
    EVIL = true,
    FORCE_MAXHP = true,
    FORCE_SLEEP = true,
    GIANT = true,
    HAS_LITE = true,
    MALE = true,
    MOVE_BODY = true,
    SMART = true,
    TAKE_ITEM = true,
    UNIQUE = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, only_item=true, '3d2', '4d2' },
  drop = { treasure=0, combat=100, magic=0, tools=0, junk=0 },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.CONFUSION, method=AttackType.HIT, dam={12,12} },
    { type=DamageType.CONFUSION, method=AttackType.HIT, dam={12,12} },
    { type=DamageType.CONFUSION, method=AttackType.HIT, dam={12,12} },
    { type=DamageType.CONFUSION, method=AttackType.HIT, dam={12,12} },
  },
  resolvers.talents {
    [Talents.T_NPC_BR_FIRE] = 1,
    [Talents.T_NPC_BR_COLD] = 1,
    [Talents.T_NPC_BR_SHAR] = 1,
    [Talents.T_NPC_BR_SOUN] = 1,
    [Talents.T_NPC_ROCKET] = 1,
    [Talents.T_NPC_S_MONSTERS] = 1,
    [Talents.T_NPC_S_KIN] = 1,
    [Talents.T_NPC_TELE_TO] = 1,
    [Talents.T_NPC_HEAL] = 1,
  },
  body = bodies.humanoid,
  speed = 20,
  vision = 30,
  alertness = 15,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'WATER_HOUND',
  name = [[Water hound]],
  display = 'Z',
  color = colors.C_r,
  image = 'npc/water_hound.png',
  desc = [[The sound of a hundred waterfalls rushes through your ears as a huge wave of water, vaguely hound-shaped, rushes towards you.]],
  corpse_weight = 60,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 5,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 12, 6 },
  ac = 30,
  max_life = resolvers.dice(12, 6),
  rarity = 1,
  level = 43,
  start_level = 43,
  exp_worth = 150,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.WATER] = true,
  },
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    FORCE_SLEEP = true,
    FRIENDS = true,
    MORTAL = true,
    NO_CUT = true,
  },
  placement_flags = {},
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={1,6} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={1,4} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={1,4} },
  },
  resolvers.talents {
    [Talents.T_NPC_BA_WATE] = 1,
  },
  body = bodies.quadruped,
  speed = 0,
  vision = 30,
  alertness = 0,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'EMPEROR_MIMIC',
  name = [[Emperor Mimic]],
  display = 'm',
  color = colors.C_y,
  image = 'npc/emperor_mimic.png',
  desc = [[A strange creature that disguises itself as an object to lure unsuspecting adventurers within reach of its venomous claws.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 1,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 50, 50 },
  ac = 60,
  max_life = resolvers.dice(50, 50),
  rarity = 3,
  level = 40,
  start_level = 40,
  exp_worth = 200,
  unique = 'EMPEROR_MIMIC',
  resist_dam = {
    [DamageType.ACID] = true,
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.ELEC] = true,
    [DamageType.FEAR] = true,
    [DamageType.FIRE] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    COLD_BLOOD = true,
    EMPTY_MIND = true,
    FORCE_SLEEP = true,
    MIMIC = true,
    NO_CUT = true,
    UNIQUE = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.POISON, method=AttackType.HIT, dam={5,5} },
    { type=DamageType.POISON, method=AttackType.HIT, dam={5,5} },
    { type=DamageType.POISON, method=AttackType.HIT, dam={5,5} },
    { type=DamageType.POISON, method=AttackType.HIT, dam={5,5} },
  },
  resolvers.talents {
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_CAUSE_4] = 1,
    [Talents.T_NPC_CAUSE_3] = 1,
    [Talents.T_NPC_FORGET] = 1,
    [Talents.T_NPC_BA_ACID] = 1,
    [Talents.T_NPC_BA_FIRE] = 1,
    [Talents.T_NPC_BA_COLD] = 1,
    [Talents.T_NPC_BA_ELEC] = 1,
    [Talents.T_NPC_S_MONSTER] = 1,
    [Talents.T_NPC_S_KIN] = 1,
    [Talents.T_NPC_SHRIEK] = 1,
    [Talents.T_NPC_BRAIN_SMASH] = 1,
    [Talents.T_NPC_TRAPS] = 1,
  },
  body = bodies.none,
  speed = 10,
  vision = 30,
  alertness = 100,
  resolvers.mon_global_speed(),
  resolvers.mon_mimic(),
}

newEntity {
  define_as = 'MELINDA_PROUDFOOT',
  name = [[Melinda Proudfoot]],
  display = 'h',
  color = colors.C_v,
  image = 'npc/melinda_proudfoot.png',
  desc = [[She seems to seek someone, you may help...]],
  corpse_weight = 73,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 1, 1 },
  ac = 250,
  faction = 'quest_givers',
  max_life = 1,
  level = 1,
  start_level = 1,
  exp_worth = 0,
  unique = 'MELINDA_PROUDFOOT',
  flags = {
    BASEANGBAND = true,
    CAN_SPEAK = true,
    FEMALE = true,
    FORCE_MAXHP = true,
    GOOD = true,
    MORTAL = true,
    NEUTRAL = true,
    NEVER_BLOW = true,
    NEVER_MOVE = true,
    NO_DEATH = true,
    NO_TARGET = true,
    SPECIAL_GENE = true,
    UNIQUE = true,
  },
  placement_flags = {},
  body = { MAIN_HAND=0, OFF_HAND=1, BODY=1, CLOAK=1, LAUNCHER=0, QUIVER=1, GLOVES=1, BOOTS=1, HELM=1, RING=2, AMULET=1, LITE=1, TOOL=1, SYMBIOTE=1, INVEN=23 },
  speed = 0,
  vision = 40,
  alertness = 3,
  resolvers.mon_global_speed(),
  -- BEGIN VERBATIM
  can_talk = 'melinda-proudfoot',
  -- END VERBATIM
}

newEntity {
  define_as = 'THRAIN_THE_KING_UNDER_THE_MOUNTAIN',
  name = [[Thráin, the King Under the Mountain]],
  display = 'h',
  color = colors.C_B,
  image = 'npc/thrain_the_king_under_the_mountain.png',
  desc = [[He must have suffered horrible tortures...]],
  corpse_weight = 73,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 1, 1 },
  ac = 250,
  faction = 'quest_givers',
  max_life = 1,
  level = 60,
  start_level = 60,
  exp_worth = 0,
  unique = 'THRAIN_THE_KING_UNDER_THE_MOUNTAIN',
  flags = {
    BASEANGBAND = true,
    CAN_SPEAK = true,
    FORCE_MAXHP = true,
    GOOD = true,
    MALE = true,
    MORTAL = true,
    NEUTRAL = true,
    NEVER_BLOW = true,
    NEVER_MOVE = true,
    NO_DEATH = true,
    NO_TARGET = true,
    SPECIAL_GENE = true,
    UNIQUE = true,
  },
  placement_flags = {},
  body = { MAIN_HAND=0, OFF_HAND=1, BODY=1, CLOAK=1, LAUNCHER=0, QUIVER=1, GLOVES=1, BOOTS=1, HELM=1, RING=2, AMULET=1, LITE=1, TOOL=1, SYMBIOTE=1, INVEN=23 },
  speed = 0,
  vision = 40,
  alertness = 3,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'FIRE_GOLEM',
  name = [[Fire golem]],
  display = 'g',
  color = colors.C_r,
  image = 'npc/fire_golem.png',
  desc = [[A sentient mass of pure fire.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 10,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 3, 20 },
  ac = 50,
  max_life = resolvers.dice(3, 20),
  level = 0,
  start_level = 0,
  exp_worth = 0,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.FEAR] = true,
    [DamageType.FIRE] = true,
    [DamageType.OLD_SLEEP] = true,
  },
  melee_retal = {
    [DamageType.FIRE] = 'mondam',
  },
  flags = {
    AI_PLAYER = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    HAS_LITE = true,
    MORTAL = true,
    NONLIVING = true,
    NO_CUT = true,
    NO_STUN = true,
    SPECIAL_GENE = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={2,6} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={2,6} },
    { type=DamageType.FIRE, method=AttackType.HIT, dam={3,6} },
    { type=DamageType.FIRE, method=AttackType.HIT, dam={3,6} },
  },
  resolvers.talents {
    [Talents.T_NPC_BR_FIRE] = 1,
  },
  body = bodies.humanoid,
  speed = 5,
  vision = 50,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'MELKOR_LORD_OF_DARKNESS',
  name = [[Melkor, Lord of Darkness]],
  display = 'G',
  color = colors.C_v,
  image = 'npc/melkor_lord_of_darkness.png',
  desc = [[He was the most powerful of the Valar, the equal of Manwë. You banned him here, in the Void, and now you must destroy him forever. However here in the Void, his spirit gained much power for he is closer to the Flame Imperishable. He is coming to you in pure madness, which makes him even more dangerous. You are on the verge of dying!]],
  corpse_weight = 20000,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 4,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 300, 300 },
  ac = 150,
  max_life = 90000,
  level = 150,
  start_level = 150,
  exp_worth = 60000,
  unique = 'MELKOR_LORD_OF_DARKNESS',
  resist_dam = {
    [DamageType.ACID] = true,
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.ELEC] = true,
    [DamageType.FEAR] = true,
    [DamageType.FIRE] = true,
    [DamageType.NETHER] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
    [DamageType.TELEPORT] = true,
  },
  melee_retal = {
    [DamageType.FIRE] = 'mondam',
  },
  flags = {
    BASEANGBAND = true,
    CAN_SPEAK = true,
    EVIL = true,
    FLY = true,
    FORCE_MAXHP = true,
    KILL_TREES = true,
    KILL_WALL = true,
    MALE = true,
    MOVE_BODY = true,
    NO_STUN = true,
    POWERFUL = true,
    REGENERATE = true,
    SMART = true,
    SPECIAL_GENE = true,
    SPIRIT = true,
    UNIQUE = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, great=true, only_item=true, '1d2', '2d2', '3d2', '4d2' },
  drop = { treasure=25, combat=25, magic=25, tools=25, junk=0 },
  attacks = {
    { type=DamageType.ABOMINATION, method=AttackType.HIT, dam={3,10} },
    { type=DamageType.TIME, method=AttackType.HIT, dam={24,10} },
    { type=DamageType.INSANITY, method=AttackType.HIT, dam={24,10} },
    { type=DamageType.LOSE_ALL, method=AttackType.HIT, dam={24,10} },
  },
  resolvers.talents {
    [Talents.T_NPC_BRAIN_SMASH] = 1,
    [Talents.T_NPC_BA_MANA] = 1,
    [Talents.T_NPC_BO_MANA] = 1,
    [Talents.T_NPC_BA_NETH] = 1,
    [Talents.T_NPC_BA_CHAO] = 1,
    [Talents.T_NPC_BA_DARK] = 1,
    [Talents.T_NPC_ANIM_DEAD] = 1,
    [Talents.T_NPC_S_KIN] = 1,
    [Talents.T_NPC_S_MONSTERS] = 1,
    [Talents.T_NPC_S_UNIQUE] = 1,
    [Talents.T_NPC_S_HI_DEMON] = 1,
    [Talents.T_NPC_S_HI_UNDEAD] = 1,
    [Talents.T_NPC_S_HI_DRAGON] = 1,
    [Talents.T_NPC_BR_NETH] = 1,
    [Talents.T_NPC_BR_DISI] = 1,
    [Talents.T_NPC_HAND_DOOM] = 1,
    [Talents.T_NPC_S_WRAITH] = 1,
    [Talents.T_NPC_HEAL] = 1,
    [Talents.T_NPC_BRAIN_SMASH] = 1,
    [Talents.T_NPC_DRAIN_MANA] = 1,
    [Talents.T_NPC_TELE_TO] = 1,
    [Talents.T_NPC_DARKNESS] = 1,
    [Talents.T_NPC_SHRIEK] = 1,
  },
  body = bodies.humanoid,
  speed = 40,
  vision = 100,
  alertness = 0,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'SPIRIT_NETHER',
  name = [[Spirit]],
  display = 'G',
  color = colors.C_v,
  image = 'npc/spirit_nether.png',
  desc = [[This strange, almost intangible spirit keeps assaulting you!]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 1,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 40, 80 },
  ac = 50,
  max_life = resolvers.dice(40, 80),
  rarity = 2,
  level = 128,
  start_level = 128,
  exp_worth = 5000,
  flags = {
    BASEANGBAND = true,
    COLD_BLOOD = true,
    EMPTY_MIND = true,
    INVISIBLE = true,
    NEVER_MOVE = true,
    NO_CUT = true,
    SPIRIT = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.EXP_80, method=AttackType.TOUCH, dam={10,10} },
    { type=DamageType.EXP_80, method=AttackType.TOUCH, dam={10,10} },
  },
  resolvers.talents {
    [Talents.T_NPC_BA_NETH] = 1,
  },
  body = { MAIN_HAND=0, OFF_HAND=1, BODY=1, CLOAK=1, LAUNCHER=0, QUIVER=1, GLOVES=1, BOOTS=0, HELM=0, RING=2, AMULET=0, LITE=1, TOOL=1, SYMBIOTE=1, INVEN=23 },
  speed = 10,
  vision = 30,
  alertness = 20,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'SPIRIT_ANNOYANCE',
  name = [[Spirit]],
  display = 'G',
  color = colors.C_B,
  image = 'npc/spirit_annoyance.png',
  desc = [[These things multiply at an apparently unstoppable rate!]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 40, 20 },
  ac = 70,
  max_life = resolvers.dice(40, 20),
  rarity = 4,
  level = 144,
  start_level = 144,
  exp_worth = 500,
  flags = {
    AI_ANNOY = true,
    BASEANGBAND = true,
    FRIENDS = true,
    MULTIPLY = true,
    PASS_WALL = true,
    SPIRIT = true,
    WEIRD_MIND = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.POISON, method=AttackType.TOUCH, dam={10,10} },
    { type=DamageType.POISON, method=AttackType.CRAWL, dam={10,10} },
    { type=DamageType.EAT_ITEM, method=AttackType.CRAWL, dam={10,9} },
    { type=DamageType.DISENCHANT, method=AttackType.BITE, dam={9,9} },
  },
  body = bodies.none,
  speed = 20,
  vision = 30,
  alertness = 70,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'SPIRIT_MOVEMENT',
  name = [[Spirit]],
  display = 'G',
  color = colors.C_B,
  image = 'npc/spirit_movement.png',
  desc = [[Coming towards you quickly, it seems intent on moving faster than you.]],
  corpse_weight = 1,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 2,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 10, 80 },
  ac = 65,
  max_life = resolvers.dice(10, 80),
  rarity = 1,
  level = 132,
  start_level = 132,
  exp_worth = 5500,
  resist_dam = {
    [DamageType.OLD_SLEEP] = true,
  },
  flags = {
    BASEANGBAND = true,
    PASS_WALL = true,
    SPIRIT = true,
    WEIRD_MIND = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.LOSE_DEX, method=AttackType.TOUCH, dam={2,3} },
    { type=DamageType.PARALYZE, method=AttackType.TOUCH, dam={1,12} },
    { type=DamageType.PARALYZE, method=AttackType.TOUCH, dam={1,12} },
  },
  resolvers.talents {
    [Talents.T_NPC_SLOW] = 1,
    [Talents.T_NPC_BLINK] = 1,
    [Talents.T_NPC_HOLD] = 1,
    [Talents.T_NPC_HASTE] = 1,
  },
  body = bodies.none,
  speed = 20,
  vision = 50,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'SPIRIT_CONFUSION',
  name = [[Spirit]],
  display = 'G',
  color = colors.C_v,
  image = 'npc/spirit_confusion.png',
  desc = [[A swirling mass, constantly changing its appearance.]],
  corpse_weight = 10,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 3,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 40, 80 },
  ac = 85,
  max_life = resolvers.dice(40, 80),
  rarity = 2,
  level = 135,
  start_level = 135,
  exp_worth = 5500,
  resist_dam = {
    [DamageType.CHAOS] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.ELEC] = true,
    [DamageType.FEAR] = true,
    [DamageType.FIRE] = true,
    [DamageType.NEXUS] = true,
    [DamageType.OLD_SLEEP] = true,
  },
  melee_retal = {
    [DamageType.ELEC] = 'mondam',
  },
  flags = {
    ATTR_MULTI = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    EMPTY_MIND = true,
    FLY = true,
    NO_CUT = true,
    POWERFUL = true,
    SPIRIT = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.HALLUCINATION, method=AttackType.ENGULF, dam={16,8} },
    { type=DamageType.HALLUCINATION, method=AttackType.ENGULF, dam={16,8} },
    { type=DamageType.CONFUSION, method=AttackType.ENGULF, dam={16,8} },
    { type=DamageType.CONFUSION, method=AttackType.ENGULF, dam={16,8} },
  },
  resolvers.talents {
    [Talents.T_NPC_BR_CHAO] = 1,
    [Talents.T_NPC_BR_NEXU] = 1,
    [Talents.T_NPC_BR_CONF] = 1,
  },
  body = bodies.none,
  speed = 10,
  vision = 80,
  alertness = 0,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'SPIRIT_BRAWN',
  name = [[Spirit]],
  display = 'G',
  color = colors.C_U,
  image = 'npc/spirit_brawn.png',
  desc = [[Strong and swarthy, this spirit could bend metal with his bare hands.]],
  corpse_weight = 1000,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 140, 100 },
  ac = 180,
  max_life = resolvers.dice(140, 100),
  rarity = 3,
  level = 145,
  start_level = 145,
  exp_worth = 8000,
  resist_dam = {
    [DamageType.ACID] = true,
    [DamageType.COLD] = true,
    [DamageType.ELEC] = true,
    [DamageType.FIRE] = true,
    [DamageType.POISON] = true,
  },
  vuln_dam = {
    [DamageType.KILL_WALL] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    EVIL = true,
    GIANT = true,
    HAS_LITE = true,
    KILL_BODY = true,
    KILL_TREES = true,
    KILL_WALL = true,
    OPEN_DOOR = true,
    SPIRIT = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ '4d2' },
  drop = { treasure=0, combat=100, magic=0, tools=0, junk=0 },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.SHATTER, method=AttackType.HIT, dam={18,18} },
    { type=DamageType.CONFUSION, method=AttackType.HIT, dam={18,18} },
    { type=DamageType.SHATTER, method=AttackType.HIT, dam={18,18} },
    { type=DamageType.CONFUSION, method=AttackType.HIT, dam={18,18} },
  },
  body = bodies.humanoid,
  speed = 20,
  vision = 50,
  alertness = 30,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'SPIRIT_WYRMS',
  name = [[Spirit]],
  display = 'G',
  color = colors.C_v,
  image = 'npc/spirit_wyrms.png',
  desc = [[This spirit bears a remarkable similarity to some of the most powerful types of dragonkind found in Middle-earth. It appears to be even more fearsome though!]],
  corpse_weight = 1000,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 3,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 151, 151 },
  ac = 190,
  max_life = 22801,
  rarity = 8,
  level = 147,
  start_level = 147,
  exp_worth = 87500,
  resist_dam = {
    [DamageType.ACID] = true,
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.DISEASE] = true,
    [DamageType.ELEC] = true,
    [DamageType.FIRE] = true,
    [DamageType.NETHER] = true,
    [DamageType.NEXUS] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.PLASMA] = true,
    [DamageType.POISON] = true,
    [DamageType.TELEPORT] = true,
  },
  melee_retal = {
    [DamageType.COLD] = 'mondam',
    [DamageType.ELEC] = 'mondam',
    [DamageType.FIRE] = 'mondam',
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    DRAGON = true,
    FLY = true,
    FORCE_MAXHP = true,
    GOOD = true,
    HAS_LITE = true,
    KILL_TREES = true,
    MOVE_BODY = true,
    NO_CUT = true,
    OPEN_DOOR = true,
    POWERFUL = true,
    REFLECTING = true,
    SPIRIT = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ good=true, only_item=true, '2d2', '3d2', '4d2' },
  drop = { treasure=50, combat=50, magic=0, tools=0, junk=0 },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={10,15} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={10,15} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={14,18} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={14,18} },
  },
  resolvers.talents {
    [Talents.T_NPC_S_HI_DRAGON] = 1,
    [Talents.T_NPC_S_DRAGON] = 1,
    [Talents.T_NPC_S_KIN] = 1,
    [Talents.T_NPC_BR_ACID] = 1,
    [Talents.T_NPC_BR_ELEC] = 1,
    [Talents.T_NPC_BR_FIRE] = 1,
    [Talents.T_NPC_BR_COLD] = 1,
    [Talents.T_NPC_BR_POIS] = 1,
    [Talents.T_NPC_BR_NETH] = 1,
    [Talents.T_NPC_BR_LITE] = 1,
    [Talents.T_NPC_BR_DARK] = 1,
    [Talents.T_NPC_BR_CONF] = 1,
    [Talents.T_NPC_BR_SOUN] = 1,
    [Talents.T_NPC_BR_CHAO] = 1,
    [Talents.T_NPC_BR_DISE] = 1,
    [Talents.T_NPC_BR_NEXU] = 1,
    [Talents.T_NPC_BR_TIME] = 1,
    [Talents.T_NPC_BR_INER] = 1,
    [Talents.T_NPC_BR_GRAV] = 1,
    [Talents.T_NPC_BR_SHAR] = 1,
    [Talents.T_NPC_BR_PLAS] = 1,
    [Talents.T_NPC_BR_WALL] = 1,
    [Talents.T_NPC_BR_MANA] = 1,
    [Talents.T_NPC_BR_DISI] = 1,
  },
  body = bodies.dragon,
  speed = 20,
  vision = 50,
  alertness = 50,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'SPIRIT_SNAKES',
  name = [[Spirit]],
  display = 'G',
  color = colors.C_g,
  image = 'npc/spirit_snakes.png',
  desc = [[It slides towards you, a horrible scaly, slidy thing.]],
  corpse_weight = 9,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 4,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 150, 100 },
  ac = 80,
  max_life = resolvers.dice(150, 100),
  rarity = 3,
  level = 133,
  start_level = 133,
  exp_worth = 750,
  resist_dam = {
    [DamageType.ACID] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    CAN_SWIM = true,
    EVIL = true,
    FRIENDS = true,
    OPEN_DOOR = true,
    SPIRIT = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ '2d2', '60%' },
  drop = { treasure=25, combat=20, magic=25, tools=20, junk=10 },
  drop_corpse = { corpse=true },
  attacks = {
    { type=DamageType.POISON, method=AttackType.BITE, dam={15,15} },
    { type=DamageType.POISON, method=AttackType.BITE, dam={15,15} },
    { type=DamageType.LOSE_ALL, method=AttackType.BITE, dam={10,12} },
  },
  resolvers.talents {
    [Talents.T_NPC_BA_POIS] = 1,
    [Talents.T_NPC_S_MONSTER] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_HOLD] = 1,
  },
  body = bodies.humanoid,
  speed = 20,
  vision = 40,
  alertness = 20,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'SPIRIT_SEEING',
  name = [[Spirit]],
  display = 'G',
  color = colors.C_v,
  image = 'npc/spirit_seeing.png',
  desc = [[You will find it difficult to avoid being seen by this spirit! And once it has you in its sight, beware!]],
  corpse_weight = 6,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 2,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 95, 110 },
  ac = 130,
  max_life = resolvers.dice(95, 110),
  rarity = 3,
  level = 141,
  start_level = 141,
  exp_worth = 50000,
  resist_dam = {
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    EVIL = true,
    FLY = true,
    SPIRIT = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.DISENCHANT, method=AttackType.GAZE, dam={12,12} },
    { type=DamageType.UN_POWER, method=AttackType.GAZE, dam={12,10} },
    { type=DamageType.INSANITY, method=AttackType.GAZE, dam={12,14} },
    { type=DamageType.LOSE_ALL, method=AttackType.GAZE, dam={6,6} },
  },
  resolvers.talents {
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_FORGET] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_DRAIN_MANA] = 1,
    [Talents.T_NPC_BRAIN_SMASH] = 1,
    [Talents.T_NPC_BA_DARK] = 1,
    [Talents.T_NPC_BO_MANA] = 1,
    [Talents.T_NPC_BA_NETH] = 1,
    [Talents.T_NPC_BA_ACID] = 1,
    [Talents.T_NPC_BA_FIRE] = 1,
    [Talents.T_NPC_BA_COLD] = 1,
  },
  body = bodies.none,
  speed = 20,
  vision = 60,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'SPIRIT_UNSEEING',
  name = [[Spirit]],
  display = '.',
  color = colors.C_W,
  image = 'npc/spirit_unseeing.png',
  desc = [[Hopefully you will kill this spirit before you realise it exists.]],
  corpse_weight = 6,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 3,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 55, 50 },
  ac = 130,
  max_life = resolvers.dice(55, 50),
  rarity = 6,
  level = 142,
  start_level = 142,
  exp_worth = 4000,
  flags = {
    ATTR_CLEAR = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    CHAR_CLEAR = true,
    CHAR_MULTI = true,
    COLD_BLOOD = true,
    EMPTY_MIND = true,
    EVIL = true,
    FLY = true,
    INVISIBLE = true,
    REFLECTING = true,
    SMART = true,
    SPIRIT = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.DISENCHANT, method=AttackType.TOUCH, dam={12,12} },
    { type=DamageType.UN_POWER, method=AttackType.TOUCH, dam={12,10} },
    { type=DamageType.INSANITY, method=AttackType.TOUCH, dam={12,14} },
    { type=DamageType.LOSE_ALL, method=AttackType.TOUCH, dam={6,6} },
  },
  resolvers.talents {
    [Talents.T_NPC_DRAIN_MANA] = 1,
    [Talents.T_NPC_BLINK] = 1,
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_HEAL] = 1,
    [Talents.T_NPC_TELE_AWAY] = 1,
    [Talents.T_NPC_DARKNESS] = 1,
    [Talents.T_NPC_TRAPS] = 1,
    [Talents.T_NPC_FORGET] = 1,
    [Talents.T_NPC_SHRIEK] = 1,
  },
  body = bodies.none,
  speed = 10,
  vision = 20,
  alertness = 80,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'SPIRIT_ICKYNESS',
  name = [[Spirit]],
  display = 'G',
  color = colors.C_g,
  image = 'npc/spirit_ickyness.png',
  desc = [[A horrible slimy spirit, that seems to ooze evilness. I wouldn't get too close to it if I were you.]],
  corpse_weight = 30,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 4,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 80, 80 },
  ac = 60,
  max_life = resolvers.dice(80, 80),
  rarity = 4,
  level = 138,
  start_level = 138,
  exp_worth = 40000,
  resist_dam = {
    [DamageType.ACID] = true,
    [DamageType.COLD] = true,
    [DamageType.ELEC] = true,
    [DamageType.FIRE] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    EMPTY_MIND = true,
    EVIL = true,
    OPEN_DOOR = true,
    SPIRIT = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.POISON, method=AttackType.CRAWL, dam={12,14} },
    { type=DamageType.EAT_FOOD, method=AttackType.CRAWL, dam={12,14} },
    { type=DamageType.ACID, method=AttackType.TOUCH, dam={13,15} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={13,15} },
  },
  resolvers.talents {
    [Talents.T_NPC_DRAIN_MANA] = 1,
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_S_KIN] = 1,
  },
  body = bodies.none,
  speed = 20,
  vision = 30,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'SPIRIT_FRIENDSHIP',
  name = [[Spirit]],
  display = 'G',
  color = colors.C_W,
  image = 'npc/spirit_friendship.png',
  desc = [[This spirit appears to have lots of friends!]],
  corpse_weight = 20,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 2,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 35, 100 },
  ac = 150,
  max_life = resolvers.dice(35, 100),
  rarity = 3,
  level = 136,
  start_level = 136,
  exp_worth = 10000,
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    ESCORT = true,
    ESCORTS = true,
    OPEN_DOOR = true,
    SPIRIT = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={12,12} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={12,12} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={12,8} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={12,8} },
  },
  resolvers.talents {
    [Talents.T_NPC_S_KIN] = 1,
  },
  body = bodies.quadruped,
  speed = 20,
  vision = 40,
  alertness = 100,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'SPIRIT_ABOMINATION',
  name = [[Spirit]],
  display = 'G',
  color = colors.C_d,
  image = 'npc/spirit_abomination.png',
  desc = [[It seems to have been woken from the dead, this spirit. It lumbers towards you, seeking to turn you into a form as hideous as its own!]],
  corpse_weight = 20,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 3,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 40, 80 },
  ac = 125,
  max_life = resolvers.dice(40, 80),
  rarity = 2,
  level = 134,
  start_level = 134,
  exp_worth = 5000,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.DARK] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  vuln_dam = {
    [DamageType.LITE] = true,
    [DamageType.LITE_WEAK] = true,
  },
  flags = {
    BASEANGBAND = true,
    COLD_BLOOD = true,
    EVIL = true,
    NO_CUT = true,
    SPIRIT = true,
    UNDEAD = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.FEAR, method=AttackType.WAIL, dam={8,9} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={10,10} },
    { type=DamageType.ABOMINATION, method=AttackType.HIT, dam={6,10} },
    { type=DamageType.ABOMINATION, method=AttackType.HIT, dam={6,10} },
  },
  on_melee_hit = util.black_breath_melee_hit,
  resolvers.talents {
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_HOLD] = 1,
    [Talents.T_NPC_DARKNESS] = 1,
    [Talents.T_NPC_SCARE] = 1,
  },
  body = bodies.none,
  speed = 20,
  vision = 30,
  alertness = 125,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'SPIRIT_STRENGTH',
  name = [[Spirit]],
  display = 'G',
  color = colors.C_u,
  image = 'npc/spirit_strength.png',
  desc = [[It is coming for you, this massive imposing tower of strength. It appears almost unstoppable!]],
  corpse_weight = 1000,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 140, 100 },
  ac = 180,
  max_life = resolvers.dice(140, 100),
  rarity = 2,
  level = 129,
  start_level = 129,
  exp_worth = 8000,
  resist_dam = {
    [DamageType.ACID] = true,
    [DamageType.COLD] = true,
    [DamageType.ELEC] = true,
    [DamageType.FIRE] = true,
    [DamageType.POISON] = true,
  },
  vuln_dam = {
    [DamageType.KILL_WALL] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    EVIL = true,
    GIANT = true,
    KILL_BODY = true,
    KILL_WALL = true,
    SPIRIT = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ '2d2' },
  drop = { treasure=0, combat=100, magic=0, tools=0, junk=0 },
  attacks = {
    { type=DamageType.LOSE_STR, method=AttackType.HIT, dam={4,8} },
    { type=DamageType.LOSE_STR, method=AttackType.HIT, dam={4,8} },
    { type=DamageType.LOSE_STR, method=AttackType.HIT, dam={4,8} },
  },
  body = bodies.humanoid,
  speed = 10,
  vision = 50,
  alertness = 170,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'SPIRIT_INTELLIGENCE',
  name = [[Spirit]],
  display = 'G',
  color = colors.C_r,
  image = 'npc/spirit_intelligence.png',
  desc = [[This spirit looks very clever, cunning almost.]],
  corpse_weight = 1000,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 2,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 80, 100 },
  ac = 100,
  max_life = resolvers.dice(80, 100),
  rarity = 2,
  level = 131,
  start_level = 131,
  exp_worth = 8000,
  resist_dam = {
    [DamageType.ACID] = true,
    [DamageType.COLD] = true,
    [DamageType.ELEC] = true,
    [DamageType.FIRE] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    EVIL = true,
    OPEN_DOOR = true,
    SMART = true,
    SPIRIT = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ '2d2' },
  drop = { treasure=0, combat=0, magic=100, tools=0, junk=0 },
  attacks = {
    { type=DamageType.LOSE_INT, method=AttackType.HIT, dam={4,8} },
    { type=DamageType.LOSE_INT, method=AttackType.HIT, dam={4,8} },
    { type=DamageType.LOSE_INT, method=AttackType.HIT, dam={4,8} },
  },
  resolvers.talents {
    [Talents.T_NPC_HASTE] = 1,
    [Talents.T_NPC_TPORT] = 1,
    [Talents.T_NPC_TELE_TO] = 1,
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_BO_MANA] = 1,
    [Talents.T_NPC_BO_FIRE] = 1,
    [Talents.T_NPC_BO_COLD] = 1,
    [Talents.T_NPC_BO_ELEC] = 1,
  },
  body = bodies.humanoid,
  speed = 30,
  vision = 50,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'SPIRIT_WISDOM',
  name = [[Spirit]],
  display = 'G',
  color = colors.C_G,
  image = 'npc/spirit_wisdom.png',
  desc = [[This spirit has something of a priestly look about it.]],
  corpse_weight = 1000,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 2,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 120, 100 },
  ac = 200,
  max_life = resolvers.dice(120, 100),
  rarity = 2,
  level = 137,
  start_level = 137,
  exp_worth = 8000,
  resist_dam = {
    [DamageType.ACID] = true,
    [DamageType.COLD] = true,
    [DamageType.ELEC] = true,
    [DamageType.FIRE] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    EVIL = true,
    OPEN_DOOR = true,
    SPIRIT = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ '2d2' },
  drop = { treasure=0, combat=50, magic=50, tools=0, junk=0 },
  attacks = {
    { type=DamageType.LOSE_WIS, method=AttackType.HIT, dam={4,8} },
    { type=DamageType.LOSE_WIS, method=AttackType.HIT, dam={4,8} },
    { type=DamageType.LOSE_WIS, method=AttackType.HIT, dam={4,8} },
  },
  resolvers.talents {
    [Talents.T_NPC_HEAL] = 1,
    [Talents.T_NPC_MIND_BLAST] = 1,
    [Talents.T_NPC_CAUSE_4] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_DRAIN_MANA] = 1,
    [Talents.T_NPC_BRAIN_SMASH] = 1,
    [Talents.T_NPC_FORGET] = 1,
  },
  body = bodies.humanoid,
  speed = 20,
  vision = 50,
  alertness = 130,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'SPIRIT_DEXTERITY',
  name = [[Spirit]],
  display = 'G',
  color = colors.C_W,
  image = 'npc/spirit_dexterity.png',
  desc = [[This spirit moves almost too quickly for you to see him.]],
  corpse_weight = 1000,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 1,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 120, 100 },
  ac = 160,
  max_life = resolvers.dice(120, 100),
  rarity = 2,
  level = 139,
  start_level = 139,
  exp_worth = 8000,
  resist_dam = {
    [DamageType.ACID] = true,
    [DamageType.COLD] = true,
    [DamageType.ELEC] = true,
    [DamageType.FIRE] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    EVIL = true,
    OPEN_DOOR = true,
    SMART = true,
    SPIRIT = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ '2d2' },
  drop = { treasure=0, combat=50, magic=25, tools=25, junk=0 },
  attacks = {
    { type=DamageType.LOSE_DEX, method=AttackType.HIT, dam={4,8} },
    { type=DamageType.LOSE_DEX, method=AttackType.HIT, dam={4,8} },
    { type=DamageType.LOSE_DEX, method=AttackType.HIT, dam={4,8} },
  },
  resolvers.talents {
    [Talents.T_NPC_ARROW_4] = 1,
  },
  body = bodies.humanoid,
  speed = 50,
  vision = 50,
  alertness = 50,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'SPIRIT_CONSTITUTION',
  name = [[Spirit]],
  display = 'G',
  color = colors.C_s,
  image = 'npc/spirit_constitution.png',
  desc = [[This spirit moves slower than most, but thunders on and on towards you.]],
  corpse_weight = 1000,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 140, 100 },
  ac = 180,
  max_life = resolvers.dice(140, 100),
  rarity = 2,
  level = 143,
  start_level = 143,
  exp_worth = 8000,
  resist_dam = {
    [DamageType.ACID] = true,
    [DamageType.COLD] = true,
    [DamageType.ELEC] = true,
    [DamageType.FIRE] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    EVIL = true,
    SPIRIT = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ '2d2' },
  drop = { treasure=0, combat=50, magic=0, tools=50, junk=0 },
  attacks = {
    { type=DamageType.LOSE_CON, method=AttackType.HIT, dam={4,8} },
    { type=DamageType.LOSE_CON, method=AttackType.HIT, dam={4,8} },
    { type=DamageType.LOSE_CON, method=AttackType.HIT, dam={4,8} },
  },
  body = bodies.humanoid,
  speed = 10,
  vision = 50,
  alertness = 50,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'SPIRIT_CHARISMA',
  name = [[Spirit]],
  display = 'G',
  color = colors.C_b,
  image = 'npc/spirit_charisma.png',
  desc = [[There is something attractive about this spirit, and it seems to have a full purse.]],
  corpse_weight = 1000,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 2,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 80, 100 },
  ac = 120,
  max_life = resolvers.dice(80, 100),
  rarity = 2,
  level = 146,
  start_level = 146,
  exp_worth = 8000,
  resist_dam = {
    [DamageType.ACID] = true,
    [DamageType.COLD] = true,
    [DamageType.ELEC] = true,
    [DamageType.FIRE] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    EVIL = true,
    OPEN_DOOR = true,
    SPIRIT = true,
    TAKE_ITEM = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ '2d2' },
  drop = { treasure=70, combat=10, magic=10, tools=10, junk=0 },
  attacks = {
    { type=DamageType.LOSE_CHR, method=AttackType.HIT, dam={4,8} },
    { type=DamageType.LOSE_CHR, method=AttackType.HIT, dam={4,8} },
    { type=DamageType.LOSE_CHR, method=AttackType.HIT, dam={4,8} },
  },
  resolvers.talents {
    [Talents.T_NPC_TRAPS] = 1,
    [Talents.T_NPC_ARROW_3] = 1,
    [Talents.T_NPC_BLINK] = 1,
    [Talents.T_NPC_TELE_TO] = 1,
    [Talents.T_NPC_CONF] = 1,
  },
  body = bodies.humanoid,
  speed = 30,
  vision = 50,
  alertness = 90,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'SPIRIT_FLICKERING',
  name = [[Spirit]],
  display = 'G',
  color = colors.C_r,
  image = 'npc/spirit_flickering.png',
  desc = [[Flickering towards you, and then away, this spirit will burn you badly!]],
  corpse_weight = 0.5,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 2,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 60, 100 },
  ac = 65,
  max_life = resolvers.dice(60, 100),
  rarity = 1,
  level = 130,
  start_level = 130,
  exp_worth = 6000,
  resist_dam = {
    [DamageType.FIRE] = true,
  },
  melee_retal = {
    [DamageType.FIRE] = 'mondam',
  },
  flags = {
    AI_ANNOY = true,
    BASEANGBAND = true,
    HAS_LITE = true,
    SPIRIT = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.FIRE, method=AttackType.HIT, dam={10,8} },
    { type=DamageType.FIRE, method=AttackType.HIT, dam={10,8} },
    { type=DamageType.FIRE, method=AttackType.HIT, dam={10,8} },
  },
  resolvers.talents {
    [Talents.T_NPC_BO_FIRE] = 1,
    [Talents.T_NPC_BA_FIRE] = 1,
  },
  body = bodies.humanoid,
  speed = 10,
  vision = 50,
  alertness = 80,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'SPIRIT_ICY',
  name = [[Spirit]],
  display = 'G',
  color = colors.C_w,
  image = 'npc/spirit_icy.png',
  desc = [[The temperature around you drops as soon as you set eyes on this spirit.]],
  corpse_weight = 0.5,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 2,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 60, 100 },
  ac = 65,
  max_life = resolvers.dice(60, 100),
  rarity = 1,
  level = 148,
  start_level = 148,
  exp_worth = 6000,
  resist_dam = {
    [DamageType.COLD] = true,
  },
  melee_retal = {
    [DamageType.COLD] = 'mondam',
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    COLD_BLOOD = true,
    SPIRIT = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.COLD, method=AttackType.HIT, dam={10,8} },
    { type=DamageType.COLD, method=AttackType.HIT, dam={10,8} },
    { type=DamageType.COLD, method=AttackType.HIT, dam={10,8} },
  },
  resolvers.talents {
    [Talents.T_NPC_BO_COLD] = 1,
    [Talents.T_NPC_BA_COLD] = 1,
  },
  body = bodies.humanoid,
  speed = 10,
  vision = 50,
  alertness = 80,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'SPIRIT_CORROSION',
  name = [[Spirit]],
  display = 'G',
  color = colors.C_s,
  image = 'npc/spirit_corrosion.png',
  desc = [[The very fabric of the void heals itself where this spirit walks.]],
  corpse_weight = 0.5,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 2,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 60, 100 },
  ac = 65,
  max_life = resolvers.dice(60, 100),
  rarity = 1,
  level = 146,
  start_level = 146,
  exp_worth = 6000,
  resist_dam = {
    [DamageType.ACID] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    KILL_TREES = true,
    SPIRIT = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.ACID, method=AttackType.HIT, dam={10,8} },
    { type=DamageType.ACID, method=AttackType.HIT, dam={10,8} },
    { type=DamageType.ACID, method=AttackType.HIT, dam={10,8} },
  },
  resolvers.talents {
    [Talents.T_NPC_BO_ACID] = 1,
    [Talents.T_NPC_BA_ACID] = 1,
  },
  body = bodies.humanoid,
  speed = 10,
  vision = 50,
  alertness = 80,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'SPIRIT_SHOCKING',
  name = [[Spirit]],
  display = 'G',
  color = colors.C_b,
  image = 'npc/spirit_shocking.png',
  desc = [[The air crackles as this spirit approaches, and you smell singed flesh.]],
  corpse_weight = 0.5,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 2,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 60, 100 },
  ac = 65,
  max_life = resolvers.dice(60, 100),
  rarity = 1,
  level = 149,
  start_level = 149,
  exp_worth = 6000,
  resist_dam = {
    [DamageType.ELEC] = true,
  },
  melee_retal = {
    [DamageType.ELEC] = 'mondam',
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    SPIRIT = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.ELEC, method=AttackType.HIT, dam={10,8} },
    { type=DamageType.ELEC, method=AttackType.HIT, dam={10,8} },
    { type=DamageType.ELEC, method=AttackType.HIT, dam={10,8} },
  },
  resolvers.talents {
    [Talents.T_NPC_BO_ELEC] = 1,
    [Talents.T_NPC_BA_ELEC] = 1,
  },
  body = bodies.humanoid,
  speed = 10,
  vision = 50,
  alertness = 80,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'SPIRIT_VALARAUKAR',
  name = [[Spirit]],
  display = 'G',
  color = colors.C_v,
  image = 'npc/spirit_valaraukar.png',
  desc = [[Carrying a whip of fire, this spirit looks not dissimilar to a certain Balrog.]],
  corpse_weight = 17,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 3,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 130, 100 },
  ac = 140,
  max_life = resolvers.dice(130, 100),
  rarity = 1,
  level = 149,
  start_level = 149,
  exp_worth = 43000,
  resist_dam = {
    [DamageType.ELEC] = true,
    [DamageType.FIRE] = true,
  },
  melee_retal = {
    [DamageType.FIRE] = 'mondam',
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    DEMON = true,
    EVIL = true,
    FLY = true,
    HAS_LITE = true,
    KILL_WALL = true,
    MOVE_BODY = true,
    NONLIVING = true,
    OPEN_DOOR = true,
    POWERFUL = true,
    SPIRIT = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ only_item=true, '2d2' },
  drop = { treasure=0, combat=100, magic=0, tools=0, junk=0 },
  attacks = {
    { type=DamageType.FIRE, method=AttackType.HIT, dam={11,12} },
    { type=DamageType.FIRE, method=AttackType.HIT, dam={11,12} },
    { type=DamageType.PHYSICAL, method=AttackType.CRUSH, dam={10,12} },
    { type=DamageType.UN_POWER, method=AttackType.TOUCH },
  },
  resolvers.talents {
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_BR_FIRE] = 1,
  },
  body = bodies.humanoid,
  speed = 20,
  vision = 100,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'SPIRIT_SHADOWS',
  name = [[Spirit]],
  display = 'G',
  color = colors.C_d,
  image = 'npc/spirit_shadows.png',
  desc = [[Deriving his strength from the shadows, this spirit steals only for the challenge.]],
  corpse_weight = 230,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 3,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 30, 100 },
  ac = 150,
  max_life = resolvers.dice(30, 100),
  rarity = 4,
  level = 140,
  start_level = 140,
  exp_worth = 10000,
  resist_dam = {
    [DamageType.ACID] = true,
    [DamageType.COLD] = true,
    [DamageType.ELEC] = true,
    [DamageType.FIRE] = true,
    [DamageType.POISON] = true,
    [DamageType.TELEPORT] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    OPEN_DOOR = true,
    POWERFUL = true,
    REFLECTING = true,
    REGENERATE = true,
    SMART = true,
    SPIRIT = true,
    TAKE_ITEM = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={10,10} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={10,10} },
    { type=DamageType.EXP_80, method=AttackType.TOUCH, dam={20,8} },
    { type=DamageType.EXP_40, method=AttackType.TOUCH, dam={20,8} },
  },
  resolvers.talents {
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_HEAL] = 1,
    [Talents.T_NPC_BA_DARK] = 1,
    [Talents.T_NPC_HASTE] = 1,
    [Talents.T_NPC_CONF] = 1,
  },
  body = bodies.humanoid,
  speed = 20,
  vision = 70,
  alertness = 4,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'SPIRIT_VAMPIRE',
  name = [[Spirit]],
  display = 'G',
  color = colors.C_W,
  image = 'npc/spirit_vampire.png',
  desc = [[Your blood curdles and your bones chill as this spirit approaches.]],
  corpse_weight = 170,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 3,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 50, 50 },
  ac = 90,
  max_life = resolvers.dice(50, 50),
  rarity = 2,
  level = 143,
  start_level = 143,
  exp_worth = 18000,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.DARK] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
    [DamageType.TELEPORT] = true,
  },
  vuln_dam = {
    [DamageType.LITE] = true,
    [DamageType.LITE_WEAK] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    COLD_BLOOD = true,
    EVIL = true,
    FLY = true,
    FORCE_SLEEP = true,
    NO_CUT = true,
    OPEN_DOOR = true,
    REGENERATE = true,
    SPIRIT = true,
    UNDEAD = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ '4d2', '60%' },
  drop = { treasure=0, combat=70, magic=30, tools=0, junk=0 },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={10,9} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={9,9} },
    { type=DamageType.EXP_80, method=AttackType.BITE, dam={9,9} },
    { type=DamageType.EXP_80, method=AttackType.BITE, dam={9,9} },
  },
  on_melee_hit = util.black_breath_melee_hit,
  resolvers.talents {
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_HOLD] = 1,
    [Talents.T_NPC_SCARE] = 1,
    [Talents.T_NPC_CAUSE_3] = 1,
    [Talents.T_NPC_CAUSE_4] = 1,
    [Talents.T_NPC_DRAIN_MANA] = 1,
    [Talents.T_NPC_BRAIN_SMASH] = 1,
    [Talents.T_NPC_DARKNESS] = 1,
    [Talents.T_NPC_BO_NETH] = 1,
  },
  body = bodies.humanoid,
  speed = 20,
  vision = 30,
  alertness = 10,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'SPIRIT_UNRESISTABILITY',
  name = [[Spirit]],
  display = 'G',
  color = colors.C_v,
  image = 'npc/spirit_unresistability.png',
  desc = [[This spirit appears to be afraid of very little, and confident in its ability to destroy you.]],
  corpse_weight = 120,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 2,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 40, 100 },
  ac = 70,
  max_life = resolvers.dice(40, 100),
  rarity = 4,
  level = 149,
  start_level = 149,
  exp_worth = 20000,
  resist_dam = {
    [DamageType.ACID] = true,
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.ELEC] = true,
    [DamageType.FEAR] = true,
    [DamageType.NETHER] = true,
    [DamageType.NEXUS] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    OPEN_DOOR = true,
    POWERFUL = true,
    SMART = true,
    SPIRIT = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.SHATTER, method=AttackType.HIT, dam={18,10} },
    { type=DamageType.SHATTER, method=AttackType.HIT, dam={18,10} },
    { type=DamageType.LOSE_ALL, method=AttackType.HIT, dam={8,8} },
    { type=DamageType.UN_POWER, method=AttackType.TOUCH },
  },
  resolvers.talents {
    [Talents.T_NPC_BA_MANA] = 1,
    [Talents.T_NPC_BR_PLAS] = 1,
    [Talents.T_NPC_BR_TIME] = 1,
    [Talents.T_NPC_ROCKET] = 1,
    [Talents.T_NPC_HAND_DOOM] = 1,
    [Talents.T_NPC_FORGET] = 1,
    [Talents.T_NPC_BA_WATE] = 1,
  },
  speed = 30,
  vision = 40,
  alertness = 20,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'SPIRIT_TIME',
  name = [[Spirit]],
  display = 'G',
  color = colors.C_G,
  image = 'npc/spirit_time.png',
  desc = [[All at once you see that which is to come and that which has gone before.]],
  corpse_weight = 80,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 2,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 80, 100 },
  ac = 110,
  max_life = resolvers.dice(80, 100),
  rarity = 3,
  level = 150,
  start_level = 150,
  exp_worth = 50000,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.TIME] = true,
  },
  flags = {
    ANIMAL = true,
    BASEANGBAND = true,
    BASH_DOOR = true,
    OPEN_DOOR = true,
    SPIRIT = true,
  },
  placement_flags = {},
  drop_corpse = { corpse=true, skeleton=true },
  attacks = {
    { type=DamageType.TIME, method=AttackType.TOUCH, dam={6,12} },
    { type=DamageType.TIME, method=AttackType.TOUCH, dam={6,12} },
    { type=DamageType.TIME, method=AttackType.TOUCH, dam={6,12} },
    { type=DamageType.TIME, method=AttackType.TOUCH, dam={6,12} },
  },
  resolvers.talents {
    [Talents.T_NPC_BR_TIME] = 1,
    [Talents.T_NPC_SLOW] = 1,
    [Talents.T_NPC_HASTE] = 1,
    [Talents.T_NPC_HOLD] = 1,
  },
  body = bodies.quadruped,
  speed = 20,
  vision = 40,
  alertness = 0,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'SPIRIT_GOLD',
  name = [[Spirit]],
  display = 'G',
  color = colors.C_y,
  image = 'npc/spirit_gold.png',
  desc = [[It is the very essence of financial greed...]],
  corpse_weight = 8,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 4,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 50, 80 },
  ac = 110,
  max_life = resolvers.dice(50, 80),
  rarity = 4,
  level = 130,
  start_level = 130,
  exp_worth = 8000,
  resist_dam = {
    [DamageType.COLD] = true,
    [DamageType.CONFUSION] = true,
    [DamageType.ELEC] = true,
    [DamageType.FEAR] = true,
    [DamageType.OLD_SLEEP] = true,
    [DamageType.POISON] = true,
    [DamageType.TELEPORT] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    COLD_BLOOD = true,
    MOVE_BODY = true,
    NO_STUN = true,
    REFLECTING = true,
    REGENERATE = true,
    SPIRIT = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ only_gold=true, '4d2', '4d2', '4d2' },
  attacks = {
    { type=DamageType.EAT_GOLD, method=AttackType.TOUCH, dam={7,15} },
    { type=DamageType.EAT_GOLD, method=AttackType.TOUCH, dam={7,15} },
    { type=DamageType.POISON, method=AttackType.HIT, dam={6,12} },
    { type=DamageType.POISON, method=AttackType.HIT, dam={6,12} },
  },
  resolvers.talents {
    [Talents.T_NPC_ARROW_4] = 1,
    [Talents.T_NPC_HEAL] = 1,
    [Talents.T_NPC_FORGET] = 1,
  },
  body = bodies.quadruped,
  speed = 20,
  vision = 20,
  alertness = 100,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'SPIRIT_DOOM',
  name = [[Spirit]],
  display = 'G',
  color = colors.C_D,
  image = 'npc/spirit_doom.png',
  desc = [[The very presence of this creature fills the air with an aura of doom. You feel waves of depression descending on you as it approaches.]],
  corpse_weight = 6,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 2,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 60, 70 },
  ac = 70,
  max_life = resolvers.dice(60, 70),
  rarity = 2,
  level = 134,
  start_level = 134,
  exp_worth = 8000,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.OLD_SLEEP] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    EVIL = true,
    HAS_LITE = true,
    OPEN_DOOR = true,
    SMART = true,
    SPIRIT = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={14,14} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={14,14} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={14,14} },
  },
  resolvers.talents {
    [Talents.T_NPC_HAND_DOOM] = 1,
    [Talents.T_NPC_CAUSE_4] = 1,
    [Talents.T_NPC_DARKNESS] = 1,
  },
  body = bodies.humanoid,
  speed = 26,
  vision = 40,
  alertness = 30,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'SPIRIT_ETHEREALISM',
  name = [[Spirit]],
  display = 'G',
  color = colors.C_o,
  image = 'npc/spirit_etherealism.png',
  desc = [[This sprit seems to flicker in and out of this plane, and is a master of light and dark.]],
  corpse_weight = 170,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
    talent_in = 2,
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 40, 100 },
  ac = 120,
  max_life = resolvers.dice(40, 100),
  rarity = 3,
  level = 141,
  start_level = 141,
  exp_worth = 10000,
  resist_dam = {
    [DamageType.CONFUSION] = true,
    [DamageType.OLD_SLEEP] = true,
  },
  flags = {
    BASEANGBAND = true,
    EVIL = true,
    FLY = true,
    INVISIBLE = true,
    MOVE_BODY = true,
    PASS_WALL = true,
    POWERFUL = true,
    SPIRIT = true,
    WEIRD_MIND = true,
  },
  placement_flags = {},
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={14,10} },
    { type=DamageType.PHYSICAL, method=AttackType.CLAW, dam={14,10} },
    { type=DamageType.PHYSICAL, method=AttackType.BITE, dam={17,10} },
  },
  resolvers.talents {
    [Talents.T_NPC_BLIND] = 1,
    [Talents.T_NPC_CONF] = 1,
    [Talents.T_NPC_BR_LITE] = 1,
    [Talents.T_NPC_BR_DARK] = 1,
    [Talents.T_NPC_BR_CONF] = 1,
  },
  body = bodies.dragon,
  speed = 10,
  vision = 30,
  alertness = 40,
  resolvers.mon_global_speed(),
}

newEntity {
  define_as = 'SPIRIT_ORC',
  name = [[Spirit]],
  display = 'G',
  color = colors.C_v,
  image = 'npc/spirit_orc.png',
  desc = [[Stupid but strong, this spirit has an orcish aura about him.]],
  corpse_weight = 270,
  ai = 'tome2',
  ai_state = {
    sleep = resolvers.mon_sleep(),
  },
  stats = { STR=10, INT=10, WIS=10, DEX=10, CON=10, CHA=10 },
  hd = { 90, 10 },
  ac = 160,
  max_life = resolvers.dice(90, 10),
  rarity = 3,
  level = 142,
  start_level = 142,
  exp_worth = 11111,
  resist_dam = {
    [DamageType.DARK] = true,
    [DamageType.POISON] = true,
  },
  flags = {
    BASEANGBAND = true,
    BASH_DOOR = true,
    EVIL = true,
    HAS_LITE = true,
    MORTAL = true,
    OPEN_DOOR = true,
    ORC = true,
    SPIRIT = true,
  },
  placement_flags = {},
  resolvers.mon_inven{ only_item=true },
  drop = { treasure=10, combat=90, magic=0, tools=0, junk=0 },
  attacks = {
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={10,10} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={10,10} },
    { type=DamageType.PHYSICAL, method=AttackType.HIT, dam={10,10} },
  },
  body = bodies.humanoid,
  speed = 10,
  vision = 30,
  alertness = 100,
  resolvers.mon_global_speed(),
}


-- seen dam types:  DamageType.SHATTER DamageType.UN_POWER DamageType.LOSE_INT DamageType.EAT_ITEM DamageType.COLD DamageType.LOSE_ALL DamageType.EAT_LITE DamageType.LOSE_DEX DamageType.EAT_FOOD DamageType.DISENCHANT DamageType.EXP_80 DamageType.EXP_10 DamageType.ELEC DamageType.LOSE_CON DamageType.INSANITY DamageType.LOSE_STR DamageType.LOSE_CHR DamageType.TIME DamageType.ABOMINATION DamageType.PARALYZE DamageType.CONFUSION DamageType.ACID DamageType.EAT_GOLD DamageType.DISEASE DamageType.EXP_20 DamageType.LOSE_WIS DamageType.BLIND DamageType.PHYSICAL DamageType.EXP_40 DamageType.FIRE DamageType.HALLUCINATION DamageType.FEAR DamageType.POISON
-- seen hit msgs:  SPIT DROOL CRAWL GAZE TOUCH EXPLODE INSULT SPORE BUTT PUNCH CRUSH BEG CHARGE CLAW KICK ENGULF STING WAIL HIT BITE
-- seen body types:
--    none [0,0,0,0,0,0]:  194 (first seen on Grey mold)
--    snake [0,0,0,0,1,0]:  66 (first seen on Large white snake)
--    0,0,0,1,0,0:  1 (first seen on Hand druj)
--    0,0,0,3,0,0:  2 (first seen on Xorn)
--    0,0,0,6,0,0:  1 (first seen on Roper)
--    quadruped [0,1,0,2,1,0]:  127 (first seen on Scrawny cat)
--    hydra [0,1,0,2,2,0]:  10 (first seen on 2-headed hydra)
--    dragon [0,1,0,6,1,0]:  76 (first seen on Baby blue dragon)
--    0,1,0,6,2,0:  1 (first seen on Kavlax the Many-Headed)
--    winged [0,1,1,0,1,0]:  29 (first seen on Sparrow)
--    0,1,1,2,0,0:  1 (first seen on Spirit)
--    0,1,1,2,1,1:  5 (first seen on Farmer Maggot)
--    1,0,1,2,1,0:  1 (first seen on Bile Demon)
--    1,1,1,0,1,1:  1 (first seen on Mezzodaemon)
--    1,1,1,2,0,1:  1 (first seen on Medusa, the Gorgon)
--    1,1,1,2,1,0:  2 (first seen on Drider)
--    humanoid [1,1,1,2,1,1]:  307 (first seen on Player)
--    1,1,1,2,2,1:  2 (first seen on Skeleton ettin)
--    2,1,2,0,0,1:  1 (first seen on Gelugon)
--    2,1,2,4,1,1:  1 (first seen on Bronze golem)
--    3,0,3,0,1,0:  2 (first seen on Lesser kraken)
--    3,0,3,3,2,0:  1 (first seen on Silent watcher)
--    3,0,3,4,1,0:  1 (first seen on Marilith)
--    3,0,3,6,1,0:  4 (first seen on Giant squid)
